package org.eclipse.xtext.xbase.annotations.ide.contentassist.antlr.internal;

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.DFA;
import org.eclipse.xtext.xbase.annotations.services.XbaseWithAnnotationsGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
/*******************************************************************************
 * Copyright (c) 2010, 2023 itemis AG (http://www.itemis.eu) and others.
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 * 
 * SPDX-License-Identifier: EPL-2.0
 *******************************************************************************/
@SuppressWarnings("all")
public class InternalXbaseWithAnnotationsParser extends AbstractInternalContentAssistParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_HEX", "RULE_INT", "RULE_DECIMAL", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'='", "'||'", "'&&'", "'+='", "'-='", "'*='", "'/='", "'%='", "'=='", "'!='", "'==='", "'!=='", "'>='", "'>'", "'<'", "'->'", "'..<'", "'..'", "'=>'", "'<>'", "'?:'", "'+'", "'-'", "'*'", "'**'", "'/'", "'%'", "'!'", "'++'", "'--'", "'.'", "'val'", "'extends'", "'static'", "'import'", "'extension'", "'super'", "'false'", "'@'", "'('", "')'", "','", "']'", "'#'", "'['", "'instanceof'", "'as'", "'{'", "'}'", "';'", "'if'", "'else'", "'switch'", "':'", "'default'", "'case'", "'for'", "'while'", "'do'", "'new'", "'null'", "'typeof'", "'throw'", "'return'", "'try'", "'finally'", "'synchronized'", "'catch'", "'?'", "'&'", "'::'", "'?.'", "'|'", "'var'", "'true'"
    };
    public static final int RULE_HEX=5;
    public static final int T__50=50;
    public static final int T__19=19;
    public static final int T__15=15;
    public static final int T__59=59;
    public static final int T__16=16;
    public static final int T__17=17;
    public static final int T__18=18;
    public static final int T__55=55;
    public static final int T__56=56;
    public static final int T__13=13;
    public static final int T__57=57;
    public static final int T__14=14;
    public static final int T__58=58;
    public static final int T__51=51;
    public static final int T__52=52;
    public static final int T__53=53;
    public static final int T__54=54;
    public static final int T__60=60;
    public static final int T__61=61;
    public static final int RULE_ID=4;
    public static final int RULE_DECIMAL=7;
    public static final int T__26=26;
    public static final int T__27=27;
    public static final int T__28=28;
    public static final int RULE_INT=6;
    public static final int T__29=29;
    public static final int T__22=22;
    public static final int T__66=66;
    public static final int RULE_ML_COMMENT=9;
    public static final int T__23=23;
    public static final int T__67=67;
    public static final int T__24=24;
    public static final int T__68=68;
    public static final int T__25=25;
    public static final int T__69=69;
    public static final int T__62=62;
    public static final int T__63=63;
    public static final int T__20=20;
    public static final int T__64=64;
    public static final int T__21=21;
    public static final int T__65=65;
    public static final int T__70=70;
    public static final int T__71=71;
    public static final int T__72=72;
    public static final int RULE_STRING=8;
    public static final int RULE_SL_COMMENT=10;
    public static final int T__37=37;
    public static final int T__38=38;
    public static final int T__39=39;
    public static final int T__33=33;
    public static final int T__77=77;
    public static final int T__34=34;
    public static final int T__78=78;
    public static final int T__35=35;
    public static final int T__79=79;
    public static final int T__36=36;
    public static final int T__73=73;
    public static final int EOF=-1;
    public static final int T__30=30;
    public static final int T__74=74;
    public static final int T__31=31;
    public static final int T__75=75;
    public static final int T__32=32;
    public static final int T__76=76;
    public static final int T__80=80;
    public static final int T__81=81;
    public static final int T__82=82;
    public static final int T__83=83;
    public static final int RULE_WS=11;
    public static final int RULE_ANY_OTHER=12;
    public static final int T__48=48;
    public static final int T__49=49;
    public static final int T__44=44;
    public static final int T__45=45;
    public static final int T__46=46;
    public static final int T__47=47;
    public static final int T__40=40;
    public static final int T__84=84;
    public static final int T__41=41;
    public static final int T__85=85;
    public static final int T__42=42;
    public static final int T__86=86;
    public static final int T__43=43;
    public static final int T__87=87;

    // delegates
    // delegators


        public InternalXbaseWithAnnotationsParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalXbaseWithAnnotationsParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalXbaseWithAnnotationsParser.tokenNames; }
    public String getGrammarFileName() { return "InternalXbaseWithAnnotations.g"; }


    	private XbaseWithAnnotationsGrammarAccess grammarAccess;

    	public void setGrammarAccess(XbaseWithAnnotationsGrammarAccess grammarAccess) {
    		this.grammarAccess = grammarAccess;
    	}

    	@Override
    	protected Grammar getGrammar() {
    		return grammarAccess.getGrammar();
    	}

    	@Override
    	protected String getValueForTokenName(String tokenName) {
    		return tokenName;
    	}



    // $ANTLR start "entryRuleXAnnotation"
    // InternalXbaseWithAnnotations.g:59:1: entryRuleXAnnotation : ruleXAnnotation EOF ;
    public final void entryRuleXAnnotation() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:60:1: ( ruleXAnnotation EOF )
            // InternalXbaseWithAnnotations.g:61:1: ruleXAnnotation EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXAnnotation();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXAnnotation"


    // $ANTLR start "ruleXAnnotation"
    // InternalXbaseWithAnnotations.g:68:1: ruleXAnnotation : ( ( rule__XAnnotation__Group__0 ) ) ;
    public final void ruleXAnnotation() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:72:2: ( ( ( rule__XAnnotation__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:73:2: ( ( rule__XAnnotation__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:73:2: ( ( rule__XAnnotation__Group__0 ) )
            // InternalXbaseWithAnnotations.g:74:3: ( rule__XAnnotation__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:75:3: ( rule__XAnnotation__Group__0 )
            // InternalXbaseWithAnnotations.g:75:4: rule__XAnnotation__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotation__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXAnnotation"


    // $ANTLR start "entryRuleXAnnotationElementValuePair"
    // InternalXbaseWithAnnotations.g:84:1: entryRuleXAnnotationElementValuePair : ruleXAnnotationElementValuePair EOF ;
    public final void entryRuleXAnnotationElementValuePair() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:85:1: ( ruleXAnnotationElementValuePair EOF )
            // InternalXbaseWithAnnotations.g:86:1: ruleXAnnotationElementValuePair EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValuePairRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXAnnotationElementValuePair();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValuePairRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXAnnotationElementValuePair"


    // $ANTLR start "ruleXAnnotationElementValuePair"
    // InternalXbaseWithAnnotations.g:93:1: ruleXAnnotationElementValuePair : ( ( rule__XAnnotationElementValuePair__Group__0 ) ) ;
    public final void ruleXAnnotationElementValuePair() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:97:2: ( ( ( rule__XAnnotationElementValuePair__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:98:2: ( ( rule__XAnnotationElementValuePair__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:98:2: ( ( rule__XAnnotationElementValuePair__Group__0 ) )
            // InternalXbaseWithAnnotations.g:99:3: ( rule__XAnnotationElementValuePair__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValuePairAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:100:3: ( rule__XAnnotationElementValuePair__Group__0 )
            // InternalXbaseWithAnnotations.g:100:4: rule__XAnnotationElementValuePair__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValuePair__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValuePairAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXAnnotationElementValuePair"


    // $ANTLR start "entryRuleXAnnotationElementValueOrCommaList"
    // InternalXbaseWithAnnotations.g:109:1: entryRuleXAnnotationElementValueOrCommaList : ruleXAnnotationElementValueOrCommaList EOF ;
    public final void entryRuleXAnnotationElementValueOrCommaList() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:110:1: ( ruleXAnnotationElementValueOrCommaList EOF )
            // InternalXbaseWithAnnotations.g:111:1: ruleXAnnotationElementValueOrCommaList EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueOrCommaListRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXAnnotationElementValueOrCommaList();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueOrCommaListRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXAnnotationElementValueOrCommaList"


    // $ANTLR start "ruleXAnnotationElementValueOrCommaList"
    // InternalXbaseWithAnnotations.g:118:1: ruleXAnnotationElementValueOrCommaList : ( ( rule__XAnnotationElementValueOrCommaList__Alternatives ) ) ;
    public final void ruleXAnnotationElementValueOrCommaList() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:122:2: ( ( ( rule__XAnnotationElementValueOrCommaList__Alternatives ) ) )
            // InternalXbaseWithAnnotations.g:123:2: ( ( rule__XAnnotationElementValueOrCommaList__Alternatives ) )
            {
            // InternalXbaseWithAnnotations.g:123:2: ( ( rule__XAnnotationElementValueOrCommaList__Alternatives ) )
            // InternalXbaseWithAnnotations.g:124:3: ( rule__XAnnotationElementValueOrCommaList__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getAlternatives()); 
            }
            // InternalXbaseWithAnnotations.g:125:3: ( rule__XAnnotationElementValueOrCommaList__Alternatives )
            // InternalXbaseWithAnnotations.g:125:4: rule__XAnnotationElementValueOrCommaList__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValueOrCommaList__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXAnnotationElementValueOrCommaList"


    // $ANTLR start "entryRuleXAnnotationElementValue"
    // InternalXbaseWithAnnotations.g:134:1: entryRuleXAnnotationElementValue : ruleXAnnotationElementValue EOF ;
    public final void entryRuleXAnnotationElementValue() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:135:1: ( ruleXAnnotationElementValue EOF )
            // InternalXbaseWithAnnotations.g:136:1: ruleXAnnotationElementValue EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXAnnotationElementValue();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXAnnotationElementValue"


    // $ANTLR start "ruleXAnnotationElementValue"
    // InternalXbaseWithAnnotations.g:143:1: ruleXAnnotationElementValue : ( ( rule__XAnnotationElementValue__Alternatives ) ) ;
    public final void ruleXAnnotationElementValue() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:147:2: ( ( ( rule__XAnnotationElementValue__Alternatives ) ) )
            // InternalXbaseWithAnnotations.g:148:2: ( ( rule__XAnnotationElementValue__Alternatives ) )
            {
            // InternalXbaseWithAnnotations.g:148:2: ( ( rule__XAnnotationElementValue__Alternatives ) )
            // InternalXbaseWithAnnotations.g:149:3: ( rule__XAnnotationElementValue__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueAccess().getAlternatives()); 
            }
            // InternalXbaseWithAnnotations.g:150:3: ( rule__XAnnotationElementValue__Alternatives )
            // InternalXbaseWithAnnotations.g:150:4: rule__XAnnotationElementValue__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValue__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXAnnotationElementValue"


    // $ANTLR start "entryRuleXAnnotationOrExpression"
    // InternalXbaseWithAnnotations.g:159:1: entryRuleXAnnotationOrExpression : ruleXAnnotationOrExpression EOF ;
    public final void entryRuleXAnnotationOrExpression() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:160:1: ( ruleXAnnotationOrExpression EOF )
            // InternalXbaseWithAnnotations.g:161:1: ruleXAnnotationOrExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationOrExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXAnnotationOrExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationOrExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXAnnotationOrExpression"


    // $ANTLR start "ruleXAnnotationOrExpression"
    // InternalXbaseWithAnnotations.g:168:1: ruleXAnnotationOrExpression : ( ( rule__XAnnotationOrExpression__Alternatives ) ) ;
    public final void ruleXAnnotationOrExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:172:2: ( ( ( rule__XAnnotationOrExpression__Alternatives ) ) )
            // InternalXbaseWithAnnotations.g:173:2: ( ( rule__XAnnotationOrExpression__Alternatives ) )
            {
            // InternalXbaseWithAnnotations.g:173:2: ( ( rule__XAnnotationOrExpression__Alternatives ) )
            // InternalXbaseWithAnnotations.g:174:3: ( rule__XAnnotationOrExpression__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationOrExpressionAccess().getAlternatives()); 
            }
            // InternalXbaseWithAnnotations.g:175:3: ( rule__XAnnotationOrExpression__Alternatives )
            // InternalXbaseWithAnnotations.g:175:4: rule__XAnnotationOrExpression__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationOrExpression__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationOrExpressionAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXAnnotationOrExpression"


    // $ANTLR start "entryRuleXExpression"
    // InternalXbaseWithAnnotations.g:184:1: entryRuleXExpression : ruleXExpression EOF ;
    public final void entryRuleXExpression() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:185:1: ( ruleXExpression EOF )
            // InternalXbaseWithAnnotations.g:186:1: ruleXExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXExpression"


    // $ANTLR start "ruleXExpression"
    // InternalXbaseWithAnnotations.g:193:1: ruleXExpression : ( ruleXAssignment ) ;
    public final void ruleXExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:197:2: ( ( ruleXAssignment ) )
            // InternalXbaseWithAnnotations.g:198:2: ( ruleXAssignment )
            {
            // InternalXbaseWithAnnotations.g:198:2: ( ruleXAssignment )
            // InternalXbaseWithAnnotations.g:199:3: ruleXAssignment
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXExpressionAccess().getXAssignmentParserRuleCall()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAssignment();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXExpressionAccess().getXAssignmentParserRuleCall()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXExpression"


    // $ANTLR start "entryRuleXAssignment"
    // InternalXbaseWithAnnotations.g:209:1: entryRuleXAssignment : ruleXAssignment EOF ;
    public final void entryRuleXAssignment() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:210:1: ( ruleXAssignment EOF )
            // InternalXbaseWithAnnotations.g:211:1: ruleXAssignment EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXAssignment();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXAssignment"


    // $ANTLR start "ruleXAssignment"
    // InternalXbaseWithAnnotations.g:218:1: ruleXAssignment : ( ( rule__XAssignment__Alternatives ) ) ;
    public final void ruleXAssignment() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:222:2: ( ( ( rule__XAssignment__Alternatives ) ) )
            // InternalXbaseWithAnnotations.g:223:2: ( ( rule__XAssignment__Alternatives ) )
            {
            // InternalXbaseWithAnnotations.g:223:2: ( ( rule__XAssignment__Alternatives ) )
            // InternalXbaseWithAnnotations.g:224:3: ( rule__XAssignment__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getAlternatives()); 
            }
            // InternalXbaseWithAnnotations.g:225:3: ( rule__XAssignment__Alternatives )
            // InternalXbaseWithAnnotations.g:225:4: rule__XAssignment__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__XAssignment__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXAssignment"


    // $ANTLR start "entryRuleOpSingleAssign"
    // InternalXbaseWithAnnotations.g:234:1: entryRuleOpSingleAssign : ruleOpSingleAssign EOF ;
    public final void entryRuleOpSingleAssign() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:235:1: ( ruleOpSingleAssign EOF )
            // InternalXbaseWithAnnotations.g:236:1: ruleOpSingleAssign EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpSingleAssignRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleOpSingleAssign();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpSingleAssignRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleOpSingleAssign"


    // $ANTLR start "ruleOpSingleAssign"
    // InternalXbaseWithAnnotations.g:243:1: ruleOpSingleAssign : ( '=' ) ;
    public final void ruleOpSingleAssign() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:247:2: ( ( '=' ) )
            // InternalXbaseWithAnnotations.g:248:2: ( '=' )
            {
            // InternalXbaseWithAnnotations.g:248:2: ( '=' )
            // InternalXbaseWithAnnotations.g:249:3: '='
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpSingleAssignAccess().getEqualsSignKeyword()); 
            }
            match(input,13,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpSingleAssignAccess().getEqualsSignKeyword()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleOpSingleAssign"


    // $ANTLR start "entryRuleOpMultiAssign"
    // InternalXbaseWithAnnotations.g:259:1: entryRuleOpMultiAssign : ruleOpMultiAssign EOF ;
    public final void entryRuleOpMultiAssign() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:260:1: ( ruleOpMultiAssign EOF )
            // InternalXbaseWithAnnotations.g:261:1: ruleOpMultiAssign EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpMultiAssignRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleOpMultiAssign();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpMultiAssignRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleOpMultiAssign"


    // $ANTLR start "ruleOpMultiAssign"
    // InternalXbaseWithAnnotations.g:268:1: ruleOpMultiAssign : ( ( rule__OpMultiAssign__Alternatives ) ) ;
    public final void ruleOpMultiAssign() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:272:2: ( ( ( rule__OpMultiAssign__Alternatives ) ) )
            // InternalXbaseWithAnnotations.g:273:2: ( ( rule__OpMultiAssign__Alternatives ) )
            {
            // InternalXbaseWithAnnotations.g:273:2: ( ( rule__OpMultiAssign__Alternatives ) )
            // InternalXbaseWithAnnotations.g:274:3: ( rule__OpMultiAssign__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpMultiAssignAccess().getAlternatives()); 
            }
            // InternalXbaseWithAnnotations.g:275:3: ( rule__OpMultiAssign__Alternatives )
            // InternalXbaseWithAnnotations.g:275:4: rule__OpMultiAssign__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__OpMultiAssign__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpMultiAssignAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleOpMultiAssign"


    // $ANTLR start "entryRuleXOrExpression"
    // InternalXbaseWithAnnotations.g:284:1: entryRuleXOrExpression : ruleXOrExpression EOF ;
    public final void entryRuleXOrExpression() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:285:1: ( ruleXOrExpression EOF )
            // InternalXbaseWithAnnotations.g:286:1: ruleXOrExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOrExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXOrExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOrExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXOrExpression"


    // $ANTLR start "ruleXOrExpression"
    // InternalXbaseWithAnnotations.g:293:1: ruleXOrExpression : ( ( rule__XOrExpression__Group__0 ) ) ;
    public final void ruleXOrExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:297:2: ( ( ( rule__XOrExpression__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:298:2: ( ( rule__XOrExpression__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:298:2: ( ( rule__XOrExpression__Group__0 ) )
            // InternalXbaseWithAnnotations.g:299:3: ( rule__XOrExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOrExpressionAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:300:3: ( rule__XOrExpression__Group__0 )
            // InternalXbaseWithAnnotations.g:300:4: rule__XOrExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XOrExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOrExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXOrExpression"


    // $ANTLR start "entryRuleOpOr"
    // InternalXbaseWithAnnotations.g:309:1: entryRuleOpOr : ruleOpOr EOF ;
    public final void entryRuleOpOr() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:310:1: ( ruleOpOr EOF )
            // InternalXbaseWithAnnotations.g:311:1: ruleOpOr EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOrRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleOpOr();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOrRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleOpOr"


    // $ANTLR start "ruleOpOr"
    // InternalXbaseWithAnnotations.g:318:1: ruleOpOr : ( '||' ) ;
    public final void ruleOpOr() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:322:2: ( ( '||' ) )
            // InternalXbaseWithAnnotations.g:323:2: ( '||' )
            {
            // InternalXbaseWithAnnotations.g:323:2: ( '||' )
            // InternalXbaseWithAnnotations.g:324:3: '||'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOrAccess().getVerticalLineVerticalLineKeyword()); 
            }
            match(input,14,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOrAccess().getVerticalLineVerticalLineKeyword()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleOpOr"


    // $ANTLR start "entryRuleXAndExpression"
    // InternalXbaseWithAnnotations.g:334:1: entryRuleXAndExpression : ruleXAndExpression EOF ;
    public final void entryRuleXAndExpression() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:335:1: ( ruleXAndExpression EOF )
            // InternalXbaseWithAnnotations.g:336:1: ruleXAndExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAndExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXAndExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAndExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXAndExpression"


    // $ANTLR start "ruleXAndExpression"
    // InternalXbaseWithAnnotations.g:343:1: ruleXAndExpression : ( ( rule__XAndExpression__Group__0 ) ) ;
    public final void ruleXAndExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:347:2: ( ( ( rule__XAndExpression__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:348:2: ( ( rule__XAndExpression__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:348:2: ( ( rule__XAndExpression__Group__0 ) )
            // InternalXbaseWithAnnotations.g:349:3: ( rule__XAndExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAndExpressionAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:350:3: ( rule__XAndExpression__Group__0 )
            // InternalXbaseWithAnnotations.g:350:4: rule__XAndExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XAndExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAndExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXAndExpression"


    // $ANTLR start "entryRuleOpAnd"
    // InternalXbaseWithAnnotations.g:359:1: entryRuleOpAnd : ruleOpAnd EOF ;
    public final void entryRuleOpAnd() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:360:1: ( ruleOpAnd EOF )
            // InternalXbaseWithAnnotations.g:361:1: ruleOpAnd EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpAndRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleOpAnd();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpAndRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleOpAnd"


    // $ANTLR start "ruleOpAnd"
    // InternalXbaseWithAnnotations.g:368:1: ruleOpAnd : ( '&&' ) ;
    public final void ruleOpAnd() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:372:2: ( ( '&&' ) )
            // InternalXbaseWithAnnotations.g:373:2: ( '&&' )
            {
            // InternalXbaseWithAnnotations.g:373:2: ( '&&' )
            // InternalXbaseWithAnnotations.g:374:3: '&&'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpAndAccess().getAmpersandAmpersandKeyword()); 
            }
            match(input,15,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpAndAccess().getAmpersandAmpersandKeyword()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleOpAnd"


    // $ANTLR start "entryRuleXEqualityExpression"
    // InternalXbaseWithAnnotations.g:384:1: entryRuleXEqualityExpression : ruleXEqualityExpression EOF ;
    public final void entryRuleXEqualityExpression() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:385:1: ( ruleXEqualityExpression EOF )
            // InternalXbaseWithAnnotations.g:386:1: ruleXEqualityExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXEqualityExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXEqualityExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXEqualityExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXEqualityExpression"


    // $ANTLR start "ruleXEqualityExpression"
    // InternalXbaseWithAnnotations.g:393:1: ruleXEqualityExpression : ( ( rule__XEqualityExpression__Group__0 ) ) ;
    public final void ruleXEqualityExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:397:2: ( ( ( rule__XEqualityExpression__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:398:2: ( ( rule__XEqualityExpression__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:398:2: ( ( rule__XEqualityExpression__Group__0 ) )
            // InternalXbaseWithAnnotations.g:399:3: ( rule__XEqualityExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXEqualityExpressionAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:400:3: ( rule__XEqualityExpression__Group__0 )
            // InternalXbaseWithAnnotations.g:400:4: rule__XEqualityExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XEqualityExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXEqualityExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXEqualityExpression"


    // $ANTLR start "entryRuleOpEquality"
    // InternalXbaseWithAnnotations.g:409:1: entryRuleOpEquality : ruleOpEquality EOF ;
    public final void entryRuleOpEquality() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:410:1: ( ruleOpEquality EOF )
            // InternalXbaseWithAnnotations.g:411:1: ruleOpEquality EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpEqualityRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleOpEquality();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpEqualityRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleOpEquality"


    // $ANTLR start "ruleOpEquality"
    // InternalXbaseWithAnnotations.g:418:1: ruleOpEquality : ( ( rule__OpEquality__Alternatives ) ) ;
    public final void ruleOpEquality() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:422:2: ( ( ( rule__OpEquality__Alternatives ) ) )
            // InternalXbaseWithAnnotations.g:423:2: ( ( rule__OpEquality__Alternatives ) )
            {
            // InternalXbaseWithAnnotations.g:423:2: ( ( rule__OpEquality__Alternatives ) )
            // InternalXbaseWithAnnotations.g:424:3: ( rule__OpEquality__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpEqualityAccess().getAlternatives()); 
            }
            // InternalXbaseWithAnnotations.g:425:3: ( rule__OpEquality__Alternatives )
            // InternalXbaseWithAnnotations.g:425:4: rule__OpEquality__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__OpEquality__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpEqualityAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleOpEquality"


    // $ANTLR start "entryRuleXRelationalExpression"
    // InternalXbaseWithAnnotations.g:434:1: entryRuleXRelationalExpression : ruleXRelationalExpression EOF ;
    public final void entryRuleXRelationalExpression() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:435:1: ( ruleXRelationalExpression EOF )
            // InternalXbaseWithAnnotations.g:436:1: ruleXRelationalExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXRelationalExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXRelationalExpression"


    // $ANTLR start "ruleXRelationalExpression"
    // InternalXbaseWithAnnotations.g:443:1: ruleXRelationalExpression : ( ( rule__XRelationalExpression__Group__0 ) ) ;
    public final void ruleXRelationalExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:447:2: ( ( ( rule__XRelationalExpression__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:448:2: ( ( rule__XRelationalExpression__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:448:2: ( ( rule__XRelationalExpression__Group__0 ) )
            // InternalXbaseWithAnnotations.g:449:3: ( rule__XRelationalExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:450:3: ( rule__XRelationalExpression__Group__0 )
            // InternalXbaseWithAnnotations.g:450:4: rule__XRelationalExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXRelationalExpression"


    // $ANTLR start "entryRuleOpCompare"
    // InternalXbaseWithAnnotations.g:459:1: entryRuleOpCompare : ruleOpCompare EOF ;
    public final void entryRuleOpCompare() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:460:1: ( ruleOpCompare EOF )
            // InternalXbaseWithAnnotations.g:461:1: ruleOpCompare EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpCompareRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleOpCompare();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpCompareRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleOpCompare"


    // $ANTLR start "ruleOpCompare"
    // InternalXbaseWithAnnotations.g:468:1: ruleOpCompare : ( ( rule__OpCompare__Alternatives ) ) ;
    public final void ruleOpCompare() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:472:2: ( ( ( rule__OpCompare__Alternatives ) ) )
            // InternalXbaseWithAnnotations.g:473:2: ( ( rule__OpCompare__Alternatives ) )
            {
            // InternalXbaseWithAnnotations.g:473:2: ( ( rule__OpCompare__Alternatives ) )
            // InternalXbaseWithAnnotations.g:474:3: ( rule__OpCompare__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpCompareAccess().getAlternatives()); 
            }
            // InternalXbaseWithAnnotations.g:475:3: ( rule__OpCompare__Alternatives )
            // InternalXbaseWithAnnotations.g:475:4: rule__OpCompare__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__OpCompare__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpCompareAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleOpCompare"


    // $ANTLR start "entryRuleXOtherOperatorExpression"
    // InternalXbaseWithAnnotations.g:484:1: entryRuleXOtherOperatorExpression : ruleXOtherOperatorExpression EOF ;
    public final void entryRuleXOtherOperatorExpression() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:485:1: ( ruleXOtherOperatorExpression EOF )
            // InternalXbaseWithAnnotations.g:486:1: ruleXOtherOperatorExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOtherOperatorExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXOtherOperatorExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOtherOperatorExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXOtherOperatorExpression"


    // $ANTLR start "ruleXOtherOperatorExpression"
    // InternalXbaseWithAnnotations.g:493:1: ruleXOtherOperatorExpression : ( ( rule__XOtherOperatorExpression__Group__0 ) ) ;
    public final void ruleXOtherOperatorExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:497:2: ( ( ( rule__XOtherOperatorExpression__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:498:2: ( ( rule__XOtherOperatorExpression__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:498:2: ( ( rule__XOtherOperatorExpression__Group__0 ) )
            // InternalXbaseWithAnnotations.g:499:3: ( rule__XOtherOperatorExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOtherOperatorExpressionAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:500:3: ( rule__XOtherOperatorExpression__Group__0 )
            // InternalXbaseWithAnnotations.g:500:4: rule__XOtherOperatorExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XOtherOperatorExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOtherOperatorExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXOtherOperatorExpression"


    // $ANTLR start "entryRuleOpOther"
    // InternalXbaseWithAnnotations.g:509:1: entryRuleOpOther : ruleOpOther EOF ;
    public final void entryRuleOpOther() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:510:1: ( ruleOpOther EOF )
            // InternalXbaseWithAnnotations.g:511:1: ruleOpOther EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleOpOther();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleOpOther"


    // $ANTLR start "ruleOpOther"
    // InternalXbaseWithAnnotations.g:518:1: ruleOpOther : ( ( rule__OpOther__Alternatives ) ) ;
    public final void ruleOpOther() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:522:2: ( ( ( rule__OpOther__Alternatives ) ) )
            // InternalXbaseWithAnnotations.g:523:2: ( ( rule__OpOther__Alternatives ) )
            {
            // InternalXbaseWithAnnotations.g:523:2: ( ( rule__OpOther__Alternatives ) )
            // InternalXbaseWithAnnotations.g:524:3: ( rule__OpOther__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getAlternatives()); 
            }
            // InternalXbaseWithAnnotations.g:525:3: ( rule__OpOther__Alternatives )
            // InternalXbaseWithAnnotations.g:525:4: rule__OpOther__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__OpOther__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleOpOther"


    // $ANTLR start "entryRuleXAdditiveExpression"
    // InternalXbaseWithAnnotations.g:534:1: entryRuleXAdditiveExpression : ruleXAdditiveExpression EOF ;
    public final void entryRuleXAdditiveExpression() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:535:1: ( ruleXAdditiveExpression EOF )
            // InternalXbaseWithAnnotations.g:536:1: ruleXAdditiveExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAdditiveExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXAdditiveExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAdditiveExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXAdditiveExpression"


    // $ANTLR start "ruleXAdditiveExpression"
    // InternalXbaseWithAnnotations.g:543:1: ruleXAdditiveExpression : ( ( rule__XAdditiveExpression__Group__0 ) ) ;
    public final void ruleXAdditiveExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:547:2: ( ( ( rule__XAdditiveExpression__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:548:2: ( ( rule__XAdditiveExpression__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:548:2: ( ( rule__XAdditiveExpression__Group__0 ) )
            // InternalXbaseWithAnnotations.g:549:3: ( rule__XAdditiveExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAdditiveExpressionAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:550:3: ( rule__XAdditiveExpression__Group__0 )
            // InternalXbaseWithAnnotations.g:550:4: rule__XAdditiveExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XAdditiveExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAdditiveExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXAdditiveExpression"


    // $ANTLR start "entryRuleOpAdd"
    // InternalXbaseWithAnnotations.g:559:1: entryRuleOpAdd : ruleOpAdd EOF ;
    public final void entryRuleOpAdd() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:560:1: ( ruleOpAdd EOF )
            // InternalXbaseWithAnnotations.g:561:1: ruleOpAdd EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpAddRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleOpAdd();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpAddRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleOpAdd"


    // $ANTLR start "ruleOpAdd"
    // InternalXbaseWithAnnotations.g:568:1: ruleOpAdd : ( ( rule__OpAdd__Alternatives ) ) ;
    public final void ruleOpAdd() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:572:2: ( ( ( rule__OpAdd__Alternatives ) ) )
            // InternalXbaseWithAnnotations.g:573:2: ( ( rule__OpAdd__Alternatives ) )
            {
            // InternalXbaseWithAnnotations.g:573:2: ( ( rule__OpAdd__Alternatives ) )
            // InternalXbaseWithAnnotations.g:574:3: ( rule__OpAdd__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpAddAccess().getAlternatives()); 
            }
            // InternalXbaseWithAnnotations.g:575:3: ( rule__OpAdd__Alternatives )
            // InternalXbaseWithAnnotations.g:575:4: rule__OpAdd__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__OpAdd__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpAddAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleOpAdd"


    // $ANTLR start "entryRuleXMultiplicativeExpression"
    // InternalXbaseWithAnnotations.g:584:1: entryRuleXMultiplicativeExpression : ruleXMultiplicativeExpression EOF ;
    public final void entryRuleXMultiplicativeExpression() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:585:1: ( ruleXMultiplicativeExpression EOF )
            // InternalXbaseWithAnnotations.g:586:1: ruleXMultiplicativeExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMultiplicativeExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXMultiplicativeExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMultiplicativeExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXMultiplicativeExpression"


    // $ANTLR start "ruleXMultiplicativeExpression"
    // InternalXbaseWithAnnotations.g:593:1: ruleXMultiplicativeExpression : ( ( rule__XMultiplicativeExpression__Group__0 ) ) ;
    public final void ruleXMultiplicativeExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:597:2: ( ( ( rule__XMultiplicativeExpression__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:598:2: ( ( rule__XMultiplicativeExpression__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:598:2: ( ( rule__XMultiplicativeExpression__Group__0 ) )
            // InternalXbaseWithAnnotations.g:599:3: ( rule__XMultiplicativeExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMultiplicativeExpressionAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:600:3: ( rule__XMultiplicativeExpression__Group__0 )
            // InternalXbaseWithAnnotations.g:600:4: rule__XMultiplicativeExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XMultiplicativeExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMultiplicativeExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXMultiplicativeExpression"


    // $ANTLR start "entryRuleOpMulti"
    // InternalXbaseWithAnnotations.g:609:1: entryRuleOpMulti : ruleOpMulti EOF ;
    public final void entryRuleOpMulti() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:610:1: ( ruleOpMulti EOF )
            // InternalXbaseWithAnnotations.g:611:1: ruleOpMulti EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpMultiRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleOpMulti();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpMultiRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleOpMulti"


    // $ANTLR start "ruleOpMulti"
    // InternalXbaseWithAnnotations.g:618:1: ruleOpMulti : ( ( rule__OpMulti__Alternatives ) ) ;
    public final void ruleOpMulti() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:622:2: ( ( ( rule__OpMulti__Alternatives ) ) )
            // InternalXbaseWithAnnotations.g:623:2: ( ( rule__OpMulti__Alternatives ) )
            {
            // InternalXbaseWithAnnotations.g:623:2: ( ( rule__OpMulti__Alternatives ) )
            // InternalXbaseWithAnnotations.g:624:3: ( rule__OpMulti__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpMultiAccess().getAlternatives()); 
            }
            // InternalXbaseWithAnnotations.g:625:3: ( rule__OpMulti__Alternatives )
            // InternalXbaseWithAnnotations.g:625:4: rule__OpMulti__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__OpMulti__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpMultiAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleOpMulti"


    // $ANTLR start "entryRuleXUnaryOperation"
    // InternalXbaseWithAnnotations.g:634:1: entryRuleXUnaryOperation : ruleXUnaryOperation EOF ;
    public final void entryRuleXUnaryOperation() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:635:1: ( ruleXUnaryOperation EOF )
            // InternalXbaseWithAnnotations.g:636:1: ruleXUnaryOperation EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXUnaryOperationRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXUnaryOperation();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXUnaryOperationRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXUnaryOperation"


    // $ANTLR start "ruleXUnaryOperation"
    // InternalXbaseWithAnnotations.g:643:1: ruleXUnaryOperation : ( ( rule__XUnaryOperation__Alternatives ) ) ;
    public final void ruleXUnaryOperation() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:647:2: ( ( ( rule__XUnaryOperation__Alternatives ) ) )
            // InternalXbaseWithAnnotations.g:648:2: ( ( rule__XUnaryOperation__Alternatives ) )
            {
            // InternalXbaseWithAnnotations.g:648:2: ( ( rule__XUnaryOperation__Alternatives ) )
            // InternalXbaseWithAnnotations.g:649:3: ( rule__XUnaryOperation__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXUnaryOperationAccess().getAlternatives()); 
            }
            // InternalXbaseWithAnnotations.g:650:3: ( rule__XUnaryOperation__Alternatives )
            // InternalXbaseWithAnnotations.g:650:4: rule__XUnaryOperation__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__XUnaryOperation__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXUnaryOperationAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXUnaryOperation"


    // $ANTLR start "entryRuleOpUnary"
    // InternalXbaseWithAnnotations.g:659:1: entryRuleOpUnary : ruleOpUnary EOF ;
    public final void entryRuleOpUnary() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:660:1: ( ruleOpUnary EOF )
            // InternalXbaseWithAnnotations.g:661:1: ruleOpUnary EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpUnaryRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleOpUnary();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpUnaryRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleOpUnary"


    // $ANTLR start "ruleOpUnary"
    // InternalXbaseWithAnnotations.g:668:1: ruleOpUnary : ( ( rule__OpUnary__Alternatives ) ) ;
    public final void ruleOpUnary() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:672:2: ( ( ( rule__OpUnary__Alternatives ) ) )
            // InternalXbaseWithAnnotations.g:673:2: ( ( rule__OpUnary__Alternatives ) )
            {
            // InternalXbaseWithAnnotations.g:673:2: ( ( rule__OpUnary__Alternatives ) )
            // InternalXbaseWithAnnotations.g:674:3: ( rule__OpUnary__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpUnaryAccess().getAlternatives()); 
            }
            // InternalXbaseWithAnnotations.g:675:3: ( rule__OpUnary__Alternatives )
            // InternalXbaseWithAnnotations.g:675:4: rule__OpUnary__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__OpUnary__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpUnaryAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleOpUnary"


    // $ANTLR start "entryRuleXCastedExpression"
    // InternalXbaseWithAnnotations.g:684:1: entryRuleXCastedExpression : ruleXCastedExpression EOF ;
    public final void entryRuleXCastedExpression() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:685:1: ( ruleXCastedExpression EOF )
            // InternalXbaseWithAnnotations.g:686:1: ruleXCastedExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCastedExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXCastedExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCastedExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXCastedExpression"


    // $ANTLR start "ruleXCastedExpression"
    // InternalXbaseWithAnnotations.g:693:1: ruleXCastedExpression : ( ( rule__XCastedExpression__Group__0 ) ) ;
    public final void ruleXCastedExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:697:2: ( ( ( rule__XCastedExpression__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:698:2: ( ( rule__XCastedExpression__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:698:2: ( ( rule__XCastedExpression__Group__0 ) )
            // InternalXbaseWithAnnotations.g:699:3: ( rule__XCastedExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCastedExpressionAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:700:3: ( rule__XCastedExpression__Group__0 )
            // InternalXbaseWithAnnotations.g:700:4: rule__XCastedExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XCastedExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCastedExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXCastedExpression"


    // $ANTLR start "entryRuleXPostfixOperation"
    // InternalXbaseWithAnnotations.g:709:1: entryRuleXPostfixOperation : ruleXPostfixOperation EOF ;
    public final void entryRuleXPostfixOperation() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:710:1: ( ruleXPostfixOperation EOF )
            // InternalXbaseWithAnnotations.g:711:1: ruleXPostfixOperation EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXPostfixOperationRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXPostfixOperation();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXPostfixOperationRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXPostfixOperation"


    // $ANTLR start "ruleXPostfixOperation"
    // InternalXbaseWithAnnotations.g:718:1: ruleXPostfixOperation : ( ( rule__XPostfixOperation__Group__0 ) ) ;
    public final void ruleXPostfixOperation() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:722:2: ( ( ( rule__XPostfixOperation__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:723:2: ( ( rule__XPostfixOperation__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:723:2: ( ( rule__XPostfixOperation__Group__0 ) )
            // InternalXbaseWithAnnotations.g:724:3: ( rule__XPostfixOperation__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXPostfixOperationAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:725:3: ( rule__XPostfixOperation__Group__0 )
            // InternalXbaseWithAnnotations.g:725:4: rule__XPostfixOperation__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XPostfixOperation__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXPostfixOperationAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXPostfixOperation"


    // $ANTLR start "entryRuleOpPostfix"
    // InternalXbaseWithAnnotations.g:734:1: entryRuleOpPostfix : ruleOpPostfix EOF ;
    public final void entryRuleOpPostfix() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:735:1: ( ruleOpPostfix EOF )
            // InternalXbaseWithAnnotations.g:736:1: ruleOpPostfix EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpPostfixRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleOpPostfix();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpPostfixRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleOpPostfix"


    // $ANTLR start "ruleOpPostfix"
    // InternalXbaseWithAnnotations.g:743:1: ruleOpPostfix : ( ( rule__OpPostfix__Alternatives ) ) ;
    public final void ruleOpPostfix() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:747:2: ( ( ( rule__OpPostfix__Alternatives ) ) )
            // InternalXbaseWithAnnotations.g:748:2: ( ( rule__OpPostfix__Alternatives ) )
            {
            // InternalXbaseWithAnnotations.g:748:2: ( ( rule__OpPostfix__Alternatives ) )
            // InternalXbaseWithAnnotations.g:749:3: ( rule__OpPostfix__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpPostfixAccess().getAlternatives()); 
            }
            // InternalXbaseWithAnnotations.g:750:3: ( rule__OpPostfix__Alternatives )
            // InternalXbaseWithAnnotations.g:750:4: rule__OpPostfix__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__OpPostfix__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpPostfixAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleOpPostfix"


    // $ANTLR start "entryRuleXMemberFeatureCall"
    // InternalXbaseWithAnnotations.g:759:1: entryRuleXMemberFeatureCall : ruleXMemberFeatureCall EOF ;
    public final void entryRuleXMemberFeatureCall() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:760:1: ( ruleXMemberFeatureCall EOF )
            // InternalXbaseWithAnnotations.g:761:1: ruleXMemberFeatureCall EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXMemberFeatureCall();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXMemberFeatureCall"


    // $ANTLR start "ruleXMemberFeatureCall"
    // InternalXbaseWithAnnotations.g:768:1: ruleXMemberFeatureCall : ( ( rule__XMemberFeatureCall__Group__0 ) ) ;
    public final void ruleXMemberFeatureCall() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:772:2: ( ( ( rule__XMemberFeatureCall__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:773:2: ( ( rule__XMemberFeatureCall__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:773:2: ( ( rule__XMemberFeatureCall__Group__0 ) )
            // InternalXbaseWithAnnotations.g:774:3: ( rule__XMemberFeatureCall__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:775:3: ( rule__XMemberFeatureCall__Group__0 )
            // InternalXbaseWithAnnotations.g:775:4: rule__XMemberFeatureCall__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXMemberFeatureCall"


    // $ANTLR start "entryRuleXPrimaryExpression"
    // InternalXbaseWithAnnotations.g:784:1: entryRuleXPrimaryExpression : ruleXPrimaryExpression EOF ;
    public final void entryRuleXPrimaryExpression() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:785:1: ( ruleXPrimaryExpression EOF )
            // InternalXbaseWithAnnotations.g:786:1: ruleXPrimaryExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXPrimaryExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXPrimaryExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXPrimaryExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXPrimaryExpression"


    // $ANTLR start "ruleXPrimaryExpression"
    // InternalXbaseWithAnnotations.g:793:1: ruleXPrimaryExpression : ( ( rule__XPrimaryExpression__Alternatives ) ) ;
    public final void ruleXPrimaryExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:797:2: ( ( ( rule__XPrimaryExpression__Alternatives ) ) )
            // InternalXbaseWithAnnotations.g:798:2: ( ( rule__XPrimaryExpression__Alternatives ) )
            {
            // InternalXbaseWithAnnotations.g:798:2: ( ( rule__XPrimaryExpression__Alternatives ) )
            // InternalXbaseWithAnnotations.g:799:3: ( rule__XPrimaryExpression__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXPrimaryExpressionAccess().getAlternatives()); 
            }
            // InternalXbaseWithAnnotations.g:800:3: ( rule__XPrimaryExpression__Alternatives )
            // InternalXbaseWithAnnotations.g:800:4: rule__XPrimaryExpression__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__XPrimaryExpression__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXPrimaryExpressionAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXPrimaryExpression"


    // $ANTLR start "entryRuleXLiteral"
    // InternalXbaseWithAnnotations.g:809:1: entryRuleXLiteral : ruleXLiteral EOF ;
    public final void entryRuleXLiteral() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:810:1: ( ruleXLiteral EOF )
            // InternalXbaseWithAnnotations.g:811:1: ruleXLiteral EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXLiteral();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXLiteralRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXLiteral"


    // $ANTLR start "ruleXLiteral"
    // InternalXbaseWithAnnotations.g:818:1: ruleXLiteral : ( ( rule__XLiteral__Alternatives ) ) ;
    public final void ruleXLiteral() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:822:2: ( ( ( rule__XLiteral__Alternatives ) ) )
            // InternalXbaseWithAnnotations.g:823:2: ( ( rule__XLiteral__Alternatives ) )
            {
            // InternalXbaseWithAnnotations.g:823:2: ( ( rule__XLiteral__Alternatives ) )
            // InternalXbaseWithAnnotations.g:824:3: ( rule__XLiteral__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXLiteralAccess().getAlternatives()); 
            }
            // InternalXbaseWithAnnotations.g:825:3: ( rule__XLiteral__Alternatives )
            // InternalXbaseWithAnnotations.g:825:4: rule__XLiteral__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__XLiteral__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXLiteralAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXLiteral"


    // $ANTLR start "entryRuleXCollectionLiteral"
    // InternalXbaseWithAnnotations.g:834:1: entryRuleXCollectionLiteral : ruleXCollectionLiteral EOF ;
    public final void entryRuleXCollectionLiteral() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:835:1: ( ruleXCollectionLiteral EOF )
            // InternalXbaseWithAnnotations.g:836:1: ruleXCollectionLiteral EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCollectionLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXCollectionLiteral();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCollectionLiteralRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXCollectionLiteral"


    // $ANTLR start "ruleXCollectionLiteral"
    // InternalXbaseWithAnnotations.g:843:1: ruleXCollectionLiteral : ( ( rule__XCollectionLiteral__Alternatives ) ) ;
    public final void ruleXCollectionLiteral() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:847:2: ( ( ( rule__XCollectionLiteral__Alternatives ) ) )
            // InternalXbaseWithAnnotations.g:848:2: ( ( rule__XCollectionLiteral__Alternatives ) )
            {
            // InternalXbaseWithAnnotations.g:848:2: ( ( rule__XCollectionLiteral__Alternatives ) )
            // InternalXbaseWithAnnotations.g:849:3: ( rule__XCollectionLiteral__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCollectionLiteralAccess().getAlternatives()); 
            }
            // InternalXbaseWithAnnotations.g:850:3: ( rule__XCollectionLiteral__Alternatives )
            // InternalXbaseWithAnnotations.g:850:4: rule__XCollectionLiteral__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__XCollectionLiteral__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCollectionLiteralAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXCollectionLiteral"


    // $ANTLR start "entryRuleXSetLiteral"
    // InternalXbaseWithAnnotations.g:859:1: entryRuleXSetLiteral : ruleXSetLiteral EOF ;
    public final void entryRuleXSetLiteral() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:860:1: ( ruleXSetLiteral EOF )
            // InternalXbaseWithAnnotations.g:861:1: ruleXSetLiteral EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXSetLiteral();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXSetLiteral"


    // $ANTLR start "ruleXSetLiteral"
    // InternalXbaseWithAnnotations.g:868:1: ruleXSetLiteral : ( ( rule__XSetLiteral__Group__0 ) ) ;
    public final void ruleXSetLiteral() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:872:2: ( ( ( rule__XSetLiteral__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:873:2: ( ( rule__XSetLiteral__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:873:2: ( ( rule__XSetLiteral__Group__0 ) )
            // InternalXbaseWithAnnotations.g:874:3: ( rule__XSetLiteral__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:875:3: ( rule__XSetLiteral__Group__0 )
            // InternalXbaseWithAnnotations.g:875:4: rule__XSetLiteral__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XSetLiteral__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXSetLiteral"


    // $ANTLR start "entryRuleXListLiteral"
    // InternalXbaseWithAnnotations.g:884:1: entryRuleXListLiteral : ruleXListLiteral EOF ;
    public final void entryRuleXListLiteral() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:885:1: ( ruleXListLiteral EOF )
            // InternalXbaseWithAnnotations.g:886:1: ruleXListLiteral EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXListLiteral();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXListLiteral"


    // $ANTLR start "ruleXListLiteral"
    // InternalXbaseWithAnnotations.g:893:1: ruleXListLiteral : ( ( rule__XListLiteral__Group__0 ) ) ;
    public final void ruleXListLiteral() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:897:2: ( ( ( rule__XListLiteral__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:898:2: ( ( rule__XListLiteral__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:898:2: ( ( rule__XListLiteral__Group__0 ) )
            // InternalXbaseWithAnnotations.g:899:3: ( rule__XListLiteral__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:900:3: ( rule__XListLiteral__Group__0 )
            // InternalXbaseWithAnnotations.g:900:4: rule__XListLiteral__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XListLiteral__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXListLiteral"


    // $ANTLR start "entryRuleXClosure"
    // InternalXbaseWithAnnotations.g:909:1: entryRuleXClosure : ruleXClosure EOF ;
    public final void entryRuleXClosure() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:910:1: ( ruleXClosure EOF )
            // InternalXbaseWithAnnotations.g:911:1: ruleXClosure EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXClosure();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXClosure"


    // $ANTLR start "ruleXClosure"
    // InternalXbaseWithAnnotations.g:918:1: ruleXClosure : ( ( rule__XClosure__Group__0 ) ) ;
    public final void ruleXClosure() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:922:2: ( ( ( rule__XClosure__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:923:2: ( ( rule__XClosure__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:923:2: ( ( rule__XClosure__Group__0 ) )
            // InternalXbaseWithAnnotations.g:924:3: ( rule__XClosure__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:925:3: ( rule__XClosure__Group__0 )
            // InternalXbaseWithAnnotations.g:925:4: rule__XClosure__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXClosure"


    // $ANTLR start "entryRuleXExpressionInClosure"
    // InternalXbaseWithAnnotations.g:934:1: entryRuleXExpressionInClosure : ruleXExpressionInClosure EOF ;
    public final void entryRuleXExpressionInClosure() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:935:1: ( ruleXExpressionInClosure EOF )
            // InternalXbaseWithAnnotations.g:936:1: ruleXExpressionInClosure EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXExpressionInClosureRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXExpressionInClosure();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXExpressionInClosureRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXExpressionInClosure"


    // $ANTLR start "ruleXExpressionInClosure"
    // InternalXbaseWithAnnotations.g:943:1: ruleXExpressionInClosure : ( ( rule__XExpressionInClosure__Group__0 ) ) ;
    public final void ruleXExpressionInClosure() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:947:2: ( ( ( rule__XExpressionInClosure__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:948:2: ( ( rule__XExpressionInClosure__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:948:2: ( ( rule__XExpressionInClosure__Group__0 ) )
            // InternalXbaseWithAnnotations.g:949:3: ( rule__XExpressionInClosure__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXExpressionInClosureAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:950:3: ( rule__XExpressionInClosure__Group__0 )
            // InternalXbaseWithAnnotations.g:950:4: rule__XExpressionInClosure__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XExpressionInClosure__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXExpressionInClosureAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXExpressionInClosure"


    // $ANTLR start "entryRuleXShortClosure"
    // InternalXbaseWithAnnotations.g:959:1: entryRuleXShortClosure : ruleXShortClosure EOF ;
    public final void entryRuleXShortClosure() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:960:1: ( ruleXShortClosure EOF )
            // InternalXbaseWithAnnotations.g:961:1: ruleXShortClosure EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXShortClosure();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXShortClosure"


    // $ANTLR start "ruleXShortClosure"
    // InternalXbaseWithAnnotations.g:968:1: ruleXShortClosure : ( ( rule__XShortClosure__Group__0 ) ) ;
    public final void ruleXShortClosure() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:972:2: ( ( ( rule__XShortClosure__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:973:2: ( ( rule__XShortClosure__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:973:2: ( ( rule__XShortClosure__Group__0 ) )
            // InternalXbaseWithAnnotations.g:974:3: ( rule__XShortClosure__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:975:3: ( rule__XShortClosure__Group__0 )
            // InternalXbaseWithAnnotations.g:975:4: rule__XShortClosure__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXShortClosure"


    // $ANTLR start "entryRuleXParenthesizedExpression"
    // InternalXbaseWithAnnotations.g:984:1: entryRuleXParenthesizedExpression : ruleXParenthesizedExpression EOF ;
    public final void entryRuleXParenthesizedExpression() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:985:1: ( ruleXParenthesizedExpression EOF )
            // InternalXbaseWithAnnotations.g:986:1: ruleXParenthesizedExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXParenthesizedExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXParenthesizedExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXParenthesizedExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXParenthesizedExpression"


    // $ANTLR start "ruleXParenthesizedExpression"
    // InternalXbaseWithAnnotations.g:993:1: ruleXParenthesizedExpression : ( ( rule__XParenthesizedExpression__Group__0 ) ) ;
    public final void ruleXParenthesizedExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:997:2: ( ( ( rule__XParenthesizedExpression__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:998:2: ( ( rule__XParenthesizedExpression__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:998:2: ( ( rule__XParenthesizedExpression__Group__0 ) )
            // InternalXbaseWithAnnotations.g:999:3: ( rule__XParenthesizedExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXParenthesizedExpressionAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1000:3: ( rule__XParenthesizedExpression__Group__0 )
            // InternalXbaseWithAnnotations.g:1000:4: rule__XParenthesizedExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XParenthesizedExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXParenthesizedExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXParenthesizedExpression"


    // $ANTLR start "entryRuleXIfExpression"
    // InternalXbaseWithAnnotations.g:1009:1: entryRuleXIfExpression : ruleXIfExpression EOF ;
    public final void entryRuleXIfExpression() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1010:1: ( ruleXIfExpression EOF )
            // InternalXbaseWithAnnotations.g:1011:1: ruleXIfExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXIfExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXIfExpression"


    // $ANTLR start "ruleXIfExpression"
    // InternalXbaseWithAnnotations.g:1018:1: ruleXIfExpression : ( ( rule__XIfExpression__Group__0 ) ) ;
    public final void ruleXIfExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1022:2: ( ( ( rule__XIfExpression__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1023:2: ( ( rule__XIfExpression__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1023:2: ( ( rule__XIfExpression__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1024:3: ( rule__XIfExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1025:3: ( rule__XIfExpression__Group__0 )
            // InternalXbaseWithAnnotations.g:1025:4: rule__XIfExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XIfExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXIfExpression"


    // $ANTLR start "entryRuleXSwitchExpression"
    // InternalXbaseWithAnnotations.g:1034:1: entryRuleXSwitchExpression : ruleXSwitchExpression EOF ;
    public final void entryRuleXSwitchExpression() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1035:1: ( ruleXSwitchExpression EOF )
            // InternalXbaseWithAnnotations.g:1036:1: ruleXSwitchExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXSwitchExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXSwitchExpression"


    // $ANTLR start "ruleXSwitchExpression"
    // InternalXbaseWithAnnotations.g:1043:1: ruleXSwitchExpression : ( ( rule__XSwitchExpression__Group__0 ) ) ;
    public final void ruleXSwitchExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1047:2: ( ( ( rule__XSwitchExpression__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1048:2: ( ( rule__XSwitchExpression__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1048:2: ( ( rule__XSwitchExpression__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1049:3: ( rule__XSwitchExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1050:3: ( rule__XSwitchExpression__Group__0 )
            // InternalXbaseWithAnnotations.g:1050:4: rule__XSwitchExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXSwitchExpression"


    // $ANTLR start "entryRuleXCasePart"
    // InternalXbaseWithAnnotations.g:1059:1: entryRuleXCasePart : ruleXCasePart EOF ;
    public final void entryRuleXCasePart() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1060:1: ( ruleXCasePart EOF )
            // InternalXbaseWithAnnotations.g:1061:1: ruleXCasePart EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXCasePart();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXCasePart"


    // $ANTLR start "ruleXCasePart"
    // InternalXbaseWithAnnotations.g:1068:1: ruleXCasePart : ( ( rule__XCasePart__Group__0 ) ) ;
    public final void ruleXCasePart() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1072:2: ( ( ( rule__XCasePart__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1073:2: ( ( rule__XCasePart__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1073:2: ( ( rule__XCasePart__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1074:3: ( rule__XCasePart__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1075:3: ( rule__XCasePart__Group__0 )
            // InternalXbaseWithAnnotations.g:1075:4: rule__XCasePart__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XCasePart__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXCasePart"


    // $ANTLR start "entryRuleXForLoopExpression"
    // InternalXbaseWithAnnotations.g:1084:1: entryRuleXForLoopExpression : ruleXForLoopExpression EOF ;
    public final void entryRuleXForLoopExpression() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1085:1: ( ruleXForLoopExpression EOF )
            // InternalXbaseWithAnnotations.g:1086:1: ruleXForLoopExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXForLoopExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXForLoopExpression"


    // $ANTLR start "ruleXForLoopExpression"
    // InternalXbaseWithAnnotations.g:1093:1: ruleXForLoopExpression : ( ( rule__XForLoopExpression__Group__0 ) ) ;
    public final void ruleXForLoopExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1097:2: ( ( ( rule__XForLoopExpression__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1098:2: ( ( rule__XForLoopExpression__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1098:2: ( ( rule__XForLoopExpression__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1099:3: ( rule__XForLoopExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1100:3: ( rule__XForLoopExpression__Group__0 )
            // InternalXbaseWithAnnotations.g:1100:4: rule__XForLoopExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXForLoopExpression"


    // $ANTLR start "entryRuleXBasicForLoopExpression"
    // InternalXbaseWithAnnotations.g:1109:1: entryRuleXBasicForLoopExpression : ruleXBasicForLoopExpression EOF ;
    public final void entryRuleXBasicForLoopExpression() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1110:1: ( ruleXBasicForLoopExpression EOF )
            // InternalXbaseWithAnnotations.g:1111:1: ruleXBasicForLoopExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXBasicForLoopExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXBasicForLoopExpression"


    // $ANTLR start "ruleXBasicForLoopExpression"
    // InternalXbaseWithAnnotations.g:1118:1: ruleXBasicForLoopExpression : ( ( rule__XBasicForLoopExpression__Group__0 ) ) ;
    public final void ruleXBasicForLoopExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1122:2: ( ( ( rule__XBasicForLoopExpression__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1123:2: ( ( rule__XBasicForLoopExpression__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1123:2: ( ( rule__XBasicForLoopExpression__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1124:3: ( rule__XBasicForLoopExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1125:3: ( rule__XBasicForLoopExpression__Group__0 )
            // InternalXbaseWithAnnotations.g:1125:4: rule__XBasicForLoopExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXBasicForLoopExpression"


    // $ANTLR start "entryRuleXWhileExpression"
    // InternalXbaseWithAnnotations.g:1134:1: entryRuleXWhileExpression : ruleXWhileExpression EOF ;
    public final void entryRuleXWhileExpression() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1135:1: ( ruleXWhileExpression EOF )
            // InternalXbaseWithAnnotations.g:1136:1: ruleXWhileExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXWhileExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXWhileExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXWhileExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXWhileExpression"


    // $ANTLR start "ruleXWhileExpression"
    // InternalXbaseWithAnnotations.g:1143:1: ruleXWhileExpression : ( ( rule__XWhileExpression__Group__0 ) ) ;
    public final void ruleXWhileExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1147:2: ( ( ( rule__XWhileExpression__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1148:2: ( ( rule__XWhileExpression__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1148:2: ( ( rule__XWhileExpression__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1149:3: ( rule__XWhileExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXWhileExpressionAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1150:3: ( rule__XWhileExpression__Group__0 )
            // InternalXbaseWithAnnotations.g:1150:4: rule__XWhileExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XWhileExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXWhileExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXWhileExpression"


    // $ANTLR start "entryRuleXDoWhileExpression"
    // InternalXbaseWithAnnotations.g:1159:1: entryRuleXDoWhileExpression : ruleXDoWhileExpression EOF ;
    public final void entryRuleXDoWhileExpression() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1160:1: ( ruleXDoWhileExpression EOF )
            // InternalXbaseWithAnnotations.g:1161:1: ruleXDoWhileExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXDoWhileExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXDoWhileExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXDoWhileExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXDoWhileExpression"


    // $ANTLR start "ruleXDoWhileExpression"
    // InternalXbaseWithAnnotations.g:1168:1: ruleXDoWhileExpression : ( ( rule__XDoWhileExpression__Group__0 ) ) ;
    public final void ruleXDoWhileExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1172:2: ( ( ( rule__XDoWhileExpression__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1173:2: ( ( rule__XDoWhileExpression__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1173:2: ( ( rule__XDoWhileExpression__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1174:3: ( rule__XDoWhileExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXDoWhileExpressionAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1175:3: ( rule__XDoWhileExpression__Group__0 )
            // InternalXbaseWithAnnotations.g:1175:4: rule__XDoWhileExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XDoWhileExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXDoWhileExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXDoWhileExpression"


    // $ANTLR start "entryRuleXBlockExpression"
    // InternalXbaseWithAnnotations.g:1184:1: entryRuleXBlockExpression : ruleXBlockExpression EOF ;
    public final void entryRuleXBlockExpression() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1185:1: ( ruleXBlockExpression EOF )
            // InternalXbaseWithAnnotations.g:1186:1: ruleXBlockExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBlockExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXBlockExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBlockExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXBlockExpression"


    // $ANTLR start "ruleXBlockExpression"
    // InternalXbaseWithAnnotations.g:1193:1: ruleXBlockExpression : ( ( rule__XBlockExpression__Group__0 ) ) ;
    public final void ruleXBlockExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1197:2: ( ( ( rule__XBlockExpression__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1198:2: ( ( rule__XBlockExpression__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1198:2: ( ( rule__XBlockExpression__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1199:3: ( rule__XBlockExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBlockExpressionAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1200:3: ( rule__XBlockExpression__Group__0 )
            // InternalXbaseWithAnnotations.g:1200:4: rule__XBlockExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XBlockExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBlockExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXBlockExpression"


    // $ANTLR start "entryRuleXExpressionOrVarDeclaration"
    // InternalXbaseWithAnnotations.g:1209:1: entryRuleXExpressionOrVarDeclaration : ruleXExpressionOrVarDeclaration EOF ;
    public final void entryRuleXExpressionOrVarDeclaration() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1210:1: ( ruleXExpressionOrVarDeclaration EOF )
            // InternalXbaseWithAnnotations.g:1211:1: ruleXExpressionOrVarDeclaration EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXExpressionOrVarDeclarationRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXExpressionOrVarDeclaration();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXExpressionOrVarDeclarationRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXExpressionOrVarDeclaration"


    // $ANTLR start "ruleXExpressionOrVarDeclaration"
    // InternalXbaseWithAnnotations.g:1218:1: ruleXExpressionOrVarDeclaration : ( ( rule__XExpressionOrVarDeclaration__Alternatives ) ) ;
    public final void ruleXExpressionOrVarDeclaration() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1222:2: ( ( ( rule__XExpressionOrVarDeclaration__Alternatives ) ) )
            // InternalXbaseWithAnnotations.g:1223:2: ( ( rule__XExpressionOrVarDeclaration__Alternatives ) )
            {
            // InternalXbaseWithAnnotations.g:1223:2: ( ( rule__XExpressionOrVarDeclaration__Alternatives ) )
            // InternalXbaseWithAnnotations.g:1224:3: ( rule__XExpressionOrVarDeclaration__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXExpressionOrVarDeclarationAccess().getAlternatives()); 
            }
            // InternalXbaseWithAnnotations.g:1225:3: ( rule__XExpressionOrVarDeclaration__Alternatives )
            // InternalXbaseWithAnnotations.g:1225:4: rule__XExpressionOrVarDeclaration__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__XExpressionOrVarDeclaration__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXExpressionOrVarDeclarationAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXExpressionOrVarDeclaration"


    // $ANTLR start "entryRuleXVariableDeclaration"
    // InternalXbaseWithAnnotations.g:1234:1: entryRuleXVariableDeclaration : ruleXVariableDeclaration EOF ;
    public final void entryRuleXVariableDeclaration() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1235:1: ( ruleXVariableDeclaration EOF )
            // InternalXbaseWithAnnotations.g:1236:1: ruleXVariableDeclaration EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXVariableDeclaration();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXVariableDeclaration"


    // $ANTLR start "ruleXVariableDeclaration"
    // InternalXbaseWithAnnotations.g:1243:1: ruleXVariableDeclaration : ( ( rule__XVariableDeclaration__Group__0 ) ) ;
    public final void ruleXVariableDeclaration() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1247:2: ( ( ( rule__XVariableDeclaration__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1248:2: ( ( rule__XVariableDeclaration__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1248:2: ( ( rule__XVariableDeclaration__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1249:3: ( rule__XVariableDeclaration__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1250:3: ( rule__XVariableDeclaration__Group__0 )
            // InternalXbaseWithAnnotations.g:1250:4: rule__XVariableDeclaration__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXVariableDeclaration"


    // $ANTLR start "entryRuleJvmFormalParameter"
    // InternalXbaseWithAnnotations.g:1259:1: entryRuleJvmFormalParameter : ruleJvmFormalParameter EOF ;
    public final void entryRuleJvmFormalParameter() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1260:1: ( ruleJvmFormalParameter EOF )
            // InternalXbaseWithAnnotations.g:1261:1: ruleJvmFormalParameter EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmFormalParameterRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleJvmFormalParameter();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmFormalParameterRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleJvmFormalParameter"


    // $ANTLR start "ruleJvmFormalParameter"
    // InternalXbaseWithAnnotations.g:1268:1: ruleJvmFormalParameter : ( ( rule__JvmFormalParameter__Group__0 ) ) ;
    public final void ruleJvmFormalParameter() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1272:2: ( ( ( rule__JvmFormalParameter__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1273:2: ( ( rule__JvmFormalParameter__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1273:2: ( ( rule__JvmFormalParameter__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1274:3: ( rule__JvmFormalParameter__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmFormalParameterAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1275:3: ( rule__JvmFormalParameter__Group__0 )
            // InternalXbaseWithAnnotations.g:1275:4: rule__JvmFormalParameter__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__JvmFormalParameter__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmFormalParameterAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleJvmFormalParameter"


    // $ANTLR start "entryRuleFullJvmFormalParameter"
    // InternalXbaseWithAnnotations.g:1284:1: entryRuleFullJvmFormalParameter : ruleFullJvmFormalParameter EOF ;
    public final void entryRuleFullJvmFormalParameter() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1285:1: ( ruleFullJvmFormalParameter EOF )
            // InternalXbaseWithAnnotations.g:1286:1: ruleFullJvmFormalParameter EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getFullJvmFormalParameterRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleFullJvmFormalParameter();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getFullJvmFormalParameterRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleFullJvmFormalParameter"


    // $ANTLR start "ruleFullJvmFormalParameter"
    // InternalXbaseWithAnnotations.g:1293:1: ruleFullJvmFormalParameter : ( ( rule__FullJvmFormalParameter__Group__0 ) ) ;
    public final void ruleFullJvmFormalParameter() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1297:2: ( ( ( rule__FullJvmFormalParameter__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1298:2: ( ( rule__FullJvmFormalParameter__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1298:2: ( ( rule__FullJvmFormalParameter__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1299:3: ( rule__FullJvmFormalParameter__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getFullJvmFormalParameterAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1300:3: ( rule__FullJvmFormalParameter__Group__0 )
            // InternalXbaseWithAnnotations.g:1300:4: rule__FullJvmFormalParameter__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__FullJvmFormalParameter__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getFullJvmFormalParameterAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleFullJvmFormalParameter"


    // $ANTLR start "entryRuleXFeatureCall"
    // InternalXbaseWithAnnotations.g:1309:1: entryRuleXFeatureCall : ruleXFeatureCall EOF ;
    public final void entryRuleXFeatureCall() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1310:1: ( ruleXFeatureCall EOF )
            // InternalXbaseWithAnnotations.g:1311:1: ruleXFeatureCall EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXFeatureCall();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXFeatureCall"


    // $ANTLR start "ruleXFeatureCall"
    // InternalXbaseWithAnnotations.g:1318:1: ruleXFeatureCall : ( ( rule__XFeatureCall__Group__0 ) ) ;
    public final void ruleXFeatureCall() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1322:2: ( ( ( rule__XFeatureCall__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1323:2: ( ( rule__XFeatureCall__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1323:2: ( ( rule__XFeatureCall__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1324:3: ( rule__XFeatureCall__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1325:3: ( rule__XFeatureCall__Group__0 )
            // InternalXbaseWithAnnotations.g:1325:4: rule__XFeatureCall__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXFeatureCall"


    // $ANTLR start "entryRuleFeatureCallID"
    // InternalXbaseWithAnnotations.g:1334:1: entryRuleFeatureCallID : ruleFeatureCallID EOF ;
    public final void entryRuleFeatureCallID() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1335:1: ( ruleFeatureCallID EOF )
            // InternalXbaseWithAnnotations.g:1336:1: ruleFeatureCallID EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getFeatureCallIDRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleFeatureCallID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getFeatureCallIDRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleFeatureCallID"


    // $ANTLR start "ruleFeatureCallID"
    // InternalXbaseWithAnnotations.g:1343:1: ruleFeatureCallID : ( ( rule__FeatureCallID__Alternatives ) ) ;
    public final void ruleFeatureCallID() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1347:2: ( ( ( rule__FeatureCallID__Alternatives ) ) )
            // InternalXbaseWithAnnotations.g:1348:2: ( ( rule__FeatureCallID__Alternatives ) )
            {
            // InternalXbaseWithAnnotations.g:1348:2: ( ( rule__FeatureCallID__Alternatives ) )
            // InternalXbaseWithAnnotations.g:1349:3: ( rule__FeatureCallID__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getFeatureCallIDAccess().getAlternatives()); 
            }
            // InternalXbaseWithAnnotations.g:1350:3: ( rule__FeatureCallID__Alternatives )
            // InternalXbaseWithAnnotations.g:1350:4: rule__FeatureCallID__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__FeatureCallID__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getFeatureCallIDAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleFeatureCallID"


    // $ANTLR start "entryRuleIdOrSuper"
    // InternalXbaseWithAnnotations.g:1359:1: entryRuleIdOrSuper : ruleIdOrSuper EOF ;
    public final void entryRuleIdOrSuper() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1360:1: ( ruleIdOrSuper EOF )
            // InternalXbaseWithAnnotations.g:1361:1: ruleIdOrSuper EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getIdOrSuperRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleIdOrSuper();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getIdOrSuperRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleIdOrSuper"


    // $ANTLR start "ruleIdOrSuper"
    // InternalXbaseWithAnnotations.g:1368:1: ruleIdOrSuper : ( ( rule__IdOrSuper__Alternatives ) ) ;
    public final void ruleIdOrSuper() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1372:2: ( ( ( rule__IdOrSuper__Alternatives ) ) )
            // InternalXbaseWithAnnotations.g:1373:2: ( ( rule__IdOrSuper__Alternatives ) )
            {
            // InternalXbaseWithAnnotations.g:1373:2: ( ( rule__IdOrSuper__Alternatives ) )
            // InternalXbaseWithAnnotations.g:1374:3: ( rule__IdOrSuper__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getIdOrSuperAccess().getAlternatives()); 
            }
            // InternalXbaseWithAnnotations.g:1375:3: ( rule__IdOrSuper__Alternatives )
            // InternalXbaseWithAnnotations.g:1375:4: rule__IdOrSuper__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__IdOrSuper__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getIdOrSuperAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleIdOrSuper"


    // $ANTLR start "entryRuleXConstructorCall"
    // InternalXbaseWithAnnotations.g:1384:1: entryRuleXConstructorCall : ruleXConstructorCall EOF ;
    public final void entryRuleXConstructorCall() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1385:1: ( ruleXConstructorCall EOF )
            // InternalXbaseWithAnnotations.g:1386:1: ruleXConstructorCall EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXConstructorCall();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXConstructorCall"


    // $ANTLR start "ruleXConstructorCall"
    // InternalXbaseWithAnnotations.g:1393:1: ruleXConstructorCall : ( ( rule__XConstructorCall__Group__0 ) ) ;
    public final void ruleXConstructorCall() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1397:2: ( ( ( rule__XConstructorCall__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1398:2: ( ( rule__XConstructorCall__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1398:2: ( ( rule__XConstructorCall__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1399:3: ( rule__XConstructorCall__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1400:3: ( rule__XConstructorCall__Group__0 )
            // InternalXbaseWithAnnotations.g:1400:4: rule__XConstructorCall__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXConstructorCall"


    // $ANTLR start "entryRuleXBooleanLiteral"
    // InternalXbaseWithAnnotations.g:1409:1: entryRuleXBooleanLiteral : ruleXBooleanLiteral EOF ;
    public final void entryRuleXBooleanLiteral() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1410:1: ( ruleXBooleanLiteral EOF )
            // InternalXbaseWithAnnotations.g:1411:1: ruleXBooleanLiteral EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBooleanLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXBooleanLiteral();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBooleanLiteralRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXBooleanLiteral"


    // $ANTLR start "ruleXBooleanLiteral"
    // InternalXbaseWithAnnotations.g:1418:1: ruleXBooleanLiteral : ( ( rule__XBooleanLiteral__Group__0 ) ) ;
    public final void ruleXBooleanLiteral() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1422:2: ( ( ( rule__XBooleanLiteral__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1423:2: ( ( rule__XBooleanLiteral__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1423:2: ( ( rule__XBooleanLiteral__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1424:3: ( rule__XBooleanLiteral__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBooleanLiteralAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1425:3: ( rule__XBooleanLiteral__Group__0 )
            // InternalXbaseWithAnnotations.g:1425:4: rule__XBooleanLiteral__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XBooleanLiteral__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBooleanLiteralAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXBooleanLiteral"


    // $ANTLR start "entryRuleXNullLiteral"
    // InternalXbaseWithAnnotations.g:1434:1: entryRuleXNullLiteral : ruleXNullLiteral EOF ;
    public final void entryRuleXNullLiteral() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1435:1: ( ruleXNullLiteral EOF )
            // InternalXbaseWithAnnotations.g:1436:1: ruleXNullLiteral EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXNullLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXNullLiteral();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXNullLiteralRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXNullLiteral"


    // $ANTLR start "ruleXNullLiteral"
    // InternalXbaseWithAnnotations.g:1443:1: ruleXNullLiteral : ( ( rule__XNullLiteral__Group__0 ) ) ;
    public final void ruleXNullLiteral() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1447:2: ( ( ( rule__XNullLiteral__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1448:2: ( ( rule__XNullLiteral__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1448:2: ( ( rule__XNullLiteral__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1449:3: ( rule__XNullLiteral__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXNullLiteralAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1450:3: ( rule__XNullLiteral__Group__0 )
            // InternalXbaseWithAnnotations.g:1450:4: rule__XNullLiteral__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XNullLiteral__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXNullLiteralAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXNullLiteral"


    // $ANTLR start "entryRuleXNumberLiteral"
    // InternalXbaseWithAnnotations.g:1459:1: entryRuleXNumberLiteral : ruleXNumberLiteral EOF ;
    public final void entryRuleXNumberLiteral() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1460:1: ( ruleXNumberLiteral EOF )
            // InternalXbaseWithAnnotations.g:1461:1: ruleXNumberLiteral EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXNumberLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXNumberLiteral();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXNumberLiteralRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXNumberLiteral"


    // $ANTLR start "ruleXNumberLiteral"
    // InternalXbaseWithAnnotations.g:1468:1: ruleXNumberLiteral : ( ( rule__XNumberLiteral__Group__0 ) ) ;
    public final void ruleXNumberLiteral() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1472:2: ( ( ( rule__XNumberLiteral__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1473:2: ( ( rule__XNumberLiteral__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1473:2: ( ( rule__XNumberLiteral__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1474:3: ( rule__XNumberLiteral__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXNumberLiteralAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1475:3: ( rule__XNumberLiteral__Group__0 )
            // InternalXbaseWithAnnotations.g:1475:4: rule__XNumberLiteral__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XNumberLiteral__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXNumberLiteralAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXNumberLiteral"


    // $ANTLR start "entryRuleXStringLiteral"
    // InternalXbaseWithAnnotations.g:1484:1: entryRuleXStringLiteral : ruleXStringLiteral EOF ;
    public final void entryRuleXStringLiteral() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1485:1: ( ruleXStringLiteral EOF )
            // InternalXbaseWithAnnotations.g:1486:1: ruleXStringLiteral EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXStringLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXStringLiteral();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXStringLiteralRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXStringLiteral"


    // $ANTLR start "ruleXStringLiteral"
    // InternalXbaseWithAnnotations.g:1493:1: ruleXStringLiteral : ( ( rule__XStringLiteral__Group__0 ) ) ;
    public final void ruleXStringLiteral() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1497:2: ( ( ( rule__XStringLiteral__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1498:2: ( ( rule__XStringLiteral__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1498:2: ( ( rule__XStringLiteral__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1499:3: ( rule__XStringLiteral__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXStringLiteralAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1500:3: ( rule__XStringLiteral__Group__0 )
            // InternalXbaseWithAnnotations.g:1500:4: rule__XStringLiteral__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XStringLiteral__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXStringLiteralAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXStringLiteral"


    // $ANTLR start "entryRuleXTypeLiteral"
    // InternalXbaseWithAnnotations.g:1509:1: entryRuleXTypeLiteral : ruleXTypeLiteral EOF ;
    public final void entryRuleXTypeLiteral() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1510:1: ( ruleXTypeLiteral EOF )
            // InternalXbaseWithAnnotations.g:1511:1: ruleXTypeLiteral EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTypeLiteralRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXTypeLiteral();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTypeLiteralRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXTypeLiteral"


    // $ANTLR start "ruleXTypeLiteral"
    // InternalXbaseWithAnnotations.g:1518:1: ruleXTypeLiteral : ( ( rule__XTypeLiteral__Group__0 ) ) ;
    public final void ruleXTypeLiteral() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1522:2: ( ( ( rule__XTypeLiteral__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1523:2: ( ( rule__XTypeLiteral__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1523:2: ( ( rule__XTypeLiteral__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1524:3: ( rule__XTypeLiteral__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTypeLiteralAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1525:3: ( rule__XTypeLiteral__Group__0 )
            // InternalXbaseWithAnnotations.g:1525:4: rule__XTypeLiteral__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XTypeLiteral__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTypeLiteralAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXTypeLiteral"


    // $ANTLR start "entryRuleXThrowExpression"
    // InternalXbaseWithAnnotations.g:1534:1: entryRuleXThrowExpression : ruleXThrowExpression EOF ;
    public final void entryRuleXThrowExpression() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1535:1: ( ruleXThrowExpression EOF )
            // InternalXbaseWithAnnotations.g:1536:1: ruleXThrowExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXThrowExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXThrowExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXThrowExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXThrowExpression"


    // $ANTLR start "ruleXThrowExpression"
    // InternalXbaseWithAnnotations.g:1543:1: ruleXThrowExpression : ( ( rule__XThrowExpression__Group__0 ) ) ;
    public final void ruleXThrowExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1547:2: ( ( ( rule__XThrowExpression__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1548:2: ( ( rule__XThrowExpression__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1548:2: ( ( rule__XThrowExpression__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1549:3: ( rule__XThrowExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXThrowExpressionAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1550:3: ( rule__XThrowExpression__Group__0 )
            // InternalXbaseWithAnnotations.g:1550:4: rule__XThrowExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XThrowExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXThrowExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXThrowExpression"


    // $ANTLR start "entryRuleXReturnExpression"
    // InternalXbaseWithAnnotations.g:1559:1: entryRuleXReturnExpression : ruleXReturnExpression EOF ;
    public final void entryRuleXReturnExpression() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1560:1: ( ruleXReturnExpression EOF )
            // InternalXbaseWithAnnotations.g:1561:1: ruleXReturnExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXReturnExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXReturnExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXReturnExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXReturnExpression"


    // $ANTLR start "ruleXReturnExpression"
    // InternalXbaseWithAnnotations.g:1568:1: ruleXReturnExpression : ( ( rule__XReturnExpression__Group__0 ) ) ;
    public final void ruleXReturnExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1572:2: ( ( ( rule__XReturnExpression__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1573:2: ( ( rule__XReturnExpression__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1573:2: ( ( rule__XReturnExpression__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1574:3: ( rule__XReturnExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXReturnExpressionAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1575:3: ( rule__XReturnExpression__Group__0 )
            // InternalXbaseWithAnnotations.g:1575:4: rule__XReturnExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XReturnExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXReturnExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXReturnExpression"


    // $ANTLR start "entryRuleXTryCatchFinallyExpression"
    // InternalXbaseWithAnnotations.g:1584:1: entryRuleXTryCatchFinallyExpression : ruleXTryCatchFinallyExpression EOF ;
    public final void entryRuleXTryCatchFinallyExpression() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1585:1: ( ruleXTryCatchFinallyExpression EOF )
            // InternalXbaseWithAnnotations.g:1586:1: ruleXTryCatchFinallyExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXTryCatchFinallyExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXTryCatchFinallyExpression"


    // $ANTLR start "ruleXTryCatchFinallyExpression"
    // InternalXbaseWithAnnotations.g:1593:1: ruleXTryCatchFinallyExpression : ( ( rule__XTryCatchFinallyExpression__Group__0 ) ) ;
    public final void ruleXTryCatchFinallyExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1597:2: ( ( ( rule__XTryCatchFinallyExpression__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1598:2: ( ( rule__XTryCatchFinallyExpression__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1598:2: ( ( rule__XTryCatchFinallyExpression__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1599:3: ( rule__XTryCatchFinallyExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1600:3: ( rule__XTryCatchFinallyExpression__Group__0 )
            // InternalXbaseWithAnnotations.g:1600:4: rule__XTryCatchFinallyExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXTryCatchFinallyExpression"


    // $ANTLR start "entryRuleXSynchronizedExpression"
    // InternalXbaseWithAnnotations.g:1609:1: entryRuleXSynchronizedExpression : ruleXSynchronizedExpression EOF ;
    public final void entryRuleXSynchronizedExpression() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1610:1: ( ruleXSynchronizedExpression EOF )
            // InternalXbaseWithAnnotations.g:1611:1: ruleXSynchronizedExpression EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSynchronizedExpressionRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXSynchronizedExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSynchronizedExpressionRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXSynchronizedExpression"


    // $ANTLR start "ruleXSynchronizedExpression"
    // InternalXbaseWithAnnotations.g:1618:1: ruleXSynchronizedExpression : ( ( rule__XSynchronizedExpression__Group__0 ) ) ;
    public final void ruleXSynchronizedExpression() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1622:2: ( ( ( rule__XSynchronizedExpression__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1623:2: ( ( rule__XSynchronizedExpression__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1623:2: ( ( rule__XSynchronizedExpression__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1624:3: ( rule__XSynchronizedExpression__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSynchronizedExpressionAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1625:3: ( rule__XSynchronizedExpression__Group__0 )
            // InternalXbaseWithAnnotations.g:1625:4: rule__XSynchronizedExpression__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSynchronizedExpressionAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXSynchronizedExpression"


    // $ANTLR start "entryRuleXCatchClause"
    // InternalXbaseWithAnnotations.g:1634:1: entryRuleXCatchClause : ruleXCatchClause EOF ;
    public final void entryRuleXCatchClause() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1635:1: ( ruleXCatchClause EOF )
            // InternalXbaseWithAnnotations.g:1636:1: ruleXCatchClause EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCatchClauseRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXCatchClause();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCatchClauseRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXCatchClause"


    // $ANTLR start "ruleXCatchClause"
    // InternalXbaseWithAnnotations.g:1643:1: ruleXCatchClause : ( ( rule__XCatchClause__Group__0 ) ) ;
    public final void ruleXCatchClause() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1647:2: ( ( ( rule__XCatchClause__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1648:2: ( ( rule__XCatchClause__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1648:2: ( ( rule__XCatchClause__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1649:3: ( rule__XCatchClause__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCatchClauseAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1650:3: ( rule__XCatchClause__Group__0 )
            // InternalXbaseWithAnnotations.g:1650:4: rule__XCatchClause__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XCatchClause__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCatchClauseAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXCatchClause"


    // $ANTLR start "entryRuleQualifiedName"
    // InternalXbaseWithAnnotations.g:1659:1: entryRuleQualifiedName : ruleQualifiedName EOF ;
    public final void entryRuleQualifiedName() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1660:1: ( ruleQualifiedName EOF )
            // InternalXbaseWithAnnotations.g:1661:1: ruleQualifiedName EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleQualifiedName();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleQualifiedName"


    // $ANTLR start "ruleQualifiedName"
    // InternalXbaseWithAnnotations.g:1668:1: ruleQualifiedName : ( ( rule__QualifiedName__Group__0 ) ) ;
    public final void ruleQualifiedName() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1672:2: ( ( ( rule__QualifiedName__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1673:2: ( ( rule__QualifiedName__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1673:2: ( ( rule__QualifiedName__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1674:3: ( rule__QualifiedName__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1675:3: ( rule__QualifiedName__Group__0 )
            // InternalXbaseWithAnnotations.g:1675:4: rule__QualifiedName__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleQualifiedName"


    // $ANTLR start "entryRuleNumber"
    // InternalXbaseWithAnnotations.g:1684:1: entryRuleNumber : ruleNumber EOF ;
    public final void entryRuleNumber() throws RecognitionException {
         
        	HiddenTokens myHiddenTokenState = ((XtextTokenStream)input).setHiddenTokens();

        try {
            // InternalXbaseWithAnnotations.g:1688:1: ( ruleNumber EOF )
            // InternalXbaseWithAnnotations.g:1689:1: ruleNumber EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getNumberRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleNumber();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getNumberRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	myHiddenTokenState.restore();

        }
        return ;
    }
    // $ANTLR end "entryRuleNumber"


    // $ANTLR start "ruleNumber"
    // InternalXbaseWithAnnotations.g:1699:1: ruleNumber : ( ( rule__Number__Alternatives ) ) ;
    public final void ruleNumber() throws RecognitionException {

        		HiddenTokens myHiddenTokenState = ((XtextTokenStream)input).setHiddenTokens();
        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1704:2: ( ( ( rule__Number__Alternatives ) ) )
            // InternalXbaseWithAnnotations.g:1705:2: ( ( rule__Number__Alternatives ) )
            {
            // InternalXbaseWithAnnotations.g:1705:2: ( ( rule__Number__Alternatives ) )
            // InternalXbaseWithAnnotations.g:1706:3: ( rule__Number__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getNumberAccess().getAlternatives()); 
            }
            // InternalXbaseWithAnnotations.g:1707:3: ( rule__Number__Alternatives )
            // InternalXbaseWithAnnotations.g:1707:4: rule__Number__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__Number__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getNumberAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);
            	myHiddenTokenState.restore();

        }
        return ;
    }
    // $ANTLR end "ruleNumber"


    // $ANTLR start "entryRuleJvmTypeReference"
    // InternalXbaseWithAnnotations.g:1717:1: entryRuleJvmTypeReference : ruleJvmTypeReference EOF ;
    public final void entryRuleJvmTypeReference() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1718:1: ( ruleJvmTypeReference EOF )
            // InternalXbaseWithAnnotations.g:1719:1: ruleJvmTypeReference EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmTypeReferenceRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmTypeReferenceRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleJvmTypeReference"


    // $ANTLR start "ruleJvmTypeReference"
    // InternalXbaseWithAnnotations.g:1726:1: ruleJvmTypeReference : ( ( rule__JvmTypeReference__Alternatives ) ) ;
    public final void ruleJvmTypeReference() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1730:2: ( ( ( rule__JvmTypeReference__Alternatives ) ) )
            // InternalXbaseWithAnnotations.g:1731:2: ( ( rule__JvmTypeReference__Alternatives ) )
            {
            // InternalXbaseWithAnnotations.g:1731:2: ( ( rule__JvmTypeReference__Alternatives ) )
            // InternalXbaseWithAnnotations.g:1732:3: ( rule__JvmTypeReference__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmTypeReferenceAccess().getAlternatives()); 
            }
            // InternalXbaseWithAnnotations.g:1733:3: ( rule__JvmTypeReference__Alternatives )
            // InternalXbaseWithAnnotations.g:1733:4: rule__JvmTypeReference__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__JvmTypeReference__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmTypeReferenceAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleJvmTypeReference"


    // $ANTLR start "entryRuleArrayBrackets"
    // InternalXbaseWithAnnotations.g:1742:1: entryRuleArrayBrackets : ruleArrayBrackets EOF ;
    public final void entryRuleArrayBrackets() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1743:1: ( ruleArrayBrackets EOF )
            // InternalXbaseWithAnnotations.g:1744:1: ruleArrayBrackets EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getArrayBracketsRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleArrayBrackets();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getArrayBracketsRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleArrayBrackets"


    // $ANTLR start "ruleArrayBrackets"
    // InternalXbaseWithAnnotations.g:1751:1: ruleArrayBrackets : ( ( rule__ArrayBrackets__Group__0 ) ) ;
    public final void ruleArrayBrackets() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1755:2: ( ( ( rule__ArrayBrackets__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1756:2: ( ( rule__ArrayBrackets__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1756:2: ( ( rule__ArrayBrackets__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1757:3: ( rule__ArrayBrackets__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getArrayBracketsAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1758:3: ( rule__ArrayBrackets__Group__0 )
            // InternalXbaseWithAnnotations.g:1758:4: rule__ArrayBrackets__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__ArrayBrackets__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getArrayBracketsAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleArrayBrackets"


    // $ANTLR start "entryRuleXFunctionTypeRef"
    // InternalXbaseWithAnnotations.g:1767:1: entryRuleXFunctionTypeRef : ruleXFunctionTypeRef EOF ;
    public final void entryRuleXFunctionTypeRef() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1768:1: ( ruleXFunctionTypeRef EOF )
            // InternalXbaseWithAnnotations.g:1769:1: ruleXFunctionTypeRef EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXFunctionTypeRef();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXFunctionTypeRef"


    // $ANTLR start "ruleXFunctionTypeRef"
    // InternalXbaseWithAnnotations.g:1776:1: ruleXFunctionTypeRef : ( ( rule__XFunctionTypeRef__Group__0 ) ) ;
    public final void ruleXFunctionTypeRef() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1780:2: ( ( ( rule__XFunctionTypeRef__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1781:2: ( ( rule__XFunctionTypeRef__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1781:2: ( ( rule__XFunctionTypeRef__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1782:3: ( rule__XFunctionTypeRef__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1783:3: ( rule__XFunctionTypeRef__Group__0 )
            // InternalXbaseWithAnnotations.g:1783:4: rule__XFunctionTypeRef__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXFunctionTypeRef"


    // $ANTLR start "entryRuleJvmParameterizedTypeReference"
    // InternalXbaseWithAnnotations.g:1792:1: entryRuleJvmParameterizedTypeReference : ruleJvmParameterizedTypeReference EOF ;
    public final void entryRuleJvmParameterizedTypeReference() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1793:1: ( ruleJvmParameterizedTypeReference EOF )
            // InternalXbaseWithAnnotations.g:1794:1: ruleJvmParameterizedTypeReference EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleJvmParameterizedTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleJvmParameterizedTypeReference"


    // $ANTLR start "ruleJvmParameterizedTypeReference"
    // InternalXbaseWithAnnotations.g:1801:1: ruleJvmParameterizedTypeReference : ( ( rule__JvmParameterizedTypeReference__Group__0 ) ) ;
    public final void ruleJvmParameterizedTypeReference() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1805:2: ( ( ( rule__JvmParameterizedTypeReference__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1806:2: ( ( rule__JvmParameterizedTypeReference__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1806:2: ( ( rule__JvmParameterizedTypeReference__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1807:3: ( rule__JvmParameterizedTypeReference__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1808:3: ( rule__JvmParameterizedTypeReference__Group__0 )
            // InternalXbaseWithAnnotations.g:1808:4: rule__JvmParameterizedTypeReference__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleJvmParameterizedTypeReference"


    // $ANTLR start "entryRuleJvmArgumentTypeReference"
    // InternalXbaseWithAnnotations.g:1817:1: entryRuleJvmArgumentTypeReference : ruleJvmArgumentTypeReference EOF ;
    public final void entryRuleJvmArgumentTypeReference() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1818:1: ( ruleJvmArgumentTypeReference EOF )
            // InternalXbaseWithAnnotations.g:1819:1: ruleJvmArgumentTypeReference EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmArgumentTypeReferenceRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleJvmArgumentTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmArgumentTypeReferenceRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleJvmArgumentTypeReference"


    // $ANTLR start "ruleJvmArgumentTypeReference"
    // InternalXbaseWithAnnotations.g:1826:1: ruleJvmArgumentTypeReference : ( ( rule__JvmArgumentTypeReference__Alternatives ) ) ;
    public final void ruleJvmArgumentTypeReference() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1830:2: ( ( ( rule__JvmArgumentTypeReference__Alternatives ) ) )
            // InternalXbaseWithAnnotations.g:1831:2: ( ( rule__JvmArgumentTypeReference__Alternatives ) )
            {
            // InternalXbaseWithAnnotations.g:1831:2: ( ( rule__JvmArgumentTypeReference__Alternatives ) )
            // InternalXbaseWithAnnotations.g:1832:3: ( rule__JvmArgumentTypeReference__Alternatives )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmArgumentTypeReferenceAccess().getAlternatives()); 
            }
            // InternalXbaseWithAnnotations.g:1833:3: ( rule__JvmArgumentTypeReference__Alternatives )
            // InternalXbaseWithAnnotations.g:1833:4: rule__JvmArgumentTypeReference__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__JvmArgumentTypeReference__Alternatives();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmArgumentTypeReferenceAccess().getAlternatives()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleJvmArgumentTypeReference"


    // $ANTLR start "entryRuleJvmWildcardTypeReference"
    // InternalXbaseWithAnnotations.g:1842:1: entryRuleJvmWildcardTypeReference : ruleJvmWildcardTypeReference EOF ;
    public final void entryRuleJvmWildcardTypeReference() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1843:1: ( ruleJvmWildcardTypeReference EOF )
            // InternalXbaseWithAnnotations.g:1844:1: ruleJvmWildcardTypeReference EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleJvmWildcardTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleJvmWildcardTypeReference"


    // $ANTLR start "ruleJvmWildcardTypeReference"
    // InternalXbaseWithAnnotations.g:1851:1: ruleJvmWildcardTypeReference : ( ( rule__JvmWildcardTypeReference__Group__0 ) ) ;
    public final void ruleJvmWildcardTypeReference() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1855:2: ( ( ( rule__JvmWildcardTypeReference__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1856:2: ( ( rule__JvmWildcardTypeReference__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1856:2: ( ( rule__JvmWildcardTypeReference__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1857:3: ( rule__JvmWildcardTypeReference__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1858:3: ( rule__JvmWildcardTypeReference__Group__0 )
            // InternalXbaseWithAnnotations.g:1858:4: rule__JvmWildcardTypeReference__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__JvmWildcardTypeReference__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleJvmWildcardTypeReference"


    // $ANTLR start "entryRuleJvmUpperBound"
    // InternalXbaseWithAnnotations.g:1867:1: entryRuleJvmUpperBound : ruleJvmUpperBound EOF ;
    public final void entryRuleJvmUpperBound() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1868:1: ( ruleJvmUpperBound EOF )
            // InternalXbaseWithAnnotations.g:1869:1: ruleJvmUpperBound EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmUpperBoundRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleJvmUpperBound();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmUpperBoundRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleJvmUpperBound"


    // $ANTLR start "ruleJvmUpperBound"
    // InternalXbaseWithAnnotations.g:1876:1: ruleJvmUpperBound : ( ( rule__JvmUpperBound__Group__0 ) ) ;
    public final void ruleJvmUpperBound() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1880:2: ( ( ( rule__JvmUpperBound__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1881:2: ( ( rule__JvmUpperBound__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1881:2: ( ( rule__JvmUpperBound__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1882:3: ( rule__JvmUpperBound__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmUpperBoundAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1883:3: ( rule__JvmUpperBound__Group__0 )
            // InternalXbaseWithAnnotations.g:1883:4: rule__JvmUpperBound__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__JvmUpperBound__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmUpperBoundAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleJvmUpperBound"


    // $ANTLR start "entryRuleJvmUpperBoundAnded"
    // InternalXbaseWithAnnotations.g:1892:1: entryRuleJvmUpperBoundAnded : ruleJvmUpperBoundAnded EOF ;
    public final void entryRuleJvmUpperBoundAnded() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1893:1: ( ruleJvmUpperBoundAnded EOF )
            // InternalXbaseWithAnnotations.g:1894:1: ruleJvmUpperBoundAnded EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmUpperBoundAndedRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleJvmUpperBoundAnded();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmUpperBoundAndedRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleJvmUpperBoundAnded"


    // $ANTLR start "ruleJvmUpperBoundAnded"
    // InternalXbaseWithAnnotations.g:1901:1: ruleJvmUpperBoundAnded : ( ( rule__JvmUpperBoundAnded__Group__0 ) ) ;
    public final void ruleJvmUpperBoundAnded() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1905:2: ( ( ( rule__JvmUpperBoundAnded__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1906:2: ( ( rule__JvmUpperBoundAnded__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1906:2: ( ( rule__JvmUpperBoundAnded__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1907:3: ( rule__JvmUpperBoundAnded__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmUpperBoundAndedAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1908:3: ( rule__JvmUpperBoundAnded__Group__0 )
            // InternalXbaseWithAnnotations.g:1908:4: rule__JvmUpperBoundAnded__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__JvmUpperBoundAnded__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmUpperBoundAndedAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleJvmUpperBoundAnded"


    // $ANTLR start "entryRuleJvmLowerBound"
    // InternalXbaseWithAnnotations.g:1917:1: entryRuleJvmLowerBound : ruleJvmLowerBound EOF ;
    public final void entryRuleJvmLowerBound() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1918:1: ( ruleJvmLowerBound EOF )
            // InternalXbaseWithAnnotations.g:1919:1: ruleJvmLowerBound EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmLowerBoundRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleJvmLowerBound();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmLowerBoundRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleJvmLowerBound"


    // $ANTLR start "ruleJvmLowerBound"
    // InternalXbaseWithAnnotations.g:1926:1: ruleJvmLowerBound : ( ( rule__JvmLowerBound__Group__0 ) ) ;
    public final void ruleJvmLowerBound() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1930:2: ( ( ( rule__JvmLowerBound__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1931:2: ( ( rule__JvmLowerBound__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1931:2: ( ( rule__JvmLowerBound__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1932:3: ( rule__JvmLowerBound__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmLowerBoundAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1933:3: ( rule__JvmLowerBound__Group__0 )
            // InternalXbaseWithAnnotations.g:1933:4: rule__JvmLowerBound__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__JvmLowerBound__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmLowerBoundAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleJvmLowerBound"


    // $ANTLR start "entryRuleJvmLowerBoundAnded"
    // InternalXbaseWithAnnotations.g:1942:1: entryRuleJvmLowerBoundAnded : ruleJvmLowerBoundAnded EOF ;
    public final void entryRuleJvmLowerBoundAnded() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1943:1: ( ruleJvmLowerBoundAnded EOF )
            // InternalXbaseWithAnnotations.g:1944:1: ruleJvmLowerBoundAnded EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmLowerBoundAndedRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleJvmLowerBoundAnded();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmLowerBoundAndedRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleJvmLowerBoundAnded"


    // $ANTLR start "ruleJvmLowerBoundAnded"
    // InternalXbaseWithAnnotations.g:1951:1: ruleJvmLowerBoundAnded : ( ( rule__JvmLowerBoundAnded__Group__0 ) ) ;
    public final void ruleJvmLowerBoundAnded() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1955:2: ( ( ( rule__JvmLowerBoundAnded__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1956:2: ( ( rule__JvmLowerBoundAnded__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1956:2: ( ( rule__JvmLowerBoundAnded__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1957:3: ( rule__JvmLowerBoundAnded__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmLowerBoundAndedAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1958:3: ( rule__JvmLowerBoundAnded__Group__0 )
            // InternalXbaseWithAnnotations.g:1958:4: rule__JvmLowerBoundAnded__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__JvmLowerBoundAnded__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmLowerBoundAndedAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleJvmLowerBoundAnded"


    // $ANTLR start "entryRuleQualifiedNameWithWildcard"
    // InternalXbaseWithAnnotations.g:1967:1: entryRuleQualifiedNameWithWildcard : ruleQualifiedNameWithWildcard EOF ;
    public final void entryRuleQualifiedNameWithWildcard() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1968:1: ( ruleQualifiedNameWithWildcard EOF )
            // InternalXbaseWithAnnotations.g:1969:1: ruleQualifiedNameWithWildcard EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameWithWildcardRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleQualifiedNameWithWildcard();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameWithWildcardRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleQualifiedNameWithWildcard"


    // $ANTLR start "ruleQualifiedNameWithWildcard"
    // InternalXbaseWithAnnotations.g:1976:1: ruleQualifiedNameWithWildcard : ( ( rule__QualifiedNameWithWildcard__Group__0 ) ) ;
    public final void ruleQualifiedNameWithWildcard() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:1980:2: ( ( ( rule__QualifiedNameWithWildcard__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:1981:2: ( ( rule__QualifiedNameWithWildcard__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:1981:2: ( ( rule__QualifiedNameWithWildcard__Group__0 ) )
            // InternalXbaseWithAnnotations.g:1982:3: ( rule__QualifiedNameWithWildcard__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameWithWildcardAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:1983:3: ( rule__QualifiedNameWithWildcard__Group__0 )
            // InternalXbaseWithAnnotations.g:1983:4: rule__QualifiedNameWithWildcard__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedNameWithWildcard__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameWithWildcardAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleQualifiedNameWithWildcard"


    // $ANTLR start "entryRuleValidID"
    // InternalXbaseWithAnnotations.g:1992:1: entryRuleValidID : ruleValidID EOF ;
    public final void entryRuleValidID() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:1993:1: ( ruleValidID EOF )
            // InternalXbaseWithAnnotations.g:1994:1: ruleValidID EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getValidIDRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleValidID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getValidIDRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleValidID"


    // $ANTLR start "ruleValidID"
    // InternalXbaseWithAnnotations.g:2001:1: ruleValidID : ( RULE_ID ) ;
    public final void ruleValidID() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2005:2: ( ( RULE_ID ) )
            // InternalXbaseWithAnnotations.g:2006:2: ( RULE_ID )
            {
            // InternalXbaseWithAnnotations.g:2006:2: ( RULE_ID )
            // InternalXbaseWithAnnotations.g:2007:3: RULE_ID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getValidIDAccess().getIDTerminalRuleCall()); 
            }
            match(input,RULE_ID,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getValidIDAccess().getIDTerminalRuleCall()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleValidID"


    // $ANTLR start "entryRuleXImportDeclaration"
    // InternalXbaseWithAnnotations.g:2017:1: entryRuleXImportDeclaration : ruleXImportDeclaration EOF ;
    public final void entryRuleXImportDeclaration() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:2018:1: ( ruleXImportDeclaration EOF )
            // InternalXbaseWithAnnotations.g:2019:1: ruleXImportDeclaration EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleXImportDeclaration();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleXImportDeclaration"


    // $ANTLR start "ruleXImportDeclaration"
    // InternalXbaseWithAnnotations.g:2026:1: ruleXImportDeclaration : ( ( rule__XImportDeclaration__Group__0 ) ) ;
    public final void ruleXImportDeclaration() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2030:2: ( ( ( rule__XImportDeclaration__Group__0 ) ) )
            // InternalXbaseWithAnnotations.g:2031:2: ( ( rule__XImportDeclaration__Group__0 ) )
            {
            // InternalXbaseWithAnnotations.g:2031:2: ( ( rule__XImportDeclaration__Group__0 ) )
            // InternalXbaseWithAnnotations.g:2032:3: ( rule__XImportDeclaration__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:2033:3: ( rule__XImportDeclaration__Group__0 )
            // InternalXbaseWithAnnotations.g:2033:4: rule__XImportDeclaration__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__XImportDeclaration__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getGroup()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleXImportDeclaration"


    // $ANTLR start "entryRuleQualifiedNameInStaticImport"
    // InternalXbaseWithAnnotations.g:2042:1: entryRuleQualifiedNameInStaticImport : ruleQualifiedNameInStaticImport EOF ;
    public final void entryRuleQualifiedNameInStaticImport() throws RecognitionException {
        try {
            // InternalXbaseWithAnnotations.g:2043:1: ( ruleQualifiedNameInStaticImport EOF )
            // InternalXbaseWithAnnotations.g:2044:1: ruleQualifiedNameInStaticImport EOF
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameInStaticImportRule()); 
            }
            pushFollow(FOLLOW_1);
            ruleQualifiedNameInStaticImport();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameInStaticImportRule()); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleQualifiedNameInStaticImport"


    // $ANTLR start "ruleQualifiedNameInStaticImport"
    // InternalXbaseWithAnnotations.g:2051:1: ruleQualifiedNameInStaticImport : ( ( ( rule__QualifiedNameInStaticImport__Group__0 ) ) ( ( rule__QualifiedNameInStaticImport__Group__0 )* ) ) ;
    public final void ruleQualifiedNameInStaticImport() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2055:2: ( ( ( ( rule__QualifiedNameInStaticImport__Group__0 ) ) ( ( rule__QualifiedNameInStaticImport__Group__0 )* ) ) )
            // InternalXbaseWithAnnotations.g:2056:2: ( ( ( rule__QualifiedNameInStaticImport__Group__0 ) ) ( ( rule__QualifiedNameInStaticImport__Group__0 )* ) )
            {
            // InternalXbaseWithAnnotations.g:2056:2: ( ( ( rule__QualifiedNameInStaticImport__Group__0 ) ) ( ( rule__QualifiedNameInStaticImport__Group__0 )* ) )
            // InternalXbaseWithAnnotations.g:2057:3: ( ( rule__QualifiedNameInStaticImport__Group__0 ) ) ( ( rule__QualifiedNameInStaticImport__Group__0 )* )
            {
            // InternalXbaseWithAnnotations.g:2057:3: ( ( rule__QualifiedNameInStaticImport__Group__0 ) )
            // InternalXbaseWithAnnotations.g:2058:4: ( rule__QualifiedNameInStaticImport__Group__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameInStaticImportAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:2059:4: ( rule__QualifiedNameInStaticImport__Group__0 )
            // InternalXbaseWithAnnotations.g:2059:5: rule__QualifiedNameInStaticImport__Group__0
            {
            pushFollow(FOLLOW_3);
            rule__QualifiedNameInStaticImport__Group__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameInStaticImportAccess().getGroup()); 
            }

            }

            // InternalXbaseWithAnnotations.g:2062:3: ( ( rule__QualifiedNameInStaticImport__Group__0 )* )
            // InternalXbaseWithAnnotations.g:2063:4: ( rule__QualifiedNameInStaticImport__Group__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameInStaticImportAccess().getGroup()); 
            }
            // InternalXbaseWithAnnotations.g:2064:4: ( rule__QualifiedNameInStaticImport__Group__0 )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==RULE_ID) ) {
                    int LA1_2 = input.LA(2);

                    if ( (LA1_2==43) ) {
                        alt1=1;
                    }


                }


                switch (alt1) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:2064:5: rule__QualifiedNameInStaticImport__Group__0
            	    {
            	    pushFollow(FOLLOW_3);
            	    rule__QualifiedNameInStaticImport__Group__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameInStaticImportAccess().getGroup()); 
            }

            }


            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleQualifiedNameInStaticImport"


    // $ANTLR start "rule__XAnnotation__Alternatives_3_1"
    // InternalXbaseWithAnnotations.g:2073:1: rule__XAnnotation__Alternatives_3_1 : ( ( ( rule__XAnnotation__Group_3_1_0__0 ) ) | ( ( rule__XAnnotation__ValueAssignment_3_1_1 ) ) );
    public final void rule__XAnnotation__Alternatives_3_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2077:1: ( ( ( rule__XAnnotation__Group_3_1_0__0 ) ) | ( ( rule__XAnnotation__ValueAssignment_3_1_1 ) ) )
            int alt2=2;
            alt2 = dfa2.predict(input);
            switch (alt2) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2078:2: ( ( rule__XAnnotation__Group_3_1_0__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2078:2: ( ( rule__XAnnotation__Group_3_1_0__0 ) )
                    // InternalXbaseWithAnnotations.g:2079:3: ( rule__XAnnotation__Group_3_1_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXAnnotationAccess().getGroup_3_1_0()); 
                    }
                    // InternalXbaseWithAnnotations.g:2080:3: ( rule__XAnnotation__Group_3_1_0__0 )
                    // InternalXbaseWithAnnotations.g:2080:4: rule__XAnnotation__Group_3_1_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XAnnotation__Group_3_1_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXAnnotationAccess().getGroup_3_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2084:2: ( ( rule__XAnnotation__ValueAssignment_3_1_1 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2084:2: ( ( rule__XAnnotation__ValueAssignment_3_1_1 ) )
                    // InternalXbaseWithAnnotations.g:2085:3: ( rule__XAnnotation__ValueAssignment_3_1_1 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXAnnotationAccess().getValueAssignment_3_1_1()); 
                    }
                    // InternalXbaseWithAnnotations.g:2086:3: ( rule__XAnnotation__ValueAssignment_3_1_1 )
                    // InternalXbaseWithAnnotations.g:2086:4: rule__XAnnotation__ValueAssignment_3_1_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XAnnotation__ValueAssignment_3_1_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXAnnotationAccess().getValueAssignment_3_1_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__Alternatives_3_1"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Alternatives"
    // InternalXbaseWithAnnotations.g:2094:1: rule__XAnnotationElementValueOrCommaList__Alternatives : ( ( ( rule__XAnnotationElementValueOrCommaList__Group_0__0 ) ) | ( ( rule__XAnnotationElementValueOrCommaList__Group_1__0 ) ) );
    public final void rule__XAnnotationElementValueOrCommaList__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2098:1: ( ( ( rule__XAnnotationElementValueOrCommaList__Group_0__0 ) ) | ( ( rule__XAnnotationElementValueOrCommaList__Group_1__0 ) ) )
            int alt3=2;
            alt3 = dfa3.predict(input);
            switch (alt3) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2099:2: ( ( rule__XAnnotationElementValueOrCommaList__Group_0__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2099:2: ( ( rule__XAnnotationElementValueOrCommaList__Group_0__0 ) )
                    // InternalXbaseWithAnnotations.g:2100:3: ( rule__XAnnotationElementValueOrCommaList__Group_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getGroup_0()); 
                    }
                    // InternalXbaseWithAnnotations.g:2101:3: ( rule__XAnnotationElementValueOrCommaList__Group_0__0 )
                    // InternalXbaseWithAnnotations.g:2101:4: rule__XAnnotationElementValueOrCommaList__Group_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XAnnotationElementValueOrCommaList__Group_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getGroup_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2105:2: ( ( rule__XAnnotationElementValueOrCommaList__Group_1__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2105:2: ( ( rule__XAnnotationElementValueOrCommaList__Group_1__0 ) )
                    // InternalXbaseWithAnnotations.g:2106:3: ( rule__XAnnotationElementValueOrCommaList__Group_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getGroup_1()); 
                    }
                    // InternalXbaseWithAnnotations.g:2107:3: ( rule__XAnnotationElementValueOrCommaList__Group_1__0 )
                    // InternalXbaseWithAnnotations.g:2107:4: rule__XAnnotationElementValueOrCommaList__Group_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XAnnotationElementValueOrCommaList__Group_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getGroup_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Alternatives"


    // $ANTLR start "rule__XAnnotationElementValue__Alternatives"
    // InternalXbaseWithAnnotations.g:2115:1: rule__XAnnotationElementValue__Alternatives : ( ( ( rule__XAnnotationElementValue__Group_0__0 ) ) | ( ruleXAnnotationOrExpression ) );
    public final void rule__XAnnotationElementValue__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2119:1: ( ( ( rule__XAnnotationElementValue__Group_0__0 ) ) | ( ruleXAnnotationOrExpression ) )
            int alt4=2;
            alt4 = dfa4.predict(input);
            switch (alt4) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2120:2: ( ( rule__XAnnotationElementValue__Group_0__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2120:2: ( ( rule__XAnnotationElementValue__Group_0__0 ) )
                    // InternalXbaseWithAnnotations.g:2121:3: ( rule__XAnnotationElementValue__Group_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXAnnotationElementValueAccess().getGroup_0()); 
                    }
                    // InternalXbaseWithAnnotations.g:2122:3: ( rule__XAnnotationElementValue__Group_0__0 )
                    // InternalXbaseWithAnnotations.g:2122:4: rule__XAnnotationElementValue__Group_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XAnnotationElementValue__Group_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXAnnotationElementValueAccess().getGroup_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2126:2: ( ruleXAnnotationOrExpression )
                    {
                    // InternalXbaseWithAnnotations.g:2126:2: ( ruleXAnnotationOrExpression )
                    // InternalXbaseWithAnnotations.g:2127:3: ruleXAnnotationOrExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXAnnotationElementValueAccess().getXAnnotationOrExpressionParserRuleCall_1()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXAnnotationOrExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXAnnotationElementValueAccess().getXAnnotationOrExpressionParserRuleCall_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__Alternatives"


    // $ANTLR start "rule__XAnnotationOrExpression__Alternatives"
    // InternalXbaseWithAnnotations.g:2136:1: rule__XAnnotationOrExpression__Alternatives : ( ( ruleXAnnotation ) | ( ruleXExpression ) );
    public final void rule__XAnnotationOrExpression__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2140:1: ( ( ruleXAnnotation ) | ( ruleXExpression ) )
            int alt5=2;
            int LA5_0 = input.LA(1);

            if ( (LA5_0==51) ) {
                alt5=1;
            }
            else if ( ((LA5_0>=RULE_ID && LA5_0<=RULE_STRING)||LA5_0==27||(LA5_0>=34 && LA5_0<=35)||LA5_0==40||(LA5_0>=45 && LA5_0<=50)||LA5_0==52||(LA5_0>=56 && LA5_0<=57)||LA5_0==60||LA5_0==63||LA5_0==65||(LA5_0>=69 && LA5_0<=77)||LA5_0==79||LA5_0==87) ) {
                alt5=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 5, 0, input);

                throw nvae;
            }
            switch (alt5) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2141:2: ( ruleXAnnotation )
                    {
                    // InternalXbaseWithAnnotations.g:2141:2: ( ruleXAnnotation )
                    // InternalXbaseWithAnnotations.g:2142:3: ruleXAnnotation
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXAnnotationOrExpressionAccess().getXAnnotationParserRuleCall_0()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXAnnotation();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXAnnotationOrExpressionAccess().getXAnnotationParserRuleCall_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2147:2: ( ruleXExpression )
                    {
                    // InternalXbaseWithAnnotations.g:2147:2: ( ruleXExpression )
                    // InternalXbaseWithAnnotations.g:2148:3: ruleXExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXAnnotationOrExpressionAccess().getXExpressionParserRuleCall_1()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXAnnotationOrExpressionAccess().getXExpressionParserRuleCall_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationOrExpression__Alternatives"


    // $ANTLR start "rule__XAssignment__Alternatives"
    // InternalXbaseWithAnnotations.g:2157:1: rule__XAssignment__Alternatives : ( ( ( rule__XAssignment__Group_0__0 ) ) | ( ( rule__XAssignment__Group_1__0 ) ) );
    public final void rule__XAssignment__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2161:1: ( ( ( rule__XAssignment__Group_0__0 ) ) | ( ( rule__XAssignment__Group_1__0 ) ) )
            int alt6=2;
            switch ( input.LA(1) ) {
            case RULE_ID:
                {
                int LA6_1 = input.LA(2);

                if ( (LA6_1==13) ) {
                    alt6=1;
                }
                else if ( (LA6_1==EOF||(LA6_1>=RULE_ID && LA6_1<=RULE_STRING)||(LA6_1>=14 && LA6_1<=50)||(LA6_1>=52 && LA6_1<=80)||(LA6_1>=83 && LA6_1<=84)||(LA6_1>=86 && LA6_1<=87)) ) {
                    alt6=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return ;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 6, 1, input);

                    throw nvae;
                }
                }
                break;
            case 45:
                {
                int LA6_2 = input.LA(2);

                if ( (LA6_2==13) ) {
                    alt6=1;
                }
                else if ( (LA6_2==EOF||(LA6_2>=RULE_ID && LA6_2<=RULE_STRING)||(LA6_2>=14 && LA6_2<=50)||(LA6_2>=52 && LA6_2<=80)||(LA6_2>=83 && LA6_2<=84)||(LA6_2>=86 && LA6_2<=87)) ) {
                    alt6=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return ;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 6, 2, input);

                    throw nvae;
                }
                }
                break;
            case 46:
                {
                int LA6_3 = input.LA(2);

                if ( (LA6_3==13) ) {
                    alt6=1;
                }
                else if ( (LA6_3==EOF||(LA6_3>=RULE_ID && LA6_3<=RULE_STRING)||(LA6_3>=14 && LA6_3<=50)||(LA6_3>=52 && LA6_3<=80)||(LA6_3>=83 && LA6_3<=84)||(LA6_3>=86 && LA6_3<=87)) ) {
                    alt6=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return ;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 6, 3, input);

                    throw nvae;
                }
                }
                break;
            case 47:
                {
                int LA6_4 = input.LA(2);

                if ( (LA6_4==13) ) {
                    alt6=1;
                }
                else if ( (LA6_4==EOF||(LA6_4>=RULE_ID && LA6_4<=RULE_STRING)||(LA6_4>=14 && LA6_4<=50)||(LA6_4>=52 && LA6_4<=80)||(LA6_4>=83 && LA6_4<=84)||(LA6_4>=86 && LA6_4<=87)) ) {
                    alt6=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return ;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 6, 4, input);

                    throw nvae;
                }
                }
                break;
            case 48:
                {
                int LA6_5 = input.LA(2);

                if ( (LA6_5==13) ) {
                    alt6=1;
                }
                else if ( (LA6_5==EOF||(LA6_5>=RULE_ID && LA6_5<=RULE_STRING)||(LA6_5>=14 && LA6_5<=50)||(LA6_5>=52 && LA6_5<=80)||(LA6_5>=83 && LA6_5<=84)||(LA6_5>=86 && LA6_5<=87)) ) {
                    alt6=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return ;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 6, 5, input);

                    throw nvae;
                }
                }
                break;
            case RULE_HEX:
            case RULE_INT:
            case RULE_DECIMAL:
            case RULE_STRING:
            case 27:
            case 34:
            case 35:
            case 40:
            case 49:
            case 50:
            case 52:
            case 56:
            case 57:
            case 60:
            case 63:
            case 65:
            case 69:
            case 70:
            case 71:
            case 72:
            case 73:
            case 74:
            case 75:
            case 76:
            case 77:
            case 79:
            case 87:
                {
                alt6=2;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 6, 0, input);

                throw nvae;
            }

            switch (alt6) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2162:2: ( ( rule__XAssignment__Group_0__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2162:2: ( ( rule__XAssignment__Group_0__0 ) )
                    // InternalXbaseWithAnnotations.g:2163:3: ( rule__XAssignment__Group_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXAssignmentAccess().getGroup_0()); 
                    }
                    // InternalXbaseWithAnnotations.g:2164:3: ( rule__XAssignment__Group_0__0 )
                    // InternalXbaseWithAnnotations.g:2164:4: rule__XAssignment__Group_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XAssignment__Group_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXAssignmentAccess().getGroup_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2168:2: ( ( rule__XAssignment__Group_1__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2168:2: ( ( rule__XAssignment__Group_1__0 ) )
                    // InternalXbaseWithAnnotations.g:2169:3: ( rule__XAssignment__Group_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXAssignmentAccess().getGroup_1()); 
                    }
                    // InternalXbaseWithAnnotations.g:2170:3: ( rule__XAssignment__Group_1__0 )
                    // InternalXbaseWithAnnotations.g:2170:4: rule__XAssignment__Group_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XAssignment__Group_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXAssignmentAccess().getGroup_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Alternatives"


    // $ANTLR start "rule__OpMultiAssign__Alternatives"
    // InternalXbaseWithAnnotations.g:2178:1: rule__OpMultiAssign__Alternatives : ( ( '+=' ) | ( '-=' ) | ( '*=' ) | ( '/=' ) | ( '%=' ) | ( ( rule__OpMultiAssign__Group_5__0 ) ) | ( ( rule__OpMultiAssign__Group_6__0 ) ) );
    public final void rule__OpMultiAssign__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2182:1: ( ( '+=' ) | ( '-=' ) | ( '*=' ) | ( '/=' ) | ( '%=' ) | ( ( rule__OpMultiAssign__Group_5__0 ) ) | ( ( rule__OpMultiAssign__Group_6__0 ) ) )
            int alt7=7;
            switch ( input.LA(1) ) {
            case 16:
                {
                alt7=1;
                }
                break;
            case 17:
                {
                alt7=2;
                }
                break;
            case 18:
                {
                alt7=3;
                }
                break;
            case 19:
                {
                alt7=4;
                }
                break;
            case 20:
                {
                alt7=5;
                }
                break;
            case 27:
                {
                alt7=6;
                }
                break;
            case 26:
                {
                alt7=7;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 7, 0, input);

                throw nvae;
            }

            switch (alt7) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2183:2: ( '+=' )
                    {
                    // InternalXbaseWithAnnotations.g:2183:2: ( '+=' )
                    // InternalXbaseWithAnnotations.g:2184:3: '+='
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpMultiAssignAccess().getPlusSignEqualsSignKeyword_0()); 
                    }
                    match(input,16,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpMultiAssignAccess().getPlusSignEqualsSignKeyword_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2189:2: ( '-=' )
                    {
                    // InternalXbaseWithAnnotations.g:2189:2: ( '-=' )
                    // InternalXbaseWithAnnotations.g:2190:3: '-='
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpMultiAssignAccess().getHyphenMinusEqualsSignKeyword_1()); 
                    }
                    match(input,17,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpMultiAssignAccess().getHyphenMinusEqualsSignKeyword_1()); 
                    }

                    }


                    }
                    break;
                case 3 :
                    // InternalXbaseWithAnnotations.g:2195:2: ( '*=' )
                    {
                    // InternalXbaseWithAnnotations.g:2195:2: ( '*=' )
                    // InternalXbaseWithAnnotations.g:2196:3: '*='
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpMultiAssignAccess().getAsteriskEqualsSignKeyword_2()); 
                    }
                    match(input,18,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpMultiAssignAccess().getAsteriskEqualsSignKeyword_2()); 
                    }

                    }


                    }
                    break;
                case 4 :
                    // InternalXbaseWithAnnotations.g:2201:2: ( '/=' )
                    {
                    // InternalXbaseWithAnnotations.g:2201:2: ( '/=' )
                    // InternalXbaseWithAnnotations.g:2202:3: '/='
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpMultiAssignAccess().getSolidusEqualsSignKeyword_3()); 
                    }
                    match(input,19,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpMultiAssignAccess().getSolidusEqualsSignKeyword_3()); 
                    }

                    }


                    }
                    break;
                case 5 :
                    // InternalXbaseWithAnnotations.g:2207:2: ( '%=' )
                    {
                    // InternalXbaseWithAnnotations.g:2207:2: ( '%=' )
                    // InternalXbaseWithAnnotations.g:2208:3: '%='
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpMultiAssignAccess().getPercentSignEqualsSignKeyword_4()); 
                    }
                    match(input,20,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpMultiAssignAccess().getPercentSignEqualsSignKeyword_4()); 
                    }

                    }


                    }
                    break;
                case 6 :
                    // InternalXbaseWithAnnotations.g:2213:2: ( ( rule__OpMultiAssign__Group_5__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2213:2: ( ( rule__OpMultiAssign__Group_5__0 ) )
                    // InternalXbaseWithAnnotations.g:2214:3: ( rule__OpMultiAssign__Group_5__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpMultiAssignAccess().getGroup_5()); 
                    }
                    // InternalXbaseWithAnnotations.g:2215:3: ( rule__OpMultiAssign__Group_5__0 )
                    // InternalXbaseWithAnnotations.g:2215:4: rule__OpMultiAssign__Group_5__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__OpMultiAssign__Group_5__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpMultiAssignAccess().getGroup_5()); 
                    }

                    }


                    }
                    break;
                case 7 :
                    // InternalXbaseWithAnnotations.g:2219:2: ( ( rule__OpMultiAssign__Group_6__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2219:2: ( ( rule__OpMultiAssign__Group_6__0 ) )
                    // InternalXbaseWithAnnotations.g:2220:3: ( rule__OpMultiAssign__Group_6__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpMultiAssignAccess().getGroup_6()); 
                    }
                    // InternalXbaseWithAnnotations.g:2221:3: ( rule__OpMultiAssign__Group_6__0 )
                    // InternalXbaseWithAnnotations.g:2221:4: rule__OpMultiAssign__Group_6__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__OpMultiAssign__Group_6__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpMultiAssignAccess().getGroup_6()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Alternatives"


    // $ANTLR start "rule__OpEquality__Alternatives"
    // InternalXbaseWithAnnotations.g:2229:1: rule__OpEquality__Alternatives : ( ( '==' ) | ( '!=' ) | ( '===' ) | ( '!==' ) );
    public final void rule__OpEquality__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2233:1: ( ( '==' ) | ( '!=' ) | ( '===' ) | ( '!==' ) )
            int alt8=4;
            switch ( input.LA(1) ) {
            case 21:
                {
                alt8=1;
                }
                break;
            case 22:
                {
                alt8=2;
                }
                break;
            case 23:
                {
                alt8=3;
                }
                break;
            case 24:
                {
                alt8=4;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 8, 0, input);

                throw nvae;
            }

            switch (alt8) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2234:2: ( '==' )
                    {
                    // InternalXbaseWithAnnotations.g:2234:2: ( '==' )
                    // InternalXbaseWithAnnotations.g:2235:3: '=='
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpEqualityAccess().getEqualsSignEqualsSignKeyword_0()); 
                    }
                    match(input,21,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpEqualityAccess().getEqualsSignEqualsSignKeyword_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2240:2: ( '!=' )
                    {
                    // InternalXbaseWithAnnotations.g:2240:2: ( '!=' )
                    // InternalXbaseWithAnnotations.g:2241:3: '!='
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpEqualityAccess().getExclamationMarkEqualsSignKeyword_1()); 
                    }
                    match(input,22,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpEqualityAccess().getExclamationMarkEqualsSignKeyword_1()); 
                    }

                    }


                    }
                    break;
                case 3 :
                    // InternalXbaseWithAnnotations.g:2246:2: ( '===' )
                    {
                    // InternalXbaseWithAnnotations.g:2246:2: ( '===' )
                    // InternalXbaseWithAnnotations.g:2247:3: '==='
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpEqualityAccess().getEqualsSignEqualsSignEqualsSignKeyword_2()); 
                    }
                    match(input,23,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpEqualityAccess().getEqualsSignEqualsSignEqualsSignKeyword_2()); 
                    }

                    }


                    }
                    break;
                case 4 :
                    // InternalXbaseWithAnnotations.g:2252:2: ( '!==' )
                    {
                    // InternalXbaseWithAnnotations.g:2252:2: ( '!==' )
                    // InternalXbaseWithAnnotations.g:2253:3: '!=='
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpEqualityAccess().getExclamationMarkEqualsSignEqualsSignKeyword_3()); 
                    }
                    match(input,24,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpEqualityAccess().getExclamationMarkEqualsSignEqualsSignKeyword_3()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpEquality__Alternatives"


    // $ANTLR start "rule__XRelationalExpression__Alternatives_1"
    // InternalXbaseWithAnnotations.g:2262:1: rule__XRelationalExpression__Alternatives_1 : ( ( ( rule__XRelationalExpression__Group_1_0__0 ) ) | ( ( rule__XRelationalExpression__Group_1_1__0 ) ) );
    public final void rule__XRelationalExpression__Alternatives_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2266:1: ( ( ( rule__XRelationalExpression__Group_1_0__0 ) ) | ( ( rule__XRelationalExpression__Group_1_1__0 ) ) )
            int alt9=2;
            int LA9_0 = input.LA(1);

            if ( (LA9_0==58) ) {
                alt9=1;
            }
            else if ( ((LA9_0>=25 && LA9_0<=27)) ) {
                alt9=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 9, 0, input);

                throw nvae;
            }
            switch (alt9) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2267:2: ( ( rule__XRelationalExpression__Group_1_0__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2267:2: ( ( rule__XRelationalExpression__Group_1_0__0 ) )
                    // InternalXbaseWithAnnotations.g:2268:3: ( rule__XRelationalExpression__Group_1_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXRelationalExpressionAccess().getGroup_1_0()); 
                    }
                    // InternalXbaseWithAnnotations.g:2269:3: ( rule__XRelationalExpression__Group_1_0__0 )
                    // InternalXbaseWithAnnotations.g:2269:4: rule__XRelationalExpression__Group_1_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XRelationalExpression__Group_1_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXRelationalExpressionAccess().getGroup_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2273:2: ( ( rule__XRelationalExpression__Group_1_1__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2273:2: ( ( rule__XRelationalExpression__Group_1_1__0 ) )
                    // InternalXbaseWithAnnotations.g:2274:3: ( rule__XRelationalExpression__Group_1_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXRelationalExpressionAccess().getGroup_1_1()); 
                    }
                    // InternalXbaseWithAnnotations.g:2275:3: ( rule__XRelationalExpression__Group_1_1__0 )
                    // InternalXbaseWithAnnotations.g:2275:4: rule__XRelationalExpression__Group_1_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XRelationalExpression__Group_1_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXRelationalExpressionAccess().getGroup_1_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Alternatives_1"


    // $ANTLR start "rule__OpCompare__Alternatives"
    // InternalXbaseWithAnnotations.g:2283:1: rule__OpCompare__Alternatives : ( ( '>=' ) | ( ( rule__OpCompare__Group_1__0 ) ) | ( '>' ) | ( '<' ) );
    public final void rule__OpCompare__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2287:1: ( ( '>=' ) | ( ( rule__OpCompare__Group_1__0 ) ) | ( '>' ) | ( '<' ) )
            int alt10=4;
            switch ( input.LA(1) ) {
            case 25:
                {
                alt10=1;
                }
                break;
            case 27:
                {
                int LA10_2 = input.LA(2);

                if ( (LA10_2==EOF||(LA10_2>=RULE_ID && LA10_2<=RULE_STRING)||LA10_2==27||(LA10_2>=34 && LA10_2<=35)||LA10_2==40||(LA10_2>=45 && LA10_2<=50)||LA10_2==52||(LA10_2>=56 && LA10_2<=57)||LA10_2==60||LA10_2==63||LA10_2==65||(LA10_2>=69 && LA10_2<=77)||LA10_2==79||LA10_2==87) ) {
                    alt10=4;
                }
                else if ( (LA10_2==13) ) {
                    alt10=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return ;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 10, 2, input);

                    throw nvae;
                }
                }
                break;
            case 26:
                {
                alt10=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 10, 0, input);

                throw nvae;
            }

            switch (alt10) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2288:2: ( '>=' )
                    {
                    // InternalXbaseWithAnnotations.g:2288:2: ( '>=' )
                    // InternalXbaseWithAnnotations.g:2289:3: '>='
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpCompareAccess().getGreaterThanSignEqualsSignKeyword_0()); 
                    }
                    match(input,25,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpCompareAccess().getGreaterThanSignEqualsSignKeyword_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2294:2: ( ( rule__OpCompare__Group_1__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2294:2: ( ( rule__OpCompare__Group_1__0 ) )
                    // InternalXbaseWithAnnotations.g:2295:3: ( rule__OpCompare__Group_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpCompareAccess().getGroup_1()); 
                    }
                    // InternalXbaseWithAnnotations.g:2296:3: ( rule__OpCompare__Group_1__0 )
                    // InternalXbaseWithAnnotations.g:2296:4: rule__OpCompare__Group_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__OpCompare__Group_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpCompareAccess().getGroup_1()); 
                    }

                    }


                    }
                    break;
                case 3 :
                    // InternalXbaseWithAnnotations.g:2300:2: ( '>' )
                    {
                    // InternalXbaseWithAnnotations.g:2300:2: ( '>' )
                    // InternalXbaseWithAnnotations.g:2301:3: '>'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpCompareAccess().getGreaterThanSignKeyword_2()); 
                    }
                    match(input,26,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpCompareAccess().getGreaterThanSignKeyword_2()); 
                    }

                    }


                    }
                    break;
                case 4 :
                    // InternalXbaseWithAnnotations.g:2306:2: ( '<' )
                    {
                    // InternalXbaseWithAnnotations.g:2306:2: ( '<' )
                    // InternalXbaseWithAnnotations.g:2307:3: '<'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpCompareAccess().getLessThanSignKeyword_3()); 
                    }
                    match(input,27,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpCompareAccess().getLessThanSignKeyword_3()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpCompare__Alternatives"


    // $ANTLR start "rule__OpOther__Alternatives"
    // InternalXbaseWithAnnotations.g:2316:1: rule__OpOther__Alternatives : ( ( '->' ) | ( '..<' ) | ( ( rule__OpOther__Group_2__0 ) ) | ( '..' ) | ( '=>' ) | ( ( rule__OpOther__Group_5__0 ) ) | ( ( rule__OpOther__Group_6__0 ) ) | ( '<>' ) | ( '?:' ) );
    public final void rule__OpOther__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2320:1: ( ( '->' ) | ( '..<' ) | ( ( rule__OpOther__Group_2__0 ) ) | ( '..' ) | ( '=>' ) | ( ( rule__OpOther__Group_5__0 ) ) | ( ( rule__OpOther__Group_6__0 ) ) | ( '<>' ) | ( '?:' ) )
            int alt11=9;
            alt11 = dfa11.predict(input);
            switch (alt11) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2321:2: ( '->' )
                    {
                    // InternalXbaseWithAnnotations.g:2321:2: ( '->' )
                    // InternalXbaseWithAnnotations.g:2322:3: '->'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getHyphenMinusGreaterThanSignKeyword_0()); 
                    }
                    match(input,28,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getHyphenMinusGreaterThanSignKeyword_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2327:2: ( '..<' )
                    {
                    // InternalXbaseWithAnnotations.g:2327:2: ( '..<' )
                    // InternalXbaseWithAnnotations.g:2328:3: '..<'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getFullStopFullStopLessThanSignKeyword_1()); 
                    }
                    match(input,29,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getFullStopFullStopLessThanSignKeyword_1()); 
                    }

                    }


                    }
                    break;
                case 3 :
                    // InternalXbaseWithAnnotations.g:2333:2: ( ( rule__OpOther__Group_2__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2333:2: ( ( rule__OpOther__Group_2__0 ) )
                    // InternalXbaseWithAnnotations.g:2334:3: ( rule__OpOther__Group_2__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getGroup_2()); 
                    }
                    // InternalXbaseWithAnnotations.g:2335:3: ( rule__OpOther__Group_2__0 )
                    // InternalXbaseWithAnnotations.g:2335:4: rule__OpOther__Group_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__OpOther__Group_2__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getGroup_2()); 
                    }

                    }


                    }
                    break;
                case 4 :
                    // InternalXbaseWithAnnotations.g:2339:2: ( '..' )
                    {
                    // InternalXbaseWithAnnotations.g:2339:2: ( '..' )
                    // InternalXbaseWithAnnotations.g:2340:3: '..'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getFullStopFullStopKeyword_3()); 
                    }
                    match(input,30,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getFullStopFullStopKeyword_3()); 
                    }

                    }


                    }
                    break;
                case 5 :
                    // InternalXbaseWithAnnotations.g:2345:2: ( '=>' )
                    {
                    // InternalXbaseWithAnnotations.g:2345:2: ( '=>' )
                    // InternalXbaseWithAnnotations.g:2346:3: '=>'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getEqualsSignGreaterThanSignKeyword_4()); 
                    }
                    match(input,31,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getEqualsSignGreaterThanSignKeyword_4()); 
                    }

                    }


                    }
                    break;
                case 6 :
                    // InternalXbaseWithAnnotations.g:2351:2: ( ( rule__OpOther__Group_5__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2351:2: ( ( rule__OpOther__Group_5__0 ) )
                    // InternalXbaseWithAnnotations.g:2352:3: ( rule__OpOther__Group_5__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getGroup_5()); 
                    }
                    // InternalXbaseWithAnnotations.g:2353:3: ( rule__OpOther__Group_5__0 )
                    // InternalXbaseWithAnnotations.g:2353:4: rule__OpOther__Group_5__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__OpOther__Group_5__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getGroup_5()); 
                    }

                    }


                    }
                    break;
                case 7 :
                    // InternalXbaseWithAnnotations.g:2357:2: ( ( rule__OpOther__Group_6__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2357:2: ( ( rule__OpOther__Group_6__0 ) )
                    // InternalXbaseWithAnnotations.g:2358:3: ( rule__OpOther__Group_6__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getGroup_6()); 
                    }
                    // InternalXbaseWithAnnotations.g:2359:3: ( rule__OpOther__Group_6__0 )
                    // InternalXbaseWithAnnotations.g:2359:4: rule__OpOther__Group_6__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__OpOther__Group_6__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getGroup_6()); 
                    }

                    }


                    }
                    break;
                case 8 :
                    // InternalXbaseWithAnnotations.g:2363:2: ( '<>' )
                    {
                    // InternalXbaseWithAnnotations.g:2363:2: ( '<>' )
                    // InternalXbaseWithAnnotations.g:2364:3: '<>'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getLessThanSignGreaterThanSignKeyword_7()); 
                    }
                    match(input,32,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getLessThanSignGreaterThanSignKeyword_7()); 
                    }

                    }


                    }
                    break;
                case 9 :
                    // InternalXbaseWithAnnotations.g:2369:2: ( '?:' )
                    {
                    // InternalXbaseWithAnnotations.g:2369:2: ( '?:' )
                    // InternalXbaseWithAnnotations.g:2370:3: '?:'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getQuestionMarkColonKeyword_8()); 
                    }
                    match(input,33,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getQuestionMarkColonKeyword_8()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Alternatives"


    // $ANTLR start "rule__OpOther__Alternatives_5_1"
    // InternalXbaseWithAnnotations.g:2379:1: rule__OpOther__Alternatives_5_1 : ( ( ( rule__OpOther__Group_5_1_0__0 ) ) | ( '>' ) );
    public final void rule__OpOther__Alternatives_5_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2383:1: ( ( ( rule__OpOther__Group_5_1_0__0 ) ) | ( '>' ) )
            int alt12=2;
            int LA12_0 = input.LA(1);

            if ( (LA12_0==26) ) {
                int LA12_1 = input.LA(2);

                if ( (LA12_1==EOF||(LA12_1>=RULE_ID && LA12_1<=RULE_STRING)||LA12_1==27||(LA12_1>=34 && LA12_1<=35)||LA12_1==40||(LA12_1>=45 && LA12_1<=50)||LA12_1==52||(LA12_1>=56 && LA12_1<=57)||LA12_1==60||LA12_1==63||LA12_1==65||(LA12_1>=69 && LA12_1<=77)||LA12_1==79||LA12_1==87) ) {
                    alt12=2;
                }
                else if ( (LA12_1==26) ) {
                    alt12=1;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return ;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 12, 1, input);

                    throw nvae;
                }
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 12, 0, input);

                throw nvae;
            }
            switch (alt12) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2384:2: ( ( rule__OpOther__Group_5_1_0__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2384:2: ( ( rule__OpOther__Group_5_1_0__0 ) )
                    // InternalXbaseWithAnnotations.g:2385:3: ( rule__OpOther__Group_5_1_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getGroup_5_1_0()); 
                    }
                    // InternalXbaseWithAnnotations.g:2386:3: ( rule__OpOther__Group_5_1_0__0 )
                    // InternalXbaseWithAnnotations.g:2386:4: rule__OpOther__Group_5_1_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__OpOther__Group_5_1_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getGroup_5_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2390:2: ( '>' )
                    {
                    // InternalXbaseWithAnnotations.g:2390:2: ( '>' )
                    // InternalXbaseWithAnnotations.g:2391:3: '>'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_5_1_1()); 
                    }
                    match(input,26,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_5_1_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Alternatives_5_1"


    // $ANTLR start "rule__OpOther__Alternatives_6_1"
    // InternalXbaseWithAnnotations.g:2400:1: rule__OpOther__Alternatives_6_1 : ( ( ( rule__OpOther__Group_6_1_0__0 ) ) | ( '<' ) | ( '=>' ) );
    public final void rule__OpOther__Alternatives_6_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2404:1: ( ( ( rule__OpOther__Group_6_1_0__0 ) ) | ( '<' ) | ( '=>' ) )
            int alt13=3;
            int LA13_0 = input.LA(1);

            if ( (LA13_0==27) ) {
                int LA13_1 = input.LA(2);

                if ( (synpred29_InternalXbaseWithAnnotations()) ) {
                    alt13=1;
                }
                else if ( (synpred30_InternalXbaseWithAnnotations()) ) {
                    alt13=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return ;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 13, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA13_0==31) ) {
                alt13=3;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 13, 0, input);

                throw nvae;
            }
            switch (alt13) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2405:2: ( ( rule__OpOther__Group_6_1_0__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2405:2: ( ( rule__OpOther__Group_6_1_0__0 ) )
                    // InternalXbaseWithAnnotations.g:2406:3: ( rule__OpOther__Group_6_1_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getGroup_6_1_0()); 
                    }
                    // InternalXbaseWithAnnotations.g:2407:3: ( rule__OpOther__Group_6_1_0__0 )
                    // InternalXbaseWithAnnotations.g:2407:4: rule__OpOther__Group_6_1_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__OpOther__Group_6_1_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getGroup_6_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2411:2: ( '<' )
                    {
                    // InternalXbaseWithAnnotations.g:2411:2: ( '<' )
                    // InternalXbaseWithAnnotations.g:2412:3: '<'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getLessThanSignKeyword_6_1_1()); 
                    }
                    match(input,27,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getLessThanSignKeyword_6_1_1()); 
                    }

                    }


                    }
                    break;
                case 3 :
                    // InternalXbaseWithAnnotations.g:2417:2: ( '=>' )
                    {
                    // InternalXbaseWithAnnotations.g:2417:2: ( '=>' )
                    // InternalXbaseWithAnnotations.g:2418:3: '=>'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpOtherAccess().getEqualsSignGreaterThanSignKeyword_6_1_2()); 
                    }
                    match(input,31,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpOtherAccess().getEqualsSignGreaterThanSignKeyword_6_1_2()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Alternatives_6_1"


    // $ANTLR start "rule__OpAdd__Alternatives"
    // InternalXbaseWithAnnotations.g:2427:1: rule__OpAdd__Alternatives : ( ( '+' ) | ( '-' ) );
    public final void rule__OpAdd__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2431:1: ( ( '+' ) | ( '-' ) )
            int alt14=2;
            int LA14_0 = input.LA(1);

            if ( (LA14_0==34) ) {
                alt14=1;
            }
            else if ( (LA14_0==35) ) {
                alt14=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 14, 0, input);

                throw nvae;
            }
            switch (alt14) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2432:2: ( '+' )
                    {
                    // InternalXbaseWithAnnotations.g:2432:2: ( '+' )
                    // InternalXbaseWithAnnotations.g:2433:3: '+'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpAddAccess().getPlusSignKeyword_0()); 
                    }
                    match(input,34,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpAddAccess().getPlusSignKeyword_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2438:2: ( '-' )
                    {
                    // InternalXbaseWithAnnotations.g:2438:2: ( '-' )
                    // InternalXbaseWithAnnotations.g:2439:3: '-'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpAddAccess().getHyphenMinusKeyword_1()); 
                    }
                    match(input,35,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpAddAccess().getHyphenMinusKeyword_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpAdd__Alternatives"


    // $ANTLR start "rule__OpMulti__Alternatives"
    // InternalXbaseWithAnnotations.g:2448:1: rule__OpMulti__Alternatives : ( ( '*' ) | ( '**' ) | ( '/' ) | ( '%' ) );
    public final void rule__OpMulti__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2452:1: ( ( '*' ) | ( '**' ) | ( '/' ) | ( '%' ) )
            int alt15=4;
            switch ( input.LA(1) ) {
            case 36:
                {
                alt15=1;
                }
                break;
            case 37:
                {
                alt15=2;
                }
                break;
            case 38:
                {
                alt15=3;
                }
                break;
            case 39:
                {
                alt15=4;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 15, 0, input);

                throw nvae;
            }

            switch (alt15) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2453:2: ( '*' )
                    {
                    // InternalXbaseWithAnnotations.g:2453:2: ( '*' )
                    // InternalXbaseWithAnnotations.g:2454:3: '*'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpMultiAccess().getAsteriskKeyword_0()); 
                    }
                    match(input,36,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpMultiAccess().getAsteriskKeyword_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2459:2: ( '**' )
                    {
                    // InternalXbaseWithAnnotations.g:2459:2: ( '**' )
                    // InternalXbaseWithAnnotations.g:2460:3: '**'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpMultiAccess().getAsteriskAsteriskKeyword_1()); 
                    }
                    match(input,37,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpMultiAccess().getAsteriskAsteriskKeyword_1()); 
                    }

                    }


                    }
                    break;
                case 3 :
                    // InternalXbaseWithAnnotations.g:2465:2: ( '/' )
                    {
                    // InternalXbaseWithAnnotations.g:2465:2: ( '/' )
                    // InternalXbaseWithAnnotations.g:2466:3: '/'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpMultiAccess().getSolidusKeyword_2()); 
                    }
                    match(input,38,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpMultiAccess().getSolidusKeyword_2()); 
                    }

                    }


                    }
                    break;
                case 4 :
                    // InternalXbaseWithAnnotations.g:2471:2: ( '%' )
                    {
                    // InternalXbaseWithAnnotations.g:2471:2: ( '%' )
                    // InternalXbaseWithAnnotations.g:2472:3: '%'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpMultiAccess().getPercentSignKeyword_3()); 
                    }
                    match(input,39,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpMultiAccess().getPercentSignKeyword_3()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMulti__Alternatives"


    // $ANTLR start "rule__XUnaryOperation__Alternatives"
    // InternalXbaseWithAnnotations.g:2481:1: rule__XUnaryOperation__Alternatives : ( ( ( rule__XUnaryOperation__Group_0__0 ) ) | ( ruleXCastedExpression ) );
    public final void rule__XUnaryOperation__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2485:1: ( ( ( rule__XUnaryOperation__Group_0__0 ) ) | ( ruleXCastedExpression ) )
            int alt16=2;
            int LA16_0 = input.LA(1);

            if ( ((LA16_0>=34 && LA16_0<=35)||LA16_0==40) ) {
                alt16=1;
            }
            else if ( ((LA16_0>=RULE_ID && LA16_0<=RULE_STRING)||LA16_0==27||(LA16_0>=45 && LA16_0<=50)||LA16_0==52||(LA16_0>=56 && LA16_0<=57)||LA16_0==60||LA16_0==63||LA16_0==65||(LA16_0>=69 && LA16_0<=77)||LA16_0==79||LA16_0==87) ) {
                alt16=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 16, 0, input);

                throw nvae;
            }
            switch (alt16) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2486:2: ( ( rule__XUnaryOperation__Group_0__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2486:2: ( ( rule__XUnaryOperation__Group_0__0 ) )
                    // InternalXbaseWithAnnotations.g:2487:3: ( rule__XUnaryOperation__Group_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXUnaryOperationAccess().getGroup_0()); 
                    }
                    // InternalXbaseWithAnnotations.g:2488:3: ( rule__XUnaryOperation__Group_0__0 )
                    // InternalXbaseWithAnnotations.g:2488:4: rule__XUnaryOperation__Group_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XUnaryOperation__Group_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXUnaryOperationAccess().getGroup_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2492:2: ( ruleXCastedExpression )
                    {
                    // InternalXbaseWithAnnotations.g:2492:2: ( ruleXCastedExpression )
                    // InternalXbaseWithAnnotations.g:2493:3: ruleXCastedExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXUnaryOperationAccess().getXCastedExpressionParserRuleCall_1()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXCastedExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXUnaryOperationAccess().getXCastedExpressionParserRuleCall_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XUnaryOperation__Alternatives"


    // $ANTLR start "rule__OpUnary__Alternatives"
    // InternalXbaseWithAnnotations.g:2502:1: rule__OpUnary__Alternatives : ( ( '!' ) | ( '-' ) | ( '+' ) );
    public final void rule__OpUnary__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2506:1: ( ( '!' ) | ( '-' ) | ( '+' ) )
            int alt17=3;
            switch ( input.LA(1) ) {
            case 40:
                {
                alt17=1;
                }
                break;
            case 35:
                {
                alt17=2;
                }
                break;
            case 34:
                {
                alt17=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 17, 0, input);

                throw nvae;
            }

            switch (alt17) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2507:2: ( '!' )
                    {
                    // InternalXbaseWithAnnotations.g:2507:2: ( '!' )
                    // InternalXbaseWithAnnotations.g:2508:3: '!'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpUnaryAccess().getExclamationMarkKeyword_0()); 
                    }
                    match(input,40,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpUnaryAccess().getExclamationMarkKeyword_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2513:2: ( '-' )
                    {
                    // InternalXbaseWithAnnotations.g:2513:2: ( '-' )
                    // InternalXbaseWithAnnotations.g:2514:3: '-'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpUnaryAccess().getHyphenMinusKeyword_1()); 
                    }
                    match(input,35,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpUnaryAccess().getHyphenMinusKeyword_1()); 
                    }

                    }


                    }
                    break;
                case 3 :
                    // InternalXbaseWithAnnotations.g:2519:2: ( '+' )
                    {
                    // InternalXbaseWithAnnotations.g:2519:2: ( '+' )
                    // InternalXbaseWithAnnotations.g:2520:3: '+'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpUnaryAccess().getPlusSignKeyword_2()); 
                    }
                    match(input,34,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpUnaryAccess().getPlusSignKeyword_2()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpUnary__Alternatives"


    // $ANTLR start "rule__OpPostfix__Alternatives"
    // InternalXbaseWithAnnotations.g:2529:1: rule__OpPostfix__Alternatives : ( ( '++' ) | ( '--' ) );
    public final void rule__OpPostfix__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2533:1: ( ( '++' ) | ( '--' ) )
            int alt18=2;
            int LA18_0 = input.LA(1);

            if ( (LA18_0==41) ) {
                alt18=1;
            }
            else if ( (LA18_0==42) ) {
                alt18=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 18, 0, input);

                throw nvae;
            }
            switch (alt18) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2534:2: ( '++' )
                    {
                    // InternalXbaseWithAnnotations.g:2534:2: ( '++' )
                    // InternalXbaseWithAnnotations.g:2535:3: '++'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpPostfixAccess().getPlusSignPlusSignKeyword_0()); 
                    }
                    match(input,41,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpPostfixAccess().getPlusSignPlusSignKeyword_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2540:2: ( '--' )
                    {
                    // InternalXbaseWithAnnotations.g:2540:2: ( '--' )
                    // InternalXbaseWithAnnotations.g:2541:3: '--'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getOpPostfixAccess().getHyphenMinusHyphenMinusKeyword_1()); 
                    }
                    match(input,42,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getOpPostfixAccess().getHyphenMinusHyphenMinusKeyword_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpPostfix__Alternatives"


    // $ANTLR start "rule__XMemberFeatureCall__Alternatives_1"
    // InternalXbaseWithAnnotations.g:2550:1: rule__XMemberFeatureCall__Alternatives_1 : ( ( ( rule__XMemberFeatureCall__Group_1_0__0 ) ) | ( ( rule__XMemberFeatureCall__Group_1_1__0 ) ) );
    public final void rule__XMemberFeatureCall__Alternatives_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2554:1: ( ( ( rule__XMemberFeatureCall__Group_1_0__0 ) ) | ( ( rule__XMemberFeatureCall__Group_1_1__0 ) ) )
            int alt19=2;
            alt19 = dfa19.predict(input);
            switch (alt19) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2555:2: ( ( rule__XMemberFeatureCall__Group_1_0__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2555:2: ( ( rule__XMemberFeatureCall__Group_1_0__0 ) )
                    // InternalXbaseWithAnnotations.g:2556:3: ( rule__XMemberFeatureCall__Group_1_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_0()); 
                    }
                    // InternalXbaseWithAnnotations.g:2557:3: ( rule__XMemberFeatureCall__Group_1_0__0 )
                    // InternalXbaseWithAnnotations.g:2557:4: rule__XMemberFeatureCall__Group_1_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XMemberFeatureCall__Group_1_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2561:2: ( ( rule__XMemberFeatureCall__Group_1_1__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2561:2: ( ( rule__XMemberFeatureCall__Group_1_1__0 ) )
                    // InternalXbaseWithAnnotations.g:2562:3: ( rule__XMemberFeatureCall__Group_1_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1()); 
                    }
                    // InternalXbaseWithAnnotations.g:2563:3: ( rule__XMemberFeatureCall__Group_1_1__0 )
                    // InternalXbaseWithAnnotations.g:2563:4: rule__XMemberFeatureCall__Group_1_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XMemberFeatureCall__Group_1_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Alternatives_1"


    // $ANTLR start "rule__XMemberFeatureCall__Alternatives_1_0_0_0_1"
    // InternalXbaseWithAnnotations.g:2571:1: rule__XMemberFeatureCall__Alternatives_1_0_0_0_1 : ( ( '.' ) | ( ( rule__XMemberFeatureCall__ExplicitStaticAssignment_1_0_0_0_1_1 ) ) );
    public final void rule__XMemberFeatureCall__Alternatives_1_0_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2575:1: ( ( '.' ) | ( ( rule__XMemberFeatureCall__ExplicitStaticAssignment_1_0_0_0_1_1 ) ) )
            int alt20=2;
            int LA20_0 = input.LA(1);

            if ( (LA20_0==43) ) {
                alt20=1;
            }
            else if ( (LA20_0==83) ) {
                alt20=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 20, 0, input);

                throw nvae;
            }
            switch (alt20) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2576:2: ( '.' )
                    {
                    // InternalXbaseWithAnnotations.g:2576:2: ( '.' )
                    // InternalXbaseWithAnnotations.g:2577:3: '.'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXMemberFeatureCallAccess().getFullStopKeyword_1_0_0_0_1_0()); 
                    }
                    match(input,43,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXMemberFeatureCallAccess().getFullStopKeyword_1_0_0_0_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2582:2: ( ( rule__XMemberFeatureCall__ExplicitStaticAssignment_1_0_0_0_1_1 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2582:2: ( ( rule__XMemberFeatureCall__ExplicitStaticAssignment_1_0_0_0_1_1 ) )
                    // InternalXbaseWithAnnotations.g:2583:3: ( rule__XMemberFeatureCall__ExplicitStaticAssignment_1_0_0_0_1_1 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticAssignment_1_0_0_0_1_1()); 
                    }
                    // InternalXbaseWithAnnotations.g:2584:3: ( rule__XMemberFeatureCall__ExplicitStaticAssignment_1_0_0_0_1_1 )
                    // InternalXbaseWithAnnotations.g:2584:4: rule__XMemberFeatureCall__ExplicitStaticAssignment_1_0_0_0_1_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XMemberFeatureCall__ExplicitStaticAssignment_1_0_0_0_1_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticAssignment_1_0_0_0_1_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Alternatives_1_0_0_0_1"


    // $ANTLR start "rule__XMemberFeatureCall__Alternatives_1_1_0_0_1"
    // InternalXbaseWithAnnotations.g:2592:1: rule__XMemberFeatureCall__Alternatives_1_1_0_0_1 : ( ( '.' ) | ( ( rule__XMemberFeatureCall__NullSafeAssignment_1_1_0_0_1_1 ) ) | ( ( rule__XMemberFeatureCall__ExplicitStaticAssignment_1_1_0_0_1_2 ) ) );
    public final void rule__XMemberFeatureCall__Alternatives_1_1_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2596:1: ( ( '.' ) | ( ( rule__XMemberFeatureCall__NullSafeAssignment_1_1_0_0_1_1 ) ) | ( ( rule__XMemberFeatureCall__ExplicitStaticAssignment_1_1_0_0_1_2 ) ) )
            int alt21=3;
            switch ( input.LA(1) ) {
            case 43:
                {
                alt21=1;
                }
                break;
            case 84:
                {
                alt21=2;
                }
                break;
            case 83:
                {
                alt21=3;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 21, 0, input);

                throw nvae;
            }

            switch (alt21) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2597:2: ( '.' )
                    {
                    // InternalXbaseWithAnnotations.g:2597:2: ( '.' )
                    // InternalXbaseWithAnnotations.g:2598:3: '.'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXMemberFeatureCallAccess().getFullStopKeyword_1_1_0_0_1_0()); 
                    }
                    match(input,43,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXMemberFeatureCallAccess().getFullStopKeyword_1_1_0_0_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2603:2: ( ( rule__XMemberFeatureCall__NullSafeAssignment_1_1_0_0_1_1 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2603:2: ( ( rule__XMemberFeatureCall__NullSafeAssignment_1_1_0_0_1_1 ) )
                    // InternalXbaseWithAnnotations.g:2604:3: ( rule__XMemberFeatureCall__NullSafeAssignment_1_1_0_0_1_1 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXMemberFeatureCallAccess().getNullSafeAssignment_1_1_0_0_1_1()); 
                    }
                    // InternalXbaseWithAnnotations.g:2605:3: ( rule__XMemberFeatureCall__NullSafeAssignment_1_1_0_0_1_1 )
                    // InternalXbaseWithAnnotations.g:2605:4: rule__XMemberFeatureCall__NullSafeAssignment_1_1_0_0_1_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XMemberFeatureCall__NullSafeAssignment_1_1_0_0_1_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXMemberFeatureCallAccess().getNullSafeAssignment_1_1_0_0_1_1()); 
                    }

                    }


                    }
                    break;
                case 3 :
                    // InternalXbaseWithAnnotations.g:2609:2: ( ( rule__XMemberFeatureCall__ExplicitStaticAssignment_1_1_0_0_1_2 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2609:2: ( ( rule__XMemberFeatureCall__ExplicitStaticAssignment_1_1_0_0_1_2 ) )
                    // InternalXbaseWithAnnotations.g:2610:3: ( rule__XMemberFeatureCall__ExplicitStaticAssignment_1_1_0_0_1_2 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticAssignment_1_1_0_0_1_2()); 
                    }
                    // InternalXbaseWithAnnotations.g:2611:3: ( rule__XMemberFeatureCall__ExplicitStaticAssignment_1_1_0_0_1_2 )
                    // InternalXbaseWithAnnotations.g:2611:4: rule__XMemberFeatureCall__ExplicitStaticAssignment_1_1_0_0_1_2
                    {
                    pushFollow(FOLLOW_2);
                    rule__XMemberFeatureCall__ExplicitStaticAssignment_1_1_0_0_1_2();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticAssignment_1_1_0_0_1_2()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Alternatives_1_1_0_0_1"


    // $ANTLR start "rule__XMemberFeatureCall__Alternatives_1_1_3_1"
    // InternalXbaseWithAnnotations.g:2619:1: rule__XMemberFeatureCall__Alternatives_1_1_3_1 : ( ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 ) ) | ( ( rule__XMemberFeatureCall__Group_1_1_3_1_1__0 ) ) );
    public final void rule__XMemberFeatureCall__Alternatives_1_1_3_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2623:1: ( ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 ) ) | ( ( rule__XMemberFeatureCall__Group_1_1_3_1_1__0 ) ) )
            int alt22=2;
            alt22 = dfa22.predict(input);
            switch (alt22) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2624:2: ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2624:2: ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 ) )
                    // InternalXbaseWithAnnotations.g:2625:3: ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsAssignment_1_1_3_1_0()); 
                    }
                    // InternalXbaseWithAnnotations.g:2626:3: ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 )
                    // InternalXbaseWithAnnotations.g:2626:4: rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsAssignment_1_1_3_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2630:2: ( ( rule__XMemberFeatureCall__Group_1_1_3_1_1__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2630:2: ( ( rule__XMemberFeatureCall__Group_1_1_3_1_1__0 ) )
                    // InternalXbaseWithAnnotations.g:2631:3: ( rule__XMemberFeatureCall__Group_1_1_3_1_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_3_1_1()); 
                    }
                    // InternalXbaseWithAnnotations.g:2632:3: ( rule__XMemberFeatureCall__Group_1_1_3_1_1__0 )
                    // InternalXbaseWithAnnotations.g:2632:4: rule__XMemberFeatureCall__Group_1_1_3_1_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XMemberFeatureCall__Group_1_1_3_1_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_3_1_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Alternatives_1_1_3_1"


    // $ANTLR start "rule__XPrimaryExpression__Alternatives"
    // InternalXbaseWithAnnotations.g:2640:1: rule__XPrimaryExpression__Alternatives : ( ( ruleXConstructorCall ) | ( ruleXBlockExpression ) | ( ruleXSwitchExpression ) | ( ( ruleXSynchronizedExpression ) ) | ( ruleXFeatureCall ) | ( ruleXLiteral ) | ( ruleXIfExpression ) | ( ( ruleXForLoopExpression ) ) | ( ruleXBasicForLoopExpression ) | ( ruleXWhileExpression ) | ( ruleXDoWhileExpression ) | ( ruleXThrowExpression ) | ( ruleXReturnExpression ) | ( ruleXTryCatchFinallyExpression ) | ( ruleXParenthesizedExpression ) );
    public final void rule__XPrimaryExpression__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2644:1: ( ( ruleXConstructorCall ) | ( ruleXBlockExpression ) | ( ruleXSwitchExpression ) | ( ( ruleXSynchronizedExpression ) ) | ( ruleXFeatureCall ) | ( ruleXLiteral ) | ( ruleXIfExpression ) | ( ( ruleXForLoopExpression ) ) | ( ruleXBasicForLoopExpression ) | ( ruleXWhileExpression ) | ( ruleXDoWhileExpression ) | ( ruleXThrowExpression ) | ( ruleXReturnExpression ) | ( ruleXTryCatchFinallyExpression ) | ( ruleXParenthesizedExpression ) )
            int alt23=15;
            alt23 = dfa23.predict(input);
            switch (alt23) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2645:2: ( ruleXConstructorCall )
                    {
                    // InternalXbaseWithAnnotations.g:2645:2: ( ruleXConstructorCall )
                    // InternalXbaseWithAnnotations.g:2646:3: ruleXConstructorCall
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXConstructorCallParserRuleCall_0()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXConstructorCall();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXConstructorCallParserRuleCall_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2651:2: ( ruleXBlockExpression )
                    {
                    // InternalXbaseWithAnnotations.g:2651:2: ( ruleXBlockExpression )
                    // InternalXbaseWithAnnotations.g:2652:3: ruleXBlockExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXBlockExpressionParserRuleCall_1()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXBlockExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXBlockExpressionParserRuleCall_1()); 
                    }

                    }


                    }
                    break;
                case 3 :
                    // InternalXbaseWithAnnotations.g:2657:2: ( ruleXSwitchExpression )
                    {
                    // InternalXbaseWithAnnotations.g:2657:2: ( ruleXSwitchExpression )
                    // InternalXbaseWithAnnotations.g:2658:3: ruleXSwitchExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXSwitchExpressionParserRuleCall_2()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXSwitchExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXSwitchExpressionParserRuleCall_2()); 
                    }

                    }


                    }
                    break;
                case 4 :
                    // InternalXbaseWithAnnotations.g:2663:2: ( ( ruleXSynchronizedExpression ) )
                    {
                    // InternalXbaseWithAnnotations.g:2663:2: ( ( ruleXSynchronizedExpression ) )
                    // InternalXbaseWithAnnotations.g:2664:3: ( ruleXSynchronizedExpression )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXSynchronizedExpressionParserRuleCall_3()); 
                    }
                    // InternalXbaseWithAnnotations.g:2665:3: ( ruleXSynchronizedExpression )
                    // InternalXbaseWithAnnotations.g:2665:4: ruleXSynchronizedExpression
                    {
                    pushFollow(FOLLOW_2);
                    ruleXSynchronizedExpression();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXSynchronizedExpressionParserRuleCall_3()); 
                    }

                    }


                    }
                    break;
                case 5 :
                    // InternalXbaseWithAnnotations.g:2669:2: ( ruleXFeatureCall )
                    {
                    // InternalXbaseWithAnnotations.g:2669:2: ( ruleXFeatureCall )
                    // InternalXbaseWithAnnotations.g:2670:3: ruleXFeatureCall
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXFeatureCallParserRuleCall_4()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXFeatureCall();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXFeatureCallParserRuleCall_4()); 
                    }

                    }


                    }
                    break;
                case 6 :
                    // InternalXbaseWithAnnotations.g:2675:2: ( ruleXLiteral )
                    {
                    // InternalXbaseWithAnnotations.g:2675:2: ( ruleXLiteral )
                    // InternalXbaseWithAnnotations.g:2676:3: ruleXLiteral
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXLiteralParserRuleCall_5()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXLiteral();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXLiteralParserRuleCall_5()); 
                    }

                    }


                    }
                    break;
                case 7 :
                    // InternalXbaseWithAnnotations.g:2681:2: ( ruleXIfExpression )
                    {
                    // InternalXbaseWithAnnotations.g:2681:2: ( ruleXIfExpression )
                    // InternalXbaseWithAnnotations.g:2682:3: ruleXIfExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXIfExpressionParserRuleCall_6()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXIfExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXIfExpressionParserRuleCall_6()); 
                    }

                    }


                    }
                    break;
                case 8 :
                    // InternalXbaseWithAnnotations.g:2687:2: ( ( ruleXForLoopExpression ) )
                    {
                    // InternalXbaseWithAnnotations.g:2687:2: ( ( ruleXForLoopExpression ) )
                    // InternalXbaseWithAnnotations.g:2688:3: ( ruleXForLoopExpression )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXForLoopExpressionParserRuleCall_7()); 
                    }
                    // InternalXbaseWithAnnotations.g:2689:3: ( ruleXForLoopExpression )
                    // InternalXbaseWithAnnotations.g:2689:4: ruleXForLoopExpression
                    {
                    pushFollow(FOLLOW_2);
                    ruleXForLoopExpression();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXForLoopExpressionParserRuleCall_7()); 
                    }

                    }


                    }
                    break;
                case 9 :
                    // InternalXbaseWithAnnotations.g:2693:2: ( ruleXBasicForLoopExpression )
                    {
                    // InternalXbaseWithAnnotations.g:2693:2: ( ruleXBasicForLoopExpression )
                    // InternalXbaseWithAnnotations.g:2694:3: ruleXBasicForLoopExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXBasicForLoopExpressionParserRuleCall_8()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXBasicForLoopExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXBasicForLoopExpressionParserRuleCall_8()); 
                    }

                    }


                    }
                    break;
                case 10 :
                    // InternalXbaseWithAnnotations.g:2699:2: ( ruleXWhileExpression )
                    {
                    // InternalXbaseWithAnnotations.g:2699:2: ( ruleXWhileExpression )
                    // InternalXbaseWithAnnotations.g:2700:3: ruleXWhileExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXWhileExpressionParserRuleCall_9()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXWhileExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXWhileExpressionParserRuleCall_9()); 
                    }

                    }


                    }
                    break;
                case 11 :
                    // InternalXbaseWithAnnotations.g:2705:2: ( ruleXDoWhileExpression )
                    {
                    // InternalXbaseWithAnnotations.g:2705:2: ( ruleXDoWhileExpression )
                    // InternalXbaseWithAnnotations.g:2706:3: ruleXDoWhileExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXDoWhileExpressionParserRuleCall_10()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXDoWhileExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXDoWhileExpressionParserRuleCall_10()); 
                    }

                    }


                    }
                    break;
                case 12 :
                    // InternalXbaseWithAnnotations.g:2711:2: ( ruleXThrowExpression )
                    {
                    // InternalXbaseWithAnnotations.g:2711:2: ( ruleXThrowExpression )
                    // InternalXbaseWithAnnotations.g:2712:3: ruleXThrowExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXThrowExpressionParserRuleCall_11()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXThrowExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXThrowExpressionParserRuleCall_11()); 
                    }

                    }


                    }
                    break;
                case 13 :
                    // InternalXbaseWithAnnotations.g:2717:2: ( ruleXReturnExpression )
                    {
                    // InternalXbaseWithAnnotations.g:2717:2: ( ruleXReturnExpression )
                    // InternalXbaseWithAnnotations.g:2718:3: ruleXReturnExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXReturnExpressionParserRuleCall_12()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXReturnExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXReturnExpressionParserRuleCall_12()); 
                    }

                    }


                    }
                    break;
                case 14 :
                    // InternalXbaseWithAnnotations.g:2723:2: ( ruleXTryCatchFinallyExpression )
                    {
                    // InternalXbaseWithAnnotations.g:2723:2: ( ruleXTryCatchFinallyExpression )
                    // InternalXbaseWithAnnotations.g:2724:3: ruleXTryCatchFinallyExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXTryCatchFinallyExpressionParserRuleCall_13()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXTryCatchFinallyExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXTryCatchFinallyExpressionParserRuleCall_13()); 
                    }

                    }


                    }
                    break;
                case 15 :
                    // InternalXbaseWithAnnotations.g:2729:2: ( ruleXParenthesizedExpression )
                    {
                    // InternalXbaseWithAnnotations.g:2729:2: ( ruleXParenthesizedExpression )
                    // InternalXbaseWithAnnotations.g:2730:3: ruleXParenthesizedExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXPrimaryExpressionAccess().getXParenthesizedExpressionParserRuleCall_14()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXParenthesizedExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXPrimaryExpressionAccess().getXParenthesizedExpressionParserRuleCall_14()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XPrimaryExpression__Alternatives"


    // $ANTLR start "rule__XLiteral__Alternatives"
    // InternalXbaseWithAnnotations.g:2739:1: rule__XLiteral__Alternatives : ( ( ruleXCollectionLiteral ) | ( ( ruleXClosure ) ) | ( ruleXBooleanLiteral ) | ( ruleXNumberLiteral ) | ( ruleXNullLiteral ) | ( ruleXStringLiteral ) | ( ruleXTypeLiteral ) );
    public final void rule__XLiteral__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2743:1: ( ( ruleXCollectionLiteral ) | ( ( ruleXClosure ) ) | ( ruleXBooleanLiteral ) | ( ruleXNumberLiteral ) | ( ruleXNullLiteral ) | ( ruleXStringLiteral ) | ( ruleXTypeLiteral ) )
            int alt24=7;
            switch ( input.LA(1) ) {
            case 56:
                {
                alt24=1;
                }
                break;
            case 57:
                {
                alt24=2;
                }
                break;
            case 50:
            case 87:
                {
                alt24=3;
                }
                break;
            case RULE_HEX:
            case RULE_INT:
            case RULE_DECIMAL:
                {
                alt24=4;
                }
                break;
            case 73:
                {
                alt24=5;
                }
                break;
            case RULE_STRING:
                {
                alt24=6;
                }
                break;
            case 74:
                {
                alt24=7;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 24, 0, input);

                throw nvae;
            }

            switch (alt24) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2744:2: ( ruleXCollectionLiteral )
                    {
                    // InternalXbaseWithAnnotations.g:2744:2: ( ruleXCollectionLiteral )
                    // InternalXbaseWithAnnotations.g:2745:3: ruleXCollectionLiteral
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXLiteralAccess().getXCollectionLiteralParserRuleCall_0()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXCollectionLiteral();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXLiteralAccess().getXCollectionLiteralParserRuleCall_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2750:2: ( ( ruleXClosure ) )
                    {
                    // InternalXbaseWithAnnotations.g:2750:2: ( ( ruleXClosure ) )
                    // InternalXbaseWithAnnotations.g:2751:3: ( ruleXClosure )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXLiteralAccess().getXClosureParserRuleCall_1()); 
                    }
                    // InternalXbaseWithAnnotations.g:2752:3: ( ruleXClosure )
                    // InternalXbaseWithAnnotations.g:2752:4: ruleXClosure
                    {
                    pushFollow(FOLLOW_2);
                    ruleXClosure();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXLiteralAccess().getXClosureParserRuleCall_1()); 
                    }

                    }


                    }
                    break;
                case 3 :
                    // InternalXbaseWithAnnotations.g:2756:2: ( ruleXBooleanLiteral )
                    {
                    // InternalXbaseWithAnnotations.g:2756:2: ( ruleXBooleanLiteral )
                    // InternalXbaseWithAnnotations.g:2757:3: ruleXBooleanLiteral
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXLiteralAccess().getXBooleanLiteralParserRuleCall_2()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXBooleanLiteral();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXLiteralAccess().getXBooleanLiteralParserRuleCall_2()); 
                    }

                    }


                    }
                    break;
                case 4 :
                    // InternalXbaseWithAnnotations.g:2762:2: ( ruleXNumberLiteral )
                    {
                    // InternalXbaseWithAnnotations.g:2762:2: ( ruleXNumberLiteral )
                    // InternalXbaseWithAnnotations.g:2763:3: ruleXNumberLiteral
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXLiteralAccess().getXNumberLiteralParserRuleCall_3()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXNumberLiteral();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXLiteralAccess().getXNumberLiteralParserRuleCall_3()); 
                    }

                    }


                    }
                    break;
                case 5 :
                    // InternalXbaseWithAnnotations.g:2768:2: ( ruleXNullLiteral )
                    {
                    // InternalXbaseWithAnnotations.g:2768:2: ( ruleXNullLiteral )
                    // InternalXbaseWithAnnotations.g:2769:3: ruleXNullLiteral
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXLiteralAccess().getXNullLiteralParserRuleCall_4()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXNullLiteral();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXLiteralAccess().getXNullLiteralParserRuleCall_4()); 
                    }

                    }


                    }
                    break;
                case 6 :
                    // InternalXbaseWithAnnotations.g:2774:2: ( ruleXStringLiteral )
                    {
                    // InternalXbaseWithAnnotations.g:2774:2: ( ruleXStringLiteral )
                    // InternalXbaseWithAnnotations.g:2775:3: ruleXStringLiteral
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXLiteralAccess().getXStringLiteralParserRuleCall_5()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXStringLiteral();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXLiteralAccess().getXStringLiteralParserRuleCall_5()); 
                    }

                    }


                    }
                    break;
                case 7 :
                    // InternalXbaseWithAnnotations.g:2780:2: ( ruleXTypeLiteral )
                    {
                    // InternalXbaseWithAnnotations.g:2780:2: ( ruleXTypeLiteral )
                    // InternalXbaseWithAnnotations.g:2781:3: ruleXTypeLiteral
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXLiteralAccess().getXTypeLiteralParserRuleCall_6()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXTypeLiteral();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXLiteralAccess().getXTypeLiteralParserRuleCall_6()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XLiteral__Alternatives"


    // $ANTLR start "rule__XCollectionLiteral__Alternatives"
    // InternalXbaseWithAnnotations.g:2790:1: rule__XCollectionLiteral__Alternatives : ( ( ruleXSetLiteral ) | ( ruleXListLiteral ) );
    public final void rule__XCollectionLiteral__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2794:1: ( ( ruleXSetLiteral ) | ( ruleXListLiteral ) )
            int alt25=2;
            int LA25_0 = input.LA(1);

            if ( (LA25_0==56) ) {
                int LA25_1 = input.LA(2);

                if ( (LA25_1==60) ) {
                    alt25=1;
                }
                else if ( (LA25_1==57) ) {
                    alt25=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return ;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 25, 1, input);

                    throw nvae;
                }
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 25, 0, input);

                throw nvae;
            }
            switch (alt25) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2795:2: ( ruleXSetLiteral )
                    {
                    // InternalXbaseWithAnnotations.g:2795:2: ( ruleXSetLiteral )
                    // InternalXbaseWithAnnotations.g:2796:3: ruleXSetLiteral
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXCollectionLiteralAccess().getXSetLiteralParserRuleCall_0()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXSetLiteral();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXCollectionLiteralAccess().getXSetLiteralParserRuleCall_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2801:2: ( ruleXListLiteral )
                    {
                    // InternalXbaseWithAnnotations.g:2801:2: ( ruleXListLiteral )
                    // InternalXbaseWithAnnotations.g:2802:3: ruleXListLiteral
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXCollectionLiteralAccess().getXListLiteralParserRuleCall_1()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXListLiteral();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXCollectionLiteralAccess().getXListLiteralParserRuleCall_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCollectionLiteral__Alternatives"


    // $ANTLR start "rule__XSwitchExpression__Alternatives_2"
    // InternalXbaseWithAnnotations.g:2811:1: rule__XSwitchExpression__Alternatives_2 : ( ( ( rule__XSwitchExpression__Group_2_0__0 ) ) | ( ( rule__XSwitchExpression__Group_2_1__0 ) ) );
    public final void rule__XSwitchExpression__Alternatives_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2815:1: ( ( ( rule__XSwitchExpression__Group_2_0__0 ) ) | ( ( rule__XSwitchExpression__Group_2_1__0 ) ) )
            int alt26=2;
            alt26 = dfa26.predict(input);
            switch (alt26) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2816:2: ( ( rule__XSwitchExpression__Group_2_0__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2816:2: ( ( rule__XSwitchExpression__Group_2_0__0 ) )
                    // InternalXbaseWithAnnotations.g:2817:3: ( rule__XSwitchExpression__Group_2_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXSwitchExpressionAccess().getGroup_2_0()); 
                    }
                    // InternalXbaseWithAnnotations.g:2818:3: ( rule__XSwitchExpression__Group_2_0__0 )
                    // InternalXbaseWithAnnotations.g:2818:4: rule__XSwitchExpression__Group_2_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XSwitchExpression__Group_2_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXSwitchExpressionAccess().getGroup_2_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2822:2: ( ( rule__XSwitchExpression__Group_2_1__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2822:2: ( ( rule__XSwitchExpression__Group_2_1__0 ) )
                    // InternalXbaseWithAnnotations.g:2823:3: ( rule__XSwitchExpression__Group_2_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXSwitchExpressionAccess().getGroup_2_1()); 
                    }
                    // InternalXbaseWithAnnotations.g:2824:3: ( rule__XSwitchExpression__Group_2_1__0 )
                    // InternalXbaseWithAnnotations.g:2824:4: rule__XSwitchExpression__Group_2_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XSwitchExpression__Group_2_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXSwitchExpressionAccess().getGroup_2_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Alternatives_2"


    // $ANTLR start "rule__XCasePart__Alternatives_3"
    // InternalXbaseWithAnnotations.g:2832:1: rule__XCasePart__Alternatives_3 : ( ( ( rule__XCasePart__Group_3_0__0 ) ) | ( ( rule__XCasePart__FallThroughAssignment_3_1 ) ) );
    public final void rule__XCasePart__Alternatives_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2836:1: ( ( ( rule__XCasePart__Group_3_0__0 ) ) | ( ( rule__XCasePart__FallThroughAssignment_3_1 ) ) )
            int alt27=2;
            int LA27_0 = input.LA(1);

            if ( (LA27_0==66) ) {
                alt27=1;
            }
            else if ( (LA27_0==54) ) {
                alt27=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 27, 0, input);

                throw nvae;
            }
            switch (alt27) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2837:2: ( ( rule__XCasePart__Group_3_0__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2837:2: ( ( rule__XCasePart__Group_3_0__0 ) )
                    // InternalXbaseWithAnnotations.g:2838:3: ( rule__XCasePart__Group_3_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXCasePartAccess().getGroup_3_0()); 
                    }
                    // InternalXbaseWithAnnotations.g:2839:3: ( rule__XCasePart__Group_3_0__0 )
                    // InternalXbaseWithAnnotations.g:2839:4: rule__XCasePart__Group_3_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XCasePart__Group_3_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXCasePartAccess().getGroup_3_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2843:2: ( ( rule__XCasePart__FallThroughAssignment_3_1 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2843:2: ( ( rule__XCasePart__FallThroughAssignment_3_1 ) )
                    // InternalXbaseWithAnnotations.g:2844:3: ( rule__XCasePart__FallThroughAssignment_3_1 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXCasePartAccess().getFallThroughAssignment_3_1()); 
                    }
                    // InternalXbaseWithAnnotations.g:2845:3: ( rule__XCasePart__FallThroughAssignment_3_1 )
                    // InternalXbaseWithAnnotations.g:2845:4: rule__XCasePart__FallThroughAssignment_3_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XCasePart__FallThroughAssignment_3_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXCasePartAccess().getFallThroughAssignment_3_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Alternatives_3"


    // $ANTLR start "rule__XExpressionOrVarDeclaration__Alternatives"
    // InternalXbaseWithAnnotations.g:2853:1: rule__XExpressionOrVarDeclaration__Alternatives : ( ( ruleXVariableDeclaration ) | ( ruleXExpression ) );
    public final void rule__XExpressionOrVarDeclaration__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2857:1: ( ( ruleXVariableDeclaration ) | ( ruleXExpression ) )
            int alt28=2;
            int LA28_0 = input.LA(1);

            if ( (LA28_0==44||LA28_0==86) ) {
                alt28=1;
            }
            else if ( ((LA28_0>=RULE_ID && LA28_0<=RULE_STRING)||LA28_0==27||(LA28_0>=34 && LA28_0<=35)||LA28_0==40||(LA28_0>=45 && LA28_0<=50)||LA28_0==52||(LA28_0>=56 && LA28_0<=57)||LA28_0==60||LA28_0==63||LA28_0==65||(LA28_0>=69 && LA28_0<=77)||LA28_0==79||LA28_0==87) ) {
                alt28=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 28, 0, input);

                throw nvae;
            }
            switch (alt28) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2858:2: ( ruleXVariableDeclaration )
                    {
                    // InternalXbaseWithAnnotations.g:2858:2: ( ruleXVariableDeclaration )
                    // InternalXbaseWithAnnotations.g:2859:3: ruleXVariableDeclaration
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXExpressionOrVarDeclarationAccess().getXVariableDeclarationParserRuleCall_0()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXVariableDeclaration();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXExpressionOrVarDeclarationAccess().getXVariableDeclarationParserRuleCall_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2864:2: ( ruleXExpression )
                    {
                    // InternalXbaseWithAnnotations.g:2864:2: ( ruleXExpression )
                    // InternalXbaseWithAnnotations.g:2865:3: ruleXExpression
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXExpressionOrVarDeclarationAccess().getXExpressionParserRuleCall_1()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXExpression();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXExpressionOrVarDeclarationAccess().getXExpressionParserRuleCall_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XExpressionOrVarDeclaration__Alternatives"


    // $ANTLR start "rule__XVariableDeclaration__Alternatives_1"
    // InternalXbaseWithAnnotations.g:2874:1: rule__XVariableDeclaration__Alternatives_1 : ( ( ( rule__XVariableDeclaration__WriteableAssignment_1_0 ) ) | ( 'val' ) );
    public final void rule__XVariableDeclaration__Alternatives_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2878:1: ( ( ( rule__XVariableDeclaration__WriteableAssignment_1_0 ) ) | ( 'val' ) )
            int alt29=2;
            int LA29_0 = input.LA(1);

            if ( (LA29_0==86) ) {
                alt29=1;
            }
            else if ( (LA29_0==44) ) {
                alt29=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 29, 0, input);

                throw nvae;
            }
            switch (alt29) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2879:2: ( ( rule__XVariableDeclaration__WriteableAssignment_1_0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2879:2: ( ( rule__XVariableDeclaration__WriteableAssignment_1_0 ) )
                    // InternalXbaseWithAnnotations.g:2880:3: ( rule__XVariableDeclaration__WriteableAssignment_1_0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXVariableDeclarationAccess().getWriteableAssignment_1_0()); 
                    }
                    // InternalXbaseWithAnnotations.g:2881:3: ( rule__XVariableDeclaration__WriteableAssignment_1_0 )
                    // InternalXbaseWithAnnotations.g:2881:4: rule__XVariableDeclaration__WriteableAssignment_1_0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XVariableDeclaration__WriteableAssignment_1_0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXVariableDeclarationAccess().getWriteableAssignment_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2885:2: ( 'val' )
                    {
                    // InternalXbaseWithAnnotations.g:2885:2: ( 'val' )
                    // InternalXbaseWithAnnotations.g:2886:3: 'val'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXVariableDeclarationAccess().getValKeyword_1_1()); 
                    }
                    match(input,44,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXVariableDeclarationAccess().getValKeyword_1_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Alternatives_1"


    // $ANTLR start "rule__XVariableDeclaration__Alternatives_2"
    // InternalXbaseWithAnnotations.g:2895:1: rule__XVariableDeclaration__Alternatives_2 : ( ( ( rule__XVariableDeclaration__Group_2_0__0 ) ) | ( ( rule__XVariableDeclaration__NameAssignment_2_1 ) ) );
    public final void rule__XVariableDeclaration__Alternatives_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2899:1: ( ( ( rule__XVariableDeclaration__Group_2_0__0 ) ) | ( ( rule__XVariableDeclaration__NameAssignment_2_1 ) ) )
            int alt30=2;
            int LA30_0 = input.LA(1);

            if ( (LA30_0==RULE_ID) ) {
                int LA30_1 = input.LA(2);

                if ( (synpred69_InternalXbaseWithAnnotations()) ) {
                    alt30=1;
                }
                else if ( (true) ) {
                    alt30=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return ;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 30, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA30_0==31||LA30_0==52) ) {
                alt30=1;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 30, 0, input);

                throw nvae;
            }
            switch (alt30) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2900:2: ( ( rule__XVariableDeclaration__Group_2_0__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2900:2: ( ( rule__XVariableDeclaration__Group_2_0__0 ) )
                    // InternalXbaseWithAnnotations.g:2901:3: ( rule__XVariableDeclaration__Group_2_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXVariableDeclarationAccess().getGroup_2_0()); 
                    }
                    // InternalXbaseWithAnnotations.g:2902:3: ( rule__XVariableDeclaration__Group_2_0__0 )
                    // InternalXbaseWithAnnotations.g:2902:4: rule__XVariableDeclaration__Group_2_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XVariableDeclaration__Group_2_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXVariableDeclarationAccess().getGroup_2_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2906:2: ( ( rule__XVariableDeclaration__NameAssignment_2_1 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2906:2: ( ( rule__XVariableDeclaration__NameAssignment_2_1 ) )
                    // InternalXbaseWithAnnotations.g:2907:3: ( rule__XVariableDeclaration__NameAssignment_2_1 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXVariableDeclarationAccess().getNameAssignment_2_1()); 
                    }
                    // InternalXbaseWithAnnotations.g:2908:3: ( rule__XVariableDeclaration__NameAssignment_2_1 )
                    // InternalXbaseWithAnnotations.g:2908:4: rule__XVariableDeclaration__NameAssignment_2_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XVariableDeclaration__NameAssignment_2_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXVariableDeclarationAccess().getNameAssignment_2_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Alternatives_2"


    // $ANTLR start "rule__XFeatureCall__Alternatives_3_1"
    // InternalXbaseWithAnnotations.g:2916:1: rule__XFeatureCall__Alternatives_3_1 : ( ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 ) ) | ( ( rule__XFeatureCall__Group_3_1_1__0 ) ) );
    public final void rule__XFeatureCall__Alternatives_3_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2920:1: ( ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 ) ) | ( ( rule__XFeatureCall__Group_3_1_1__0 ) ) )
            int alt31=2;
            alt31 = dfa31.predict(input);
            switch (alt31) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2921:2: ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2921:2: ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 ) )
                    // InternalXbaseWithAnnotations.g:2922:3: ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsAssignment_3_1_0()); 
                    }
                    // InternalXbaseWithAnnotations.g:2923:3: ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 )
                    // InternalXbaseWithAnnotations.g:2923:4: rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsAssignment_3_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2927:2: ( ( rule__XFeatureCall__Group_3_1_1__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:2927:2: ( ( rule__XFeatureCall__Group_3_1_1__0 ) )
                    // InternalXbaseWithAnnotations.g:2928:3: ( rule__XFeatureCall__Group_3_1_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXFeatureCallAccess().getGroup_3_1_1()); 
                    }
                    // InternalXbaseWithAnnotations.g:2929:3: ( rule__XFeatureCall__Group_3_1_1__0 )
                    // InternalXbaseWithAnnotations.g:2929:4: rule__XFeatureCall__Group_3_1_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XFeatureCall__Group_3_1_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXFeatureCallAccess().getGroup_3_1_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Alternatives_3_1"


    // $ANTLR start "rule__FeatureCallID__Alternatives"
    // InternalXbaseWithAnnotations.g:2937:1: rule__FeatureCallID__Alternatives : ( ( ruleValidID ) | ( 'extends' ) | ( 'static' ) | ( 'import' ) | ( 'extension' ) );
    public final void rule__FeatureCallID__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2941:1: ( ( ruleValidID ) | ( 'extends' ) | ( 'static' ) | ( 'import' ) | ( 'extension' ) )
            int alt32=5;
            switch ( input.LA(1) ) {
            case RULE_ID:
                {
                alt32=1;
                }
                break;
            case 45:
                {
                alt32=2;
                }
                break;
            case 46:
                {
                alt32=3;
                }
                break;
            case 47:
                {
                alt32=4;
                }
                break;
            case 48:
                {
                alt32=5;
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 32, 0, input);

                throw nvae;
            }

            switch (alt32) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2942:2: ( ruleValidID )
                    {
                    // InternalXbaseWithAnnotations.g:2942:2: ( ruleValidID )
                    // InternalXbaseWithAnnotations.g:2943:3: ruleValidID
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getFeatureCallIDAccess().getValidIDParserRuleCall_0()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleValidID();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getFeatureCallIDAccess().getValidIDParserRuleCall_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2948:2: ( 'extends' )
                    {
                    // InternalXbaseWithAnnotations.g:2948:2: ( 'extends' )
                    // InternalXbaseWithAnnotations.g:2949:3: 'extends'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getFeatureCallIDAccess().getExtendsKeyword_1()); 
                    }
                    match(input,45,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getFeatureCallIDAccess().getExtendsKeyword_1()); 
                    }

                    }


                    }
                    break;
                case 3 :
                    // InternalXbaseWithAnnotations.g:2954:2: ( 'static' )
                    {
                    // InternalXbaseWithAnnotations.g:2954:2: ( 'static' )
                    // InternalXbaseWithAnnotations.g:2955:3: 'static'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getFeatureCallIDAccess().getStaticKeyword_2()); 
                    }
                    match(input,46,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getFeatureCallIDAccess().getStaticKeyword_2()); 
                    }

                    }


                    }
                    break;
                case 4 :
                    // InternalXbaseWithAnnotations.g:2960:2: ( 'import' )
                    {
                    // InternalXbaseWithAnnotations.g:2960:2: ( 'import' )
                    // InternalXbaseWithAnnotations.g:2961:3: 'import'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getFeatureCallIDAccess().getImportKeyword_3()); 
                    }
                    match(input,47,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getFeatureCallIDAccess().getImportKeyword_3()); 
                    }

                    }


                    }
                    break;
                case 5 :
                    // InternalXbaseWithAnnotations.g:2966:2: ( 'extension' )
                    {
                    // InternalXbaseWithAnnotations.g:2966:2: ( 'extension' )
                    // InternalXbaseWithAnnotations.g:2967:3: 'extension'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getFeatureCallIDAccess().getExtensionKeyword_4()); 
                    }
                    match(input,48,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getFeatureCallIDAccess().getExtensionKeyword_4()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FeatureCallID__Alternatives"


    // $ANTLR start "rule__IdOrSuper__Alternatives"
    // InternalXbaseWithAnnotations.g:2976:1: rule__IdOrSuper__Alternatives : ( ( ruleFeatureCallID ) | ( 'super' ) );
    public final void rule__IdOrSuper__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:2980:1: ( ( ruleFeatureCallID ) | ( 'super' ) )
            int alt33=2;
            int LA33_0 = input.LA(1);

            if ( (LA33_0==RULE_ID||(LA33_0>=45 && LA33_0<=48)) ) {
                alt33=1;
            }
            else if ( (LA33_0==49) ) {
                alt33=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 33, 0, input);

                throw nvae;
            }
            switch (alt33) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:2981:2: ( ruleFeatureCallID )
                    {
                    // InternalXbaseWithAnnotations.g:2981:2: ( ruleFeatureCallID )
                    // InternalXbaseWithAnnotations.g:2982:3: ruleFeatureCallID
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getIdOrSuperAccess().getFeatureCallIDParserRuleCall_0()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleFeatureCallID();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getIdOrSuperAccess().getFeatureCallIDParserRuleCall_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:2987:2: ( 'super' )
                    {
                    // InternalXbaseWithAnnotations.g:2987:2: ( 'super' )
                    // InternalXbaseWithAnnotations.g:2988:3: 'super'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getIdOrSuperAccess().getSuperKeyword_1()); 
                    }
                    match(input,49,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getIdOrSuperAccess().getSuperKeyword_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__IdOrSuper__Alternatives"


    // $ANTLR start "rule__XConstructorCall__Alternatives_4_1"
    // InternalXbaseWithAnnotations.g:2997:1: rule__XConstructorCall__Alternatives_4_1 : ( ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_0 ) ) | ( ( rule__XConstructorCall__Group_4_1_1__0 ) ) );
    public final void rule__XConstructorCall__Alternatives_4_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3001:1: ( ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_0 ) ) | ( ( rule__XConstructorCall__Group_4_1_1__0 ) ) )
            int alt34=2;
            alt34 = dfa34.predict(input);
            switch (alt34) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:3002:2: ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:3002:2: ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_0 ) )
                    // InternalXbaseWithAnnotations.g:3003:3: ( rule__XConstructorCall__ArgumentsAssignment_4_1_0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXConstructorCallAccess().getArgumentsAssignment_4_1_0()); 
                    }
                    // InternalXbaseWithAnnotations.g:3004:3: ( rule__XConstructorCall__ArgumentsAssignment_4_1_0 )
                    // InternalXbaseWithAnnotations.g:3004:4: rule__XConstructorCall__ArgumentsAssignment_4_1_0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XConstructorCall__ArgumentsAssignment_4_1_0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXConstructorCallAccess().getArgumentsAssignment_4_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:3008:2: ( ( rule__XConstructorCall__Group_4_1_1__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:3008:2: ( ( rule__XConstructorCall__Group_4_1_1__0 ) )
                    // InternalXbaseWithAnnotations.g:3009:3: ( rule__XConstructorCall__Group_4_1_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXConstructorCallAccess().getGroup_4_1_1()); 
                    }
                    // InternalXbaseWithAnnotations.g:3010:3: ( rule__XConstructorCall__Group_4_1_1__0 )
                    // InternalXbaseWithAnnotations.g:3010:4: rule__XConstructorCall__Group_4_1_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XConstructorCall__Group_4_1_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXConstructorCallAccess().getGroup_4_1_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Alternatives_4_1"


    // $ANTLR start "rule__XBooleanLiteral__Alternatives_1"
    // InternalXbaseWithAnnotations.g:3018:1: rule__XBooleanLiteral__Alternatives_1 : ( ( 'false' ) | ( ( rule__XBooleanLiteral__IsTrueAssignment_1_1 ) ) );
    public final void rule__XBooleanLiteral__Alternatives_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3022:1: ( ( 'false' ) | ( ( rule__XBooleanLiteral__IsTrueAssignment_1_1 ) ) )
            int alt35=2;
            int LA35_0 = input.LA(1);

            if ( (LA35_0==50) ) {
                alt35=1;
            }
            else if ( (LA35_0==87) ) {
                alt35=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 35, 0, input);

                throw nvae;
            }
            switch (alt35) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:3023:2: ( 'false' )
                    {
                    // InternalXbaseWithAnnotations.g:3023:2: ( 'false' )
                    // InternalXbaseWithAnnotations.g:3024:3: 'false'
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXBooleanLiteralAccess().getFalseKeyword_1_0()); 
                    }
                    match(input,50,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXBooleanLiteralAccess().getFalseKeyword_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:3029:2: ( ( rule__XBooleanLiteral__IsTrueAssignment_1_1 ) )
                    {
                    // InternalXbaseWithAnnotations.g:3029:2: ( ( rule__XBooleanLiteral__IsTrueAssignment_1_1 ) )
                    // InternalXbaseWithAnnotations.g:3030:3: ( rule__XBooleanLiteral__IsTrueAssignment_1_1 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXBooleanLiteralAccess().getIsTrueAssignment_1_1()); 
                    }
                    // InternalXbaseWithAnnotations.g:3031:3: ( rule__XBooleanLiteral__IsTrueAssignment_1_1 )
                    // InternalXbaseWithAnnotations.g:3031:4: rule__XBooleanLiteral__IsTrueAssignment_1_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XBooleanLiteral__IsTrueAssignment_1_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXBooleanLiteralAccess().getIsTrueAssignment_1_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBooleanLiteral__Alternatives_1"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Alternatives_3"
    // InternalXbaseWithAnnotations.g:3039:1: rule__XTryCatchFinallyExpression__Alternatives_3 : ( ( ( rule__XTryCatchFinallyExpression__Group_3_0__0 ) ) | ( ( rule__XTryCatchFinallyExpression__Group_3_1__0 ) ) );
    public final void rule__XTryCatchFinallyExpression__Alternatives_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3043:1: ( ( ( rule__XTryCatchFinallyExpression__Group_3_0__0 ) ) | ( ( rule__XTryCatchFinallyExpression__Group_3_1__0 ) ) )
            int alt36=2;
            int LA36_0 = input.LA(1);

            if ( (LA36_0==80) ) {
                alt36=1;
            }
            else if ( (LA36_0==78) ) {
                alt36=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 36, 0, input);

                throw nvae;
            }
            switch (alt36) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:3044:2: ( ( rule__XTryCatchFinallyExpression__Group_3_0__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:3044:2: ( ( rule__XTryCatchFinallyExpression__Group_3_0__0 ) )
                    // InternalXbaseWithAnnotations.g:3045:3: ( rule__XTryCatchFinallyExpression__Group_3_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_3_0()); 
                    }
                    // InternalXbaseWithAnnotations.g:3046:3: ( rule__XTryCatchFinallyExpression__Group_3_0__0 )
                    // InternalXbaseWithAnnotations.g:3046:4: rule__XTryCatchFinallyExpression__Group_3_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XTryCatchFinallyExpression__Group_3_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_3_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:3050:2: ( ( rule__XTryCatchFinallyExpression__Group_3_1__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:3050:2: ( ( rule__XTryCatchFinallyExpression__Group_3_1__0 ) )
                    // InternalXbaseWithAnnotations.g:3051:3: ( rule__XTryCatchFinallyExpression__Group_3_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_3_1()); 
                    }
                    // InternalXbaseWithAnnotations.g:3052:3: ( rule__XTryCatchFinallyExpression__Group_3_1__0 )
                    // InternalXbaseWithAnnotations.g:3052:4: rule__XTryCatchFinallyExpression__Group_3_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XTryCatchFinallyExpression__Group_3_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_3_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Alternatives_3"


    // $ANTLR start "rule__Number__Alternatives"
    // InternalXbaseWithAnnotations.g:3060:1: rule__Number__Alternatives : ( ( RULE_HEX ) | ( ( rule__Number__Group_1__0 ) ) );
    public final void rule__Number__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3064:1: ( ( RULE_HEX ) | ( ( rule__Number__Group_1__0 ) ) )
            int alt37=2;
            int LA37_0 = input.LA(1);

            if ( (LA37_0==RULE_HEX) ) {
                alt37=1;
            }
            else if ( ((LA37_0>=RULE_INT && LA37_0<=RULE_DECIMAL)) ) {
                alt37=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 37, 0, input);

                throw nvae;
            }
            switch (alt37) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:3065:2: ( RULE_HEX )
                    {
                    // InternalXbaseWithAnnotations.g:3065:2: ( RULE_HEX )
                    // InternalXbaseWithAnnotations.g:3066:3: RULE_HEX
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getNumberAccess().getHEXTerminalRuleCall_0()); 
                    }
                    match(input,RULE_HEX,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getNumberAccess().getHEXTerminalRuleCall_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:3071:2: ( ( rule__Number__Group_1__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:3071:2: ( ( rule__Number__Group_1__0 ) )
                    // InternalXbaseWithAnnotations.g:3072:3: ( rule__Number__Group_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getNumberAccess().getGroup_1()); 
                    }
                    // InternalXbaseWithAnnotations.g:3073:3: ( rule__Number__Group_1__0 )
                    // InternalXbaseWithAnnotations.g:3073:4: rule__Number__Group_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Number__Group_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getNumberAccess().getGroup_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Number__Alternatives"


    // $ANTLR start "rule__Number__Alternatives_1_0"
    // InternalXbaseWithAnnotations.g:3081:1: rule__Number__Alternatives_1_0 : ( ( RULE_INT ) | ( RULE_DECIMAL ) );
    public final void rule__Number__Alternatives_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3085:1: ( ( RULE_INT ) | ( RULE_DECIMAL ) )
            int alt38=2;
            int LA38_0 = input.LA(1);

            if ( (LA38_0==RULE_INT) ) {
                alt38=1;
            }
            else if ( (LA38_0==RULE_DECIMAL) ) {
                alt38=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 38, 0, input);

                throw nvae;
            }
            switch (alt38) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:3086:2: ( RULE_INT )
                    {
                    // InternalXbaseWithAnnotations.g:3086:2: ( RULE_INT )
                    // InternalXbaseWithAnnotations.g:3087:3: RULE_INT
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getNumberAccess().getINTTerminalRuleCall_1_0_0()); 
                    }
                    match(input,RULE_INT,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getNumberAccess().getINTTerminalRuleCall_1_0_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:3092:2: ( RULE_DECIMAL )
                    {
                    // InternalXbaseWithAnnotations.g:3092:2: ( RULE_DECIMAL )
                    // InternalXbaseWithAnnotations.g:3093:3: RULE_DECIMAL
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getNumberAccess().getDECIMALTerminalRuleCall_1_0_1()); 
                    }
                    match(input,RULE_DECIMAL,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getNumberAccess().getDECIMALTerminalRuleCall_1_0_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Number__Alternatives_1_0"


    // $ANTLR start "rule__Number__Alternatives_1_1_1"
    // InternalXbaseWithAnnotations.g:3102:1: rule__Number__Alternatives_1_1_1 : ( ( RULE_INT ) | ( RULE_DECIMAL ) );
    public final void rule__Number__Alternatives_1_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3106:1: ( ( RULE_INT ) | ( RULE_DECIMAL ) )
            int alt39=2;
            int LA39_0 = input.LA(1);

            if ( (LA39_0==RULE_INT) ) {
                alt39=1;
            }
            else if ( (LA39_0==RULE_DECIMAL) ) {
                alt39=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 39, 0, input);

                throw nvae;
            }
            switch (alt39) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:3107:2: ( RULE_INT )
                    {
                    // InternalXbaseWithAnnotations.g:3107:2: ( RULE_INT )
                    // InternalXbaseWithAnnotations.g:3108:3: RULE_INT
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getNumberAccess().getINTTerminalRuleCall_1_1_1_0()); 
                    }
                    match(input,RULE_INT,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getNumberAccess().getINTTerminalRuleCall_1_1_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:3113:2: ( RULE_DECIMAL )
                    {
                    // InternalXbaseWithAnnotations.g:3113:2: ( RULE_DECIMAL )
                    // InternalXbaseWithAnnotations.g:3114:3: RULE_DECIMAL
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getNumberAccess().getDECIMALTerminalRuleCall_1_1_1_1()); 
                    }
                    match(input,RULE_DECIMAL,FOLLOW_2); if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getNumberAccess().getDECIMALTerminalRuleCall_1_1_1_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Number__Alternatives_1_1_1"


    // $ANTLR start "rule__JvmTypeReference__Alternatives"
    // InternalXbaseWithAnnotations.g:3123:1: rule__JvmTypeReference__Alternatives : ( ( ( rule__JvmTypeReference__Group_0__0 ) ) | ( ruleXFunctionTypeRef ) );
    public final void rule__JvmTypeReference__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3127:1: ( ( ( rule__JvmTypeReference__Group_0__0 ) ) | ( ruleXFunctionTypeRef ) )
            int alt40=2;
            int LA40_0 = input.LA(1);

            if ( (LA40_0==RULE_ID) ) {
                alt40=1;
            }
            else if ( (LA40_0==31||LA40_0==52) ) {
                alt40=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 40, 0, input);

                throw nvae;
            }
            switch (alt40) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:3128:2: ( ( rule__JvmTypeReference__Group_0__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:3128:2: ( ( rule__JvmTypeReference__Group_0__0 ) )
                    // InternalXbaseWithAnnotations.g:3129:3: ( rule__JvmTypeReference__Group_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getJvmTypeReferenceAccess().getGroup_0()); 
                    }
                    // InternalXbaseWithAnnotations.g:3130:3: ( rule__JvmTypeReference__Group_0__0 )
                    // InternalXbaseWithAnnotations.g:3130:4: rule__JvmTypeReference__Group_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__JvmTypeReference__Group_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getJvmTypeReferenceAccess().getGroup_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:3134:2: ( ruleXFunctionTypeRef )
                    {
                    // InternalXbaseWithAnnotations.g:3134:2: ( ruleXFunctionTypeRef )
                    // InternalXbaseWithAnnotations.g:3135:3: ruleXFunctionTypeRef
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getJvmTypeReferenceAccess().getXFunctionTypeRefParserRuleCall_1()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleXFunctionTypeRef();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getJvmTypeReferenceAccess().getXFunctionTypeRefParserRuleCall_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmTypeReference__Alternatives"


    // $ANTLR start "rule__JvmArgumentTypeReference__Alternatives"
    // InternalXbaseWithAnnotations.g:3144:1: rule__JvmArgumentTypeReference__Alternatives : ( ( ruleJvmTypeReference ) | ( ruleJvmWildcardTypeReference ) );
    public final void rule__JvmArgumentTypeReference__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3148:1: ( ( ruleJvmTypeReference ) | ( ruleJvmWildcardTypeReference ) )
            int alt41=2;
            int LA41_0 = input.LA(1);

            if ( (LA41_0==RULE_ID||LA41_0==31||LA41_0==52) ) {
                alt41=1;
            }
            else if ( (LA41_0==81) ) {
                alt41=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 41, 0, input);

                throw nvae;
            }
            switch (alt41) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:3149:2: ( ruleJvmTypeReference )
                    {
                    // InternalXbaseWithAnnotations.g:3149:2: ( ruleJvmTypeReference )
                    // InternalXbaseWithAnnotations.g:3150:3: ruleJvmTypeReference
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getJvmArgumentTypeReferenceAccess().getJvmTypeReferenceParserRuleCall_0()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleJvmTypeReference();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getJvmArgumentTypeReferenceAccess().getJvmTypeReferenceParserRuleCall_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:3155:2: ( ruleJvmWildcardTypeReference )
                    {
                    // InternalXbaseWithAnnotations.g:3155:2: ( ruleJvmWildcardTypeReference )
                    // InternalXbaseWithAnnotations.g:3156:3: ruleJvmWildcardTypeReference
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getJvmArgumentTypeReferenceAccess().getJvmWildcardTypeReferenceParserRuleCall_1()); 
                    }
                    pushFollow(FOLLOW_2);
                    ruleJvmWildcardTypeReference();

                    state._fsp--;
                    if (state.failed) return ;
                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getJvmArgumentTypeReferenceAccess().getJvmWildcardTypeReferenceParserRuleCall_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmArgumentTypeReference__Alternatives"


    // $ANTLR start "rule__JvmWildcardTypeReference__Alternatives_2"
    // InternalXbaseWithAnnotations.g:3165:1: rule__JvmWildcardTypeReference__Alternatives_2 : ( ( ( rule__JvmWildcardTypeReference__Group_2_0__0 ) ) | ( ( rule__JvmWildcardTypeReference__Group_2_1__0 ) ) );
    public final void rule__JvmWildcardTypeReference__Alternatives_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3169:1: ( ( ( rule__JvmWildcardTypeReference__Group_2_0__0 ) ) | ( ( rule__JvmWildcardTypeReference__Group_2_1__0 ) ) )
            int alt42=2;
            int LA42_0 = input.LA(1);

            if ( (LA42_0==45) ) {
                alt42=1;
            }
            else if ( (LA42_0==49) ) {
                alt42=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 42, 0, input);

                throw nvae;
            }
            switch (alt42) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:3170:2: ( ( rule__JvmWildcardTypeReference__Group_2_0__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:3170:2: ( ( rule__JvmWildcardTypeReference__Group_2_0__0 ) )
                    // InternalXbaseWithAnnotations.g:3171:3: ( rule__JvmWildcardTypeReference__Group_2_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getJvmWildcardTypeReferenceAccess().getGroup_2_0()); 
                    }
                    // InternalXbaseWithAnnotations.g:3172:3: ( rule__JvmWildcardTypeReference__Group_2_0__0 )
                    // InternalXbaseWithAnnotations.g:3172:4: rule__JvmWildcardTypeReference__Group_2_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__JvmWildcardTypeReference__Group_2_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getJvmWildcardTypeReferenceAccess().getGroup_2_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:3176:2: ( ( rule__JvmWildcardTypeReference__Group_2_1__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:3176:2: ( ( rule__JvmWildcardTypeReference__Group_2_1__0 ) )
                    // InternalXbaseWithAnnotations.g:3177:3: ( rule__JvmWildcardTypeReference__Group_2_1__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getJvmWildcardTypeReferenceAccess().getGroup_2_1()); 
                    }
                    // InternalXbaseWithAnnotations.g:3178:3: ( rule__JvmWildcardTypeReference__Group_2_1__0 )
                    // InternalXbaseWithAnnotations.g:3178:4: rule__JvmWildcardTypeReference__Group_2_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__JvmWildcardTypeReference__Group_2_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getJvmWildcardTypeReferenceAccess().getGroup_2_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Alternatives_2"


    // $ANTLR start "rule__XImportDeclaration__Alternatives_1"
    // InternalXbaseWithAnnotations.g:3186:1: rule__XImportDeclaration__Alternatives_1 : ( ( ( rule__XImportDeclaration__Group_1_0__0 ) ) | ( ( rule__XImportDeclaration__ImportedTypeAssignment_1_1 ) ) | ( ( rule__XImportDeclaration__ImportedNamespaceAssignment_1_2 ) ) );
    public final void rule__XImportDeclaration__Alternatives_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3190:1: ( ( ( rule__XImportDeclaration__Group_1_0__0 ) ) | ( ( rule__XImportDeclaration__ImportedTypeAssignment_1_1 ) ) | ( ( rule__XImportDeclaration__ImportedNamespaceAssignment_1_2 ) ) )
            int alt43=3;
            alt43 = dfa43.predict(input);
            switch (alt43) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:3191:2: ( ( rule__XImportDeclaration__Group_1_0__0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:3191:2: ( ( rule__XImportDeclaration__Group_1_0__0 ) )
                    // InternalXbaseWithAnnotations.g:3192:3: ( rule__XImportDeclaration__Group_1_0__0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXImportDeclarationAccess().getGroup_1_0()); 
                    }
                    // InternalXbaseWithAnnotations.g:3193:3: ( rule__XImportDeclaration__Group_1_0__0 )
                    // InternalXbaseWithAnnotations.g:3193:4: rule__XImportDeclaration__Group_1_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XImportDeclaration__Group_1_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXImportDeclarationAccess().getGroup_1_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:3197:2: ( ( rule__XImportDeclaration__ImportedTypeAssignment_1_1 ) )
                    {
                    // InternalXbaseWithAnnotations.g:3197:2: ( ( rule__XImportDeclaration__ImportedTypeAssignment_1_1 ) )
                    // InternalXbaseWithAnnotations.g:3198:3: ( rule__XImportDeclaration__ImportedTypeAssignment_1_1 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXImportDeclarationAccess().getImportedTypeAssignment_1_1()); 
                    }
                    // InternalXbaseWithAnnotations.g:3199:3: ( rule__XImportDeclaration__ImportedTypeAssignment_1_1 )
                    // InternalXbaseWithAnnotations.g:3199:4: rule__XImportDeclaration__ImportedTypeAssignment_1_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XImportDeclaration__ImportedTypeAssignment_1_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXImportDeclarationAccess().getImportedTypeAssignment_1_1()); 
                    }

                    }


                    }
                    break;
                case 3 :
                    // InternalXbaseWithAnnotations.g:3203:2: ( ( rule__XImportDeclaration__ImportedNamespaceAssignment_1_2 ) )
                    {
                    // InternalXbaseWithAnnotations.g:3203:2: ( ( rule__XImportDeclaration__ImportedNamespaceAssignment_1_2 ) )
                    // InternalXbaseWithAnnotations.g:3204:3: ( rule__XImportDeclaration__ImportedNamespaceAssignment_1_2 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXImportDeclarationAccess().getImportedNamespaceAssignment_1_2()); 
                    }
                    // InternalXbaseWithAnnotations.g:3205:3: ( rule__XImportDeclaration__ImportedNamespaceAssignment_1_2 )
                    // InternalXbaseWithAnnotations.g:3205:4: rule__XImportDeclaration__ImportedNamespaceAssignment_1_2
                    {
                    pushFollow(FOLLOW_2);
                    rule__XImportDeclaration__ImportedNamespaceAssignment_1_2();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXImportDeclarationAccess().getImportedNamespaceAssignment_1_2()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Alternatives_1"


    // $ANTLR start "rule__XImportDeclaration__Alternatives_1_0_3"
    // InternalXbaseWithAnnotations.g:3213:1: rule__XImportDeclaration__Alternatives_1_0_3 : ( ( ( rule__XImportDeclaration__WildcardAssignment_1_0_3_0 ) ) | ( ( rule__XImportDeclaration__MemberNameAssignment_1_0_3_1 ) ) );
    public final void rule__XImportDeclaration__Alternatives_1_0_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3217:1: ( ( ( rule__XImportDeclaration__WildcardAssignment_1_0_3_0 ) ) | ( ( rule__XImportDeclaration__MemberNameAssignment_1_0_3_1 ) ) )
            int alt44=2;
            int LA44_0 = input.LA(1);

            if ( (LA44_0==36) ) {
                alt44=1;
            }
            else if ( (LA44_0==RULE_ID) ) {
                alt44=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return ;}
                NoViableAltException nvae =
                    new NoViableAltException("", 44, 0, input);

                throw nvae;
            }
            switch (alt44) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:3218:2: ( ( rule__XImportDeclaration__WildcardAssignment_1_0_3_0 ) )
                    {
                    // InternalXbaseWithAnnotations.g:3218:2: ( ( rule__XImportDeclaration__WildcardAssignment_1_0_3_0 ) )
                    // InternalXbaseWithAnnotations.g:3219:3: ( rule__XImportDeclaration__WildcardAssignment_1_0_3_0 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXImportDeclarationAccess().getWildcardAssignment_1_0_3_0()); 
                    }
                    // InternalXbaseWithAnnotations.g:3220:3: ( rule__XImportDeclaration__WildcardAssignment_1_0_3_0 )
                    // InternalXbaseWithAnnotations.g:3220:4: rule__XImportDeclaration__WildcardAssignment_1_0_3_0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XImportDeclaration__WildcardAssignment_1_0_3_0();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXImportDeclarationAccess().getWildcardAssignment_1_0_3_0()); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalXbaseWithAnnotations.g:3224:2: ( ( rule__XImportDeclaration__MemberNameAssignment_1_0_3_1 ) )
                    {
                    // InternalXbaseWithAnnotations.g:3224:2: ( ( rule__XImportDeclaration__MemberNameAssignment_1_0_3_1 ) )
                    // InternalXbaseWithAnnotations.g:3225:3: ( rule__XImportDeclaration__MemberNameAssignment_1_0_3_1 )
                    {
                    if ( state.backtracking==0 ) {
                       before(grammarAccess.getXImportDeclarationAccess().getMemberNameAssignment_1_0_3_1()); 
                    }
                    // InternalXbaseWithAnnotations.g:3226:3: ( rule__XImportDeclaration__MemberNameAssignment_1_0_3_1 )
                    // InternalXbaseWithAnnotations.g:3226:4: rule__XImportDeclaration__MemberNameAssignment_1_0_3_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XImportDeclaration__MemberNameAssignment_1_0_3_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }

                    if ( state.backtracking==0 ) {
                       after(grammarAccess.getXImportDeclarationAccess().getMemberNameAssignment_1_0_3_1()); 
                    }

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Alternatives_1_0_3"


    // $ANTLR start "rule__XAnnotation__Group__0"
    // InternalXbaseWithAnnotations.g:3234:1: rule__XAnnotation__Group__0 : rule__XAnnotation__Group__0__Impl rule__XAnnotation__Group__1 ;
    public final void rule__XAnnotation__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3238:1: ( rule__XAnnotation__Group__0__Impl rule__XAnnotation__Group__1 )
            // InternalXbaseWithAnnotations.g:3239:2: rule__XAnnotation__Group__0__Impl rule__XAnnotation__Group__1
            {
            pushFollow(FOLLOW_4);
            rule__XAnnotation__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAnnotation__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__Group__0"


    // $ANTLR start "rule__XAnnotation__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:3246:1: rule__XAnnotation__Group__0__Impl : ( () ) ;
    public final void rule__XAnnotation__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3250:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:3251:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:3251:1: ( () )
            // InternalXbaseWithAnnotations.g:3252:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationAccess().getXAnnotationAction_0()); 
            }
            // InternalXbaseWithAnnotations.g:3253:2: ()
            // InternalXbaseWithAnnotations.g:3253:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationAccess().getXAnnotationAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__Group__0__Impl"


    // $ANTLR start "rule__XAnnotation__Group__1"
    // InternalXbaseWithAnnotations.g:3261:1: rule__XAnnotation__Group__1 : rule__XAnnotation__Group__1__Impl rule__XAnnotation__Group__2 ;
    public final void rule__XAnnotation__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3265:1: ( rule__XAnnotation__Group__1__Impl rule__XAnnotation__Group__2 )
            // InternalXbaseWithAnnotations.g:3266:2: rule__XAnnotation__Group__1__Impl rule__XAnnotation__Group__2
            {
            pushFollow(FOLLOW_5);
            rule__XAnnotation__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAnnotation__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__Group__1"


    // $ANTLR start "rule__XAnnotation__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:3273:1: rule__XAnnotation__Group__1__Impl : ( '@' ) ;
    public final void rule__XAnnotation__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3277:1: ( ( '@' ) )
            // InternalXbaseWithAnnotations.g:3278:1: ( '@' )
            {
            // InternalXbaseWithAnnotations.g:3278:1: ( '@' )
            // InternalXbaseWithAnnotations.g:3279:2: '@'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationAccess().getCommercialAtKeyword_1()); 
            }
            match(input,51,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationAccess().getCommercialAtKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__Group__1__Impl"


    // $ANTLR start "rule__XAnnotation__Group__2"
    // InternalXbaseWithAnnotations.g:3288:1: rule__XAnnotation__Group__2 : rule__XAnnotation__Group__2__Impl rule__XAnnotation__Group__3 ;
    public final void rule__XAnnotation__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3292:1: ( rule__XAnnotation__Group__2__Impl rule__XAnnotation__Group__3 )
            // InternalXbaseWithAnnotations.g:3293:2: rule__XAnnotation__Group__2__Impl rule__XAnnotation__Group__3
            {
            pushFollow(FOLLOW_6);
            rule__XAnnotation__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAnnotation__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__Group__2"


    // $ANTLR start "rule__XAnnotation__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:3300:1: rule__XAnnotation__Group__2__Impl : ( ( rule__XAnnotation__AnnotationTypeAssignment_2 ) ) ;
    public final void rule__XAnnotation__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3304:1: ( ( ( rule__XAnnotation__AnnotationTypeAssignment_2 ) ) )
            // InternalXbaseWithAnnotations.g:3305:1: ( ( rule__XAnnotation__AnnotationTypeAssignment_2 ) )
            {
            // InternalXbaseWithAnnotations.g:3305:1: ( ( rule__XAnnotation__AnnotationTypeAssignment_2 ) )
            // InternalXbaseWithAnnotations.g:3306:2: ( rule__XAnnotation__AnnotationTypeAssignment_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationAccess().getAnnotationTypeAssignment_2()); 
            }
            // InternalXbaseWithAnnotations.g:3307:2: ( rule__XAnnotation__AnnotationTypeAssignment_2 )
            // InternalXbaseWithAnnotations.g:3307:3: rule__XAnnotation__AnnotationTypeAssignment_2
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotation__AnnotationTypeAssignment_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationAccess().getAnnotationTypeAssignment_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__Group__2__Impl"


    // $ANTLR start "rule__XAnnotation__Group__3"
    // InternalXbaseWithAnnotations.g:3315:1: rule__XAnnotation__Group__3 : rule__XAnnotation__Group__3__Impl ;
    public final void rule__XAnnotation__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3319:1: ( rule__XAnnotation__Group__3__Impl )
            // InternalXbaseWithAnnotations.g:3320:2: rule__XAnnotation__Group__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotation__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__Group__3"


    // $ANTLR start "rule__XAnnotation__Group__3__Impl"
    // InternalXbaseWithAnnotations.g:3326:1: rule__XAnnotation__Group__3__Impl : ( ( rule__XAnnotation__Group_3__0 )? ) ;
    public final void rule__XAnnotation__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3330:1: ( ( ( rule__XAnnotation__Group_3__0 )? ) )
            // InternalXbaseWithAnnotations.g:3331:1: ( ( rule__XAnnotation__Group_3__0 )? )
            {
            // InternalXbaseWithAnnotations.g:3331:1: ( ( rule__XAnnotation__Group_3__0 )? )
            // InternalXbaseWithAnnotations.g:3332:2: ( rule__XAnnotation__Group_3__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationAccess().getGroup_3()); 
            }
            // InternalXbaseWithAnnotations.g:3333:2: ( rule__XAnnotation__Group_3__0 )?
            int alt45=2;
            int LA45_0 = input.LA(1);

            if ( (LA45_0==52) ) {
                alt45=1;
            }
            switch (alt45) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:3333:3: rule__XAnnotation__Group_3__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XAnnotation__Group_3__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationAccess().getGroup_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__Group__3__Impl"


    // $ANTLR start "rule__XAnnotation__Group_3__0"
    // InternalXbaseWithAnnotations.g:3342:1: rule__XAnnotation__Group_3__0 : rule__XAnnotation__Group_3__0__Impl rule__XAnnotation__Group_3__1 ;
    public final void rule__XAnnotation__Group_3__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3346:1: ( rule__XAnnotation__Group_3__0__Impl rule__XAnnotation__Group_3__1 )
            // InternalXbaseWithAnnotations.g:3347:2: rule__XAnnotation__Group_3__0__Impl rule__XAnnotation__Group_3__1
            {
            pushFollow(FOLLOW_7);
            rule__XAnnotation__Group_3__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAnnotation__Group_3__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__Group_3__0"


    // $ANTLR start "rule__XAnnotation__Group_3__0__Impl"
    // InternalXbaseWithAnnotations.g:3354:1: rule__XAnnotation__Group_3__0__Impl : ( ( '(' ) ) ;
    public final void rule__XAnnotation__Group_3__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3358:1: ( ( ( '(' ) ) )
            // InternalXbaseWithAnnotations.g:3359:1: ( ( '(' ) )
            {
            // InternalXbaseWithAnnotations.g:3359:1: ( ( '(' ) )
            // InternalXbaseWithAnnotations.g:3360:2: ( '(' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationAccess().getLeftParenthesisKeyword_3_0()); 
            }
            // InternalXbaseWithAnnotations.g:3361:2: ( '(' )
            // InternalXbaseWithAnnotations.g:3361:3: '('
            {
            match(input,52,FOLLOW_2); if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationAccess().getLeftParenthesisKeyword_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__Group_3__0__Impl"


    // $ANTLR start "rule__XAnnotation__Group_3__1"
    // InternalXbaseWithAnnotations.g:3369:1: rule__XAnnotation__Group_3__1 : rule__XAnnotation__Group_3__1__Impl rule__XAnnotation__Group_3__2 ;
    public final void rule__XAnnotation__Group_3__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3373:1: ( rule__XAnnotation__Group_3__1__Impl rule__XAnnotation__Group_3__2 )
            // InternalXbaseWithAnnotations.g:3374:2: rule__XAnnotation__Group_3__1__Impl rule__XAnnotation__Group_3__2
            {
            pushFollow(FOLLOW_7);
            rule__XAnnotation__Group_3__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAnnotation__Group_3__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__Group_3__1"


    // $ANTLR start "rule__XAnnotation__Group_3__1__Impl"
    // InternalXbaseWithAnnotations.g:3381:1: rule__XAnnotation__Group_3__1__Impl : ( ( rule__XAnnotation__Alternatives_3_1 )? ) ;
    public final void rule__XAnnotation__Group_3__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3385:1: ( ( ( rule__XAnnotation__Alternatives_3_1 )? ) )
            // InternalXbaseWithAnnotations.g:3386:1: ( ( rule__XAnnotation__Alternatives_3_1 )? )
            {
            // InternalXbaseWithAnnotations.g:3386:1: ( ( rule__XAnnotation__Alternatives_3_1 )? )
            // InternalXbaseWithAnnotations.g:3387:2: ( rule__XAnnotation__Alternatives_3_1 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationAccess().getAlternatives_3_1()); 
            }
            // InternalXbaseWithAnnotations.g:3388:2: ( rule__XAnnotation__Alternatives_3_1 )?
            int alt46=2;
            int LA46_0 = input.LA(1);

            if ( ((LA46_0>=RULE_ID && LA46_0<=RULE_STRING)||LA46_0==27||(LA46_0>=34 && LA46_0<=35)||LA46_0==40||(LA46_0>=45 && LA46_0<=52)||(LA46_0>=56 && LA46_0<=57)||LA46_0==60||LA46_0==63||LA46_0==65||(LA46_0>=69 && LA46_0<=77)||LA46_0==79||LA46_0==87) ) {
                alt46=1;
            }
            switch (alt46) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:3388:3: rule__XAnnotation__Alternatives_3_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XAnnotation__Alternatives_3_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationAccess().getAlternatives_3_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__Group_3__1__Impl"


    // $ANTLR start "rule__XAnnotation__Group_3__2"
    // InternalXbaseWithAnnotations.g:3396:1: rule__XAnnotation__Group_3__2 : rule__XAnnotation__Group_3__2__Impl ;
    public final void rule__XAnnotation__Group_3__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3400:1: ( rule__XAnnotation__Group_3__2__Impl )
            // InternalXbaseWithAnnotations.g:3401:2: rule__XAnnotation__Group_3__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotation__Group_3__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__Group_3__2"


    // $ANTLR start "rule__XAnnotation__Group_3__2__Impl"
    // InternalXbaseWithAnnotations.g:3407:1: rule__XAnnotation__Group_3__2__Impl : ( ')' ) ;
    public final void rule__XAnnotation__Group_3__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3411:1: ( ( ')' ) )
            // InternalXbaseWithAnnotations.g:3412:1: ( ')' )
            {
            // InternalXbaseWithAnnotations.g:3412:1: ( ')' )
            // InternalXbaseWithAnnotations.g:3413:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationAccess().getRightParenthesisKeyword_3_2()); 
            }
            match(input,53,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationAccess().getRightParenthesisKeyword_3_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__Group_3__2__Impl"


    // $ANTLR start "rule__XAnnotation__Group_3_1_0__0"
    // InternalXbaseWithAnnotations.g:3423:1: rule__XAnnotation__Group_3_1_0__0 : rule__XAnnotation__Group_3_1_0__0__Impl rule__XAnnotation__Group_3_1_0__1 ;
    public final void rule__XAnnotation__Group_3_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3427:1: ( rule__XAnnotation__Group_3_1_0__0__Impl rule__XAnnotation__Group_3_1_0__1 )
            // InternalXbaseWithAnnotations.g:3428:2: rule__XAnnotation__Group_3_1_0__0__Impl rule__XAnnotation__Group_3_1_0__1
            {
            pushFollow(FOLLOW_8);
            rule__XAnnotation__Group_3_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAnnotation__Group_3_1_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__Group_3_1_0__0"


    // $ANTLR start "rule__XAnnotation__Group_3_1_0__0__Impl"
    // InternalXbaseWithAnnotations.g:3435:1: rule__XAnnotation__Group_3_1_0__0__Impl : ( ( rule__XAnnotation__ElementValuePairsAssignment_3_1_0_0 ) ) ;
    public final void rule__XAnnotation__Group_3_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3439:1: ( ( ( rule__XAnnotation__ElementValuePairsAssignment_3_1_0_0 ) ) )
            // InternalXbaseWithAnnotations.g:3440:1: ( ( rule__XAnnotation__ElementValuePairsAssignment_3_1_0_0 ) )
            {
            // InternalXbaseWithAnnotations.g:3440:1: ( ( rule__XAnnotation__ElementValuePairsAssignment_3_1_0_0 ) )
            // InternalXbaseWithAnnotations.g:3441:2: ( rule__XAnnotation__ElementValuePairsAssignment_3_1_0_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationAccess().getElementValuePairsAssignment_3_1_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:3442:2: ( rule__XAnnotation__ElementValuePairsAssignment_3_1_0_0 )
            // InternalXbaseWithAnnotations.g:3442:3: rule__XAnnotation__ElementValuePairsAssignment_3_1_0_0
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotation__ElementValuePairsAssignment_3_1_0_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationAccess().getElementValuePairsAssignment_3_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__Group_3_1_0__0__Impl"


    // $ANTLR start "rule__XAnnotation__Group_3_1_0__1"
    // InternalXbaseWithAnnotations.g:3450:1: rule__XAnnotation__Group_3_1_0__1 : rule__XAnnotation__Group_3_1_0__1__Impl ;
    public final void rule__XAnnotation__Group_3_1_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3454:1: ( rule__XAnnotation__Group_3_1_0__1__Impl )
            // InternalXbaseWithAnnotations.g:3455:2: rule__XAnnotation__Group_3_1_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotation__Group_3_1_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__Group_3_1_0__1"


    // $ANTLR start "rule__XAnnotation__Group_3_1_0__1__Impl"
    // InternalXbaseWithAnnotations.g:3461:1: rule__XAnnotation__Group_3_1_0__1__Impl : ( ( rule__XAnnotation__Group_3_1_0_1__0 )* ) ;
    public final void rule__XAnnotation__Group_3_1_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3465:1: ( ( ( rule__XAnnotation__Group_3_1_0_1__0 )* ) )
            // InternalXbaseWithAnnotations.g:3466:1: ( ( rule__XAnnotation__Group_3_1_0_1__0 )* )
            {
            // InternalXbaseWithAnnotations.g:3466:1: ( ( rule__XAnnotation__Group_3_1_0_1__0 )* )
            // InternalXbaseWithAnnotations.g:3467:2: ( rule__XAnnotation__Group_3_1_0_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationAccess().getGroup_3_1_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:3468:2: ( rule__XAnnotation__Group_3_1_0_1__0 )*
            loop47:
            do {
                int alt47=2;
                int LA47_0 = input.LA(1);

                if ( (LA47_0==54) ) {
                    alt47=1;
                }


                switch (alt47) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:3468:3: rule__XAnnotation__Group_3_1_0_1__0
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__XAnnotation__Group_3_1_0_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop47;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationAccess().getGroup_3_1_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__Group_3_1_0__1__Impl"


    // $ANTLR start "rule__XAnnotation__Group_3_1_0_1__0"
    // InternalXbaseWithAnnotations.g:3477:1: rule__XAnnotation__Group_3_1_0_1__0 : rule__XAnnotation__Group_3_1_0_1__0__Impl rule__XAnnotation__Group_3_1_0_1__1 ;
    public final void rule__XAnnotation__Group_3_1_0_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3481:1: ( rule__XAnnotation__Group_3_1_0_1__0__Impl rule__XAnnotation__Group_3_1_0_1__1 )
            // InternalXbaseWithAnnotations.g:3482:2: rule__XAnnotation__Group_3_1_0_1__0__Impl rule__XAnnotation__Group_3_1_0_1__1
            {
            pushFollow(FOLLOW_5);
            rule__XAnnotation__Group_3_1_0_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAnnotation__Group_3_1_0_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__Group_3_1_0_1__0"


    // $ANTLR start "rule__XAnnotation__Group_3_1_0_1__0__Impl"
    // InternalXbaseWithAnnotations.g:3489:1: rule__XAnnotation__Group_3_1_0_1__0__Impl : ( ',' ) ;
    public final void rule__XAnnotation__Group_3_1_0_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3493:1: ( ( ',' ) )
            // InternalXbaseWithAnnotations.g:3494:1: ( ',' )
            {
            // InternalXbaseWithAnnotations.g:3494:1: ( ',' )
            // InternalXbaseWithAnnotations.g:3495:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationAccess().getCommaKeyword_3_1_0_1_0()); 
            }
            match(input,54,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationAccess().getCommaKeyword_3_1_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__Group_3_1_0_1__0__Impl"


    // $ANTLR start "rule__XAnnotation__Group_3_1_0_1__1"
    // InternalXbaseWithAnnotations.g:3504:1: rule__XAnnotation__Group_3_1_0_1__1 : rule__XAnnotation__Group_3_1_0_1__1__Impl ;
    public final void rule__XAnnotation__Group_3_1_0_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3508:1: ( rule__XAnnotation__Group_3_1_0_1__1__Impl )
            // InternalXbaseWithAnnotations.g:3509:2: rule__XAnnotation__Group_3_1_0_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotation__Group_3_1_0_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__Group_3_1_0_1__1"


    // $ANTLR start "rule__XAnnotation__Group_3_1_0_1__1__Impl"
    // InternalXbaseWithAnnotations.g:3515:1: rule__XAnnotation__Group_3_1_0_1__1__Impl : ( ( rule__XAnnotation__ElementValuePairsAssignment_3_1_0_1_1 ) ) ;
    public final void rule__XAnnotation__Group_3_1_0_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3519:1: ( ( ( rule__XAnnotation__ElementValuePairsAssignment_3_1_0_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:3520:1: ( ( rule__XAnnotation__ElementValuePairsAssignment_3_1_0_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:3520:1: ( ( rule__XAnnotation__ElementValuePairsAssignment_3_1_0_1_1 ) )
            // InternalXbaseWithAnnotations.g:3521:2: ( rule__XAnnotation__ElementValuePairsAssignment_3_1_0_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationAccess().getElementValuePairsAssignment_3_1_0_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:3522:2: ( rule__XAnnotation__ElementValuePairsAssignment_3_1_0_1_1 )
            // InternalXbaseWithAnnotations.g:3522:3: rule__XAnnotation__ElementValuePairsAssignment_3_1_0_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotation__ElementValuePairsAssignment_3_1_0_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationAccess().getElementValuePairsAssignment_3_1_0_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__Group_3_1_0_1__1__Impl"


    // $ANTLR start "rule__XAnnotationElementValuePair__Group__0"
    // InternalXbaseWithAnnotations.g:3531:1: rule__XAnnotationElementValuePair__Group__0 : rule__XAnnotationElementValuePair__Group__0__Impl rule__XAnnotationElementValuePair__Group__1 ;
    public final void rule__XAnnotationElementValuePair__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3535:1: ( rule__XAnnotationElementValuePair__Group__0__Impl rule__XAnnotationElementValuePair__Group__1 )
            // InternalXbaseWithAnnotations.g:3536:2: rule__XAnnotationElementValuePair__Group__0__Impl rule__XAnnotationElementValuePair__Group__1
            {
            pushFollow(FOLLOW_10);
            rule__XAnnotationElementValuePair__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValuePair__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValuePair__Group__0"


    // $ANTLR start "rule__XAnnotationElementValuePair__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:3543:1: rule__XAnnotationElementValuePair__Group__0__Impl : ( ( rule__XAnnotationElementValuePair__Group_0__0 ) ) ;
    public final void rule__XAnnotationElementValuePair__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3547:1: ( ( ( rule__XAnnotationElementValuePair__Group_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:3548:1: ( ( rule__XAnnotationElementValuePair__Group_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:3548:1: ( ( rule__XAnnotationElementValuePair__Group_0__0 ) )
            // InternalXbaseWithAnnotations.g:3549:2: ( rule__XAnnotationElementValuePair__Group_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValuePairAccess().getGroup_0()); 
            }
            // InternalXbaseWithAnnotations.g:3550:2: ( rule__XAnnotationElementValuePair__Group_0__0 )
            // InternalXbaseWithAnnotations.g:3550:3: rule__XAnnotationElementValuePair__Group_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValuePair__Group_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValuePairAccess().getGroup_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValuePair__Group__0__Impl"


    // $ANTLR start "rule__XAnnotationElementValuePair__Group__1"
    // InternalXbaseWithAnnotations.g:3558:1: rule__XAnnotationElementValuePair__Group__1 : rule__XAnnotationElementValuePair__Group__1__Impl ;
    public final void rule__XAnnotationElementValuePair__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3562:1: ( rule__XAnnotationElementValuePair__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:3563:2: rule__XAnnotationElementValuePair__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValuePair__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValuePair__Group__1"


    // $ANTLR start "rule__XAnnotationElementValuePair__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:3569:1: rule__XAnnotationElementValuePair__Group__1__Impl : ( ( rule__XAnnotationElementValuePair__ValueAssignment_1 ) ) ;
    public final void rule__XAnnotationElementValuePair__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3573:1: ( ( ( rule__XAnnotationElementValuePair__ValueAssignment_1 ) ) )
            // InternalXbaseWithAnnotations.g:3574:1: ( ( rule__XAnnotationElementValuePair__ValueAssignment_1 ) )
            {
            // InternalXbaseWithAnnotations.g:3574:1: ( ( rule__XAnnotationElementValuePair__ValueAssignment_1 ) )
            // InternalXbaseWithAnnotations.g:3575:2: ( rule__XAnnotationElementValuePair__ValueAssignment_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValuePairAccess().getValueAssignment_1()); 
            }
            // InternalXbaseWithAnnotations.g:3576:2: ( rule__XAnnotationElementValuePair__ValueAssignment_1 )
            // InternalXbaseWithAnnotations.g:3576:3: rule__XAnnotationElementValuePair__ValueAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValuePair__ValueAssignment_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValuePairAccess().getValueAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValuePair__Group__1__Impl"


    // $ANTLR start "rule__XAnnotationElementValuePair__Group_0__0"
    // InternalXbaseWithAnnotations.g:3585:1: rule__XAnnotationElementValuePair__Group_0__0 : rule__XAnnotationElementValuePair__Group_0__0__Impl ;
    public final void rule__XAnnotationElementValuePair__Group_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3589:1: ( rule__XAnnotationElementValuePair__Group_0__0__Impl )
            // InternalXbaseWithAnnotations.g:3590:2: rule__XAnnotationElementValuePair__Group_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValuePair__Group_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValuePair__Group_0__0"


    // $ANTLR start "rule__XAnnotationElementValuePair__Group_0__0__Impl"
    // InternalXbaseWithAnnotations.g:3596:1: rule__XAnnotationElementValuePair__Group_0__0__Impl : ( ( rule__XAnnotationElementValuePair__Group_0_0__0 ) ) ;
    public final void rule__XAnnotationElementValuePair__Group_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3600:1: ( ( ( rule__XAnnotationElementValuePair__Group_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:3601:1: ( ( rule__XAnnotationElementValuePair__Group_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:3601:1: ( ( rule__XAnnotationElementValuePair__Group_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:3602:2: ( rule__XAnnotationElementValuePair__Group_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValuePairAccess().getGroup_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:3603:2: ( rule__XAnnotationElementValuePair__Group_0_0__0 )
            // InternalXbaseWithAnnotations.g:3603:3: rule__XAnnotationElementValuePair__Group_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValuePair__Group_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValuePairAccess().getGroup_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValuePair__Group_0__0__Impl"


    // $ANTLR start "rule__XAnnotationElementValuePair__Group_0_0__0"
    // InternalXbaseWithAnnotations.g:3612:1: rule__XAnnotationElementValuePair__Group_0_0__0 : rule__XAnnotationElementValuePair__Group_0_0__0__Impl rule__XAnnotationElementValuePair__Group_0_0__1 ;
    public final void rule__XAnnotationElementValuePair__Group_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3616:1: ( rule__XAnnotationElementValuePair__Group_0_0__0__Impl rule__XAnnotationElementValuePair__Group_0_0__1 )
            // InternalXbaseWithAnnotations.g:3617:2: rule__XAnnotationElementValuePair__Group_0_0__0__Impl rule__XAnnotationElementValuePair__Group_0_0__1
            {
            pushFollow(FOLLOW_11);
            rule__XAnnotationElementValuePair__Group_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValuePair__Group_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValuePair__Group_0_0__0"


    // $ANTLR start "rule__XAnnotationElementValuePair__Group_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:3624:1: rule__XAnnotationElementValuePair__Group_0_0__0__Impl : ( ( rule__XAnnotationElementValuePair__ElementAssignment_0_0_0 ) ) ;
    public final void rule__XAnnotationElementValuePair__Group_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3628:1: ( ( ( rule__XAnnotationElementValuePair__ElementAssignment_0_0_0 ) ) )
            // InternalXbaseWithAnnotations.g:3629:1: ( ( rule__XAnnotationElementValuePair__ElementAssignment_0_0_0 ) )
            {
            // InternalXbaseWithAnnotations.g:3629:1: ( ( rule__XAnnotationElementValuePair__ElementAssignment_0_0_0 ) )
            // InternalXbaseWithAnnotations.g:3630:2: ( rule__XAnnotationElementValuePair__ElementAssignment_0_0_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValuePairAccess().getElementAssignment_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:3631:2: ( rule__XAnnotationElementValuePair__ElementAssignment_0_0_0 )
            // InternalXbaseWithAnnotations.g:3631:3: rule__XAnnotationElementValuePair__ElementAssignment_0_0_0
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValuePair__ElementAssignment_0_0_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValuePairAccess().getElementAssignment_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValuePair__Group_0_0__0__Impl"


    // $ANTLR start "rule__XAnnotationElementValuePair__Group_0_0__1"
    // InternalXbaseWithAnnotations.g:3639:1: rule__XAnnotationElementValuePair__Group_0_0__1 : rule__XAnnotationElementValuePair__Group_0_0__1__Impl ;
    public final void rule__XAnnotationElementValuePair__Group_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3643:1: ( rule__XAnnotationElementValuePair__Group_0_0__1__Impl )
            // InternalXbaseWithAnnotations.g:3644:2: rule__XAnnotationElementValuePair__Group_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValuePair__Group_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValuePair__Group_0_0__1"


    // $ANTLR start "rule__XAnnotationElementValuePair__Group_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:3650:1: rule__XAnnotationElementValuePair__Group_0_0__1__Impl : ( '=' ) ;
    public final void rule__XAnnotationElementValuePair__Group_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3654:1: ( ( '=' ) )
            // InternalXbaseWithAnnotations.g:3655:1: ( '=' )
            {
            // InternalXbaseWithAnnotations.g:3655:1: ( '=' )
            // InternalXbaseWithAnnotations.g:3656:2: '='
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValuePairAccess().getEqualsSignKeyword_0_0_1()); 
            }
            match(input,13,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValuePairAccess().getEqualsSignKeyword_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValuePair__Group_0_0__1__Impl"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_0__0"
    // InternalXbaseWithAnnotations.g:3666:1: rule__XAnnotationElementValueOrCommaList__Group_0__0 : rule__XAnnotationElementValueOrCommaList__Group_0__0__Impl rule__XAnnotationElementValueOrCommaList__Group_0__1 ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3670:1: ( rule__XAnnotationElementValueOrCommaList__Group_0__0__Impl rule__XAnnotationElementValueOrCommaList__Group_0__1 )
            // InternalXbaseWithAnnotations.g:3671:2: rule__XAnnotationElementValueOrCommaList__Group_0__0__Impl rule__XAnnotationElementValueOrCommaList__Group_0__1
            {
            pushFollow(FOLLOW_12);
            rule__XAnnotationElementValueOrCommaList__Group_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValueOrCommaList__Group_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_0__0"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_0__0__Impl"
    // InternalXbaseWithAnnotations.g:3678:1: rule__XAnnotationElementValueOrCommaList__Group_0__0__Impl : ( ( rule__XAnnotationElementValueOrCommaList__Group_0_0__0 ) ) ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3682:1: ( ( ( rule__XAnnotationElementValueOrCommaList__Group_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:3683:1: ( ( rule__XAnnotationElementValueOrCommaList__Group_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:3683:1: ( ( rule__XAnnotationElementValueOrCommaList__Group_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:3684:2: ( rule__XAnnotationElementValueOrCommaList__Group_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getGroup_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:3685:2: ( rule__XAnnotationElementValueOrCommaList__Group_0_0__0 )
            // InternalXbaseWithAnnotations.g:3685:3: rule__XAnnotationElementValueOrCommaList__Group_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValueOrCommaList__Group_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getGroup_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_0__0__Impl"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_0__1"
    // InternalXbaseWithAnnotations.g:3693:1: rule__XAnnotationElementValueOrCommaList__Group_0__1 : rule__XAnnotationElementValueOrCommaList__Group_0__1__Impl rule__XAnnotationElementValueOrCommaList__Group_0__2 ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3697:1: ( rule__XAnnotationElementValueOrCommaList__Group_0__1__Impl rule__XAnnotationElementValueOrCommaList__Group_0__2 )
            // InternalXbaseWithAnnotations.g:3698:2: rule__XAnnotationElementValueOrCommaList__Group_0__1__Impl rule__XAnnotationElementValueOrCommaList__Group_0__2
            {
            pushFollow(FOLLOW_12);
            rule__XAnnotationElementValueOrCommaList__Group_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValueOrCommaList__Group_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_0__1"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_0__1__Impl"
    // InternalXbaseWithAnnotations.g:3705:1: rule__XAnnotationElementValueOrCommaList__Group_0__1__Impl : ( ( rule__XAnnotationElementValueOrCommaList__Group_0_1__0 )? ) ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3709:1: ( ( ( rule__XAnnotationElementValueOrCommaList__Group_0_1__0 )? ) )
            // InternalXbaseWithAnnotations.g:3710:1: ( ( rule__XAnnotationElementValueOrCommaList__Group_0_1__0 )? )
            {
            // InternalXbaseWithAnnotations.g:3710:1: ( ( rule__XAnnotationElementValueOrCommaList__Group_0_1__0 )? )
            // InternalXbaseWithAnnotations.g:3711:2: ( rule__XAnnotationElementValueOrCommaList__Group_0_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getGroup_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:3712:2: ( rule__XAnnotationElementValueOrCommaList__Group_0_1__0 )?
            int alt48=2;
            int LA48_0 = input.LA(1);

            if ( ((LA48_0>=RULE_ID && LA48_0<=RULE_STRING)||LA48_0==27||(LA48_0>=34 && LA48_0<=35)||LA48_0==40||(LA48_0>=45 && LA48_0<=52)||(LA48_0>=56 && LA48_0<=57)||LA48_0==60||LA48_0==63||LA48_0==65||(LA48_0>=69 && LA48_0<=77)||LA48_0==79||LA48_0==87) ) {
                alt48=1;
            }
            switch (alt48) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:3712:3: rule__XAnnotationElementValueOrCommaList__Group_0_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XAnnotationElementValueOrCommaList__Group_0_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getGroup_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_0__1__Impl"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_0__2"
    // InternalXbaseWithAnnotations.g:3720:1: rule__XAnnotationElementValueOrCommaList__Group_0__2 : rule__XAnnotationElementValueOrCommaList__Group_0__2__Impl ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3724:1: ( rule__XAnnotationElementValueOrCommaList__Group_0__2__Impl )
            // InternalXbaseWithAnnotations.g:3725:2: rule__XAnnotationElementValueOrCommaList__Group_0__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValueOrCommaList__Group_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_0__2"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_0__2__Impl"
    // InternalXbaseWithAnnotations.g:3731:1: rule__XAnnotationElementValueOrCommaList__Group_0__2__Impl : ( ']' ) ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3735:1: ( ( ']' ) )
            // InternalXbaseWithAnnotations.g:3736:1: ( ']' )
            {
            // InternalXbaseWithAnnotations.g:3736:1: ( ']' )
            // InternalXbaseWithAnnotations.g:3737:2: ']'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getRightSquareBracketKeyword_0_2()); 
            }
            match(input,55,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getRightSquareBracketKeyword_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_0__2__Impl"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_0_0__0"
    // InternalXbaseWithAnnotations.g:3747:1: rule__XAnnotationElementValueOrCommaList__Group_0_0__0 : rule__XAnnotationElementValueOrCommaList__Group_0_0__0__Impl ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3751:1: ( rule__XAnnotationElementValueOrCommaList__Group_0_0__0__Impl )
            // InternalXbaseWithAnnotations.g:3752:2: rule__XAnnotationElementValueOrCommaList__Group_0_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValueOrCommaList__Group_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_0_0__0"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:3758:1: rule__XAnnotationElementValueOrCommaList__Group_0_0__0__Impl : ( ( rule__XAnnotationElementValueOrCommaList__Group_0_0_0__0 ) ) ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3762:1: ( ( ( rule__XAnnotationElementValueOrCommaList__Group_0_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:3763:1: ( ( rule__XAnnotationElementValueOrCommaList__Group_0_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:3763:1: ( ( rule__XAnnotationElementValueOrCommaList__Group_0_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:3764:2: ( rule__XAnnotationElementValueOrCommaList__Group_0_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getGroup_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:3765:2: ( rule__XAnnotationElementValueOrCommaList__Group_0_0_0__0 )
            // InternalXbaseWithAnnotations.g:3765:3: rule__XAnnotationElementValueOrCommaList__Group_0_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValueOrCommaList__Group_0_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getGroup_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_0_0__0__Impl"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_0_0_0__0"
    // InternalXbaseWithAnnotations.g:3774:1: rule__XAnnotationElementValueOrCommaList__Group_0_0_0__0 : rule__XAnnotationElementValueOrCommaList__Group_0_0_0__0__Impl rule__XAnnotationElementValueOrCommaList__Group_0_0_0__1 ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_0_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3778:1: ( rule__XAnnotationElementValueOrCommaList__Group_0_0_0__0__Impl rule__XAnnotationElementValueOrCommaList__Group_0_0_0__1 )
            // InternalXbaseWithAnnotations.g:3779:2: rule__XAnnotationElementValueOrCommaList__Group_0_0_0__0__Impl rule__XAnnotationElementValueOrCommaList__Group_0_0_0__1
            {
            pushFollow(FOLLOW_13);
            rule__XAnnotationElementValueOrCommaList__Group_0_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValueOrCommaList__Group_0_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_0_0_0__0"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_0_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:3786:1: rule__XAnnotationElementValueOrCommaList__Group_0_0_0__0__Impl : ( () ) ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_0_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3790:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:3791:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:3791:1: ( () )
            // InternalXbaseWithAnnotations.g:3792:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getXListLiteralAction_0_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:3793:2: ()
            // InternalXbaseWithAnnotations.g:3793:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getXListLiteralAction_0_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_0_0_0__0__Impl"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_0_0_0__1"
    // InternalXbaseWithAnnotations.g:3801:1: rule__XAnnotationElementValueOrCommaList__Group_0_0_0__1 : rule__XAnnotationElementValueOrCommaList__Group_0_0_0__1__Impl rule__XAnnotationElementValueOrCommaList__Group_0_0_0__2 ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_0_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3805:1: ( rule__XAnnotationElementValueOrCommaList__Group_0_0_0__1__Impl rule__XAnnotationElementValueOrCommaList__Group_0_0_0__2 )
            // InternalXbaseWithAnnotations.g:3806:2: rule__XAnnotationElementValueOrCommaList__Group_0_0_0__1__Impl rule__XAnnotationElementValueOrCommaList__Group_0_0_0__2
            {
            pushFollow(FOLLOW_14);
            rule__XAnnotationElementValueOrCommaList__Group_0_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValueOrCommaList__Group_0_0_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_0_0_0__1"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_0_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:3813:1: rule__XAnnotationElementValueOrCommaList__Group_0_0_0__1__Impl : ( '#' ) ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_0_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3817:1: ( ( '#' ) )
            // InternalXbaseWithAnnotations.g:3818:1: ( '#' )
            {
            // InternalXbaseWithAnnotations.g:3818:1: ( '#' )
            // InternalXbaseWithAnnotations.g:3819:2: '#'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getNumberSignKeyword_0_0_0_1()); 
            }
            match(input,56,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getNumberSignKeyword_0_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_0_0_0__1__Impl"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_0_0_0__2"
    // InternalXbaseWithAnnotations.g:3828:1: rule__XAnnotationElementValueOrCommaList__Group_0_0_0__2 : rule__XAnnotationElementValueOrCommaList__Group_0_0_0__2__Impl ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_0_0_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3832:1: ( rule__XAnnotationElementValueOrCommaList__Group_0_0_0__2__Impl )
            // InternalXbaseWithAnnotations.g:3833:2: rule__XAnnotationElementValueOrCommaList__Group_0_0_0__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValueOrCommaList__Group_0_0_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_0_0_0__2"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_0_0_0__2__Impl"
    // InternalXbaseWithAnnotations.g:3839:1: rule__XAnnotationElementValueOrCommaList__Group_0_0_0__2__Impl : ( '[' ) ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_0_0_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3843:1: ( ( '[' ) )
            // InternalXbaseWithAnnotations.g:3844:1: ( '[' )
            {
            // InternalXbaseWithAnnotations.g:3844:1: ( '[' )
            // InternalXbaseWithAnnotations.g:3845:2: '['
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getLeftSquareBracketKeyword_0_0_0_2()); 
            }
            match(input,57,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getLeftSquareBracketKeyword_0_0_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_0_0_0__2__Impl"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_0_1__0"
    // InternalXbaseWithAnnotations.g:3855:1: rule__XAnnotationElementValueOrCommaList__Group_0_1__0 : rule__XAnnotationElementValueOrCommaList__Group_0_1__0__Impl rule__XAnnotationElementValueOrCommaList__Group_0_1__1 ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_0_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3859:1: ( rule__XAnnotationElementValueOrCommaList__Group_0_1__0__Impl rule__XAnnotationElementValueOrCommaList__Group_0_1__1 )
            // InternalXbaseWithAnnotations.g:3860:2: rule__XAnnotationElementValueOrCommaList__Group_0_1__0__Impl rule__XAnnotationElementValueOrCommaList__Group_0_1__1
            {
            pushFollow(FOLLOW_8);
            rule__XAnnotationElementValueOrCommaList__Group_0_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValueOrCommaList__Group_0_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_0_1__0"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_0_1__0__Impl"
    // InternalXbaseWithAnnotations.g:3867:1: rule__XAnnotationElementValueOrCommaList__Group_0_1__0__Impl : ( ( rule__XAnnotationElementValueOrCommaList__ElementsAssignment_0_1_0 ) ) ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_0_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3871:1: ( ( ( rule__XAnnotationElementValueOrCommaList__ElementsAssignment_0_1_0 ) ) )
            // InternalXbaseWithAnnotations.g:3872:1: ( ( rule__XAnnotationElementValueOrCommaList__ElementsAssignment_0_1_0 ) )
            {
            // InternalXbaseWithAnnotations.g:3872:1: ( ( rule__XAnnotationElementValueOrCommaList__ElementsAssignment_0_1_0 ) )
            // InternalXbaseWithAnnotations.g:3873:2: ( rule__XAnnotationElementValueOrCommaList__ElementsAssignment_0_1_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getElementsAssignment_0_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:3874:2: ( rule__XAnnotationElementValueOrCommaList__ElementsAssignment_0_1_0 )
            // InternalXbaseWithAnnotations.g:3874:3: rule__XAnnotationElementValueOrCommaList__ElementsAssignment_0_1_0
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValueOrCommaList__ElementsAssignment_0_1_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getElementsAssignment_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_0_1__0__Impl"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_0_1__1"
    // InternalXbaseWithAnnotations.g:3882:1: rule__XAnnotationElementValueOrCommaList__Group_0_1__1 : rule__XAnnotationElementValueOrCommaList__Group_0_1__1__Impl ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_0_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3886:1: ( rule__XAnnotationElementValueOrCommaList__Group_0_1__1__Impl )
            // InternalXbaseWithAnnotations.g:3887:2: rule__XAnnotationElementValueOrCommaList__Group_0_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValueOrCommaList__Group_0_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_0_1__1"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_0_1__1__Impl"
    // InternalXbaseWithAnnotations.g:3893:1: rule__XAnnotationElementValueOrCommaList__Group_0_1__1__Impl : ( ( rule__XAnnotationElementValueOrCommaList__Group_0_1_1__0 )* ) ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_0_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3897:1: ( ( ( rule__XAnnotationElementValueOrCommaList__Group_0_1_1__0 )* ) )
            // InternalXbaseWithAnnotations.g:3898:1: ( ( rule__XAnnotationElementValueOrCommaList__Group_0_1_1__0 )* )
            {
            // InternalXbaseWithAnnotations.g:3898:1: ( ( rule__XAnnotationElementValueOrCommaList__Group_0_1_1__0 )* )
            // InternalXbaseWithAnnotations.g:3899:2: ( rule__XAnnotationElementValueOrCommaList__Group_0_1_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getGroup_0_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:3900:2: ( rule__XAnnotationElementValueOrCommaList__Group_0_1_1__0 )*
            loop49:
            do {
                int alt49=2;
                int LA49_0 = input.LA(1);

                if ( (LA49_0==54) ) {
                    alt49=1;
                }


                switch (alt49) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:3900:3: rule__XAnnotationElementValueOrCommaList__Group_0_1_1__0
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__XAnnotationElementValueOrCommaList__Group_0_1_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop49;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getGroup_0_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_0_1__1__Impl"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_0_1_1__0"
    // InternalXbaseWithAnnotations.g:3909:1: rule__XAnnotationElementValueOrCommaList__Group_0_1_1__0 : rule__XAnnotationElementValueOrCommaList__Group_0_1_1__0__Impl rule__XAnnotationElementValueOrCommaList__Group_0_1_1__1 ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_0_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3913:1: ( rule__XAnnotationElementValueOrCommaList__Group_0_1_1__0__Impl rule__XAnnotationElementValueOrCommaList__Group_0_1_1__1 )
            // InternalXbaseWithAnnotations.g:3914:2: rule__XAnnotationElementValueOrCommaList__Group_0_1_1__0__Impl rule__XAnnotationElementValueOrCommaList__Group_0_1_1__1
            {
            pushFollow(FOLLOW_10);
            rule__XAnnotationElementValueOrCommaList__Group_0_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValueOrCommaList__Group_0_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_0_1_1__0"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_0_1_1__0__Impl"
    // InternalXbaseWithAnnotations.g:3921:1: rule__XAnnotationElementValueOrCommaList__Group_0_1_1__0__Impl : ( ',' ) ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_0_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3925:1: ( ( ',' ) )
            // InternalXbaseWithAnnotations.g:3926:1: ( ',' )
            {
            // InternalXbaseWithAnnotations.g:3926:1: ( ',' )
            // InternalXbaseWithAnnotations.g:3927:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getCommaKeyword_0_1_1_0()); 
            }
            match(input,54,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getCommaKeyword_0_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_0_1_1__0__Impl"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_0_1_1__1"
    // InternalXbaseWithAnnotations.g:3936:1: rule__XAnnotationElementValueOrCommaList__Group_0_1_1__1 : rule__XAnnotationElementValueOrCommaList__Group_0_1_1__1__Impl ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_0_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3940:1: ( rule__XAnnotationElementValueOrCommaList__Group_0_1_1__1__Impl )
            // InternalXbaseWithAnnotations.g:3941:2: rule__XAnnotationElementValueOrCommaList__Group_0_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValueOrCommaList__Group_0_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_0_1_1__1"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_0_1_1__1__Impl"
    // InternalXbaseWithAnnotations.g:3947:1: rule__XAnnotationElementValueOrCommaList__Group_0_1_1__1__Impl : ( ( rule__XAnnotationElementValueOrCommaList__ElementsAssignment_0_1_1_1 ) ) ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_0_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3951:1: ( ( ( rule__XAnnotationElementValueOrCommaList__ElementsAssignment_0_1_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:3952:1: ( ( rule__XAnnotationElementValueOrCommaList__ElementsAssignment_0_1_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:3952:1: ( ( rule__XAnnotationElementValueOrCommaList__ElementsAssignment_0_1_1_1 ) )
            // InternalXbaseWithAnnotations.g:3953:2: ( rule__XAnnotationElementValueOrCommaList__ElementsAssignment_0_1_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getElementsAssignment_0_1_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:3954:2: ( rule__XAnnotationElementValueOrCommaList__ElementsAssignment_0_1_1_1 )
            // InternalXbaseWithAnnotations.g:3954:3: rule__XAnnotationElementValueOrCommaList__ElementsAssignment_0_1_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValueOrCommaList__ElementsAssignment_0_1_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getElementsAssignment_0_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_0_1_1__1__Impl"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_1__0"
    // InternalXbaseWithAnnotations.g:3963:1: rule__XAnnotationElementValueOrCommaList__Group_1__0 : rule__XAnnotationElementValueOrCommaList__Group_1__0__Impl rule__XAnnotationElementValueOrCommaList__Group_1__1 ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3967:1: ( rule__XAnnotationElementValueOrCommaList__Group_1__0__Impl rule__XAnnotationElementValueOrCommaList__Group_1__1 )
            // InternalXbaseWithAnnotations.g:3968:2: rule__XAnnotationElementValueOrCommaList__Group_1__0__Impl rule__XAnnotationElementValueOrCommaList__Group_1__1
            {
            pushFollow(FOLLOW_8);
            rule__XAnnotationElementValueOrCommaList__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValueOrCommaList__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_1__0"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_1__0__Impl"
    // InternalXbaseWithAnnotations.g:3975:1: rule__XAnnotationElementValueOrCommaList__Group_1__0__Impl : ( ruleXAnnotationOrExpression ) ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3979:1: ( ( ruleXAnnotationOrExpression ) )
            // InternalXbaseWithAnnotations.g:3980:1: ( ruleXAnnotationOrExpression )
            {
            // InternalXbaseWithAnnotations.g:3980:1: ( ruleXAnnotationOrExpression )
            // InternalXbaseWithAnnotations.g:3981:2: ruleXAnnotationOrExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getXAnnotationOrExpressionParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAnnotationOrExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getXAnnotationOrExpressionParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_1__0__Impl"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_1__1"
    // InternalXbaseWithAnnotations.g:3990:1: rule__XAnnotationElementValueOrCommaList__Group_1__1 : rule__XAnnotationElementValueOrCommaList__Group_1__1__Impl ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:3994:1: ( rule__XAnnotationElementValueOrCommaList__Group_1__1__Impl )
            // InternalXbaseWithAnnotations.g:3995:2: rule__XAnnotationElementValueOrCommaList__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValueOrCommaList__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_1__1"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_1__1__Impl"
    // InternalXbaseWithAnnotations.g:4001:1: rule__XAnnotationElementValueOrCommaList__Group_1__1__Impl : ( ( rule__XAnnotationElementValueOrCommaList__Group_1_1__0 )? ) ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4005:1: ( ( ( rule__XAnnotationElementValueOrCommaList__Group_1_1__0 )? ) )
            // InternalXbaseWithAnnotations.g:4006:1: ( ( rule__XAnnotationElementValueOrCommaList__Group_1_1__0 )? )
            {
            // InternalXbaseWithAnnotations.g:4006:1: ( ( rule__XAnnotationElementValueOrCommaList__Group_1_1__0 )? )
            // InternalXbaseWithAnnotations.g:4007:2: ( rule__XAnnotationElementValueOrCommaList__Group_1_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getGroup_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:4008:2: ( rule__XAnnotationElementValueOrCommaList__Group_1_1__0 )?
            int alt50=2;
            int LA50_0 = input.LA(1);

            if ( (LA50_0==54) ) {
                alt50=1;
            }
            switch (alt50) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:4008:3: rule__XAnnotationElementValueOrCommaList__Group_1_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XAnnotationElementValueOrCommaList__Group_1_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getGroup_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_1__1__Impl"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_1_1__0"
    // InternalXbaseWithAnnotations.g:4017:1: rule__XAnnotationElementValueOrCommaList__Group_1_1__0 : rule__XAnnotationElementValueOrCommaList__Group_1_1__0__Impl rule__XAnnotationElementValueOrCommaList__Group_1_1__1 ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4021:1: ( rule__XAnnotationElementValueOrCommaList__Group_1_1__0__Impl rule__XAnnotationElementValueOrCommaList__Group_1_1__1 )
            // InternalXbaseWithAnnotations.g:4022:2: rule__XAnnotationElementValueOrCommaList__Group_1_1__0__Impl rule__XAnnotationElementValueOrCommaList__Group_1_1__1
            {
            pushFollow(FOLLOW_8);
            rule__XAnnotationElementValueOrCommaList__Group_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValueOrCommaList__Group_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_1_1__0"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_1_1__0__Impl"
    // InternalXbaseWithAnnotations.g:4029:1: rule__XAnnotationElementValueOrCommaList__Group_1_1__0__Impl : ( () ) ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4033:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:4034:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:4034:1: ( () )
            // InternalXbaseWithAnnotations.g:4035:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getXListLiteralElementsAction_1_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:4036:2: ()
            // InternalXbaseWithAnnotations.g:4036:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getXListLiteralElementsAction_1_1_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_1_1__0__Impl"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_1_1__1"
    // InternalXbaseWithAnnotations.g:4044:1: rule__XAnnotationElementValueOrCommaList__Group_1_1__1 : rule__XAnnotationElementValueOrCommaList__Group_1_1__1__Impl ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4048:1: ( rule__XAnnotationElementValueOrCommaList__Group_1_1__1__Impl )
            // InternalXbaseWithAnnotations.g:4049:2: rule__XAnnotationElementValueOrCommaList__Group_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValueOrCommaList__Group_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_1_1__1"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_1_1__1__Impl"
    // InternalXbaseWithAnnotations.g:4055:1: rule__XAnnotationElementValueOrCommaList__Group_1_1__1__Impl : ( ( ( rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0 ) ) ( ( rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0 )* ) ) ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4059:1: ( ( ( ( rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0 ) ) ( ( rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0 )* ) ) )
            // InternalXbaseWithAnnotations.g:4060:1: ( ( ( rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0 ) ) ( ( rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0 )* ) )
            {
            // InternalXbaseWithAnnotations.g:4060:1: ( ( ( rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0 ) ) ( ( rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0 )* ) )
            // InternalXbaseWithAnnotations.g:4061:2: ( ( rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0 ) ) ( ( rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0 )* )
            {
            // InternalXbaseWithAnnotations.g:4061:2: ( ( rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0 ) )
            // InternalXbaseWithAnnotations.g:4062:3: ( rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getGroup_1_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:4063:3: ( rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0 )
            // InternalXbaseWithAnnotations.g:4063:4: rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0
            {
            pushFollow(FOLLOW_9);
            rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getGroup_1_1_1()); 
            }

            }

            // InternalXbaseWithAnnotations.g:4066:2: ( ( rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0 )* )
            // InternalXbaseWithAnnotations.g:4067:3: ( rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getGroup_1_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:4068:3: ( rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0 )*
            loop51:
            do {
                int alt51=2;
                int LA51_0 = input.LA(1);

                if ( (LA51_0==54) ) {
                    alt51=1;
                }


                switch (alt51) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:4068:4: rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop51;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getGroup_1_1_1()); 
            }

            }


            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_1_1__1__Impl"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0"
    // InternalXbaseWithAnnotations.g:4078:1: rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0 : rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0__Impl rule__XAnnotationElementValueOrCommaList__Group_1_1_1__1 ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4082:1: ( rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0__Impl rule__XAnnotationElementValueOrCommaList__Group_1_1_1__1 )
            // InternalXbaseWithAnnotations.g:4083:2: rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0__Impl rule__XAnnotationElementValueOrCommaList__Group_1_1_1__1
            {
            pushFollow(FOLLOW_10);
            rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValueOrCommaList__Group_1_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0__Impl"
    // InternalXbaseWithAnnotations.g:4090:1: rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0__Impl : ( ',' ) ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4094:1: ( ( ',' ) )
            // InternalXbaseWithAnnotations.g:4095:1: ( ',' )
            {
            // InternalXbaseWithAnnotations.g:4095:1: ( ',' )
            // InternalXbaseWithAnnotations.g:4096:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getCommaKeyword_1_1_1_0()); 
            }
            match(input,54,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getCommaKeyword_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_1_1_1__0__Impl"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_1_1_1__1"
    // InternalXbaseWithAnnotations.g:4105:1: rule__XAnnotationElementValueOrCommaList__Group_1_1_1__1 : rule__XAnnotationElementValueOrCommaList__Group_1_1_1__1__Impl ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_1_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4109:1: ( rule__XAnnotationElementValueOrCommaList__Group_1_1_1__1__Impl )
            // InternalXbaseWithAnnotations.g:4110:2: rule__XAnnotationElementValueOrCommaList__Group_1_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValueOrCommaList__Group_1_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_1_1_1__1"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__Group_1_1_1__1__Impl"
    // InternalXbaseWithAnnotations.g:4116:1: rule__XAnnotationElementValueOrCommaList__Group_1_1_1__1__Impl : ( ( rule__XAnnotationElementValueOrCommaList__ElementsAssignment_1_1_1_1 ) ) ;
    public final void rule__XAnnotationElementValueOrCommaList__Group_1_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4120:1: ( ( ( rule__XAnnotationElementValueOrCommaList__ElementsAssignment_1_1_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:4121:1: ( ( rule__XAnnotationElementValueOrCommaList__ElementsAssignment_1_1_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:4121:1: ( ( rule__XAnnotationElementValueOrCommaList__ElementsAssignment_1_1_1_1 ) )
            // InternalXbaseWithAnnotations.g:4122:2: ( rule__XAnnotationElementValueOrCommaList__ElementsAssignment_1_1_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getElementsAssignment_1_1_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:4123:2: ( rule__XAnnotationElementValueOrCommaList__ElementsAssignment_1_1_1_1 )
            // InternalXbaseWithAnnotations.g:4123:3: rule__XAnnotationElementValueOrCommaList__ElementsAssignment_1_1_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValueOrCommaList__ElementsAssignment_1_1_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getElementsAssignment_1_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__Group_1_1_1__1__Impl"


    // $ANTLR start "rule__XAnnotationElementValue__Group_0__0"
    // InternalXbaseWithAnnotations.g:4132:1: rule__XAnnotationElementValue__Group_0__0 : rule__XAnnotationElementValue__Group_0__0__Impl rule__XAnnotationElementValue__Group_0__1 ;
    public final void rule__XAnnotationElementValue__Group_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4136:1: ( rule__XAnnotationElementValue__Group_0__0__Impl rule__XAnnotationElementValue__Group_0__1 )
            // InternalXbaseWithAnnotations.g:4137:2: rule__XAnnotationElementValue__Group_0__0__Impl rule__XAnnotationElementValue__Group_0__1
            {
            pushFollow(FOLLOW_12);
            rule__XAnnotationElementValue__Group_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValue__Group_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__Group_0__0"


    // $ANTLR start "rule__XAnnotationElementValue__Group_0__0__Impl"
    // InternalXbaseWithAnnotations.g:4144:1: rule__XAnnotationElementValue__Group_0__0__Impl : ( ( rule__XAnnotationElementValue__Group_0_0__0 ) ) ;
    public final void rule__XAnnotationElementValue__Group_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4148:1: ( ( ( rule__XAnnotationElementValue__Group_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:4149:1: ( ( rule__XAnnotationElementValue__Group_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:4149:1: ( ( rule__XAnnotationElementValue__Group_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:4150:2: ( rule__XAnnotationElementValue__Group_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueAccess().getGroup_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:4151:2: ( rule__XAnnotationElementValue__Group_0_0__0 )
            // InternalXbaseWithAnnotations.g:4151:3: rule__XAnnotationElementValue__Group_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValue__Group_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueAccess().getGroup_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__Group_0__0__Impl"


    // $ANTLR start "rule__XAnnotationElementValue__Group_0__1"
    // InternalXbaseWithAnnotations.g:4159:1: rule__XAnnotationElementValue__Group_0__1 : rule__XAnnotationElementValue__Group_0__1__Impl rule__XAnnotationElementValue__Group_0__2 ;
    public final void rule__XAnnotationElementValue__Group_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4163:1: ( rule__XAnnotationElementValue__Group_0__1__Impl rule__XAnnotationElementValue__Group_0__2 )
            // InternalXbaseWithAnnotations.g:4164:2: rule__XAnnotationElementValue__Group_0__1__Impl rule__XAnnotationElementValue__Group_0__2
            {
            pushFollow(FOLLOW_12);
            rule__XAnnotationElementValue__Group_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValue__Group_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__Group_0__1"


    // $ANTLR start "rule__XAnnotationElementValue__Group_0__1__Impl"
    // InternalXbaseWithAnnotations.g:4171:1: rule__XAnnotationElementValue__Group_0__1__Impl : ( ( rule__XAnnotationElementValue__Group_0_1__0 )? ) ;
    public final void rule__XAnnotationElementValue__Group_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4175:1: ( ( ( rule__XAnnotationElementValue__Group_0_1__0 )? ) )
            // InternalXbaseWithAnnotations.g:4176:1: ( ( rule__XAnnotationElementValue__Group_0_1__0 )? )
            {
            // InternalXbaseWithAnnotations.g:4176:1: ( ( rule__XAnnotationElementValue__Group_0_1__0 )? )
            // InternalXbaseWithAnnotations.g:4177:2: ( rule__XAnnotationElementValue__Group_0_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueAccess().getGroup_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:4178:2: ( rule__XAnnotationElementValue__Group_0_1__0 )?
            int alt52=2;
            int LA52_0 = input.LA(1);

            if ( ((LA52_0>=RULE_ID && LA52_0<=RULE_STRING)||LA52_0==27||(LA52_0>=34 && LA52_0<=35)||LA52_0==40||(LA52_0>=45 && LA52_0<=52)||(LA52_0>=56 && LA52_0<=57)||LA52_0==60||LA52_0==63||LA52_0==65||(LA52_0>=69 && LA52_0<=77)||LA52_0==79||LA52_0==87) ) {
                alt52=1;
            }
            switch (alt52) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:4178:3: rule__XAnnotationElementValue__Group_0_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XAnnotationElementValue__Group_0_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueAccess().getGroup_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__Group_0__1__Impl"


    // $ANTLR start "rule__XAnnotationElementValue__Group_0__2"
    // InternalXbaseWithAnnotations.g:4186:1: rule__XAnnotationElementValue__Group_0__2 : rule__XAnnotationElementValue__Group_0__2__Impl ;
    public final void rule__XAnnotationElementValue__Group_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4190:1: ( rule__XAnnotationElementValue__Group_0__2__Impl )
            // InternalXbaseWithAnnotations.g:4191:2: rule__XAnnotationElementValue__Group_0__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValue__Group_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__Group_0__2"


    // $ANTLR start "rule__XAnnotationElementValue__Group_0__2__Impl"
    // InternalXbaseWithAnnotations.g:4197:1: rule__XAnnotationElementValue__Group_0__2__Impl : ( ']' ) ;
    public final void rule__XAnnotationElementValue__Group_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4201:1: ( ( ']' ) )
            // InternalXbaseWithAnnotations.g:4202:1: ( ']' )
            {
            // InternalXbaseWithAnnotations.g:4202:1: ( ']' )
            // InternalXbaseWithAnnotations.g:4203:2: ']'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueAccess().getRightSquareBracketKeyword_0_2()); 
            }
            match(input,55,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueAccess().getRightSquareBracketKeyword_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__Group_0__2__Impl"


    // $ANTLR start "rule__XAnnotationElementValue__Group_0_0__0"
    // InternalXbaseWithAnnotations.g:4213:1: rule__XAnnotationElementValue__Group_0_0__0 : rule__XAnnotationElementValue__Group_0_0__0__Impl ;
    public final void rule__XAnnotationElementValue__Group_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4217:1: ( rule__XAnnotationElementValue__Group_0_0__0__Impl )
            // InternalXbaseWithAnnotations.g:4218:2: rule__XAnnotationElementValue__Group_0_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValue__Group_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__Group_0_0__0"


    // $ANTLR start "rule__XAnnotationElementValue__Group_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:4224:1: rule__XAnnotationElementValue__Group_0_0__0__Impl : ( ( rule__XAnnotationElementValue__Group_0_0_0__0 ) ) ;
    public final void rule__XAnnotationElementValue__Group_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4228:1: ( ( ( rule__XAnnotationElementValue__Group_0_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:4229:1: ( ( rule__XAnnotationElementValue__Group_0_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:4229:1: ( ( rule__XAnnotationElementValue__Group_0_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:4230:2: ( rule__XAnnotationElementValue__Group_0_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueAccess().getGroup_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:4231:2: ( rule__XAnnotationElementValue__Group_0_0_0__0 )
            // InternalXbaseWithAnnotations.g:4231:3: rule__XAnnotationElementValue__Group_0_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValue__Group_0_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueAccess().getGroup_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__Group_0_0__0__Impl"


    // $ANTLR start "rule__XAnnotationElementValue__Group_0_0_0__0"
    // InternalXbaseWithAnnotations.g:4240:1: rule__XAnnotationElementValue__Group_0_0_0__0 : rule__XAnnotationElementValue__Group_0_0_0__0__Impl rule__XAnnotationElementValue__Group_0_0_0__1 ;
    public final void rule__XAnnotationElementValue__Group_0_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4244:1: ( rule__XAnnotationElementValue__Group_0_0_0__0__Impl rule__XAnnotationElementValue__Group_0_0_0__1 )
            // InternalXbaseWithAnnotations.g:4245:2: rule__XAnnotationElementValue__Group_0_0_0__0__Impl rule__XAnnotationElementValue__Group_0_0_0__1
            {
            pushFollow(FOLLOW_13);
            rule__XAnnotationElementValue__Group_0_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValue__Group_0_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__Group_0_0_0__0"


    // $ANTLR start "rule__XAnnotationElementValue__Group_0_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:4252:1: rule__XAnnotationElementValue__Group_0_0_0__0__Impl : ( () ) ;
    public final void rule__XAnnotationElementValue__Group_0_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4256:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:4257:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:4257:1: ( () )
            // InternalXbaseWithAnnotations.g:4258:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueAccess().getXListLiteralAction_0_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:4259:2: ()
            // InternalXbaseWithAnnotations.g:4259:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueAccess().getXListLiteralAction_0_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__Group_0_0_0__0__Impl"


    // $ANTLR start "rule__XAnnotationElementValue__Group_0_0_0__1"
    // InternalXbaseWithAnnotations.g:4267:1: rule__XAnnotationElementValue__Group_0_0_0__1 : rule__XAnnotationElementValue__Group_0_0_0__1__Impl rule__XAnnotationElementValue__Group_0_0_0__2 ;
    public final void rule__XAnnotationElementValue__Group_0_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4271:1: ( rule__XAnnotationElementValue__Group_0_0_0__1__Impl rule__XAnnotationElementValue__Group_0_0_0__2 )
            // InternalXbaseWithAnnotations.g:4272:2: rule__XAnnotationElementValue__Group_0_0_0__1__Impl rule__XAnnotationElementValue__Group_0_0_0__2
            {
            pushFollow(FOLLOW_14);
            rule__XAnnotationElementValue__Group_0_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValue__Group_0_0_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__Group_0_0_0__1"


    // $ANTLR start "rule__XAnnotationElementValue__Group_0_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:4279:1: rule__XAnnotationElementValue__Group_0_0_0__1__Impl : ( '#' ) ;
    public final void rule__XAnnotationElementValue__Group_0_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4283:1: ( ( '#' ) )
            // InternalXbaseWithAnnotations.g:4284:1: ( '#' )
            {
            // InternalXbaseWithAnnotations.g:4284:1: ( '#' )
            // InternalXbaseWithAnnotations.g:4285:2: '#'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueAccess().getNumberSignKeyword_0_0_0_1()); 
            }
            match(input,56,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueAccess().getNumberSignKeyword_0_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__Group_0_0_0__1__Impl"


    // $ANTLR start "rule__XAnnotationElementValue__Group_0_0_0__2"
    // InternalXbaseWithAnnotations.g:4294:1: rule__XAnnotationElementValue__Group_0_0_0__2 : rule__XAnnotationElementValue__Group_0_0_0__2__Impl ;
    public final void rule__XAnnotationElementValue__Group_0_0_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4298:1: ( rule__XAnnotationElementValue__Group_0_0_0__2__Impl )
            // InternalXbaseWithAnnotations.g:4299:2: rule__XAnnotationElementValue__Group_0_0_0__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValue__Group_0_0_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__Group_0_0_0__2"


    // $ANTLR start "rule__XAnnotationElementValue__Group_0_0_0__2__Impl"
    // InternalXbaseWithAnnotations.g:4305:1: rule__XAnnotationElementValue__Group_0_0_0__2__Impl : ( '[' ) ;
    public final void rule__XAnnotationElementValue__Group_0_0_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4309:1: ( ( '[' ) )
            // InternalXbaseWithAnnotations.g:4310:1: ( '[' )
            {
            // InternalXbaseWithAnnotations.g:4310:1: ( '[' )
            // InternalXbaseWithAnnotations.g:4311:2: '['
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueAccess().getLeftSquareBracketKeyword_0_0_0_2()); 
            }
            match(input,57,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueAccess().getLeftSquareBracketKeyword_0_0_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__Group_0_0_0__2__Impl"


    // $ANTLR start "rule__XAnnotationElementValue__Group_0_1__0"
    // InternalXbaseWithAnnotations.g:4321:1: rule__XAnnotationElementValue__Group_0_1__0 : rule__XAnnotationElementValue__Group_0_1__0__Impl rule__XAnnotationElementValue__Group_0_1__1 ;
    public final void rule__XAnnotationElementValue__Group_0_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4325:1: ( rule__XAnnotationElementValue__Group_0_1__0__Impl rule__XAnnotationElementValue__Group_0_1__1 )
            // InternalXbaseWithAnnotations.g:4326:2: rule__XAnnotationElementValue__Group_0_1__0__Impl rule__XAnnotationElementValue__Group_0_1__1
            {
            pushFollow(FOLLOW_8);
            rule__XAnnotationElementValue__Group_0_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValue__Group_0_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__Group_0_1__0"


    // $ANTLR start "rule__XAnnotationElementValue__Group_0_1__0__Impl"
    // InternalXbaseWithAnnotations.g:4333:1: rule__XAnnotationElementValue__Group_0_1__0__Impl : ( ( rule__XAnnotationElementValue__ElementsAssignment_0_1_0 ) ) ;
    public final void rule__XAnnotationElementValue__Group_0_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4337:1: ( ( ( rule__XAnnotationElementValue__ElementsAssignment_0_1_0 ) ) )
            // InternalXbaseWithAnnotations.g:4338:1: ( ( rule__XAnnotationElementValue__ElementsAssignment_0_1_0 ) )
            {
            // InternalXbaseWithAnnotations.g:4338:1: ( ( rule__XAnnotationElementValue__ElementsAssignment_0_1_0 ) )
            // InternalXbaseWithAnnotations.g:4339:2: ( rule__XAnnotationElementValue__ElementsAssignment_0_1_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueAccess().getElementsAssignment_0_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:4340:2: ( rule__XAnnotationElementValue__ElementsAssignment_0_1_0 )
            // InternalXbaseWithAnnotations.g:4340:3: rule__XAnnotationElementValue__ElementsAssignment_0_1_0
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValue__ElementsAssignment_0_1_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueAccess().getElementsAssignment_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__Group_0_1__0__Impl"


    // $ANTLR start "rule__XAnnotationElementValue__Group_0_1__1"
    // InternalXbaseWithAnnotations.g:4348:1: rule__XAnnotationElementValue__Group_0_1__1 : rule__XAnnotationElementValue__Group_0_1__1__Impl ;
    public final void rule__XAnnotationElementValue__Group_0_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4352:1: ( rule__XAnnotationElementValue__Group_0_1__1__Impl )
            // InternalXbaseWithAnnotations.g:4353:2: rule__XAnnotationElementValue__Group_0_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValue__Group_0_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__Group_0_1__1"


    // $ANTLR start "rule__XAnnotationElementValue__Group_0_1__1__Impl"
    // InternalXbaseWithAnnotations.g:4359:1: rule__XAnnotationElementValue__Group_0_1__1__Impl : ( ( rule__XAnnotationElementValue__Group_0_1_1__0 )* ) ;
    public final void rule__XAnnotationElementValue__Group_0_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4363:1: ( ( ( rule__XAnnotationElementValue__Group_0_1_1__0 )* ) )
            // InternalXbaseWithAnnotations.g:4364:1: ( ( rule__XAnnotationElementValue__Group_0_1_1__0 )* )
            {
            // InternalXbaseWithAnnotations.g:4364:1: ( ( rule__XAnnotationElementValue__Group_0_1_1__0 )* )
            // InternalXbaseWithAnnotations.g:4365:2: ( rule__XAnnotationElementValue__Group_0_1_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueAccess().getGroup_0_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:4366:2: ( rule__XAnnotationElementValue__Group_0_1_1__0 )*
            loop53:
            do {
                int alt53=2;
                int LA53_0 = input.LA(1);

                if ( (LA53_0==54) ) {
                    alt53=1;
                }


                switch (alt53) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:4366:3: rule__XAnnotationElementValue__Group_0_1_1__0
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__XAnnotationElementValue__Group_0_1_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop53;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueAccess().getGroup_0_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__Group_0_1__1__Impl"


    // $ANTLR start "rule__XAnnotationElementValue__Group_0_1_1__0"
    // InternalXbaseWithAnnotations.g:4375:1: rule__XAnnotationElementValue__Group_0_1_1__0 : rule__XAnnotationElementValue__Group_0_1_1__0__Impl rule__XAnnotationElementValue__Group_0_1_1__1 ;
    public final void rule__XAnnotationElementValue__Group_0_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4379:1: ( rule__XAnnotationElementValue__Group_0_1_1__0__Impl rule__XAnnotationElementValue__Group_0_1_1__1 )
            // InternalXbaseWithAnnotations.g:4380:2: rule__XAnnotationElementValue__Group_0_1_1__0__Impl rule__XAnnotationElementValue__Group_0_1_1__1
            {
            pushFollow(FOLLOW_10);
            rule__XAnnotationElementValue__Group_0_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValue__Group_0_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__Group_0_1_1__0"


    // $ANTLR start "rule__XAnnotationElementValue__Group_0_1_1__0__Impl"
    // InternalXbaseWithAnnotations.g:4387:1: rule__XAnnotationElementValue__Group_0_1_1__0__Impl : ( ',' ) ;
    public final void rule__XAnnotationElementValue__Group_0_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4391:1: ( ( ',' ) )
            // InternalXbaseWithAnnotations.g:4392:1: ( ',' )
            {
            // InternalXbaseWithAnnotations.g:4392:1: ( ',' )
            // InternalXbaseWithAnnotations.g:4393:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueAccess().getCommaKeyword_0_1_1_0()); 
            }
            match(input,54,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueAccess().getCommaKeyword_0_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__Group_0_1_1__0__Impl"


    // $ANTLR start "rule__XAnnotationElementValue__Group_0_1_1__1"
    // InternalXbaseWithAnnotations.g:4402:1: rule__XAnnotationElementValue__Group_0_1_1__1 : rule__XAnnotationElementValue__Group_0_1_1__1__Impl ;
    public final void rule__XAnnotationElementValue__Group_0_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4406:1: ( rule__XAnnotationElementValue__Group_0_1_1__1__Impl )
            // InternalXbaseWithAnnotations.g:4407:2: rule__XAnnotationElementValue__Group_0_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValue__Group_0_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__Group_0_1_1__1"


    // $ANTLR start "rule__XAnnotationElementValue__Group_0_1_1__1__Impl"
    // InternalXbaseWithAnnotations.g:4413:1: rule__XAnnotationElementValue__Group_0_1_1__1__Impl : ( ( rule__XAnnotationElementValue__ElementsAssignment_0_1_1_1 ) ) ;
    public final void rule__XAnnotationElementValue__Group_0_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4417:1: ( ( ( rule__XAnnotationElementValue__ElementsAssignment_0_1_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:4418:1: ( ( rule__XAnnotationElementValue__ElementsAssignment_0_1_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:4418:1: ( ( rule__XAnnotationElementValue__ElementsAssignment_0_1_1_1 ) )
            // InternalXbaseWithAnnotations.g:4419:2: ( rule__XAnnotationElementValue__ElementsAssignment_0_1_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueAccess().getElementsAssignment_0_1_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:4420:2: ( rule__XAnnotationElementValue__ElementsAssignment_0_1_1_1 )
            // InternalXbaseWithAnnotations.g:4420:3: rule__XAnnotationElementValue__ElementsAssignment_0_1_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XAnnotationElementValue__ElementsAssignment_0_1_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueAccess().getElementsAssignment_0_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__Group_0_1_1__1__Impl"


    // $ANTLR start "rule__XAssignment__Group_0__0"
    // InternalXbaseWithAnnotations.g:4429:1: rule__XAssignment__Group_0__0 : rule__XAssignment__Group_0__0__Impl rule__XAssignment__Group_0__1 ;
    public final void rule__XAssignment__Group_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4433:1: ( rule__XAssignment__Group_0__0__Impl rule__XAssignment__Group_0__1 )
            // InternalXbaseWithAnnotations.g:4434:2: rule__XAssignment__Group_0__0__Impl rule__XAssignment__Group_0__1
            {
            pushFollow(FOLLOW_15);
            rule__XAssignment__Group_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_0__0"


    // $ANTLR start "rule__XAssignment__Group_0__0__Impl"
    // InternalXbaseWithAnnotations.g:4441:1: rule__XAssignment__Group_0__0__Impl : ( () ) ;
    public final void rule__XAssignment__Group_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4445:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:4446:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:4446:1: ( () )
            // InternalXbaseWithAnnotations.g:4447:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getXAssignmentAction_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:4448:2: ()
            // InternalXbaseWithAnnotations.g:4448:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getXAssignmentAction_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_0__0__Impl"


    // $ANTLR start "rule__XAssignment__Group_0__1"
    // InternalXbaseWithAnnotations.g:4456:1: rule__XAssignment__Group_0__1 : rule__XAssignment__Group_0__1__Impl rule__XAssignment__Group_0__2 ;
    public final void rule__XAssignment__Group_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4460:1: ( rule__XAssignment__Group_0__1__Impl rule__XAssignment__Group_0__2 )
            // InternalXbaseWithAnnotations.g:4461:2: rule__XAssignment__Group_0__1__Impl rule__XAssignment__Group_0__2
            {
            pushFollow(FOLLOW_11);
            rule__XAssignment__Group_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_0__1"


    // $ANTLR start "rule__XAssignment__Group_0__1__Impl"
    // InternalXbaseWithAnnotations.g:4468:1: rule__XAssignment__Group_0__1__Impl : ( ( rule__XAssignment__FeatureAssignment_0_1 ) ) ;
    public final void rule__XAssignment__Group_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4472:1: ( ( ( rule__XAssignment__FeatureAssignment_0_1 ) ) )
            // InternalXbaseWithAnnotations.g:4473:1: ( ( rule__XAssignment__FeatureAssignment_0_1 ) )
            {
            // InternalXbaseWithAnnotations.g:4473:1: ( ( rule__XAssignment__FeatureAssignment_0_1 ) )
            // InternalXbaseWithAnnotations.g:4474:2: ( rule__XAssignment__FeatureAssignment_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getFeatureAssignment_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:4475:2: ( rule__XAssignment__FeatureAssignment_0_1 )
            // InternalXbaseWithAnnotations.g:4475:3: rule__XAssignment__FeatureAssignment_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XAssignment__FeatureAssignment_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getFeatureAssignment_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_0__1__Impl"


    // $ANTLR start "rule__XAssignment__Group_0__2"
    // InternalXbaseWithAnnotations.g:4483:1: rule__XAssignment__Group_0__2 : rule__XAssignment__Group_0__2__Impl rule__XAssignment__Group_0__3 ;
    public final void rule__XAssignment__Group_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4487:1: ( rule__XAssignment__Group_0__2__Impl rule__XAssignment__Group_0__3 )
            // InternalXbaseWithAnnotations.g:4488:2: rule__XAssignment__Group_0__2__Impl rule__XAssignment__Group_0__3
            {
            pushFollow(FOLLOW_10);
            rule__XAssignment__Group_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_0__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_0__2"


    // $ANTLR start "rule__XAssignment__Group_0__2__Impl"
    // InternalXbaseWithAnnotations.g:4495:1: rule__XAssignment__Group_0__2__Impl : ( ruleOpSingleAssign ) ;
    public final void rule__XAssignment__Group_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4499:1: ( ( ruleOpSingleAssign ) )
            // InternalXbaseWithAnnotations.g:4500:1: ( ruleOpSingleAssign )
            {
            // InternalXbaseWithAnnotations.g:4500:1: ( ruleOpSingleAssign )
            // InternalXbaseWithAnnotations.g:4501:2: ruleOpSingleAssign
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getOpSingleAssignParserRuleCall_0_2()); 
            }
            pushFollow(FOLLOW_2);
            ruleOpSingleAssign();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getOpSingleAssignParserRuleCall_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_0__2__Impl"


    // $ANTLR start "rule__XAssignment__Group_0__3"
    // InternalXbaseWithAnnotations.g:4510:1: rule__XAssignment__Group_0__3 : rule__XAssignment__Group_0__3__Impl ;
    public final void rule__XAssignment__Group_0__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4514:1: ( rule__XAssignment__Group_0__3__Impl )
            // InternalXbaseWithAnnotations.g:4515:2: rule__XAssignment__Group_0__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_0__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_0__3"


    // $ANTLR start "rule__XAssignment__Group_0__3__Impl"
    // InternalXbaseWithAnnotations.g:4521:1: rule__XAssignment__Group_0__3__Impl : ( ( rule__XAssignment__ValueAssignment_0_3 ) ) ;
    public final void rule__XAssignment__Group_0__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4525:1: ( ( ( rule__XAssignment__ValueAssignment_0_3 ) ) )
            // InternalXbaseWithAnnotations.g:4526:1: ( ( rule__XAssignment__ValueAssignment_0_3 ) )
            {
            // InternalXbaseWithAnnotations.g:4526:1: ( ( rule__XAssignment__ValueAssignment_0_3 ) )
            // InternalXbaseWithAnnotations.g:4527:2: ( rule__XAssignment__ValueAssignment_0_3 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getValueAssignment_0_3()); 
            }
            // InternalXbaseWithAnnotations.g:4528:2: ( rule__XAssignment__ValueAssignment_0_3 )
            // InternalXbaseWithAnnotations.g:4528:3: rule__XAssignment__ValueAssignment_0_3
            {
            pushFollow(FOLLOW_2);
            rule__XAssignment__ValueAssignment_0_3();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getValueAssignment_0_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_0__3__Impl"


    // $ANTLR start "rule__XAssignment__Group_1__0"
    // InternalXbaseWithAnnotations.g:4537:1: rule__XAssignment__Group_1__0 : rule__XAssignment__Group_1__0__Impl rule__XAssignment__Group_1__1 ;
    public final void rule__XAssignment__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4541:1: ( rule__XAssignment__Group_1__0__Impl rule__XAssignment__Group_1__1 )
            // InternalXbaseWithAnnotations.g:4542:2: rule__XAssignment__Group_1__0__Impl rule__XAssignment__Group_1__1
            {
            pushFollow(FOLLOW_16);
            rule__XAssignment__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1__0"


    // $ANTLR start "rule__XAssignment__Group_1__0__Impl"
    // InternalXbaseWithAnnotations.g:4549:1: rule__XAssignment__Group_1__0__Impl : ( ruleXOrExpression ) ;
    public final void rule__XAssignment__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4553:1: ( ( ruleXOrExpression ) )
            // InternalXbaseWithAnnotations.g:4554:1: ( ruleXOrExpression )
            {
            // InternalXbaseWithAnnotations.g:4554:1: ( ruleXOrExpression )
            // InternalXbaseWithAnnotations.g:4555:2: ruleXOrExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getXOrExpressionParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXOrExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getXOrExpressionParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1__0__Impl"


    // $ANTLR start "rule__XAssignment__Group_1__1"
    // InternalXbaseWithAnnotations.g:4564:1: rule__XAssignment__Group_1__1 : rule__XAssignment__Group_1__1__Impl ;
    public final void rule__XAssignment__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4568:1: ( rule__XAssignment__Group_1__1__Impl )
            // InternalXbaseWithAnnotations.g:4569:2: rule__XAssignment__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1__1"


    // $ANTLR start "rule__XAssignment__Group_1__1__Impl"
    // InternalXbaseWithAnnotations.g:4575:1: rule__XAssignment__Group_1__1__Impl : ( ( rule__XAssignment__Group_1_1__0 )? ) ;
    public final void rule__XAssignment__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4579:1: ( ( ( rule__XAssignment__Group_1_1__0 )? ) )
            // InternalXbaseWithAnnotations.g:4580:1: ( ( rule__XAssignment__Group_1_1__0 )? )
            {
            // InternalXbaseWithAnnotations.g:4580:1: ( ( rule__XAssignment__Group_1_1__0 )? )
            // InternalXbaseWithAnnotations.g:4581:2: ( rule__XAssignment__Group_1_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getGroup_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:4582:2: ( rule__XAssignment__Group_1_1__0 )?
            int alt54=2;
            alt54 = dfa54.predict(input);
            switch (alt54) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:4582:3: rule__XAssignment__Group_1_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XAssignment__Group_1_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getGroup_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1__1__Impl"


    // $ANTLR start "rule__XAssignment__Group_1_1__0"
    // InternalXbaseWithAnnotations.g:4591:1: rule__XAssignment__Group_1_1__0 : rule__XAssignment__Group_1_1__0__Impl rule__XAssignment__Group_1_1__1 ;
    public final void rule__XAssignment__Group_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4595:1: ( rule__XAssignment__Group_1_1__0__Impl rule__XAssignment__Group_1_1__1 )
            // InternalXbaseWithAnnotations.g:4596:2: rule__XAssignment__Group_1_1__0__Impl rule__XAssignment__Group_1_1__1
            {
            pushFollow(FOLLOW_10);
            rule__XAssignment__Group_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1_1__0"


    // $ANTLR start "rule__XAssignment__Group_1_1__0__Impl"
    // InternalXbaseWithAnnotations.g:4603:1: rule__XAssignment__Group_1_1__0__Impl : ( ( rule__XAssignment__Group_1_1_0__0 ) ) ;
    public final void rule__XAssignment__Group_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4607:1: ( ( ( rule__XAssignment__Group_1_1_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:4608:1: ( ( rule__XAssignment__Group_1_1_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:4608:1: ( ( rule__XAssignment__Group_1_1_0__0 ) )
            // InternalXbaseWithAnnotations.g:4609:2: ( rule__XAssignment__Group_1_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getGroup_1_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:4610:2: ( rule__XAssignment__Group_1_1_0__0 )
            // InternalXbaseWithAnnotations.g:4610:3: rule__XAssignment__Group_1_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_1_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getGroup_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1_1__0__Impl"


    // $ANTLR start "rule__XAssignment__Group_1_1__1"
    // InternalXbaseWithAnnotations.g:4618:1: rule__XAssignment__Group_1_1__1 : rule__XAssignment__Group_1_1__1__Impl ;
    public final void rule__XAssignment__Group_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4622:1: ( rule__XAssignment__Group_1_1__1__Impl )
            // InternalXbaseWithAnnotations.g:4623:2: rule__XAssignment__Group_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1_1__1"


    // $ANTLR start "rule__XAssignment__Group_1_1__1__Impl"
    // InternalXbaseWithAnnotations.g:4629:1: rule__XAssignment__Group_1_1__1__Impl : ( ( rule__XAssignment__RightOperandAssignment_1_1_1 ) ) ;
    public final void rule__XAssignment__Group_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4633:1: ( ( ( rule__XAssignment__RightOperandAssignment_1_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:4634:1: ( ( rule__XAssignment__RightOperandAssignment_1_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:4634:1: ( ( rule__XAssignment__RightOperandAssignment_1_1_1 ) )
            // InternalXbaseWithAnnotations.g:4635:2: ( rule__XAssignment__RightOperandAssignment_1_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getRightOperandAssignment_1_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:4636:2: ( rule__XAssignment__RightOperandAssignment_1_1_1 )
            // InternalXbaseWithAnnotations.g:4636:3: rule__XAssignment__RightOperandAssignment_1_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XAssignment__RightOperandAssignment_1_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getRightOperandAssignment_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1_1__1__Impl"


    // $ANTLR start "rule__XAssignment__Group_1_1_0__0"
    // InternalXbaseWithAnnotations.g:4645:1: rule__XAssignment__Group_1_1_0__0 : rule__XAssignment__Group_1_1_0__0__Impl ;
    public final void rule__XAssignment__Group_1_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4649:1: ( rule__XAssignment__Group_1_1_0__0__Impl )
            // InternalXbaseWithAnnotations.g:4650:2: rule__XAssignment__Group_1_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_1_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1_1_0__0"


    // $ANTLR start "rule__XAssignment__Group_1_1_0__0__Impl"
    // InternalXbaseWithAnnotations.g:4656:1: rule__XAssignment__Group_1_1_0__0__Impl : ( ( rule__XAssignment__Group_1_1_0_0__0 ) ) ;
    public final void rule__XAssignment__Group_1_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4660:1: ( ( ( rule__XAssignment__Group_1_1_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:4661:1: ( ( rule__XAssignment__Group_1_1_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:4661:1: ( ( rule__XAssignment__Group_1_1_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:4662:2: ( rule__XAssignment__Group_1_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getGroup_1_1_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:4663:2: ( rule__XAssignment__Group_1_1_0_0__0 )
            // InternalXbaseWithAnnotations.g:4663:3: rule__XAssignment__Group_1_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_1_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getGroup_1_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1_1_0__0__Impl"


    // $ANTLR start "rule__XAssignment__Group_1_1_0_0__0"
    // InternalXbaseWithAnnotations.g:4672:1: rule__XAssignment__Group_1_1_0_0__0 : rule__XAssignment__Group_1_1_0_0__0__Impl rule__XAssignment__Group_1_1_0_0__1 ;
    public final void rule__XAssignment__Group_1_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4676:1: ( rule__XAssignment__Group_1_1_0_0__0__Impl rule__XAssignment__Group_1_1_0_0__1 )
            // InternalXbaseWithAnnotations.g:4677:2: rule__XAssignment__Group_1_1_0_0__0__Impl rule__XAssignment__Group_1_1_0_0__1
            {
            pushFollow(FOLLOW_16);
            rule__XAssignment__Group_1_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_1_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1_1_0_0__0"


    // $ANTLR start "rule__XAssignment__Group_1_1_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:4684:1: rule__XAssignment__Group_1_1_0_0__0__Impl : ( () ) ;
    public final void rule__XAssignment__Group_1_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4688:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:4689:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:4689:1: ( () )
            // InternalXbaseWithAnnotations.g:4690:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getXBinaryOperationLeftOperandAction_1_1_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:4691:2: ()
            // InternalXbaseWithAnnotations.g:4691:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getXBinaryOperationLeftOperandAction_1_1_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1_1_0_0__0__Impl"


    // $ANTLR start "rule__XAssignment__Group_1_1_0_0__1"
    // InternalXbaseWithAnnotations.g:4699:1: rule__XAssignment__Group_1_1_0_0__1 : rule__XAssignment__Group_1_1_0_0__1__Impl ;
    public final void rule__XAssignment__Group_1_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4703:1: ( rule__XAssignment__Group_1_1_0_0__1__Impl )
            // InternalXbaseWithAnnotations.g:4704:2: rule__XAssignment__Group_1_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAssignment__Group_1_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1_1_0_0__1"


    // $ANTLR start "rule__XAssignment__Group_1_1_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:4710:1: rule__XAssignment__Group_1_1_0_0__1__Impl : ( ( rule__XAssignment__FeatureAssignment_1_1_0_0_1 ) ) ;
    public final void rule__XAssignment__Group_1_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4714:1: ( ( ( rule__XAssignment__FeatureAssignment_1_1_0_0_1 ) ) )
            // InternalXbaseWithAnnotations.g:4715:1: ( ( rule__XAssignment__FeatureAssignment_1_1_0_0_1 ) )
            {
            // InternalXbaseWithAnnotations.g:4715:1: ( ( rule__XAssignment__FeatureAssignment_1_1_0_0_1 ) )
            // InternalXbaseWithAnnotations.g:4716:2: ( rule__XAssignment__FeatureAssignment_1_1_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getFeatureAssignment_1_1_0_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:4717:2: ( rule__XAssignment__FeatureAssignment_1_1_0_0_1 )
            // InternalXbaseWithAnnotations.g:4717:3: rule__XAssignment__FeatureAssignment_1_1_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XAssignment__FeatureAssignment_1_1_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getFeatureAssignment_1_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__Group_1_1_0_0__1__Impl"


    // $ANTLR start "rule__OpMultiAssign__Group_5__0"
    // InternalXbaseWithAnnotations.g:4726:1: rule__OpMultiAssign__Group_5__0 : rule__OpMultiAssign__Group_5__0__Impl rule__OpMultiAssign__Group_5__1 ;
    public final void rule__OpMultiAssign__Group_5__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4730:1: ( rule__OpMultiAssign__Group_5__0__Impl rule__OpMultiAssign__Group_5__1 )
            // InternalXbaseWithAnnotations.g:4731:2: rule__OpMultiAssign__Group_5__0__Impl rule__OpMultiAssign__Group_5__1
            {
            pushFollow(FOLLOW_17);
            rule__OpMultiAssign__Group_5__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__OpMultiAssign__Group_5__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Group_5__0"


    // $ANTLR start "rule__OpMultiAssign__Group_5__0__Impl"
    // InternalXbaseWithAnnotations.g:4738:1: rule__OpMultiAssign__Group_5__0__Impl : ( '<' ) ;
    public final void rule__OpMultiAssign__Group_5__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4742:1: ( ( '<' ) )
            // InternalXbaseWithAnnotations.g:4743:1: ( '<' )
            {
            // InternalXbaseWithAnnotations.g:4743:1: ( '<' )
            // InternalXbaseWithAnnotations.g:4744:2: '<'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpMultiAssignAccess().getLessThanSignKeyword_5_0()); 
            }
            match(input,27,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpMultiAssignAccess().getLessThanSignKeyword_5_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Group_5__0__Impl"


    // $ANTLR start "rule__OpMultiAssign__Group_5__1"
    // InternalXbaseWithAnnotations.g:4753:1: rule__OpMultiAssign__Group_5__1 : rule__OpMultiAssign__Group_5__1__Impl rule__OpMultiAssign__Group_5__2 ;
    public final void rule__OpMultiAssign__Group_5__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4757:1: ( rule__OpMultiAssign__Group_5__1__Impl rule__OpMultiAssign__Group_5__2 )
            // InternalXbaseWithAnnotations.g:4758:2: rule__OpMultiAssign__Group_5__1__Impl rule__OpMultiAssign__Group_5__2
            {
            pushFollow(FOLLOW_11);
            rule__OpMultiAssign__Group_5__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__OpMultiAssign__Group_5__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Group_5__1"


    // $ANTLR start "rule__OpMultiAssign__Group_5__1__Impl"
    // InternalXbaseWithAnnotations.g:4765:1: rule__OpMultiAssign__Group_5__1__Impl : ( '<' ) ;
    public final void rule__OpMultiAssign__Group_5__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4769:1: ( ( '<' ) )
            // InternalXbaseWithAnnotations.g:4770:1: ( '<' )
            {
            // InternalXbaseWithAnnotations.g:4770:1: ( '<' )
            // InternalXbaseWithAnnotations.g:4771:2: '<'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpMultiAssignAccess().getLessThanSignKeyword_5_1()); 
            }
            match(input,27,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpMultiAssignAccess().getLessThanSignKeyword_5_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Group_5__1__Impl"


    // $ANTLR start "rule__OpMultiAssign__Group_5__2"
    // InternalXbaseWithAnnotations.g:4780:1: rule__OpMultiAssign__Group_5__2 : rule__OpMultiAssign__Group_5__2__Impl ;
    public final void rule__OpMultiAssign__Group_5__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4784:1: ( rule__OpMultiAssign__Group_5__2__Impl )
            // InternalXbaseWithAnnotations.g:4785:2: rule__OpMultiAssign__Group_5__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__OpMultiAssign__Group_5__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Group_5__2"


    // $ANTLR start "rule__OpMultiAssign__Group_5__2__Impl"
    // InternalXbaseWithAnnotations.g:4791:1: rule__OpMultiAssign__Group_5__2__Impl : ( '=' ) ;
    public final void rule__OpMultiAssign__Group_5__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4795:1: ( ( '=' ) )
            // InternalXbaseWithAnnotations.g:4796:1: ( '=' )
            {
            // InternalXbaseWithAnnotations.g:4796:1: ( '=' )
            // InternalXbaseWithAnnotations.g:4797:2: '='
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpMultiAssignAccess().getEqualsSignKeyword_5_2()); 
            }
            match(input,13,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpMultiAssignAccess().getEqualsSignKeyword_5_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Group_5__2__Impl"


    // $ANTLR start "rule__OpMultiAssign__Group_6__0"
    // InternalXbaseWithAnnotations.g:4807:1: rule__OpMultiAssign__Group_6__0 : rule__OpMultiAssign__Group_6__0__Impl rule__OpMultiAssign__Group_6__1 ;
    public final void rule__OpMultiAssign__Group_6__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4811:1: ( rule__OpMultiAssign__Group_6__0__Impl rule__OpMultiAssign__Group_6__1 )
            // InternalXbaseWithAnnotations.g:4812:2: rule__OpMultiAssign__Group_6__0__Impl rule__OpMultiAssign__Group_6__1
            {
            pushFollow(FOLLOW_18);
            rule__OpMultiAssign__Group_6__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__OpMultiAssign__Group_6__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Group_6__0"


    // $ANTLR start "rule__OpMultiAssign__Group_6__0__Impl"
    // InternalXbaseWithAnnotations.g:4819:1: rule__OpMultiAssign__Group_6__0__Impl : ( '>' ) ;
    public final void rule__OpMultiAssign__Group_6__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4823:1: ( ( '>' ) )
            // InternalXbaseWithAnnotations.g:4824:1: ( '>' )
            {
            // InternalXbaseWithAnnotations.g:4824:1: ( '>' )
            // InternalXbaseWithAnnotations.g:4825:2: '>'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpMultiAssignAccess().getGreaterThanSignKeyword_6_0()); 
            }
            match(input,26,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpMultiAssignAccess().getGreaterThanSignKeyword_6_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Group_6__0__Impl"


    // $ANTLR start "rule__OpMultiAssign__Group_6__1"
    // InternalXbaseWithAnnotations.g:4834:1: rule__OpMultiAssign__Group_6__1 : rule__OpMultiAssign__Group_6__1__Impl rule__OpMultiAssign__Group_6__2 ;
    public final void rule__OpMultiAssign__Group_6__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4838:1: ( rule__OpMultiAssign__Group_6__1__Impl rule__OpMultiAssign__Group_6__2 )
            // InternalXbaseWithAnnotations.g:4839:2: rule__OpMultiAssign__Group_6__1__Impl rule__OpMultiAssign__Group_6__2
            {
            pushFollow(FOLLOW_18);
            rule__OpMultiAssign__Group_6__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__OpMultiAssign__Group_6__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Group_6__1"


    // $ANTLR start "rule__OpMultiAssign__Group_6__1__Impl"
    // InternalXbaseWithAnnotations.g:4846:1: rule__OpMultiAssign__Group_6__1__Impl : ( ( '>' )? ) ;
    public final void rule__OpMultiAssign__Group_6__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4850:1: ( ( ( '>' )? ) )
            // InternalXbaseWithAnnotations.g:4851:1: ( ( '>' )? )
            {
            // InternalXbaseWithAnnotations.g:4851:1: ( ( '>' )? )
            // InternalXbaseWithAnnotations.g:4852:2: ( '>' )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpMultiAssignAccess().getGreaterThanSignKeyword_6_1()); 
            }
            // InternalXbaseWithAnnotations.g:4853:2: ( '>' )?
            int alt55=2;
            int LA55_0 = input.LA(1);

            if ( (LA55_0==26) ) {
                alt55=1;
            }
            switch (alt55) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:4853:3: '>'
                    {
                    match(input,26,FOLLOW_2); if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpMultiAssignAccess().getGreaterThanSignKeyword_6_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Group_6__1__Impl"


    // $ANTLR start "rule__OpMultiAssign__Group_6__2"
    // InternalXbaseWithAnnotations.g:4861:1: rule__OpMultiAssign__Group_6__2 : rule__OpMultiAssign__Group_6__2__Impl ;
    public final void rule__OpMultiAssign__Group_6__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4865:1: ( rule__OpMultiAssign__Group_6__2__Impl )
            // InternalXbaseWithAnnotations.g:4866:2: rule__OpMultiAssign__Group_6__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__OpMultiAssign__Group_6__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Group_6__2"


    // $ANTLR start "rule__OpMultiAssign__Group_6__2__Impl"
    // InternalXbaseWithAnnotations.g:4872:1: rule__OpMultiAssign__Group_6__2__Impl : ( '>=' ) ;
    public final void rule__OpMultiAssign__Group_6__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4876:1: ( ( '>=' ) )
            // InternalXbaseWithAnnotations.g:4877:1: ( '>=' )
            {
            // InternalXbaseWithAnnotations.g:4877:1: ( '>=' )
            // InternalXbaseWithAnnotations.g:4878:2: '>='
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpMultiAssignAccess().getGreaterThanSignEqualsSignKeyword_6_2()); 
            }
            match(input,25,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpMultiAssignAccess().getGreaterThanSignEqualsSignKeyword_6_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpMultiAssign__Group_6__2__Impl"


    // $ANTLR start "rule__XOrExpression__Group__0"
    // InternalXbaseWithAnnotations.g:4888:1: rule__XOrExpression__Group__0 : rule__XOrExpression__Group__0__Impl rule__XOrExpression__Group__1 ;
    public final void rule__XOrExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4892:1: ( rule__XOrExpression__Group__0__Impl rule__XOrExpression__Group__1 )
            // InternalXbaseWithAnnotations.g:4893:2: rule__XOrExpression__Group__0__Impl rule__XOrExpression__Group__1
            {
            pushFollow(FOLLOW_19);
            rule__XOrExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XOrExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group__0"


    // $ANTLR start "rule__XOrExpression__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:4900:1: rule__XOrExpression__Group__0__Impl : ( ruleXAndExpression ) ;
    public final void rule__XOrExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4904:1: ( ( ruleXAndExpression ) )
            // InternalXbaseWithAnnotations.g:4905:1: ( ruleXAndExpression )
            {
            // InternalXbaseWithAnnotations.g:4905:1: ( ruleXAndExpression )
            // InternalXbaseWithAnnotations.g:4906:2: ruleXAndExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOrExpressionAccess().getXAndExpressionParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAndExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOrExpressionAccess().getXAndExpressionParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group__0__Impl"


    // $ANTLR start "rule__XOrExpression__Group__1"
    // InternalXbaseWithAnnotations.g:4915:1: rule__XOrExpression__Group__1 : rule__XOrExpression__Group__1__Impl ;
    public final void rule__XOrExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4919:1: ( rule__XOrExpression__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:4920:2: rule__XOrExpression__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XOrExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group__1"


    // $ANTLR start "rule__XOrExpression__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:4926:1: rule__XOrExpression__Group__1__Impl : ( ( rule__XOrExpression__Group_1__0 )* ) ;
    public final void rule__XOrExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4930:1: ( ( ( rule__XOrExpression__Group_1__0 )* ) )
            // InternalXbaseWithAnnotations.g:4931:1: ( ( rule__XOrExpression__Group_1__0 )* )
            {
            // InternalXbaseWithAnnotations.g:4931:1: ( ( rule__XOrExpression__Group_1__0 )* )
            // InternalXbaseWithAnnotations.g:4932:2: ( rule__XOrExpression__Group_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOrExpressionAccess().getGroup_1()); 
            }
            // InternalXbaseWithAnnotations.g:4933:2: ( rule__XOrExpression__Group_1__0 )*
            loop56:
            do {
                int alt56=2;
                int LA56_0 = input.LA(1);

                if ( (LA56_0==14) ) {
                    int LA56_2 = input.LA(2);

                    if ( (synpred99_InternalXbaseWithAnnotations()) ) {
                        alt56=1;
                    }


                }


                switch (alt56) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:4933:3: rule__XOrExpression__Group_1__0
            	    {
            	    pushFollow(FOLLOW_20);
            	    rule__XOrExpression__Group_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop56;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOrExpressionAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group__1__Impl"


    // $ANTLR start "rule__XOrExpression__Group_1__0"
    // InternalXbaseWithAnnotations.g:4942:1: rule__XOrExpression__Group_1__0 : rule__XOrExpression__Group_1__0__Impl rule__XOrExpression__Group_1__1 ;
    public final void rule__XOrExpression__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4946:1: ( rule__XOrExpression__Group_1__0__Impl rule__XOrExpression__Group_1__1 )
            // InternalXbaseWithAnnotations.g:4947:2: rule__XOrExpression__Group_1__0__Impl rule__XOrExpression__Group_1__1
            {
            pushFollow(FOLLOW_10);
            rule__XOrExpression__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XOrExpression__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group_1__0"


    // $ANTLR start "rule__XOrExpression__Group_1__0__Impl"
    // InternalXbaseWithAnnotations.g:4954:1: rule__XOrExpression__Group_1__0__Impl : ( ( rule__XOrExpression__Group_1_0__0 ) ) ;
    public final void rule__XOrExpression__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4958:1: ( ( ( rule__XOrExpression__Group_1_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:4959:1: ( ( rule__XOrExpression__Group_1_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:4959:1: ( ( rule__XOrExpression__Group_1_0__0 ) )
            // InternalXbaseWithAnnotations.g:4960:2: ( rule__XOrExpression__Group_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOrExpressionAccess().getGroup_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:4961:2: ( rule__XOrExpression__Group_1_0__0 )
            // InternalXbaseWithAnnotations.g:4961:3: rule__XOrExpression__Group_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XOrExpression__Group_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOrExpressionAccess().getGroup_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group_1__0__Impl"


    // $ANTLR start "rule__XOrExpression__Group_1__1"
    // InternalXbaseWithAnnotations.g:4969:1: rule__XOrExpression__Group_1__1 : rule__XOrExpression__Group_1__1__Impl ;
    public final void rule__XOrExpression__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4973:1: ( rule__XOrExpression__Group_1__1__Impl )
            // InternalXbaseWithAnnotations.g:4974:2: rule__XOrExpression__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XOrExpression__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group_1__1"


    // $ANTLR start "rule__XOrExpression__Group_1__1__Impl"
    // InternalXbaseWithAnnotations.g:4980:1: rule__XOrExpression__Group_1__1__Impl : ( ( rule__XOrExpression__RightOperandAssignment_1_1 ) ) ;
    public final void rule__XOrExpression__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:4984:1: ( ( ( rule__XOrExpression__RightOperandAssignment_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:4985:1: ( ( rule__XOrExpression__RightOperandAssignment_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:4985:1: ( ( rule__XOrExpression__RightOperandAssignment_1_1 ) )
            // InternalXbaseWithAnnotations.g:4986:2: ( rule__XOrExpression__RightOperandAssignment_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOrExpressionAccess().getRightOperandAssignment_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:4987:2: ( rule__XOrExpression__RightOperandAssignment_1_1 )
            // InternalXbaseWithAnnotations.g:4987:3: rule__XOrExpression__RightOperandAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XOrExpression__RightOperandAssignment_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOrExpressionAccess().getRightOperandAssignment_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group_1__1__Impl"


    // $ANTLR start "rule__XOrExpression__Group_1_0__0"
    // InternalXbaseWithAnnotations.g:4996:1: rule__XOrExpression__Group_1_0__0 : rule__XOrExpression__Group_1_0__0__Impl ;
    public final void rule__XOrExpression__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5000:1: ( rule__XOrExpression__Group_1_0__0__Impl )
            // InternalXbaseWithAnnotations.g:5001:2: rule__XOrExpression__Group_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XOrExpression__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group_1_0__0"


    // $ANTLR start "rule__XOrExpression__Group_1_0__0__Impl"
    // InternalXbaseWithAnnotations.g:5007:1: rule__XOrExpression__Group_1_0__0__Impl : ( ( rule__XOrExpression__Group_1_0_0__0 ) ) ;
    public final void rule__XOrExpression__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5011:1: ( ( ( rule__XOrExpression__Group_1_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:5012:1: ( ( rule__XOrExpression__Group_1_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:5012:1: ( ( rule__XOrExpression__Group_1_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:5013:2: ( rule__XOrExpression__Group_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOrExpressionAccess().getGroup_1_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:5014:2: ( rule__XOrExpression__Group_1_0_0__0 )
            // InternalXbaseWithAnnotations.g:5014:3: rule__XOrExpression__Group_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XOrExpression__Group_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOrExpressionAccess().getGroup_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group_1_0__0__Impl"


    // $ANTLR start "rule__XOrExpression__Group_1_0_0__0"
    // InternalXbaseWithAnnotations.g:5023:1: rule__XOrExpression__Group_1_0_0__0 : rule__XOrExpression__Group_1_0_0__0__Impl rule__XOrExpression__Group_1_0_0__1 ;
    public final void rule__XOrExpression__Group_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5027:1: ( rule__XOrExpression__Group_1_0_0__0__Impl rule__XOrExpression__Group_1_0_0__1 )
            // InternalXbaseWithAnnotations.g:5028:2: rule__XOrExpression__Group_1_0_0__0__Impl rule__XOrExpression__Group_1_0_0__1
            {
            pushFollow(FOLLOW_19);
            rule__XOrExpression__Group_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XOrExpression__Group_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group_1_0_0__0"


    // $ANTLR start "rule__XOrExpression__Group_1_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:5035:1: rule__XOrExpression__Group_1_0_0__0__Impl : ( () ) ;
    public final void rule__XOrExpression__Group_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5039:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:5040:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:5040:1: ( () )
            // InternalXbaseWithAnnotations.g:5041:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOrExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:5042:2: ()
            // InternalXbaseWithAnnotations.g:5042:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOrExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group_1_0_0__0__Impl"


    // $ANTLR start "rule__XOrExpression__Group_1_0_0__1"
    // InternalXbaseWithAnnotations.g:5050:1: rule__XOrExpression__Group_1_0_0__1 : rule__XOrExpression__Group_1_0_0__1__Impl ;
    public final void rule__XOrExpression__Group_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5054:1: ( rule__XOrExpression__Group_1_0_0__1__Impl )
            // InternalXbaseWithAnnotations.g:5055:2: rule__XOrExpression__Group_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XOrExpression__Group_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group_1_0_0__1"


    // $ANTLR start "rule__XOrExpression__Group_1_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:5061:1: rule__XOrExpression__Group_1_0_0__1__Impl : ( ( rule__XOrExpression__FeatureAssignment_1_0_0_1 ) ) ;
    public final void rule__XOrExpression__Group_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5065:1: ( ( ( rule__XOrExpression__FeatureAssignment_1_0_0_1 ) ) )
            // InternalXbaseWithAnnotations.g:5066:1: ( ( rule__XOrExpression__FeatureAssignment_1_0_0_1 ) )
            {
            // InternalXbaseWithAnnotations.g:5066:1: ( ( rule__XOrExpression__FeatureAssignment_1_0_0_1 ) )
            // InternalXbaseWithAnnotations.g:5067:2: ( rule__XOrExpression__FeatureAssignment_1_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOrExpressionAccess().getFeatureAssignment_1_0_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:5068:2: ( rule__XOrExpression__FeatureAssignment_1_0_0_1 )
            // InternalXbaseWithAnnotations.g:5068:3: rule__XOrExpression__FeatureAssignment_1_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XOrExpression__FeatureAssignment_1_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOrExpressionAccess().getFeatureAssignment_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__Group_1_0_0__1__Impl"


    // $ANTLR start "rule__XAndExpression__Group__0"
    // InternalXbaseWithAnnotations.g:5077:1: rule__XAndExpression__Group__0 : rule__XAndExpression__Group__0__Impl rule__XAndExpression__Group__1 ;
    public final void rule__XAndExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5081:1: ( rule__XAndExpression__Group__0__Impl rule__XAndExpression__Group__1 )
            // InternalXbaseWithAnnotations.g:5082:2: rule__XAndExpression__Group__0__Impl rule__XAndExpression__Group__1
            {
            pushFollow(FOLLOW_21);
            rule__XAndExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAndExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group__0"


    // $ANTLR start "rule__XAndExpression__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:5089:1: rule__XAndExpression__Group__0__Impl : ( ruleXEqualityExpression ) ;
    public final void rule__XAndExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5093:1: ( ( ruleXEqualityExpression ) )
            // InternalXbaseWithAnnotations.g:5094:1: ( ruleXEqualityExpression )
            {
            // InternalXbaseWithAnnotations.g:5094:1: ( ruleXEqualityExpression )
            // InternalXbaseWithAnnotations.g:5095:2: ruleXEqualityExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAndExpressionAccess().getXEqualityExpressionParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXEqualityExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAndExpressionAccess().getXEqualityExpressionParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group__0__Impl"


    // $ANTLR start "rule__XAndExpression__Group__1"
    // InternalXbaseWithAnnotations.g:5104:1: rule__XAndExpression__Group__1 : rule__XAndExpression__Group__1__Impl ;
    public final void rule__XAndExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5108:1: ( rule__XAndExpression__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:5109:2: rule__XAndExpression__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAndExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group__1"


    // $ANTLR start "rule__XAndExpression__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:5115:1: rule__XAndExpression__Group__1__Impl : ( ( rule__XAndExpression__Group_1__0 )* ) ;
    public final void rule__XAndExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5119:1: ( ( ( rule__XAndExpression__Group_1__0 )* ) )
            // InternalXbaseWithAnnotations.g:5120:1: ( ( rule__XAndExpression__Group_1__0 )* )
            {
            // InternalXbaseWithAnnotations.g:5120:1: ( ( rule__XAndExpression__Group_1__0 )* )
            // InternalXbaseWithAnnotations.g:5121:2: ( rule__XAndExpression__Group_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAndExpressionAccess().getGroup_1()); 
            }
            // InternalXbaseWithAnnotations.g:5122:2: ( rule__XAndExpression__Group_1__0 )*
            loop57:
            do {
                int alt57=2;
                int LA57_0 = input.LA(1);

                if ( (LA57_0==15) ) {
                    int LA57_2 = input.LA(2);

                    if ( (synpred100_InternalXbaseWithAnnotations()) ) {
                        alt57=1;
                    }


                }


                switch (alt57) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:5122:3: rule__XAndExpression__Group_1__0
            	    {
            	    pushFollow(FOLLOW_22);
            	    rule__XAndExpression__Group_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop57;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAndExpressionAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group__1__Impl"


    // $ANTLR start "rule__XAndExpression__Group_1__0"
    // InternalXbaseWithAnnotations.g:5131:1: rule__XAndExpression__Group_1__0 : rule__XAndExpression__Group_1__0__Impl rule__XAndExpression__Group_1__1 ;
    public final void rule__XAndExpression__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5135:1: ( rule__XAndExpression__Group_1__0__Impl rule__XAndExpression__Group_1__1 )
            // InternalXbaseWithAnnotations.g:5136:2: rule__XAndExpression__Group_1__0__Impl rule__XAndExpression__Group_1__1
            {
            pushFollow(FOLLOW_10);
            rule__XAndExpression__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAndExpression__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group_1__0"


    // $ANTLR start "rule__XAndExpression__Group_1__0__Impl"
    // InternalXbaseWithAnnotations.g:5143:1: rule__XAndExpression__Group_1__0__Impl : ( ( rule__XAndExpression__Group_1_0__0 ) ) ;
    public final void rule__XAndExpression__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5147:1: ( ( ( rule__XAndExpression__Group_1_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:5148:1: ( ( rule__XAndExpression__Group_1_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:5148:1: ( ( rule__XAndExpression__Group_1_0__0 ) )
            // InternalXbaseWithAnnotations.g:5149:2: ( rule__XAndExpression__Group_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAndExpressionAccess().getGroup_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:5150:2: ( rule__XAndExpression__Group_1_0__0 )
            // InternalXbaseWithAnnotations.g:5150:3: rule__XAndExpression__Group_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XAndExpression__Group_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAndExpressionAccess().getGroup_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group_1__0__Impl"


    // $ANTLR start "rule__XAndExpression__Group_1__1"
    // InternalXbaseWithAnnotations.g:5158:1: rule__XAndExpression__Group_1__1 : rule__XAndExpression__Group_1__1__Impl ;
    public final void rule__XAndExpression__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5162:1: ( rule__XAndExpression__Group_1__1__Impl )
            // InternalXbaseWithAnnotations.g:5163:2: rule__XAndExpression__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAndExpression__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group_1__1"


    // $ANTLR start "rule__XAndExpression__Group_1__1__Impl"
    // InternalXbaseWithAnnotations.g:5169:1: rule__XAndExpression__Group_1__1__Impl : ( ( rule__XAndExpression__RightOperandAssignment_1_1 ) ) ;
    public final void rule__XAndExpression__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5173:1: ( ( ( rule__XAndExpression__RightOperandAssignment_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:5174:1: ( ( rule__XAndExpression__RightOperandAssignment_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:5174:1: ( ( rule__XAndExpression__RightOperandAssignment_1_1 ) )
            // InternalXbaseWithAnnotations.g:5175:2: ( rule__XAndExpression__RightOperandAssignment_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAndExpressionAccess().getRightOperandAssignment_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:5176:2: ( rule__XAndExpression__RightOperandAssignment_1_1 )
            // InternalXbaseWithAnnotations.g:5176:3: rule__XAndExpression__RightOperandAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XAndExpression__RightOperandAssignment_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAndExpressionAccess().getRightOperandAssignment_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group_1__1__Impl"


    // $ANTLR start "rule__XAndExpression__Group_1_0__0"
    // InternalXbaseWithAnnotations.g:5185:1: rule__XAndExpression__Group_1_0__0 : rule__XAndExpression__Group_1_0__0__Impl ;
    public final void rule__XAndExpression__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5189:1: ( rule__XAndExpression__Group_1_0__0__Impl )
            // InternalXbaseWithAnnotations.g:5190:2: rule__XAndExpression__Group_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAndExpression__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group_1_0__0"


    // $ANTLR start "rule__XAndExpression__Group_1_0__0__Impl"
    // InternalXbaseWithAnnotations.g:5196:1: rule__XAndExpression__Group_1_0__0__Impl : ( ( rule__XAndExpression__Group_1_0_0__0 ) ) ;
    public final void rule__XAndExpression__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5200:1: ( ( ( rule__XAndExpression__Group_1_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:5201:1: ( ( rule__XAndExpression__Group_1_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:5201:1: ( ( rule__XAndExpression__Group_1_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:5202:2: ( rule__XAndExpression__Group_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAndExpressionAccess().getGroup_1_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:5203:2: ( rule__XAndExpression__Group_1_0_0__0 )
            // InternalXbaseWithAnnotations.g:5203:3: rule__XAndExpression__Group_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XAndExpression__Group_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAndExpressionAccess().getGroup_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group_1_0__0__Impl"


    // $ANTLR start "rule__XAndExpression__Group_1_0_0__0"
    // InternalXbaseWithAnnotations.g:5212:1: rule__XAndExpression__Group_1_0_0__0 : rule__XAndExpression__Group_1_0_0__0__Impl rule__XAndExpression__Group_1_0_0__1 ;
    public final void rule__XAndExpression__Group_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5216:1: ( rule__XAndExpression__Group_1_0_0__0__Impl rule__XAndExpression__Group_1_0_0__1 )
            // InternalXbaseWithAnnotations.g:5217:2: rule__XAndExpression__Group_1_0_0__0__Impl rule__XAndExpression__Group_1_0_0__1
            {
            pushFollow(FOLLOW_21);
            rule__XAndExpression__Group_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAndExpression__Group_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group_1_0_0__0"


    // $ANTLR start "rule__XAndExpression__Group_1_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:5224:1: rule__XAndExpression__Group_1_0_0__0__Impl : ( () ) ;
    public final void rule__XAndExpression__Group_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5228:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:5229:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:5229:1: ( () )
            // InternalXbaseWithAnnotations.g:5230:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAndExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:5231:2: ()
            // InternalXbaseWithAnnotations.g:5231:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAndExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group_1_0_0__0__Impl"


    // $ANTLR start "rule__XAndExpression__Group_1_0_0__1"
    // InternalXbaseWithAnnotations.g:5239:1: rule__XAndExpression__Group_1_0_0__1 : rule__XAndExpression__Group_1_0_0__1__Impl ;
    public final void rule__XAndExpression__Group_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5243:1: ( rule__XAndExpression__Group_1_0_0__1__Impl )
            // InternalXbaseWithAnnotations.g:5244:2: rule__XAndExpression__Group_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAndExpression__Group_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group_1_0_0__1"


    // $ANTLR start "rule__XAndExpression__Group_1_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:5250:1: rule__XAndExpression__Group_1_0_0__1__Impl : ( ( rule__XAndExpression__FeatureAssignment_1_0_0_1 ) ) ;
    public final void rule__XAndExpression__Group_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5254:1: ( ( ( rule__XAndExpression__FeatureAssignment_1_0_0_1 ) ) )
            // InternalXbaseWithAnnotations.g:5255:1: ( ( rule__XAndExpression__FeatureAssignment_1_0_0_1 ) )
            {
            // InternalXbaseWithAnnotations.g:5255:1: ( ( rule__XAndExpression__FeatureAssignment_1_0_0_1 ) )
            // InternalXbaseWithAnnotations.g:5256:2: ( rule__XAndExpression__FeatureAssignment_1_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAndExpressionAccess().getFeatureAssignment_1_0_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:5257:2: ( rule__XAndExpression__FeatureAssignment_1_0_0_1 )
            // InternalXbaseWithAnnotations.g:5257:3: rule__XAndExpression__FeatureAssignment_1_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XAndExpression__FeatureAssignment_1_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAndExpressionAccess().getFeatureAssignment_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__Group_1_0_0__1__Impl"


    // $ANTLR start "rule__XEqualityExpression__Group__0"
    // InternalXbaseWithAnnotations.g:5266:1: rule__XEqualityExpression__Group__0 : rule__XEqualityExpression__Group__0__Impl rule__XEqualityExpression__Group__1 ;
    public final void rule__XEqualityExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5270:1: ( rule__XEqualityExpression__Group__0__Impl rule__XEqualityExpression__Group__1 )
            // InternalXbaseWithAnnotations.g:5271:2: rule__XEqualityExpression__Group__0__Impl rule__XEqualityExpression__Group__1
            {
            pushFollow(FOLLOW_23);
            rule__XEqualityExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XEqualityExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group__0"


    // $ANTLR start "rule__XEqualityExpression__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:5278:1: rule__XEqualityExpression__Group__0__Impl : ( ruleXRelationalExpression ) ;
    public final void rule__XEqualityExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5282:1: ( ( ruleXRelationalExpression ) )
            // InternalXbaseWithAnnotations.g:5283:1: ( ruleXRelationalExpression )
            {
            // InternalXbaseWithAnnotations.g:5283:1: ( ruleXRelationalExpression )
            // InternalXbaseWithAnnotations.g:5284:2: ruleXRelationalExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXEqualityExpressionAccess().getXRelationalExpressionParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXRelationalExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXEqualityExpressionAccess().getXRelationalExpressionParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group__0__Impl"


    // $ANTLR start "rule__XEqualityExpression__Group__1"
    // InternalXbaseWithAnnotations.g:5293:1: rule__XEqualityExpression__Group__1 : rule__XEqualityExpression__Group__1__Impl ;
    public final void rule__XEqualityExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5297:1: ( rule__XEqualityExpression__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:5298:2: rule__XEqualityExpression__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XEqualityExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group__1"


    // $ANTLR start "rule__XEqualityExpression__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:5304:1: rule__XEqualityExpression__Group__1__Impl : ( ( rule__XEqualityExpression__Group_1__0 )* ) ;
    public final void rule__XEqualityExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5308:1: ( ( ( rule__XEqualityExpression__Group_1__0 )* ) )
            // InternalXbaseWithAnnotations.g:5309:1: ( ( rule__XEqualityExpression__Group_1__0 )* )
            {
            // InternalXbaseWithAnnotations.g:5309:1: ( ( rule__XEqualityExpression__Group_1__0 )* )
            // InternalXbaseWithAnnotations.g:5310:2: ( rule__XEqualityExpression__Group_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXEqualityExpressionAccess().getGroup_1()); 
            }
            // InternalXbaseWithAnnotations.g:5311:2: ( rule__XEqualityExpression__Group_1__0 )*
            loop58:
            do {
                int alt58=2;
                switch ( input.LA(1) ) {
                case 21:
                    {
                    int LA58_2 = input.LA(2);

                    if ( (synpred101_InternalXbaseWithAnnotations()) ) {
                        alt58=1;
                    }


                    }
                    break;
                case 22:
                    {
                    int LA58_3 = input.LA(2);

                    if ( (synpred101_InternalXbaseWithAnnotations()) ) {
                        alt58=1;
                    }


                    }
                    break;
                case 23:
                    {
                    int LA58_4 = input.LA(2);

                    if ( (synpred101_InternalXbaseWithAnnotations()) ) {
                        alt58=1;
                    }


                    }
                    break;
                case 24:
                    {
                    int LA58_5 = input.LA(2);

                    if ( (synpred101_InternalXbaseWithAnnotations()) ) {
                        alt58=1;
                    }


                    }
                    break;

                }

                switch (alt58) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:5311:3: rule__XEqualityExpression__Group_1__0
            	    {
            	    pushFollow(FOLLOW_24);
            	    rule__XEqualityExpression__Group_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop58;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXEqualityExpressionAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group__1__Impl"


    // $ANTLR start "rule__XEqualityExpression__Group_1__0"
    // InternalXbaseWithAnnotations.g:5320:1: rule__XEqualityExpression__Group_1__0 : rule__XEqualityExpression__Group_1__0__Impl rule__XEqualityExpression__Group_1__1 ;
    public final void rule__XEqualityExpression__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5324:1: ( rule__XEqualityExpression__Group_1__0__Impl rule__XEqualityExpression__Group_1__1 )
            // InternalXbaseWithAnnotations.g:5325:2: rule__XEqualityExpression__Group_1__0__Impl rule__XEqualityExpression__Group_1__1
            {
            pushFollow(FOLLOW_10);
            rule__XEqualityExpression__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XEqualityExpression__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group_1__0"


    // $ANTLR start "rule__XEqualityExpression__Group_1__0__Impl"
    // InternalXbaseWithAnnotations.g:5332:1: rule__XEqualityExpression__Group_1__0__Impl : ( ( rule__XEqualityExpression__Group_1_0__0 ) ) ;
    public final void rule__XEqualityExpression__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5336:1: ( ( ( rule__XEqualityExpression__Group_1_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:5337:1: ( ( rule__XEqualityExpression__Group_1_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:5337:1: ( ( rule__XEqualityExpression__Group_1_0__0 ) )
            // InternalXbaseWithAnnotations.g:5338:2: ( rule__XEqualityExpression__Group_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXEqualityExpressionAccess().getGroup_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:5339:2: ( rule__XEqualityExpression__Group_1_0__0 )
            // InternalXbaseWithAnnotations.g:5339:3: rule__XEqualityExpression__Group_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XEqualityExpression__Group_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXEqualityExpressionAccess().getGroup_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group_1__0__Impl"


    // $ANTLR start "rule__XEqualityExpression__Group_1__1"
    // InternalXbaseWithAnnotations.g:5347:1: rule__XEqualityExpression__Group_1__1 : rule__XEqualityExpression__Group_1__1__Impl ;
    public final void rule__XEqualityExpression__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5351:1: ( rule__XEqualityExpression__Group_1__1__Impl )
            // InternalXbaseWithAnnotations.g:5352:2: rule__XEqualityExpression__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XEqualityExpression__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group_1__1"


    // $ANTLR start "rule__XEqualityExpression__Group_1__1__Impl"
    // InternalXbaseWithAnnotations.g:5358:1: rule__XEqualityExpression__Group_1__1__Impl : ( ( rule__XEqualityExpression__RightOperandAssignment_1_1 ) ) ;
    public final void rule__XEqualityExpression__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5362:1: ( ( ( rule__XEqualityExpression__RightOperandAssignment_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:5363:1: ( ( rule__XEqualityExpression__RightOperandAssignment_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:5363:1: ( ( rule__XEqualityExpression__RightOperandAssignment_1_1 ) )
            // InternalXbaseWithAnnotations.g:5364:2: ( rule__XEqualityExpression__RightOperandAssignment_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXEqualityExpressionAccess().getRightOperandAssignment_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:5365:2: ( rule__XEqualityExpression__RightOperandAssignment_1_1 )
            // InternalXbaseWithAnnotations.g:5365:3: rule__XEqualityExpression__RightOperandAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XEqualityExpression__RightOperandAssignment_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXEqualityExpressionAccess().getRightOperandAssignment_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group_1__1__Impl"


    // $ANTLR start "rule__XEqualityExpression__Group_1_0__0"
    // InternalXbaseWithAnnotations.g:5374:1: rule__XEqualityExpression__Group_1_0__0 : rule__XEqualityExpression__Group_1_0__0__Impl ;
    public final void rule__XEqualityExpression__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5378:1: ( rule__XEqualityExpression__Group_1_0__0__Impl )
            // InternalXbaseWithAnnotations.g:5379:2: rule__XEqualityExpression__Group_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XEqualityExpression__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group_1_0__0"


    // $ANTLR start "rule__XEqualityExpression__Group_1_0__0__Impl"
    // InternalXbaseWithAnnotations.g:5385:1: rule__XEqualityExpression__Group_1_0__0__Impl : ( ( rule__XEqualityExpression__Group_1_0_0__0 ) ) ;
    public final void rule__XEqualityExpression__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5389:1: ( ( ( rule__XEqualityExpression__Group_1_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:5390:1: ( ( rule__XEqualityExpression__Group_1_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:5390:1: ( ( rule__XEqualityExpression__Group_1_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:5391:2: ( rule__XEqualityExpression__Group_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXEqualityExpressionAccess().getGroup_1_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:5392:2: ( rule__XEqualityExpression__Group_1_0_0__0 )
            // InternalXbaseWithAnnotations.g:5392:3: rule__XEqualityExpression__Group_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XEqualityExpression__Group_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXEqualityExpressionAccess().getGroup_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group_1_0__0__Impl"


    // $ANTLR start "rule__XEqualityExpression__Group_1_0_0__0"
    // InternalXbaseWithAnnotations.g:5401:1: rule__XEqualityExpression__Group_1_0_0__0 : rule__XEqualityExpression__Group_1_0_0__0__Impl rule__XEqualityExpression__Group_1_0_0__1 ;
    public final void rule__XEqualityExpression__Group_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5405:1: ( rule__XEqualityExpression__Group_1_0_0__0__Impl rule__XEqualityExpression__Group_1_0_0__1 )
            // InternalXbaseWithAnnotations.g:5406:2: rule__XEqualityExpression__Group_1_0_0__0__Impl rule__XEqualityExpression__Group_1_0_0__1
            {
            pushFollow(FOLLOW_23);
            rule__XEqualityExpression__Group_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XEqualityExpression__Group_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group_1_0_0__0"


    // $ANTLR start "rule__XEqualityExpression__Group_1_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:5413:1: rule__XEqualityExpression__Group_1_0_0__0__Impl : ( () ) ;
    public final void rule__XEqualityExpression__Group_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5417:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:5418:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:5418:1: ( () )
            // InternalXbaseWithAnnotations.g:5419:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXEqualityExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:5420:2: ()
            // InternalXbaseWithAnnotations.g:5420:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXEqualityExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group_1_0_0__0__Impl"


    // $ANTLR start "rule__XEqualityExpression__Group_1_0_0__1"
    // InternalXbaseWithAnnotations.g:5428:1: rule__XEqualityExpression__Group_1_0_0__1 : rule__XEqualityExpression__Group_1_0_0__1__Impl ;
    public final void rule__XEqualityExpression__Group_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5432:1: ( rule__XEqualityExpression__Group_1_0_0__1__Impl )
            // InternalXbaseWithAnnotations.g:5433:2: rule__XEqualityExpression__Group_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XEqualityExpression__Group_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group_1_0_0__1"


    // $ANTLR start "rule__XEqualityExpression__Group_1_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:5439:1: rule__XEqualityExpression__Group_1_0_0__1__Impl : ( ( rule__XEqualityExpression__FeatureAssignment_1_0_0_1 ) ) ;
    public final void rule__XEqualityExpression__Group_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5443:1: ( ( ( rule__XEqualityExpression__FeatureAssignment_1_0_0_1 ) ) )
            // InternalXbaseWithAnnotations.g:5444:1: ( ( rule__XEqualityExpression__FeatureAssignment_1_0_0_1 ) )
            {
            // InternalXbaseWithAnnotations.g:5444:1: ( ( rule__XEqualityExpression__FeatureAssignment_1_0_0_1 ) )
            // InternalXbaseWithAnnotations.g:5445:2: ( rule__XEqualityExpression__FeatureAssignment_1_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXEqualityExpressionAccess().getFeatureAssignment_1_0_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:5446:2: ( rule__XEqualityExpression__FeatureAssignment_1_0_0_1 )
            // InternalXbaseWithAnnotations.g:5446:3: rule__XEqualityExpression__FeatureAssignment_1_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XEqualityExpression__FeatureAssignment_1_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXEqualityExpressionAccess().getFeatureAssignment_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__Group_1_0_0__1__Impl"


    // $ANTLR start "rule__XRelationalExpression__Group__0"
    // InternalXbaseWithAnnotations.g:5455:1: rule__XRelationalExpression__Group__0 : rule__XRelationalExpression__Group__0__Impl rule__XRelationalExpression__Group__1 ;
    public final void rule__XRelationalExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5459:1: ( rule__XRelationalExpression__Group__0__Impl rule__XRelationalExpression__Group__1 )
            // InternalXbaseWithAnnotations.g:5460:2: rule__XRelationalExpression__Group__0__Impl rule__XRelationalExpression__Group__1
            {
            pushFollow(FOLLOW_25);
            rule__XRelationalExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group__0"


    // $ANTLR start "rule__XRelationalExpression__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:5467:1: rule__XRelationalExpression__Group__0__Impl : ( ruleXOtherOperatorExpression ) ;
    public final void rule__XRelationalExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5471:1: ( ( ruleXOtherOperatorExpression ) )
            // InternalXbaseWithAnnotations.g:5472:1: ( ruleXOtherOperatorExpression )
            {
            // InternalXbaseWithAnnotations.g:5472:1: ( ruleXOtherOperatorExpression )
            // InternalXbaseWithAnnotations.g:5473:2: ruleXOtherOperatorExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getXOtherOperatorExpressionParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXOtherOperatorExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getXOtherOperatorExpressionParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group__0__Impl"


    // $ANTLR start "rule__XRelationalExpression__Group__1"
    // InternalXbaseWithAnnotations.g:5482:1: rule__XRelationalExpression__Group__1 : rule__XRelationalExpression__Group__1__Impl ;
    public final void rule__XRelationalExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5486:1: ( rule__XRelationalExpression__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:5487:2: rule__XRelationalExpression__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group__1"


    // $ANTLR start "rule__XRelationalExpression__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:5493:1: rule__XRelationalExpression__Group__1__Impl : ( ( rule__XRelationalExpression__Alternatives_1 )* ) ;
    public final void rule__XRelationalExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5497:1: ( ( ( rule__XRelationalExpression__Alternatives_1 )* ) )
            // InternalXbaseWithAnnotations.g:5498:1: ( ( rule__XRelationalExpression__Alternatives_1 )* )
            {
            // InternalXbaseWithAnnotations.g:5498:1: ( ( rule__XRelationalExpression__Alternatives_1 )* )
            // InternalXbaseWithAnnotations.g:5499:2: ( rule__XRelationalExpression__Alternatives_1 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getAlternatives_1()); 
            }
            // InternalXbaseWithAnnotations.g:5500:2: ( rule__XRelationalExpression__Alternatives_1 )*
            loop59:
            do {
                int alt59=2;
                switch ( input.LA(1) ) {
                case 27:
                    {
                    int LA59_2 = input.LA(2);

                    if ( (synpred102_InternalXbaseWithAnnotations()) ) {
                        alt59=1;
                    }


                    }
                    break;
                case 26:
                    {
                    int LA59_3 = input.LA(2);

                    if ( (synpred102_InternalXbaseWithAnnotations()) ) {
                        alt59=1;
                    }


                    }
                    break;
                case 58:
                    {
                    int LA59_4 = input.LA(2);

                    if ( (synpred102_InternalXbaseWithAnnotations()) ) {
                        alt59=1;
                    }


                    }
                    break;
                case 25:
                    {
                    int LA59_5 = input.LA(2);

                    if ( (synpred102_InternalXbaseWithAnnotations()) ) {
                        alt59=1;
                    }


                    }
                    break;

                }

                switch (alt59) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:5500:3: rule__XRelationalExpression__Alternatives_1
            	    {
            	    pushFollow(FOLLOW_26);
            	    rule__XRelationalExpression__Alternatives_1();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop59;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getAlternatives_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group__1__Impl"


    // $ANTLR start "rule__XRelationalExpression__Group_1_0__0"
    // InternalXbaseWithAnnotations.g:5509:1: rule__XRelationalExpression__Group_1_0__0 : rule__XRelationalExpression__Group_1_0__0__Impl rule__XRelationalExpression__Group_1_0__1 ;
    public final void rule__XRelationalExpression__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5513:1: ( rule__XRelationalExpression__Group_1_0__0__Impl rule__XRelationalExpression__Group_1_0__1 )
            // InternalXbaseWithAnnotations.g:5514:2: rule__XRelationalExpression__Group_1_0__0__Impl rule__XRelationalExpression__Group_1_0__1
            {
            pushFollow(FOLLOW_27);
            rule__XRelationalExpression__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_0__0"


    // $ANTLR start "rule__XRelationalExpression__Group_1_0__0__Impl"
    // InternalXbaseWithAnnotations.g:5521:1: rule__XRelationalExpression__Group_1_0__0__Impl : ( ( rule__XRelationalExpression__Group_1_0_0__0 ) ) ;
    public final void rule__XRelationalExpression__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5525:1: ( ( ( rule__XRelationalExpression__Group_1_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:5526:1: ( ( rule__XRelationalExpression__Group_1_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:5526:1: ( ( rule__XRelationalExpression__Group_1_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:5527:2: ( rule__XRelationalExpression__Group_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getGroup_1_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:5528:2: ( rule__XRelationalExpression__Group_1_0_0__0 )
            // InternalXbaseWithAnnotations.g:5528:3: rule__XRelationalExpression__Group_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getGroup_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_0__0__Impl"


    // $ANTLR start "rule__XRelationalExpression__Group_1_0__1"
    // InternalXbaseWithAnnotations.g:5536:1: rule__XRelationalExpression__Group_1_0__1 : rule__XRelationalExpression__Group_1_0__1__Impl ;
    public final void rule__XRelationalExpression__Group_1_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5540:1: ( rule__XRelationalExpression__Group_1_0__1__Impl )
            // InternalXbaseWithAnnotations.g:5541:2: rule__XRelationalExpression__Group_1_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_0__1"


    // $ANTLR start "rule__XRelationalExpression__Group_1_0__1__Impl"
    // InternalXbaseWithAnnotations.g:5547:1: rule__XRelationalExpression__Group_1_0__1__Impl : ( ( rule__XRelationalExpression__TypeAssignment_1_0_1 ) ) ;
    public final void rule__XRelationalExpression__Group_1_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5551:1: ( ( ( rule__XRelationalExpression__TypeAssignment_1_0_1 ) ) )
            // InternalXbaseWithAnnotations.g:5552:1: ( ( rule__XRelationalExpression__TypeAssignment_1_0_1 ) )
            {
            // InternalXbaseWithAnnotations.g:5552:1: ( ( rule__XRelationalExpression__TypeAssignment_1_0_1 ) )
            // InternalXbaseWithAnnotations.g:5553:2: ( rule__XRelationalExpression__TypeAssignment_1_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getTypeAssignment_1_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:5554:2: ( rule__XRelationalExpression__TypeAssignment_1_0_1 )
            // InternalXbaseWithAnnotations.g:5554:3: rule__XRelationalExpression__TypeAssignment_1_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__TypeAssignment_1_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getTypeAssignment_1_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_0__1__Impl"


    // $ANTLR start "rule__XRelationalExpression__Group_1_0_0__0"
    // InternalXbaseWithAnnotations.g:5563:1: rule__XRelationalExpression__Group_1_0_0__0 : rule__XRelationalExpression__Group_1_0_0__0__Impl ;
    public final void rule__XRelationalExpression__Group_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5567:1: ( rule__XRelationalExpression__Group_1_0_0__0__Impl )
            // InternalXbaseWithAnnotations.g:5568:2: rule__XRelationalExpression__Group_1_0_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_0_0__0"


    // $ANTLR start "rule__XRelationalExpression__Group_1_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:5574:1: rule__XRelationalExpression__Group_1_0_0__0__Impl : ( ( rule__XRelationalExpression__Group_1_0_0_0__0 ) ) ;
    public final void rule__XRelationalExpression__Group_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5578:1: ( ( ( rule__XRelationalExpression__Group_1_0_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:5579:1: ( ( rule__XRelationalExpression__Group_1_0_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:5579:1: ( ( rule__XRelationalExpression__Group_1_0_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:5580:2: ( rule__XRelationalExpression__Group_1_0_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getGroup_1_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:5581:2: ( rule__XRelationalExpression__Group_1_0_0_0__0 )
            // InternalXbaseWithAnnotations.g:5581:3: rule__XRelationalExpression__Group_1_0_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_0_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getGroup_1_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_0_0__0__Impl"


    // $ANTLR start "rule__XRelationalExpression__Group_1_0_0_0__0"
    // InternalXbaseWithAnnotations.g:5590:1: rule__XRelationalExpression__Group_1_0_0_0__0 : rule__XRelationalExpression__Group_1_0_0_0__0__Impl rule__XRelationalExpression__Group_1_0_0_0__1 ;
    public final void rule__XRelationalExpression__Group_1_0_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5594:1: ( rule__XRelationalExpression__Group_1_0_0_0__0__Impl rule__XRelationalExpression__Group_1_0_0_0__1 )
            // InternalXbaseWithAnnotations.g:5595:2: rule__XRelationalExpression__Group_1_0_0_0__0__Impl rule__XRelationalExpression__Group_1_0_0_0__1
            {
            pushFollow(FOLLOW_28);
            rule__XRelationalExpression__Group_1_0_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_0_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_0_0_0__0"


    // $ANTLR start "rule__XRelationalExpression__Group_1_0_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:5602:1: rule__XRelationalExpression__Group_1_0_0_0__0__Impl : ( () ) ;
    public final void rule__XRelationalExpression__Group_1_0_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5606:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:5607:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:5607:1: ( () )
            // InternalXbaseWithAnnotations.g:5608:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getXInstanceOfExpressionExpressionAction_1_0_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:5609:2: ()
            // InternalXbaseWithAnnotations.g:5609:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getXInstanceOfExpressionExpressionAction_1_0_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_0_0_0__0__Impl"


    // $ANTLR start "rule__XRelationalExpression__Group_1_0_0_0__1"
    // InternalXbaseWithAnnotations.g:5617:1: rule__XRelationalExpression__Group_1_0_0_0__1 : rule__XRelationalExpression__Group_1_0_0_0__1__Impl ;
    public final void rule__XRelationalExpression__Group_1_0_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5621:1: ( rule__XRelationalExpression__Group_1_0_0_0__1__Impl )
            // InternalXbaseWithAnnotations.g:5622:2: rule__XRelationalExpression__Group_1_0_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_0_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_0_0_0__1"


    // $ANTLR start "rule__XRelationalExpression__Group_1_0_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:5628:1: rule__XRelationalExpression__Group_1_0_0_0__1__Impl : ( 'instanceof' ) ;
    public final void rule__XRelationalExpression__Group_1_0_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5632:1: ( ( 'instanceof' ) )
            // InternalXbaseWithAnnotations.g:5633:1: ( 'instanceof' )
            {
            // InternalXbaseWithAnnotations.g:5633:1: ( 'instanceof' )
            // InternalXbaseWithAnnotations.g:5634:2: 'instanceof'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getInstanceofKeyword_1_0_0_0_1()); 
            }
            match(input,58,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getInstanceofKeyword_1_0_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_0_0_0__1__Impl"


    // $ANTLR start "rule__XRelationalExpression__Group_1_1__0"
    // InternalXbaseWithAnnotations.g:5644:1: rule__XRelationalExpression__Group_1_1__0 : rule__XRelationalExpression__Group_1_1__0__Impl rule__XRelationalExpression__Group_1_1__1 ;
    public final void rule__XRelationalExpression__Group_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5648:1: ( rule__XRelationalExpression__Group_1_1__0__Impl rule__XRelationalExpression__Group_1_1__1 )
            // InternalXbaseWithAnnotations.g:5649:2: rule__XRelationalExpression__Group_1_1__0__Impl rule__XRelationalExpression__Group_1_1__1
            {
            pushFollow(FOLLOW_10);
            rule__XRelationalExpression__Group_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_1__0"


    // $ANTLR start "rule__XRelationalExpression__Group_1_1__0__Impl"
    // InternalXbaseWithAnnotations.g:5656:1: rule__XRelationalExpression__Group_1_1__0__Impl : ( ( rule__XRelationalExpression__Group_1_1_0__0 ) ) ;
    public final void rule__XRelationalExpression__Group_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5660:1: ( ( ( rule__XRelationalExpression__Group_1_1_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:5661:1: ( ( rule__XRelationalExpression__Group_1_1_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:5661:1: ( ( rule__XRelationalExpression__Group_1_1_0__0 ) )
            // InternalXbaseWithAnnotations.g:5662:2: ( rule__XRelationalExpression__Group_1_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getGroup_1_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:5663:2: ( rule__XRelationalExpression__Group_1_1_0__0 )
            // InternalXbaseWithAnnotations.g:5663:3: rule__XRelationalExpression__Group_1_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getGroup_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_1__0__Impl"


    // $ANTLR start "rule__XRelationalExpression__Group_1_1__1"
    // InternalXbaseWithAnnotations.g:5671:1: rule__XRelationalExpression__Group_1_1__1 : rule__XRelationalExpression__Group_1_1__1__Impl ;
    public final void rule__XRelationalExpression__Group_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5675:1: ( rule__XRelationalExpression__Group_1_1__1__Impl )
            // InternalXbaseWithAnnotations.g:5676:2: rule__XRelationalExpression__Group_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_1__1"


    // $ANTLR start "rule__XRelationalExpression__Group_1_1__1__Impl"
    // InternalXbaseWithAnnotations.g:5682:1: rule__XRelationalExpression__Group_1_1__1__Impl : ( ( rule__XRelationalExpression__RightOperandAssignment_1_1_1 ) ) ;
    public final void rule__XRelationalExpression__Group_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5686:1: ( ( ( rule__XRelationalExpression__RightOperandAssignment_1_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:5687:1: ( ( rule__XRelationalExpression__RightOperandAssignment_1_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:5687:1: ( ( rule__XRelationalExpression__RightOperandAssignment_1_1_1 ) )
            // InternalXbaseWithAnnotations.g:5688:2: ( rule__XRelationalExpression__RightOperandAssignment_1_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getRightOperandAssignment_1_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:5689:2: ( rule__XRelationalExpression__RightOperandAssignment_1_1_1 )
            // InternalXbaseWithAnnotations.g:5689:3: rule__XRelationalExpression__RightOperandAssignment_1_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__RightOperandAssignment_1_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getRightOperandAssignment_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_1__1__Impl"


    // $ANTLR start "rule__XRelationalExpression__Group_1_1_0__0"
    // InternalXbaseWithAnnotations.g:5698:1: rule__XRelationalExpression__Group_1_1_0__0 : rule__XRelationalExpression__Group_1_1_0__0__Impl ;
    public final void rule__XRelationalExpression__Group_1_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5702:1: ( rule__XRelationalExpression__Group_1_1_0__0__Impl )
            // InternalXbaseWithAnnotations.g:5703:2: rule__XRelationalExpression__Group_1_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_1_0__0"


    // $ANTLR start "rule__XRelationalExpression__Group_1_1_0__0__Impl"
    // InternalXbaseWithAnnotations.g:5709:1: rule__XRelationalExpression__Group_1_1_0__0__Impl : ( ( rule__XRelationalExpression__Group_1_1_0_0__0 ) ) ;
    public final void rule__XRelationalExpression__Group_1_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5713:1: ( ( ( rule__XRelationalExpression__Group_1_1_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:5714:1: ( ( rule__XRelationalExpression__Group_1_1_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:5714:1: ( ( rule__XRelationalExpression__Group_1_1_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:5715:2: ( rule__XRelationalExpression__Group_1_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getGroup_1_1_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:5716:2: ( rule__XRelationalExpression__Group_1_1_0_0__0 )
            // InternalXbaseWithAnnotations.g:5716:3: rule__XRelationalExpression__Group_1_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getGroup_1_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_1_0__0__Impl"


    // $ANTLR start "rule__XRelationalExpression__Group_1_1_0_0__0"
    // InternalXbaseWithAnnotations.g:5725:1: rule__XRelationalExpression__Group_1_1_0_0__0 : rule__XRelationalExpression__Group_1_1_0_0__0__Impl rule__XRelationalExpression__Group_1_1_0_0__1 ;
    public final void rule__XRelationalExpression__Group_1_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5729:1: ( rule__XRelationalExpression__Group_1_1_0_0__0__Impl rule__XRelationalExpression__Group_1_1_0_0__1 )
            // InternalXbaseWithAnnotations.g:5730:2: rule__XRelationalExpression__Group_1_1_0_0__0__Impl rule__XRelationalExpression__Group_1_1_0_0__1
            {
            pushFollow(FOLLOW_25);
            rule__XRelationalExpression__Group_1_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_1_0_0__0"


    // $ANTLR start "rule__XRelationalExpression__Group_1_1_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:5737:1: rule__XRelationalExpression__Group_1_1_0_0__0__Impl : ( () ) ;
    public final void rule__XRelationalExpression__Group_1_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5741:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:5742:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:5742:1: ( () )
            // InternalXbaseWithAnnotations.g:5743:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getXBinaryOperationLeftOperandAction_1_1_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:5744:2: ()
            // InternalXbaseWithAnnotations.g:5744:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getXBinaryOperationLeftOperandAction_1_1_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_1_0_0__0__Impl"


    // $ANTLR start "rule__XRelationalExpression__Group_1_1_0_0__1"
    // InternalXbaseWithAnnotations.g:5752:1: rule__XRelationalExpression__Group_1_1_0_0__1 : rule__XRelationalExpression__Group_1_1_0_0__1__Impl ;
    public final void rule__XRelationalExpression__Group_1_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5756:1: ( rule__XRelationalExpression__Group_1_1_0_0__1__Impl )
            // InternalXbaseWithAnnotations.g:5757:2: rule__XRelationalExpression__Group_1_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__Group_1_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_1_0_0__1"


    // $ANTLR start "rule__XRelationalExpression__Group_1_1_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:5763:1: rule__XRelationalExpression__Group_1_1_0_0__1__Impl : ( ( rule__XRelationalExpression__FeatureAssignment_1_1_0_0_1 ) ) ;
    public final void rule__XRelationalExpression__Group_1_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5767:1: ( ( ( rule__XRelationalExpression__FeatureAssignment_1_1_0_0_1 ) ) )
            // InternalXbaseWithAnnotations.g:5768:1: ( ( rule__XRelationalExpression__FeatureAssignment_1_1_0_0_1 ) )
            {
            // InternalXbaseWithAnnotations.g:5768:1: ( ( rule__XRelationalExpression__FeatureAssignment_1_1_0_0_1 ) )
            // InternalXbaseWithAnnotations.g:5769:2: ( rule__XRelationalExpression__FeatureAssignment_1_1_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getFeatureAssignment_1_1_0_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:5770:2: ( rule__XRelationalExpression__FeatureAssignment_1_1_0_0_1 )
            // InternalXbaseWithAnnotations.g:5770:3: rule__XRelationalExpression__FeatureAssignment_1_1_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XRelationalExpression__FeatureAssignment_1_1_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getFeatureAssignment_1_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__Group_1_1_0_0__1__Impl"


    // $ANTLR start "rule__OpCompare__Group_1__0"
    // InternalXbaseWithAnnotations.g:5779:1: rule__OpCompare__Group_1__0 : rule__OpCompare__Group_1__0__Impl rule__OpCompare__Group_1__1 ;
    public final void rule__OpCompare__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5783:1: ( rule__OpCompare__Group_1__0__Impl rule__OpCompare__Group_1__1 )
            // InternalXbaseWithAnnotations.g:5784:2: rule__OpCompare__Group_1__0__Impl rule__OpCompare__Group_1__1
            {
            pushFollow(FOLLOW_11);
            rule__OpCompare__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__OpCompare__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpCompare__Group_1__0"


    // $ANTLR start "rule__OpCompare__Group_1__0__Impl"
    // InternalXbaseWithAnnotations.g:5791:1: rule__OpCompare__Group_1__0__Impl : ( '<' ) ;
    public final void rule__OpCompare__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5795:1: ( ( '<' ) )
            // InternalXbaseWithAnnotations.g:5796:1: ( '<' )
            {
            // InternalXbaseWithAnnotations.g:5796:1: ( '<' )
            // InternalXbaseWithAnnotations.g:5797:2: '<'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpCompareAccess().getLessThanSignKeyword_1_0()); 
            }
            match(input,27,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpCompareAccess().getLessThanSignKeyword_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpCompare__Group_1__0__Impl"


    // $ANTLR start "rule__OpCompare__Group_1__1"
    // InternalXbaseWithAnnotations.g:5806:1: rule__OpCompare__Group_1__1 : rule__OpCompare__Group_1__1__Impl ;
    public final void rule__OpCompare__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5810:1: ( rule__OpCompare__Group_1__1__Impl )
            // InternalXbaseWithAnnotations.g:5811:2: rule__OpCompare__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__OpCompare__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpCompare__Group_1__1"


    // $ANTLR start "rule__OpCompare__Group_1__1__Impl"
    // InternalXbaseWithAnnotations.g:5817:1: rule__OpCompare__Group_1__1__Impl : ( '=' ) ;
    public final void rule__OpCompare__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5821:1: ( ( '=' ) )
            // InternalXbaseWithAnnotations.g:5822:1: ( '=' )
            {
            // InternalXbaseWithAnnotations.g:5822:1: ( '=' )
            // InternalXbaseWithAnnotations.g:5823:2: '='
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpCompareAccess().getEqualsSignKeyword_1_1()); 
            }
            match(input,13,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpCompareAccess().getEqualsSignKeyword_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpCompare__Group_1__1__Impl"


    // $ANTLR start "rule__XOtherOperatorExpression__Group__0"
    // InternalXbaseWithAnnotations.g:5833:1: rule__XOtherOperatorExpression__Group__0 : rule__XOtherOperatorExpression__Group__0__Impl rule__XOtherOperatorExpression__Group__1 ;
    public final void rule__XOtherOperatorExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5837:1: ( rule__XOtherOperatorExpression__Group__0__Impl rule__XOtherOperatorExpression__Group__1 )
            // InternalXbaseWithAnnotations.g:5838:2: rule__XOtherOperatorExpression__Group__0__Impl rule__XOtherOperatorExpression__Group__1
            {
            pushFollow(FOLLOW_29);
            rule__XOtherOperatorExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XOtherOperatorExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group__0"


    // $ANTLR start "rule__XOtherOperatorExpression__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:5845:1: rule__XOtherOperatorExpression__Group__0__Impl : ( ruleXAdditiveExpression ) ;
    public final void rule__XOtherOperatorExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5849:1: ( ( ruleXAdditiveExpression ) )
            // InternalXbaseWithAnnotations.g:5850:1: ( ruleXAdditiveExpression )
            {
            // InternalXbaseWithAnnotations.g:5850:1: ( ruleXAdditiveExpression )
            // InternalXbaseWithAnnotations.g:5851:2: ruleXAdditiveExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOtherOperatorExpressionAccess().getXAdditiveExpressionParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAdditiveExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOtherOperatorExpressionAccess().getXAdditiveExpressionParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group__0__Impl"


    // $ANTLR start "rule__XOtherOperatorExpression__Group__1"
    // InternalXbaseWithAnnotations.g:5860:1: rule__XOtherOperatorExpression__Group__1 : rule__XOtherOperatorExpression__Group__1__Impl ;
    public final void rule__XOtherOperatorExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5864:1: ( rule__XOtherOperatorExpression__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:5865:2: rule__XOtherOperatorExpression__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XOtherOperatorExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group__1"


    // $ANTLR start "rule__XOtherOperatorExpression__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:5871:1: rule__XOtherOperatorExpression__Group__1__Impl : ( ( rule__XOtherOperatorExpression__Group_1__0 )* ) ;
    public final void rule__XOtherOperatorExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5875:1: ( ( ( rule__XOtherOperatorExpression__Group_1__0 )* ) )
            // InternalXbaseWithAnnotations.g:5876:1: ( ( rule__XOtherOperatorExpression__Group_1__0 )* )
            {
            // InternalXbaseWithAnnotations.g:5876:1: ( ( rule__XOtherOperatorExpression__Group_1__0 )* )
            // InternalXbaseWithAnnotations.g:5877:2: ( rule__XOtherOperatorExpression__Group_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOtherOperatorExpressionAccess().getGroup_1()); 
            }
            // InternalXbaseWithAnnotations.g:5878:2: ( rule__XOtherOperatorExpression__Group_1__0 )*
            loop60:
            do {
                int alt60=2;
                alt60 = dfa60.predict(input);
                switch (alt60) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:5878:3: rule__XOtherOperatorExpression__Group_1__0
            	    {
            	    pushFollow(FOLLOW_30);
            	    rule__XOtherOperatorExpression__Group_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop60;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOtherOperatorExpressionAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group__1__Impl"


    // $ANTLR start "rule__XOtherOperatorExpression__Group_1__0"
    // InternalXbaseWithAnnotations.g:5887:1: rule__XOtherOperatorExpression__Group_1__0 : rule__XOtherOperatorExpression__Group_1__0__Impl rule__XOtherOperatorExpression__Group_1__1 ;
    public final void rule__XOtherOperatorExpression__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5891:1: ( rule__XOtherOperatorExpression__Group_1__0__Impl rule__XOtherOperatorExpression__Group_1__1 )
            // InternalXbaseWithAnnotations.g:5892:2: rule__XOtherOperatorExpression__Group_1__0__Impl rule__XOtherOperatorExpression__Group_1__1
            {
            pushFollow(FOLLOW_10);
            rule__XOtherOperatorExpression__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XOtherOperatorExpression__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group_1__0"


    // $ANTLR start "rule__XOtherOperatorExpression__Group_1__0__Impl"
    // InternalXbaseWithAnnotations.g:5899:1: rule__XOtherOperatorExpression__Group_1__0__Impl : ( ( rule__XOtherOperatorExpression__Group_1_0__0 ) ) ;
    public final void rule__XOtherOperatorExpression__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5903:1: ( ( ( rule__XOtherOperatorExpression__Group_1_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:5904:1: ( ( rule__XOtherOperatorExpression__Group_1_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:5904:1: ( ( rule__XOtherOperatorExpression__Group_1_0__0 ) )
            // InternalXbaseWithAnnotations.g:5905:2: ( rule__XOtherOperatorExpression__Group_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOtherOperatorExpressionAccess().getGroup_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:5906:2: ( rule__XOtherOperatorExpression__Group_1_0__0 )
            // InternalXbaseWithAnnotations.g:5906:3: rule__XOtherOperatorExpression__Group_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XOtherOperatorExpression__Group_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOtherOperatorExpressionAccess().getGroup_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group_1__0__Impl"


    // $ANTLR start "rule__XOtherOperatorExpression__Group_1__1"
    // InternalXbaseWithAnnotations.g:5914:1: rule__XOtherOperatorExpression__Group_1__1 : rule__XOtherOperatorExpression__Group_1__1__Impl ;
    public final void rule__XOtherOperatorExpression__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5918:1: ( rule__XOtherOperatorExpression__Group_1__1__Impl )
            // InternalXbaseWithAnnotations.g:5919:2: rule__XOtherOperatorExpression__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XOtherOperatorExpression__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group_1__1"


    // $ANTLR start "rule__XOtherOperatorExpression__Group_1__1__Impl"
    // InternalXbaseWithAnnotations.g:5925:1: rule__XOtherOperatorExpression__Group_1__1__Impl : ( ( rule__XOtherOperatorExpression__RightOperandAssignment_1_1 ) ) ;
    public final void rule__XOtherOperatorExpression__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5929:1: ( ( ( rule__XOtherOperatorExpression__RightOperandAssignment_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:5930:1: ( ( rule__XOtherOperatorExpression__RightOperandAssignment_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:5930:1: ( ( rule__XOtherOperatorExpression__RightOperandAssignment_1_1 ) )
            // InternalXbaseWithAnnotations.g:5931:2: ( rule__XOtherOperatorExpression__RightOperandAssignment_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOtherOperatorExpressionAccess().getRightOperandAssignment_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:5932:2: ( rule__XOtherOperatorExpression__RightOperandAssignment_1_1 )
            // InternalXbaseWithAnnotations.g:5932:3: rule__XOtherOperatorExpression__RightOperandAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XOtherOperatorExpression__RightOperandAssignment_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOtherOperatorExpressionAccess().getRightOperandAssignment_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group_1__1__Impl"


    // $ANTLR start "rule__XOtherOperatorExpression__Group_1_0__0"
    // InternalXbaseWithAnnotations.g:5941:1: rule__XOtherOperatorExpression__Group_1_0__0 : rule__XOtherOperatorExpression__Group_1_0__0__Impl ;
    public final void rule__XOtherOperatorExpression__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5945:1: ( rule__XOtherOperatorExpression__Group_1_0__0__Impl )
            // InternalXbaseWithAnnotations.g:5946:2: rule__XOtherOperatorExpression__Group_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XOtherOperatorExpression__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group_1_0__0"


    // $ANTLR start "rule__XOtherOperatorExpression__Group_1_0__0__Impl"
    // InternalXbaseWithAnnotations.g:5952:1: rule__XOtherOperatorExpression__Group_1_0__0__Impl : ( ( rule__XOtherOperatorExpression__Group_1_0_0__0 ) ) ;
    public final void rule__XOtherOperatorExpression__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5956:1: ( ( ( rule__XOtherOperatorExpression__Group_1_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:5957:1: ( ( rule__XOtherOperatorExpression__Group_1_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:5957:1: ( ( rule__XOtherOperatorExpression__Group_1_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:5958:2: ( rule__XOtherOperatorExpression__Group_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOtherOperatorExpressionAccess().getGroup_1_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:5959:2: ( rule__XOtherOperatorExpression__Group_1_0_0__0 )
            // InternalXbaseWithAnnotations.g:5959:3: rule__XOtherOperatorExpression__Group_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XOtherOperatorExpression__Group_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOtherOperatorExpressionAccess().getGroup_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group_1_0__0__Impl"


    // $ANTLR start "rule__XOtherOperatorExpression__Group_1_0_0__0"
    // InternalXbaseWithAnnotations.g:5968:1: rule__XOtherOperatorExpression__Group_1_0_0__0 : rule__XOtherOperatorExpression__Group_1_0_0__0__Impl rule__XOtherOperatorExpression__Group_1_0_0__1 ;
    public final void rule__XOtherOperatorExpression__Group_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5972:1: ( rule__XOtherOperatorExpression__Group_1_0_0__0__Impl rule__XOtherOperatorExpression__Group_1_0_0__1 )
            // InternalXbaseWithAnnotations.g:5973:2: rule__XOtherOperatorExpression__Group_1_0_0__0__Impl rule__XOtherOperatorExpression__Group_1_0_0__1
            {
            pushFollow(FOLLOW_29);
            rule__XOtherOperatorExpression__Group_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XOtherOperatorExpression__Group_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group_1_0_0__0"


    // $ANTLR start "rule__XOtherOperatorExpression__Group_1_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:5980:1: rule__XOtherOperatorExpression__Group_1_0_0__0__Impl : ( () ) ;
    public final void rule__XOtherOperatorExpression__Group_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5984:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:5985:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:5985:1: ( () )
            // InternalXbaseWithAnnotations.g:5986:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOtherOperatorExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:5987:2: ()
            // InternalXbaseWithAnnotations.g:5987:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOtherOperatorExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group_1_0_0__0__Impl"


    // $ANTLR start "rule__XOtherOperatorExpression__Group_1_0_0__1"
    // InternalXbaseWithAnnotations.g:5995:1: rule__XOtherOperatorExpression__Group_1_0_0__1 : rule__XOtherOperatorExpression__Group_1_0_0__1__Impl ;
    public final void rule__XOtherOperatorExpression__Group_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:5999:1: ( rule__XOtherOperatorExpression__Group_1_0_0__1__Impl )
            // InternalXbaseWithAnnotations.g:6000:2: rule__XOtherOperatorExpression__Group_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XOtherOperatorExpression__Group_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group_1_0_0__1"


    // $ANTLR start "rule__XOtherOperatorExpression__Group_1_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:6006:1: rule__XOtherOperatorExpression__Group_1_0_0__1__Impl : ( ( rule__XOtherOperatorExpression__FeatureAssignment_1_0_0_1 ) ) ;
    public final void rule__XOtherOperatorExpression__Group_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6010:1: ( ( ( rule__XOtherOperatorExpression__FeatureAssignment_1_0_0_1 ) ) )
            // InternalXbaseWithAnnotations.g:6011:1: ( ( rule__XOtherOperatorExpression__FeatureAssignment_1_0_0_1 ) )
            {
            // InternalXbaseWithAnnotations.g:6011:1: ( ( rule__XOtherOperatorExpression__FeatureAssignment_1_0_0_1 ) )
            // InternalXbaseWithAnnotations.g:6012:2: ( rule__XOtherOperatorExpression__FeatureAssignment_1_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOtherOperatorExpressionAccess().getFeatureAssignment_1_0_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:6013:2: ( rule__XOtherOperatorExpression__FeatureAssignment_1_0_0_1 )
            // InternalXbaseWithAnnotations.g:6013:3: rule__XOtherOperatorExpression__FeatureAssignment_1_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XOtherOperatorExpression__FeatureAssignment_1_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOtherOperatorExpressionAccess().getFeatureAssignment_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__Group_1_0_0__1__Impl"


    // $ANTLR start "rule__OpOther__Group_2__0"
    // InternalXbaseWithAnnotations.g:6022:1: rule__OpOther__Group_2__0 : rule__OpOther__Group_2__0__Impl rule__OpOther__Group_2__1 ;
    public final void rule__OpOther__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6026:1: ( rule__OpOther__Group_2__0__Impl rule__OpOther__Group_2__1 )
            // InternalXbaseWithAnnotations.g:6027:2: rule__OpOther__Group_2__0__Impl rule__OpOther__Group_2__1
            {
            pushFollow(FOLLOW_31);
            rule__OpOther__Group_2__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_2__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_2__0"


    // $ANTLR start "rule__OpOther__Group_2__0__Impl"
    // InternalXbaseWithAnnotations.g:6034:1: rule__OpOther__Group_2__0__Impl : ( '>' ) ;
    public final void rule__OpOther__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6038:1: ( ( '>' ) )
            // InternalXbaseWithAnnotations.g:6039:1: ( '>' )
            {
            // InternalXbaseWithAnnotations.g:6039:1: ( '>' )
            // InternalXbaseWithAnnotations.g:6040:2: '>'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_2_0()); 
            }
            match(input,26,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_2__0__Impl"


    // $ANTLR start "rule__OpOther__Group_2__1"
    // InternalXbaseWithAnnotations.g:6049:1: rule__OpOther__Group_2__1 : rule__OpOther__Group_2__1__Impl ;
    public final void rule__OpOther__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6053:1: ( rule__OpOther__Group_2__1__Impl )
            // InternalXbaseWithAnnotations.g:6054:2: rule__OpOther__Group_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_2__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_2__1"


    // $ANTLR start "rule__OpOther__Group_2__1__Impl"
    // InternalXbaseWithAnnotations.g:6060:1: rule__OpOther__Group_2__1__Impl : ( '..' ) ;
    public final void rule__OpOther__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6064:1: ( ( '..' ) )
            // InternalXbaseWithAnnotations.g:6065:1: ( '..' )
            {
            // InternalXbaseWithAnnotations.g:6065:1: ( '..' )
            // InternalXbaseWithAnnotations.g:6066:2: '..'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getFullStopFullStopKeyword_2_1()); 
            }
            match(input,30,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getFullStopFullStopKeyword_2_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_2__1__Impl"


    // $ANTLR start "rule__OpOther__Group_5__0"
    // InternalXbaseWithAnnotations.g:6076:1: rule__OpOther__Group_5__0 : rule__OpOther__Group_5__0__Impl rule__OpOther__Group_5__1 ;
    public final void rule__OpOther__Group_5__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6080:1: ( rule__OpOther__Group_5__0__Impl rule__OpOther__Group_5__1 )
            // InternalXbaseWithAnnotations.g:6081:2: rule__OpOther__Group_5__0__Impl rule__OpOther__Group_5__1
            {
            pushFollow(FOLLOW_32);
            rule__OpOther__Group_5__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_5__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_5__0"


    // $ANTLR start "rule__OpOther__Group_5__0__Impl"
    // InternalXbaseWithAnnotations.g:6088:1: rule__OpOther__Group_5__0__Impl : ( '>' ) ;
    public final void rule__OpOther__Group_5__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6092:1: ( ( '>' ) )
            // InternalXbaseWithAnnotations.g:6093:1: ( '>' )
            {
            // InternalXbaseWithAnnotations.g:6093:1: ( '>' )
            // InternalXbaseWithAnnotations.g:6094:2: '>'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_5_0()); 
            }
            match(input,26,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_5_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_5__0__Impl"


    // $ANTLR start "rule__OpOther__Group_5__1"
    // InternalXbaseWithAnnotations.g:6103:1: rule__OpOther__Group_5__1 : rule__OpOther__Group_5__1__Impl ;
    public final void rule__OpOther__Group_5__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6107:1: ( rule__OpOther__Group_5__1__Impl )
            // InternalXbaseWithAnnotations.g:6108:2: rule__OpOther__Group_5__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_5__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_5__1"


    // $ANTLR start "rule__OpOther__Group_5__1__Impl"
    // InternalXbaseWithAnnotations.g:6114:1: rule__OpOther__Group_5__1__Impl : ( ( rule__OpOther__Alternatives_5_1 ) ) ;
    public final void rule__OpOther__Group_5__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6118:1: ( ( ( rule__OpOther__Alternatives_5_1 ) ) )
            // InternalXbaseWithAnnotations.g:6119:1: ( ( rule__OpOther__Alternatives_5_1 ) )
            {
            // InternalXbaseWithAnnotations.g:6119:1: ( ( rule__OpOther__Alternatives_5_1 ) )
            // InternalXbaseWithAnnotations.g:6120:2: ( rule__OpOther__Alternatives_5_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getAlternatives_5_1()); 
            }
            // InternalXbaseWithAnnotations.g:6121:2: ( rule__OpOther__Alternatives_5_1 )
            // InternalXbaseWithAnnotations.g:6121:3: rule__OpOther__Alternatives_5_1
            {
            pushFollow(FOLLOW_2);
            rule__OpOther__Alternatives_5_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getAlternatives_5_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_5__1__Impl"


    // $ANTLR start "rule__OpOther__Group_5_1_0__0"
    // InternalXbaseWithAnnotations.g:6130:1: rule__OpOther__Group_5_1_0__0 : rule__OpOther__Group_5_1_0__0__Impl ;
    public final void rule__OpOther__Group_5_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6134:1: ( rule__OpOther__Group_5_1_0__0__Impl )
            // InternalXbaseWithAnnotations.g:6135:2: rule__OpOther__Group_5_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_5_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_5_1_0__0"


    // $ANTLR start "rule__OpOther__Group_5_1_0__0__Impl"
    // InternalXbaseWithAnnotations.g:6141:1: rule__OpOther__Group_5_1_0__0__Impl : ( ( rule__OpOther__Group_5_1_0_0__0 ) ) ;
    public final void rule__OpOther__Group_5_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6145:1: ( ( ( rule__OpOther__Group_5_1_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:6146:1: ( ( rule__OpOther__Group_5_1_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:6146:1: ( ( rule__OpOther__Group_5_1_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:6147:2: ( rule__OpOther__Group_5_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getGroup_5_1_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:6148:2: ( rule__OpOther__Group_5_1_0_0__0 )
            // InternalXbaseWithAnnotations.g:6148:3: rule__OpOther__Group_5_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_5_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getGroup_5_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_5_1_0__0__Impl"


    // $ANTLR start "rule__OpOther__Group_5_1_0_0__0"
    // InternalXbaseWithAnnotations.g:6157:1: rule__OpOther__Group_5_1_0_0__0 : rule__OpOther__Group_5_1_0_0__0__Impl rule__OpOther__Group_5_1_0_0__1 ;
    public final void rule__OpOther__Group_5_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6161:1: ( rule__OpOther__Group_5_1_0_0__0__Impl rule__OpOther__Group_5_1_0_0__1 )
            // InternalXbaseWithAnnotations.g:6162:2: rule__OpOther__Group_5_1_0_0__0__Impl rule__OpOther__Group_5_1_0_0__1
            {
            pushFollow(FOLLOW_32);
            rule__OpOther__Group_5_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_5_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_5_1_0_0__0"


    // $ANTLR start "rule__OpOther__Group_5_1_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:6169:1: rule__OpOther__Group_5_1_0_0__0__Impl : ( '>' ) ;
    public final void rule__OpOther__Group_5_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6173:1: ( ( '>' ) )
            // InternalXbaseWithAnnotations.g:6174:1: ( '>' )
            {
            // InternalXbaseWithAnnotations.g:6174:1: ( '>' )
            // InternalXbaseWithAnnotations.g:6175:2: '>'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_5_1_0_0_0()); 
            }
            match(input,26,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_5_1_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_5_1_0_0__0__Impl"


    // $ANTLR start "rule__OpOther__Group_5_1_0_0__1"
    // InternalXbaseWithAnnotations.g:6184:1: rule__OpOther__Group_5_1_0_0__1 : rule__OpOther__Group_5_1_0_0__1__Impl ;
    public final void rule__OpOther__Group_5_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6188:1: ( rule__OpOther__Group_5_1_0_0__1__Impl )
            // InternalXbaseWithAnnotations.g:6189:2: rule__OpOther__Group_5_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_5_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_5_1_0_0__1"


    // $ANTLR start "rule__OpOther__Group_5_1_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:6195:1: rule__OpOther__Group_5_1_0_0__1__Impl : ( '>' ) ;
    public final void rule__OpOther__Group_5_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6199:1: ( ( '>' ) )
            // InternalXbaseWithAnnotations.g:6200:1: ( '>' )
            {
            // InternalXbaseWithAnnotations.g:6200:1: ( '>' )
            // InternalXbaseWithAnnotations.g:6201:2: '>'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_5_1_0_0_1()); 
            }
            match(input,26,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getGreaterThanSignKeyword_5_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_5_1_0_0__1__Impl"


    // $ANTLR start "rule__OpOther__Group_6__0"
    // InternalXbaseWithAnnotations.g:6211:1: rule__OpOther__Group_6__0 : rule__OpOther__Group_6__0__Impl rule__OpOther__Group_6__1 ;
    public final void rule__OpOther__Group_6__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6215:1: ( rule__OpOther__Group_6__0__Impl rule__OpOther__Group_6__1 )
            // InternalXbaseWithAnnotations.g:6216:2: rule__OpOther__Group_6__0__Impl rule__OpOther__Group_6__1
            {
            pushFollow(FOLLOW_33);
            rule__OpOther__Group_6__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_6__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_6__0"


    // $ANTLR start "rule__OpOther__Group_6__0__Impl"
    // InternalXbaseWithAnnotations.g:6223:1: rule__OpOther__Group_6__0__Impl : ( '<' ) ;
    public final void rule__OpOther__Group_6__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6227:1: ( ( '<' ) )
            // InternalXbaseWithAnnotations.g:6228:1: ( '<' )
            {
            // InternalXbaseWithAnnotations.g:6228:1: ( '<' )
            // InternalXbaseWithAnnotations.g:6229:2: '<'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getLessThanSignKeyword_6_0()); 
            }
            match(input,27,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getLessThanSignKeyword_6_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_6__0__Impl"


    // $ANTLR start "rule__OpOther__Group_6__1"
    // InternalXbaseWithAnnotations.g:6238:1: rule__OpOther__Group_6__1 : rule__OpOther__Group_6__1__Impl ;
    public final void rule__OpOther__Group_6__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6242:1: ( rule__OpOther__Group_6__1__Impl )
            // InternalXbaseWithAnnotations.g:6243:2: rule__OpOther__Group_6__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_6__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_6__1"


    // $ANTLR start "rule__OpOther__Group_6__1__Impl"
    // InternalXbaseWithAnnotations.g:6249:1: rule__OpOther__Group_6__1__Impl : ( ( rule__OpOther__Alternatives_6_1 ) ) ;
    public final void rule__OpOther__Group_6__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6253:1: ( ( ( rule__OpOther__Alternatives_6_1 ) ) )
            // InternalXbaseWithAnnotations.g:6254:1: ( ( rule__OpOther__Alternatives_6_1 ) )
            {
            // InternalXbaseWithAnnotations.g:6254:1: ( ( rule__OpOther__Alternatives_6_1 ) )
            // InternalXbaseWithAnnotations.g:6255:2: ( rule__OpOther__Alternatives_6_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getAlternatives_6_1()); 
            }
            // InternalXbaseWithAnnotations.g:6256:2: ( rule__OpOther__Alternatives_6_1 )
            // InternalXbaseWithAnnotations.g:6256:3: rule__OpOther__Alternatives_6_1
            {
            pushFollow(FOLLOW_2);
            rule__OpOther__Alternatives_6_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getAlternatives_6_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_6__1__Impl"


    // $ANTLR start "rule__OpOther__Group_6_1_0__0"
    // InternalXbaseWithAnnotations.g:6265:1: rule__OpOther__Group_6_1_0__0 : rule__OpOther__Group_6_1_0__0__Impl ;
    public final void rule__OpOther__Group_6_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6269:1: ( rule__OpOther__Group_6_1_0__0__Impl )
            // InternalXbaseWithAnnotations.g:6270:2: rule__OpOther__Group_6_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_6_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_6_1_0__0"


    // $ANTLR start "rule__OpOther__Group_6_1_0__0__Impl"
    // InternalXbaseWithAnnotations.g:6276:1: rule__OpOther__Group_6_1_0__0__Impl : ( ( rule__OpOther__Group_6_1_0_0__0 ) ) ;
    public final void rule__OpOther__Group_6_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6280:1: ( ( ( rule__OpOther__Group_6_1_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:6281:1: ( ( rule__OpOther__Group_6_1_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:6281:1: ( ( rule__OpOther__Group_6_1_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:6282:2: ( rule__OpOther__Group_6_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getGroup_6_1_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:6283:2: ( rule__OpOther__Group_6_1_0_0__0 )
            // InternalXbaseWithAnnotations.g:6283:3: rule__OpOther__Group_6_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_6_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getGroup_6_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_6_1_0__0__Impl"


    // $ANTLR start "rule__OpOther__Group_6_1_0_0__0"
    // InternalXbaseWithAnnotations.g:6292:1: rule__OpOther__Group_6_1_0_0__0 : rule__OpOther__Group_6_1_0_0__0__Impl rule__OpOther__Group_6_1_0_0__1 ;
    public final void rule__OpOther__Group_6_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6296:1: ( rule__OpOther__Group_6_1_0_0__0__Impl rule__OpOther__Group_6_1_0_0__1 )
            // InternalXbaseWithAnnotations.g:6297:2: rule__OpOther__Group_6_1_0_0__0__Impl rule__OpOther__Group_6_1_0_0__1
            {
            pushFollow(FOLLOW_17);
            rule__OpOther__Group_6_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_6_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_6_1_0_0__0"


    // $ANTLR start "rule__OpOther__Group_6_1_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:6304:1: rule__OpOther__Group_6_1_0_0__0__Impl : ( '<' ) ;
    public final void rule__OpOther__Group_6_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6308:1: ( ( '<' ) )
            // InternalXbaseWithAnnotations.g:6309:1: ( '<' )
            {
            // InternalXbaseWithAnnotations.g:6309:1: ( '<' )
            // InternalXbaseWithAnnotations.g:6310:2: '<'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getLessThanSignKeyword_6_1_0_0_0()); 
            }
            match(input,27,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getLessThanSignKeyword_6_1_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_6_1_0_0__0__Impl"


    // $ANTLR start "rule__OpOther__Group_6_1_0_0__1"
    // InternalXbaseWithAnnotations.g:6319:1: rule__OpOther__Group_6_1_0_0__1 : rule__OpOther__Group_6_1_0_0__1__Impl ;
    public final void rule__OpOther__Group_6_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6323:1: ( rule__OpOther__Group_6_1_0_0__1__Impl )
            // InternalXbaseWithAnnotations.g:6324:2: rule__OpOther__Group_6_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__OpOther__Group_6_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_6_1_0_0__1"


    // $ANTLR start "rule__OpOther__Group_6_1_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:6330:1: rule__OpOther__Group_6_1_0_0__1__Impl : ( '<' ) ;
    public final void rule__OpOther__Group_6_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6334:1: ( ( '<' ) )
            // InternalXbaseWithAnnotations.g:6335:1: ( '<' )
            {
            // InternalXbaseWithAnnotations.g:6335:1: ( '<' )
            // InternalXbaseWithAnnotations.g:6336:2: '<'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getOpOtherAccess().getLessThanSignKeyword_6_1_0_0_1()); 
            }
            match(input,27,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getOpOtherAccess().getLessThanSignKeyword_6_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__OpOther__Group_6_1_0_0__1__Impl"


    // $ANTLR start "rule__XAdditiveExpression__Group__0"
    // InternalXbaseWithAnnotations.g:6346:1: rule__XAdditiveExpression__Group__0 : rule__XAdditiveExpression__Group__0__Impl rule__XAdditiveExpression__Group__1 ;
    public final void rule__XAdditiveExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6350:1: ( rule__XAdditiveExpression__Group__0__Impl rule__XAdditiveExpression__Group__1 )
            // InternalXbaseWithAnnotations.g:6351:2: rule__XAdditiveExpression__Group__0__Impl rule__XAdditiveExpression__Group__1
            {
            pushFollow(FOLLOW_34);
            rule__XAdditiveExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAdditiveExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group__0"


    // $ANTLR start "rule__XAdditiveExpression__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:6358:1: rule__XAdditiveExpression__Group__0__Impl : ( ruleXMultiplicativeExpression ) ;
    public final void rule__XAdditiveExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6362:1: ( ( ruleXMultiplicativeExpression ) )
            // InternalXbaseWithAnnotations.g:6363:1: ( ruleXMultiplicativeExpression )
            {
            // InternalXbaseWithAnnotations.g:6363:1: ( ruleXMultiplicativeExpression )
            // InternalXbaseWithAnnotations.g:6364:2: ruleXMultiplicativeExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAdditiveExpressionAccess().getXMultiplicativeExpressionParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXMultiplicativeExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAdditiveExpressionAccess().getXMultiplicativeExpressionParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group__0__Impl"


    // $ANTLR start "rule__XAdditiveExpression__Group__1"
    // InternalXbaseWithAnnotations.g:6373:1: rule__XAdditiveExpression__Group__1 : rule__XAdditiveExpression__Group__1__Impl ;
    public final void rule__XAdditiveExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6377:1: ( rule__XAdditiveExpression__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:6378:2: rule__XAdditiveExpression__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAdditiveExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group__1"


    // $ANTLR start "rule__XAdditiveExpression__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:6384:1: rule__XAdditiveExpression__Group__1__Impl : ( ( rule__XAdditiveExpression__Group_1__0 )* ) ;
    public final void rule__XAdditiveExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6388:1: ( ( ( rule__XAdditiveExpression__Group_1__0 )* ) )
            // InternalXbaseWithAnnotations.g:6389:1: ( ( rule__XAdditiveExpression__Group_1__0 )* )
            {
            // InternalXbaseWithAnnotations.g:6389:1: ( ( rule__XAdditiveExpression__Group_1__0 )* )
            // InternalXbaseWithAnnotations.g:6390:2: ( rule__XAdditiveExpression__Group_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAdditiveExpressionAccess().getGroup_1()); 
            }
            // InternalXbaseWithAnnotations.g:6391:2: ( rule__XAdditiveExpression__Group_1__0 )*
            loop61:
            do {
                int alt61=2;
                int LA61_0 = input.LA(1);

                if ( (LA61_0==35) ) {
                    int LA61_2 = input.LA(2);

                    if ( (synpred104_InternalXbaseWithAnnotations()) ) {
                        alt61=1;
                    }


                }
                else if ( (LA61_0==34) ) {
                    int LA61_3 = input.LA(2);

                    if ( (synpred104_InternalXbaseWithAnnotations()) ) {
                        alt61=1;
                    }


                }


                switch (alt61) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:6391:3: rule__XAdditiveExpression__Group_1__0
            	    {
            	    pushFollow(FOLLOW_35);
            	    rule__XAdditiveExpression__Group_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop61;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAdditiveExpressionAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group__1__Impl"


    // $ANTLR start "rule__XAdditiveExpression__Group_1__0"
    // InternalXbaseWithAnnotations.g:6400:1: rule__XAdditiveExpression__Group_1__0 : rule__XAdditiveExpression__Group_1__0__Impl rule__XAdditiveExpression__Group_1__1 ;
    public final void rule__XAdditiveExpression__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6404:1: ( rule__XAdditiveExpression__Group_1__0__Impl rule__XAdditiveExpression__Group_1__1 )
            // InternalXbaseWithAnnotations.g:6405:2: rule__XAdditiveExpression__Group_1__0__Impl rule__XAdditiveExpression__Group_1__1
            {
            pushFollow(FOLLOW_10);
            rule__XAdditiveExpression__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAdditiveExpression__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group_1__0"


    // $ANTLR start "rule__XAdditiveExpression__Group_1__0__Impl"
    // InternalXbaseWithAnnotations.g:6412:1: rule__XAdditiveExpression__Group_1__0__Impl : ( ( rule__XAdditiveExpression__Group_1_0__0 ) ) ;
    public final void rule__XAdditiveExpression__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6416:1: ( ( ( rule__XAdditiveExpression__Group_1_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:6417:1: ( ( rule__XAdditiveExpression__Group_1_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:6417:1: ( ( rule__XAdditiveExpression__Group_1_0__0 ) )
            // InternalXbaseWithAnnotations.g:6418:2: ( rule__XAdditiveExpression__Group_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAdditiveExpressionAccess().getGroup_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:6419:2: ( rule__XAdditiveExpression__Group_1_0__0 )
            // InternalXbaseWithAnnotations.g:6419:3: rule__XAdditiveExpression__Group_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XAdditiveExpression__Group_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAdditiveExpressionAccess().getGroup_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group_1__0__Impl"


    // $ANTLR start "rule__XAdditiveExpression__Group_1__1"
    // InternalXbaseWithAnnotations.g:6427:1: rule__XAdditiveExpression__Group_1__1 : rule__XAdditiveExpression__Group_1__1__Impl ;
    public final void rule__XAdditiveExpression__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6431:1: ( rule__XAdditiveExpression__Group_1__1__Impl )
            // InternalXbaseWithAnnotations.g:6432:2: rule__XAdditiveExpression__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAdditiveExpression__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group_1__1"


    // $ANTLR start "rule__XAdditiveExpression__Group_1__1__Impl"
    // InternalXbaseWithAnnotations.g:6438:1: rule__XAdditiveExpression__Group_1__1__Impl : ( ( rule__XAdditiveExpression__RightOperandAssignment_1_1 ) ) ;
    public final void rule__XAdditiveExpression__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6442:1: ( ( ( rule__XAdditiveExpression__RightOperandAssignment_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:6443:1: ( ( rule__XAdditiveExpression__RightOperandAssignment_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:6443:1: ( ( rule__XAdditiveExpression__RightOperandAssignment_1_1 ) )
            // InternalXbaseWithAnnotations.g:6444:2: ( rule__XAdditiveExpression__RightOperandAssignment_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAdditiveExpressionAccess().getRightOperandAssignment_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:6445:2: ( rule__XAdditiveExpression__RightOperandAssignment_1_1 )
            // InternalXbaseWithAnnotations.g:6445:3: rule__XAdditiveExpression__RightOperandAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XAdditiveExpression__RightOperandAssignment_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAdditiveExpressionAccess().getRightOperandAssignment_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group_1__1__Impl"


    // $ANTLR start "rule__XAdditiveExpression__Group_1_0__0"
    // InternalXbaseWithAnnotations.g:6454:1: rule__XAdditiveExpression__Group_1_0__0 : rule__XAdditiveExpression__Group_1_0__0__Impl ;
    public final void rule__XAdditiveExpression__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6458:1: ( rule__XAdditiveExpression__Group_1_0__0__Impl )
            // InternalXbaseWithAnnotations.g:6459:2: rule__XAdditiveExpression__Group_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAdditiveExpression__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group_1_0__0"


    // $ANTLR start "rule__XAdditiveExpression__Group_1_0__0__Impl"
    // InternalXbaseWithAnnotations.g:6465:1: rule__XAdditiveExpression__Group_1_0__0__Impl : ( ( rule__XAdditiveExpression__Group_1_0_0__0 ) ) ;
    public final void rule__XAdditiveExpression__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6469:1: ( ( ( rule__XAdditiveExpression__Group_1_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:6470:1: ( ( rule__XAdditiveExpression__Group_1_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:6470:1: ( ( rule__XAdditiveExpression__Group_1_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:6471:2: ( rule__XAdditiveExpression__Group_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAdditiveExpressionAccess().getGroup_1_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:6472:2: ( rule__XAdditiveExpression__Group_1_0_0__0 )
            // InternalXbaseWithAnnotations.g:6472:3: rule__XAdditiveExpression__Group_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XAdditiveExpression__Group_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAdditiveExpressionAccess().getGroup_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group_1_0__0__Impl"


    // $ANTLR start "rule__XAdditiveExpression__Group_1_0_0__0"
    // InternalXbaseWithAnnotations.g:6481:1: rule__XAdditiveExpression__Group_1_0_0__0 : rule__XAdditiveExpression__Group_1_0_0__0__Impl rule__XAdditiveExpression__Group_1_0_0__1 ;
    public final void rule__XAdditiveExpression__Group_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6485:1: ( rule__XAdditiveExpression__Group_1_0_0__0__Impl rule__XAdditiveExpression__Group_1_0_0__1 )
            // InternalXbaseWithAnnotations.g:6486:2: rule__XAdditiveExpression__Group_1_0_0__0__Impl rule__XAdditiveExpression__Group_1_0_0__1
            {
            pushFollow(FOLLOW_34);
            rule__XAdditiveExpression__Group_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XAdditiveExpression__Group_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group_1_0_0__0"


    // $ANTLR start "rule__XAdditiveExpression__Group_1_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:6493:1: rule__XAdditiveExpression__Group_1_0_0__0__Impl : ( () ) ;
    public final void rule__XAdditiveExpression__Group_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6497:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:6498:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:6498:1: ( () )
            // InternalXbaseWithAnnotations.g:6499:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAdditiveExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:6500:2: ()
            // InternalXbaseWithAnnotations.g:6500:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAdditiveExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group_1_0_0__0__Impl"


    // $ANTLR start "rule__XAdditiveExpression__Group_1_0_0__1"
    // InternalXbaseWithAnnotations.g:6508:1: rule__XAdditiveExpression__Group_1_0_0__1 : rule__XAdditiveExpression__Group_1_0_0__1__Impl ;
    public final void rule__XAdditiveExpression__Group_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6512:1: ( rule__XAdditiveExpression__Group_1_0_0__1__Impl )
            // InternalXbaseWithAnnotations.g:6513:2: rule__XAdditiveExpression__Group_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XAdditiveExpression__Group_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group_1_0_0__1"


    // $ANTLR start "rule__XAdditiveExpression__Group_1_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:6519:1: rule__XAdditiveExpression__Group_1_0_0__1__Impl : ( ( rule__XAdditiveExpression__FeatureAssignment_1_0_0_1 ) ) ;
    public final void rule__XAdditiveExpression__Group_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6523:1: ( ( ( rule__XAdditiveExpression__FeatureAssignment_1_0_0_1 ) ) )
            // InternalXbaseWithAnnotations.g:6524:1: ( ( rule__XAdditiveExpression__FeatureAssignment_1_0_0_1 ) )
            {
            // InternalXbaseWithAnnotations.g:6524:1: ( ( rule__XAdditiveExpression__FeatureAssignment_1_0_0_1 ) )
            // InternalXbaseWithAnnotations.g:6525:2: ( rule__XAdditiveExpression__FeatureAssignment_1_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAdditiveExpressionAccess().getFeatureAssignment_1_0_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:6526:2: ( rule__XAdditiveExpression__FeatureAssignment_1_0_0_1 )
            // InternalXbaseWithAnnotations.g:6526:3: rule__XAdditiveExpression__FeatureAssignment_1_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XAdditiveExpression__FeatureAssignment_1_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAdditiveExpressionAccess().getFeatureAssignment_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__Group_1_0_0__1__Impl"


    // $ANTLR start "rule__XMultiplicativeExpression__Group__0"
    // InternalXbaseWithAnnotations.g:6535:1: rule__XMultiplicativeExpression__Group__0 : rule__XMultiplicativeExpression__Group__0__Impl rule__XMultiplicativeExpression__Group__1 ;
    public final void rule__XMultiplicativeExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6539:1: ( rule__XMultiplicativeExpression__Group__0__Impl rule__XMultiplicativeExpression__Group__1 )
            // InternalXbaseWithAnnotations.g:6540:2: rule__XMultiplicativeExpression__Group__0__Impl rule__XMultiplicativeExpression__Group__1
            {
            pushFollow(FOLLOW_36);
            rule__XMultiplicativeExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMultiplicativeExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group__0"


    // $ANTLR start "rule__XMultiplicativeExpression__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:6547:1: rule__XMultiplicativeExpression__Group__0__Impl : ( ruleXUnaryOperation ) ;
    public final void rule__XMultiplicativeExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6551:1: ( ( ruleXUnaryOperation ) )
            // InternalXbaseWithAnnotations.g:6552:1: ( ruleXUnaryOperation )
            {
            // InternalXbaseWithAnnotations.g:6552:1: ( ruleXUnaryOperation )
            // InternalXbaseWithAnnotations.g:6553:2: ruleXUnaryOperation
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMultiplicativeExpressionAccess().getXUnaryOperationParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXUnaryOperation();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMultiplicativeExpressionAccess().getXUnaryOperationParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group__0__Impl"


    // $ANTLR start "rule__XMultiplicativeExpression__Group__1"
    // InternalXbaseWithAnnotations.g:6562:1: rule__XMultiplicativeExpression__Group__1 : rule__XMultiplicativeExpression__Group__1__Impl ;
    public final void rule__XMultiplicativeExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6566:1: ( rule__XMultiplicativeExpression__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:6567:2: rule__XMultiplicativeExpression__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMultiplicativeExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group__1"


    // $ANTLR start "rule__XMultiplicativeExpression__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:6573:1: rule__XMultiplicativeExpression__Group__1__Impl : ( ( rule__XMultiplicativeExpression__Group_1__0 )* ) ;
    public final void rule__XMultiplicativeExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6577:1: ( ( ( rule__XMultiplicativeExpression__Group_1__0 )* ) )
            // InternalXbaseWithAnnotations.g:6578:1: ( ( rule__XMultiplicativeExpression__Group_1__0 )* )
            {
            // InternalXbaseWithAnnotations.g:6578:1: ( ( rule__XMultiplicativeExpression__Group_1__0 )* )
            // InternalXbaseWithAnnotations.g:6579:2: ( rule__XMultiplicativeExpression__Group_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMultiplicativeExpressionAccess().getGroup_1()); 
            }
            // InternalXbaseWithAnnotations.g:6580:2: ( rule__XMultiplicativeExpression__Group_1__0 )*
            loop62:
            do {
                int alt62=2;
                switch ( input.LA(1) ) {
                case 36:
                    {
                    int LA62_2 = input.LA(2);

                    if ( (synpred105_InternalXbaseWithAnnotations()) ) {
                        alt62=1;
                    }


                    }
                    break;
                case 37:
                    {
                    int LA62_3 = input.LA(2);

                    if ( (synpred105_InternalXbaseWithAnnotations()) ) {
                        alt62=1;
                    }


                    }
                    break;
                case 38:
                    {
                    int LA62_4 = input.LA(2);

                    if ( (synpred105_InternalXbaseWithAnnotations()) ) {
                        alt62=1;
                    }


                    }
                    break;
                case 39:
                    {
                    int LA62_5 = input.LA(2);

                    if ( (synpred105_InternalXbaseWithAnnotations()) ) {
                        alt62=1;
                    }


                    }
                    break;

                }

                switch (alt62) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:6580:3: rule__XMultiplicativeExpression__Group_1__0
            	    {
            	    pushFollow(FOLLOW_37);
            	    rule__XMultiplicativeExpression__Group_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop62;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMultiplicativeExpressionAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group__1__Impl"


    // $ANTLR start "rule__XMultiplicativeExpression__Group_1__0"
    // InternalXbaseWithAnnotations.g:6589:1: rule__XMultiplicativeExpression__Group_1__0 : rule__XMultiplicativeExpression__Group_1__0__Impl rule__XMultiplicativeExpression__Group_1__1 ;
    public final void rule__XMultiplicativeExpression__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6593:1: ( rule__XMultiplicativeExpression__Group_1__0__Impl rule__XMultiplicativeExpression__Group_1__1 )
            // InternalXbaseWithAnnotations.g:6594:2: rule__XMultiplicativeExpression__Group_1__0__Impl rule__XMultiplicativeExpression__Group_1__1
            {
            pushFollow(FOLLOW_10);
            rule__XMultiplicativeExpression__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMultiplicativeExpression__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group_1__0"


    // $ANTLR start "rule__XMultiplicativeExpression__Group_1__0__Impl"
    // InternalXbaseWithAnnotations.g:6601:1: rule__XMultiplicativeExpression__Group_1__0__Impl : ( ( rule__XMultiplicativeExpression__Group_1_0__0 ) ) ;
    public final void rule__XMultiplicativeExpression__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6605:1: ( ( ( rule__XMultiplicativeExpression__Group_1_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:6606:1: ( ( rule__XMultiplicativeExpression__Group_1_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:6606:1: ( ( rule__XMultiplicativeExpression__Group_1_0__0 ) )
            // InternalXbaseWithAnnotations.g:6607:2: ( rule__XMultiplicativeExpression__Group_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMultiplicativeExpressionAccess().getGroup_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:6608:2: ( rule__XMultiplicativeExpression__Group_1_0__0 )
            // InternalXbaseWithAnnotations.g:6608:3: rule__XMultiplicativeExpression__Group_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XMultiplicativeExpression__Group_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMultiplicativeExpressionAccess().getGroup_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group_1__0__Impl"


    // $ANTLR start "rule__XMultiplicativeExpression__Group_1__1"
    // InternalXbaseWithAnnotations.g:6616:1: rule__XMultiplicativeExpression__Group_1__1 : rule__XMultiplicativeExpression__Group_1__1__Impl ;
    public final void rule__XMultiplicativeExpression__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6620:1: ( rule__XMultiplicativeExpression__Group_1__1__Impl )
            // InternalXbaseWithAnnotations.g:6621:2: rule__XMultiplicativeExpression__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMultiplicativeExpression__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group_1__1"


    // $ANTLR start "rule__XMultiplicativeExpression__Group_1__1__Impl"
    // InternalXbaseWithAnnotations.g:6627:1: rule__XMultiplicativeExpression__Group_1__1__Impl : ( ( rule__XMultiplicativeExpression__RightOperandAssignment_1_1 ) ) ;
    public final void rule__XMultiplicativeExpression__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6631:1: ( ( ( rule__XMultiplicativeExpression__RightOperandAssignment_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:6632:1: ( ( rule__XMultiplicativeExpression__RightOperandAssignment_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:6632:1: ( ( rule__XMultiplicativeExpression__RightOperandAssignment_1_1 ) )
            // InternalXbaseWithAnnotations.g:6633:2: ( rule__XMultiplicativeExpression__RightOperandAssignment_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMultiplicativeExpressionAccess().getRightOperandAssignment_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:6634:2: ( rule__XMultiplicativeExpression__RightOperandAssignment_1_1 )
            // InternalXbaseWithAnnotations.g:6634:3: rule__XMultiplicativeExpression__RightOperandAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XMultiplicativeExpression__RightOperandAssignment_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMultiplicativeExpressionAccess().getRightOperandAssignment_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group_1__1__Impl"


    // $ANTLR start "rule__XMultiplicativeExpression__Group_1_0__0"
    // InternalXbaseWithAnnotations.g:6643:1: rule__XMultiplicativeExpression__Group_1_0__0 : rule__XMultiplicativeExpression__Group_1_0__0__Impl ;
    public final void rule__XMultiplicativeExpression__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6647:1: ( rule__XMultiplicativeExpression__Group_1_0__0__Impl )
            // InternalXbaseWithAnnotations.g:6648:2: rule__XMultiplicativeExpression__Group_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMultiplicativeExpression__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group_1_0__0"


    // $ANTLR start "rule__XMultiplicativeExpression__Group_1_0__0__Impl"
    // InternalXbaseWithAnnotations.g:6654:1: rule__XMultiplicativeExpression__Group_1_0__0__Impl : ( ( rule__XMultiplicativeExpression__Group_1_0_0__0 ) ) ;
    public final void rule__XMultiplicativeExpression__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6658:1: ( ( ( rule__XMultiplicativeExpression__Group_1_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:6659:1: ( ( rule__XMultiplicativeExpression__Group_1_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:6659:1: ( ( rule__XMultiplicativeExpression__Group_1_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:6660:2: ( rule__XMultiplicativeExpression__Group_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMultiplicativeExpressionAccess().getGroup_1_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:6661:2: ( rule__XMultiplicativeExpression__Group_1_0_0__0 )
            // InternalXbaseWithAnnotations.g:6661:3: rule__XMultiplicativeExpression__Group_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XMultiplicativeExpression__Group_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMultiplicativeExpressionAccess().getGroup_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group_1_0__0__Impl"


    // $ANTLR start "rule__XMultiplicativeExpression__Group_1_0_0__0"
    // InternalXbaseWithAnnotations.g:6670:1: rule__XMultiplicativeExpression__Group_1_0_0__0 : rule__XMultiplicativeExpression__Group_1_0_0__0__Impl rule__XMultiplicativeExpression__Group_1_0_0__1 ;
    public final void rule__XMultiplicativeExpression__Group_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6674:1: ( rule__XMultiplicativeExpression__Group_1_0_0__0__Impl rule__XMultiplicativeExpression__Group_1_0_0__1 )
            // InternalXbaseWithAnnotations.g:6675:2: rule__XMultiplicativeExpression__Group_1_0_0__0__Impl rule__XMultiplicativeExpression__Group_1_0_0__1
            {
            pushFollow(FOLLOW_36);
            rule__XMultiplicativeExpression__Group_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMultiplicativeExpression__Group_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group_1_0_0__0"


    // $ANTLR start "rule__XMultiplicativeExpression__Group_1_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:6682:1: rule__XMultiplicativeExpression__Group_1_0_0__0__Impl : ( () ) ;
    public final void rule__XMultiplicativeExpression__Group_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6686:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:6687:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:6687:1: ( () )
            // InternalXbaseWithAnnotations.g:6688:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMultiplicativeExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:6689:2: ()
            // InternalXbaseWithAnnotations.g:6689:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMultiplicativeExpressionAccess().getXBinaryOperationLeftOperandAction_1_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group_1_0_0__0__Impl"


    // $ANTLR start "rule__XMultiplicativeExpression__Group_1_0_0__1"
    // InternalXbaseWithAnnotations.g:6697:1: rule__XMultiplicativeExpression__Group_1_0_0__1 : rule__XMultiplicativeExpression__Group_1_0_0__1__Impl ;
    public final void rule__XMultiplicativeExpression__Group_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6701:1: ( rule__XMultiplicativeExpression__Group_1_0_0__1__Impl )
            // InternalXbaseWithAnnotations.g:6702:2: rule__XMultiplicativeExpression__Group_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMultiplicativeExpression__Group_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group_1_0_0__1"


    // $ANTLR start "rule__XMultiplicativeExpression__Group_1_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:6708:1: rule__XMultiplicativeExpression__Group_1_0_0__1__Impl : ( ( rule__XMultiplicativeExpression__FeatureAssignment_1_0_0_1 ) ) ;
    public final void rule__XMultiplicativeExpression__Group_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6712:1: ( ( ( rule__XMultiplicativeExpression__FeatureAssignment_1_0_0_1 ) ) )
            // InternalXbaseWithAnnotations.g:6713:1: ( ( rule__XMultiplicativeExpression__FeatureAssignment_1_0_0_1 ) )
            {
            // InternalXbaseWithAnnotations.g:6713:1: ( ( rule__XMultiplicativeExpression__FeatureAssignment_1_0_0_1 ) )
            // InternalXbaseWithAnnotations.g:6714:2: ( rule__XMultiplicativeExpression__FeatureAssignment_1_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMultiplicativeExpressionAccess().getFeatureAssignment_1_0_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:6715:2: ( rule__XMultiplicativeExpression__FeatureAssignment_1_0_0_1 )
            // InternalXbaseWithAnnotations.g:6715:3: rule__XMultiplicativeExpression__FeatureAssignment_1_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XMultiplicativeExpression__FeatureAssignment_1_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMultiplicativeExpressionAccess().getFeatureAssignment_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__Group_1_0_0__1__Impl"


    // $ANTLR start "rule__XUnaryOperation__Group_0__0"
    // InternalXbaseWithAnnotations.g:6724:1: rule__XUnaryOperation__Group_0__0 : rule__XUnaryOperation__Group_0__0__Impl rule__XUnaryOperation__Group_0__1 ;
    public final void rule__XUnaryOperation__Group_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6728:1: ( rule__XUnaryOperation__Group_0__0__Impl rule__XUnaryOperation__Group_0__1 )
            // InternalXbaseWithAnnotations.g:6729:2: rule__XUnaryOperation__Group_0__0__Impl rule__XUnaryOperation__Group_0__1
            {
            pushFollow(FOLLOW_38);
            rule__XUnaryOperation__Group_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XUnaryOperation__Group_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XUnaryOperation__Group_0__0"


    // $ANTLR start "rule__XUnaryOperation__Group_0__0__Impl"
    // InternalXbaseWithAnnotations.g:6736:1: rule__XUnaryOperation__Group_0__0__Impl : ( () ) ;
    public final void rule__XUnaryOperation__Group_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6740:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:6741:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:6741:1: ( () )
            // InternalXbaseWithAnnotations.g:6742:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXUnaryOperationAccess().getXUnaryOperationAction_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:6743:2: ()
            // InternalXbaseWithAnnotations.g:6743:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXUnaryOperationAccess().getXUnaryOperationAction_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XUnaryOperation__Group_0__0__Impl"


    // $ANTLR start "rule__XUnaryOperation__Group_0__1"
    // InternalXbaseWithAnnotations.g:6751:1: rule__XUnaryOperation__Group_0__1 : rule__XUnaryOperation__Group_0__1__Impl rule__XUnaryOperation__Group_0__2 ;
    public final void rule__XUnaryOperation__Group_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6755:1: ( rule__XUnaryOperation__Group_0__1__Impl rule__XUnaryOperation__Group_0__2 )
            // InternalXbaseWithAnnotations.g:6756:2: rule__XUnaryOperation__Group_0__1__Impl rule__XUnaryOperation__Group_0__2
            {
            pushFollow(FOLLOW_10);
            rule__XUnaryOperation__Group_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XUnaryOperation__Group_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XUnaryOperation__Group_0__1"


    // $ANTLR start "rule__XUnaryOperation__Group_0__1__Impl"
    // InternalXbaseWithAnnotations.g:6763:1: rule__XUnaryOperation__Group_0__1__Impl : ( ( rule__XUnaryOperation__FeatureAssignment_0_1 ) ) ;
    public final void rule__XUnaryOperation__Group_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6767:1: ( ( ( rule__XUnaryOperation__FeatureAssignment_0_1 ) ) )
            // InternalXbaseWithAnnotations.g:6768:1: ( ( rule__XUnaryOperation__FeatureAssignment_0_1 ) )
            {
            // InternalXbaseWithAnnotations.g:6768:1: ( ( rule__XUnaryOperation__FeatureAssignment_0_1 ) )
            // InternalXbaseWithAnnotations.g:6769:2: ( rule__XUnaryOperation__FeatureAssignment_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXUnaryOperationAccess().getFeatureAssignment_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:6770:2: ( rule__XUnaryOperation__FeatureAssignment_0_1 )
            // InternalXbaseWithAnnotations.g:6770:3: rule__XUnaryOperation__FeatureAssignment_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XUnaryOperation__FeatureAssignment_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXUnaryOperationAccess().getFeatureAssignment_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XUnaryOperation__Group_0__1__Impl"


    // $ANTLR start "rule__XUnaryOperation__Group_0__2"
    // InternalXbaseWithAnnotations.g:6778:1: rule__XUnaryOperation__Group_0__2 : rule__XUnaryOperation__Group_0__2__Impl ;
    public final void rule__XUnaryOperation__Group_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6782:1: ( rule__XUnaryOperation__Group_0__2__Impl )
            // InternalXbaseWithAnnotations.g:6783:2: rule__XUnaryOperation__Group_0__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XUnaryOperation__Group_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XUnaryOperation__Group_0__2"


    // $ANTLR start "rule__XUnaryOperation__Group_0__2__Impl"
    // InternalXbaseWithAnnotations.g:6789:1: rule__XUnaryOperation__Group_0__2__Impl : ( ( rule__XUnaryOperation__OperandAssignment_0_2 ) ) ;
    public final void rule__XUnaryOperation__Group_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6793:1: ( ( ( rule__XUnaryOperation__OperandAssignment_0_2 ) ) )
            // InternalXbaseWithAnnotations.g:6794:1: ( ( rule__XUnaryOperation__OperandAssignment_0_2 ) )
            {
            // InternalXbaseWithAnnotations.g:6794:1: ( ( rule__XUnaryOperation__OperandAssignment_0_2 ) )
            // InternalXbaseWithAnnotations.g:6795:2: ( rule__XUnaryOperation__OperandAssignment_0_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXUnaryOperationAccess().getOperandAssignment_0_2()); 
            }
            // InternalXbaseWithAnnotations.g:6796:2: ( rule__XUnaryOperation__OperandAssignment_0_2 )
            // InternalXbaseWithAnnotations.g:6796:3: rule__XUnaryOperation__OperandAssignment_0_2
            {
            pushFollow(FOLLOW_2);
            rule__XUnaryOperation__OperandAssignment_0_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXUnaryOperationAccess().getOperandAssignment_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XUnaryOperation__Group_0__2__Impl"


    // $ANTLR start "rule__XCastedExpression__Group__0"
    // InternalXbaseWithAnnotations.g:6805:1: rule__XCastedExpression__Group__0 : rule__XCastedExpression__Group__0__Impl rule__XCastedExpression__Group__1 ;
    public final void rule__XCastedExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6809:1: ( rule__XCastedExpression__Group__0__Impl rule__XCastedExpression__Group__1 )
            // InternalXbaseWithAnnotations.g:6810:2: rule__XCastedExpression__Group__0__Impl rule__XCastedExpression__Group__1
            {
            pushFollow(FOLLOW_39);
            rule__XCastedExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XCastedExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group__0"


    // $ANTLR start "rule__XCastedExpression__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:6817:1: rule__XCastedExpression__Group__0__Impl : ( ruleXPostfixOperation ) ;
    public final void rule__XCastedExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6821:1: ( ( ruleXPostfixOperation ) )
            // InternalXbaseWithAnnotations.g:6822:1: ( ruleXPostfixOperation )
            {
            // InternalXbaseWithAnnotations.g:6822:1: ( ruleXPostfixOperation )
            // InternalXbaseWithAnnotations.g:6823:2: ruleXPostfixOperation
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCastedExpressionAccess().getXPostfixOperationParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXPostfixOperation();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCastedExpressionAccess().getXPostfixOperationParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group__0__Impl"


    // $ANTLR start "rule__XCastedExpression__Group__1"
    // InternalXbaseWithAnnotations.g:6832:1: rule__XCastedExpression__Group__1 : rule__XCastedExpression__Group__1__Impl ;
    public final void rule__XCastedExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6836:1: ( rule__XCastedExpression__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:6837:2: rule__XCastedExpression__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XCastedExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group__1"


    // $ANTLR start "rule__XCastedExpression__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:6843:1: rule__XCastedExpression__Group__1__Impl : ( ( rule__XCastedExpression__Group_1__0 )* ) ;
    public final void rule__XCastedExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6847:1: ( ( ( rule__XCastedExpression__Group_1__0 )* ) )
            // InternalXbaseWithAnnotations.g:6848:1: ( ( rule__XCastedExpression__Group_1__0 )* )
            {
            // InternalXbaseWithAnnotations.g:6848:1: ( ( rule__XCastedExpression__Group_1__0 )* )
            // InternalXbaseWithAnnotations.g:6849:2: ( rule__XCastedExpression__Group_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCastedExpressionAccess().getGroup_1()); 
            }
            // InternalXbaseWithAnnotations.g:6850:2: ( rule__XCastedExpression__Group_1__0 )*
            loop63:
            do {
                int alt63=2;
                int LA63_0 = input.LA(1);

                if ( (LA63_0==59) ) {
                    int LA63_2 = input.LA(2);

                    if ( (synpred106_InternalXbaseWithAnnotations()) ) {
                        alt63=1;
                    }


                }


                switch (alt63) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:6850:3: rule__XCastedExpression__Group_1__0
            	    {
            	    pushFollow(FOLLOW_40);
            	    rule__XCastedExpression__Group_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop63;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCastedExpressionAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group__1__Impl"


    // $ANTLR start "rule__XCastedExpression__Group_1__0"
    // InternalXbaseWithAnnotations.g:6859:1: rule__XCastedExpression__Group_1__0 : rule__XCastedExpression__Group_1__0__Impl rule__XCastedExpression__Group_1__1 ;
    public final void rule__XCastedExpression__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6863:1: ( rule__XCastedExpression__Group_1__0__Impl rule__XCastedExpression__Group_1__1 )
            // InternalXbaseWithAnnotations.g:6864:2: rule__XCastedExpression__Group_1__0__Impl rule__XCastedExpression__Group_1__1
            {
            pushFollow(FOLLOW_27);
            rule__XCastedExpression__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XCastedExpression__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group_1__0"


    // $ANTLR start "rule__XCastedExpression__Group_1__0__Impl"
    // InternalXbaseWithAnnotations.g:6871:1: rule__XCastedExpression__Group_1__0__Impl : ( ( rule__XCastedExpression__Group_1_0__0 ) ) ;
    public final void rule__XCastedExpression__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6875:1: ( ( ( rule__XCastedExpression__Group_1_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:6876:1: ( ( rule__XCastedExpression__Group_1_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:6876:1: ( ( rule__XCastedExpression__Group_1_0__0 ) )
            // InternalXbaseWithAnnotations.g:6877:2: ( rule__XCastedExpression__Group_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCastedExpressionAccess().getGroup_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:6878:2: ( rule__XCastedExpression__Group_1_0__0 )
            // InternalXbaseWithAnnotations.g:6878:3: rule__XCastedExpression__Group_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XCastedExpression__Group_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCastedExpressionAccess().getGroup_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group_1__0__Impl"


    // $ANTLR start "rule__XCastedExpression__Group_1__1"
    // InternalXbaseWithAnnotations.g:6886:1: rule__XCastedExpression__Group_1__1 : rule__XCastedExpression__Group_1__1__Impl ;
    public final void rule__XCastedExpression__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6890:1: ( rule__XCastedExpression__Group_1__1__Impl )
            // InternalXbaseWithAnnotations.g:6891:2: rule__XCastedExpression__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XCastedExpression__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group_1__1"


    // $ANTLR start "rule__XCastedExpression__Group_1__1__Impl"
    // InternalXbaseWithAnnotations.g:6897:1: rule__XCastedExpression__Group_1__1__Impl : ( ( rule__XCastedExpression__TypeAssignment_1_1 ) ) ;
    public final void rule__XCastedExpression__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6901:1: ( ( ( rule__XCastedExpression__TypeAssignment_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:6902:1: ( ( rule__XCastedExpression__TypeAssignment_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:6902:1: ( ( rule__XCastedExpression__TypeAssignment_1_1 ) )
            // InternalXbaseWithAnnotations.g:6903:2: ( rule__XCastedExpression__TypeAssignment_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCastedExpressionAccess().getTypeAssignment_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:6904:2: ( rule__XCastedExpression__TypeAssignment_1_1 )
            // InternalXbaseWithAnnotations.g:6904:3: rule__XCastedExpression__TypeAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XCastedExpression__TypeAssignment_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCastedExpressionAccess().getTypeAssignment_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group_1__1__Impl"


    // $ANTLR start "rule__XCastedExpression__Group_1_0__0"
    // InternalXbaseWithAnnotations.g:6913:1: rule__XCastedExpression__Group_1_0__0 : rule__XCastedExpression__Group_1_0__0__Impl ;
    public final void rule__XCastedExpression__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6917:1: ( rule__XCastedExpression__Group_1_0__0__Impl )
            // InternalXbaseWithAnnotations.g:6918:2: rule__XCastedExpression__Group_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XCastedExpression__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group_1_0__0"


    // $ANTLR start "rule__XCastedExpression__Group_1_0__0__Impl"
    // InternalXbaseWithAnnotations.g:6924:1: rule__XCastedExpression__Group_1_0__0__Impl : ( ( rule__XCastedExpression__Group_1_0_0__0 ) ) ;
    public final void rule__XCastedExpression__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6928:1: ( ( ( rule__XCastedExpression__Group_1_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:6929:1: ( ( rule__XCastedExpression__Group_1_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:6929:1: ( ( rule__XCastedExpression__Group_1_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:6930:2: ( rule__XCastedExpression__Group_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCastedExpressionAccess().getGroup_1_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:6931:2: ( rule__XCastedExpression__Group_1_0_0__0 )
            // InternalXbaseWithAnnotations.g:6931:3: rule__XCastedExpression__Group_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XCastedExpression__Group_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCastedExpressionAccess().getGroup_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group_1_0__0__Impl"


    // $ANTLR start "rule__XCastedExpression__Group_1_0_0__0"
    // InternalXbaseWithAnnotations.g:6940:1: rule__XCastedExpression__Group_1_0_0__0 : rule__XCastedExpression__Group_1_0_0__0__Impl rule__XCastedExpression__Group_1_0_0__1 ;
    public final void rule__XCastedExpression__Group_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6944:1: ( rule__XCastedExpression__Group_1_0_0__0__Impl rule__XCastedExpression__Group_1_0_0__1 )
            // InternalXbaseWithAnnotations.g:6945:2: rule__XCastedExpression__Group_1_0_0__0__Impl rule__XCastedExpression__Group_1_0_0__1
            {
            pushFollow(FOLLOW_39);
            rule__XCastedExpression__Group_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XCastedExpression__Group_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group_1_0_0__0"


    // $ANTLR start "rule__XCastedExpression__Group_1_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:6952:1: rule__XCastedExpression__Group_1_0_0__0__Impl : ( () ) ;
    public final void rule__XCastedExpression__Group_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6956:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:6957:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:6957:1: ( () )
            // InternalXbaseWithAnnotations.g:6958:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCastedExpressionAccess().getXCastedExpressionTargetAction_1_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:6959:2: ()
            // InternalXbaseWithAnnotations.g:6959:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCastedExpressionAccess().getXCastedExpressionTargetAction_1_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group_1_0_0__0__Impl"


    // $ANTLR start "rule__XCastedExpression__Group_1_0_0__1"
    // InternalXbaseWithAnnotations.g:6967:1: rule__XCastedExpression__Group_1_0_0__1 : rule__XCastedExpression__Group_1_0_0__1__Impl ;
    public final void rule__XCastedExpression__Group_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6971:1: ( rule__XCastedExpression__Group_1_0_0__1__Impl )
            // InternalXbaseWithAnnotations.g:6972:2: rule__XCastedExpression__Group_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XCastedExpression__Group_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group_1_0_0__1"


    // $ANTLR start "rule__XCastedExpression__Group_1_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:6978:1: rule__XCastedExpression__Group_1_0_0__1__Impl : ( 'as' ) ;
    public final void rule__XCastedExpression__Group_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6982:1: ( ( 'as' ) )
            // InternalXbaseWithAnnotations.g:6983:1: ( 'as' )
            {
            // InternalXbaseWithAnnotations.g:6983:1: ( 'as' )
            // InternalXbaseWithAnnotations.g:6984:2: 'as'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCastedExpressionAccess().getAsKeyword_1_0_0_1()); 
            }
            match(input,59,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCastedExpressionAccess().getAsKeyword_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__Group_1_0_0__1__Impl"


    // $ANTLR start "rule__XPostfixOperation__Group__0"
    // InternalXbaseWithAnnotations.g:6994:1: rule__XPostfixOperation__Group__0 : rule__XPostfixOperation__Group__0__Impl rule__XPostfixOperation__Group__1 ;
    public final void rule__XPostfixOperation__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:6998:1: ( rule__XPostfixOperation__Group__0__Impl rule__XPostfixOperation__Group__1 )
            // InternalXbaseWithAnnotations.g:6999:2: rule__XPostfixOperation__Group__0__Impl rule__XPostfixOperation__Group__1
            {
            pushFollow(FOLLOW_41);
            rule__XPostfixOperation__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XPostfixOperation__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XPostfixOperation__Group__0"


    // $ANTLR start "rule__XPostfixOperation__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:7006:1: rule__XPostfixOperation__Group__0__Impl : ( ruleXMemberFeatureCall ) ;
    public final void rule__XPostfixOperation__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7010:1: ( ( ruleXMemberFeatureCall ) )
            // InternalXbaseWithAnnotations.g:7011:1: ( ruleXMemberFeatureCall )
            {
            // InternalXbaseWithAnnotations.g:7011:1: ( ruleXMemberFeatureCall )
            // InternalXbaseWithAnnotations.g:7012:2: ruleXMemberFeatureCall
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXPostfixOperationAccess().getXMemberFeatureCallParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXMemberFeatureCall();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXPostfixOperationAccess().getXMemberFeatureCallParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XPostfixOperation__Group__0__Impl"


    // $ANTLR start "rule__XPostfixOperation__Group__1"
    // InternalXbaseWithAnnotations.g:7021:1: rule__XPostfixOperation__Group__1 : rule__XPostfixOperation__Group__1__Impl ;
    public final void rule__XPostfixOperation__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7025:1: ( rule__XPostfixOperation__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:7026:2: rule__XPostfixOperation__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XPostfixOperation__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XPostfixOperation__Group__1"


    // $ANTLR start "rule__XPostfixOperation__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:7032:1: rule__XPostfixOperation__Group__1__Impl : ( ( rule__XPostfixOperation__Group_1__0 )? ) ;
    public final void rule__XPostfixOperation__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7036:1: ( ( ( rule__XPostfixOperation__Group_1__0 )? ) )
            // InternalXbaseWithAnnotations.g:7037:1: ( ( rule__XPostfixOperation__Group_1__0 )? )
            {
            // InternalXbaseWithAnnotations.g:7037:1: ( ( rule__XPostfixOperation__Group_1__0 )? )
            // InternalXbaseWithAnnotations.g:7038:2: ( rule__XPostfixOperation__Group_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXPostfixOperationAccess().getGroup_1()); 
            }
            // InternalXbaseWithAnnotations.g:7039:2: ( rule__XPostfixOperation__Group_1__0 )?
            int alt64=2;
            int LA64_0 = input.LA(1);

            if ( (LA64_0==41) ) {
                int LA64_1 = input.LA(2);

                if ( (synpred107_InternalXbaseWithAnnotations()) ) {
                    alt64=1;
                }
            }
            else if ( (LA64_0==42) ) {
                int LA64_2 = input.LA(2);

                if ( (synpred107_InternalXbaseWithAnnotations()) ) {
                    alt64=1;
                }
            }
            switch (alt64) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:7039:3: rule__XPostfixOperation__Group_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XPostfixOperation__Group_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXPostfixOperationAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XPostfixOperation__Group__1__Impl"


    // $ANTLR start "rule__XPostfixOperation__Group_1__0"
    // InternalXbaseWithAnnotations.g:7048:1: rule__XPostfixOperation__Group_1__0 : rule__XPostfixOperation__Group_1__0__Impl ;
    public final void rule__XPostfixOperation__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7052:1: ( rule__XPostfixOperation__Group_1__0__Impl )
            // InternalXbaseWithAnnotations.g:7053:2: rule__XPostfixOperation__Group_1__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XPostfixOperation__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XPostfixOperation__Group_1__0"


    // $ANTLR start "rule__XPostfixOperation__Group_1__0__Impl"
    // InternalXbaseWithAnnotations.g:7059:1: rule__XPostfixOperation__Group_1__0__Impl : ( ( rule__XPostfixOperation__Group_1_0__0 ) ) ;
    public final void rule__XPostfixOperation__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7063:1: ( ( ( rule__XPostfixOperation__Group_1_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:7064:1: ( ( rule__XPostfixOperation__Group_1_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:7064:1: ( ( rule__XPostfixOperation__Group_1_0__0 ) )
            // InternalXbaseWithAnnotations.g:7065:2: ( rule__XPostfixOperation__Group_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXPostfixOperationAccess().getGroup_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:7066:2: ( rule__XPostfixOperation__Group_1_0__0 )
            // InternalXbaseWithAnnotations.g:7066:3: rule__XPostfixOperation__Group_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XPostfixOperation__Group_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXPostfixOperationAccess().getGroup_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XPostfixOperation__Group_1__0__Impl"


    // $ANTLR start "rule__XPostfixOperation__Group_1_0__0"
    // InternalXbaseWithAnnotations.g:7075:1: rule__XPostfixOperation__Group_1_0__0 : rule__XPostfixOperation__Group_1_0__0__Impl rule__XPostfixOperation__Group_1_0__1 ;
    public final void rule__XPostfixOperation__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7079:1: ( rule__XPostfixOperation__Group_1_0__0__Impl rule__XPostfixOperation__Group_1_0__1 )
            // InternalXbaseWithAnnotations.g:7080:2: rule__XPostfixOperation__Group_1_0__0__Impl rule__XPostfixOperation__Group_1_0__1
            {
            pushFollow(FOLLOW_41);
            rule__XPostfixOperation__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XPostfixOperation__Group_1_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XPostfixOperation__Group_1_0__0"


    // $ANTLR start "rule__XPostfixOperation__Group_1_0__0__Impl"
    // InternalXbaseWithAnnotations.g:7087:1: rule__XPostfixOperation__Group_1_0__0__Impl : ( () ) ;
    public final void rule__XPostfixOperation__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7091:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:7092:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:7092:1: ( () )
            // InternalXbaseWithAnnotations.g:7093:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXPostfixOperationAccess().getXPostfixOperationOperandAction_1_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:7094:2: ()
            // InternalXbaseWithAnnotations.g:7094:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXPostfixOperationAccess().getXPostfixOperationOperandAction_1_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XPostfixOperation__Group_1_0__0__Impl"


    // $ANTLR start "rule__XPostfixOperation__Group_1_0__1"
    // InternalXbaseWithAnnotations.g:7102:1: rule__XPostfixOperation__Group_1_0__1 : rule__XPostfixOperation__Group_1_0__1__Impl ;
    public final void rule__XPostfixOperation__Group_1_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7106:1: ( rule__XPostfixOperation__Group_1_0__1__Impl )
            // InternalXbaseWithAnnotations.g:7107:2: rule__XPostfixOperation__Group_1_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XPostfixOperation__Group_1_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XPostfixOperation__Group_1_0__1"


    // $ANTLR start "rule__XPostfixOperation__Group_1_0__1__Impl"
    // InternalXbaseWithAnnotations.g:7113:1: rule__XPostfixOperation__Group_1_0__1__Impl : ( ( rule__XPostfixOperation__FeatureAssignment_1_0_1 ) ) ;
    public final void rule__XPostfixOperation__Group_1_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7117:1: ( ( ( rule__XPostfixOperation__FeatureAssignment_1_0_1 ) ) )
            // InternalXbaseWithAnnotations.g:7118:1: ( ( rule__XPostfixOperation__FeatureAssignment_1_0_1 ) )
            {
            // InternalXbaseWithAnnotations.g:7118:1: ( ( rule__XPostfixOperation__FeatureAssignment_1_0_1 ) )
            // InternalXbaseWithAnnotations.g:7119:2: ( rule__XPostfixOperation__FeatureAssignment_1_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXPostfixOperationAccess().getFeatureAssignment_1_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:7120:2: ( rule__XPostfixOperation__FeatureAssignment_1_0_1 )
            // InternalXbaseWithAnnotations.g:7120:3: rule__XPostfixOperation__FeatureAssignment_1_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XPostfixOperation__FeatureAssignment_1_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXPostfixOperationAccess().getFeatureAssignment_1_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XPostfixOperation__Group_1_0__1__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group__0"
    // InternalXbaseWithAnnotations.g:7129:1: rule__XMemberFeatureCall__Group__0 : rule__XMemberFeatureCall__Group__0__Impl rule__XMemberFeatureCall__Group__1 ;
    public final void rule__XMemberFeatureCall__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7133:1: ( rule__XMemberFeatureCall__Group__0__Impl rule__XMemberFeatureCall__Group__1 )
            // InternalXbaseWithAnnotations.g:7134:2: rule__XMemberFeatureCall__Group__0__Impl rule__XMemberFeatureCall__Group__1
            {
            pushFollow(FOLLOW_42);
            rule__XMemberFeatureCall__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group__0"


    // $ANTLR start "rule__XMemberFeatureCall__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:7141:1: rule__XMemberFeatureCall__Group__0__Impl : ( ruleXPrimaryExpression ) ;
    public final void rule__XMemberFeatureCall__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7145:1: ( ( ruleXPrimaryExpression ) )
            // InternalXbaseWithAnnotations.g:7146:1: ( ruleXPrimaryExpression )
            {
            // InternalXbaseWithAnnotations.g:7146:1: ( ruleXPrimaryExpression )
            // InternalXbaseWithAnnotations.g:7147:2: ruleXPrimaryExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getXPrimaryExpressionParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXPrimaryExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getXPrimaryExpressionParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group__0__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group__1"
    // InternalXbaseWithAnnotations.g:7156:1: rule__XMemberFeatureCall__Group__1 : rule__XMemberFeatureCall__Group__1__Impl ;
    public final void rule__XMemberFeatureCall__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7160:1: ( rule__XMemberFeatureCall__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:7161:2: rule__XMemberFeatureCall__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group__1"


    // $ANTLR start "rule__XMemberFeatureCall__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:7167:1: rule__XMemberFeatureCall__Group__1__Impl : ( ( rule__XMemberFeatureCall__Alternatives_1 )* ) ;
    public final void rule__XMemberFeatureCall__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7171:1: ( ( ( rule__XMemberFeatureCall__Alternatives_1 )* ) )
            // InternalXbaseWithAnnotations.g:7172:1: ( ( rule__XMemberFeatureCall__Alternatives_1 )* )
            {
            // InternalXbaseWithAnnotations.g:7172:1: ( ( rule__XMemberFeatureCall__Alternatives_1 )* )
            // InternalXbaseWithAnnotations.g:7173:2: ( rule__XMemberFeatureCall__Alternatives_1 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getAlternatives_1()); 
            }
            // InternalXbaseWithAnnotations.g:7174:2: ( rule__XMemberFeatureCall__Alternatives_1 )*
            loop65:
            do {
                int alt65=2;
                switch ( input.LA(1) ) {
                case 43:
                    {
                    int LA65_2 = input.LA(2);

                    if ( (synpred108_InternalXbaseWithAnnotations()) ) {
                        alt65=1;
                    }


                    }
                    break;
                case 83:
                    {
                    int LA65_3 = input.LA(2);

                    if ( (synpred108_InternalXbaseWithAnnotations()) ) {
                        alt65=1;
                    }


                    }
                    break;
                case 84:
                    {
                    int LA65_4 = input.LA(2);

                    if ( (synpred108_InternalXbaseWithAnnotations()) ) {
                        alt65=1;
                    }


                    }
                    break;

                }

                switch (alt65) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:7174:3: rule__XMemberFeatureCall__Alternatives_1
            	    {
            	    pushFollow(FOLLOW_43);
            	    rule__XMemberFeatureCall__Alternatives_1();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop65;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getAlternatives_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group__1__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0__0"
    // InternalXbaseWithAnnotations.g:7183:1: rule__XMemberFeatureCall__Group_1_0__0 : rule__XMemberFeatureCall__Group_1_0__0__Impl rule__XMemberFeatureCall__Group_1_0__1 ;
    public final void rule__XMemberFeatureCall__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7187:1: ( rule__XMemberFeatureCall__Group_1_0__0__Impl rule__XMemberFeatureCall__Group_1_0__1 )
            // InternalXbaseWithAnnotations.g:7188:2: rule__XMemberFeatureCall__Group_1_0__0__Impl rule__XMemberFeatureCall__Group_1_0__1
            {
            pushFollow(FOLLOW_10);
            rule__XMemberFeatureCall__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0__0"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0__0__Impl"
    // InternalXbaseWithAnnotations.g:7195:1: rule__XMemberFeatureCall__Group_1_0__0__Impl : ( ( rule__XMemberFeatureCall__Group_1_0_0__0 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7199:1: ( ( ( rule__XMemberFeatureCall__Group_1_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:7200:1: ( ( rule__XMemberFeatureCall__Group_1_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:7200:1: ( ( rule__XMemberFeatureCall__Group_1_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:7201:2: ( rule__XMemberFeatureCall__Group_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:7202:2: ( rule__XMemberFeatureCall__Group_1_0_0__0 )
            // InternalXbaseWithAnnotations.g:7202:3: rule__XMemberFeatureCall__Group_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0__0__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0__1"
    // InternalXbaseWithAnnotations.g:7210:1: rule__XMemberFeatureCall__Group_1_0__1 : rule__XMemberFeatureCall__Group_1_0__1__Impl ;
    public final void rule__XMemberFeatureCall__Group_1_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7214:1: ( rule__XMemberFeatureCall__Group_1_0__1__Impl )
            // InternalXbaseWithAnnotations.g:7215:2: rule__XMemberFeatureCall__Group_1_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0__1"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0__1__Impl"
    // InternalXbaseWithAnnotations.g:7221:1: rule__XMemberFeatureCall__Group_1_0__1__Impl : ( ( rule__XMemberFeatureCall__ValueAssignment_1_0_1 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7225:1: ( ( ( rule__XMemberFeatureCall__ValueAssignment_1_0_1 ) ) )
            // InternalXbaseWithAnnotations.g:7226:1: ( ( rule__XMemberFeatureCall__ValueAssignment_1_0_1 ) )
            {
            // InternalXbaseWithAnnotations.g:7226:1: ( ( rule__XMemberFeatureCall__ValueAssignment_1_0_1 ) )
            // InternalXbaseWithAnnotations.g:7227:2: ( rule__XMemberFeatureCall__ValueAssignment_1_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getValueAssignment_1_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:7228:2: ( rule__XMemberFeatureCall__ValueAssignment_1_0_1 )
            // InternalXbaseWithAnnotations.g:7228:3: rule__XMemberFeatureCall__ValueAssignment_1_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__ValueAssignment_1_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getValueAssignment_1_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0__1__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0_0__0"
    // InternalXbaseWithAnnotations.g:7237:1: rule__XMemberFeatureCall__Group_1_0_0__0 : rule__XMemberFeatureCall__Group_1_0_0__0__Impl ;
    public final void rule__XMemberFeatureCall__Group_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7241:1: ( rule__XMemberFeatureCall__Group_1_0_0__0__Impl )
            // InternalXbaseWithAnnotations.g:7242:2: rule__XMemberFeatureCall__Group_1_0_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0_0__0"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:7248:1: rule__XMemberFeatureCall__Group_1_0_0__0__Impl : ( ( rule__XMemberFeatureCall__Group_1_0_0_0__0 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7252:1: ( ( ( rule__XMemberFeatureCall__Group_1_0_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:7253:1: ( ( rule__XMemberFeatureCall__Group_1_0_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:7253:1: ( ( rule__XMemberFeatureCall__Group_1_0_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:7254:2: ( rule__XMemberFeatureCall__Group_1_0_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:7255:2: ( rule__XMemberFeatureCall__Group_1_0_0_0__0 )
            // InternalXbaseWithAnnotations.g:7255:3: rule__XMemberFeatureCall__Group_1_0_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_0_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0_0__0__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0_0_0__0"
    // InternalXbaseWithAnnotations.g:7264:1: rule__XMemberFeatureCall__Group_1_0_0_0__0 : rule__XMemberFeatureCall__Group_1_0_0_0__0__Impl rule__XMemberFeatureCall__Group_1_0_0_0__1 ;
    public final void rule__XMemberFeatureCall__Group_1_0_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7268:1: ( rule__XMemberFeatureCall__Group_1_0_0_0__0__Impl rule__XMemberFeatureCall__Group_1_0_0_0__1 )
            // InternalXbaseWithAnnotations.g:7269:2: rule__XMemberFeatureCall__Group_1_0_0_0__0__Impl rule__XMemberFeatureCall__Group_1_0_0_0__1
            {
            pushFollow(FOLLOW_44);
            rule__XMemberFeatureCall__Group_1_0_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_0_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0_0_0__0"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:7276:1: rule__XMemberFeatureCall__Group_1_0_0_0__0__Impl : ( () ) ;
    public final void rule__XMemberFeatureCall__Group_1_0_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7280:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:7281:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:7281:1: ( () )
            // InternalXbaseWithAnnotations.g:7282:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getXAssignmentAssignableAction_1_0_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:7283:2: ()
            // InternalXbaseWithAnnotations.g:7283:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getXAssignmentAssignableAction_1_0_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0_0_0__0__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0_0_0__1"
    // InternalXbaseWithAnnotations.g:7291:1: rule__XMemberFeatureCall__Group_1_0_0_0__1 : rule__XMemberFeatureCall__Group_1_0_0_0__1__Impl rule__XMemberFeatureCall__Group_1_0_0_0__2 ;
    public final void rule__XMemberFeatureCall__Group_1_0_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7295:1: ( rule__XMemberFeatureCall__Group_1_0_0_0__1__Impl rule__XMemberFeatureCall__Group_1_0_0_0__2 )
            // InternalXbaseWithAnnotations.g:7296:2: rule__XMemberFeatureCall__Group_1_0_0_0__1__Impl rule__XMemberFeatureCall__Group_1_0_0_0__2
            {
            pushFollow(FOLLOW_15);
            rule__XMemberFeatureCall__Group_1_0_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_0_0_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0_0_0__1"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:7303:1: rule__XMemberFeatureCall__Group_1_0_0_0__1__Impl : ( ( rule__XMemberFeatureCall__Alternatives_1_0_0_0_1 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_0_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7307:1: ( ( ( rule__XMemberFeatureCall__Alternatives_1_0_0_0_1 ) ) )
            // InternalXbaseWithAnnotations.g:7308:1: ( ( rule__XMemberFeatureCall__Alternatives_1_0_0_0_1 ) )
            {
            // InternalXbaseWithAnnotations.g:7308:1: ( ( rule__XMemberFeatureCall__Alternatives_1_0_0_0_1 ) )
            // InternalXbaseWithAnnotations.g:7309:2: ( rule__XMemberFeatureCall__Alternatives_1_0_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getAlternatives_1_0_0_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:7310:2: ( rule__XMemberFeatureCall__Alternatives_1_0_0_0_1 )
            // InternalXbaseWithAnnotations.g:7310:3: rule__XMemberFeatureCall__Alternatives_1_0_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Alternatives_1_0_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getAlternatives_1_0_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0_0_0__1__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0_0_0__2"
    // InternalXbaseWithAnnotations.g:7318:1: rule__XMemberFeatureCall__Group_1_0_0_0__2 : rule__XMemberFeatureCall__Group_1_0_0_0__2__Impl rule__XMemberFeatureCall__Group_1_0_0_0__3 ;
    public final void rule__XMemberFeatureCall__Group_1_0_0_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7322:1: ( rule__XMemberFeatureCall__Group_1_0_0_0__2__Impl rule__XMemberFeatureCall__Group_1_0_0_0__3 )
            // InternalXbaseWithAnnotations.g:7323:2: rule__XMemberFeatureCall__Group_1_0_0_0__2__Impl rule__XMemberFeatureCall__Group_1_0_0_0__3
            {
            pushFollow(FOLLOW_11);
            rule__XMemberFeatureCall__Group_1_0_0_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_0_0_0__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0_0_0__2"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0_0_0__2__Impl"
    // InternalXbaseWithAnnotations.g:7330:1: rule__XMemberFeatureCall__Group_1_0_0_0__2__Impl : ( ( rule__XMemberFeatureCall__FeatureAssignment_1_0_0_0_2 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_0_0_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7334:1: ( ( ( rule__XMemberFeatureCall__FeatureAssignment_1_0_0_0_2 ) ) )
            // InternalXbaseWithAnnotations.g:7335:1: ( ( rule__XMemberFeatureCall__FeatureAssignment_1_0_0_0_2 ) )
            {
            // InternalXbaseWithAnnotations.g:7335:1: ( ( rule__XMemberFeatureCall__FeatureAssignment_1_0_0_0_2 ) )
            // InternalXbaseWithAnnotations.g:7336:2: ( rule__XMemberFeatureCall__FeatureAssignment_1_0_0_0_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getFeatureAssignment_1_0_0_0_2()); 
            }
            // InternalXbaseWithAnnotations.g:7337:2: ( rule__XMemberFeatureCall__FeatureAssignment_1_0_0_0_2 )
            // InternalXbaseWithAnnotations.g:7337:3: rule__XMemberFeatureCall__FeatureAssignment_1_0_0_0_2
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__FeatureAssignment_1_0_0_0_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getFeatureAssignment_1_0_0_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0_0_0__2__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0_0_0__3"
    // InternalXbaseWithAnnotations.g:7345:1: rule__XMemberFeatureCall__Group_1_0_0_0__3 : rule__XMemberFeatureCall__Group_1_0_0_0__3__Impl ;
    public final void rule__XMemberFeatureCall__Group_1_0_0_0__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7349:1: ( rule__XMemberFeatureCall__Group_1_0_0_0__3__Impl )
            // InternalXbaseWithAnnotations.g:7350:2: rule__XMemberFeatureCall__Group_1_0_0_0__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_0_0_0__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0_0_0__3"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_0_0_0__3__Impl"
    // InternalXbaseWithAnnotations.g:7356:1: rule__XMemberFeatureCall__Group_1_0_0_0__3__Impl : ( ruleOpSingleAssign ) ;
    public final void rule__XMemberFeatureCall__Group_1_0_0_0__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7360:1: ( ( ruleOpSingleAssign ) )
            // InternalXbaseWithAnnotations.g:7361:1: ( ruleOpSingleAssign )
            {
            // InternalXbaseWithAnnotations.g:7361:1: ( ruleOpSingleAssign )
            // InternalXbaseWithAnnotations.g:7362:2: ruleOpSingleAssign
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getOpSingleAssignParserRuleCall_1_0_0_0_3()); 
            }
            pushFollow(FOLLOW_2);
            ruleOpSingleAssign();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getOpSingleAssignParserRuleCall_1_0_0_0_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_0_0_0__3__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1__0"
    // InternalXbaseWithAnnotations.g:7372:1: rule__XMemberFeatureCall__Group_1_1__0 : rule__XMemberFeatureCall__Group_1_1__0__Impl rule__XMemberFeatureCall__Group_1_1__1 ;
    public final void rule__XMemberFeatureCall__Group_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7376:1: ( rule__XMemberFeatureCall__Group_1_1__0__Impl rule__XMemberFeatureCall__Group_1_1__1 )
            // InternalXbaseWithAnnotations.g:7377:2: rule__XMemberFeatureCall__Group_1_1__0__Impl rule__XMemberFeatureCall__Group_1_1__1
            {
            pushFollow(FOLLOW_45);
            rule__XMemberFeatureCall__Group_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1__0"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1__0__Impl"
    // InternalXbaseWithAnnotations.g:7384:1: rule__XMemberFeatureCall__Group_1_1__0__Impl : ( ( rule__XMemberFeatureCall__Group_1_1_0__0 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7388:1: ( ( ( rule__XMemberFeatureCall__Group_1_1_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:7389:1: ( ( rule__XMemberFeatureCall__Group_1_1_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:7389:1: ( ( rule__XMemberFeatureCall__Group_1_1_0__0 ) )
            // InternalXbaseWithAnnotations.g:7390:2: ( rule__XMemberFeatureCall__Group_1_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:7391:2: ( rule__XMemberFeatureCall__Group_1_1_0__0 )
            // InternalXbaseWithAnnotations.g:7391:3: rule__XMemberFeatureCall__Group_1_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1__0__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1__1"
    // InternalXbaseWithAnnotations.g:7399:1: rule__XMemberFeatureCall__Group_1_1__1 : rule__XMemberFeatureCall__Group_1_1__1__Impl rule__XMemberFeatureCall__Group_1_1__2 ;
    public final void rule__XMemberFeatureCall__Group_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7403:1: ( rule__XMemberFeatureCall__Group_1_1__1__Impl rule__XMemberFeatureCall__Group_1_1__2 )
            // InternalXbaseWithAnnotations.g:7404:2: rule__XMemberFeatureCall__Group_1_1__1__Impl rule__XMemberFeatureCall__Group_1_1__2
            {
            pushFollow(FOLLOW_45);
            rule__XMemberFeatureCall__Group_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1__1"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1__1__Impl"
    // InternalXbaseWithAnnotations.g:7411:1: rule__XMemberFeatureCall__Group_1_1__1__Impl : ( ( rule__XMemberFeatureCall__Group_1_1_1__0 )? ) ;
    public final void rule__XMemberFeatureCall__Group_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7415:1: ( ( ( rule__XMemberFeatureCall__Group_1_1_1__0 )? ) )
            // InternalXbaseWithAnnotations.g:7416:1: ( ( rule__XMemberFeatureCall__Group_1_1_1__0 )? )
            {
            // InternalXbaseWithAnnotations.g:7416:1: ( ( rule__XMemberFeatureCall__Group_1_1_1__0 )? )
            // InternalXbaseWithAnnotations.g:7417:2: ( rule__XMemberFeatureCall__Group_1_1_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:7418:2: ( rule__XMemberFeatureCall__Group_1_1_1__0 )?
            int alt66=2;
            int LA66_0 = input.LA(1);

            if ( (LA66_0==27) ) {
                alt66=1;
            }
            switch (alt66) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:7418:3: rule__XMemberFeatureCall__Group_1_1_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XMemberFeatureCall__Group_1_1_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1__1__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1__2"
    // InternalXbaseWithAnnotations.g:7426:1: rule__XMemberFeatureCall__Group_1_1__2 : rule__XMemberFeatureCall__Group_1_1__2__Impl rule__XMemberFeatureCall__Group_1_1__3 ;
    public final void rule__XMemberFeatureCall__Group_1_1__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7430:1: ( rule__XMemberFeatureCall__Group_1_1__2__Impl rule__XMemberFeatureCall__Group_1_1__3 )
            // InternalXbaseWithAnnotations.g:7431:2: rule__XMemberFeatureCall__Group_1_1__2__Impl rule__XMemberFeatureCall__Group_1_1__3
            {
            pushFollow(FOLLOW_46);
            rule__XMemberFeatureCall__Group_1_1__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1__2"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1__2__Impl"
    // InternalXbaseWithAnnotations.g:7438:1: rule__XMemberFeatureCall__Group_1_1__2__Impl : ( ( rule__XMemberFeatureCall__FeatureAssignment_1_1_2 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_1__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7442:1: ( ( ( rule__XMemberFeatureCall__FeatureAssignment_1_1_2 ) ) )
            // InternalXbaseWithAnnotations.g:7443:1: ( ( rule__XMemberFeatureCall__FeatureAssignment_1_1_2 ) )
            {
            // InternalXbaseWithAnnotations.g:7443:1: ( ( rule__XMemberFeatureCall__FeatureAssignment_1_1_2 ) )
            // InternalXbaseWithAnnotations.g:7444:2: ( rule__XMemberFeatureCall__FeatureAssignment_1_1_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getFeatureAssignment_1_1_2()); 
            }
            // InternalXbaseWithAnnotations.g:7445:2: ( rule__XMemberFeatureCall__FeatureAssignment_1_1_2 )
            // InternalXbaseWithAnnotations.g:7445:3: rule__XMemberFeatureCall__FeatureAssignment_1_1_2
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__FeatureAssignment_1_1_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getFeatureAssignment_1_1_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1__2__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1__3"
    // InternalXbaseWithAnnotations.g:7453:1: rule__XMemberFeatureCall__Group_1_1__3 : rule__XMemberFeatureCall__Group_1_1__3__Impl rule__XMemberFeatureCall__Group_1_1__4 ;
    public final void rule__XMemberFeatureCall__Group_1_1__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7457:1: ( rule__XMemberFeatureCall__Group_1_1__3__Impl rule__XMemberFeatureCall__Group_1_1__4 )
            // InternalXbaseWithAnnotations.g:7458:2: rule__XMemberFeatureCall__Group_1_1__3__Impl rule__XMemberFeatureCall__Group_1_1__4
            {
            pushFollow(FOLLOW_46);
            rule__XMemberFeatureCall__Group_1_1__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1__3"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1__3__Impl"
    // InternalXbaseWithAnnotations.g:7465:1: rule__XMemberFeatureCall__Group_1_1__3__Impl : ( ( rule__XMemberFeatureCall__Group_1_1_3__0 )? ) ;
    public final void rule__XMemberFeatureCall__Group_1_1__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7469:1: ( ( ( rule__XMemberFeatureCall__Group_1_1_3__0 )? ) )
            // InternalXbaseWithAnnotations.g:7470:1: ( ( rule__XMemberFeatureCall__Group_1_1_3__0 )? )
            {
            // InternalXbaseWithAnnotations.g:7470:1: ( ( rule__XMemberFeatureCall__Group_1_1_3__0 )? )
            // InternalXbaseWithAnnotations.g:7471:2: ( rule__XMemberFeatureCall__Group_1_1_3__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_3()); 
            }
            // InternalXbaseWithAnnotations.g:7472:2: ( rule__XMemberFeatureCall__Group_1_1_3__0 )?
            int alt67=2;
            alt67 = dfa67.predict(input);
            switch (alt67) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:7472:3: rule__XMemberFeatureCall__Group_1_1_3__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XMemberFeatureCall__Group_1_1_3__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1__3__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1__4"
    // InternalXbaseWithAnnotations.g:7480:1: rule__XMemberFeatureCall__Group_1_1__4 : rule__XMemberFeatureCall__Group_1_1__4__Impl ;
    public final void rule__XMemberFeatureCall__Group_1_1__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7484:1: ( rule__XMemberFeatureCall__Group_1_1__4__Impl )
            // InternalXbaseWithAnnotations.g:7485:2: rule__XMemberFeatureCall__Group_1_1__4__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1__4__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1__4"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1__4__Impl"
    // InternalXbaseWithAnnotations.g:7491:1: rule__XMemberFeatureCall__Group_1_1__4__Impl : ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4 )? ) ;
    public final void rule__XMemberFeatureCall__Group_1_1__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7495:1: ( ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4 )? ) )
            // InternalXbaseWithAnnotations.g:7496:1: ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4 )? )
            {
            // InternalXbaseWithAnnotations.g:7496:1: ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4 )? )
            // InternalXbaseWithAnnotations.g:7497:2: ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsAssignment_1_1_4()); 
            }
            // InternalXbaseWithAnnotations.g:7498:2: ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4 )?
            int alt68=2;
            alt68 = dfa68.predict(input);
            switch (alt68) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:7498:3: rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4
                    {
                    pushFollow(FOLLOW_2);
                    rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsAssignment_1_1_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1__4__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_0__0"
    // InternalXbaseWithAnnotations.g:7507:1: rule__XMemberFeatureCall__Group_1_1_0__0 : rule__XMemberFeatureCall__Group_1_1_0__0__Impl ;
    public final void rule__XMemberFeatureCall__Group_1_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7511:1: ( rule__XMemberFeatureCall__Group_1_1_0__0__Impl )
            // InternalXbaseWithAnnotations.g:7512:2: rule__XMemberFeatureCall__Group_1_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_0__0"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_0__0__Impl"
    // InternalXbaseWithAnnotations.g:7518:1: rule__XMemberFeatureCall__Group_1_1_0__0__Impl : ( ( rule__XMemberFeatureCall__Group_1_1_0_0__0 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7522:1: ( ( ( rule__XMemberFeatureCall__Group_1_1_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:7523:1: ( ( rule__XMemberFeatureCall__Group_1_1_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:7523:1: ( ( rule__XMemberFeatureCall__Group_1_1_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:7524:2: ( rule__XMemberFeatureCall__Group_1_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:7525:2: ( rule__XMemberFeatureCall__Group_1_1_0_0__0 )
            // InternalXbaseWithAnnotations.g:7525:3: rule__XMemberFeatureCall__Group_1_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_0__0__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_0_0__0"
    // InternalXbaseWithAnnotations.g:7534:1: rule__XMemberFeatureCall__Group_1_1_0_0__0 : rule__XMemberFeatureCall__Group_1_1_0_0__0__Impl rule__XMemberFeatureCall__Group_1_1_0_0__1 ;
    public final void rule__XMemberFeatureCall__Group_1_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7538:1: ( rule__XMemberFeatureCall__Group_1_1_0_0__0__Impl rule__XMemberFeatureCall__Group_1_1_0_0__1 )
            // InternalXbaseWithAnnotations.g:7539:2: rule__XMemberFeatureCall__Group_1_1_0_0__0__Impl rule__XMemberFeatureCall__Group_1_1_0_0__1
            {
            pushFollow(FOLLOW_42);
            rule__XMemberFeatureCall__Group_1_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_0_0__0"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:7546:1: rule__XMemberFeatureCall__Group_1_1_0_0__0__Impl : ( () ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7550:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:7551:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:7551:1: ( () )
            // InternalXbaseWithAnnotations.g:7552:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getXMemberFeatureCallMemberCallTargetAction_1_1_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:7553:2: ()
            // InternalXbaseWithAnnotations.g:7553:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getXMemberFeatureCallMemberCallTargetAction_1_1_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_0_0__0__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_0_0__1"
    // InternalXbaseWithAnnotations.g:7561:1: rule__XMemberFeatureCall__Group_1_1_0_0__1 : rule__XMemberFeatureCall__Group_1_1_0_0__1__Impl ;
    public final void rule__XMemberFeatureCall__Group_1_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7565:1: ( rule__XMemberFeatureCall__Group_1_1_0_0__1__Impl )
            // InternalXbaseWithAnnotations.g:7566:2: rule__XMemberFeatureCall__Group_1_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_0_0__1"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:7572:1: rule__XMemberFeatureCall__Group_1_1_0_0__1__Impl : ( ( rule__XMemberFeatureCall__Alternatives_1_1_0_0_1 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7576:1: ( ( ( rule__XMemberFeatureCall__Alternatives_1_1_0_0_1 ) ) )
            // InternalXbaseWithAnnotations.g:7577:1: ( ( rule__XMemberFeatureCall__Alternatives_1_1_0_0_1 ) )
            {
            // InternalXbaseWithAnnotations.g:7577:1: ( ( rule__XMemberFeatureCall__Alternatives_1_1_0_0_1 ) )
            // InternalXbaseWithAnnotations.g:7578:2: ( rule__XMemberFeatureCall__Alternatives_1_1_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getAlternatives_1_1_0_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:7579:2: ( rule__XMemberFeatureCall__Alternatives_1_1_0_0_1 )
            // InternalXbaseWithAnnotations.g:7579:3: rule__XMemberFeatureCall__Alternatives_1_1_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Alternatives_1_1_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getAlternatives_1_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_0_0__1__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_1__0"
    // InternalXbaseWithAnnotations.g:7588:1: rule__XMemberFeatureCall__Group_1_1_1__0 : rule__XMemberFeatureCall__Group_1_1_1__0__Impl rule__XMemberFeatureCall__Group_1_1_1__1 ;
    public final void rule__XMemberFeatureCall__Group_1_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7592:1: ( rule__XMemberFeatureCall__Group_1_1_1__0__Impl rule__XMemberFeatureCall__Group_1_1_1__1 )
            // InternalXbaseWithAnnotations.g:7593:2: rule__XMemberFeatureCall__Group_1_1_1__0__Impl rule__XMemberFeatureCall__Group_1_1_1__1
            {
            pushFollow(FOLLOW_47);
            rule__XMemberFeatureCall__Group_1_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_1__0"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_1__0__Impl"
    // InternalXbaseWithAnnotations.g:7600:1: rule__XMemberFeatureCall__Group_1_1_1__0__Impl : ( '<' ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7604:1: ( ( '<' ) )
            // InternalXbaseWithAnnotations.g:7605:1: ( '<' )
            {
            // InternalXbaseWithAnnotations.g:7605:1: ( '<' )
            // InternalXbaseWithAnnotations.g:7606:2: '<'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getLessThanSignKeyword_1_1_1_0()); 
            }
            match(input,27,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getLessThanSignKeyword_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_1__0__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_1__1"
    // InternalXbaseWithAnnotations.g:7615:1: rule__XMemberFeatureCall__Group_1_1_1__1 : rule__XMemberFeatureCall__Group_1_1_1__1__Impl rule__XMemberFeatureCall__Group_1_1_1__2 ;
    public final void rule__XMemberFeatureCall__Group_1_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7619:1: ( rule__XMemberFeatureCall__Group_1_1_1__1__Impl rule__XMemberFeatureCall__Group_1_1_1__2 )
            // InternalXbaseWithAnnotations.g:7620:2: rule__XMemberFeatureCall__Group_1_1_1__1__Impl rule__XMemberFeatureCall__Group_1_1_1__2
            {
            pushFollow(FOLLOW_48);
            rule__XMemberFeatureCall__Group_1_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_1__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_1__1"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_1__1__Impl"
    // InternalXbaseWithAnnotations.g:7627:1: rule__XMemberFeatureCall__Group_1_1_1__1__Impl : ( ( rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_1 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7631:1: ( ( ( rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:7632:1: ( ( rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:7632:1: ( ( rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_1 ) )
            // InternalXbaseWithAnnotations.g:7633:2: ( rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getTypeArgumentsAssignment_1_1_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:7634:2: ( rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_1 )
            // InternalXbaseWithAnnotations.g:7634:3: rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getTypeArgumentsAssignment_1_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_1__1__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_1__2"
    // InternalXbaseWithAnnotations.g:7642:1: rule__XMemberFeatureCall__Group_1_1_1__2 : rule__XMemberFeatureCall__Group_1_1_1__2__Impl rule__XMemberFeatureCall__Group_1_1_1__3 ;
    public final void rule__XMemberFeatureCall__Group_1_1_1__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7646:1: ( rule__XMemberFeatureCall__Group_1_1_1__2__Impl rule__XMemberFeatureCall__Group_1_1_1__3 )
            // InternalXbaseWithAnnotations.g:7647:2: rule__XMemberFeatureCall__Group_1_1_1__2__Impl rule__XMemberFeatureCall__Group_1_1_1__3
            {
            pushFollow(FOLLOW_48);
            rule__XMemberFeatureCall__Group_1_1_1__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_1__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_1__2"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_1__2__Impl"
    // InternalXbaseWithAnnotations.g:7654:1: rule__XMemberFeatureCall__Group_1_1_1__2__Impl : ( ( rule__XMemberFeatureCall__Group_1_1_1_2__0 )* ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_1__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7658:1: ( ( ( rule__XMemberFeatureCall__Group_1_1_1_2__0 )* ) )
            // InternalXbaseWithAnnotations.g:7659:1: ( ( rule__XMemberFeatureCall__Group_1_1_1_2__0 )* )
            {
            // InternalXbaseWithAnnotations.g:7659:1: ( ( rule__XMemberFeatureCall__Group_1_1_1_2__0 )* )
            // InternalXbaseWithAnnotations.g:7660:2: ( rule__XMemberFeatureCall__Group_1_1_1_2__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_1_2()); 
            }
            // InternalXbaseWithAnnotations.g:7661:2: ( rule__XMemberFeatureCall__Group_1_1_1_2__0 )*
            loop69:
            do {
                int alt69=2;
                int LA69_0 = input.LA(1);

                if ( (LA69_0==54) ) {
                    alt69=1;
                }


                switch (alt69) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:7661:3: rule__XMemberFeatureCall__Group_1_1_1_2__0
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__XMemberFeatureCall__Group_1_1_1_2__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop69;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_1_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_1__2__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_1__3"
    // InternalXbaseWithAnnotations.g:7669:1: rule__XMemberFeatureCall__Group_1_1_1__3 : rule__XMemberFeatureCall__Group_1_1_1__3__Impl ;
    public final void rule__XMemberFeatureCall__Group_1_1_1__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7673:1: ( rule__XMemberFeatureCall__Group_1_1_1__3__Impl )
            // InternalXbaseWithAnnotations.g:7674:2: rule__XMemberFeatureCall__Group_1_1_1__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_1__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_1__3"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_1__3__Impl"
    // InternalXbaseWithAnnotations.g:7680:1: rule__XMemberFeatureCall__Group_1_1_1__3__Impl : ( '>' ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_1__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7684:1: ( ( '>' ) )
            // InternalXbaseWithAnnotations.g:7685:1: ( '>' )
            {
            // InternalXbaseWithAnnotations.g:7685:1: ( '>' )
            // InternalXbaseWithAnnotations.g:7686:2: '>'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getGreaterThanSignKeyword_1_1_1_3()); 
            }
            match(input,26,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getGreaterThanSignKeyword_1_1_1_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_1__3__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_1_2__0"
    // InternalXbaseWithAnnotations.g:7696:1: rule__XMemberFeatureCall__Group_1_1_1_2__0 : rule__XMemberFeatureCall__Group_1_1_1_2__0__Impl rule__XMemberFeatureCall__Group_1_1_1_2__1 ;
    public final void rule__XMemberFeatureCall__Group_1_1_1_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7700:1: ( rule__XMemberFeatureCall__Group_1_1_1_2__0__Impl rule__XMemberFeatureCall__Group_1_1_1_2__1 )
            // InternalXbaseWithAnnotations.g:7701:2: rule__XMemberFeatureCall__Group_1_1_1_2__0__Impl rule__XMemberFeatureCall__Group_1_1_1_2__1
            {
            pushFollow(FOLLOW_47);
            rule__XMemberFeatureCall__Group_1_1_1_2__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_1_2__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_1_2__0"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_1_2__0__Impl"
    // InternalXbaseWithAnnotations.g:7708:1: rule__XMemberFeatureCall__Group_1_1_1_2__0__Impl : ( ',' ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_1_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7712:1: ( ( ',' ) )
            // InternalXbaseWithAnnotations.g:7713:1: ( ',' )
            {
            // InternalXbaseWithAnnotations.g:7713:1: ( ',' )
            // InternalXbaseWithAnnotations.g:7714:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getCommaKeyword_1_1_1_2_0()); 
            }
            match(input,54,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getCommaKeyword_1_1_1_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_1_2__0__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_1_2__1"
    // InternalXbaseWithAnnotations.g:7723:1: rule__XMemberFeatureCall__Group_1_1_1_2__1 : rule__XMemberFeatureCall__Group_1_1_1_2__1__Impl ;
    public final void rule__XMemberFeatureCall__Group_1_1_1_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7727:1: ( rule__XMemberFeatureCall__Group_1_1_1_2__1__Impl )
            // InternalXbaseWithAnnotations.g:7728:2: rule__XMemberFeatureCall__Group_1_1_1_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_1_2__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_1_2__1"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_1_2__1__Impl"
    // InternalXbaseWithAnnotations.g:7734:1: rule__XMemberFeatureCall__Group_1_1_1_2__1__Impl : ( ( rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_2_1 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_1_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7738:1: ( ( ( rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_2_1 ) ) )
            // InternalXbaseWithAnnotations.g:7739:1: ( ( rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_2_1 ) )
            {
            // InternalXbaseWithAnnotations.g:7739:1: ( ( rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_2_1 ) )
            // InternalXbaseWithAnnotations.g:7740:2: ( rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_2_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getTypeArgumentsAssignment_1_1_1_2_1()); 
            }
            // InternalXbaseWithAnnotations.g:7741:2: ( rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_2_1 )
            // InternalXbaseWithAnnotations.g:7741:3: rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_2_1
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_2_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getTypeArgumentsAssignment_1_1_1_2_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_1_2__1__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3__0"
    // InternalXbaseWithAnnotations.g:7750:1: rule__XMemberFeatureCall__Group_1_1_3__0 : rule__XMemberFeatureCall__Group_1_1_3__0__Impl rule__XMemberFeatureCall__Group_1_1_3__1 ;
    public final void rule__XMemberFeatureCall__Group_1_1_3__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7754:1: ( rule__XMemberFeatureCall__Group_1_1_3__0__Impl rule__XMemberFeatureCall__Group_1_1_3__1 )
            // InternalXbaseWithAnnotations.g:7755:2: rule__XMemberFeatureCall__Group_1_1_3__0__Impl rule__XMemberFeatureCall__Group_1_1_3__1
            {
            pushFollow(FOLLOW_49);
            rule__XMemberFeatureCall__Group_1_1_3__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_3__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3__0"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3__0__Impl"
    // InternalXbaseWithAnnotations.g:7762:1: rule__XMemberFeatureCall__Group_1_1_3__0__Impl : ( ( rule__XMemberFeatureCall__ExplicitOperationCallAssignment_1_1_3_0 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_3__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7766:1: ( ( ( rule__XMemberFeatureCall__ExplicitOperationCallAssignment_1_1_3_0 ) ) )
            // InternalXbaseWithAnnotations.g:7767:1: ( ( rule__XMemberFeatureCall__ExplicitOperationCallAssignment_1_1_3_0 ) )
            {
            // InternalXbaseWithAnnotations.g:7767:1: ( ( rule__XMemberFeatureCall__ExplicitOperationCallAssignment_1_1_3_0 ) )
            // InternalXbaseWithAnnotations.g:7768:2: ( rule__XMemberFeatureCall__ExplicitOperationCallAssignment_1_1_3_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getExplicitOperationCallAssignment_1_1_3_0()); 
            }
            // InternalXbaseWithAnnotations.g:7769:2: ( rule__XMemberFeatureCall__ExplicitOperationCallAssignment_1_1_3_0 )
            // InternalXbaseWithAnnotations.g:7769:3: rule__XMemberFeatureCall__ExplicitOperationCallAssignment_1_1_3_0
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__ExplicitOperationCallAssignment_1_1_3_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getExplicitOperationCallAssignment_1_1_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3__0__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3__1"
    // InternalXbaseWithAnnotations.g:7777:1: rule__XMemberFeatureCall__Group_1_1_3__1 : rule__XMemberFeatureCall__Group_1_1_3__1__Impl rule__XMemberFeatureCall__Group_1_1_3__2 ;
    public final void rule__XMemberFeatureCall__Group_1_1_3__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7781:1: ( rule__XMemberFeatureCall__Group_1_1_3__1__Impl rule__XMemberFeatureCall__Group_1_1_3__2 )
            // InternalXbaseWithAnnotations.g:7782:2: rule__XMemberFeatureCall__Group_1_1_3__1__Impl rule__XMemberFeatureCall__Group_1_1_3__2
            {
            pushFollow(FOLLOW_49);
            rule__XMemberFeatureCall__Group_1_1_3__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_3__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3__1"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3__1__Impl"
    // InternalXbaseWithAnnotations.g:7789:1: rule__XMemberFeatureCall__Group_1_1_3__1__Impl : ( ( rule__XMemberFeatureCall__Alternatives_1_1_3_1 )? ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_3__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7793:1: ( ( ( rule__XMemberFeatureCall__Alternatives_1_1_3_1 )? ) )
            // InternalXbaseWithAnnotations.g:7794:1: ( ( rule__XMemberFeatureCall__Alternatives_1_1_3_1 )? )
            {
            // InternalXbaseWithAnnotations.g:7794:1: ( ( rule__XMemberFeatureCall__Alternatives_1_1_3_1 )? )
            // InternalXbaseWithAnnotations.g:7795:2: ( rule__XMemberFeatureCall__Alternatives_1_1_3_1 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getAlternatives_1_1_3_1()); 
            }
            // InternalXbaseWithAnnotations.g:7796:2: ( rule__XMemberFeatureCall__Alternatives_1_1_3_1 )?
            int alt70=2;
            int LA70_0 = input.LA(1);

            if ( ((LA70_0>=RULE_ID && LA70_0<=RULE_STRING)||LA70_0==27||LA70_0==31||(LA70_0>=34 && LA70_0<=35)||LA70_0==40||(LA70_0>=45 && LA70_0<=50)||LA70_0==52||(LA70_0>=56 && LA70_0<=57)||LA70_0==60||LA70_0==63||LA70_0==65||(LA70_0>=69 && LA70_0<=77)||LA70_0==79||LA70_0==85||LA70_0==87) ) {
                alt70=1;
            }
            switch (alt70) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:7796:3: rule__XMemberFeatureCall__Alternatives_1_1_3_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XMemberFeatureCall__Alternatives_1_1_3_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getAlternatives_1_1_3_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3__1__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3__2"
    // InternalXbaseWithAnnotations.g:7804:1: rule__XMemberFeatureCall__Group_1_1_3__2 : rule__XMemberFeatureCall__Group_1_1_3__2__Impl ;
    public final void rule__XMemberFeatureCall__Group_1_1_3__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7808:1: ( rule__XMemberFeatureCall__Group_1_1_3__2__Impl )
            // InternalXbaseWithAnnotations.g:7809:2: rule__XMemberFeatureCall__Group_1_1_3__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_3__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3__2"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3__2__Impl"
    // InternalXbaseWithAnnotations.g:7815:1: rule__XMemberFeatureCall__Group_1_1_3__2__Impl : ( ')' ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_3__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7819:1: ( ( ')' ) )
            // InternalXbaseWithAnnotations.g:7820:1: ( ')' )
            {
            // InternalXbaseWithAnnotations.g:7820:1: ( ')' )
            // InternalXbaseWithAnnotations.g:7821:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getRightParenthesisKeyword_1_1_3_2()); 
            }
            match(input,53,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getRightParenthesisKeyword_1_1_3_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3__2__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3_1_1__0"
    // InternalXbaseWithAnnotations.g:7831:1: rule__XMemberFeatureCall__Group_1_1_3_1_1__0 : rule__XMemberFeatureCall__Group_1_1_3_1_1__0__Impl rule__XMemberFeatureCall__Group_1_1_3_1_1__1 ;
    public final void rule__XMemberFeatureCall__Group_1_1_3_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7835:1: ( rule__XMemberFeatureCall__Group_1_1_3_1_1__0__Impl rule__XMemberFeatureCall__Group_1_1_3_1_1__1 )
            // InternalXbaseWithAnnotations.g:7836:2: rule__XMemberFeatureCall__Group_1_1_3_1_1__0__Impl rule__XMemberFeatureCall__Group_1_1_3_1_1__1
            {
            pushFollow(FOLLOW_8);
            rule__XMemberFeatureCall__Group_1_1_3_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_3_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3_1_1__0"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3_1_1__0__Impl"
    // InternalXbaseWithAnnotations.g:7843:1: rule__XMemberFeatureCall__Group_1_1_3_1_1__0__Impl : ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_0 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_3_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7847:1: ( ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_0 ) ) )
            // InternalXbaseWithAnnotations.g:7848:1: ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_0 ) )
            {
            // InternalXbaseWithAnnotations.g:7848:1: ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_0 ) )
            // InternalXbaseWithAnnotations.g:7849:2: ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsAssignment_1_1_3_1_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:7850:2: ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_0 )
            // InternalXbaseWithAnnotations.g:7850:3: rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_0
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsAssignment_1_1_3_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3_1_1__0__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3_1_1__1"
    // InternalXbaseWithAnnotations.g:7858:1: rule__XMemberFeatureCall__Group_1_1_3_1_1__1 : rule__XMemberFeatureCall__Group_1_1_3_1_1__1__Impl ;
    public final void rule__XMemberFeatureCall__Group_1_1_3_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7862:1: ( rule__XMemberFeatureCall__Group_1_1_3_1_1__1__Impl )
            // InternalXbaseWithAnnotations.g:7863:2: rule__XMemberFeatureCall__Group_1_1_3_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_3_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3_1_1__1"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3_1_1__1__Impl"
    // InternalXbaseWithAnnotations.g:7869:1: rule__XMemberFeatureCall__Group_1_1_3_1_1__1__Impl : ( ( rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0 )* ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_3_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7873:1: ( ( ( rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0 )* ) )
            // InternalXbaseWithAnnotations.g:7874:1: ( ( rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0 )* )
            {
            // InternalXbaseWithAnnotations.g:7874:1: ( ( rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0 )* )
            // InternalXbaseWithAnnotations.g:7875:2: ( rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_3_1_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:7876:2: ( rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0 )*
            loop71:
            do {
                int alt71=2;
                int LA71_0 = input.LA(1);

                if ( (LA71_0==54) ) {
                    alt71=1;
                }


                switch (alt71) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:7876:3: rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop71;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getGroup_1_1_3_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3_1_1__1__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0"
    // InternalXbaseWithAnnotations.g:7885:1: rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0 : rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0__Impl rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1 ;
    public final void rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7889:1: ( rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0__Impl rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1 )
            // InternalXbaseWithAnnotations.g:7890:2: rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0__Impl rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1
            {
            pushFollow(FOLLOW_10);
            rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0__Impl"
    // InternalXbaseWithAnnotations.g:7897:1: rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0__Impl : ( ',' ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7901:1: ( ( ',' ) )
            // InternalXbaseWithAnnotations.g:7902:1: ( ',' )
            {
            // InternalXbaseWithAnnotations.g:7902:1: ( ',' )
            // InternalXbaseWithAnnotations.g:7903:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getCommaKeyword_1_1_3_1_1_1_0()); 
            }
            match(input,54,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getCommaKeyword_1_1_3_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3_1_1_1__0__Impl"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1"
    // InternalXbaseWithAnnotations.g:7912:1: rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1 : rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1__Impl ;
    public final void rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7916:1: ( rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1__Impl )
            // InternalXbaseWithAnnotations.g:7917:2: rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1"


    // $ANTLR start "rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1__Impl"
    // InternalXbaseWithAnnotations.g:7923:1: rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1__Impl : ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_1_1 ) ) ;
    public final void rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7927:1: ( ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:7928:1: ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:7928:1: ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_1_1 ) )
            // InternalXbaseWithAnnotations.g:7929:2: ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsAssignment_1_1_3_1_1_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:7930:2: ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_1_1 )
            // InternalXbaseWithAnnotations.g:7930:3: rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsAssignment_1_1_3_1_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__Group_1_1_3_1_1_1__1__Impl"


    // $ANTLR start "rule__XSetLiteral__Group__0"
    // InternalXbaseWithAnnotations.g:7939:1: rule__XSetLiteral__Group__0 : rule__XSetLiteral__Group__0__Impl rule__XSetLiteral__Group__1 ;
    public final void rule__XSetLiteral__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7943:1: ( rule__XSetLiteral__Group__0__Impl rule__XSetLiteral__Group__1 )
            // InternalXbaseWithAnnotations.g:7944:2: rule__XSetLiteral__Group__0__Impl rule__XSetLiteral__Group__1
            {
            pushFollow(FOLLOW_13);
            rule__XSetLiteral__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSetLiteral__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group__0"


    // $ANTLR start "rule__XSetLiteral__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:7951:1: rule__XSetLiteral__Group__0__Impl : ( () ) ;
    public final void rule__XSetLiteral__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7955:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:7956:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:7956:1: ( () )
            // InternalXbaseWithAnnotations.g:7957:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralAccess().getXSetLiteralAction_0()); 
            }
            // InternalXbaseWithAnnotations.g:7958:2: ()
            // InternalXbaseWithAnnotations.g:7958:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralAccess().getXSetLiteralAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group__0__Impl"


    // $ANTLR start "rule__XSetLiteral__Group__1"
    // InternalXbaseWithAnnotations.g:7966:1: rule__XSetLiteral__Group__1 : rule__XSetLiteral__Group__1__Impl rule__XSetLiteral__Group__2 ;
    public final void rule__XSetLiteral__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7970:1: ( rule__XSetLiteral__Group__1__Impl rule__XSetLiteral__Group__2 )
            // InternalXbaseWithAnnotations.g:7971:2: rule__XSetLiteral__Group__1__Impl rule__XSetLiteral__Group__2
            {
            pushFollow(FOLLOW_50);
            rule__XSetLiteral__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSetLiteral__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group__1"


    // $ANTLR start "rule__XSetLiteral__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:7978:1: rule__XSetLiteral__Group__1__Impl : ( '#' ) ;
    public final void rule__XSetLiteral__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7982:1: ( ( '#' ) )
            // InternalXbaseWithAnnotations.g:7983:1: ( '#' )
            {
            // InternalXbaseWithAnnotations.g:7983:1: ( '#' )
            // InternalXbaseWithAnnotations.g:7984:2: '#'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralAccess().getNumberSignKeyword_1()); 
            }
            match(input,56,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralAccess().getNumberSignKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group__1__Impl"


    // $ANTLR start "rule__XSetLiteral__Group__2"
    // InternalXbaseWithAnnotations.g:7993:1: rule__XSetLiteral__Group__2 : rule__XSetLiteral__Group__2__Impl rule__XSetLiteral__Group__3 ;
    public final void rule__XSetLiteral__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:7997:1: ( rule__XSetLiteral__Group__2__Impl rule__XSetLiteral__Group__3 )
            // InternalXbaseWithAnnotations.g:7998:2: rule__XSetLiteral__Group__2__Impl rule__XSetLiteral__Group__3
            {
            pushFollow(FOLLOW_51);
            rule__XSetLiteral__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSetLiteral__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group__2"


    // $ANTLR start "rule__XSetLiteral__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:8005:1: rule__XSetLiteral__Group__2__Impl : ( '{' ) ;
    public final void rule__XSetLiteral__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8009:1: ( ( '{' ) )
            // InternalXbaseWithAnnotations.g:8010:1: ( '{' )
            {
            // InternalXbaseWithAnnotations.g:8010:1: ( '{' )
            // InternalXbaseWithAnnotations.g:8011:2: '{'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralAccess().getLeftCurlyBracketKeyword_2()); 
            }
            match(input,60,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralAccess().getLeftCurlyBracketKeyword_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group__2__Impl"


    // $ANTLR start "rule__XSetLiteral__Group__3"
    // InternalXbaseWithAnnotations.g:8020:1: rule__XSetLiteral__Group__3 : rule__XSetLiteral__Group__3__Impl rule__XSetLiteral__Group__4 ;
    public final void rule__XSetLiteral__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8024:1: ( rule__XSetLiteral__Group__3__Impl rule__XSetLiteral__Group__4 )
            // InternalXbaseWithAnnotations.g:8025:2: rule__XSetLiteral__Group__3__Impl rule__XSetLiteral__Group__4
            {
            pushFollow(FOLLOW_51);
            rule__XSetLiteral__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSetLiteral__Group__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group__3"


    // $ANTLR start "rule__XSetLiteral__Group__3__Impl"
    // InternalXbaseWithAnnotations.g:8032:1: rule__XSetLiteral__Group__3__Impl : ( ( rule__XSetLiteral__Group_3__0 )? ) ;
    public final void rule__XSetLiteral__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8036:1: ( ( ( rule__XSetLiteral__Group_3__0 )? ) )
            // InternalXbaseWithAnnotations.g:8037:1: ( ( rule__XSetLiteral__Group_3__0 )? )
            {
            // InternalXbaseWithAnnotations.g:8037:1: ( ( rule__XSetLiteral__Group_3__0 )? )
            // InternalXbaseWithAnnotations.g:8038:2: ( rule__XSetLiteral__Group_3__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralAccess().getGroup_3()); 
            }
            // InternalXbaseWithAnnotations.g:8039:2: ( rule__XSetLiteral__Group_3__0 )?
            int alt72=2;
            int LA72_0 = input.LA(1);

            if ( ((LA72_0>=RULE_ID && LA72_0<=RULE_STRING)||LA72_0==27||(LA72_0>=34 && LA72_0<=35)||LA72_0==40||(LA72_0>=45 && LA72_0<=50)||LA72_0==52||(LA72_0>=56 && LA72_0<=57)||LA72_0==60||LA72_0==63||LA72_0==65||(LA72_0>=69 && LA72_0<=77)||LA72_0==79||LA72_0==87) ) {
                alt72=1;
            }
            switch (alt72) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:8039:3: rule__XSetLiteral__Group_3__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XSetLiteral__Group_3__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralAccess().getGroup_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group__3__Impl"


    // $ANTLR start "rule__XSetLiteral__Group__4"
    // InternalXbaseWithAnnotations.g:8047:1: rule__XSetLiteral__Group__4 : rule__XSetLiteral__Group__4__Impl ;
    public final void rule__XSetLiteral__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8051:1: ( rule__XSetLiteral__Group__4__Impl )
            // InternalXbaseWithAnnotations.g:8052:2: rule__XSetLiteral__Group__4__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSetLiteral__Group__4__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group__4"


    // $ANTLR start "rule__XSetLiteral__Group__4__Impl"
    // InternalXbaseWithAnnotations.g:8058:1: rule__XSetLiteral__Group__4__Impl : ( '}' ) ;
    public final void rule__XSetLiteral__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8062:1: ( ( '}' ) )
            // InternalXbaseWithAnnotations.g:8063:1: ( '}' )
            {
            // InternalXbaseWithAnnotations.g:8063:1: ( '}' )
            // InternalXbaseWithAnnotations.g:8064:2: '}'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralAccess().getRightCurlyBracketKeyword_4()); 
            }
            match(input,61,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralAccess().getRightCurlyBracketKeyword_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group__4__Impl"


    // $ANTLR start "rule__XSetLiteral__Group_3__0"
    // InternalXbaseWithAnnotations.g:8074:1: rule__XSetLiteral__Group_3__0 : rule__XSetLiteral__Group_3__0__Impl rule__XSetLiteral__Group_3__1 ;
    public final void rule__XSetLiteral__Group_3__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8078:1: ( rule__XSetLiteral__Group_3__0__Impl rule__XSetLiteral__Group_3__1 )
            // InternalXbaseWithAnnotations.g:8079:2: rule__XSetLiteral__Group_3__0__Impl rule__XSetLiteral__Group_3__1
            {
            pushFollow(FOLLOW_8);
            rule__XSetLiteral__Group_3__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSetLiteral__Group_3__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group_3__0"


    // $ANTLR start "rule__XSetLiteral__Group_3__0__Impl"
    // InternalXbaseWithAnnotations.g:8086:1: rule__XSetLiteral__Group_3__0__Impl : ( ( rule__XSetLiteral__ElementsAssignment_3_0 ) ) ;
    public final void rule__XSetLiteral__Group_3__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8090:1: ( ( ( rule__XSetLiteral__ElementsAssignment_3_0 ) ) )
            // InternalXbaseWithAnnotations.g:8091:1: ( ( rule__XSetLiteral__ElementsAssignment_3_0 ) )
            {
            // InternalXbaseWithAnnotations.g:8091:1: ( ( rule__XSetLiteral__ElementsAssignment_3_0 ) )
            // InternalXbaseWithAnnotations.g:8092:2: ( rule__XSetLiteral__ElementsAssignment_3_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralAccess().getElementsAssignment_3_0()); 
            }
            // InternalXbaseWithAnnotations.g:8093:2: ( rule__XSetLiteral__ElementsAssignment_3_0 )
            // InternalXbaseWithAnnotations.g:8093:3: rule__XSetLiteral__ElementsAssignment_3_0
            {
            pushFollow(FOLLOW_2);
            rule__XSetLiteral__ElementsAssignment_3_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralAccess().getElementsAssignment_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group_3__0__Impl"


    // $ANTLR start "rule__XSetLiteral__Group_3__1"
    // InternalXbaseWithAnnotations.g:8101:1: rule__XSetLiteral__Group_3__1 : rule__XSetLiteral__Group_3__1__Impl ;
    public final void rule__XSetLiteral__Group_3__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8105:1: ( rule__XSetLiteral__Group_3__1__Impl )
            // InternalXbaseWithAnnotations.g:8106:2: rule__XSetLiteral__Group_3__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSetLiteral__Group_3__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group_3__1"


    // $ANTLR start "rule__XSetLiteral__Group_3__1__Impl"
    // InternalXbaseWithAnnotations.g:8112:1: rule__XSetLiteral__Group_3__1__Impl : ( ( rule__XSetLiteral__Group_3_1__0 )* ) ;
    public final void rule__XSetLiteral__Group_3__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8116:1: ( ( ( rule__XSetLiteral__Group_3_1__0 )* ) )
            // InternalXbaseWithAnnotations.g:8117:1: ( ( rule__XSetLiteral__Group_3_1__0 )* )
            {
            // InternalXbaseWithAnnotations.g:8117:1: ( ( rule__XSetLiteral__Group_3_1__0 )* )
            // InternalXbaseWithAnnotations.g:8118:2: ( rule__XSetLiteral__Group_3_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralAccess().getGroup_3_1()); 
            }
            // InternalXbaseWithAnnotations.g:8119:2: ( rule__XSetLiteral__Group_3_1__0 )*
            loop73:
            do {
                int alt73=2;
                int LA73_0 = input.LA(1);

                if ( (LA73_0==54) ) {
                    alt73=1;
                }


                switch (alt73) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:8119:3: rule__XSetLiteral__Group_3_1__0
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__XSetLiteral__Group_3_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop73;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralAccess().getGroup_3_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group_3__1__Impl"


    // $ANTLR start "rule__XSetLiteral__Group_3_1__0"
    // InternalXbaseWithAnnotations.g:8128:1: rule__XSetLiteral__Group_3_1__0 : rule__XSetLiteral__Group_3_1__0__Impl rule__XSetLiteral__Group_3_1__1 ;
    public final void rule__XSetLiteral__Group_3_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8132:1: ( rule__XSetLiteral__Group_3_1__0__Impl rule__XSetLiteral__Group_3_1__1 )
            // InternalXbaseWithAnnotations.g:8133:2: rule__XSetLiteral__Group_3_1__0__Impl rule__XSetLiteral__Group_3_1__1
            {
            pushFollow(FOLLOW_10);
            rule__XSetLiteral__Group_3_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSetLiteral__Group_3_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group_3_1__0"


    // $ANTLR start "rule__XSetLiteral__Group_3_1__0__Impl"
    // InternalXbaseWithAnnotations.g:8140:1: rule__XSetLiteral__Group_3_1__0__Impl : ( ',' ) ;
    public final void rule__XSetLiteral__Group_3_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8144:1: ( ( ',' ) )
            // InternalXbaseWithAnnotations.g:8145:1: ( ',' )
            {
            // InternalXbaseWithAnnotations.g:8145:1: ( ',' )
            // InternalXbaseWithAnnotations.g:8146:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralAccess().getCommaKeyword_3_1_0()); 
            }
            match(input,54,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralAccess().getCommaKeyword_3_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group_3_1__0__Impl"


    // $ANTLR start "rule__XSetLiteral__Group_3_1__1"
    // InternalXbaseWithAnnotations.g:8155:1: rule__XSetLiteral__Group_3_1__1 : rule__XSetLiteral__Group_3_1__1__Impl ;
    public final void rule__XSetLiteral__Group_3_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8159:1: ( rule__XSetLiteral__Group_3_1__1__Impl )
            // InternalXbaseWithAnnotations.g:8160:2: rule__XSetLiteral__Group_3_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSetLiteral__Group_3_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group_3_1__1"


    // $ANTLR start "rule__XSetLiteral__Group_3_1__1__Impl"
    // InternalXbaseWithAnnotations.g:8166:1: rule__XSetLiteral__Group_3_1__1__Impl : ( ( rule__XSetLiteral__ElementsAssignment_3_1_1 ) ) ;
    public final void rule__XSetLiteral__Group_3_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8170:1: ( ( ( rule__XSetLiteral__ElementsAssignment_3_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:8171:1: ( ( rule__XSetLiteral__ElementsAssignment_3_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:8171:1: ( ( rule__XSetLiteral__ElementsAssignment_3_1_1 ) )
            // InternalXbaseWithAnnotations.g:8172:2: ( rule__XSetLiteral__ElementsAssignment_3_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralAccess().getElementsAssignment_3_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:8173:2: ( rule__XSetLiteral__ElementsAssignment_3_1_1 )
            // InternalXbaseWithAnnotations.g:8173:3: rule__XSetLiteral__ElementsAssignment_3_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XSetLiteral__ElementsAssignment_3_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralAccess().getElementsAssignment_3_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__Group_3_1__1__Impl"


    // $ANTLR start "rule__XListLiteral__Group__0"
    // InternalXbaseWithAnnotations.g:8182:1: rule__XListLiteral__Group__0 : rule__XListLiteral__Group__0__Impl rule__XListLiteral__Group__1 ;
    public final void rule__XListLiteral__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8186:1: ( rule__XListLiteral__Group__0__Impl rule__XListLiteral__Group__1 )
            // InternalXbaseWithAnnotations.g:8187:2: rule__XListLiteral__Group__0__Impl rule__XListLiteral__Group__1
            {
            pushFollow(FOLLOW_13);
            rule__XListLiteral__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XListLiteral__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group__0"


    // $ANTLR start "rule__XListLiteral__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:8194:1: rule__XListLiteral__Group__0__Impl : ( () ) ;
    public final void rule__XListLiteral__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8198:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:8199:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:8199:1: ( () )
            // InternalXbaseWithAnnotations.g:8200:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralAccess().getXListLiteralAction_0()); 
            }
            // InternalXbaseWithAnnotations.g:8201:2: ()
            // InternalXbaseWithAnnotations.g:8201:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralAccess().getXListLiteralAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group__0__Impl"


    // $ANTLR start "rule__XListLiteral__Group__1"
    // InternalXbaseWithAnnotations.g:8209:1: rule__XListLiteral__Group__1 : rule__XListLiteral__Group__1__Impl rule__XListLiteral__Group__2 ;
    public final void rule__XListLiteral__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8213:1: ( rule__XListLiteral__Group__1__Impl rule__XListLiteral__Group__2 )
            // InternalXbaseWithAnnotations.g:8214:2: rule__XListLiteral__Group__1__Impl rule__XListLiteral__Group__2
            {
            pushFollow(FOLLOW_14);
            rule__XListLiteral__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XListLiteral__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group__1"


    // $ANTLR start "rule__XListLiteral__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:8221:1: rule__XListLiteral__Group__1__Impl : ( '#' ) ;
    public final void rule__XListLiteral__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8225:1: ( ( '#' ) )
            // InternalXbaseWithAnnotations.g:8226:1: ( '#' )
            {
            // InternalXbaseWithAnnotations.g:8226:1: ( '#' )
            // InternalXbaseWithAnnotations.g:8227:2: '#'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralAccess().getNumberSignKeyword_1()); 
            }
            match(input,56,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralAccess().getNumberSignKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group__1__Impl"


    // $ANTLR start "rule__XListLiteral__Group__2"
    // InternalXbaseWithAnnotations.g:8236:1: rule__XListLiteral__Group__2 : rule__XListLiteral__Group__2__Impl rule__XListLiteral__Group__3 ;
    public final void rule__XListLiteral__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8240:1: ( rule__XListLiteral__Group__2__Impl rule__XListLiteral__Group__3 )
            // InternalXbaseWithAnnotations.g:8241:2: rule__XListLiteral__Group__2__Impl rule__XListLiteral__Group__3
            {
            pushFollow(FOLLOW_12);
            rule__XListLiteral__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XListLiteral__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group__2"


    // $ANTLR start "rule__XListLiteral__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:8248:1: rule__XListLiteral__Group__2__Impl : ( '[' ) ;
    public final void rule__XListLiteral__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8252:1: ( ( '[' ) )
            // InternalXbaseWithAnnotations.g:8253:1: ( '[' )
            {
            // InternalXbaseWithAnnotations.g:8253:1: ( '[' )
            // InternalXbaseWithAnnotations.g:8254:2: '['
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralAccess().getLeftSquareBracketKeyword_2()); 
            }
            match(input,57,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralAccess().getLeftSquareBracketKeyword_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group__2__Impl"


    // $ANTLR start "rule__XListLiteral__Group__3"
    // InternalXbaseWithAnnotations.g:8263:1: rule__XListLiteral__Group__3 : rule__XListLiteral__Group__3__Impl rule__XListLiteral__Group__4 ;
    public final void rule__XListLiteral__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8267:1: ( rule__XListLiteral__Group__3__Impl rule__XListLiteral__Group__4 )
            // InternalXbaseWithAnnotations.g:8268:2: rule__XListLiteral__Group__3__Impl rule__XListLiteral__Group__4
            {
            pushFollow(FOLLOW_12);
            rule__XListLiteral__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XListLiteral__Group__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group__3"


    // $ANTLR start "rule__XListLiteral__Group__3__Impl"
    // InternalXbaseWithAnnotations.g:8275:1: rule__XListLiteral__Group__3__Impl : ( ( rule__XListLiteral__Group_3__0 )? ) ;
    public final void rule__XListLiteral__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8279:1: ( ( ( rule__XListLiteral__Group_3__0 )? ) )
            // InternalXbaseWithAnnotations.g:8280:1: ( ( rule__XListLiteral__Group_3__0 )? )
            {
            // InternalXbaseWithAnnotations.g:8280:1: ( ( rule__XListLiteral__Group_3__0 )? )
            // InternalXbaseWithAnnotations.g:8281:2: ( rule__XListLiteral__Group_3__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralAccess().getGroup_3()); 
            }
            // InternalXbaseWithAnnotations.g:8282:2: ( rule__XListLiteral__Group_3__0 )?
            int alt74=2;
            int LA74_0 = input.LA(1);

            if ( ((LA74_0>=RULE_ID && LA74_0<=RULE_STRING)||LA74_0==27||(LA74_0>=34 && LA74_0<=35)||LA74_0==40||(LA74_0>=45 && LA74_0<=50)||LA74_0==52||(LA74_0>=56 && LA74_0<=57)||LA74_0==60||LA74_0==63||LA74_0==65||(LA74_0>=69 && LA74_0<=77)||LA74_0==79||LA74_0==87) ) {
                alt74=1;
            }
            switch (alt74) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:8282:3: rule__XListLiteral__Group_3__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XListLiteral__Group_3__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralAccess().getGroup_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group__3__Impl"


    // $ANTLR start "rule__XListLiteral__Group__4"
    // InternalXbaseWithAnnotations.g:8290:1: rule__XListLiteral__Group__4 : rule__XListLiteral__Group__4__Impl ;
    public final void rule__XListLiteral__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8294:1: ( rule__XListLiteral__Group__4__Impl )
            // InternalXbaseWithAnnotations.g:8295:2: rule__XListLiteral__Group__4__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XListLiteral__Group__4__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group__4"


    // $ANTLR start "rule__XListLiteral__Group__4__Impl"
    // InternalXbaseWithAnnotations.g:8301:1: rule__XListLiteral__Group__4__Impl : ( ']' ) ;
    public final void rule__XListLiteral__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8305:1: ( ( ']' ) )
            // InternalXbaseWithAnnotations.g:8306:1: ( ']' )
            {
            // InternalXbaseWithAnnotations.g:8306:1: ( ']' )
            // InternalXbaseWithAnnotations.g:8307:2: ']'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralAccess().getRightSquareBracketKeyword_4()); 
            }
            match(input,55,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralAccess().getRightSquareBracketKeyword_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group__4__Impl"


    // $ANTLR start "rule__XListLiteral__Group_3__0"
    // InternalXbaseWithAnnotations.g:8317:1: rule__XListLiteral__Group_3__0 : rule__XListLiteral__Group_3__0__Impl rule__XListLiteral__Group_3__1 ;
    public final void rule__XListLiteral__Group_3__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8321:1: ( rule__XListLiteral__Group_3__0__Impl rule__XListLiteral__Group_3__1 )
            // InternalXbaseWithAnnotations.g:8322:2: rule__XListLiteral__Group_3__0__Impl rule__XListLiteral__Group_3__1
            {
            pushFollow(FOLLOW_8);
            rule__XListLiteral__Group_3__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XListLiteral__Group_3__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group_3__0"


    // $ANTLR start "rule__XListLiteral__Group_3__0__Impl"
    // InternalXbaseWithAnnotations.g:8329:1: rule__XListLiteral__Group_3__0__Impl : ( ( rule__XListLiteral__ElementsAssignment_3_0 ) ) ;
    public final void rule__XListLiteral__Group_3__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8333:1: ( ( ( rule__XListLiteral__ElementsAssignment_3_0 ) ) )
            // InternalXbaseWithAnnotations.g:8334:1: ( ( rule__XListLiteral__ElementsAssignment_3_0 ) )
            {
            // InternalXbaseWithAnnotations.g:8334:1: ( ( rule__XListLiteral__ElementsAssignment_3_0 ) )
            // InternalXbaseWithAnnotations.g:8335:2: ( rule__XListLiteral__ElementsAssignment_3_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralAccess().getElementsAssignment_3_0()); 
            }
            // InternalXbaseWithAnnotations.g:8336:2: ( rule__XListLiteral__ElementsAssignment_3_0 )
            // InternalXbaseWithAnnotations.g:8336:3: rule__XListLiteral__ElementsAssignment_3_0
            {
            pushFollow(FOLLOW_2);
            rule__XListLiteral__ElementsAssignment_3_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralAccess().getElementsAssignment_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group_3__0__Impl"


    // $ANTLR start "rule__XListLiteral__Group_3__1"
    // InternalXbaseWithAnnotations.g:8344:1: rule__XListLiteral__Group_3__1 : rule__XListLiteral__Group_3__1__Impl ;
    public final void rule__XListLiteral__Group_3__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8348:1: ( rule__XListLiteral__Group_3__1__Impl )
            // InternalXbaseWithAnnotations.g:8349:2: rule__XListLiteral__Group_3__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XListLiteral__Group_3__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group_3__1"


    // $ANTLR start "rule__XListLiteral__Group_3__1__Impl"
    // InternalXbaseWithAnnotations.g:8355:1: rule__XListLiteral__Group_3__1__Impl : ( ( rule__XListLiteral__Group_3_1__0 )* ) ;
    public final void rule__XListLiteral__Group_3__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8359:1: ( ( ( rule__XListLiteral__Group_3_1__0 )* ) )
            // InternalXbaseWithAnnotations.g:8360:1: ( ( rule__XListLiteral__Group_3_1__0 )* )
            {
            // InternalXbaseWithAnnotations.g:8360:1: ( ( rule__XListLiteral__Group_3_1__0 )* )
            // InternalXbaseWithAnnotations.g:8361:2: ( rule__XListLiteral__Group_3_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralAccess().getGroup_3_1()); 
            }
            // InternalXbaseWithAnnotations.g:8362:2: ( rule__XListLiteral__Group_3_1__0 )*
            loop75:
            do {
                int alt75=2;
                int LA75_0 = input.LA(1);

                if ( (LA75_0==54) ) {
                    alt75=1;
                }


                switch (alt75) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:8362:3: rule__XListLiteral__Group_3_1__0
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__XListLiteral__Group_3_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop75;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralAccess().getGroup_3_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group_3__1__Impl"


    // $ANTLR start "rule__XListLiteral__Group_3_1__0"
    // InternalXbaseWithAnnotations.g:8371:1: rule__XListLiteral__Group_3_1__0 : rule__XListLiteral__Group_3_1__0__Impl rule__XListLiteral__Group_3_1__1 ;
    public final void rule__XListLiteral__Group_3_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8375:1: ( rule__XListLiteral__Group_3_1__0__Impl rule__XListLiteral__Group_3_1__1 )
            // InternalXbaseWithAnnotations.g:8376:2: rule__XListLiteral__Group_3_1__0__Impl rule__XListLiteral__Group_3_1__1
            {
            pushFollow(FOLLOW_10);
            rule__XListLiteral__Group_3_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XListLiteral__Group_3_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group_3_1__0"


    // $ANTLR start "rule__XListLiteral__Group_3_1__0__Impl"
    // InternalXbaseWithAnnotations.g:8383:1: rule__XListLiteral__Group_3_1__0__Impl : ( ',' ) ;
    public final void rule__XListLiteral__Group_3_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8387:1: ( ( ',' ) )
            // InternalXbaseWithAnnotations.g:8388:1: ( ',' )
            {
            // InternalXbaseWithAnnotations.g:8388:1: ( ',' )
            // InternalXbaseWithAnnotations.g:8389:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralAccess().getCommaKeyword_3_1_0()); 
            }
            match(input,54,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralAccess().getCommaKeyword_3_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group_3_1__0__Impl"


    // $ANTLR start "rule__XListLiteral__Group_3_1__1"
    // InternalXbaseWithAnnotations.g:8398:1: rule__XListLiteral__Group_3_1__1 : rule__XListLiteral__Group_3_1__1__Impl ;
    public final void rule__XListLiteral__Group_3_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8402:1: ( rule__XListLiteral__Group_3_1__1__Impl )
            // InternalXbaseWithAnnotations.g:8403:2: rule__XListLiteral__Group_3_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XListLiteral__Group_3_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group_3_1__1"


    // $ANTLR start "rule__XListLiteral__Group_3_1__1__Impl"
    // InternalXbaseWithAnnotations.g:8409:1: rule__XListLiteral__Group_3_1__1__Impl : ( ( rule__XListLiteral__ElementsAssignment_3_1_1 ) ) ;
    public final void rule__XListLiteral__Group_3_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8413:1: ( ( ( rule__XListLiteral__ElementsAssignment_3_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:8414:1: ( ( rule__XListLiteral__ElementsAssignment_3_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:8414:1: ( ( rule__XListLiteral__ElementsAssignment_3_1_1 ) )
            // InternalXbaseWithAnnotations.g:8415:2: ( rule__XListLiteral__ElementsAssignment_3_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralAccess().getElementsAssignment_3_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:8416:2: ( rule__XListLiteral__ElementsAssignment_3_1_1 )
            // InternalXbaseWithAnnotations.g:8416:3: rule__XListLiteral__ElementsAssignment_3_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XListLiteral__ElementsAssignment_3_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralAccess().getElementsAssignment_3_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__Group_3_1__1__Impl"


    // $ANTLR start "rule__XClosure__Group__0"
    // InternalXbaseWithAnnotations.g:8425:1: rule__XClosure__Group__0 : rule__XClosure__Group__0__Impl rule__XClosure__Group__1 ;
    public final void rule__XClosure__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8429:1: ( rule__XClosure__Group__0__Impl rule__XClosure__Group__1 )
            // InternalXbaseWithAnnotations.g:8430:2: rule__XClosure__Group__0__Impl rule__XClosure__Group__1
            {
            pushFollow(FOLLOW_52);
            rule__XClosure__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XClosure__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group__0"


    // $ANTLR start "rule__XClosure__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:8437:1: rule__XClosure__Group__0__Impl : ( ( rule__XClosure__Group_0__0 ) ) ;
    public final void rule__XClosure__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8441:1: ( ( ( rule__XClosure__Group_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:8442:1: ( ( rule__XClosure__Group_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:8442:1: ( ( rule__XClosure__Group_0__0 ) )
            // InternalXbaseWithAnnotations.g:8443:2: ( rule__XClosure__Group_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getGroup_0()); 
            }
            // InternalXbaseWithAnnotations.g:8444:2: ( rule__XClosure__Group_0__0 )
            // InternalXbaseWithAnnotations.g:8444:3: rule__XClosure__Group_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getGroup_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group__0__Impl"


    // $ANTLR start "rule__XClosure__Group__1"
    // InternalXbaseWithAnnotations.g:8452:1: rule__XClosure__Group__1 : rule__XClosure__Group__1__Impl rule__XClosure__Group__2 ;
    public final void rule__XClosure__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8456:1: ( rule__XClosure__Group__1__Impl rule__XClosure__Group__2 )
            // InternalXbaseWithAnnotations.g:8457:2: rule__XClosure__Group__1__Impl rule__XClosure__Group__2
            {
            pushFollow(FOLLOW_52);
            rule__XClosure__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XClosure__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group__1"


    // $ANTLR start "rule__XClosure__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:8464:1: rule__XClosure__Group__1__Impl : ( ( rule__XClosure__Group_1__0 )? ) ;
    public final void rule__XClosure__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8468:1: ( ( ( rule__XClosure__Group_1__0 )? ) )
            // InternalXbaseWithAnnotations.g:8469:1: ( ( rule__XClosure__Group_1__0 )? )
            {
            // InternalXbaseWithAnnotations.g:8469:1: ( ( rule__XClosure__Group_1__0 )? )
            // InternalXbaseWithAnnotations.g:8470:2: ( rule__XClosure__Group_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getGroup_1()); 
            }
            // InternalXbaseWithAnnotations.g:8471:2: ( rule__XClosure__Group_1__0 )?
            int alt76=2;
            alt76 = dfa76.predict(input);
            switch (alt76) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:8471:3: rule__XClosure__Group_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XClosure__Group_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group__1__Impl"


    // $ANTLR start "rule__XClosure__Group__2"
    // InternalXbaseWithAnnotations.g:8479:1: rule__XClosure__Group__2 : rule__XClosure__Group__2__Impl rule__XClosure__Group__3 ;
    public final void rule__XClosure__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8483:1: ( rule__XClosure__Group__2__Impl rule__XClosure__Group__3 )
            // InternalXbaseWithAnnotations.g:8484:2: rule__XClosure__Group__2__Impl rule__XClosure__Group__3
            {
            pushFollow(FOLLOW_53);
            rule__XClosure__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XClosure__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group__2"


    // $ANTLR start "rule__XClosure__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:8491:1: rule__XClosure__Group__2__Impl : ( ( rule__XClosure__ExpressionAssignment_2 ) ) ;
    public final void rule__XClosure__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8495:1: ( ( ( rule__XClosure__ExpressionAssignment_2 ) ) )
            // InternalXbaseWithAnnotations.g:8496:1: ( ( rule__XClosure__ExpressionAssignment_2 ) )
            {
            // InternalXbaseWithAnnotations.g:8496:1: ( ( rule__XClosure__ExpressionAssignment_2 ) )
            // InternalXbaseWithAnnotations.g:8497:2: ( rule__XClosure__ExpressionAssignment_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getExpressionAssignment_2()); 
            }
            // InternalXbaseWithAnnotations.g:8498:2: ( rule__XClosure__ExpressionAssignment_2 )
            // InternalXbaseWithAnnotations.g:8498:3: rule__XClosure__ExpressionAssignment_2
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__ExpressionAssignment_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getExpressionAssignment_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group__2__Impl"


    // $ANTLR start "rule__XClosure__Group__3"
    // InternalXbaseWithAnnotations.g:8506:1: rule__XClosure__Group__3 : rule__XClosure__Group__3__Impl ;
    public final void rule__XClosure__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8510:1: ( rule__XClosure__Group__3__Impl )
            // InternalXbaseWithAnnotations.g:8511:2: rule__XClosure__Group__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group__3"


    // $ANTLR start "rule__XClosure__Group__3__Impl"
    // InternalXbaseWithAnnotations.g:8517:1: rule__XClosure__Group__3__Impl : ( ']' ) ;
    public final void rule__XClosure__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8521:1: ( ( ']' ) )
            // InternalXbaseWithAnnotations.g:8522:1: ( ']' )
            {
            // InternalXbaseWithAnnotations.g:8522:1: ( ']' )
            // InternalXbaseWithAnnotations.g:8523:2: ']'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getRightSquareBracketKeyword_3()); 
            }
            match(input,55,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getRightSquareBracketKeyword_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group__3__Impl"


    // $ANTLR start "rule__XClosure__Group_0__0"
    // InternalXbaseWithAnnotations.g:8533:1: rule__XClosure__Group_0__0 : rule__XClosure__Group_0__0__Impl ;
    public final void rule__XClosure__Group_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8537:1: ( rule__XClosure__Group_0__0__Impl )
            // InternalXbaseWithAnnotations.g:8538:2: rule__XClosure__Group_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_0__0"


    // $ANTLR start "rule__XClosure__Group_0__0__Impl"
    // InternalXbaseWithAnnotations.g:8544:1: rule__XClosure__Group_0__0__Impl : ( ( rule__XClosure__Group_0_0__0 ) ) ;
    public final void rule__XClosure__Group_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8548:1: ( ( ( rule__XClosure__Group_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:8549:1: ( ( rule__XClosure__Group_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:8549:1: ( ( rule__XClosure__Group_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:8550:2: ( rule__XClosure__Group_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getGroup_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:8551:2: ( rule__XClosure__Group_0_0__0 )
            // InternalXbaseWithAnnotations.g:8551:3: rule__XClosure__Group_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getGroup_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_0__0__Impl"


    // $ANTLR start "rule__XClosure__Group_0_0__0"
    // InternalXbaseWithAnnotations.g:8560:1: rule__XClosure__Group_0_0__0 : rule__XClosure__Group_0_0__0__Impl rule__XClosure__Group_0_0__1 ;
    public final void rule__XClosure__Group_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8564:1: ( rule__XClosure__Group_0_0__0__Impl rule__XClosure__Group_0_0__1 )
            // InternalXbaseWithAnnotations.g:8565:2: rule__XClosure__Group_0_0__0__Impl rule__XClosure__Group_0_0__1
            {
            pushFollow(FOLLOW_14);
            rule__XClosure__Group_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_0_0__0"


    // $ANTLR start "rule__XClosure__Group_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:8572:1: rule__XClosure__Group_0_0__0__Impl : ( () ) ;
    public final void rule__XClosure__Group_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8576:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:8577:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:8577:1: ( () )
            // InternalXbaseWithAnnotations.g:8578:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getXClosureAction_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:8579:2: ()
            // InternalXbaseWithAnnotations.g:8579:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getXClosureAction_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_0_0__0__Impl"


    // $ANTLR start "rule__XClosure__Group_0_0__1"
    // InternalXbaseWithAnnotations.g:8587:1: rule__XClosure__Group_0_0__1 : rule__XClosure__Group_0_0__1__Impl ;
    public final void rule__XClosure__Group_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8591:1: ( rule__XClosure__Group_0_0__1__Impl )
            // InternalXbaseWithAnnotations.g:8592:2: rule__XClosure__Group_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_0_0__1"


    // $ANTLR start "rule__XClosure__Group_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:8598:1: rule__XClosure__Group_0_0__1__Impl : ( '[' ) ;
    public final void rule__XClosure__Group_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8602:1: ( ( '[' ) )
            // InternalXbaseWithAnnotations.g:8603:1: ( '[' )
            {
            // InternalXbaseWithAnnotations.g:8603:1: ( '[' )
            // InternalXbaseWithAnnotations.g:8604:2: '['
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getLeftSquareBracketKeyword_0_0_1()); 
            }
            match(input,57,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getLeftSquareBracketKeyword_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_0_0__1__Impl"


    // $ANTLR start "rule__XClosure__Group_1__0"
    // InternalXbaseWithAnnotations.g:8614:1: rule__XClosure__Group_1__0 : rule__XClosure__Group_1__0__Impl ;
    public final void rule__XClosure__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8618:1: ( rule__XClosure__Group_1__0__Impl )
            // InternalXbaseWithAnnotations.g:8619:2: rule__XClosure__Group_1__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1__0"


    // $ANTLR start "rule__XClosure__Group_1__0__Impl"
    // InternalXbaseWithAnnotations.g:8625:1: rule__XClosure__Group_1__0__Impl : ( ( rule__XClosure__Group_1_0__0 ) ) ;
    public final void rule__XClosure__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8629:1: ( ( ( rule__XClosure__Group_1_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:8630:1: ( ( rule__XClosure__Group_1_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:8630:1: ( ( rule__XClosure__Group_1_0__0 ) )
            // InternalXbaseWithAnnotations.g:8631:2: ( rule__XClosure__Group_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getGroup_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:8632:2: ( rule__XClosure__Group_1_0__0 )
            // InternalXbaseWithAnnotations.g:8632:3: rule__XClosure__Group_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getGroup_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1__0__Impl"


    // $ANTLR start "rule__XClosure__Group_1_0__0"
    // InternalXbaseWithAnnotations.g:8641:1: rule__XClosure__Group_1_0__0 : rule__XClosure__Group_1_0__0__Impl rule__XClosure__Group_1_0__1 ;
    public final void rule__XClosure__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8645:1: ( rule__XClosure__Group_1_0__0__Impl rule__XClosure__Group_1_0__1 )
            // InternalXbaseWithAnnotations.g:8646:2: rule__XClosure__Group_1_0__0__Impl rule__XClosure__Group_1_0__1
            {
            pushFollow(FOLLOW_54);
            rule__XClosure__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_1_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1_0__0"


    // $ANTLR start "rule__XClosure__Group_1_0__0__Impl"
    // InternalXbaseWithAnnotations.g:8653:1: rule__XClosure__Group_1_0__0__Impl : ( ( rule__XClosure__Group_1_0_0__0 )? ) ;
    public final void rule__XClosure__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8657:1: ( ( ( rule__XClosure__Group_1_0_0__0 )? ) )
            // InternalXbaseWithAnnotations.g:8658:1: ( ( rule__XClosure__Group_1_0_0__0 )? )
            {
            // InternalXbaseWithAnnotations.g:8658:1: ( ( rule__XClosure__Group_1_0_0__0 )? )
            // InternalXbaseWithAnnotations.g:8659:2: ( rule__XClosure__Group_1_0_0__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getGroup_1_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:8660:2: ( rule__XClosure__Group_1_0_0__0 )?
            int alt77=2;
            int LA77_0 = input.LA(1);

            if ( (LA77_0==RULE_ID||LA77_0==31||LA77_0==52) ) {
                alt77=1;
            }
            switch (alt77) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:8660:3: rule__XClosure__Group_1_0_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XClosure__Group_1_0_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getGroup_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1_0__0__Impl"


    // $ANTLR start "rule__XClosure__Group_1_0__1"
    // InternalXbaseWithAnnotations.g:8668:1: rule__XClosure__Group_1_0__1 : rule__XClosure__Group_1_0__1__Impl ;
    public final void rule__XClosure__Group_1_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8672:1: ( rule__XClosure__Group_1_0__1__Impl )
            // InternalXbaseWithAnnotations.g:8673:2: rule__XClosure__Group_1_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_1_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1_0__1"


    // $ANTLR start "rule__XClosure__Group_1_0__1__Impl"
    // InternalXbaseWithAnnotations.g:8679:1: rule__XClosure__Group_1_0__1__Impl : ( ( rule__XClosure__ExplicitSyntaxAssignment_1_0_1 ) ) ;
    public final void rule__XClosure__Group_1_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8683:1: ( ( ( rule__XClosure__ExplicitSyntaxAssignment_1_0_1 ) ) )
            // InternalXbaseWithAnnotations.g:8684:1: ( ( rule__XClosure__ExplicitSyntaxAssignment_1_0_1 ) )
            {
            // InternalXbaseWithAnnotations.g:8684:1: ( ( rule__XClosure__ExplicitSyntaxAssignment_1_0_1 ) )
            // InternalXbaseWithAnnotations.g:8685:2: ( rule__XClosure__ExplicitSyntaxAssignment_1_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getExplicitSyntaxAssignment_1_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:8686:2: ( rule__XClosure__ExplicitSyntaxAssignment_1_0_1 )
            // InternalXbaseWithAnnotations.g:8686:3: rule__XClosure__ExplicitSyntaxAssignment_1_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__ExplicitSyntaxAssignment_1_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getExplicitSyntaxAssignment_1_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1_0__1__Impl"


    // $ANTLR start "rule__XClosure__Group_1_0_0__0"
    // InternalXbaseWithAnnotations.g:8695:1: rule__XClosure__Group_1_0_0__0 : rule__XClosure__Group_1_0_0__0__Impl rule__XClosure__Group_1_0_0__1 ;
    public final void rule__XClosure__Group_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8699:1: ( rule__XClosure__Group_1_0_0__0__Impl rule__XClosure__Group_1_0_0__1 )
            // InternalXbaseWithAnnotations.g:8700:2: rule__XClosure__Group_1_0_0__0__Impl rule__XClosure__Group_1_0_0__1
            {
            pushFollow(FOLLOW_8);
            rule__XClosure__Group_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1_0_0__0"


    // $ANTLR start "rule__XClosure__Group_1_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:8707:1: rule__XClosure__Group_1_0_0__0__Impl : ( ( rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_0 ) ) ;
    public final void rule__XClosure__Group_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8711:1: ( ( ( rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_0 ) ) )
            // InternalXbaseWithAnnotations.g:8712:1: ( ( rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_0 ) )
            {
            // InternalXbaseWithAnnotations.g:8712:1: ( ( rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_0 ) )
            // InternalXbaseWithAnnotations.g:8713:2: ( rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getDeclaredFormalParametersAssignment_1_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:8714:2: ( rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_0 )
            // InternalXbaseWithAnnotations.g:8714:3: rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_0
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getDeclaredFormalParametersAssignment_1_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1_0_0__0__Impl"


    // $ANTLR start "rule__XClosure__Group_1_0_0__1"
    // InternalXbaseWithAnnotations.g:8722:1: rule__XClosure__Group_1_0_0__1 : rule__XClosure__Group_1_0_0__1__Impl ;
    public final void rule__XClosure__Group_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8726:1: ( rule__XClosure__Group_1_0_0__1__Impl )
            // InternalXbaseWithAnnotations.g:8727:2: rule__XClosure__Group_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1_0_0__1"


    // $ANTLR start "rule__XClosure__Group_1_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:8733:1: rule__XClosure__Group_1_0_0__1__Impl : ( ( rule__XClosure__Group_1_0_0_1__0 )* ) ;
    public final void rule__XClosure__Group_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8737:1: ( ( ( rule__XClosure__Group_1_0_0_1__0 )* ) )
            // InternalXbaseWithAnnotations.g:8738:1: ( ( rule__XClosure__Group_1_0_0_1__0 )* )
            {
            // InternalXbaseWithAnnotations.g:8738:1: ( ( rule__XClosure__Group_1_0_0_1__0 )* )
            // InternalXbaseWithAnnotations.g:8739:2: ( rule__XClosure__Group_1_0_0_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getGroup_1_0_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:8740:2: ( rule__XClosure__Group_1_0_0_1__0 )*
            loop78:
            do {
                int alt78=2;
                int LA78_0 = input.LA(1);

                if ( (LA78_0==54) ) {
                    alt78=1;
                }


                switch (alt78) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:8740:3: rule__XClosure__Group_1_0_0_1__0
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__XClosure__Group_1_0_0_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop78;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getGroup_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1_0_0__1__Impl"


    // $ANTLR start "rule__XClosure__Group_1_0_0_1__0"
    // InternalXbaseWithAnnotations.g:8749:1: rule__XClosure__Group_1_0_0_1__0 : rule__XClosure__Group_1_0_0_1__0__Impl rule__XClosure__Group_1_0_0_1__1 ;
    public final void rule__XClosure__Group_1_0_0_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8753:1: ( rule__XClosure__Group_1_0_0_1__0__Impl rule__XClosure__Group_1_0_0_1__1 )
            // InternalXbaseWithAnnotations.g:8754:2: rule__XClosure__Group_1_0_0_1__0__Impl rule__XClosure__Group_1_0_0_1__1
            {
            pushFollow(FOLLOW_27);
            rule__XClosure__Group_1_0_0_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_1_0_0_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1_0_0_1__0"


    // $ANTLR start "rule__XClosure__Group_1_0_0_1__0__Impl"
    // InternalXbaseWithAnnotations.g:8761:1: rule__XClosure__Group_1_0_0_1__0__Impl : ( ',' ) ;
    public final void rule__XClosure__Group_1_0_0_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8765:1: ( ( ',' ) )
            // InternalXbaseWithAnnotations.g:8766:1: ( ',' )
            {
            // InternalXbaseWithAnnotations.g:8766:1: ( ',' )
            // InternalXbaseWithAnnotations.g:8767:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getCommaKeyword_1_0_0_1_0()); 
            }
            match(input,54,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getCommaKeyword_1_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1_0_0_1__0__Impl"


    // $ANTLR start "rule__XClosure__Group_1_0_0_1__1"
    // InternalXbaseWithAnnotations.g:8776:1: rule__XClosure__Group_1_0_0_1__1 : rule__XClosure__Group_1_0_0_1__1__Impl ;
    public final void rule__XClosure__Group_1_0_0_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8780:1: ( rule__XClosure__Group_1_0_0_1__1__Impl )
            // InternalXbaseWithAnnotations.g:8781:2: rule__XClosure__Group_1_0_0_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__Group_1_0_0_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1_0_0_1__1"


    // $ANTLR start "rule__XClosure__Group_1_0_0_1__1__Impl"
    // InternalXbaseWithAnnotations.g:8787:1: rule__XClosure__Group_1_0_0_1__1__Impl : ( ( rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_1_1 ) ) ;
    public final void rule__XClosure__Group_1_0_0_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8791:1: ( ( ( rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:8792:1: ( ( rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:8792:1: ( ( rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_1_1 ) )
            // InternalXbaseWithAnnotations.g:8793:2: ( rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getDeclaredFormalParametersAssignment_1_0_0_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:8794:2: ( rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_1_1 )
            // InternalXbaseWithAnnotations.g:8794:3: rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getDeclaredFormalParametersAssignment_1_0_0_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__Group_1_0_0_1__1__Impl"


    // $ANTLR start "rule__XExpressionInClosure__Group__0"
    // InternalXbaseWithAnnotations.g:8803:1: rule__XExpressionInClosure__Group__0 : rule__XExpressionInClosure__Group__0__Impl rule__XExpressionInClosure__Group__1 ;
    public final void rule__XExpressionInClosure__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8807:1: ( rule__XExpressionInClosure__Group__0__Impl rule__XExpressionInClosure__Group__1 )
            // InternalXbaseWithAnnotations.g:8808:2: rule__XExpressionInClosure__Group__0__Impl rule__XExpressionInClosure__Group__1
            {
            pushFollow(FOLLOW_52);
            rule__XExpressionInClosure__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XExpressionInClosure__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XExpressionInClosure__Group__0"


    // $ANTLR start "rule__XExpressionInClosure__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:8815:1: rule__XExpressionInClosure__Group__0__Impl : ( () ) ;
    public final void rule__XExpressionInClosure__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8819:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:8820:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:8820:1: ( () )
            // InternalXbaseWithAnnotations.g:8821:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXExpressionInClosureAccess().getXBlockExpressionAction_0()); 
            }
            // InternalXbaseWithAnnotations.g:8822:2: ()
            // InternalXbaseWithAnnotations.g:8822:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXExpressionInClosureAccess().getXBlockExpressionAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XExpressionInClosure__Group__0__Impl"


    // $ANTLR start "rule__XExpressionInClosure__Group__1"
    // InternalXbaseWithAnnotations.g:8830:1: rule__XExpressionInClosure__Group__1 : rule__XExpressionInClosure__Group__1__Impl ;
    public final void rule__XExpressionInClosure__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8834:1: ( rule__XExpressionInClosure__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:8835:2: rule__XExpressionInClosure__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XExpressionInClosure__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XExpressionInClosure__Group__1"


    // $ANTLR start "rule__XExpressionInClosure__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:8841:1: rule__XExpressionInClosure__Group__1__Impl : ( ( rule__XExpressionInClosure__Group_1__0 )* ) ;
    public final void rule__XExpressionInClosure__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8845:1: ( ( ( rule__XExpressionInClosure__Group_1__0 )* ) )
            // InternalXbaseWithAnnotations.g:8846:1: ( ( rule__XExpressionInClosure__Group_1__0 )* )
            {
            // InternalXbaseWithAnnotations.g:8846:1: ( ( rule__XExpressionInClosure__Group_1__0 )* )
            // InternalXbaseWithAnnotations.g:8847:2: ( rule__XExpressionInClosure__Group_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXExpressionInClosureAccess().getGroup_1()); 
            }
            // InternalXbaseWithAnnotations.g:8848:2: ( rule__XExpressionInClosure__Group_1__0 )*
            loop79:
            do {
                int alt79=2;
                int LA79_0 = input.LA(1);

                if ( ((LA79_0>=RULE_ID && LA79_0<=RULE_STRING)||LA79_0==27||(LA79_0>=34 && LA79_0<=35)||LA79_0==40||(LA79_0>=44 && LA79_0<=50)||LA79_0==52||(LA79_0>=56 && LA79_0<=57)||LA79_0==60||LA79_0==63||LA79_0==65||(LA79_0>=69 && LA79_0<=77)||LA79_0==79||(LA79_0>=86 && LA79_0<=87)) ) {
                    alt79=1;
                }


                switch (alt79) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:8848:3: rule__XExpressionInClosure__Group_1__0
            	    {
            	    pushFollow(FOLLOW_55);
            	    rule__XExpressionInClosure__Group_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop79;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXExpressionInClosureAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XExpressionInClosure__Group__1__Impl"


    // $ANTLR start "rule__XExpressionInClosure__Group_1__0"
    // InternalXbaseWithAnnotations.g:8857:1: rule__XExpressionInClosure__Group_1__0 : rule__XExpressionInClosure__Group_1__0__Impl rule__XExpressionInClosure__Group_1__1 ;
    public final void rule__XExpressionInClosure__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8861:1: ( rule__XExpressionInClosure__Group_1__0__Impl rule__XExpressionInClosure__Group_1__1 )
            // InternalXbaseWithAnnotations.g:8862:2: rule__XExpressionInClosure__Group_1__0__Impl rule__XExpressionInClosure__Group_1__1
            {
            pushFollow(FOLLOW_56);
            rule__XExpressionInClosure__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XExpressionInClosure__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XExpressionInClosure__Group_1__0"


    // $ANTLR start "rule__XExpressionInClosure__Group_1__0__Impl"
    // InternalXbaseWithAnnotations.g:8869:1: rule__XExpressionInClosure__Group_1__0__Impl : ( ( rule__XExpressionInClosure__ExpressionsAssignment_1_0 ) ) ;
    public final void rule__XExpressionInClosure__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8873:1: ( ( ( rule__XExpressionInClosure__ExpressionsAssignment_1_0 ) ) )
            // InternalXbaseWithAnnotations.g:8874:1: ( ( rule__XExpressionInClosure__ExpressionsAssignment_1_0 ) )
            {
            // InternalXbaseWithAnnotations.g:8874:1: ( ( rule__XExpressionInClosure__ExpressionsAssignment_1_0 ) )
            // InternalXbaseWithAnnotations.g:8875:2: ( rule__XExpressionInClosure__ExpressionsAssignment_1_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXExpressionInClosureAccess().getExpressionsAssignment_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:8876:2: ( rule__XExpressionInClosure__ExpressionsAssignment_1_0 )
            // InternalXbaseWithAnnotations.g:8876:3: rule__XExpressionInClosure__ExpressionsAssignment_1_0
            {
            pushFollow(FOLLOW_2);
            rule__XExpressionInClosure__ExpressionsAssignment_1_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXExpressionInClosureAccess().getExpressionsAssignment_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XExpressionInClosure__Group_1__0__Impl"


    // $ANTLR start "rule__XExpressionInClosure__Group_1__1"
    // InternalXbaseWithAnnotations.g:8884:1: rule__XExpressionInClosure__Group_1__1 : rule__XExpressionInClosure__Group_1__1__Impl ;
    public final void rule__XExpressionInClosure__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8888:1: ( rule__XExpressionInClosure__Group_1__1__Impl )
            // InternalXbaseWithAnnotations.g:8889:2: rule__XExpressionInClosure__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XExpressionInClosure__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XExpressionInClosure__Group_1__1"


    // $ANTLR start "rule__XExpressionInClosure__Group_1__1__Impl"
    // InternalXbaseWithAnnotations.g:8895:1: rule__XExpressionInClosure__Group_1__1__Impl : ( ( ';' )? ) ;
    public final void rule__XExpressionInClosure__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8899:1: ( ( ( ';' )? ) )
            // InternalXbaseWithAnnotations.g:8900:1: ( ( ';' )? )
            {
            // InternalXbaseWithAnnotations.g:8900:1: ( ( ';' )? )
            // InternalXbaseWithAnnotations.g:8901:2: ( ';' )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXExpressionInClosureAccess().getSemicolonKeyword_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:8902:2: ( ';' )?
            int alt80=2;
            int LA80_0 = input.LA(1);

            if ( (LA80_0==62) ) {
                alt80=1;
            }
            switch (alt80) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:8902:3: ';'
                    {
                    match(input,62,FOLLOW_2); if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXExpressionInClosureAccess().getSemicolonKeyword_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XExpressionInClosure__Group_1__1__Impl"


    // $ANTLR start "rule__XShortClosure__Group__0"
    // InternalXbaseWithAnnotations.g:8911:1: rule__XShortClosure__Group__0 : rule__XShortClosure__Group__0__Impl rule__XShortClosure__Group__1 ;
    public final void rule__XShortClosure__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8915:1: ( rule__XShortClosure__Group__0__Impl rule__XShortClosure__Group__1 )
            // InternalXbaseWithAnnotations.g:8916:2: rule__XShortClosure__Group__0__Impl rule__XShortClosure__Group__1
            {
            pushFollow(FOLLOW_10);
            rule__XShortClosure__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group__0"


    // $ANTLR start "rule__XShortClosure__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:8923:1: rule__XShortClosure__Group__0__Impl : ( ( rule__XShortClosure__Group_0__0 ) ) ;
    public final void rule__XShortClosure__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8927:1: ( ( ( rule__XShortClosure__Group_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:8928:1: ( ( rule__XShortClosure__Group_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:8928:1: ( ( rule__XShortClosure__Group_0__0 ) )
            // InternalXbaseWithAnnotations.g:8929:2: ( rule__XShortClosure__Group_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getGroup_0()); 
            }
            // InternalXbaseWithAnnotations.g:8930:2: ( rule__XShortClosure__Group_0__0 )
            // InternalXbaseWithAnnotations.g:8930:3: rule__XShortClosure__Group_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getGroup_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group__0__Impl"


    // $ANTLR start "rule__XShortClosure__Group__1"
    // InternalXbaseWithAnnotations.g:8938:1: rule__XShortClosure__Group__1 : rule__XShortClosure__Group__1__Impl ;
    public final void rule__XShortClosure__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8942:1: ( rule__XShortClosure__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:8943:2: rule__XShortClosure__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group__1"


    // $ANTLR start "rule__XShortClosure__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:8949:1: rule__XShortClosure__Group__1__Impl : ( ( rule__XShortClosure__ExpressionAssignment_1 ) ) ;
    public final void rule__XShortClosure__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8953:1: ( ( ( rule__XShortClosure__ExpressionAssignment_1 ) ) )
            // InternalXbaseWithAnnotations.g:8954:1: ( ( rule__XShortClosure__ExpressionAssignment_1 ) )
            {
            // InternalXbaseWithAnnotations.g:8954:1: ( ( rule__XShortClosure__ExpressionAssignment_1 ) )
            // InternalXbaseWithAnnotations.g:8955:2: ( rule__XShortClosure__ExpressionAssignment_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getExpressionAssignment_1()); 
            }
            // InternalXbaseWithAnnotations.g:8956:2: ( rule__XShortClosure__ExpressionAssignment_1 )
            // InternalXbaseWithAnnotations.g:8956:3: rule__XShortClosure__ExpressionAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__XShortClosure__ExpressionAssignment_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getExpressionAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group__1__Impl"


    // $ANTLR start "rule__XShortClosure__Group_0__0"
    // InternalXbaseWithAnnotations.g:8965:1: rule__XShortClosure__Group_0__0 : rule__XShortClosure__Group_0__0__Impl ;
    public final void rule__XShortClosure__Group_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8969:1: ( rule__XShortClosure__Group_0__0__Impl )
            // InternalXbaseWithAnnotations.g:8970:2: rule__XShortClosure__Group_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0__0"


    // $ANTLR start "rule__XShortClosure__Group_0__0__Impl"
    // InternalXbaseWithAnnotations.g:8976:1: rule__XShortClosure__Group_0__0__Impl : ( ( rule__XShortClosure__Group_0_0__0 ) ) ;
    public final void rule__XShortClosure__Group_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8980:1: ( ( ( rule__XShortClosure__Group_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:8981:1: ( ( rule__XShortClosure__Group_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:8981:1: ( ( rule__XShortClosure__Group_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:8982:2: ( rule__XShortClosure__Group_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getGroup_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:8983:2: ( rule__XShortClosure__Group_0_0__0 )
            // InternalXbaseWithAnnotations.g:8983:3: rule__XShortClosure__Group_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getGroup_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0__0__Impl"


    // $ANTLR start "rule__XShortClosure__Group_0_0__0"
    // InternalXbaseWithAnnotations.g:8992:1: rule__XShortClosure__Group_0_0__0 : rule__XShortClosure__Group_0_0__0__Impl rule__XShortClosure__Group_0_0__1 ;
    public final void rule__XShortClosure__Group_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:8996:1: ( rule__XShortClosure__Group_0_0__0__Impl rule__XShortClosure__Group_0_0__1 )
            // InternalXbaseWithAnnotations.g:8997:2: rule__XShortClosure__Group_0_0__0__Impl rule__XShortClosure__Group_0_0__1
            {
            pushFollow(FOLLOW_54);
            rule__XShortClosure__Group_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0__0"


    // $ANTLR start "rule__XShortClosure__Group_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:9004:1: rule__XShortClosure__Group_0_0__0__Impl : ( () ) ;
    public final void rule__XShortClosure__Group_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9008:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:9009:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:9009:1: ( () )
            // InternalXbaseWithAnnotations.g:9010:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getXClosureAction_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:9011:2: ()
            // InternalXbaseWithAnnotations.g:9011:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getXClosureAction_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0__0__Impl"


    // $ANTLR start "rule__XShortClosure__Group_0_0__1"
    // InternalXbaseWithAnnotations.g:9019:1: rule__XShortClosure__Group_0_0__1 : rule__XShortClosure__Group_0_0__1__Impl rule__XShortClosure__Group_0_0__2 ;
    public final void rule__XShortClosure__Group_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9023:1: ( rule__XShortClosure__Group_0_0__1__Impl rule__XShortClosure__Group_0_0__2 )
            // InternalXbaseWithAnnotations.g:9024:2: rule__XShortClosure__Group_0_0__1__Impl rule__XShortClosure__Group_0_0__2
            {
            pushFollow(FOLLOW_54);
            rule__XShortClosure__Group_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group_0_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0__1"


    // $ANTLR start "rule__XShortClosure__Group_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:9031:1: rule__XShortClosure__Group_0_0__1__Impl : ( ( rule__XShortClosure__Group_0_0_1__0 )? ) ;
    public final void rule__XShortClosure__Group_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9035:1: ( ( ( rule__XShortClosure__Group_0_0_1__0 )? ) )
            // InternalXbaseWithAnnotations.g:9036:1: ( ( rule__XShortClosure__Group_0_0_1__0 )? )
            {
            // InternalXbaseWithAnnotations.g:9036:1: ( ( rule__XShortClosure__Group_0_0_1__0 )? )
            // InternalXbaseWithAnnotations.g:9037:2: ( rule__XShortClosure__Group_0_0_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getGroup_0_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:9038:2: ( rule__XShortClosure__Group_0_0_1__0 )?
            int alt81=2;
            int LA81_0 = input.LA(1);

            if ( (LA81_0==RULE_ID||LA81_0==31||LA81_0==52) ) {
                alt81=1;
            }
            switch (alt81) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:9038:3: rule__XShortClosure__Group_0_0_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XShortClosure__Group_0_0_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getGroup_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0__1__Impl"


    // $ANTLR start "rule__XShortClosure__Group_0_0__2"
    // InternalXbaseWithAnnotations.g:9046:1: rule__XShortClosure__Group_0_0__2 : rule__XShortClosure__Group_0_0__2__Impl ;
    public final void rule__XShortClosure__Group_0_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9050:1: ( rule__XShortClosure__Group_0_0__2__Impl )
            // InternalXbaseWithAnnotations.g:9051:2: rule__XShortClosure__Group_0_0__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group_0_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0__2"


    // $ANTLR start "rule__XShortClosure__Group_0_0__2__Impl"
    // InternalXbaseWithAnnotations.g:9057:1: rule__XShortClosure__Group_0_0__2__Impl : ( ( rule__XShortClosure__ExplicitSyntaxAssignment_0_0_2 ) ) ;
    public final void rule__XShortClosure__Group_0_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9061:1: ( ( ( rule__XShortClosure__ExplicitSyntaxAssignment_0_0_2 ) ) )
            // InternalXbaseWithAnnotations.g:9062:1: ( ( rule__XShortClosure__ExplicitSyntaxAssignment_0_0_2 ) )
            {
            // InternalXbaseWithAnnotations.g:9062:1: ( ( rule__XShortClosure__ExplicitSyntaxAssignment_0_0_2 ) )
            // InternalXbaseWithAnnotations.g:9063:2: ( rule__XShortClosure__ExplicitSyntaxAssignment_0_0_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getExplicitSyntaxAssignment_0_0_2()); 
            }
            // InternalXbaseWithAnnotations.g:9064:2: ( rule__XShortClosure__ExplicitSyntaxAssignment_0_0_2 )
            // InternalXbaseWithAnnotations.g:9064:3: rule__XShortClosure__ExplicitSyntaxAssignment_0_0_2
            {
            pushFollow(FOLLOW_2);
            rule__XShortClosure__ExplicitSyntaxAssignment_0_0_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getExplicitSyntaxAssignment_0_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0__2__Impl"


    // $ANTLR start "rule__XShortClosure__Group_0_0_1__0"
    // InternalXbaseWithAnnotations.g:9073:1: rule__XShortClosure__Group_0_0_1__0 : rule__XShortClosure__Group_0_0_1__0__Impl rule__XShortClosure__Group_0_0_1__1 ;
    public final void rule__XShortClosure__Group_0_0_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9077:1: ( rule__XShortClosure__Group_0_0_1__0__Impl rule__XShortClosure__Group_0_0_1__1 )
            // InternalXbaseWithAnnotations.g:9078:2: rule__XShortClosure__Group_0_0_1__0__Impl rule__XShortClosure__Group_0_0_1__1
            {
            pushFollow(FOLLOW_8);
            rule__XShortClosure__Group_0_0_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group_0_0_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0_1__0"


    // $ANTLR start "rule__XShortClosure__Group_0_0_1__0__Impl"
    // InternalXbaseWithAnnotations.g:9085:1: rule__XShortClosure__Group_0_0_1__0__Impl : ( ( rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_0 ) ) ;
    public final void rule__XShortClosure__Group_0_0_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9089:1: ( ( ( rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_0 ) ) )
            // InternalXbaseWithAnnotations.g:9090:1: ( ( rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_0 ) )
            {
            // InternalXbaseWithAnnotations.g:9090:1: ( ( rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_0 ) )
            // InternalXbaseWithAnnotations.g:9091:2: ( rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getDeclaredFormalParametersAssignment_0_0_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:9092:2: ( rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_0 )
            // InternalXbaseWithAnnotations.g:9092:3: rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_0
            {
            pushFollow(FOLLOW_2);
            rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getDeclaredFormalParametersAssignment_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0_1__0__Impl"


    // $ANTLR start "rule__XShortClosure__Group_0_0_1__1"
    // InternalXbaseWithAnnotations.g:9100:1: rule__XShortClosure__Group_0_0_1__1 : rule__XShortClosure__Group_0_0_1__1__Impl ;
    public final void rule__XShortClosure__Group_0_0_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9104:1: ( rule__XShortClosure__Group_0_0_1__1__Impl )
            // InternalXbaseWithAnnotations.g:9105:2: rule__XShortClosure__Group_0_0_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group_0_0_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0_1__1"


    // $ANTLR start "rule__XShortClosure__Group_0_0_1__1__Impl"
    // InternalXbaseWithAnnotations.g:9111:1: rule__XShortClosure__Group_0_0_1__1__Impl : ( ( rule__XShortClosure__Group_0_0_1_1__0 )* ) ;
    public final void rule__XShortClosure__Group_0_0_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9115:1: ( ( ( rule__XShortClosure__Group_0_0_1_1__0 )* ) )
            // InternalXbaseWithAnnotations.g:9116:1: ( ( rule__XShortClosure__Group_0_0_1_1__0 )* )
            {
            // InternalXbaseWithAnnotations.g:9116:1: ( ( rule__XShortClosure__Group_0_0_1_1__0 )* )
            // InternalXbaseWithAnnotations.g:9117:2: ( rule__XShortClosure__Group_0_0_1_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getGroup_0_0_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:9118:2: ( rule__XShortClosure__Group_0_0_1_1__0 )*
            loop82:
            do {
                int alt82=2;
                int LA82_0 = input.LA(1);

                if ( (LA82_0==54) ) {
                    alt82=1;
                }


                switch (alt82) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:9118:3: rule__XShortClosure__Group_0_0_1_1__0
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__XShortClosure__Group_0_0_1_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop82;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getGroup_0_0_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0_1__1__Impl"


    // $ANTLR start "rule__XShortClosure__Group_0_0_1_1__0"
    // InternalXbaseWithAnnotations.g:9127:1: rule__XShortClosure__Group_0_0_1_1__0 : rule__XShortClosure__Group_0_0_1_1__0__Impl rule__XShortClosure__Group_0_0_1_1__1 ;
    public final void rule__XShortClosure__Group_0_0_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9131:1: ( rule__XShortClosure__Group_0_0_1_1__0__Impl rule__XShortClosure__Group_0_0_1_1__1 )
            // InternalXbaseWithAnnotations.g:9132:2: rule__XShortClosure__Group_0_0_1_1__0__Impl rule__XShortClosure__Group_0_0_1_1__1
            {
            pushFollow(FOLLOW_27);
            rule__XShortClosure__Group_0_0_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group_0_0_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0_1_1__0"


    // $ANTLR start "rule__XShortClosure__Group_0_0_1_1__0__Impl"
    // InternalXbaseWithAnnotations.g:9139:1: rule__XShortClosure__Group_0_0_1_1__0__Impl : ( ',' ) ;
    public final void rule__XShortClosure__Group_0_0_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9143:1: ( ( ',' ) )
            // InternalXbaseWithAnnotations.g:9144:1: ( ',' )
            {
            // InternalXbaseWithAnnotations.g:9144:1: ( ',' )
            // InternalXbaseWithAnnotations.g:9145:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getCommaKeyword_0_0_1_1_0()); 
            }
            match(input,54,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getCommaKeyword_0_0_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0_1_1__0__Impl"


    // $ANTLR start "rule__XShortClosure__Group_0_0_1_1__1"
    // InternalXbaseWithAnnotations.g:9154:1: rule__XShortClosure__Group_0_0_1_1__1 : rule__XShortClosure__Group_0_0_1_1__1__Impl ;
    public final void rule__XShortClosure__Group_0_0_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9158:1: ( rule__XShortClosure__Group_0_0_1_1__1__Impl )
            // InternalXbaseWithAnnotations.g:9159:2: rule__XShortClosure__Group_0_0_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XShortClosure__Group_0_0_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0_1_1__1"


    // $ANTLR start "rule__XShortClosure__Group_0_0_1_1__1__Impl"
    // InternalXbaseWithAnnotations.g:9165:1: rule__XShortClosure__Group_0_0_1_1__1__Impl : ( ( rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_1_1 ) ) ;
    public final void rule__XShortClosure__Group_0_0_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9169:1: ( ( ( rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:9170:1: ( ( rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:9170:1: ( ( rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_1_1 ) )
            // InternalXbaseWithAnnotations.g:9171:2: ( rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getDeclaredFormalParametersAssignment_0_0_1_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:9172:2: ( rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_1_1 )
            // InternalXbaseWithAnnotations.g:9172:3: rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getDeclaredFormalParametersAssignment_0_0_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__Group_0_0_1_1__1__Impl"


    // $ANTLR start "rule__XParenthesizedExpression__Group__0"
    // InternalXbaseWithAnnotations.g:9181:1: rule__XParenthesizedExpression__Group__0 : rule__XParenthesizedExpression__Group__0__Impl rule__XParenthesizedExpression__Group__1 ;
    public final void rule__XParenthesizedExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9185:1: ( rule__XParenthesizedExpression__Group__0__Impl rule__XParenthesizedExpression__Group__1 )
            // InternalXbaseWithAnnotations.g:9186:2: rule__XParenthesizedExpression__Group__0__Impl rule__XParenthesizedExpression__Group__1
            {
            pushFollow(FOLLOW_10);
            rule__XParenthesizedExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XParenthesizedExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XParenthesizedExpression__Group__0"


    // $ANTLR start "rule__XParenthesizedExpression__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:9193:1: rule__XParenthesizedExpression__Group__0__Impl : ( '(' ) ;
    public final void rule__XParenthesizedExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9197:1: ( ( '(' ) )
            // InternalXbaseWithAnnotations.g:9198:1: ( '(' )
            {
            // InternalXbaseWithAnnotations.g:9198:1: ( '(' )
            // InternalXbaseWithAnnotations.g:9199:2: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXParenthesizedExpressionAccess().getLeftParenthesisKeyword_0()); 
            }
            match(input,52,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXParenthesizedExpressionAccess().getLeftParenthesisKeyword_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XParenthesizedExpression__Group__0__Impl"


    // $ANTLR start "rule__XParenthesizedExpression__Group__1"
    // InternalXbaseWithAnnotations.g:9208:1: rule__XParenthesizedExpression__Group__1 : rule__XParenthesizedExpression__Group__1__Impl rule__XParenthesizedExpression__Group__2 ;
    public final void rule__XParenthesizedExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9212:1: ( rule__XParenthesizedExpression__Group__1__Impl rule__XParenthesizedExpression__Group__2 )
            // InternalXbaseWithAnnotations.g:9213:2: rule__XParenthesizedExpression__Group__1__Impl rule__XParenthesizedExpression__Group__2
            {
            pushFollow(FOLLOW_57);
            rule__XParenthesizedExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XParenthesizedExpression__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XParenthesizedExpression__Group__1"


    // $ANTLR start "rule__XParenthesizedExpression__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:9220:1: rule__XParenthesizedExpression__Group__1__Impl : ( ruleXExpression ) ;
    public final void rule__XParenthesizedExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9224:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:9225:1: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:9225:1: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:9226:2: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXParenthesizedExpressionAccess().getXExpressionParserRuleCall_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXParenthesizedExpressionAccess().getXExpressionParserRuleCall_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XParenthesizedExpression__Group__1__Impl"


    // $ANTLR start "rule__XParenthesizedExpression__Group__2"
    // InternalXbaseWithAnnotations.g:9235:1: rule__XParenthesizedExpression__Group__2 : rule__XParenthesizedExpression__Group__2__Impl ;
    public final void rule__XParenthesizedExpression__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9239:1: ( rule__XParenthesizedExpression__Group__2__Impl )
            // InternalXbaseWithAnnotations.g:9240:2: rule__XParenthesizedExpression__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XParenthesizedExpression__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XParenthesizedExpression__Group__2"


    // $ANTLR start "rule__XParenthesizedExpression__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:9246:1: rule__XParenthesizedExpression__Group__2__Impl : ( ')' ) ;
    public final void rule__XParenthesizedExpression__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9250:1: ( ( ')' ) )
            // InternalXbaseWithAnnotations.g:9251:1: ( ')' )
            {
            // InternalXbaseWithAnnotations.g:9251:1: ( ')' )
            // InternalXbaseWithAnnotations.g:9252:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXParenthesizedExpressionAccess().getRightParenthesisKeyword_2()); 
            }
            match(input,53,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXParenthesizedExpressionAccess().getRightParenthesisKeyword_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XParenthesizedExpression__Group__2__Impl"


    // $ANTLR start "rule__XIfExpression__Group__0"
    // InternalXbaseWithAnnotations.g:9262:1: rule__XIfExpression__Group__0 : rule__XIfExpression__Group__0__Impl rule__XIfExpression__Group__1 ;
    public final void rule__XIfExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9266:1: ( rule__XIfExpression__Group__0__Impl rule__XIfExpression__Group__1 )
            // InternalXbaseWithAnnotations.g:9267:2: rule__XIfExpression__Group__0__Impl rule__XIfExpression__Group__1
            {
            pushFollow(FOLLOW_58);
            rule__XIfExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XIfExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__0"


    // $ANTLR start "rule__XIfExpression__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:9274:1: rule__XIfExpression__Group__0__Impl : ( () ) ;
    public final void rule__XIfExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9278:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:9279:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:9279:1: ( () )
            // InternalXbaseWithAnnotations.g:9280:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getXIfExpressionAction_0()); 
            }
            // InternalXbaseWithAnnotations.g:9281:2: ()
            // InternalXbaseWithAnnotations.g:9281:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getXIfExpressionAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__0__Impl"


    // $ANTLR start "rule__XIfExpression__Group__1"
    // InternalXbaseWithAnnotations.g:9289:1: rule__XIfExpression__Group__1 : rule__XIfExpression__Group__1__Impl rule__XIfExpression__Group__2 ;
    public final void rule__XIfExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9293:1: ( rule__XIfExpression__Group__1__Impl rule__XIfExpression__Group__2 )
            // InternalXbaseWithAnnotations.g:9294:2: rule__XIfExpression__Group__1__Impl rule__XIfExpression__Group__2
            {
            pushFollow(FOLLOW_6);
            rule__XIfExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XIfExpression__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__1"


    // $ANTLR start "rule__XIfExpression__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:9301:1: rule__XIfExpression__Group__1__Impl : ( 'if' ) ;
    public final void rule__XIfExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9305:1: ( ( 'if' ) )
            // InternalXbaseWithAnnotations.g:9306:1: ( 'if' )
            {
            // InternalXbaseWithAnnotations.g:9306:1: ( 'if' )
            // InternalXbaseWithAnnotations.g:9307:2: 'if'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getIfKeyword_1()); 
            }
            match(input,63,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getIfKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__1__Impl"


    // $ANTLR start "rule__XIfExpression__Group__2"
    // InternalXbaseWithAnnotations.g:9316:1: rule__XIfExpression__Group__2 : rule__XIfExpression__Group__2__Impl rule__XIfExpression__Group__3 ;
    public final void rule__XIfExpression__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9320:1: ( rule__XIfExpression__Group__2__Impl rule__XIfExpression__Group__3 )
            // InternalXbaseWithAnnotations.g:9321:2: rule__XIfExpression__Group__2__Impl rule__XIfExpression__Group__3
            {
            pushFollow(FOLLOW_10);
            rule__XIfExpression__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XIfExpression__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__2"


    // $ANTLR start "rule__XIfExpression__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:9328:1: rule__XIfExpression__Group__2__Impl : ( '(' ) ;
    public final void rule__XIfExpression__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9332:1: ( ( '(' ) )
            // InternalXbaseWithAnnotations.g:9333:1: ( '(' )
            {
            // InternalXbaseWithAnnotations.g:9333:1: ( '(' )
            // InternalXbaseWithAnnotations.g:9334:2: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getLeftParenthesisKeyword_2()); 
            }
            match(input,52,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getLeftParenthesisKeyword_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__2__Impl"


    // $ANTLR start "rule__XIfExpression__Group__3"
    // InternalXbaseWithAnnotations.g:9343:1: rule__XIfExpression__Group__3 : rule__XIfExpression__Group__3__Impl rule__XIfExpression__Group__4 ;
    public final void rule__XIfExpression__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9347:1: ( rule__XIfExpression__Group__3__Impl rule__XIfExpression__Group__4 )
            // InternalXbaseWithAnnotations.g:9348:2: rule__XIfExpression__Group__3__Impl rule__XIfExpression__Group__4
            {
            pushFollow(FOLLOW_57);
            rule__XIfExpression__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XIfExpression__Group__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__3"


    // $ANTLR start "rule__XIfExpression__Group__3__Impl"
    // InternalXbaseWithAnnotations.g:9355:1: rule__XIfExpression__Group__3__Impl : ( ( rule__XIfExpression__IfAssignment_3 ) ) ;
    public final void rule__XIfExpression__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9359:1: ( ( ( rule__XIfExpression__IfAssignment_3 ) ) )
            // InternalXbaseWithAnnotations.g:9360:1: ( ( rule__XIfExpression__IfAssignment_3 ) )
            {
            // InternalXbaseWithAnnotations.g:9360:1: ( ( rule__XIfExpression__IfAssignment_3 ) )
            // InternalXbaseWithAnnotations.g:9361:2: ( rule__XIfExpression__IfAssignment_3 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getIfAssignment_3()); 
            }
            // InternalXbaseWithAnnotations.g:9362:2: ( rule__XIfExpression__IfAssignment_3 )
            // InternalXbaseWithAnnotations.g:9362:3: rule__XIfExpression__IfAssignment_3
            {
            pushFollow(FOLLOW_2);
            rule__XIfExpression__IfAssignment_3();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getIfAssignment_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__3__Impl"


    // $ANTLR start "rule__XIfExpression__Group__4"
    // InternalXbaseWithAnnotations.g:9370:1: rule__XIfExpression__Group__4 : rule__XIfExpression__Group__4__Impl rule__XIfExpression__Group__5 ;
    public final void rule__XIfExpression__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9374:1: ( rule__XIfExpression__Group__4__Impl rule__XIfExpression__Group__5 )
            // InternalXbaseWithAnnotations.g:9375:2: rule__XIfExpression__Group__4__Impl rule__XIfExpression__Group__5
            {
            pushFollow(FOLLOW_10);
            rule__XIfExpression__Group__4__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XIfExpression__Group__5();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__4"


    // $ANTLR start "rule__XIfExpression__Group__4__Impl"
    // InternalXbaseWithAnnotations.g:9382:1: rule__XIfExpression__Group__4__Impl : ( ')' ) ;
    public final void rule__XIfExpression__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9386:1: ( ( ')' ) )
            // InternalXbaseWithAnnotations.g:9387:1: ( ')' )
            {
            // InternalXbaseWithAnnotations.g:9387:1: ( ')' )
            // InternalXbaseWithAnnotations.g:9388:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getRightParenthesisKeyword_4()); 
            }
            match(input,53,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getRightParenthesisKeyword_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__4__Impl"


    // $ANTLR start "rule__XIfExpression__Group__5"
    // InternalXbaseWithAnnotations.g:9397:1: rule__XIfExpression__Group__5 : rule__XIfExpression__Group__5__Impl rule__XIfExpression__Group__6 ;
    public final void rule__XIfExpression__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9401:1: ( rule__XIfExpression__Group__5__Impl rule__XIfExpression__Group__6 )
            // InternalXbaseWithAnnotations.g:9402:2: rule__XIfExpression__Group__5__Impl rule__XIfExpression__Group__6
            {
            pushFollow(FOLLOW_59);
            rule__XIfExpression__Group__5__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XIfExpression__Group__6();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__5"


    // $ANTLR start "rule__XIfExpression__Group__5__Impl"
    // InternalXbaseWithAnnotations.g:9409:1: rule__XIfExpression__Group__5__Impl : ( ( rule__XIfExpression__ThenAssignment_5 ) ) ;
    public final void rule__XIfExpression__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9413:1: ( ( ( rule__XIfExpression__ThenAssignment_5 ) ) )
            // InternalXbaseWithAnnotations.g:9414:1: ( ( rule__XIfExpression__ThenAssignment_5 ) )
            {
            // InternalXbaseWithAnnotations.g:9414:1: ( ( rule__XIfExpression__ThenAssignment_5 ) )
            // InternalXbaseWithAnnotations.g:9415:2: ( rule__XIfExpression__ThenAssignment_5 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getThenAssignment_5()); 
            }
            // InternalXbaseWithAnnotations.g:9416:2: ( rule__XIfExpression__ThenAssignment_5 )
            // InternalXbaseWithAnnotations.g:9416:3: rule__XIfExpression__ThenAssignment_5
            {
            pushFollow(FOLLOW_2);
            rule__XIfExpression__ThenAssignment_5();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getThenAssignment_5()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__5__Impl"


    // $ANTLR start "rule__XIfExpression__Group__6"
    // InternalXbaseWithAnnotations.g:9424:1: rule__XIfExpression__Group__6 : rule__XIfExpression__Group__6__Impl ;
    public final void rule__XIfExpression__Group__6() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9428:1: ( rule__XIfExpression__Group__6__Impl )
            // InternalXbaseWithAnnotations.g:9429:2: rule__XIfExpression__Group__6__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XIfExpression__Group__6__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__6"


    // $ANTLR start "rule__XIfExpression__Group__6__Impl"
    // InternalXbaseWithAnnotations.g:9435:1: rule__XIfExpression__Group__6__Impl : ( ( rule__XIfExpression__Group_6__0 )? ) ;
    public final void rule__XIfExpression__Group__6__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9439:1: ( ( ( rule__XIfExpression__Group_6__0 )? ) )
            // InternalXbaseWithAnnotations.g:9440:1: ( ( rule__XIfExpression__Group_6__0 )? )
            {
            // InternalXbaseWithAnnotations.g:9440:1: ( ( rule__XIfExpression__Group_6__0 )? )
            // InternalXbaseWithAnnotations.g:9441:2: ( rule__XIfExpression__Group_6__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getGroup_6()); 
            }
            // InternalXbaseWithAnnotations.g:9442:2: ( rule__XIfExpression__Group_6__0 )?
            int alt83=2;
            int LA83_0 = input.LA(1);

            if ( (LA83_0==64) ) {
                int LA83_1 = input.LA(2);

                if ( (synpred126_InternalXbaseWithAnnotations()) ) {
                    alt83=1;
                }
            }
            switch (alt83) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:9442:3: rule__XIfExpression__Group_6__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XIfExpression__Group_6__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getGroup_6()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group__6__Impl"


    // $ANTLR start "rule__XIfExpression__Group_6__0"
    // InternalXbaseWithAnnotations.g:9451:1: rule__XIfExpression__Group_6__0 : rule__XIfExpression__Group_6__0__Impl rule__XIfExpression__Group_6__1 ;
    public final void rule__XIfExpression__Group_6__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9455:1: ( rule__XIfExpression__Group_6__0__Impl rule__XIfExpression__Group_6__1 )
            // InternalXbaseWithAnnotations.g:9456:2: rule__XIfExpression__Group_6__0__Impl rule__XIfExpression__Group_6__1
            {
            pushFollow(FOLLOW_10);
            rule__XIfExpression__Group_6__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XIfExpression__Group_6__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group_6__0"


    // $ANTLR start "rule__XIfExpression__Group_6__0__Impl"
    // InternalXbaseWithAnnotations.g:9463:1: rule__XIfExpression__Group_6__0__Impl : ( ( 'else' ) ) ;
    public final void rule__XIfExpression__Group_6__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9467:1: ( ( ( 'else' ) ) )
            // InternalXbaseWithAnnotations.g:9468:1: ( ( 'else' ) )
            {
            // InternalXbaseWithAnnotations.g:9468:1: ( ( 'else' ) )
            // InternalXbaseWithAnnotations.g:9469:2: ( 'else' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getElseKeyword_6_0()); 
            }
            // InternalXbaseWithAnnotations.g:9470:2: ( 'else' )
            // InternalXbaseWithAnnotations.g:9470:3: 'else'
            {
            match(input,64,FOLLOW_2); if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getElseKeyword_6_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group_6__0__Impl"


    // $ANTLR start "rule__XIfExpression__Group_6__1"
    // InternalXbaseWithAnnotations.g:9478:1: rule__XIfExpression__Group_6__1 : rule__XIfExpression__Group_6__1__Impl ;
    public final void rule__XIfExpression__Group_6__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9482:1: ( rule__XIfExpression__Group_6__1__Impl )
            // InternalXbaseWithAnnotations.g:9483:2: rule__XIfExpression__Group_6__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XIfExpression__Group_6__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group_6__1"


    // $ANTLR start "rule__XIfExpression__Group_6__1__Impl"
    // InternalXbaseWithAnnotations.g:9489:1: rule__XIfExpression__Group_6__1__Impl : ( ( rule__XIfExpression__ElseAssignment_6_1 ) ) ;
    public final void rule__XIfExpression__Group_6__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9493:1: ( ( ( rule__XIfExpression__ElseAssignment_6_1 ) ) )
            // InternalXbaseWithAnnotations.g:9494:1: ( ( rule__XIfExpression__ElseAssignment_6_1 ) )
            {
            // InternalXbaseWithAnnotations.g:9494:1: ( ( rule__XIfExpression__ElseAssignment_6_1 ) )
            // InternalXbaseWithAnnotations.g:9495:2: ( rule__XIfExpression__ElseAssignment_6_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getElseAssignment_6_1()); 
            }
            // InternalXbaseWithAnnotations.g:9496:2: ( rule__XIfExpression__ElseAssignment_6_1 )
            // InternalXbaseWithAnnotations.g:9496:3: rule__XIfExpression__ElseAssignment_6_1
            {
            pushFollow(FOLLOW_2);
            rule__XIfExpression__ElseAssignment_6_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getElseAssignment_6_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__Group_6__1__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group__0"
    // InternalXbaseWithAnnotations.g:9505:1: rule__XSwitchExpression__Group__0 : rule__XSwitchExpression__Group__0__Impl rule__XSwitchExpression__Group__1 ;
    public final void rule__XSwitchExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9509:1: ( rule__XSwitchExpression__Group__0__Impl rule__XSwitchExpression__Group__1 )
            // InternalXbaseWithAnnotations.g:9510:2: rule__XSwitchExpression__Group__0__Impl rule__XSwitchExpression__Group__1
            {
            pushFollow(FOLLOW_60);
            rule__XSwitchExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__0"


    // $ANTLR start "rule__XSwitchExpression__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:9517:1: rule__XSwitchExpression__Group__0__Impl : ( () ) ;
    public final void rule__XSwitchExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9521:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:9522:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:9522:1: ( () )
            // InternalXbaseWithAnnotations.g:9523:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getXSwitchExpressionAction_0()); 
            }
            // InternalXbaseWithAnnotations.g:9524:2: ()
            // InternalXbaseWithAnnotations.g:9524:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getXSwitchExpressionAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__0__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group__1"
    // InternalXbaseWithAnnotations.g:9532:1: rule__XSwitchExpression__Group__1 : rule__XSwitchExpression__Group__1__Impl rule__XSwitchExpression__Group__2 ;
    public final void rule__XSwitchExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9536:1: ( rule__XSwitchExpression__Group__1__Impl rule__XSwitchExpression__Group__2 )
            // InternalXbaseWithAnnotations.g:9537:2: rule__XSwitchExpression__Group__1__Impl rule__XSwitchExpression__Group__2
            {
            pushFollow(FOLLOW_61);
            rule__XSwitchExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__1"


    // $ANTLR start "rule__XSwitchExpression__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:9544:1: rule__XSwitchExpression__Group__1__Impl : ( 'switch' ) ;
    public final void rule__XSwitchExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9548:1: ( ( 'switch' ) )
            // InternalXbaseWithAnnotations.g:9549:1: ( 'switch' )
            {
            // InternalXbaseWithAnnotations.g:9549:1: ( 'switch' )
            // InternalXbaseWithAnnotations.g:9550:2: 'switch'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getSwitchKeyword_1()); 
            }
            match(input,65,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getSwitchKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__1__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group__2"
    // InternalXbaseWithAnnotations.g:9559:1: rule__XSwitchExpression__Group__2 : rule__XSwitchExpression__Group__2__Impl rule__XSwitchExpression__Group__3 ;
    public final void rule__XSwitchExpression__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9563:1: ( rule__XSwitchExpression__Group__2__Impl rule__XSwitchExpression__Group__3 )
            // InternalXbaseWithAnnotations.g:9564:2: rule__XSwitchExpression__Group__2__Impl rule__XSwitchExpression__Group__3
            {
            pushFollow(FOLLOW_50);
            rule__XSwitchExpression__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__2"


    // $ANTLR start "rule__XSwitchExpression__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:9571:1: rule__XSwitchExpression__Group__2__Impl : ( ( rule__XSwitchExpression__Alternatives_2 ) ) ;
    public final void rule__XSwitchExpression__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9575:1: ( ( ( rule__XSwitchExpression__Alternatives_2 ) ) )
            // InternalXbaseWithAnnotations.g:9576:1: ( ( rule__XSwitchExpression__Alternatives_2 ) )
            {
            // InternalXbaseWithAnnotations.g:9576:1: ( ( rule__XSwitchExpression__Alternatives_2 ) )
            // InternalXbaseWithAnnotations.g:9577:2: ( rule__XSwitchExpression__Alternatives_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getAlternatives_2()); 
            }
            // InternalXbaseWithAnnotations.g:9578:2: ( rule__XSwitchExpression__Alternatives_2 )
            // InternalXbaseWithAnnotations.g:9578:3: rule__XSwitchExpression__Alternatives_2
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Alternatives_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getAlternatives_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__2__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group__3"
    // InternalXbaseWithAnnotations.g:9586:1: rule__XSwitchExpression__Group__3 : rule__XSwitchExpression__Group__3__Impl rule__XSwitchExpression__Group__4 ;
    public final void rule__XSwitchExpression__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9590:1: ( rule__XSwitchExpression__Group__3__Impl rule__XSwitchExpression__Group__4 )
            // InternalXbaseWithAnnotations.g:9591:2: rule__XSwitchExpression__Group__3__Impl rule__XSwitchExpression__Group__4
            {
            pushFollow(FOLLOW_62);
            rule__XSwitchExpression__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__3"


    // $ANTLR start "rule__XSwitchExpression__Group__3__Impl"
    // InternalXbaseWithAnnotations.g:9598:1: rule__XSwitchExpression__Group__3__Impl : ( '{' ) ;
    public final void rule__XSwitchExpression__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9602:1: ( ( '{' ) )
            // InternalXbaseWithAnnotations.g:9603:1: ( '{' )
            {
            // InternalXbaseWithAnnotations.g:9603:1: ( '{' )
            // InternalXbaseWithAnnotations.g:9604:2: '{'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getLeftCurlyBracketKeyword_3()); 
            }
            match(input,60,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getLeftCurlyBracketKeyword_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__3__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group__4"
    // InternalXbaseWithAnnotations.g:9613:1: rule__XSwitchExpression__Group__4 : rule__XSwitchExpression__Group__4__Impl rule__XSwitchExpression__Group__5 ;
    public final void rule__XSwitchExpression__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9617:1: ( rule__XSwitchExpression__Group__4__Impl rule__XSwitchExpression__Group__5 )
            // InternalXbaseWithAnnotations.g:9618:2: rule__XSwitchExpression__Group__4__Impl rule__XSwitchExpression__Group__5
            {
            pushFollow(FOLLOW_62);
            rule__XSwitchExpression__Group__4__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group__5();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__4"


    // $ANTLR start "rule__XSwitchExpression__Group__4__Impl"
    // InternalXbaseWithAnnotations.g:9625:1: rule__XSwitchExpression__Group__4__Impl : ( ( rule__XSwitchExpression__CasesAssignment_4 )* ) ;
    public final void rule__XSwitchExpression__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9629:1: ( ( ( rule__XSwitchExpression__CasesAssignment_4 )* ) )
            // InternalXbaseWithAnnotations.g:9630:1: ( ( rule__XSwitchExpression__CasesAssignment_4 )* )
            {
            // InternalXbaseWithAnnotations.g:9630:1: ( ( rule__XSwitchExpression__CasesAssignment_4 )* )
            // InternalXbaseWithAnnotations.g:9631:2: ( rule__XSwitchExpression__CasesAssignment_4 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getCasesAssignment_4()); 
            }
            // InternalXbaseWithAnnotations.g:9632:2: ( rule__XSwitchExpression__CasesAssignment_4 )*
            loop84:
            do {
                int alt84=2;
                int LA84_0 = input.LA(1);

                if ( (LA84_0==RULE_ID||LA84_0==31||LA84_0==52||LA84_0==54||LA84_0==66||LA84_0==68) ) {
                    alt84=1;
                }


                switch (alt84) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:9632:3: rule__XSwitchExpression__CasesAssignment_4
            	    {
            	    pushFollow(FOLLOW_63);
            	    rule__XSwitchExpression__CasesAssignment_4();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop84;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getCasesAssignment_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__4__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group__5"
    // InternalXbaseWithAnnotations.g:9640:1: rule__XSwitchExpression__Group__5 : rule__XSwitchExpression__Group__5__Impl rule__XSwitchExpression__Group__6 ;
    public final void rule__XSwitchExpression__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9644:1: ( rule__XSwitchExpression__Group__5__Impl rule__XSwitchExpression__Group__6 )
            // InternalXbaseWithAnnotations.g:9645:2: rule__XSwitchExpression__Group__5__Impl rule__XSwitchExpression__Group__6
            {
            pushFollow(FOLLOW_62);
            rule__XSwitchExpression__Group__5__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group__6();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__5"


    // $ANTLR start "rule__XSwitchExpression__Group__5__Impl"
    // InternalXbaseWithAnnotations.g:9652:1: rule__XSwitchExpression__Group__5__Impl : ( ( rule__XSwitchExpression__Group_5__0 )? ) ;
    public final void rule__XSwitchExpression__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9656:1: ( ( ( rule__XSwitchExpression__Group_5__0 )? ) )
            // InternalXbaseWithAnnotations.g:9657:1: ( ( rule__XSwitchExpression__Group_5__0 )? )
            {
            // InternalXbaseWithAnnotations.g:9657:1: ( ( rule__XSwitchExpression__Group_5__0 )? )
            // InternalXbaseWithAnnotations.g:9658:2: ( rule__XSwitchExpression__Group_5__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getGroup_5()); 
            }
            // InternalXbaseWithAnnotations.g:9659:2: ( rule__XSwitchExpression__Group_5__0 )?
            int alt85=2;
            int LA85_0 = input.LA(1);

            if ( (LA85_0==67) ) {
                alt85=1;
            }
            switch (alt85) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:9659:3: rule__XSwitchExpression__Group_5__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XSwitchExpression__Group_5__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getGroup_5()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__5__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group__6"
    // InternalXbaseWithAnnotations.g:9667:1: rule__XSwitchExpression__Group__6 : rule__XSwitchExpression__Group__6__Impl ;
    public final void rule__XSwitchExpression__Group__6() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9671:1: ( rule__XSwitchExpression__Group__6__Impl )
            // InternalXbaseWithAnnotations.g:9672:2: rule__XSwitchExpression__Group__6__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group__6__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__6"


    // $ANTLR start "rule__XSwitchExpression__Group__6__Impl"
    // InternalXbaseWithAnnotations.g:9678:1: rule__XSwitchExpression__Group__6__Impl : ( '}' ) ;
    public final void rule__XSwitchExpression__Group__6__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9682:1: ( ( '}' ) )
            // InternalXbaseWithAnnotations.g:9683:1: ( '}' )
            {
            // InternalXbaseWithAnnotations.g:9683:1: ( '}' )
            // InternalXbaseWithAnnotations.g:9684:2: '}'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getRightCurlyBracketKeyword_6()); 
            }
            match(input,61,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getRightCurlyBracketKeyword_6()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group__6__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0__0"
    // InternalXbaseWithAnnotations.g:9694:1: rule__XSwitchExpression__Group_2_0__0 : rule__XSwitchExpression__Group_2_0__0__Impl rule__XSwitchExpression__Group_2_0__1 ;
    public final void rule__XSwitchExpression__Group_2_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9698:1: ( rule__XSwitchExpression__Group_2_0__0__Impl rule__XSwitchExpression__Group_2_0__1 )
            // InternalXbaseWithAnnotations.g:9699:2: rule__XSwitchExpression__Group_2_0__0__Impl rule__XSwitchExpression__Group_2_0__1
            {
            pushFollow(FOLLOW_10);
            rule__XSwitchExpression__Group_2_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0__0"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0__0__Impl"
    // InternalXbaseWithAnnotations.g:9706:1: rule__XSwitchExpression__Group_2_0__0__Impl : ( ( rule__XSwitchExpression__Group_2_0_0__0 ) ) ;
    public final void rule__XSwitchExpression__Group_2_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9710:1: ( ( ( rule__XSwitchExpression__Group_2_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:9711:1: ( ( rule__XSwitchExpression__Group_2_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:9711:1: ( ( rule__XSwitchExpression__Group_2_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:9712:2: ( rule__XSwitchExpression__Group_2_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getGroup_2_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:9713:2: ( rule__XSwitchExpression__Group_2_0_0__0 )
            // InternalXbaseWithAnnotations.g:9713:3: rule__XSwitchExpression__Group_2_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getGroup_2_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0__0__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0__1"
    // InternalXbaseWithAnnotations.g:9721:1: rule__XSwitchExpression__Group_2_0__1 : rule__XSwitchExpression__Group_2_0__1__Impl rule__XSwitchExpression__Group_2_0__2 ;
    public final void rule__XSwitchExpression__Group_2_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9725:1: ( rule__XSwitchExpression__Group_2_0__1__Impl rule__XSwitchExpression__Group_2_0__2 )
            // InternalXbaseWithAnnotations.g:9726:2: rule__XSwitchExpression__Group_2_0__1__Impl rule__XSwitchExpression__Group_2_0__2
            {
            pushFollow(FOLLOW_57);
            rule__XSwitchExpression__Group_2_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0__1"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0__1__Impl"
    // InternalXbaseWithAnnotations.g:9733:1: rule__XSwitchExpression__Group_2_0__1__Impl : ( ( rule__XSwitchExpression__SwitchAssignment_2_0_1 ) ) ;
    public final void rule__XSwitchExpression__Group_2_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9737:1: ( ( ( rule__XSwitchExpression__SwitchAssignment_2_0_1 ) ) )
            // InternalXbaseWithAnnotations.g:9738:1: ( ( rule__XSwitchExpression__SwitchAssignment_2_0_1 ) )
            {
            // InternalXbaseWithAnnotations.g:9738:1: ( ( rule__XSwitchExpression__SwitchAssignment_2_0_1 ) )
            // InternalXbaseWithAnnotations.g:9739:2: ( rule__XSwitchExpression__SwitchAssignment_2_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getSwitchAssignment_2_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:9740:2: ( rule__XSwitchExpression__SwitchAssignment_2_0_1 )
            // InternalXbaseWithAnnotations.g:9740:3: rule__XSwitchExpression__SwitchAssignment_2_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__SwitchAssignment_2_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getSwitchAssignment_2_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0__1__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0__2"
    // InternalXbaseWithAnnotations.g:9748:1: rule__XSwitchExpression__Group_2_0__2 : rule__XSwitchExpression__Group_2_0__2__Impl ;
    public final void rule__XSwitchExpression__Group_2_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9752:1: ( rule__XSwitchExpression__Group_2_0__2__Impl )
            // InternalXbaseWithAnnotations.g:9753:2: rule__XSwitchExpression__Group_2_0__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0__2"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0__2__Impl"
    // InternalXbaseWithAnnotations.g:9759:1: rule__XSwitchExpression__Group_2_0__2__Impl : ( ')' ) ;
    public final void rule__XSwitchExpression__Group_2_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9763:1: ( ( ')' ) )
            // InternalXbaseWithAnnotations.g:9764:1: ( ')' )
            {
            // InternalXbaseWithAnnotations.g:9764:1: ( ')' )
            // InternalXbaseWithAnnotations.g:9765:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getRightParenthesisKeyword_2_0_2()); 
            }
            match(input,53,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getRightParenthesisKeyword_2_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0__2__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0_0__0"
    // InternalXbaseWithAnnotations.g:9775:1: rule__XSwitchExpression__Group_2_0_0__0 : rule__XSwitchExpression__Group_2_0_0__0__Impl ;
    public final void rule__XSwitchExpression__Group_2_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9779:1: ( rule__XSwitchExpression__Group_2_0_0__0__Impl )
            // InternalXbaseWithAnnotations.g:9780:2: rule__XSwitchExpression__Group_2_0_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0_0__0"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:9786:1: rule__XSwitchExpression__Group_2_0_0__0__Impl : ( ( rule__XSwitchExpression__Group_2_0_0_0__0 ) ) ;
    public final void rule__XSwitchExpression__Group_2_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9790:1: ( ( ( rule__XSwitchExpression__Group_2_0_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:9791:1: ( ( rule__XSwitchExpression__Group_2_0_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:9791:1: ( ( rule__XSwitchExpression__Group_2_0_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:9792:2: ( rule__XSwitchExpression__Group_2_0_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getGroup_2_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:9793:2: ( rule__XSwitchExpression__Group_2_0_0_0__0 )
            // InternalXbaseWithAnnotations.g:9793:3: rule__XSwitchExpression__Group_2_0_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_0_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getGroup_2_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0_0__0__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0_0_0__0"
    // InternalXbaseWithAnnotations.g:9802:1: rule__XSwitchExpression__Group_2_0_0_0__0 : rule__XSwitchExpression__Group_2_0_0_0__0__Impl rule__XSwitchExpression__Group_2_0_0_0__1 ;
    public final void rule__XSwitchExpression__Group_2_0_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9806:1: ( rule__XSwitchExpression__Group_2_0_0_0__0__Impl rule__XSwitchExpression__Group_2_0_0_0__1 )
            // InternalXbaseWithAnnotations.g:9807:2: rule__XSwitchExpression__Group_2_0_0_0__0__Impl rule__XSwitchExpression__Group_2_0_0_0__1
            {
            pushFollow(FOLLOW_27);
            rule__XSwitchExpression__Group_2_0_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_0_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0_0_0__0"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:9814:1: rule__XSwitchExpression__Group_2_0_0_0__0__Impl : ( '(' ) ;
    public final void rule__XSwitchExpression__Group_2_0_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9818:1: ( ( '(' ) )
            // InternalXbaseWithAnnotations.g:9819:1: ( '(' )
            {
            // InternalXbaseWithAnnotations.g:9819:1: ( '(' )
            // InternalXbaseWithAnnotations.g:9820:2: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getLeftParenthesisKeyword_2_0_0_0_0()); 
            }
            match(input,52,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getLeftParenthesisKeyword_2_0_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0_0_0__0__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0_0_0__1"
    // InternalXbaseWithAnnotations.g:9829:1: rule__XSwitchExpression__Group_2_0_0_0__1 : rule__XSwitchExpression__Group_2_0_0_0__1__Impl rule__XSwitchExpression__Group_2_0_0_0__2 ;
    public final void rule__XSwitchExpression__Group_2_0_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9833:1: ( rule__XSwitchExpression__Group_2_0_0_0__1__Impl rule__XSwitchExpression__Group_2_0_0_0__2 )
            // InternalXbaseWithAnnotations.g:9834:2: rule__XSwitchExpression__Group_2_0_0_0__1__Impl rule__XSwitchExpression__Group_2_0_0_0__2
            {
            pushFollow(FOLLOW_64);
            rule__XSwitchExpression__Group_2_0_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_0_0_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0_0_0__1"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:9841:1: rule__XSwitchExpression__Group_2_0_0_0__1__Impl : ( ( rule__XSwitchExpression__DeclaredParamAssignment_2_0_0_0_1 ) ) ;
    public final void rule__XSwitchExpression__Group_2_0_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9845:1: ( ( ( rule__XSwitchExpression__DeclaredParamAssignment_2_0_0_0_1 ) ) )
            // InternalXbaseWithAnnotations.g:9846:1: ( ( rule__XSwitchExpression__DeclaredParamAssignment_2_0_0_0_1 ) )
            {
            // InternalXbaseWithAnnotations.g:9846:1: ( ( rule__XSwitchExpression__DeclaredParamAssignment_2_0_0_0_1 ) )
            // InternalXbaseWithAnnotations.g:9847:2: ( rule__XSwitchExpression__DeclaredParamAssignment_2_0_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getDeclaredParamAssignment_2_0_0_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:9848:2: ( rule__XSwitchExpression__DeclaredParamAssignment_2_0_0_0_1 )
            // InternalXbaseWithAnnotations.g:9848:3: rule__XSwitchExpression__DeclaredParamAssignment_2_0_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__DeclaredParamAssignment_2_0_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getDeclaredParamAssignment_2_0_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0_0_0__1__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0_0_0__2"
    // InternalXbaseWithAnnotations.g:9856:1: rule__XSwitchExpression__Group_2_0_0_0__2 : rule__XSwitchExpression__Group_2_0_0_0__2__Impl ;
    public final void rule__XSwitchExpression__Group_2_0_0_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9860:1: ( rule__XSwitchExpression__Group_2_0_0_0__2__Impl )
            // InternalXbaseWithAnnotations.g:9861:2: rule__XSwitchExpression__Group_2_0_0_0__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_0_0_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0_0_0__2"


    // $ANTLR start "rule__XSwitchExpression__Group_2_0_0_0__2__Impl"
    // InternalXbaseWithAnnotations.g:9867:1: rule__XSwitchExpression__Group_2_0_0_0__2__Impl : ( ':' ) ;
    public final void rule__XSwitchExpression__Group_2_0_0_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9871:1: ( ( ':' ) )
            // InternalXbaseWithAnnotations.g:9872:1: ( ':' )
            {
            // InternalXbaseWithAnnotations.g:9872:1: ( ':' )
            // InternalXbaseWithAnnotations.g:9873:2: ':'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getColonKeyword_2_0_0_0_2()); 
            }
            match(input,66,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getColonKeyword_2_0_0_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_0_0_0__2__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_2_1__0"
    // InternalXbaseWithAnnotations.g:9883:1: rule__XSwitchExpression__Group_2_1__0 : rule__XSwitchExpression__Group_2_1__0__Impl rule__XSwitchExpression__Group_2_1__1 ;
    public final void rule__XSwitchExpression__Group_2_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9887:1: ( rule__XSwitchExpression__Group_2_1__0__Impl rule__XSwitchExpression__Group_2_1__1 )
            // InternalXbaseWithAnnotations.g:9888:2: rule__XSwitchExpression__Group_2_1__0__Impl rule__XSwitchExpression__Group_2_1__1
            {
            pushFollow(FOLLOW_61);
            rule__XSwitchExpression__Group_2_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_1__0"


    // $ANTLR start "rule__XSwitchExpression__Group_2_1__0__Impl"
    // InternalXbaseWithAnnotations.g:9895:1: rule__XSwitchExpression__Group_2_1__0__Impl : ( ( rule__XSwitchExpression__Group_2_1_0__0 )? ) ;
    public final void rule__XSwitchExpression__Group_2_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9899:1: ( ( ( rule__XSwitchExpression__Group_2_1_0__0 )? ) )
            // InternalXbaseWithAnnotations.g:9900:1: ( ( rule__XSwitchExpression__Group_2_1_0__0 )? )
            {
            // InternalXbaseWithAnnotations.g:9900:1: ( ( rule__XSwitchExpression__Group_2_1_0__0 )? )
            // InternalXbaseWithAnnotations.g:9901:2: ( rule__XSwitchExpression__Group_2_1_0__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getGroup_2_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:9902:2: ( rule__XSwitchExpression__Group_2_1_0__0 )?
            int alt86=2;
            alt86 = dfa86.predict(input);
            switch (alt86) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:9902:3: rule__XSwitchExpression__Group_2_1_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XSwitchExpression__Group_2_1_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getGroup_2_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_1__0__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_2_1__1"
    // InternalXbaseWithAnnotations.g:9910:1: rule__XSwitchExpression__Group_2_1__1 : rule__XSwitchExpression__Group_2_1__1__Impl ;
    public final void rule__XSwitchExpression__Group_2_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9914:1: ( rule__XSwitchExpression__Group_2_1__1__Impl )
            // InternalXbaseWithAnnotations.g:9915:2: rule__XSwitchExpression__Group_2_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_1__1"


    // $ANTLR start "rule__XSwitchExpression__Group_2_1__1__Impl"
    // InternalXbaseWithAnnotations.g:9921:1: rule__XSwitchExpression__Group_2_1__1__Impl : ( ( rule__XSwitchExpression__SwitchAssignment_2_1_1 ) ) ;
    public final void rule__XSwitchExpression__Group_2_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9925:1: ( ( ( rule__XSwitchExpression__SwitchAssignment_2_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:9926:1: ( ( rule__XSwitchExpression__SwitchAssignment_2_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:9926:1: ( ( rule__XSwitchExpression__SwitchAssignment_2_1_1 ) )
            // InternalXbaseWithAnnotations.g:9927:2: ( rule__XSwitchExpression__SwitchAssignment_2_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getSwitchAssignment_2_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:9928:2: ( rule__XSwitchExpression__SwitchAssignment_2_1_1 )
            // InternalXbaseWithAnnotations.g:9928:3: rule__XSwitchExpression__SwitchAssignment_2_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__SwitchAssignment_2_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getSwitchAssignment_2_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_1__1__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_2_1_0__0"
    // InternalXbaseWithAnnotations.g:9937:1: rule__XSwitchExpression__Group_2_1_0__0 : rule__XSwitchExpression__Group_2_1_0__0__Impl ;
    public final void rule__XSwitchExpression__Group_2_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9941:1: ( rule__XSwitchExpression__Group_2_1_0__0__Impl )
            // InternalXbaseWithAnnotations.g:9942:2: rule__XSwitchExpression__Group_2_1_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_1_0__0"


    // $ANTLR start "rule__XSwitchExpression__Group_2_1_0__0__Impl"
    // InternalXbaseWithAnnotations.g:9948:1: rule__XSwitchExpression__Group_2_1_0__0__Impl : ( ( rule__XSwitchExpression__Group_2_1_0_0__0 ) ) ;
    public final void rule__XSwitchExpression__Group_2_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9952:1: ( ( ( rule__XSwitchExpression__Group_2_1_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:9953:1: ( ( rule__XSwitchExpression__Group_2_1_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:9953:1: ( ( rule__XSwitchExpression__Group_2_1_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:9954:2: ( rule__XSwitchExpression__Group_2_1_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getGroup_2_1_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:9955:2: ( rule__XSwitchExpression__Group_2_1_0_0__0 )
            // InternalXbaseWithAnnotations.g:9955:3: rule__XSwitchExpression__Group_2_1_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_1_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getGroup_2_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_1_0__0__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_2_1_0_0__0"
    // InternalXbaseWithAnnotations.g:9964:1: rule__XSwitchExpression__Group_2_1_0_0__0 : rule__XSwitchExpression__Group_2_1_0_0__0__Impl rule__XSwitchExpression__Group_2_1_0_0__1 ;
    public final void rule__XSwitchExpression__Group_2_1_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9968:1: ( rule__XSwitchExpression__Group_2_1_0_0__0__Impl rule__XSwitchExpression__Group_2_1_0_0__1 )
            // InternalXbaseWithAnnotations.g:9969:2: rule__XSwitchExpression__Group_2_1_0_0__0__Impl rule__XSwitchExpression__Group_2_1_0_0__1
            {
            pushFollow(FOLLOW_64);
            rule__XSwitchExpression__Group_2_1_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_1_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_1_0_0__0"


    // $ANTLR start "rule__XSwitchExpression__Group_2_1_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:9976:1: rule__XSwitchExpression__Group_2_1_0_0__0__Impl : ( ( rule__XSwitchExpression__DeclaredParamAssignment_2_1_0_0_0 ) ) ;
    public final void rule__XSwitchExpression__Group_2_1_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9980:1: ( ( ( rule__XSwitchExpression__DeclaredParamAssignment_2_1_0_0_0 ) ) )
            // InternalXbaseWithAnnotations.g:9981:1: ( ( rule__XSwitchExpression__DeclaredParamAssignment_2_1_0_0_0 ) )
            {
            // InternalXbaseWithAnnotations.g:9981:1: ( ( rule__XSwitchExpression__DeclaredParamAssignment_2_1_0_0_0 ) )
            // InternalXbaseWithAnnotations.g:9982:2: ( rule__XSwitchExpression__DeclaredParamAssignment_2_1_0_0_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getDeclaredParamAssignment_2_1_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:9983:2: ( rule__XSwitchExpression__DeclaredParamAssignment_2_1_0_0_0 )
            // InternalXbaseWithAnnotations.g:9983:3: rule__XSwitchExpression__DeclaredParamAssignment_2_1_0_0_0
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__DeclaredParamAssignment_2_1_0_0_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getDeclaredParamAssignment_2_1_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_1_0_0__0__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_2_1_0_0__1"
    // InternalXbaseWithAnnotations.g:9991:1: rule__XSwitchExpression__Group_2_1_0_0__1 : rule__XSwitchExpression__Group_2_1_0_0__1__Impl ;
    public final void rule__XSwitchExpression__Group_2_1_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:9995:1: ( rule__XSwitchExpression__Group_2_1_0_0__1__Impl )
            // InternalXbaseWithAnnotations.g:9996:2: rule__XSwitchExpression__Group_2_1_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_2_1_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_1_0_0__1"


    // $ANTLR start "rule__XSwitchExpression__Group_2_1_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:10002:1: rule__XSwitchExpression__Group_2_1_0_0__1__Impl : ( ':' ) ;
    public final void rule__XSwitchExpression__Group_2_1_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10006:1: ( ( ':' ) )
            // InternalXbaseWithAnnotations.g:10007:1: ( ':' )
            {
            // InternalXbaseWithAnnotations.g:10007:1: ( ':' )
            // InternalXbaseWithAnnotations.g:10008:2: ':'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getColonKeyword_2_1_0_0_1()); 
            }
            match(input,66,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getColonKeyword_2_1_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_2_1_0_0__1__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_5__0"
    // InternalXbaseWithAnnotations.g:10018:1: rule__XSwitchExpression__Group_5__0 : rule__XSwitchExpression__Group_5__0__Impl rule__XSwitchExpression__Group_5__1 ;
    public final void rule__XSwitchExpression__Group_5__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10022:1: ( rule__XSwitchExpression__Group_5__0__Impl rule__XSwitchExpression__Group_5__1 )
            // InternalXbaseWithAnnotations.g:10023:2: rule__XSwitchExpression__Group_5__0__Impl rule__XSwitchExpression__Group_5__1
            {
            pushFollow(FOLLOW_64);
            rule__XSwitchExpression__Group_5__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_5__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_5__0"


    // $ANTLR start "rule__XSwitchExpression__Group_5__0__Impl"
    // InternalXbaseWithAnnotations.g:10030:1: rule__XSwitchExpression__Group_5__0__Impl : ( 'default' ) ;
    public final void rule__XSwitchExpression__Group_5__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10034:1: ( ( 'default' ) )
            // InternalXbaseWithAnnotations.g:10035:1: ( 'default' )
            {
            // InternalXbaseWithAnnotations.g:10035:1: ( 'default' )
            // InternalXbaseWithAnnotations.g:10036:2: 'default'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getDefaultKeyword_5_0()); 
            }
            match(input,67,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getDefaultKeyword_5_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_5__0__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_5__1"
    // InternalXbaseWithAnnotations.g:10045:1: rule__XSwitchExpression__Group_5__1 : rule__XSwitchExpression__Group_5__1__Impl rule__XSwitchExpression__Group_5__2 ;
    public final void rule__XSwitchExpression__Group_5__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10049:1: ( rule__XSwitchExpression__Group_5__1__Impl rule__XSwitchExpression__Group_5__2 )
            // InternalXbaseWithAnnotations.g:10050:2: rule__XSwitchExpression__Group_5__1__Impl rule__XSwitchExpression__Group_5__2
            {
            pushFollow(FOLLOW_10);
            rule__XSwitchExpression__Group_5__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_5__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_5__1"


    // $ANTLR start "rule__XSwitchExpression__Group_5__1__Impl"
    // InternalXbaseWithAnnotations.g:10057:1: rule__XSwitchExpression__Group_5__1__Impl : ( ':' ) ;
    public final void rule__XSwitchExpression__Group_5__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10061:1: ( ( ':' ) )
            // InternalXbaseWithAnnotations.g:10062:1: ( ':' )
            {
            // InternalXbaseWithAnnotations.g:10062:1: ( ':' )
            // InternalXbaseWithAnnotations.g:10063:2: ':'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getColonKeyword_5_1()); 
            }
            match(input,66,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getColonKeyword_5_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_5__1__Impl"


    // $ANTLR start "rule__XSwitchExpression__Group_5__2"
    // InternalXbaseWithAnnotations.g:10072:1: rule__XSwitchExpression__Group_5__2 : rule__XSwitchExpression__Group_5__2__Impl ;
    public final void rule__XSwitchExpression__Group_5__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10076:1: ( rule__XSwitchExpression__Group_5__2__Impl )
            // InternalXbaseWithAnnotations.g:10077:2: rule__XSwitchExpression__Group_5__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__Group_5__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_5__2"


    // $ANTLR start "rule__XSwitchExpression__Group_5__2__Impl"
    // InternalXbaseWithAnnotations.g:10083:1: rule__XSwitchExpression__Group_5__2__Impl : ( ( rule__XSwitchExpression__DefaultAssignment_5_2 ) ) ;
    public final void rule__XSwitchExpression__Group_5__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10087:1: ( ( ( rule__XSwitchExpression__DefaultAssignment_5_2 ) ) )
            // InternalXbaseWithAnnotations.g:10088:1: ( ( rule__XSwitchExpression__DefaultAssignment_5_2 ) )
            {
            // InternalXbaseWithAnnotations.g:10088:1: ( ( rule__XSwitchExpression__DefaultAssignment_5_2 ) )
            // InternalXbaseWithAnnotations.g:10089:2: ( rule__XSwitchExpression__DefaultAssignment_5_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getDefaultAssignment_5_2()); 
            }
            // InternalXbaseWithAnnotations.g:10090:2: ( rule__XSwitchExpression__DefaultAssignment_5_2 )
            // InternalXbaseWithAnnotations.g:10090:3: rule__XSwitchExpression__DefaultAssignment_5_2
            {
            pushFollow(FOLLOW_2);
            rule__XSwitchExpression__DefaultAssignment_5_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getDefaultAssignment_5_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__Group_5__2__Impl"


    // $ANTLR start "rule__XCasePart__Group__0"
    // InternalXbaseWithAnnotations.g:10099:1: rule__XCasePart__Group__0 : rule__XCasePart__Group__0__Impl rule__XCasePart__Group__1 ;
    public final void rule__XCasePart__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10103:1: ( rule__XCasePart__Group__0__Impl rule__XCasePart__Group__1 )
            // InternalXbaseWithAnnotations.g:10104:2: rule__XCasePart__Group__0__Impl rule__XCasePart__Group__1
            {
            pushFollow(FOLLOW_65);
            rule__XCasePart__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XCasePart__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group__0"


    // $ANTLR start "rule__XCasePart__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:10111:1: rule__XCasePart__Group__0__Impl : ( () ) ;
    public final void rule__XCasePart__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10115:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:10116:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:10116:1: ( () )
            // InternalXbaseWithAnnotations.g:10117:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getXCasePartAction_0()); 
            }
            // InternalXbaseWithAnnotations.g:10118:2: ()
            // InternalXbaseWithAnnotations.g:10118:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getXCasePartAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group__0__Impl"


    // $ANTLR start "rule__XCasePart__Group__1"
    // InternalXbaseWithAnnotations.g:10126:1: rule__XCasePart__Group__1 : rule__XCasePart__Group__1__Impl rule__XCasePart__Group__2 ;
    public final void rule__XCasePart__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10130:1: ( rule__XCasePart__Group__1__Impl rule__XCasePart__Group__2 )
            // InternalXbaseWithAnnotations.g:10131:2: rule__XCasePart__Group__1__Impl rule__XCasePart__Group__2
            {
            pushFollow(FOLLOW_65);
            rule__XCasePart__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XCasePart__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group__1"


    // $ANTLR start "rule__XCasePart__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:10138:1: rule__XCasePart__Group__1__Impl : ( ( rule__XCasePart__TypeGuardAssignment_1 )? ) ;
    public final void rule__XCasePart__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10142:1: ( ( ( rule__XCasePart__TypeGuardAssignment_1 )? ) )
            // InternalXbaseWithAnnotations.g:10143:1: ( ( rule__XCasePart__TypeGuardAssignment_1 )? )
            {
            // InternalXbaseWithAnnotations.g:10143:1: ( ( rule__XCasePart__TypeGuardAssignment_1 )? )
            // InternalXbaseWithAnnotations.g:10144:2: ( rule__XCasePart__TypeGuardAssignment_1 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getTypeGuardAssignment_1()); 
            }
            // InternalXbaseWithAnnotations.g:10145:2: ( rule__XCasePart__TypeGuardAssignment_1 )?
            int alt87=2;
            int LA87_0 = input.LA(1);

            if ( (LA87_0==RULE_ID||LA87_0==31||LA87_0==52) ) {
                alt87=1;
            }
            switch (alt87) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:10145:3: rule__XCasePart__TypeGuardAssignment_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XCasePart__TypeGuardAssignment_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getTypeGuardAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group__1__Impl"


    // $ANTLR start "rule__XCasePart__Group__2"
    // InternalXbaseWithAnnotations.g:10153:1: rule__XCasePart__Group__2 : rule__XCasePart__Group__2__Impl rule__XCasePart__Group__3 ;
    public final void rule__XCasePart__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10157:1: ( rule__XCasePart__Group__2__Impl rule__XCasePart__Group__3 )
            // InternalXbaseWithAnnotations.g:10158:2: rule__XCasePart__Group__2__Impl rule__XCasePart__Group__3
            {
            pushFollow(FOLLOW_65);
            rule__XCasePart__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XCasePart__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group__2"


    // $ANTLR start "rule__XCasePart__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:10165:1: rule__XCasePart__Group__2__Impl : ( ( rule__XCasePart__Group_2__0 )? ) ;
    public final void rule__XCasePart__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10169:1: ( ( ( rule__XCasePart__Group_2__0 )? ) )
            // InternalXbaseWithAnnotations.g:10170:1: ( ( rule__XCasePart__Group_2__0 )? )
            {
            // InternalXbaseWithAnnotations.g:10170:1: ( ( rule__XCasePart__Group_2__0 )? )
            // InternalXbaseWithAnnotations.g:10171:2: ( rule__XCasePart__Group_2__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getGroup_2()); 
            }
            // InternalXbaseWithAnnotations.g:10172:2: ( rule__XCasePart__Group_2__0 )?
            int alt88=2;
            int LA88_0 = input.LA(1);

            if ( (LA88_0==68) ) {
                alt88=1;
            }
            switch (alt88) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:10172:3: rule__XCasePart__Group_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XCasePart__Group_2__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getGroup_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group__2__Impl"


    // $ANTLR start "rule__XCasePart__Group__3"
    // InternalXbaseWithAnnotations.g:10180:1: rule__XCasePart__Group__3 : rule__XCasePart__Group__3__Impl ;
    public final void rule__XCasePart__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10184:1: ( rule__XCasePart__Group__3__Impl )
            // InternalXbaseWithAnnotations.g:10185:2: rule__XCasePart__Group__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XCasePart__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group__3"


    // $ANTLR start "rule__XCasePart__Group__3__Impl"
    // InternalXbaseWithAnnotations.g:10191:1: rule__XCasePart__Group__3__Impl : ( ( rule__XCasePart__Alternatives_3 ) ) ;
    public final void rule__XCasePart__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10195:1: ( ( ( rule__XCasePart__Alternatives_3 ) ) )
            // InternalXbaseWithAnnotations.g:10196:1: ( ( rule__XCasePart__Alternatives_3 ) )
            {
            // InternalXbaseWithAnnotations.g:10196:1: ( ( rule__XCasePart__Alternatives_3 ) )
            // InternalXbaseWithAnnotations.g:10197:2: ( rule__XCasePart__Alternatives_3 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getAlternatives_3()); 
            }
            // InternalXbaseWithAnnotations.g:10198:2: ( rule__XCasePart__Alternatives_3 )
            // InternalXbaseWithAnnotations.g:10198:3: rule__XCasePart__Alternatives_3
            {
            pushFollow(FOLLOW_2);
            rule__XCasePart__Alternatives_3();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getAlternatives_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group__3__Impl"


    // $ANTLR start "rule__XCasePart__Group_2__0"
    // InternalXbaseWithAnnotations.g:10207:1: rule__XCasePart__Group_2__0 : rule__XCasePart__Group_2__0__Impl rule__XCasePart__Group_2__1 ;
    public final void rule__XCasePart__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10211:1: ( rule__XCasePart__Group_2__0__Impl rule__XCasePart__Group_2__1 )
            // InternalXbaseWithAnnotations.g:10212:2: rule__XCasePart__Group_2__0__Impl rule__XCasePart__Group_2__1
            {
            pushFollow(FOLLOW_10);
            rule__XCasePart__Group_2__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XCasePart__Group_2__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group_2__0"


    // $ANTLR start "rule__XCasePart__Group_2__0__Impl"
    // InternalXbaseWithAnnotations.g:10219:1: rule__XCasePart__Group_2__0__Impl : ( 'case' ) ;
    public final void rule__XCasePart__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10223:1: ( ( 'case' ) )
            // InternalXbaseWithAnnotations.g:10224:1: ( 'case' )
            {
            // InternalXbaseWithAnnotations.g:10224:1: ( 'case' )
            // InternalXbaseWithAnnotations.g:10225:2: 'case'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getCaseKeyword_2_0()); 
            }
            match(input,68,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getCaseKeyword_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group_2__0__Impl"


    // $ANTLR start "rule__XCasePart__Group_2__1"
    // InternalXbaseWithAnnotations.g:10234:1: rule__XCasePart__Group_2__1 : rule__XCasePart__Group_2__1__Impl ;
    public final void rule__XCasePart__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10238:1: ( rule__XCasePart__Group_2__1__Impl )
            // InternalXbaseWithAnnotations.g:10239:2: rule__XCasePart__Group_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XCasePart__Group_2__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group_2__1"


    // $ANTLR start "rule__XCasePart__Group_2__1__Impl"
    // InternalXbaseWithAnnotations.g:10245:1: rule__XCasePart__Group_2__1__Impl : ( ( rule__XCasePart__CaseAssignment_2_1 ) ) ;
    public final void rule__XCasePart__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10249:1: ( ( ( rule__XCasePart__CaseAssignment_2_1 ) ) )
            // InternalXbaseWithAnnotations.g:10250:1: ( ( rule__XCasePart__CaseAssignment_2_1 ) )
            {
            // InternalXbaseWithAnnotations.g:10250:1: ( ( rule__XCasePart__CaseAssignment_2_1 ) )
            // InternalXbaseWithAnnotations.g:10251:2: ( rule__XCasePart__CaseAssignment_2_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getCaseAssignment_2_1()); 
            }
            // InternalXbaseWithAnnotations.g:10252:2: ( rule__XCasePart__CaseAssignment_2_1 )
            // InternalXbaseWithAnnotations.g:10252:3: rule__XCasePart__CaseAssignment_2_1
            {
            pushFollow(FOLLOW_2);
            rule__XCasePart__CaseAssignment_2_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getCaseAssignment_2_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group_2__1__Impl"


    // $ANTLR start "rule__XCasePart__Group_3_0__0"
    // InternalXbaseWithAnnotations.g:10261:1: rule__XCasePart__Group_3_0__0 : rule__XCasePart__Group_3_0__0__Impl rule__XCasePart__Group_3_0__1 ;
    public final void rule__XCasePart__Group_3_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10265:1: ( rule__XCasePart__Group_3_0__0__Impl rule__XCasePart__Group_3_0__1 )
            // InternalXbaseWithAnnotations.g:10266:2: rule__XCasePart__Group_3_0__0__Impl rule__XCasePart__Group_3_0__1
            {
            pushFollow(FOLLOW_10);
            rule__XCasePart__Group_3_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XCasePart__Group_3_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group_3_0__0"


    // $ANTLR start "rule__XCasePart__Group_3_0__0__Impl"
    // InternalXbaseWithAnnotations.g:10273:1: rule__XCasePart__Group_3_0__0__Impl : ( ':' ) ;
    public final void rule__XCasePart__Group_3_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10277:1: ( ( ':' ) )
            // InternalXbaseWithAnnotations.g:10278:1: ( ':' )
            {
            // InternalXbaseWithAnnotations.g:10278:1: ( ':' )
            // InternalXbaseWithAnnotations.g:10279:2: ':'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getColonKeyword_3_0_0()); 
            }
            match(input,66,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getColonKeyword_3_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group_3_0__0__Impl"


    // $ANTLR start "rule__XCasePart__Group_3_0__1"
    // InternalXbaseWithAnnotations.g:10288:1: rule__XCasePart__Group_3_0__1 : rule__XCasePart__Group_3_0__1__Impl ;
    public final void rule__XCasePart__Group_3_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10292:1: ( rule__XCasePart__Group_3_0__1__Impl )
            // InternalXbaseWithAnnotations.g:10293:2: rule__XCasePart__Group_3_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XCasePart__Group_3_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group_3_0__1"


    // $ANTLR start "rule__XCasePart__Group_3_0__1__Impl"
    // InternalXbaseWithAnnotations.g:10299:1: rule__XCasePart__Group_3_0__1__Impl : ( ( rule__XCasePart__ThenAssignment_3_0_1 ) ) ;
    public final void rule__XCasePart__Group_3_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10303:1: ( ( ( rule__XCasePart__ThenAssignment_3_0_1 ) ) )
            // InternalXbaseWithAnnotations.g:10304:1: ( ( rule__XCasePart__ThenAssignment_3_0_1 ) )
            {
            // InternalXbaseWithAnnotations.g:10304:1: ( ( rule__XCasePart__ThenAssignment_3_0_1 ) )
            // InternalXbaseWithAnnotations.g:10305:2: ( rule__XCasePart__ThenAssignment_3_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getThenAssignment_3_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:10306:2: ( rule__XCasePart__ThenAssignment_3_0_1 )
            // InternalXbaseWithAnnotations.g:10306:3: rule__XCasePart__ThenAssignment_3_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XCasePart__ThenAssignment_3_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getThenAssignment_3_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__Group_3_0__1__Impl"


    // $ANTLR start "rule__XForLoopExpression__Group__0"
    // InternalXbaseWithAnnotations.g:10315:1: rule__XForLoopExpression__Group__0 : rule__XForLoopExpression__Group__0__Impl rule__XForLoopExpression__Group__1 ;
    public final void rule__XForLoopExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10319:1: ( rule__XForLoopExpression__Group__0__Impl rule__XForLoopExpression__Group__1 )
            // InternalXbaseWithAnnotations.g:10320:2: rule__XForLoopExpression__Group__0__Impl rule__XForLoopExpression__Group__1
            {
            pushFollow(FOLLOW_10);
            rule__XForLoopExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group__0"


    // $ANTLR start "rule__XForLoopExpression__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:10327:1: rule__XForLoopExpression__Group__0__Impl : ( ( rule__XForLoopExpression__Group_0__0 ) ) ;
    public final void rule__XForLoopExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10331:1: ( ( ( rule__XForLoopExpression__Group_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:10332:1: ( ( rule__XForLoopExpression__Group_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:10332:1: ( ( rule__XForLoopExpression__Group_0__0 ) )
            // InternalXbaseWithAnnotations.g:10333:2: ( rule__XForLoopExpression__Group_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getGroup_0()); 
            }
            // InternalXbaseWithAnnotations.g:10334:2: ( rule__XForLoopExpression__Group_0__0 )
            // InternalXbaseWithAnnotations.g:10334:3: rule__XForLoopExpression__Group_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getGroup_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group__0__Impl"


    // $ANTLR start "rule__XForLoopExpression__Group__1"
    // InternalXbaseWithAnnotations.g:10342:1: rule__XForLoopExpression__Group__1 : rule__XForLoopExpression__Group__1__Impl rule__XForLoopExpression__Group__2 ;
    public final void rule__XForLoopExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10346:1: ( rule__XForLoopExpression__Group__1__Impl rule__XForLoopExpression__Group__2 )
            // InternalXbaseWithAnnotations.g:10347:2: rule__XForLoopExpression__Group__1__Impl rule__XForLoopExpression__Group__2
            {
            pushFollow(FOLLOW_57);
            rule__XForLoopExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group__1"


    // $ANTLR start "rule__XForLoopExpression__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:10354:1: rule__XForLoopExpression__Group__1__Impl : ( ( rule__XForLoopExpression__ForExpressionAssignment_1 ) ) ;
    public final void rule__XForLoopExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10358:1: ( ( ( rule__XForLoopExpression__ForExpressionAssignment_1 ) ) )
            // InternalXbaseWithAnnotations.g:10359:1: ( ( rule__XForLoopExpression__ForExpressionAssignment_1 ) )
            {
            // InternalXbaseWithAnnotations.g:10359:1: ( ( rule__XForLoopExpression__ForExpressionAssignment_1 ) )
            // InternalXbaseWithAnnotations.g:10360:2: ( rule__XForLoopExpression__ForExpressionAssignment_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getForExpressionAssignment_1()); 
            }
            // InternalXbaseWithAnnotations.g:10361:2: ( rule__XForLoopExpression__ForExpressionAssignment_1 )
            // InternalXbaseWithAnnotations.g:10361:3: rule__XForLoopExpression__ForExpressionAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__ForExpressionAssignment_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getForExpressionAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group__1__Impl"


    // $ANTLR start "rule__XForLoopExpression__Group__2"
    // InternalXbaseWithAnnotations.g:10369:1: rule__XForLoopExpression__Group__2 : rule__XForLoopExpression__Group__2__Impl rule__XForLoopExpression__Group__3 ;
    public final void rule__XForLoopExpression__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10373:1: ( rule__XForLoopExpression__Group__2__Impl rule__XForLoopExpression__Group__3 )
            // InternalXbaseWithAnnotations.g:10374:2: rule__XForLoopExpression__Group__2__Impl rule__XForLoopExpression__Group__3
            {
            pushFollow(FOLLOW_10);
            rule__XForLoopExpression__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group__2"


    // $ANTLR start "rule__XForLoopExpression__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:10381:1: rule__XForLoopExpression__Group__2__Impl : ( ')' ) ;
    public final void rule__XForLoopExpression__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10385:1: ( ( ')' ) )
            // InternalXbaseWithAnnotations.g:10386:1: ( ')' )
            {
            // InternalXbaseWithAnnotations.g:10386:1: ( ')' )
            // InternalXbaseWithAnnotations.g:10387:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getRightParenthesisKeyword_2()); 
            }
            match(input,53,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getRightParenthesisKeyword_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group__2__Impl"


    // $ANTLR start "rule__XForLoopExpression__Group__3"
    // InternalXbaseWithAnnotations.g:10396:1: rule__XForLoopExpression__Group__3 : rule__XForLoopExpression__Group__3__Impl ;
    public final void rule__XForLoopExpression__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10400:1: ( rule__XForLoopExpression__Group__3__Impl )
            // InternalXbaseWithAnnotations.g:10401:2: rule__XForLoopExpression__Group__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group__3"


    // $ANTLR start "rule__XForLoopExpression__Group__3__Impl"
    // InternalXbaseWithAnnotations.g:10407:1: rule__XForLoopExpression__Group__3__Impl : ( ( rule__XForLoopExpression__EachExpressionAssignment_3 ) ) ;
    public final void rule__XForLoopExpression__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10411:1: ( ( ( rule__XForLoopExpression__EachExpressionAssignment_3 ) ) )
            // InternalXbaseWithAnnotations.g:10412:1: ( ( rule__XForLoopExpression__EachExpressionAssignment_3 ) )
            {
            // InternalXbaseWithAnnotations.g:10412:1: ( ( rule__XForLoopExpression__EachExpressionAssignment_3 ) )
            // InternalXbaseWithAnnotations.g:10413:2: ( rule__XForLoopExpression__EachExpressionAssignment_3 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getEachExpressionAssignment_3()); 
            }
            // InternalXbaseWithAnnotations.g:10414:2: ( rule__XForLoopExpression__EachExpressionAssignment_3 )
            // InternalXbaseWithAnnotations.g:10414:3: rule__XForLoopExpression__EachExpressionAssignment_3
            {
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__EachExpressionAssignment_3();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getEachExpressionAssignment_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group__3__Impl"


    // $ANTLR start "rule__XForLoopExpression__Group_0__0"
    // InternalXbaseWithAnnotations.g:10423:1: rule__XForLoopExpression__Group_0__0 : rule__XForLoopExpression__Group_0__0__Impl ;
    public final void rule__XForLoopExpression__Group_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10427:1: ( rule__XForLoopExpression__Group_0__0__Impl )
            // InternalXbaseWithAnnotations.g:10428:2: rule__XForLoopExpression__Group_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group_0__0"


    // $ANTLR start "rule__XForLoopExpression__Group_0__0__Impl"
    // InternalXbaseWithAnnotations.g:10434:1: rule__XForLoopExpression__Group_0__0__Impl : ( ( rule__XForLoopExpression__Group_0_0__0 ) ) ;
    public final void rule__XForLoopExpression__Group_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10438:1: ( ( ( rule__XForLoopExpression__Group_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:10439:1: ( ( rule__XForLoopExpression__Group_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:10439:1: ( ( rule__XForLoopExpression__Group_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:10440:2: ( rule__XForLoopExpression__Group_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getGroup_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:10441:2: ( rule__XForLoopExpression__Group_0_0__0 )
            // InternalXbaseWithAnnotations.g:10441:3: rule__XForLoopExpression__Group_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getGroup_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group_0__0__Impl"


    // $ANTLR start "rule__XForLoopExpression__Group_0_0__0"
    // InternalXbaseWithAnnotations.g:10450:1: rule__XForLoopExpression__Group_0_0__0 : rule__XForLoopExpression__Group_0_0__0__Impl rule__XForLoopExpression__Group_0_0__1 ;
    public final void rule__XForLoopExpression__Group_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10454:1: ( rule__XForLoopExpression__Group_0_0__0__Impl rule__XForLoopExpression__Group_0_0__1 )
            // InternalXbaseWithAnnotations.g:10455:2: rule__XForLoopExpression__Group_0_0__0__Impl rule__XForLoopExpression__Group_0_0__1
            {
            pushFollow(FOLLOW_66);
            rule__XForLoopExpression__Group_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group_0_0__0"


    // $ANTLR start "rule__XForLoopExpression__Group_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:10462:1: rule__XForLoopExpression__Group_0_0__0__Impl : ( () ) ;
    public final void rule__XForLoopExpression__Group_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10466:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:10467:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:10467:1: ( () )
            // InternalXbaseWithAnnotations.g:10468:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getXForLoopExpressionAction_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:10469:2: ()
            // InternalXbaseWithAnnotations.g:10469:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getXForLoopExpressionAction_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group_0_0__0__Impl"


    // $ANTLR start "rule__XForLoopExpression__Group_0_0__1"
    // InternalXbaseWithAnnotations.g:10477:1: rule__XForLoopExpression__Group_0_0__1 : rule__XForLoopExpression__Group_0_0__1__Impl rule__XForLoopExpression__Group_0_0__2 ;
    public final void rule__XForLoopExpression__Group_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10481:1: ( rule__XForLoopExpression__Group_0_0__1__Impl rule__XForLoopExpression__Group_0_0__2 )
            // InternalXbaseWithAnnotations.g:10482:2: rule__XForLoopExpression__Group_0_0__1__Impl rule__XForLoopExpression__Group_0_0__2
            {
            pushFollow(FOLLOW_6);
            rule__XForLoopExpression__Group_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group_0_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group_0_0__1"


    // $ANTLR start "rule__XForLoopExpression__Group_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:10489:1: rule__XForLoopExpression__Group_0_0__1__Impl : ( 'for' ) ;
    public final void rule__XForLoopExpression__Group_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10493:1: ( ( 'for' ) )
            // InternalXbaseWithAnnotations.g:10494:1: ( 'for' )
            {
            // InternalXbaseWithAnnotations.g:10494:1: ( 'for' )
            // InternalXbaseWithAnnotations.g:10495:2: 'for'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getForKeyword_0_0_1()); 
            }
            match(input,69,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getForKeyword_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group_0_0__1__Impl"


    // $ANTLR start "rule__XForLoopExpression__Group_0_0__2"
    // InternalXbaseWithAnnotations.g:10504:1: rule__XForLoopExpression__Group_0_0__2 : rule__XForLoopExpression__Group_0_0__2__Impl rule__XForLoopExpression__Group_0_0__3 ;
    public final void rule__XForLoopExpression__Group_0_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10508:1: ( rule__XForLoopExpression__Group_0_0__2__Impl rule__XForLoopExpression__Group_0_0__3 )
            // InternalXbaseWithAnnotations.g:10509:2: rule__XForLoopExpression__Group_0_0__2__Impl rule__XForLoopExpression__Group_0_0__3
            {
            pushFollow(FOLLOW_27);
            rule__XForLoopExpression__Group_0_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group_0_0__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group_0_0__2"


    // $ANTLR start "rule__XForLoopExpression__Group_0_0__2__Impl"
    // InternalXbaseWithAnnotations.g:10516:1: rule__XForLoopExpression__Group_0_0__2__Impl : ( '(' ) ;
    public final void rule__XForLoopExpression__Group_0_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10520:1: ( ( '(' ) )
            // InternalXbaseWithAnnotations.g:10521:1: ( '(' )
            {
            // InternalXbaseWithAnnotations.g:10521:1: ( '(' )
            // InternalXbaseWithAnnotations.g:10522:2: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getLeftParenthesisKeyword_0_0_2()); 
            }
            match(input,52,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getLeftParenthesisKeyword_0_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group_0_0__2__Impl"


    // $ANTLR start "rule__XForLoopExpression__Group_0_0__3"
    // InternalXbaseWithAnnotations.g:10531:1: rule__XForLoopExpression__Group_0_0__3 : rule__XForLoopExpression__Group_0_0__3__Impl rule__XForLoopExpression__Group_0_0__4 ;
    public final void rule__XForLoopExpression__Group_0_0__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10535:1: ( rule__XForLoopExpression__Group_0_0__3__Impl rule__XForLoopExpression__Group_0_0__4 )
            // InternalXbaseWithAnnotations.g:10536:2: rule__XForLoopExpression__Group_0_0__3__Impl rule__XForLoopExpression__Group_0_0__4
            {
            pushFollow(FOLLOW_64);
            rule__XForLoopExpression__Group_0_0__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group_0_0__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group_0_0__3"


    // $ANTLR start "rule__XForLoopExpression__Group_0_0__3__Impl"
    // InternalXbaseWithAnnotations.g:10543:1: rule__XForLoopExpression__Group_0_0__3__Impl : ( ( rule__XForLoopExpression__DeclaredParamAssignment_0_0_3 ) ) ;
    public final void rule__XForLoopExpression__Group_0_0__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10547:1: ( ( ( rule__XForLoopExpression__DeclaredParamAssignment_0_0_3 ) ) )
            // InternalXbaseWithAnnotations.g:10548:1: ( ( rule__XForLoopExpression__DeclaredParamAssignment_0_0_3 ) )
            {
            // InternalXbaseWithAnnotations.g:10548:1: ( ( rule__XForLoopExpression__DeclaredParamAssignment_0_0_3 ) )
            // InternalXbaseWithAnnotations.g:10549:2: ( rule__XForLoopExpression__DeclaredParamAssignment_0_0_3 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getDeclaredParamAssignment_0_0_3()); 
            }
            // InternalXbaseWithAnnotations.g:10550:2: ( rule__XForLoopExpression__DeclaredParamAssignment_0_0_3 )
            // InternalXbaseWithAnnotations.g:10550:3: rule__XForLoopExpression__DeclaredParamAssignment_0_0_3
            {
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__DeclaredParamAssignment_0_0_3();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getDeclaredParamAssignment_0_0_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group_0_0__3__Impl"


    // $ANTLR start "rule__XForLoopExpression__Group_0_0__4"
    // InternalXbaseWithAnnotations.g:10558:1: rule__XForLoopExpression__Group_0_0__4 : rule__XForLoopExpression__Group_0_0__4__Impl ;
    public final void rule__XForLoopExpression__Group_0_0__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10562:1: ( rule__XForLoopExpression__Group_0_0__4__Impl )
            // InternalXbaseWithAnnotations.g:10563:2: rule__XForLoopExpression__Group_0_0__4__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XForLoopExpression__Group_0_0__4__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group_0_0__4"


    // $ANTLR start "rule__XForLoopExpression__Group_0_0__4__Impl"
    // InternalXbaseWithAnnotations.g:10569:1: rule__XForLoopExpression__Group_0_0__4__Impl : ( ':' ) ;
    public final void rule__XForLoopExpression__Group_0_0__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10573:1: ( ( ':' ) )
            // InternalXbaseWithAnnotations.g:10574:1: ( ':' )
            {
            // InternalXbaseWithAnnotations.g:10574:1: ( ':' )
            // InternalXbaseWithAnnotations.g:10575:2: ':'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getColonKeyword_0_0_4()); 
            }
            match(input,66,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getColonKeyword_0_0_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__Group_0_0__4__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__0"
    // InternalXbaseWithAnnotations.g:10585:1: rule__XBasicForLoopExpression__Group__0 : rule__XBasicForLoopExpression__Group__0__Impl rule__XBasicForLoopExpression__Group__1 ;
    public final void rule__XBasicForLoopExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10589:1: ( rule__XBasicForLoopExpression__Group__0__Impl rule__XBasicForLoopExpression__Group__1 )
            // InternalXbaseWithAnnotations.g:10590:2: rule__XBasicForLoopExpression__Group__0__Impl rule__XBasicForLoopExpression__Group__1
            {
            pushFollow(FOLLOW_66);
            rule__XBasicForLoopExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__0"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:10597:1: rule__XBasicForLoopExpression__Group__0__Impl : ( () ) ;
    public final void rule__XBasicForLoopExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10601:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:10602:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:10602:1: ( () )
            // InternalXbaseWithAnnotations.g:10603:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getXBasicForLoopExpressionAction_0()); 
            }
            // InternalXbaseWithAnnotations.g:10604:2: ()
            // InternalXbaseWithAnnotations.g:10604:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getXBasicForLoopExpressionAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__0__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__1"
    // InternalXbaseWithAnnotations.g:10612:1: rule__XBasicForLoopExpression__Group__1 : rule__XBasicForLoopExpression__Group__1__Impl rule__XBasicForLoopExpression__Group__2 ;
    public final void rule__XBasicForLoopExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10616:1: ( rule__XBasicForLoopExpression__Group__1__Impl rule__XBasicForLoopExpression__Group__2 )
            // InternalXbaseWithAnnotations.g:10617:2: rule__XBasicForLoopExpression__Group__1__Impl rule__XBasicForLoopExpression__Group__2
            {
            pushFollow(FOLLOW_6);
            rule__XBasicForLoopExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__1"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:10624:1: rule__XBasicForLoopExpression__Group__1__Impl : ( 'for' ) ;
    public final void rule__XBasicForLoopExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10628:1: ( ( 'for' ) )
            // InternalXbaseWithAnnotations.g:10629:1: ( 'for' )
            {
            // InternalXbaseWithAnnotations.g:10629:1: ( 'for' )
            // InternalXbaseWithAnnotations.g:10630:2: 'for'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getForKeyword_1()); 
            }
            match(input,69,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getForKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__1__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__2"
    // InternalXbaseWithAnnotations.g:10639:1: rule__XBasicForLoopExpression__Group__2 : rule__XBasicForLoopExpression__Group__2__Impl rule__XBasicForLoopExpression__Group__3 ;
    public final void rule__XBasicForLoopExpression__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10643:1: ( rule__XBasicForLoopExpression__Group__2__Impl rule__XBasicForLoopExpression__Group__3 )
            // InternalXbaseWithAnnotations.g:10644:2: rule__XBasicForLoopExpression__Group__2__Impl rule__XBasicForLoopExpression__Group__3
            {
            pushFollow(FOLLOW_67);
            rule__XBasicForLoopExpression__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__2"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:10651:1: rule__XBasicForLoopExpression__Group__2__Impl : ( '(' ) ;
    public final void rule__XBasicForLoopExpression__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10655:1: ( ( '(' ) )
            // InternalXbaseWithAnnotations.g:10656:1: ( '(' )
            {
            // InternalXbaseWithAnnotations.g:10656:1: ( '(' )
            // InternalXbaseWithAnnotations.g:10657:2: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getLeftParenthesisKeyword_2()); 
            }
            match(input,52,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getLeftParenthesisKeyword_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__2__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__3"
    // InternalXbaseWithAnnotations.g:10666:1: rule__XBasicForLoopExpression__Group__3 : rule__XBasicForLoopExpression__Group__3__Impl rule__XBasicForLoopExpression__Group__4 ;
    public final void rule__XBasicForLoopExpression__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10670:1: ( rule__XBasicForLoopExpression__Group__3__Impl rule__XBasicForLoopExpression__Group__4 )
            // InternalXbaseWithAnnotations.g:10671:2: rule__XBasicForLoopExpression__Group__3__Impl rule__XBasicForLoopExpression__Group__4
            {
            pushFollow(FOLLOW_67);
            rule__XBasicForLoopExpression__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__3"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__3__Impl"
    // InternalXbaseWithAnnotations.g:10678:1: rule__XBasicForLoopExpression__Group__3__Impl : ( ( rule__XBasicForLoopExpression__Group_3__0 )? ) ;
    public final void rule__XBasicForLoopExpression__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10682:1: ( ( ( rule__XBasicForLoopExpression__Group_3__0 )? ) )
            // InternalXbaseWithAnnotations.g:10683:1: ( ( rule__XBasicForLoopExpression__Group_3__0 )? )
            {
            // InternalXbaseWithAnnotations.g:10683:1: ( ( rule__XBasicForLoopExpression__Group_3__0 )? )
            // InternalXbaseWithAnnotations.g:10684:2: ( rule__XBasicForLoopExpression__Group_3__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getGroup_3()); 
            }
            // InternalXbaseWithAnnotations.g:10685:2: ( rule__XBasicForLoopExpression__Group_3__0 )?
            int alt89=2;
            int LA89_0 = input.LA(1);

            if ( ((LA89_0>=RULE_ID && LA89_0<=RULE_STRING)||LA89_0==27||(LA89_0>=34 && LA89_0<=35)||LA89_0==40||(LA89_0>=44 && LA89_0<=50)||LA89_0==52||(LA89_0>=56 && LA89_0<=57)||LA89_0==60||LA89_0==63||LA89_0==65||(LA89_0>=69 && LA89_0<=77)||LA89_0==79||(LA89_0>=86 && LA89_0<=87)) ) {
                alt89=1;
            }
            switch (alt89) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:10685:3: rule__XBasicForLoopExpression__Group_3__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XBasicForLoopExpression__Group_3__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getGroup_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__3__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__4"
    // InternalXbaseWithAnnotations.g:10693:1: rule__XBasicForLoopExpression__Group__4 : rule__XBasicForLoopExpression__Group__4__Impl rule__XBasicForLoopExpression__Group__5 ;
    public final void rule__XBasicForLoopExpression__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10697:1: ( rule__XBasicForLoopExpression__Group__4__Impl rule__XBasicForLoopExpression__Group__5 )
            // InternalXbaseWithAnnotations.g:10698:2: rule__XBasicForLoopExpression__Group__4__Impl rule__XBasicForLoopExpression__Group__5
            {
            pushFollow(FOLLOW_68);
            rule__XBasicForLoopExpression__Group__4__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group__5();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__4"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__4__Impl"
    // InternalXbaseWithAnnotations.g:10705:1: rule__XBasicForLoopExpression__Group__4__Impl : ( ';' ) ;
    public final void rule__XBasicForLoopExpression__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10709:1: ( ( ';' ) )
            // InternalXbaseWithAnnotations.g:10710:1: ( ';' )
            {
            // InternalXbaseWithAnnotations.g:10710:1: ( ';' )
            // InternalXbaseWithAnnotations.g:10711:2: ';'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getSemicolonKeyword_4()); 
            }
            match(input,62,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getSemicolonKeyword_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__4__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__5"
    // InternalXbaseWithAnnotations.g:10720:1: rule__XBasicForLoopExpression__Group__5 : rule__XBasicForLoopExpression__Group__5__Impl rule__XBasicForLoopExpression__Group__6 ;
    public final void rule__XBasicForLoopExpression__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10724:1: ( rule__XBasicForLoopExpression__Group__5__Impl rule__XBasicForLoopExpression__Group__6 )
            // InternalXbaseWithAnnotations.g:10725:2: rule__XBasicForLoopExpression__Group__5__Impl rule__XBasicForLoopExpression__Group__6
            {
            pushFollow(FOLLOW_68);
            rule__XBasicForLoopExpression__Group__5__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group__6();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__5"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__5__Impl"
    // InternalXbaseWithAnnotations.g:10732:1: rule__XBasicForLoopExpression__Group__5__Impl : ( ( rule__XBasicForLoopExpression__ExpressionAssignment_5 )? ) ;
    public final void rule__XBasicForLoopExpression__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10736:1: ( ( ( rule__XBasicForLoopExpression__ExpressionAssignment_5 )? ) )
            // InternalXbaseWithAnnotations.g:10737:1: ( ( rule__XBasicForLoopExpression__ExpressionAssignment_5 )? )
            {
            // InternalXbaseWithAnnotations.g:10737:1: ( ( rule__XBasicForLoopExpression__ExpressionAssignment_5 )? )
            // InternalXbaseWithAnnotations.g:10738:2: ( rule__XBasicForLoopExpression__ExpressionAssignment_5 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getExpressionAssignment_5()); 
            }
            // InternalXbaseWithAnnotations.g:10739:2: ( rule__XBasicForLoopExpression__ExpressionAssignment_5 )?
            int alt90=2;
            int LA90_0 = input.LA(1);

            if ( ((LA90_0>=RULE_ID && LA90_0<=RULE_STRING)||LA90_0==27||(LA90_0>=34 && LA90_0<=35)||LA90_0==40||(LA90_0>=45 && LA90_0<=50)||LA90_0==52||(LA90_0>=56 && LA90_0<=57)||LA90_0==60||LA90_0==63||LA90_0==65||(LA90_0>=69 && LA90_0<=77)||LA90_0==79||LA90_0==87) ) {
                alt90=1;
            }
            switch (alt90) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:10739:3: rule__XBasicForLoopExpression__ExpressionAssignment_5
                    {
                    pushFollow(FOLLOW_2);
                    rule__XBasicForLoopExpression__ExpressionAssignment_5();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getExpressionAssignment_5()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__5__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__6"
    // InternalXbaseWithAnnotations.g:10747:1: rule__XBasicForLoopExpression__Group__6 : rule__XBasicForLoopExpression__Group__6__Impl rule__XBasicForLoopExpression__Group__7 ;
    public final void rule__XBasicForLoopExpression__Group__6() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10751:1: ( rule__XBasicForLoopExpression__Group__6__Impl rule__XBasicForLoopExpression__Group__7 )
            // InternalXbaseWithAnnotations.g:10752:2: rule__XBasicForLoopExpression__Group__6__Impl rule__XBasicForLoopExpression__Group__7
            {
            pushFollow(FOLLOW_7);
            rule__XBasicForLoopExpression__Group__6__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group__7();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__6"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__6__Impl"
    // InternalXbaseWithAnnotations.g:10759:1: rule__XBasicForLoopExpression__Group__6__Impl : ( ';' ) ;
    public final void rule__XBasicForLoopExpression__Group__6__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10763:1: ( ( ';' ) )
            // InternalXbaseWithAnnotations.g:10764:1: ( ';' )
            {
            // InternalXbaseWithAnnotations.g:10764:1: ( ';' )
            // InternalXbaseWithAnnotations.g:10765:2: ';'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getSemicolonKeyword_6()); 
            }
            match(input,62,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getSemicolonKeyword_6()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__6__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__7"
    // InternalXbaseWithAnnotations.g:10774:1: rule__XBasicForLoopExpression__Group__7 : rule__XBasicForLoopExpression__Group__7__Impl rule__XBasicForLoopExpression__Group__8 ;
    public final void rule__XBasicForLoopExpression__Group__7() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10778:1: ( rule__XBasicForLoopExpression__Group__7__Impl rule__XBasicForLoopExpression__Group__8 )
            // InternalXbaseWithAnnotations.g:10779:2: rule__XBasicForLoopExpression__Group__7__Impl rule__XBasicForLoopExpression__Group__8
            {
            pushFollow(FOLLOW_7);
            rule__XBasicForLoopExpression__Group__7__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group__8();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__7"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__7__Impl"
    // InternalXbaseWithAnnotations.g:10786:1: rule__XBasicForLoopExpression__Group__7__Impl : ( ( rule__XBasicForLoopExpression__Group_7__0 )? ) ;
    public final void rule__XBasicForLoopExpression__Group__7__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10790:1: ( ( ( rule__XBasicForLoopExpression__Group_7__0 )? ) )
            // InternalXbaseWithAnnotations.g:10791:1: ( ( rule__XBasicForLoopExpression__Group_7__0 )? )
            {
            // InternalXbaseWithAnnotations.g:10791:1: ( ( rule__XBasicForLoopExpression__Group_7__0 )? )
            // InternalXbaseWithAnnotations.g:10792:2: ( rule__XBasicForLoopExpression__Group_7__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getGroup_7()); 
            }
            // InternalXbaseWithAnnotations.g:10793:2: ( rule__XBasicForLoopExpression__Group_7__0 )?
            int alt91=2;
            int LA91_0 = input.LA(1);

            if ( ((LA91_0>=RULE_ID && LA91_0<=RULE_STRING)||LA91_0==27||(LA91_0>=34 && LA91_0<=35)||LA91_0==40||(LA91_0>=45 && LA91_0<=50)||LA91_0==52||(LA91_0>=56 && LA91_0<=57)||LA91_0==60||LA91_0==63||LA91_0==65||(LA91_0>=69 && LA91_0<=77)||LA91_0==79||LA91_0==87) ) {
                alt91=1;
            }
            switch (alt91) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:10793:3: rule__XBasicForLoopExpression__Group_7__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XBasicForLoopExpression__Group_7__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getGroup_7()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__7__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__8"
    // InternalXbaseWithAnnotations.g:10801:1: rule__XBasicForLoopExpression__Group__8 : rule__XBasicForLoopExpression__Group__8__Impl rule__XBasicForLoopExpression__Group__9 ;
    public final void rule__XBasicForLoopExpression__Group__8() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10805:1: ( rule__XBasicForLoopExpression__Group__8__Impl rule__XBasicForLoopExpression__Group__9 )
            // InternalXbaseWithAnnotations.g:10806:2: rule__XBasicForLoopExpression__Group__8__Impl rule__XBasicForLoopExpression__Group__9
            {
            pushFollow(FOLLOW_10);
            rule__XBasicForLoopExpression__Group__8__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group__9();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__8"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__8__Impl"
    // InternalXbaseWithAnnotations.g:10813:1: rule__XBasicForLoopExpression__Group__8__Impl : ( ')' ) ;
    public final void rule__XBasicForLoopExpression__Group__8__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10817:1: ( ( ')' ) )
            // InternalXbaseWithAnnotations.g:10818:1: ( ')' )
            {
            // InternalXbaseWithAnnotations.g:10818:1: ( ')' )
            // InternalXbaseWithAnnotations.g:10819:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getRightParenthesisKeyword_8()); 
            }
            match(input,53,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getRightParenthesisKeyword_8()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__8__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__9"
    // InternalXbaseWithAnnotations.g:10828:1: rule__XBasicForLoopExpression__Group__9 : rule__XBasicForLoopExpression__Group__9__Impl ;
    public final void rule__XBasicForLoopExpression__Group__9() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10832:1: ( rule__XBasicForLoopExpression__Group__9__Impl )
            // InternalXbaseWithAnnotations.g:10833:2: rule__XBasicForLoopExpression__Group__9__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group__9__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__9"


    // $ANTLR start "rule__XBasicForLoopExpression__Group__9__Impl"
    // InternalXbaseWithAnnotations.g:10839:1: rule__XBasicForLoopExpression__Group__9__Impl : ( ( rule__XBasicForLoopExpression__EachExpressionAssignment_9 ) ) ;
    public final void rule__XBasicForLoopExpression__Group__9__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10843:1: ( ( ( rule__XBasicForLoopExpression__EachExpressionAssignment_9 ) ) )
            // InternalXbaseWithAnnotations.g:10844:1: ( ( rule__XBasicForLoopExpression__EachExpressionAssignment_9 ) )
            {
            // InternalXbaseWithAnnotations.g:10844:1: ( ( rule__XBasicForLoopExpression__EachExpressionAssignment_9 ) )
            // InternalXbaseWithAnnotations.g:10845:2: ( rule__XBasicForLoopExpression__EachExpressionAssignment_9 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getEachExpressionAssignment_9()); 
            }
            // InternalXbaseWithAnnotations.g:10846:2: ( rule__XBasicForLoopExpression__EachExpressionAssignment_9 )
            // InternalXbaseWithAnnotations.g:10846:3: rule__XBasicForLoopExpression__EachExpressionAssignment_9
            {
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__EachExpressionAssignment_9();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getEachExpressionAssignment_9()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group__9__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_3__0"
    // InternalXbaseWithAnnotations.g:10855:1: rule__XBasicForLoopExpression__Group_3__0 : rule__XBasicForLoopExpression__Group_3__0__Impl rule__XBasicForLoopExpression__Group_3__1 ;
    public final void rule__XBasicForLoopExpression__Group_3__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10859:1: ( rule__XBasicForLoopExpression__Group_3__0__Impl rule__XBasicForLoopExpression__Group_3__1 )
            // InternalXbaseWithAnnotations.g:10860:2: rule__XBasicForLoopExpression__Group_3__0__Impl rule__XBasicForLoopExpression__Group_3__1
            {
            pushFollow(FOLLOW_8);
            rule__XBasicForLoopExpression__Group_3__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group_3__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_3__0"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_3__0__Impl"
    // InternalXbaseWithAnnotations.g:10867:1: rule__XBasicForLoopExpression__Group_3__0__Impl : ( ( rule__XBasicForLoopExpression__InitExpressionsAssignment_3_0 ) ) ;
    public final void rule__XBasicForLoopExpression__Group_3__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10871:1: ( ( ( rule__XBasicForLoopExpression__InitExpressionsAssignment_3_0 ) ) )
            // InternalXbaseWithAnnotations.g:10872:1: ( ( rule__XBasicForLoopExpression__InitExpressionsAssignment_3_0 ) )
            {
            // InternalXbaseWithAnnotations.g:10872:1: ( ( rule__XBasicForLoopExpression__InitExpressionsAssignment_3_0 ) )
            // InternalXbaseWithAnnotations.g:10873:2: ( rule__XBasicForLoopExpression__InitExpressionsAssignment_3_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getInitExpressionsAssignment_3_0()); 
            }
            // InternalXbaseWithAnnotations.g:10874:2: ( rule__XBasicForLoopExpression__InitExpressionsAssignment_3_0 )
            // InternalXbaseWithAnnotations.g:10874:3: rule__XBasicForLoopExpression__InitExpressionsAssignment_3_0
            {
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__InitExpressionsAssignment_3_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getInitExpressionsAssignment_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_3__0__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_3__1"
    // InternalXbaseWithAnnotations.g:10882:1: rule__XBasicForLoopExpression__Group_3__1 : rule__XBasicForLoopExpression__Group_3__1__Impl ;
    public final void rule__XBasicForLoopExpression__Group_3__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10886:1: ( rule__XBasicForLoopExpression__Group_3__1__Impl )
            // InternalXbaseWithAnnotations.g:10887:2: rule__XBasicForLoopExpression__Group_3__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group_3__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_3__1"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_3__1__Impl"
    // InternalXbaseWithAnnotations.g:10893:1: rule__XBasicForLoopExpression__Group_3__1__Impl : ( ( rule__XBasicForLoopExpression__Group_3_1__0 )* ) ;
    public final void rule__XBasicForLoopExpression__Group_3__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10897:1: ( ( ( rule__XBasicForLoopExpression__Group_3_1__0 )* ) )
            // InternalXbaseWithAnnotations.g:10898:1: ( ( rule__XBasicForLoopExpression__Group_3_1__0 )* )
            {
            // InternalXbaseWithAnnotations.g:10898:1: ( ( rule__XBasicForLoopExpression__Group_3_1__0 )* )
            // InternalXbaseWithAnnotations.g:10899:2: ( rule__XBasicForLoopExpression__Group_3_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getGroup_3_1()); 
            }
            // InternalXbaseWithAnnotations.g:10900:2: ( rule__XBasicForLoopExpression__Group_3_1__0 )*
            loop92:
            do {
                int alt92=2;
                int LA92_0 = input.LA(1);

                if ( (LA92_0==54) ) {
                    alt92=1;
                }


                switch (alt92) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:10900:3: rule__XBasicForLoopExpression__Group_3_1__0
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__XBasicForLoopExpression__Group_3_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop92;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getGroup_3_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_3__1__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_3_1__0"
    // InternalXbaseWithAnnotations.g:10909:1: rule__XBasicForLoopExpression__Group_3_1__0 : rule__XBasicForLoopExpression__Group_3_1__0__Impl rule__XBasicForLoopExpression__Group_3_1__1 ;
    public final void rule__XBasicForLoopExpression__Group_3_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10913:1: ( rule__XBasicForLoopExpression__Group_3_1__0__Impl rule__XBasicForLoopExpression__Group_3_1__1 )
            // InternalXbaseWithAnnotations.g:10914:2: rule__XBasicForLoopExpression__Group_3_1__0__Impl rule__XBasicForLoopExpression__Group_3_1__1
            {
            pushFollow(FOLLOW_69);
            rule__XBasicForLoopExpression__Group_3_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group_3_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_3_1__0"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_3_1__0__Impl"
    // InternalXbaseWithAnnotations.g:10921:1: rule__XBasicForLoopExpression__Group_3_1__0__Impl : ( ',' ) ;
    public final void rule__XBasicForLoopExpression__Group_3_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10925:1: ( ( ',' ) )
            // InternalXbaseWithAnnotations.g:10926:1: ( ',' )
            {
            // InternalXbaseWithAnnotations.g:10926:1: ( ',' )
            // InternalXbaseWithAnnotations.g:10927:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getCommaKeyword_3_1_0()); 
            }
            match(input,54,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getCommaKeyword_3_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_3_1__0__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_3_1__1"
    // InternalXbaseWithAnnotations.g:10936:1: rule__XBasicForLoopExpression__Group_3_1__1 : rule__XBasicForLoopExpression__Group_3_1__1__Impl ;
    public final void rule__XBasicForLoopExpression__Group_3_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10940:1: ( rule__XBasicForLoopExpression__Group_3_1__1__Impl )
            // InternalXbaseWithAnnotations.g:10941:2: rule__XBasicForLoopExpression__Group_3_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group_3_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_3_1__1"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_3_1__1__Impl"
    // InternalXbaseWithAnnotations.g:10947:1: rule__XBasicForLoopExpression__Group_3_1__1__Impl : ( ( rule__XBasicForLoopExpression__InitExpressionsAssignment_3_1_1 ) ) ;
    public final void rule__XBasicForLoopExpression__Group_3_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10951:1: ( ( ( rule__XBasicForLoopExpression__InitExpressionsAssignment_3_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:10952:1: ( ( rule__XBasicForLoopExpression__InitExpressionsAssignment_3_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:10952:1: ( ( rule__XBasicForLoopExpression__InitExpressionsAssignment_3_1_1 ) )
            // InternalXbaseWithAnnotations.g:10953:2: ( rule__XBasicForLoopExpression__InitExpressionsAssignment_3_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getInitExpressionsAssignment_3_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:10954:2: ( rule__XBasicForLoopExpression__InitExpressionsAssignment_3_1_1 )
            // InternalXbaseWithAnnotations.g:10954:3: rule__XBasicForLoopExpression__InitExpressionsAssignment_3_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__InitExpressionsAssignment_3_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getInitExpressionsAssignment_3_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_3_1__1__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_7__0"
    // InternalXbaseWithAnnotations.g:10963:1: rule__XBasicForLoopExpression__Group_7__0 : rule__XBasicForLoopExpression__Group_7__0__Impl rule__XBasicForLoopExpression__Group_7__1 ;
    public final void rule__XBasicForLoopExpression__Group_7__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10967:1: ( rule__XBasicForLoopExpression__Group_7__0__Impl rule__XBasicForLoopExpression__Group_7__1 )
            // InternalXbaseWithAnnotations.g:10968:2: rule__XBasicForLoopExpression__Group_7__0__Impl rule__XBasicForLoopExpression__Group_7__1
            {
            pushFollow(FOLLOW_8);
            rule__XBasicForLoopExpression__Group_7__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group_7__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_7__0"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_7__0__Impl"
    // InternalXbaseWithAnnotations.g:10975:1: rule__XBasicForLoopExpression__Group_7__0__Impl : ( ( rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_0 ) ) ;
    public final void rule__XBasicForLoopExpression__Group_7__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10979:1: ( ( ( rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_0 ) ) )
            // InternalXbaseWithAnnotations.g:10980:1: ( ( rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_0 ) )
            {
            // InternalXbaseWithAnnotations.g:10980:1: ( ( rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_0 ) )
            // InternalXbaseWithAnnotations.g:10981:2: ( rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getUpdateExpressionsAssignment_7_0()); 
            }
            // InternalXbaseWithAnnotations.g:10982:2: ( rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_0 )
            // InternalXbaseWithAnnotations.g:10982:3: rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_0
            {
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getUpdateExpressionsAssignment_7_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_7__0__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_7__1"
    // InternalXbaseWithAnnotations.g:10990:1: rule__XBasicForLoopExpression__Group_7__1 : rule__XBasicForLoopExpression__Group_7__1__Impl ;
    public final void rule__XBasicForLoopExpression__Group_7__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:10994:1: ( rule__XBasicForLoopExpression__Group_7__1__Impl )
            // InternalXbaseWithAnnotations.g:10995:2: rule__XBasicForLoopExpression__Group_7__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group_7__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_7__1"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_7__1__Impl"
    // InternalXbaseWithAnnotations.g:11001:1: rule__XBasicForLoopExpression__Group_7__1__Impl : ( ( rule__XBasicForLoopExpression__Group_7_1__0 )* ) ;
    public final void rule__XBasicForLoopExpression__Group_7__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11005:1: ( ( ( rule__XBasicForLoopExpression__Group_7_1__0 )* ) )
            // InternalXbaseWithAnnotations.g:11006:1: ( ( rule__XBasicForLoopExpression__Group_7_1__0 )* )
            {
            // InternalXbaseWithAnnotations.g:11006:1: ( ( rule__XBasicForLoopExpression__Group_7_1__0 )* )
            // InternalXbaseWithAnnotations.g:11007:2: ( rule__XBasicForLoopExpression__Group_7_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getGroup_7_1()); 
            }
            // InternalXbaseWithAnnotations.g:11008:2: ( rule__XBasicForLoopExpression__Group_7_1__0 )*
            loop93:
            do {
                int alt93=2;
                int LA93_0 = input.LA(1);

                if ( (LA93_0==54) ) {
                    alt93=1;
                }


                switch (alt93) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:11008:3: rule__XBasicForLoopExpression__Group_7_1__0
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__XBasicForLoopExpression__Group_7_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop93;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getGroup_7_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_7__1__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_7_1__0"
    // InternalXbaseWithAnnotations.g:11017:1: rule__XBasicForLoopExpression__Group_7_1__0 : rule__XBasicForLoopExpression__Group_7_1__0__Impl rule__XBasicForLoopExpression__Group_7_1__1 ;
    public final void rule__XBasicForLoopExpression__Group_7_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11021:1: ( rule__XBasicForLoopExpression__Group_7_1__0__Impl rule__XBasicForLoopExpression__Group_7_1__1 )
            // InternalXbaseWithAnnotations.g:11022:2: rule__XBasicForLoopExpression__Group_7_1__0__Impl rule__XBasicForLoopExpression__Group_7_1__1
            {
            pushFollow(FOLLOW_10);
            rule__XBasicForLoopExpression__Group_7_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group_7_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_7_1__0"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_7_1__0__Impl"
    // InternalXbaseWithAnnotations.g:11029:1: rule__XBasicForLoopExpression__Group_7_1__0__Impl : ( ',' ) ;
    public final void rule__XBasicForLoopExpression__Group_7_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11033:1: ( ( ',' ) )
            // InternalXbaseWithAnnotations.g:11034:1: ( ',' )
            {
            // InternalXbaseWithAnnotations.g:11034:1: ( ',' )
            // InternalXbaseWithAnnotations.g:11035:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getCommaKeyword_7_1_0()); 
            }
            match(input,54,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getCommaKeyword_7_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_7_1__0__Impl"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_7_1__1"
    // InternalXbaseWithAnnotations.g:11044:1: rule__XBasicForLoopExpression__Group_7_1__1 : rule__XBasicForLoopExpression__Group_7_1__1__Impl ;
    public final void rule__XBasicForLoopExpression__Group_7_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11048:1: ( rule__XBasicForLoopExpression__Group_7_1__1__Impl )
            // InternalXbaseWithAnnotations.g:11049:2: rule__XBasicForLoopExpression__Group_7_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__Group_7_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_7_1__1"


    // $ANTLR start "rule__XBasicForLoopExpression__Group_7_1__1__Impl"
    // InternalXbaseWithAnnotations.g:11055:1: rule__XBasicForLoopExpression__Group_7_1__1__Impl : ( ( rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_1_1 ) ) ;
    public final void rule__XBasicForLoopExpression__Group_7_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11059:1: ( ( ( rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:11060:1: ( ( rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:11060:1: ( ( rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_1_1 ) )
            // InternalXbaseWithAnnotations.g:11061:2: ( rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getUpdateExpressionsAssignment_7_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:11062:2: ( rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_1_1 )
            // InternalXbaseWithAnnotations.g:11062:3: rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getUpdateExpressionsAssignment_7_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__Group_7_1__1__Impl"


    // $ANTLR start "rule__XWhileExpression__Group__0"
    // InternalXbaseWithAnnotations.g:11071:1: rule__XWhileExpression__Group__0 : rule__XWhileExpression__Group__0__Impl rule__XWhileExpression__Group__1 ;
    public final void rule__XWhileExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11075:1: ( rule__XWhileExpression__Group__0__Impl rule__XWhileExpression__Group__1 )
            // InternalXbaseWithAnnotations.g:11076:2: rule__XWhileExpression__Group__0__Impl rule__XWhileExpression__Group__1
            {
            pushFollow(FOLLOW_70);
            rule__XWhileExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XWhileExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__Group__0"


    // $ANTLR start "rule__XWhileExpression__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:11083:1: rule__XWhileExpression__Group__0__Impl : ( () ) ;
    public final void rule__XWhileExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11087:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:11088:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:11088:1: ( () )
            // InternalXbaseWithAnnotations.g:11089:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXWhileExpressionAccess().getXWhileExpressionAction_0()); 
            }
            // InternalXbaseWithAnnotations.g:11090:2: ()
            // InternalXbaseWithAnnotations.g:11090:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXWhileExpressionAccess().getXWhileExpressionAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__Group__0__Impl"


    // $ANTLR start "rule__XWhileExpression__Group__1"
    // InternalXbaseWithAnnotations.g:11098:1: rule__XWhileExpression__Group__1 : rule__XWhileExpression__Group__1__Impl rule__XWhileExpression__Group__2 ;
    public final void rule__XWhileExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11102:1: ( rule__XWhileExpression__Group__1__Impl rule__XWhileExpression__Group__2 )
            // InternalXbaseWithAnnotations.g:11103:2: rule__XWhileExpression__Group__1__Impl rule__XWhileExpression__Group__2
            {
            pushFollow(FOLLOW_6);
            rule__XWhileExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XWhileExpression__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__Group__1"


    // $ANTLR start "rule__XWhileExpression__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:11110:1: rule__XWhileExpression__Group__1__Impl : ( 'while' ) ;
    public final void rule__XWhileExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11114:1: ( ( 'while' ) )
            // InternalXbaseWithAnnotations.g:11115:1: ( 'while' )
            {
            // InternalXbaseWithAnnotations.g:11115:1: ( 'while' )
            // InternalXbaseWithAnnotations.g:11116:2: 'while'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXWhileExpressionAccess().getWhileKeyword_1()); 
            }
            match(input,70,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXWhileExpressionAccess().getWhileKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__Group__1__Impl"


    // $ANTLR start "rule__XWhileExpression__Group__2"
    // InternalXbaseWithAnnotations.g:11125:1: rule__XWhileExpression__Group__2 : rule__XWhileExpression__Group__2__Impl rule__XWhileExpression__Group__3 ;
    public final void rule__XWhileExpression__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11129:1: ( rule__XWhileExpression__Group__2__Impl rule__XWhileExpression__Group__3 )
            // InternalXbaseWithAnnotations.g:11130:2: rule__XWhileExpression__Group__2__Impl rule__XWhileExpression__Group__3
            {
            pushFollow(FOLLOW_10);
            rule__XWhileExpression__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XWhileExpression__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__Group__2"


    // $ANTLR start "rule__XWhileExpression__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:11137:1: rule__XWhileExpression__Group__2__Impl : ( '(' ) ;
    public final void rule__XWhileExpression__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11141:1: ( ( '(' ) )
            // InternalXbaseWithAnnotations.g:11142:1: ( '(' )
            {
            // InternalXbaseWithAnnotations.g:11142:1: ( '(' )
            // InternalXbaseWithAnnotations.g:11143:2: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXWhileExpressionAccess().getLeftParenthesisKeyword_2()); 
            }
            match(input,52,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXWhileExpressionAccess().getLeftParenthesisKeyword_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__Group__2__Impl"


    // $ANTLR start "rule__XWhileExpression__Group__3"
    // InternalXbaseWithAnnotations.g:11152:1: rule__XWhileExpression__Group__3 : rule__XWhileExpression__Group__3__Impl rule__XWhileExpression__Group__4 ;
    public final void rule__XWhileExpression__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11156:1: ( rule__XWhileExpression__Group__3__Impl rule__XWhileExpression__Group__4 )
            // InternalXbaseWithAnnotations.g:11157:2: rule__XWhileExpression__Group__3__Impl rule__XWhileExpression__Group__4
            {
            pushFollow(FOLLOW_57);
            rule__XWhileExpression__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XWhileExpression__Group__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__Group__3"


    // $ANTLR start "rule__XWhileExpression__Group__3__Impl"
    // InternalXbaseWithAnnotations.g:11164:1: rule__XWhileExpression__Group__3__Impl : ( ( rule__XWhileExpression__PredicateAssignment_3 ) ) ;
    public final void rule__XWhileExpression__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11168:1: ( ( ( rule__XWhileExpression__PredicateAssignment_3 ) ) )
            // InternalXbaseWithAnnotations.g:11169:1: ( ( rule__XWhileExpression__PredicateAssignment_3 ) )
            {
            // InternalXbaseWithAnnotations.g:11169:1: ( ( rule__XWhileExpression__PredicateAssignment_3 ) )
            // InternalXbaseWithAnnotations.g:11170:2: ( rule__XWhileExpression__PredicateAssignment_3 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXWhileExpressionAccess().getPredicateAssignment_3()); 
            }
            // InternalXbaseWithAnnotations.g:11171:2: ( rule__XWhileExpression__PredicateAssignment_3 )
            // InternalXbaseWithAnnotations.g:11171:3: rule__XWhileExpression__PredicateAssignment_3
            {
            pushFollow(FOLLOW_2);
            rule__XWhileExpression__PredicateAssignment_3();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXWhileExpressionAccess().getPredicateAssignment_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__Group__3__Impl"


    // $ANTLR start "rule__XWhileExpression__Group__4"
    // InternalXbaseWithAnnotations.g:11179:1: rule__XWhileExpression__Group__4 : rule__XWhileExpression__Group__4__Impl rule__XWhileExpression__Group__5 ;
    public final void rule__XWhileExpression__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11183:1: ( rule__XWhileExpression__Group__4__Impl rule__XWhileExpression__Group__5 )
            // InternalXbaseWithAnnotations.g:11184:2: rule__XWhileExpression__Group__4__Impl rule__XWhileExpression__Group__5
            {
            pushFollow(FOLLOW_10);
            rule__XWhileExpression__Group__4__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XWhileExpression__Group__5();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__Group__4"


    // $ANTLR start "rule__XWhileExpression__Group__4__Impl"
    // InternalXbaseWithAnnotations.g:11191:1: rule__XWhileExpression__Group__4__Impl : ( ')' ) ;
    public final void rule__XWhileExpression__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11195:1: ( ( ')' ) )
            // InternalXbaseWithAnnotations.g:11196:1: ( ')' )
            {
            // InternalXbaseWithAnnotations.g:11196:1: ( ')' )
            // InternalXbaseWithAnnotations.g:11197:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXWhileExpressionAccess().getRightParenthesisKeyword_4()); 
            }
            match(input,53,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXWhileExpressionAccess().getRightParenthesisKeyword_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__Group__4__Impl"


    // $ANTLR start "rule__XWhileExpression__Group__5"
    // InternalXbaseWithAnnotations.g:11206:1: rule__XWhileExpression__Group__5 : rule__XWhileExpression__Group__5__Impl ;
    public final void rule__XWhileExpression__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11210:1: ( rule__XWhileExpression__Group__5__Impl )
            // InternalXbaseWithAnnotations.g:11211:2: rule__XWhileExpression__Group__5__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XWhileExpression__Group__5__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__Group__5"


    // $ANTLR start "rule__XWhileExpression__Group__5__Impl"
    // InternalXbaseWithAnnotations.g:11217:1: rule__XWhileExpression__Group__5__Impl : ( ( rule__XWhileExpression__BodyAssignment_5 ) ) ;
    public final void rule__XWhileExpression__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11221:1: ( ( ( rule__XWhileExpression__BodyAssignment_5 ) ) )
            // InternalXbaseWithAnnotations.g:11222:1: ( ( rule__XWhileExpression__BodyAssignment_5 ) )
            {
            // InternalXbaseWithAnnotations.g:11222:1: ( ( rule__XWhileExpression__BodyAssignment_5 ) )
            // InternalXbaseWithAnnotations.g:11223:2: ( rule__XWhileExpression__BodyAssignment_5 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXWhileExpressionAccess().getBodyAssignment_5()); 
            }
            // InternalXbaseWithAnnotations.g:11224:2: ( rule__XWhileExpression__BodyAssignment_5 )
            // InternalXbaseWithAnnotations.g:11224:3: rule__XWhileExpression__BodyAssignment_5
            {
            pushFollow(FOLLOW_2);
            rule__XWhileExpression__BodyAssignment_5();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXWhileExpressionAccess().getBodyAssignment_5()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__Group__5__Impl"


    // $ANTLR start "rule__XDoWhileExpression__Group__0"
    // InternalXbaseWithAnnotations.g:11233:1: rule__XDoWhileExpression__Group__0 : rule__XDoWhileExpression__Group__0__Impl rule__XDoWhileExpression__Group__1 ;
    public final void rule__XDoWhileExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11237:1: ( rule__XDoWhileExpression__Group__0__Impl rule__XDoWhileExpression__Group__1 )
            // InternalXbaseWithAnnotations.g:11238:2: rule__XDoWhileExpression__Group__0__Impl rule__XDoWhileExpression__Group__1
            {
            pushFollow(FOLLOW_71);
            rule__XDoWhileExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XDoWhileExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__0"


    // $ANTLR start "rule__XDoWhileExpression__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:11245:1: rule__XDoWhileExpression__Group__0__Impl : ( () ) ;
    public final void rule__XDoWhileExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11249:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:11250:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:11250:1: ( () )
            // InternalXbaseWithAnnotations.g:11251:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXDoWhileExpressionAccess().getXDoWhileExpressionAction_0()); 
            }
            // InternalXbaseWithAnnotations.g:11252:2: ()
            // InternalXbaseWithAnnotations.g:11252:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXDoWhileExpressionAccess().getXDoWhileExpressionAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__0__Impl"


    // $ANTLR start "rule__XDoWhileExpression__Group__1"
    // InternalXbaseWithAnnotations.g:11260:1: rule__XDoWhileExpression__Group__1 : rule__XDoWhileExpression__Group__1__Impl rule__XDoWhileExpression__Group__2 ;
    public final void rule__XDoWhileExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11264:1: ( rule__XDoWhileExpression__Group__1__Impl rule__XDoWhileExpression__Group__2 )
            // InternalXbaseWithAnnotations.g:11265:2: rule__XDoWhileExpression__Group__1__Impl rule__XDoWhileExpression__Group__2
            {
            pushFollow(FOLLOW_10);
            rule__XDoWhileExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XDoWhileExpression__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__1"


    // $ANTLR start "rule__XDoWhileExpression__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:11272:1: rule__XDoWhileExpression__Group__1__Impl : ( 'do' ) ;
    public final void rule__XDoWhileExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11276:1: ( ( 'do' ) )
            // InternalXbaseWithAnnotations.g:11277:1: ( 'do' )
            {
            // InternalXbaseWithAnnotations.g:11277:1: ( 'do' )
            // InternalXbaseWithAnnotations.g:11278:2: 'do'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXDoWhileExpressionAccess().getDoKeyword_1()); 
            }
            match(input,71,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXDoWhileExpressionAccess().getDoKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__1__Impl"


    // $ANTLR start "rule__XDoWhileExpression__Group__2"
    // InternalXbaseWithAnnotations.g:11287:1: rule__XDoWhileExpression__Group__2 : rule__XDoWhileExpression__Group__2__Impl rule__XDoWhileExpression__Group__3 ;
    public final void rule__XDoWhileExpression__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11291:1: ( rule__XDoWhileExpression__Group__2__Impl rule__XDoWhileExpression__Group__3 )
            // InternalXbaseWithAnnotations.g:11292:2: rule__XDoWhileExpression__Group__2__Impl rule__XDoWhileExpression__Group__3
            {
            pushFollow(FOLLOW_70);
            rule__XDoWhileExpression__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XDoWhileExpression__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__2"


    // $ANTLR start "rule__XDoWhileExpression__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:11299:1: rule__XDoWhileExpression__Group__2__Impl : ( ( rule__XDoWhileExpression__BodyAssignment_2 ) ) ;
    public final void rule__XDoWhileExpression__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11303:1: ( ( ( rule__XDoWhileExpression__BodyAssignment_2 ) ) )
            // InternalXbaseWithAnnotations.g:11304:1: ( ( rule__XDoWhileExpression__BodyAssignment_2 ) )
            {
            // InternalXbaseWithAnnotations.g:11304:1: ( ( rule__XDoWhileExpression__BodyAssignment_2 ) )
            // InternalXbaseWithAnnotations.g:11305:2: ( rule__XDoWhileExpression__BodyAssignment_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXDoWhileExpressionAccess().getBodyAssignment_2()); 
            }
            // InternalXbaseWithAnnotations.g:11306:2: ( rule__XDoWhileExpression__BodyAssignment_2 )
            // InternalXbaseWithAnnotations.g:11306:3: rule__XDoWhileExpression__BodyAssignment_2
            {
            pushFollow(FOLLOW_2);
            rule__XDoWhileExpression__BodyAssignment_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXDoWhileExpressionAccess().getBodyAssignment_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__2__Impl"


    // $ANTLR start "rule__XDoWhileExpression__Group__3"
    // InternalXbaseWithAnnotations.g:11314:1: rule__XDoWhileExpression__Group__3 : rule__XDoWhileExpression__Group__3__Impl rule__XDoWhileExpression__Group__4 ;
    public final void rule__XDoWhileExpression__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11318:1: ( rule__XDoWhileExpression__Group__3__Impl rule__XDoWhileExpression__Group__4 )
            // InternalXbaseWithAnnotations.g:11319:2: rule__XDoWhileExpression__Group__3__Impl rule__XDoWhileExpression__Group__4
            {
            pushFollow(FOLLOW_6);
            rule__XDoWhileExpression__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XDoWhileExpression__Group__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__3"


    // $ANTLR start "rule__XDoWhileExpression__Group__3__Impl"
    // InternalXbaseWithAnnotations.g:11326:1: rule__XDoWhileExpression__Group__3__Impl : ( 'while' ) ;
    public final void rule__XDoWhileExpression__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11330:1: ( ( 'while' ) )
            // InternalXbaseWithAnnotations.g:11331:1: ( 'while' )
            {
            // InternalXbaseWithAnnotations.g:11331:1: ( 'while' )
            // InternalXbaseWithAnnotations.g:11332:2: 'while'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXDoWhileExpressionAccess().getWhileKeyword_3()); 
            }
            match(input,70,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXDoWhileExpressionAccess().getWhileKeyword_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__3__Impl"


    // $ANTLR start "rule__XDoWhileExpression__Group__4"
    // InternalXbaseWithAnnotations.g:11341:1: rule__XDoWhileExpression__Group__4 : rule__XDoWhileExpression__Group__4__Impl rule__XDoWhileExpression__Group__5 ;
    public final void rule__XDoWhileExpression__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11345:1: ( rule__XDoWhileExpression__Group__4__Impl rule__XDoWhileExpression__Group__5 )
            // InternalXbaseWithAnnotations.g:11346:2: rule__XDoWhileExpression__Group__4__Impl rule__XDoWhileExpression__Group__5
            {
            pushFollow(FOLLOW_10);
            rule__XDoWhileExpression__Group__4__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XDoWhileExpression__Group__5();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__4"


    // $ANTLR start "rule__XDoWhileExpression__Group__4__Impl"
    // InternalXbaseWithAnnotations.g:11353:1: rule__XDoWhileExpression__Group__4__Impl : ( '(' ) ;
    public final void rule__XDoWhileExpression__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11357:1: ( ( '(' ) )
            // InternalXbaseWithAnnotations.g:11358:1: ( '(' )
            {
            // InternalXbaseWithAnnotations.g:11358:1: ( '(' )
            // InternalXbaseWithAnnotations.g:11359:2: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXDoWhileExpressionAccess().getLeftParenthesisKeyword_4()); 
            }
            match(input,52,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXDoWhileExpressionAccess().getLeftParenthesisKeyword_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__4__Impl"


    // $ANTLR start "rule__XDoWhileExpression__Group__5"
    // InternalXbaseWithAnnotations.g:11368:1: rule__XDoWhileExpression__Group__5 : rule__XDoWhileExpression__Group__5__Impl rule__XDoWhileExpression__Group__6 ;
    public final void rule__XDoWhileExpression__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11372:1: ( rule__XDoWhileExpression__Group__5__Impl rule__XDoWhileExpression__Group__6 )
            // InternalXbaseWithAnnotations.g:11373:2: rule__XDoWhileExpression__Group__5__Impl rule__XDoWhileExpression__Group__6
            {
            pushFollow(FOLLOW_57);
            rule__XDoWhileExpression__Group__5__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XDoWhileExpression__Group__6();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__5"


    // $ANTLR start "rule__XDoWhileExpression__Group__5__Impl"
    // InternalXbaseWithAnnotations.g:11380:1: rule__XDoWhileExpression__Group__5__Impl : ( ( rule__XDoWhileExpression__PredicateAssignment_5 ) ) ;
    public final void rule__XDoWhileExpression__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11384:1: ( ( ( rule__XDoWhileExpression__PredicateAssignment_5 ) ) )
            // InternalXbaseWithAnnotations.g:11385:1: ( ( rule__XDoWhileExpression__PredicateAssignment_5 ) )
            {
            // InternalXbaseWithAnnotations.g:11385:1: ( ( rule__XDoWhileExpression__PredicateAssignment_5 ) )
            // InternalXbaseWithAnnotations.g:11386:2: ( rule__XDoWhileExpression__PredicateAssignment_5 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXDoWhileExpressionAccess().getPredicateAssignment_5()); 
            }
            // InternalXbaseWithAnnotations.g:11387:2: ( rule__XDoWhileExpression__PredicateAssignment_5 )
            // InternalXbaseWithAnnotations.g:11387:3: rule__XDoWhileExpression__PredicateAssignment_5
            {
            pushFollow(FOLLOW_2);
            rule__XDoWhileExpression__PredicateAssignment_5();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXDoWhileExpressionAccess().getPredicateAssignment_5()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__5__Impl"


    // $ANTLR start "rule__XDoWhileExpression__Group__6"
    // InternalXbaseWithAnnotations.g:11395:1: rule__XDoWhileExpression__Group__6 : rule__XDoWhileExpression__Group__6__Impl ;
    public final void rule__XDoWhileExpression__Group__6() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11399:1: ( rule__XDoWhileExpression__Group__6__Impl )
            // InternalXbaseWithAnnotations.g:11400:2: rule__XDoWhileExpression__Group__6__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XDoWhileExpression__Group__6__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__6"


    // $ANTLR start "rule__XDoWhileExpression__Group__6__Impl"
    // InternalXbaseWithAnnotations.g:11406:1: rule__XDoWhileExpression__Group__6__Impl : ( ')' ) ;
    public final void rule__XDoWhileExpression__Group__6__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11410:1: ( ( ')' ) )
            // InternalXbaseWithAnnotations.g:11411:1: ( ')' )
            {
            // InternalXbaseWithAnnotations.g:11411:1: ( ')' )
            // InternalXbaseWithAnnotations.g:11412:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXDoWhileExpressionAccess().getRightParenthesisKeyword_6()); 
            }
            match(input,53,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXDoWhileExpressionAccess().getRightParenthesisKeyword_6()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__Group__6__Impl"


    // $ANTLR start "rule__XBlockExpression__Group__0"
    // InternalXbaseWithAnnotations.g:11422:1: rule__XBlockExpression__Group__0 : rule__XBlockExpression__Group__0__Impl rule__XBlockExpression__Group__1 ;
    public final void rule__XBlockExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11426:1: ( rule__XBlockExpression__Group__0__Impl rule__XBlockExpression__Group__1 )
            // InternalXbaseWithAnnotations.g:11427:2: rule__XBlockExpression__Group__0__Impl rule__XBlockExpression__Group__1
            {
            pushFollow(FOLLOW_50);
            rule__XBlockExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBlockExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__Group__0"


    // $ANTLR start "rule__XBlockExpression__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:11434:1: rule__XBlockExpression__Group__0__Impl : ( () ) ;
    public final void rule__XBlockExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11438:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:11439:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:11439:1: ( () )
            // InternalXbaseWithAnnotations.g:11440:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBlockExpressionAccess().getXBlockExpressionAction_0()); 
            }
            // InternalXbaseWithAnnotations.g:11441:2: ()
            // InternalXbaseWithAnnotations.g:11441:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBlockExpressionAccess().getXBlockExpressionAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__Group__0__Impl"


    // $ANTLR start "rule__XBlockExpression__Group__1"
    // InternalXbaseWithAnnotations.g:11449:1: rule__XBlockExpression__Group__1 : rule__XBlockExpression__Group__1__Impl rule__XBlockExpression__Group__2 ;
    public final void rule__XBlockExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11453:1: ( rule__XBlockExpression__Group__1__Impl rule__XBlockExpression__Group__2 )
            // InternalXbaseWithAnnotations.g:11454:2: rule__XBlockExpression__Group__1__Impl rule__XBlockExpression__Group__2
            {
            pushFollow(FOLLOW_72);
            rule__XBlockExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBlockExpression__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__Group__1"


    // $ANTLR start "rule__XBlockExpression__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:11461:1: rule__XBlockExpression__Group__1__Impl : ( '{' ) ;
    public final void rule__XBlockExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11465:1: ( ( '{' ) )
            // InternalXbaseWithAnnotations.g:11466:1: ( '{' )
            {
            // InternalXbaseWithAnnotations.g:11466:1: ( '{' )
            // InternalXbaseWithAnnotations.g:11467:2: '{'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBlockExpressionAccess().getLeftCurlyBracketKeyword_1()); 
            }
            match(input,60,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBlockExpressionAccess().getLeftCurlyBracketKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__Group__1__Impl"


    // $ANTLR start "rule__XBlockExpression__Group__2"
    // InternalXbaseWithAnnotations.g:11476:1: rule__XBlockExpression__Group__2 : rule__XBlockExpression__Group__2__Impl rule__XBlockExpression__Group__3 ;
    public final void rule__XBlockExpression__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11480:1: ( rule__XBlockExpression__Group__2__Impl rule__XBlockExpression__Group__3 )
            // InternalXbaseWithAnnotations.g:11481:2: rule__XBlockExpression__Group__2__Impl rule__XBlockExpression__Group__3
            {
            pushFollow(FOLLOW_72);
            rule__XBlockExpression__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBlockExpression__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__Group__2"


    // $ANTLR start "rule__XBlockExpression__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:11488:1: rule__XBlockExpression__Group__2__Impl : ( ( rule__XBlockExpression__Group_2__0 )* ) ;
    public final void rule__XBlockExpression__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11492:1: ( ( ( rule__XBlockExpression__Group_2__0 )* ) )
            // InternalXbaseWithAnnotations.g:11493:1: ( ( rule__XBlockExpression__Group_2__0 )* )
            {
            // InternalXbaseWithAnnotations.g:11493:1: ( ( rule__XBlockExpression__Group_2__0 )* )
            // InternalXbaseWithAnnotations.g:11494:2: ( rule__XBlockExpression__Group_2__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBlockExpressionAccess().getGroup_2()); 
            }
            // InternalXbaseWithAnnotations.g:11495:2: ( rule__XBlockExpression__Group_2__0 )*
            loop94:
            do {
                int alt94=2;
                int LA94_0 = input.LA(1);

                if ( ((LA94_0>=RULE_ID && LA94_0<=RULE_STRING)||LA94_0==27||(LA94_0>=34 && LA94_0<=35)||LA94_0==40||(LA94_0>=44 && LA94_0<=50)||LA94_0==52||(LA94_0>=56 && LA94_0<=57)||LA94_0==60||LA94_0==63||LA94_0==65||(LA94_0>=69 && LA94_0<=77)||LA94_0==79||(LA94_0>=86 && LA94_0<=87)) ) {
                    alt94=1;
                }


                switch (alt94) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:11495:3: rule__XBlockExpression__Group_2__0
            	    {
            	    pushFollow(FOLLOW_55);
            	    rule__XBlockExpression__Group_2__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop94;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBlockExpressionAccess().getGroup_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__Group__2__Impl"


    // $ANTLR start "rule__XBlockExpression__Group__3"
    // InternalXbaseWithAnnotations.g:11503:1: rule__XBlockExpression__Group__3 : rule__XBlockExpression__Group__3__Impl ;
    public final void rule__XBlockExpression__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11507:1: ( rule__XBlockExpression__Group__3__Impl )
            // InternalXbaseWithAnnotations.g:11508:2: rule__XBlockExpression__Group__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XBlockExpression__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__Group__3"


    // $ANTLR start "rule__XBlockExpression__Group__3__Impl"
    // InternalXbaseWithAnnotations.g:11514:1: rule__XBlockExpression__Group__3__Impl : ( '}' ) ;
    public final void rule__XBlockExpression__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11518:1: ( ( '}' ) )
            // InternalXbaseWithAnnotations.g:11519:1: ( '}' )
            {
            // InternalXbaseWithAnnotations.g:11519:1: ( '}' )
            // InternalXbaseWithAnnotations.g:11520:2: '}'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBlockExpressionAccess().getRightCurlyBracketKeyword_3()); 
            }
            match(input,61,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBlockExpressionAccess().getRightCurlyBracketKeyword_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__Group__3__Impl"


    // $ANTLR start "rule__XBlockExpression__Group_2__0"
    // InternalXbaseWithAnnotations.g:11530:1: rule__XBlockExpression__Group_2__0 : rule__XBlockExpression__Group_2__0__Impl rule__XBlockExpression__Group_2__1 ;
    public final void rule__XBlockExpression__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11534:1: ( rule__XBlockExpression__Group_2__0__Impl rule__XBlockExpression__Group_2__1 )
            // InternalXbaseWithAnnotations.g:11535:2: rule__XBlockExpression__Group_2__0__Impl rule__XBlockExpression__Group_2__1
            {
            pushFollow(FOLLOW_56);
            rule__XBlockExpression__Group_2__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBlockExpression__Group_2__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__Group_2__0"


    // $ANTLR start "rule__XBlockExpression__Group_2__0__Impl"
    // InternalXbaseWithAnnotations.g:11542:1: rule__XBlockExpression__Group_2__0__Impl : ( ( rule__XBlockExpression__ExpressionsAssignment_2_0 ) ) ;
    public final void rule__XBlockExpression__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11546:1: ( ( ( rule__XBlockExpression__ExpressionsAssignment_2_0 ) ) )
            // InternalXbaseWithAnnotations.g:11547:1: ( ( rule__XBlockExpression__ExpressionsAssignment_2_0 ) )
            {
            // InternalXbaseWithAnnotations.g:11547:1: ( ( rule__XBlockExpression__ExpressionsAssignment_2_0 ) )
            // InternalXbaseWithAnnotations.g:11548:2: ( rule__XBlockExpression__ExpressionsAssignment_2_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBlockExpressionAccess().getExpressionsAssignment_2_0()); 
            }
            // InternalXbaseWithAnnotations.g:11549:2: ( rule__XBlockExpression__ExpressionsAssignment_2_0 )
            // InternalXbaseWithAnnotations.g:11549:3: rule__XBlockExpression__ExpressionsAssignment_2_0
            {
            pushFollow(FOLLOW_2);
            rule__XBlockExpression__ExpressionsAssignment_2_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBlockExpressionAccess().getExpressionsAssignment_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__Group_2__0__Impl"


    // $ANTLR start "rule__XBlockExpression__Group_2__1"
    // InternalXbaseWithAnnotations.g:11557:1: rule__XBlockExpression__Group_2__1 : rule__XBlockExpression__Group_2__1__Impl ;
    public final void rule__XBlockExpression__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11561:1: ( rule__XBlockExpression__Group_2__1__Impl )
            // InternalXbaseWithAnnotations.g:11562:2: rule__XBlockExpression__Group_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XBlockExpression__Group_2__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__Group_2__1"


    // $ANTLR start "rule__XBlockExpression__Group_2__1__Impl"
    // InternalXbaseWithAnnotations.g:11568:1: rule__XBlockExpression__Group_2__1__Impl : ( ( ';' )? ) ;
    public final void rule__XBlockExpression__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11572:1: ( ( ( ';' )? ) )
            // InternalXbaseWithAnnotations.g:11573:1: ( ( ';' )? )
            {
            // InternalXbaseWithAnnotations.g:11573:1: ( ( ';' )? )
            // InternalXbaseWithAnnotations.g:11574:2: ( ';' )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBlockExpressionAccess().getSemicolonKeyword_2_1()); 
            }
            // InternalXbaseWithAnnotations.g:11575:2: ( ';' )?
            int alt95=2;
            int LA95_0 = input.LA(1);

            if ( (LA95_0==62) ) {
                alt95=1;
            }
            switch (alt95) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:11575:3: ';'
                    {
                    match(input,62,FOLLOW_2); if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBlockExpressionAccess().getSemicolonKeyword_2_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__Group_2__1__Impl"


    // $ANTLR start "rule__XVariableDeclaration__Group__0"
    // InternalXbaseWithAnnotations.g:11584:1: rule__XVariableDeclaration__Group__0 : rule__XVariableDeclaration__Group__0__Impl rule__XVariableDeclaration__Group__1 ;
    public final void rule__XVariableDeclaration__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11588:1: ( rule__XVariableDeclaration__Group__0__Impl rule__XVariableDeclaration__Group__1 )
            // InternalXbaseWithAnnotations.g:11589:2: rule__XVariableDeclaration__Group__0__Impl rule__XVariableDeclaration__Group__1
            {
            pushFollow(FOLLOW_73);
            rule__XVariableDeclaration__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group__0"


    // $ANTLR start "rule__XVariableDeclaration__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:11596:1: rule__XVariableDeclaration__Group__0__Impl : ( () ) ;
    public final void rule__XVariableDeclaration__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11600:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:11601:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:11601:1: ( () )
            // InternalXbaseWithAnnotations.g:11602:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getXVariableDeclarationAction_0()); 
            }
            // InternalXbaseWithAnnotations.g:11603:2: ()
            // InternalXbaseWithAnnotations.g:11603:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getXVariableDeclarationAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group__0__Impl"


    // $ANTLR start "rule__XVariableDeclaration__Group__1"
    // InternalXbaseWithAnnotations.g:11611:1: rule__XVariableDeclaration__Group__1 : rule__XVariableDeclaration__Group__1__Impl rule__XVariableDeclaration__Group__2 ;
    public final void rule__XVariableDeclaration__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11615:1: ( rule__XVariableDeclaration__Group__1__Impl rule__XVariableDeclaration__Group__2 )
            // InternalXbaseWithAnnotations.g:11616:2: rule__XVariableDeclaration__Group__1__Impl rule__XVariableDeclaration__Group__2
            {
            pushFollow(FOLLOW_27);
            rule__XVariableDeclaration__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group__1"


    // $ANTLR start "rule__XVariableDeclaration__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:11623:1: rule__XVariableDeclaration__Group__1__Impl : ( ( rule__XVariableDeclaration__Alternatives_1 ) ) ;
    public final void rule__XVariableDeclaration__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11627:1: ( ( ( rule__XVariableDeclaration__Alternatives_1 ) ) )
            // InternalXbaseWithAnnotations.g:11628:1: ( ( rule__XVariableDeclaration__Alternatives_1 ) )
            {
            // InternalXbaseWithAnnotations.g:11628:1: ( ( rule__XVariableDeclaration__Alternatives_1 ) )
            // InternalXbaseWithAnnotations.g:11629:2: ( rule__XVariableDeclaration__Alternatives_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getAlternatives_1()); 
            }
            // InternalXbaseWithAnnotations.g:11630:2: ( rule__XVariableDeclaration__Alternatives_1 )
            // InternalXbaseWithAnnotations.g:11630:3: rule__XVariableDeclaration__Alternatives_1
            {
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Alternatives_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getAlternatives_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group__1__Impl"


    // $ANTLR start "rule__XVariableDeclaration__Group__2"
    // InternalXbaseWithAnnotations.g:11638:1: rule__XVariableDeclaration__Group__2 : rule__XVariableDeclaration__Group__2__Impl rule__XVariableDeclaration__Group__3 ;
    public final void rule__XVariableDeclaration__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11642:1: ( rule__XVariableDeclaration__Group__2__Impl rule__XVariableDeclaration__Group__3 )
            // InternalXbaseWithAnnotations.g:11643:2: rule__XVariableDeclaration__Group__2__Impl rule__XVariableDeclaration__Group__3
            {
            pushFollow(FOLLOW_11);
            rule__XVariableDeclaration__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group__2"


    // $ANTLR start "rule__XVariableDeclaration__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:11650:1: rule__XVariableDeclaration__Group__2__Impl : ( ( rule__XVariableDeclaration__Alternatives_2 ) ) ;
    public final void rule__XVariableDeclaration__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11654:1: ( ( ( rule__XVariableDeclaration__Alternatives_2 ) ) )
            // InternalXbaseWithAnnotations.g:11655:1: ( ( rule__XVariableDeclaration__Alternatives_2 ) )
            {
            // InternalXbaseWithAnnotations.g:11655:1: ( ( rule__XVariableDeclaration__Alternatives_2 ) )
            // InternalXbaseWithAnnotations.g:11656:2: ( rule__XVariableDeclaration__Alternatives_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getAlternatives_2()); 
            }
            // InternalXbaseWithAnnotations.g:11657:2: ( rule__XVariableDeclaration__Alternatives_2 )
            // InternalXbaseWithAnnotations.g:11657:3: rule__XVariableDeclaration__Alternatives_2
            {
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Alternatives_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getAlternatives_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group__2__Impl"


    // $ANTLR start "rule__XVariableDeclaration__Group__3"
    // InternalXbaseWithAnnotations.g:11665:1: rule__XVariableDeclaration__Group__3 : rule__XVariableDeclaration__Group__3__Impl ;
    public final void rule__XVariableDeclaration__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11669:1: ( rule__XVariableDeclaration__Group__3__Impl )
            // InternalXbaseWithAnnotations.g:11670:2: rule__XVariableDeclaration__Group__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group__3"


    // $ANTLR start "rule__XVariableDeclaration__Group__3__Impl"
    // InternalXbaseWithAnnotations.g:11676:1: rule__XVariableDeclaration__Group__3__Impl : ( ( rule__XVariableDeclaration__Group_3__0 )? ) ;
    public final void rule__XVariableDeclaration__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11680:1: ( ( ( rule__XVariableDeclaration__Group_3__0 )? ) )
            // InternalXbaseWithAnnotations.g:11681:1: ( ( rule__XVariableDeclaration__Group_3__0 )? )
            {
            // InternalXbaseWithAnnotations.g:11681:1: ( ( rule__XVariableDeclaration__Group_3__0 )? )
            // InternalXbaseWithAnnotations.g:11682:2: ( rule__XVariableDeclaration__Group_3__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getGroup_3()); 
            }
            // InternalXbaseWithAnnotations.g:11683:2: ( rule__XVariableDeclaration__Group_3__0 )?
            int alt96=2;
            int LA96_0 = input.LA(1);

            if ( (LA96_0==13) ) {
                alt96=1;
            }
            switch (alt96) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:11683:3: rule__XVariableDeclaration__Group_3__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XVariableDeclaration__Group_3__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getGroup_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group__3__Impl"


    // $ANTLR start "rule__XVariableDeclaration__Group_2_0__0"
    // InternalXbaseWithAnnotations.g:11692:1: rule__XVariableDeclaration__Group_2_0__0 : rule__XVariableDeclaration__Group_2_0__0__Impl ;
    public final void rule__XVariableDeclaration__Group_2_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11696:1: ( rule__XVariableDeclaration__Group_2_0__0__Impl )
            // InternalXbaseWithAnnotations.g:11697:2: rule__XVariableDeclaration__Group_2_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Group_2_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group_2_0__0"


    // $ANTLR start "rule__XVariableDeclaration__Group_2_0__0__Impl"
    // InternalXbaseWithAnnotations.g:11703:1: rule__XVariableDeclaration__Group_2_0__0__Impl : ( ( rule__XVariableDeclaration__Group_2_0_0__0 ) ) ;
    public final void rule__XVariableDeclaration__Group_2_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11707:1: ( ( ( rule__XVariableDeclaration__Group_2_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:11708:1: ( ( rule__XVariableDeclaration__Group_2_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:11708:1: ( ( rule__XVariableDeclaration__Group_2_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:11709:2: ( rule__XVariableDeclaration__Group_2_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getGroup_2_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:11710:2: ( rule__XVariableDeclaration__Group_2_0_0__0 )
            // InternalXbaseWithAnnotations.g:11710:3: rule__XVariableDeclaration__Group_2_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Group_2_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getGroup_2_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group_2_0__0__Impl"


    // $ANTLR start "rule__XVariableDeclaration__Group_2_0_0__0"
    // InternalXbaseWithAnnotations.g:11719:1: rule__XVariableDeclaration__Group_2_0_0__0 : rule__XVariableDeclaration__Group_2_0_0__0__Impl rule__XVariableDeclaration__Group_2_0_0__1 ;
    public final void rule__XVariableDeclaration__Group_2_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11723:1: ( rule__XVariableDeclaration__Group_2_0_0__0__Impl rule__XVariableDeclaration__Group_2_0_0__1 )
            // InternalXbaseWithAnnotations.g:11724:2: rule__XVariableDeclaration__Group_2_0_0__0__Impl rule__XVariableDeclaration__Group_2_0_0__1
            {
            pushFollow(FOLLOW_5);
            rule__XVariableDeclaration__Group_2_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Group_2_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group_2_0_0__0"


    // $ANTLR start "rule__XVariableDeclaration__Group_2_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:11731:1: rule__XVariableDeclaration__Group_2_0_0__0__Impl : ( ( rule__XVariableDeclaration__TypeAssignment_2_0_0_0 ) ) ;
    public final void rule__XVariableDeclaration__Group_2_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11735:1: ( ( ( rule__XVariableDeclaration__TypeAssignment_2_0_0_0 ) ) )
            // InternalXbaseWithAnnotations.g:11736:1: ( ( rule__XVariableDeclaration__TypeAssignment_2_0_0_0 ) )
            {
            // InternalXbaseWithAnnotations.g:11736:1: ( ( rule__XVariableDeclaration__TypeAssignment_2_0_0_0 ) )
            // InternalXbaseWithAnnotations.g:11737:2: ( rule__XVariableDeclaration__TypeAssignment_2_0_0_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getTypeAssignment_2_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:11738:2: ( rule__XVariableDeclaration__TypeAssignment_2_0_0_0 )
            // InternalXbaseWithAnnotations.g:11738:3: rule__XVariableDeclaration__TypeAssignment_2_0_0_0
            {
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__TypeAssignment_2_0_0_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getTypeAssignment_2_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group_2_0_0__0__Impl"


    // $ANTLR start "rule__XVariableDeclaration__Group_2_0_0__1"
    // InternalXbaseWithAnnotations.g:11746:1: rule__XVariableDeclaration__Group_2_0_0__1 : rule__XVariableDeclaration__Group_2_0_0__1__Impl ;
    public final void rule__XVariableDeclaration__Group_2_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11750:1: ( rule__XVariableDeclaration__Group_2_0_0__1__Impl )
            // InternalXbaseWithAnnotations.g:11751:2: rule__XVariableDeclaration__Group_2_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Group_2_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group_2_0_0__1"


    // $ANTLR start "rule__XVariableDeclaration__Group_2_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:11757:1: rule__XVariableDeclaration__Group_2_0_0__1__Impl : ( ( rule__XVariableDeclaration__NameAssignment_2_0_0_1 ) ) ;
    public final void rule__XVariableDeclaration__Group_2_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11761:1: ( ( ( rule__XVariableDeclaration__NameAssignment_2_0_0_1 ) ) )
            // InternalXbaseWithAnnotations.g:11762:1: ( ( rule__XVariableDeclaration__NameAssignment_2_0_0_1 ) )
            {
            // InternalXbaseWithAnnotations.g:11762:1: ( ( rule__XVariableDeclaration__NameAssignment_2_0_0_1 ) )
            // InternalXbaseWithAnnotations.g:11763:2: ( rule__XVariableDeclaration__NameAssignment_2_0_0_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getNameAssignment_2_0_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:11764:2: ( rule__XVariableDeclaration__NameAssignment_2_0_0_1 )
            // InternalXbaseWithAnnotations.g:11764:3: rule__XVariableDeclaration__NameAssignment_2_0_0_1
            {
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__NameAssignment_2_0_0_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getNameAssignment_2_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group_2_0_0__1__Impl"


    // $ANTLR start "rule__XVariableDeclaration__Group_3__0"
    // InternalXbaseWithAnnotations.g:11773:1: rule__XVariableDeclaration__Group_3__0 : rule__XVariableDeclaration__Group_3__0__Impl rule__XVariableDeclaration__Group_3__1 ;
    public final void rule__XVariableDeclaration__Group_3__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11777:1: ( rule__XVariableDeclaration__Group_3__0__Impl rule__XVariableDeclaration__Group_3__1 )
            // InternalXbaseWithAnnotations.g:11778:2: rule__XVariableDeclaration__Group_3__0__Impl rule__XVariableDeclaration__Group_3__1
            {
            pushFollow(FOLLOW_10);
            rule__XVariableDeclaration__Group_3__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Group_3__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group_3__0"


    // $ANTLR start "rule__XVariableDeclaration__Group_3__0__Impl"
    // InternalXbaseWithAnnotations.g:11785:1: rule__XVariableDeclaration__Group_3__0__Impl : ( '=' ) ;
    public final void rule__XVariableDeclaration__Group_3__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11789:1: ( ( '=' ) )
            // InternalXbaseWithAnnotations.g:11790:1: ( '=' )
            {
            // InternalXbaseWithAnnotations.g:11790:1: ( '=' )
            // InternalXbaseWithAnnotations.g:11791:2: '='
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getEqualsSignKeyword_3_0()); 
            }
            match(input,13,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getEqualsSignKeyword_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group_3__0__Impl"


    // $ANTLR start "rule__XVariableDeclaration__Group_3__1"
    // InternalXbaseWithAnnotations.g:11800:1: rule__XVariableDeclaration__Group_3__1 : rule__XVariableDeclaration__Group_3__1__Impl ;
    public final void rule__XVariableDeclaration__Group_3__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11804:1: ( rule__XVariableDeclaration__Group_3__1__Impl )
            // InternalXbaseWithAnnotations.g:11805:2: rule__XVariableDeclaration__Group_3__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__Group_3__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group_3__1"


    // $ANTLR start "rule__XVariableDeclaration__Group_3__1__Impl"
    // InternalXbaseWithAnnotations.g:11811:1: rule__XVariableDeclaration__Group_3__1__Impl : ( ( rule__XVariableDeclaration__RightAssignment_3_1 ) ) ;
    public final void rule__XVariableDeclaration__Group_3__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11815:1: ( ( ( rule__XVariableDeclaration__RightAssignment_3_1 ) ) )
            // InternalXbaseWithAnnotations.g:11816:1: ( ( rule__XVariableDeclaration__RightAssignment_3_1 ) )
            {
            // InternalXbaseWithAnnotations.g:11816:1: ( ( rule__XVariableDeclaration__RightAssignment_3_1 ) )
            // InternalXbaseWithAnnotations.g:11817:2: ( rule__XVariableDeclaration__RightAssignment_3_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getRightAssignment_3_1()); 
            }
            // InternalXbaseWithAnnotations.g:11818:2: ( rule__XVariableDeclaration__RightAssignment_3_1 )
            // InternalXbaseWithAnnotations.g:11818:3: rule__XVariableDeclaration__RightAssignment_3_1
            {
            pushFollow(FOLLOW_2);
            rule__XVariableDeclaration__RightAssignment_3_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getRightAssignment_3_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__Group_3__1__Impl"


    // $ANTLR start "rule__JvmFormalParameter__Group__0"
    // InternalXbaseWithAnnotations.g:11827:1: rule__JvmFormalParameter__Group__0 : rule__JvmFormalParameter__Group__0__Impl rule__JvmFormalParameter__Group__1 ;
    public final void rule__JvmFormalParameter__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11831:1: ( rule__JvmFormalParameter__Group__0__Impl rule__JvmFormalParameter__Group__1 )
            // InternalXbaseWithAnnotations.g:11832:2: rule__JvmFormalParameter__Group__0__Impl rule__JvmFormalParameter__Group__1
            {
            pushFollow(FOLLOW_27);
            rule__JvmFormalParameter__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmFormalParameter__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmFormalParameter__Group__0"


    // $ANTLR start "rule__JvmFormalParameter__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:11839:1: rule__JvmFormalParameter__Group__0__Impl : ( ( rule__JvmFormalParameter__ParameterTypeAssignment_0 )? ) ;
    public final void rule__JvmFormalParameter__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11843:1: ( ( ( rule__JvmFormalParameter__ParameterTypeAssignment_0 )? ) )
            // InternalXbaseWithAnnotations.g:11844:1: ( ( rule__JvmFormalParameter__ParameterTypeAssignment_0 )? )
            {
            // InternalXbaseWithAnnotations.g:11844:1: ( ( rule__JvmFormalParameter__ParameterTypeAssignment_0 )? )
            // InternalXbaseWithAnnotations.g:11845:2: ( rule__JvmFormalParameter__ParameterTypeAssignment_0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmFormalParameterAccess().getParameterTypeAssignment_0()); 
            }
            // InternalXbaseWithAnnotations.g:11846:2: ( rule__JvmFormalParameter__ParameterTypeAssignment_0 )?
            int alt97=2;
            int LA97_0 = input.LA(1);

            if ( (LA97_0==RULE_ID) ) {
                int LA97_1 = input.LA(2);

                if ( (LA97_1==RULE_ID||LA97_1==27||LA97_1==43||LA97_1==57) ) {
                    alt97=1;
                }
            }
            else if ( (LA97_0==31||LA97_0==52) ) {
                alt97=1;
            }
            switch (alt97) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:11846:3: rule__JvmFormalParameter__ParameterTypeAssignment_0
                    {
                    pushFollow(FOLLOW_2);
                    rule__JvmFormalParameter__ParameterTypeAssignment_0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmFormalParameterAccess().getParameterTypeAssignment_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmFormalParameter__Group__0__Impl"


    // $ANTLR start "rule__JvmFormalParameter__Group__1"
    // InternalXbaseWithAnnotations.g:11854:1: rule__JvmFormalParameter__Group__1 : rule__JvmFormalParameter__Group__1__Impl ;
    public final void rule__JvmFormalParameter__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11858:1: ( rule__JvmFormalParameter__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:11859:2: rule__JvmFormalParameter__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmFormalParameter__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmFormalParameter__Group__1"


    // $ANTLR start "rule__JvmFormalParameter__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:11865:1: rule__JvmFormalParameter__Group__1__Impl : ( ( rule__JvmFormalParameter__NameAssignment_1 ) ) ;
    public final void rule__JvmFormalParameter__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11869:1: ( ( ( rule__JvmFormalParameter__NameAssignment_1 ) ) )
            // InternalXbaseWithAnnotations.g:11870:1: ( ( rule__JvmFormalParameter__NameAssignment_1 ) )
            {
            // InternalXbaseWithAnnotations.g:11870:1: ( ( rule__JvmFormalParameter__NameAssignment_1 ) )
            // InternalXbaseWithAnnotations.g:11871:2: ( rule__JvmFormalParameter__NameAssignment_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmFormalParameterAccess().getNameAssignment_1()); 
            }
            // InternalXbaseWithAnnotations.g:11872:2: ( rule__JvmFormalParameter__NameAssignment_1 )
            // InternalXbaseWithAnnotations.g:11872:3: rule__JvmFormalParameter__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__JvmFormalParameter__NameAssignment_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmFormalParameterAccess().getNameAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmFormalParameter__Group__1__Impl"


    // $ANTLR start "rule__FullJvmFormalParameter__Group__0"
    // InternalXbaseWithAnnotations.g:11881:1: rule__FullJvmFormalParameter__Group__0 : rule__FullJvmFormalParameter__Group__0__Impl rule__FullJvmFormalParameter__Group__1 ;
    public final void rule__FullJvmFormalParameter__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11885:1: ( rule__FullJvmFormalParameter__Group__0__Impl rule__FullJvmFormalParameter__Group__1 )
            // InternalXbaseWithAnnotations.g:11886:2: rule__FullJvmFormalParameter__Group__0__Impl rule__FullJvmFormalParameter__Group__1
            {
            pushFollow(FOLLOW_5);
            rule__FullJvmFormalParameter__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__FullJvmFormalParameter__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullJvmFormalParameter__Group__0"


    // $ANTLR start "rule__FullJvmFormalParameter__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:11893:1: rule__FullJvmFormalParameter__Group__0__Impl : ( ( rule__FullJvmFormalParameter__ParameterTypeAssignment_0 ) ) ;
    public final void rule__FullJvmFormalParameter__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11897:1: ( ( ( rule__FullJvmFormalParameter__ParameterTypeAssignment_0 ) ) )
            // InternalXbaseWithAnnotations.g:11898:1: ( ( rule__FullJvmFormalParameter__ParameterTypeAssignment_0 ) )
            {
            // InternalXbaseWithAnnotations.g:11898:1: ( ( rule__FullJvmFormalParameter__ParameterTypeAssignment_0 ) )
            // InternalXbaseWithAnnotations.g:11899:2: ( rule__FullJvmFormalParameter__ParameterTypeAssignment_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getFullJvmFormalParameterAccess().getParameterTypeAssignment_0()); 
            }
            // InternalXbaseWithAnnotations.g:11900:2: ( rule__FullJvmFormalParameter__ParameterTypeAssignment_0 )
            // InternalXbaseWithAnnotations.g:11900:3: rule__FullJvmFormalParameter__ParameterTypeAssignment_0
            {
            pushFollow(FOLLOW_2);
            rule__FullJvmFormalParameter__ParameterTypeAssignment_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getFullJvmFormalParameterAccess().getParameterTypeAssignment_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullJvmFormalParameter__Group__0__Impl"


    // $ANTLR start "rule__FullJvmFormalParameter__Group__1"
    // InternalXbaseWithAnnotations.g:11908:1: rule__FullJvmFormalParameter__Group__1 : rule__FullJvmFormalParameter__Group__1__Impl ;
    public final void rule__FullJvmFormalParameter__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11912:1: ( rule__FullJvmFormalParameter__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:11913:2: rule__FullJvmFormalParameter__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__FullJvmFormalParameter__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullJvmFormalParameter__Group__1"


    // $ANTLR start "rule__FullJvmFormalParameter__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:11919:1: rule__FullJvmFormalParameter__Group__1__Impl : ( ( rule__FullJvmFormalParameter__NameAssignment_1 ) ) ;
    public final void rule__FullJvmFormalParameter__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11923:1: ( ( ( rule__FullJvmFormalParameter__NameAssignment_1 ) ) )
            // InternalXbaseWithAnnotations.g:11924:1: ( ( rule__FullJvmFormalParameter__NameAssignment_1 ) )
            {
            // InternalXbaseWithAnnotations.g:11924:1: ( ( rule__FullJvmFormalParameter__NameAssignment_1 ) )
            // InternalXbaseWithAnnotations.g:11925:2: ( rule__FullJvmFormalParameter__NameAssignment_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getFullJvmFormalParameterAccess().getNameAssignment_1()); 
            }
            // InternalXbaseWithAnnotations.g:11926:2: ( rule__FullJvmFormalParameter__NameAssignment_1 )
            // InternalXbaseWithAnnotations.g:11926:3: rule__FullJvmFormalParameter__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__FullJvmFormalParameter__NameAssignment_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getFullJvmFormalParameterAccess().getNameAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullJvmFormalParameter__Group__1__Impl"


    // $ANTLR start "rule__XFeatureCall__Group__0"
    // InternalXbaseWithAnnotations.g:11935:1: rule__XFeatureCall__Group__0 : rule__XFeatureCall__Group__0__Impl rule__XFeatureCall__Group__1 ;
    public final void rule__XFeatureCall__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11939:1: ( rule__XFeatureCall__Group__0__Impl rule__XFeatureCall__Group__1 )
            // InternalXbaseWithAnnotations.g:11940:2: rule__XFeatureCall__Group__0__Impl rule__XFeatureCall__Group__1
            {
            pushFollow(FOLLOW_45);
            rule__XFeatureCall__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group__0"


    // $ANTLR start "rule__XFeatureCall__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:11947:1: rule__XFeatureCall__Group__0__Impl : ( () ) ;
    public final void rule__XFeatureCall__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11951:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:11952:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:11952:1: ( () )
            // InternalXbaseWithAnnotations.g:11953:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getXFeatureCallAction_0()); 
            }
            // InternalXbaseWithAnnotations.g:11954:2: ()
            // InternalXbaseWithAnnotations.g:11954:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getXFeatureCallAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group__0__Impl"


    // $ANTLR start "rule__XFeatureCall__Group__1"
    // InternalXbaseWithAnnotations.g:11962:1: rule__XFeatureCall__Group__1 : rule__XFeatureCall__Group__1__Impl rule__XFeatureCall__Group__2 ;
    public final void rule__XFeatureCall__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11966:1: ( rule__XFeatureCall__Group__1__Impl rule__XFeatureCall__Group__2 )
            // InternalXbaseWithAnnotations.g:11967:2: rule__XFeatureCall__Group__1__Impl rule__XFeatureCall__Group__2
            {
            pushFollow(FOLLOW_45);
            rule__XFeatureCall__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group__1"


    // $ANTLR start "rule__XFeatureCall__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:11974:1: rule__XFeatureCall__Group__1__Impl : ( ( rule__XFeatureCall__Group_1__0 )? ) ;
    public final void rule__XFeatureCall__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11978:1: ( ( ( rule__XFeatureCall__Group_1__0 )? ) )
            // InternalXbaseWithAnnotations.g:11979:1: ( ( rule__XFeatureCall__Group_1__0 )? )
            {
            // InternalXbaseWithAnnotations.g:11979:1: ( ( rule__XFeatureCall__Group_1__0 )? )
            // InternalXbaseWithAnnotations.g:11980:2: ( rule__XFeatureCall__Group_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getGroup_1()); 
            }
            // InternalXbaseWithAnnotations.g:11981:2: ( rule__XFeatureCall__Group_1__0 )?
            int alt98=2;
            int LA98_0 = input.LA(1);

            if ( (LA98_0==27) ) {
                alt98=1;
            }
            switch (alt98) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:11981:3: rule__XFeatureCall__Group_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XFeatureCall__Group_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group__1__Impl"


    // $ANTLR start "rule__XFeatureCall__Group__2"
    // InternalXbaseWithAnnotations.g:11989:1: rule__XFeatureCall__Group__2 : rule__XFeatureCall__Group__2__Impl rule__XFeatureCall__Group__3 ;
    public final void rule__XFeatureCall__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:11993:1: ( rule__XFeatureCall__Group__2__Impl rule__XFeatureCall__Group__3 )
            // InternalXbaseWithAnnotations.g:11994:2: rule__XFeatureCall__Group__2__Impl rule__XFeatureCall__Group__3
            {
            pushFollow(FOLLOW_46);
            rule__XFeatureCall__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group__2"


    // $ANTLR start "rule__XFeatureCall__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:12001:1: rule__XFeatureCall__Group__2__Impl : ( ( rule__XFeatureCall__FeatureAssignment_2 ) ) ;
    public final void rule__XFeatureCall__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12005:1: ( ( ( rule__XFeatureCall__FeatureAssignment_2 ) ) )
            // InternalXbaseWithAnnotations.g:12006:1: ( ( rule__XFeatureCall__FeatureAssignment_2 ) )
            {
            // InternalXbaseWithAnnotations.g:12006:1: ( ( rule__XFeatureCall__FeatureAssignment_2 ) )
            // InternalXbaseWithAnnotations.g:12007:2: ( rule__XFeatureCall__FeatureAssignment_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getFeatureAssignment_2()); 
            }
            // InternalXbaseWithAnnotations.g:12008:2: ( rule__XFeatureCall__FeatureAssignment_2 )
            // InternalXbaseWithAnnotations.g:12008:3: rule__XFeatureCall__FeatureAssignment_2
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__FeatureAssignment_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getFeatureAssignment_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group__2__Impl"


    // $ANTLR start "rule__XFeatureCall__Group__3"
    // InternalXbaseWithAnnotations.g:12016:1: rule__XFeatureCall__Group__3 : rule__XFeatureCall__Group__3__Impl rule__XFeatureCall__Group__4 ;
    public final void rule__XFeatureCall__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12020:1: ( rule__XFeatureCall__Group__3__Impl rule__XFeatureCall__Group__4 )
            // InternalXbaseWithAnnotations.g:12021:2: rule__XFeatureCall__Group__3__Impl rule__XFeatureCall__Group__4
            {
            pushFollow(FOLLOW_46);
            rule__XFeatureCall__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group__3"


    // $ANTLR start "rule__XFeatureCall__Group__3__Impl"
    // InternalXbaseWithAnnotations.g:12028:1: rule__XFeatureCall__Group__3__Impl : ( ( rule__XFeatureCall__Group_3__0 )? ) ;
    public final void rule__XFeatureCall__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12032:1: ( ( ( rule__XFeatureCall__Group_3__0 )? ) )
            // InternalXbaseWithAnnotations.g:12033:1: ( ( rule__XFeatureCall__Group_3__0 )? )
            {
            // InternalXbaseWithAnnotations.g:12033:1: ( ( rule__XFeatureCall__Group_3__0 )? )
            // InternalXbaseWithAnnotations.g:12034:2: ( rule__XFeatureCall__Group_3__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getGroup_3()); 
            }
            // InternalXbaseWithAnnotations.g:12035:2: ( rule__XFeatureCall__Group_3__0 )?
            int alt99=2;
            alt99 = dfa99.predict(input);
            switch (alt99) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:12035:3: rule__XFeatureCall__Group_3__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XFeatureCall__Group_3__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getGroup_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group__3__Impl"


    // $ANTLR start "rule__XFeatureCall__Group__4"
    // InternalXbaseWithAnnotations.g:12043:1: rule__XFeatureCall__Group__4 : rule__XFeatureCall__Group__4__Impl ;
    public final void rule__XFeatureCall__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12047:1: ( rule__XFeatureCall__Group__4__Impl )
            // InternalXbaseWithAnnotations.g:12048:2: rule__XFeatureCall__Group__4__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group__4__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group__4"


    // $ANTLR start "rule__XFeatureCall__Group__4__Impl"
    // InternalXbaseWithAnnotations.g:12054:1: rule__XFeatureCall__Group__4__Impl : ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_4 )? ) ;
    public final void rule__XFeatureCall__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12058:1: ( ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_4 )? ) )
            // InternalXbaseWithAnnotations.g:12059:1: ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_4 )? )
            {
            // InternalXbaseWithAnnotations.g:12059:1: ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_4 )? )
            // InternalXbaseWithAnnotations.g:12060:2: ( rule__XFeatureCall__FeatureCallArgumentsAssignment_4 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsAssignment_4()); 
            }
            // InternalXbaseWithAnnotations.g:12061:2: ( rule__XFeatureCall__FeatureCallArgumentsAssignment_4 )?
            int alt100=2;
            alt100 = dfa100.predict(input);
            switch (alt100) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:12061:3: rule__XFeatureCall__FeatureCallArgumentsAssignment_4
                    {
                    pushFollow(FOLLOW_2);
                    rule__XFeatureCall__FeatureCallArgumentsAssignment_4();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsAssignment_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group__4__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_1__0"
    // InternalXbaseWithAnnotations.g:12070:1: rule__XFeatureCall__Group_1__0 : rule__XFeatureCall__Group_1__0__Impl rule__XFeatureCall__Group_1__1 ;
    public final void rule__XFeatureCall__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12074:1: ( rule__XFeatureCall__Group_1__0__Impl rule__XFeatureCall__Group_1__1 )
            // InternalXbaseWithAnnotations.g:12075:2: rule__XFeatureCall__Group_1__0__Impl rule__XFeatureCall__Group_1__1
            {
            pushFollow(FOLLOW_47);
            rule__XFeatureCall__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_1__0"


    // $ANTLR start "rule__XFeatureCall__Group_1__0__Impl"
    // InternalXbaseWithAnnotations.g:12082:1: rule__XFeatureCall__Group_1__0__Impl : ( '<' ) ;
    public final void rule__XFeatureCall__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12086:1: ( ( '<' ) )
            // InternalXbaseWithAnnotations.g:12087:1: ( '<' )
            {
            // InternalXbaseWithAnnotations.g:12087:1: ( '<' )
            // InternalXbaseWithAnnotations.g:12088:2: '<'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getLessThanSignKeyword_1_0()); 
            }
            match(input,27,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getLessThanSignKeyword_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_1__0__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_1__1"
    // InternalXbaseWithAnnotations.g:12097:1: rule__XFeatureCall__Group_1__1 : rule__XFeatureCall__Group_1__1__Impl rule__XFeatureCall__Group_1__2 ;
    public final void rule__XFeatureCall__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12101:1: ( rule__XFeatureCall__Group_1__1__Impl rule__XFeatureCall__Group_1__2 )
            // InternalXbaseWithAnnotations.g:12102:2: rule__XFeatureCall__Group_1__1__Impl rule__XFeatureCall__Group_1__2
            {
            pushFollow(FOLLOW_48);
            rule__XFeatureCall__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_1__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_1__1"


    // $ANTLR start "rule__XFeatureCall__Group_1__1__Impl"
    // InternalXbaseWithAnnotations.g:12109:1: rule__XFeatureCall__Group_1__1__Impl : ( ( rule__XFeatureCall__TypeArgumentsAssignment_1_1 ) ) ;
    public final void rule__XFeatureCall__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12113:1: ( ( ( rule__XFeatureCall__TypeArgumentsAssignment_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:12114:1: ( ( rule__XFeatureCall__TypeArgumentsAssignment_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:12114:1: ( ( rule__XFeatureCall__TypeArgumentsAssignment_1_1 ) )
            // InternalXbaseWithAnnotations.g:12115:2: ( rule__XFeatureCall__TypeArgumentsAssignment_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getTypeArgumentsAssignment_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:12116:2: ( rule__XFeatureCall__TypeArgumentsAssignment_1_1 )
            // InternalXbaseWithAnnotations.g:12116:3: rule__XFeatureCall__TypeArgumentsAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__TypeArgumentsAssignment_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getTypeArgumentsAssignment_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_1__1__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_1__2"
    // InternalXbaseWithAnnotations.g:12124:1: rule__XFeatureCall__Group_1__2 : rule__XFeatureCall__Group_1__2__Impl rule__XFeatureCall__Group_1__3 ;
    public final void rule__XFeatureCall__Group_1__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12128:1: ( rule__XFeatureCall__Group_1__2__Impl rule__XFeatureCall__Group_1__3 )
            // InternalXbaseWithAnnotations.g:12129:2: rule__XFeatureCall__Group_1__2__Impl rule__XFeatureCall__Group_1__3
            {
            pushFollow(FOLLOW_48);
            rule__XFeatureCall__Group_1__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_1__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_1__2"


    // $ANTLR start "rule__XFeatureCall__Group_1__2__Impl"
    // InternalXbaseWithAnnotations.g:12136:1: rule__XFeatureCall__Group_1__2__Impl : ( ( rule__XFeatureCall__Group_1_2__0 )* ) ;
    public final void rule__XFeatureCall__Group_1__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12140:1: ( ( ( rule__XFeatureCall__Group_1_2__0 )* ) )
            // InternalXbaseWithAnnotations.g:12141:1: ( ( rule__XFeatureCall__Group_1_2__0 )* )
            {
            // InternalXbaseWithAnnotations.g:12141:1: ( ( rule__XFeatureCall__Group_1_2__0 )* )
            // InternalXbaseWithAnnotations.g:12142:2: ( rule__XFeatureCall__Group_1_2__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getGroup_1_2()); 
            }
            // InternalXbaseWithAnnotations.g:12143:2: ( rule__XFeatureCall__Group_1_2__0 )*
            loop101:
            do {
                int alt101=2;
                int LA101_0 = input.LA(1);

                if ( (LA101_0==54) ) {
                    alt101=1;
                }


                switch (alt101) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:12143:3: rule__XFeatureCall__Group_1_2__0
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__XFeatureCall__Group_1_2__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop101;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getGroup_1_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_1__2__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_1__3"
    // InternalXbaseWithAnnotations.g:12151:1: rule__XFeatureCall__Group_1__3 : rule__XFeatureCall__Group_1__3__Impl ;
    public final void rule__XFeatureCall__Group_1__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12155:1: ( rule__XFeatureCall__Group_1__3__Impl )
            // InternalXbaseWithAnnotations.g:12156:2: rule__XFeatureCall__Group_1__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_1__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_1__3"


    // $ANTLR start "rule__XFeatureCall__Group_1__3__Impl"
    // InternalXbaseWithAnnotations.g:12162:1: rule__XFeatureCall__Group_1__3__Impl : ( '>' ) ;
    public final void rule__XFeatureCall__Group_1__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12166:1: ( ( '>' ) )
            // InternalXbaseWithAnnotations.g:12167:1: ( '>' )
            {
            // InternalXbaseWithAnnotations.g:12167:1: ( '>' )
            // InternalXbaseWithAnnotations.g:12168:2: '>'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getGreaterThanSignKeyword_1_3()); 
            }
            match(input,26,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getGreaterThanSignKeyword_1_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_1__3__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_1_2__0"
    // InternalXbaseWithAnnotations.g:12178:1: rule__XFeatureCall__Group_1_2__0 : rule__XFeatureCall__Group_1_2__0__Impl rule__XFeatureCall__Group_1_2__1 ;
    public final void rule__XFeatureCall__Group_1_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12182:1: ( rule__XFeatureCall__Group_1_2__0__Impl rule__XFeatureCall__Group_1_2__1 )
            // InternalXbaseWithAnnotations.g:12183:2: rule__XFeatureCall__Group_1_2__0__Impl rule__XFeatureCall__Group_1_2__1
            {
            pushFollow(FOLLOW_47);
            rule__XFeatureCall__Group_1_2__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_1_2__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_1_2__0"


    // $ANTLR start "rule__XFeatureCall__Group_1_2__0__Impl"
    // InternalXbaseWithAnnotations.g:12190:1: rule__XFeatureCall__Group_1_2__0__Impl : ( ',' ) ;
    public final void rule__XFeatureCall__Group_1_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12194:1: ( ( ',' ) )
            // InternalXbaseWithAnnotations.g:12195:1: ( ',' )
            {
            // InternalXbaseWithAnnotations.g:12195:1: ( ',' )
            // InternalXbaseWithAnnotations.g:12196:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getCommaKeyword_1_2_0()); 
            }
            match(input,54,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getCommaKeyword_1_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_1_2__0__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_1_2__1"
    // InternalXbaseWithAnnotations.g:12205:1: rule__XFeatureCall__Group_1_2__1 : rule__XFeatureCall__Group_1_2__1__Impl ;
    public final void rule__XFeatureCall__Group_1_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12209:1: ( rule__XFeatureCall__Group_1_2__1__Impl )
            // InternalXbaseWithAnnotations.g:12210:2: rule__XFeatureCall__Group_1_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_1_2__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_1_2__1"


    // $ANTLR start "rule__XFeatureCall__Group_1_2__1__Impl"
    // InternalXbaseWithAnnotations.g:12216:1: rule__XFeatureCall__Group_1_2__1__Impl : ( ( rule__XFeatureCall__TypeArgumentsAssignment_1_2_1 ) ) ;
    public final void rule__XFeatureCall__Group_1_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12220:1: ( ( ( rule__XFeatureCall__TypeArgumentsAssignment_1_2_1 ) ) )
            // InternalXbaseWithAnnotations.g:12221:1: ( ( rule__XFeatureCall__TypeArgumentsAssignment_1_2_1 ) )
            {
            // InternalXbaseWithAnnotations.g:12221:1: ( ( rule__XFeatureCall__TypeArgumentsAssignment_1_2_1 ) )
            // InternalXbaseWithAnnotations.g:12222:2: ( rule__XFeatureCall__TypeArgumentsAssignment_1_2_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getTypeArgumentsAssignment_1_2_1()); 
            }
            // InternalXbaseWithAnnotations.g:12223:2: ( rule__XFeatureCall__TypeArgumentsAssignment_1_2_1 )
            // InternalXbaseWithAnnotations.g:12223:3: rule__XFeatureCall__TypeArgumentsAssignment_1_2_1
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__TypeArgumentsAssignment_1_2_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getTypeArgumentsAssignment_1_2_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_1_2__1__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_3__0"
    // InternalXbaseWithAnnotations.g:12232:1: rule__XFeatureCall__Group_3__0 : rule__XFeatureCall__Group_3__0__Impl rule__XFeatureCall__Group_3__1 ;
    public final void rule__XFeatureCall__Group_3__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12236:1: ( rule__XFeatureCall__Group_3__0__Impl rule__XFeatureCall__Group_3__1 )
            // InternalXbaseWithAnnotations.g:12237:2: rule__XFeatureCall__Group_3__0__Impl rule__XFeatureCall__Group_3__1
            {
            pushFollow(FOLLOW_49);
            rule__XFeatureCall__Group_3__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_3__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3__0"


    // $ANTLR start "rule__XFeatureCall__Group_3__0__Impl"
    // InternalXbaseWithAnnotations.g:12244:1: rule__XFeatureCall__Group_3__0__Impl : ( ( rule__XFeatureCall__ExplicitOperationCallAssignment_3_0 ) ) ;
    public final void rule__XFeatureCall__Group_3__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12248:1: ( ( ( rule__XFeatureCall__ExplicitOperationCallAssignment_3_0 ) ) )
            // InternalXbaseWithAnnotations.g:12249:1: ( ( rule__XFeatureCall__ExplicitOperationCallAssignment_3_0 ) )
            {
            // InternalXbaseWithAnnotations.g:12249:1: ( ( rule__XFeatureCall__ExplicitOperationCallAssignment_3_0 ) )
            // InternalXbaseWithAnnotations.g:12250:2: ( rule__XFeatureCall__ExplicitOperationCallAssignment_3_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getExplicitOperationCallAssignment_3_0()); 
            }
            // InternalXbaseWithAnnotations.g:12251:2: ( rule__XFeatureCall__ExplicitOperationCallAssignment_3_0 )
            // InternalXbaseWithAnnotations.g:12251:3: rule__XFeatureCall__ExplicitOperationCallAssignment_3_0
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__ExplicitOperationCallAssignment_3_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getExplicitOperationCallAssignment_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3__0__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_3__1"
    // InternalXbaseWithAnnotations.g:12259:1: rule__XFeatureCall__Group_3__1 : rule__XFeatureCall__Group_3__1__Impl rule__XFeatureCall__Group_3__2 ;
    public final void rule__XFeatureCall__Group_3__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12263:1: ( rule__XFeatureCall__Group_3__1__Impl rule__XFeatureCall__Group_3__2 )
            // InternalXbaseWithAnnotations.g:12264:2: rule__XFeatureCall__Group_3__1__Impl rule__XFeatureCall__Group_3__2
            {
            pushFollow(FOLLOW_49);
            rule__XFeatureCall__Group_3__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_3__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3__1"


    // $ANTLR start "rule__XFeatureCall__Group_3__1__Impl"
    // InternalXbaseWithAnnotations.g:12271:1: rule__XFeatureCall__Group_3__1__Impl : ( ( rule__XFeatureCall__Alternatives_3_1 )? ) ;
    public final void rule__XFeatureCall__Group_3__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12275:1: ( ( ( rule__XFeatureCall__Alternatives_3_1 )? ) )
            // InternalXbaseWithAnnotations.g:12276:1: ( ( rule__XFeatureCall__Alternatives_3_1 )? )
            {
            // InternalXbaseWithAnnotations.g:12276:1: ( ( rule__XFeatureCall__Alternatives_3_1 )? )
            // InternalXbaseWithAnnotations.g:12277:2: ( rule__XFeatureCall__Alternatives_3_1 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getAlternatives_3_1()); 
            }
            // InternalXbaseWithAnnotations.g:12278:2: ( rule__XFeatureCall__Alternatives_3_1 )?
            int alt102=2;
            int LA102_0 = input.LA(1);

            if ( ((LA102_0>=RULE_ID && LA102_0<=RULE_STRING)||LA102_0==27||LA102_0==31||(LA102_0>=34 && LA102_0<=35)||LA102_0==40||(LA102_0>=45 && LA102_0<=50)||LA102_0==52||(LA102_0>=56 && LA102_0<=57)||LA102_0==60||LA102_0==63||LA102_0==65||(LA102_0>=69 && LA102_0<=77)||LA102_0==79||LA102_0==85||LA102_0==87) ) {
                alt102=1;
            }
            switch (alt102) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:12278:3: rule__XFeatureCall__Alternatives_3_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XFeatureCall__Alternatives_3_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getAlternatives_3_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3__1__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_3__2"
    // InternalXbaseWithAnnotations.g:12286:1: rule__XFeatureCall__Group_3__2 : rule__XFeatureCall__Group_3__2__Impl ;
    public final void rule__XFeatureCall__Group_3__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12290:1: ( rule__XFeatureCall__Group_3__2__Impl )
            // InternalXbaseWithAnnotations.g:12291:2: rule__XFeatureCall__Group_3__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_3__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3__2"


    // $ANTLR start "rule__XFeatureCall__Group_3__2__Impl"
    // InternalXbaseWithAnnotations.g:12297:1: rule__XFeatureCall__Group_3__2__Impl : ( ')' ) ;
    public final void rule__XFeatureCall__Group_3__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12301:1: ( ( ')' ) )
            // InternalXbaseWithAnnotations.g:12302:1: ( ')' )
            {
            // InternalXbaseWithAnnotations.g:12302:1: ( ')' )
            // InternalXbaseWithAnnotations.g:12303:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getRightParenthesisKeyword_3_2()); 
            }
            match(input,53,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getRightParenthesisKeyword_3_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3__2__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_3_1_1__0"
    // InternalXbaseWithAnnotations.g:12313:1: rule__XFeatureCall__Group_3_1_1__0 : rule__XFeatureCall__Group_3_1_1__0__Impl rule__XFeatureCall__Group_3_1_1__1 ;
    public final void rule__XFeatureCall__Group_3_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12317:1: ( rule__XFeatureCall__Group_3_1_1__0__Impl rule__XFeatureCall__Group_3_1_1__1 )
            // InternalXbaseWithAnnotations.g:12318:2: rule__XFeatureCall__Group_3_1_1__0__Impl rule__XFeatureCall__Group_3_1_1__1
            {
            pushFollow(FOLLOW_8);
            rule__XFeatureCall__Group_3_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_3_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3_1_1__0"


    // $ANTLR start "rule__XFeatureCall__Group_3_1_1__0__Impl"
    // InternalXbaseWithAnnotations.g:12325:1: rule__XFeatureCall__Group_3_1_1__0__Impl : ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_0 ) ) ;
    public final void rule__XFeatureCall__Group_3_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12329:1: ( ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_0 ) ) )
            // InternalXbaseWithAnnotations.g:12330:1: ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_0 ) )
            {
            // InternalXbaseWithAnnotations.g:12330:1: ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_0 ) )
            // InternalXbaseWithAnnotations.g:12331:2: ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsAssignment_3_1_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:12332:2: ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_0 )
            // InternalXbaseWithAnnotations.g:12332:3: rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_0
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsAssignment_3_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3_1_1__0__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_3_1_1__1"
    // InternalXbaseWithAnnotations.g:12340:1: rule__XFeatureCall__Group_3_1_1__1 : rule__XFeatureCall__Group_3_1_1__1__Impl ;
    public final void rule__XFeatureCall__Group_3_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12344:1: ( rule__XFeatureCall__Group_3_1_1__1__Impl )
            // InternalXbaseWithAnnotations.g:12345:2: rule__XFeatureCall__Group_3_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_3_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3_1_1__1"


    // $ANTLR start "rule__XFeatureCall__Group_3_1_1__1__Impl"
    // InternalXbaseWithAnnotations.g:12351:1: rule__XFeatureCall__Group_3_1_1__1__Impl : ( ( rule__XFeatureCall__Group_3_1_1_1__0 )* ) ;
    public final void rule__XFeatureCall__Group_3_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12355:1: ( ( ( rule__XFeatureCall__Group_3_1_1_1__0 )* ) )
            // InternalXbaseWithAnnotations.g:12356:1: ( ( rule__XFeatureCall__Group_3_1_1_1__0 )* )
            {
            // InternalXbaseWithAnnotations.g:12356:1: ( ( rule__XFeatureCall__Group_3_1_1_1__0 )* )
            // InternalXbaseWithAnnotations.g:12357:2: ( rule__XFeatureCall__Group_3_1_1_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getGroup_3_1_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:12358:2: ( rule__XFeatureCall__Group_3_1_1_1__0 )*
            loop103:
            do {
                int alt103=2;
                int LA103_0 = input.LA(1);

                if ( (LA103_0==54) ) {
                    alt103=1;
                }


                switch (alt103) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:12358:3: rule__XFeatureCall__Group_3_1_1_1__0
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__XFeatureCall__Group_3_1_1_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop103;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getGroup_3_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3_1_1__1__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_3_1_1_1__0"
    // InternalXbaseWithAnnotations.g:12367:1: rule__XFeatureCall__Group_3_1_1_1__0 : rule__XFeatureCall__Group_3_1_1_1__0__Impl rule__XFeatureCall__Group_3_1_1_1__1 ;
    public final void rule__XFeatureCall__Group_3_1_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12371:1: ( rule__XFeatureCall__Group_3_1_1_1__0__Impl rule__XFeatureCall__Group_3_1_1_1__1 )
            // InternalXbaseWithAnnotations.g:12372:2: rule__XFeatureCall__Group_3_1_1_1__0__Impl rule__XFeatureCall__Group_3_1_1_1__1
            {
            pushFollow(FOLLOW_10);
            rule__XFeatureCall__Group_3_1_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_3_1_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3_1_1_1__0"


    // $ANTLR start "rule__XFeatureCall__Group_3_1_1_1__0__Impl"
    // InternalXbaseWithAnnotations.g:12379:1: rule__XFeatureCall__Group_3_1_1_1__0__Impl : ( ',' ) ;
    public final void rule__XFeatureCall__Group_3_1_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12383:1: ( ( ',' ) )
            // InternalXbaseWithAnnotations.g:12384:1: ( ',' )
            {
            // InternalXbaseWithAnnotations.g:12384:1: ( ',' )
            // InternalXbaseWithAnnotations.g:12385:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getCommaKeyword_3_1_1_1_0()); 
            }
            match(input,54,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getCommaKeyword_3_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3_1_1_1__0__Impl"


    // $ANTLR start "rule__XFeatureCall__Group_3_1_1_1__1"
    // InternalXbaseWithAnnotations.g:12394:1: rule__XFeatureCall__Group_3_1_1_1__1 : rule__XFeatureCall__Group_3_1_1_1__1__Impl ;
    public final void rule__XFeatureCall__Group_3_1_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12398:1: ( rule__XFeatureCall__Group_3_1_1_1__1__Impl )
            // InternalXbaseWithAnnotations.g:12399:2: rule__XFeatureCall__Group_3_1_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__Group_3_1_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3_1_1_1__1"


    // $ANTLR start "rule__XFeatureCall__Group_3_1_1_1__1__Impl"
    // InternalXbaseWithAnnotations.g:12405:1: rule__XFeatureCall__Group_3_1_1_1__1__Impl : ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_1_1 ) ) ;
    public final void rule__XFeatureCall__Group_3_1_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12409:1: ( ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:12410:1: ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:12410:1: ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_1_1 ) )
            // InternalXbaseWithAnnotations.g:12411:2: ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsAssignment_3_1_1_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:12412:2: ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_1_1 )
            // InternalXbaseWithAnnotations.g:12412:3: rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsAssignment_3_1_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__Group_3_1_1_1__1__Impl"


    // $ANTLR start "rule__XConstructorCall__Group__0"
    // InternalXbaseWithAnnotations.g:12421:1: rule__XConstructorCall__Group__0 : rule__XConstructorCall__Group__0__Impl rule__XConstructorCall__Group__1 ;
    public final void rule__XConstructorCall__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12425:1: ( rule__XConstructorCall__Group__0__Impl rule__XConstructorCall__Group__1 )
            // InternalXbaseWithAnnotations.g:12426:2: rule__XConstructorCall__Group__0__Impl rule__XConstructorCall__Group__1
            {
            pushFollow(FOLLOW_74);
            rule__XConstructorCall__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group__0"


    // $ANTLR start "rule__XConstructorCall__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:12433:1: rule__XConstructorCall__Group__0__Impl : ( () ) ;
    public final void rule__XConstructorCall__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12437:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:12438:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:12438:1: ( () )
            // InternalXbaseWithAnnotations.g:12439:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getXConstructorCallAction_0()); 
            }
            // InternalXbaseWithAnnotations.g:12440:2: ()
            // InternalXbaseWithAnnotations.g:12440:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getXConstructorCallAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group__0__Impl"


    // $ANTLR start "rule__XConstructorCall__Group__1"
    // InternalXbaseWithAnnotations.g:12448:1: rule__XConstructorCall__Group__1 : rule__XConstructorCall__Group__1__Impl rule__XConstructorCall__Group__2 ;
    public final void rule__XConstructorCall__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12452:1: ( rule__XConstructorCall__Group__1__Impl rule__XConstructorCall__Group__2 )
            // InternalXbaseWithAnnotations.g:12453:2: rule__XConstructorCall__Group__1__Impl rule__XConstructorCall__Group__2
            {
            pushFollow(FOLLOW_5);
            rule__XConstructorCall__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group__1"


    // $ANTLR start "rule__XConstructorCall__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:12460:1: rule__XConstructorCall__Group__1__Impl : ( 'new' ) ;
    public final void rule__XConstructorCall__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12464:1: ( ( 'new' ) )
            // InternalXbaseWithAnnotations.g:12465:1: ( 'new' )
            {
            // InternalXbaseWithAnnotations.g:12465:1: ( 'new' )
            // InternalXbaseWithAnnotations.g:12466:2: 'new'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getNewKeyword_1()); 
            }
            match(input,72,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getNewKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group__1__Impl"


    // $ANTLR start "rule__XConstructorCall__Group__2"
    // InternalXbaseWithAnnotations.g:12475:1: rule__XConstructorCall__Group__2 : rule__XConstructorCall__Group__2__Impl rule__XConstructorCall__Group__3 ;
    public final void rule__XConstructorCall__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12479:1: ( rule__XConstructorCall__Group__2__Impl rule__XConstructorCall__Group__3 )
            // InternalXbaseWithAnnotations.g:12480:2: rule__XConstructorCall__Group__2__Impl rule__XConstructorCall__Group__3
            {
            pushFollow(FOLLOW_75);
            rule__XConstructorCall__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group__2"


    // $ANTLR start "rule__XConstructorCall__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:12487:1: rule__XConstructorCall__Group__2__Impl : ( ( rule__XConstructorCall__ConstructorAssignment_2 ) ) ;
    public final void rule__XConstructorCall__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12491:1: ( ( ( rule__XConstructorCall__ConstructorAssignment_2 ) ) )
            // InternalXbaseWithAnnotations.g:12492:1: ( ( rule__XConstructorCall__ConstructorAssignment_2 ) )
            {
            // InternalXbaseWithAnnotations.g:12492:1: ( ( rule__XConstructorCall__ConstructorAssignment_2 ) )
            // InternalXbaseWithAnnotations.g:12493:2: ( rule__XConstructorCall__ConstructorAssignment_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getConstructorAssignment_2()); 
            }
            // InternalXbaseWithAnnotations.g:12494:2: ( rule__XConstructorCall__ConstructorAssignment_2 )
            // InternalXbaseWithAnnotations.g:12494:3: rule__XConstructorCall__ConstructorAssignment_2
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__ConstructorAssignment_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getConstructorAssignment_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group__2__Impl"


    // $ANTLR start "rule__XConstructorCall__Group__3"
    // InternalXbaseWithAnnotations.g:12502:1: rule__XConstructorCall__Group__3 : rule__XConstructorCall__Group__3__Impl rule__XConstructorCall__Group__4 ;
    public final void rule__XConstructorCall__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12506:1: ( rule__XConstructorCall__Group__3__Impl rule__XConstructorCall__Group__4 )
            // InternalXbaseWithAnnotations.g:12507:2: rule__XConstructorCall__Group__3__Impl rule__XConstructorCall__Group__4
            {
            pushFollow(FOLLOW_75);
            rule__XConstructorCall__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group__3"


    // $ANTLR start "rule__XConstructorCall__Group__3__Impl"
    // InternalXbaseWithAnnotations.g:12514:1: rule__XConstructorCall__Group__3__Impl : ( ( rule__XConstructorCall__Group_3__0 )? ) ;
    public final void rule__XConstructorCall__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12518:1: ( ( ( rule__XConstructorCall__Group_3__0 )? ) )
            // InternalXbaseWithAnnotations.g:12519:1: ( ( rule__XConstructorCall__Group_3__0 )? )
            {
            // InternalXbaseWithAnnotations.g:12519:1: ( ( rule__XConstructorCall__Group_3__0 )? )
            // InternalXbaseWithAnnotations.g:12520:2: ( rule__XConstructorCall__Group_3__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getGroup_3()); 
            }
            // InternalXbaseWithAnnotations.g:12521:2: ( rule__XConstructorCall__Group_3__0 )?
            int alt104=2;
            alt104 = dfa104.predict(input);
            switch (alt104) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:12521:3: rule__XConstructorCall__Group_3__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XConstructorCall__Group_3__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getGroup_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group__3__Impl"


    // $ANTLR start "rule__XConstructorCall__Group__4"
    // InternalXbaseWithAnnotations.g:12529:1: rule__XConstructorCall__Group__4 : rule__XConstructorCall__Group__4__Impl rule__XConstructorCall__Group__5 ;
    public final void rule__XConstructorCall__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12533:1: ( rule__XConstructorCall__Group__4__Impl rule__XConstructorCall__Group__5 )
            // InternalXbaseWithAnnotations.g:12534:2: rule__XConstructorCall__Group__4__Impl rule__XConstructorCall__Group__5
            {
            pushFollow(FOLLOW_75);
            rule__XConstructorCall__Group__4__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group__5();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group__4"


    // $ANTLR start "rule__XConstructorCall__Group__4__Impl"
    // InternalXbaseWithAnnotations.g:12541:1: rule__XConstructorCall__Group__4__Impl : ( ( rule__XConstructorCall__Group_4__0 )? ) ;
    public final void rule__XConstructorCall__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12545:1: ( ( ( rule__XConstructorCall__Group_4__0 )? ) )
            // InternalXbaseWithAnnotations.g:12546:1: ( ( rule__XConstructorCall__Group_4__0 )? )
            {
            // InternalXbaseWithAnnotations.g:12546:1: ( ( rule__XConstructorCall__Group_4__0 )? )
            // InternalXbaseWithAnnotations.g:12547:2: ( rule__XConstructorCall__Group_4__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getGroup_4()); 
            }
            // InternalXbaseWithAnnotations.g:12548:2: ( rule__XConstructorCall__Group_4__0 )?
            int alt105=2;
            alt105 = dfa105.predict(input);
            switch (alt105) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:12548:3: rule__XConstructorCall__Group_4__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XConstructorCall__Group_4__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getGroup_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group__4__Impl"


    // $ANTLR start "rule__XConstructorCall__Group__5"
    // InternalXbaseWithAnnotations.g:12556:1: rule__XConstructorCall__Group__5 : rule__XConstructorCall__Group__5__Impl ;
    public final void rule__XConstructorCall__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12560:1: ( rule__XConstructorCall__Group__5__Impl )
            // InternalXbaseWithAnnotations.g:12561:2: rule__XConstructorCall__Group__5__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group__5__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group__5"


    // $ANTLR start "rule__XConstructorCall__Group__5__Impl"
    // InternalXbaseWithAnnotations.g:12567:1: rule__XConstructorCall__Group__5__Impl : ( ( rule__XConstructorCall__ArgumentsAssignment_5 )? ) ;
    public final void rule__XConstructorCall__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12571:1: ( ( ( rule__XConstructorCall__ArgumentsAssignment_5 )? ) )
            // InternalXbaseWithAnnotations.g:12572:1: ( ( rule__XConstructorCall__ArgumentsAssignment_5 )? )
            {
            // InternalXbaseWithAnnotations.g:12572:1: ( ( rule__XConstructorCall__ArgumentsAssignment_5 )? )
            // InternalXbaseWithAnnotations.g:12573:2: ( rule__XConstructorCall__ArgumentsAssignment_5 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getArgumentsAssignment_5()); 
            }
            // InternalXbaseWithAnnotations.g:12574:2: ( rule__XConstructorCall__ArgumentsAssignment_5 )?
            int alt106=2;
            alt106 = dfa106.predict(input);
            switch (alt106) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:12574:3: rule__XConstructorCall__ArgumentsAssignment_5
                    {
                    pushFollow(FOLLOW_2);
                    rule__XConstructorCall__ArgumentsAssignment_5();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getArgumentsAssignment_5()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group__5__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_3__0"
    // InternalXbaseWithAnnotations.g:12583:1: rule__XConstructorCall__Group_3__0 : rule__XConstructorCall__Group_3__0__Impl rule__XConstructorCall__Group_3__1 ;
    public final void rule__XConstructorCall__Group_3__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12587:1: ( rule__XConstructorCall__Group_3__0__Impl rule__XConstructorCall__Group_3__1 )
            // InternalXbaseWithAnnotations.g:12588:2: rule__XConstructorCall__Group_3__0__Impl rule__XConstructorCall__Group_3__1
            {
            pushFollow(FOLLOW_47);
            rule__XConstructorCall__Group_3__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_3__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_3__0"


    // $ANTLR start "rule__XConstructorCall__Group_3__0__Impl"
    // InternalXbaseWithAnnotations.g:12595:1: rule__XConstructorCall__Group_3__0__Impl : ( ( '<' ) ) ;
    public final void rule__XConstructorCall__Group_3__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12599:1: ( ( ( '<' ) ) )
            // InternalXbaseWithAnnotations.g:12600:1: ( ( '<' ) )
            {
            // InternalXbaseWithAnnotations.g:12600:1: ( ( '<' ) )
            // InternalXbaseWithAnnotations.g:12601:2: ( '<' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getLessThanSignKeyword_3_0()); 
            }
            // InternalXbaseWithAnnotations.g:12602:2: ( '<' )
            // InternalXbaseWithAnnotations.g:12602:3: '<'
            {
            match(input,27,FOLLOW_2); if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getLessThanSignKeyword_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_3__0__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_3__1"
    // InternalXbaseWithAnnotations.g:12610:1: rule__XConstructorCall__Group_3__1 : rule__XConstructorCall__Group_3__1__Impl rule__XConstructorCall__Group_3__2 ;
    public final void rule__XConstructorCall__Group_3__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12614:1: ( rule__XConstructorCall__Group_3__1__Impl rule__XConstructorCall__Group_3__2 )
            // InternalXbaseWithAnnotations.g:12615:2: rule__XConstructorCall__Group_3__1__Impl rule__XConstructorCall__Group_3__2
            {
            pushFollow(FOLLOW_48);
            rule__XConstructorCall__Group_3__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_3__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_3__1"


    // $ANTLR start "rule__XConstructorCall__Group_3__1__Impl"
    // InternalXbaseWithAnnotations.g:12622:1: rule__XConstructorCall__Group_3__1__Impl : ( ( rule__XConstructorCall__TypeArgumentsAssignment_3_1 ) ) ;
    public final void rule__XConstructorCall__Group_3__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12626:1: ( ( ( rule__XConstructorCall__TypeArgumentsAssignment_3_1 ) ) )
            // InternalXbaseWithAnnotations.g:12627:1: ( ( rule__XConstructorCall__TypeArgumentsAssignment_3_1 ) )
            {
            // InternalXbaseWithAnnotations.g:12627:1: ( ( rule__XConstructorCall__TypeArgumentsAssignment_3_1 ) )
            // InternalXbaseWithAnnotations.g:12628:2: ( rule__XConstructorCall__TypeArgumentsAssignment_3_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getTypeArgumentsAssignment_3_1()); 
            }
            // InternalXbaseWithAnnotations.g:12629:2: ( rule__XConstructorCall__TypeArgumentsAssignment_3_1 )
            // InternalXbaseWithAnnotations.g:12629:3: rule__XConstructorCall__TypeArgumentsAssignment_3_1
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__TypeArgumentsAssignment_3_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getTypeArgumentsAssignment_3_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_3__1__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_3__2"
    // InternalXbaseWithAnnotations.g:12637:1: rule__XConstructorCall__Group_3__2 : rule__XConstructorCall__Group_3__2__Impl rule__XConstructorCall__Group_3__3 ;
    public final void rule__XConstructorCall__Group_3__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12641:1: ( rule__XConstructorCall__Group_3__2__Impl rule__XConstructorCall__Group_3__3 )
            // InternalXbaseWithAnnotations.g:12642:2: rule__XConstructorCall__Group_3__2__Impl rule__XConstructorCall__Group_3__3
            {
            pushFollow(FOLLOW_48);
            rule__XConstructorCall__Group_3__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_3__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_3__2"


    // $ANTLR start "rule__XConstructorCall__Group_3__2__Impl"
    // InternalXbaseWithAnnotations.g:12649:1: rule__XConstructorCall__Group_3__2__Impl : ( ( rule__XConstructorCall__Group_3_2__0 )* ) ;
    public final void rule__XConstructorCall__Group_3__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12653:1: ( ( ( rule__XConstructorCall__Group_3_2__0 )* ) )
            // InternalXbaseWithAnnotations.g:12654:1: ( ( rule__XConstructorCall__Group_3_2__0 )* )
            {
            // InternalXbaseWithAnnotations.g:12654:1: ( ( rule__XConstructorCall__Group_3_2__0 )* )
            // InternalXbaseWithAnnotations.g:12655:2: ( rule__XConstructorCall__Group_3_2__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getGroup_3_2()); 
            }
            // InternalXbaseWithAnnotations.g:12656:2: ( rule__XConstructorCall__Group_3_2__0 )*
            loop107:
            do {
                int alt107=2;
                int LA107_0 = input.LA(1);

                if ( (LA107_0==54) ) {
                    alt107=1;
                }


                switch (alt107) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:12656:3: rule__XConstructorCall__Group_3_2__0
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__XConstructorCall__Group_3_2__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop107;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getGroup_3_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_3__2__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_3__3"
    // InternalXbaseWithAnnotations.g:12664:1: rule__XConstructorCall__Group_3__3 : rule__XConstructorCall__Group_3__3__Impl ;
    public final void rule__XConstructorCall__Group_3__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12668:1: ( rule__XConstructorCall__Group_3__3__Impl )
            // InternalXbaseWithAnnotations.g:12669:2: rule__XConstructorCall__Group_3__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_3__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_3__3"


    // $ANTLR start "rule__XConstructorCall__Group_3__3__Impl"
    // InternalXbaseWithAnnotations.g:12675:1: rule__XConstructorCall__Group_3__3__Impl : ( '>' ) ;
    public final void rule__XConstructorCall__Group_3__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12679:1: ( ( '>' ) )
            // InternalXbaseWithAnnotations.g:12680:1: ( '>' )
            {
            // InternalXbaseWithAnnotations.g:12680:1: ( '>' )
            // InternalXbaseWithAnnotations.g:12681:2: '>'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getGreaterThanSignKeyword_3_3()); 
            }
            match(input,26,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getGreaterThanSignKeyword_3_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_3__3__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_3_2__0"
    // InternalXbaseWithAnnotations.g:12691:1: rule__XConstructorCall__Group_3_2__0 : rule__XConstructorCall__Group_3_2__0__Impl rule__XConstructorCall__Group_3_2__1 ;
    public final void rule__XConstructorCall__Group_3_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12695:1: ( rule__XConstructorCall__Group_3_2__0__Impl rule__XConstructorCall__Group_3_2__1 )
            // InternalXbaseWithAnnotations.g:12696:2: rule__XConstructorCall__Group_3_2__0__Impl rule__XConstructorCall__Group_3_2__1
            {
            pushFollow(FOLLOW_47);
            rule__XConstructorCall__Group_3_2__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_3_2__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_3_2__0"


    // $ANTLR start "rule__XConstructorCall__Group_3_2__0__Impl"
    // InternalXbaseWithAnnotations.g:12703:1: rule__XConstructorCall__Group_3_2__0__Impl : ( ',' ) ;
    public final void rule__XConstructorCall__Group_3_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12707:1: ( ( ',' ) )
            // InternalXbaseWithAnnotations.g:12708:1: ( ',' )
            {
            // InternalXbaseWithAnnotations.g:12708:1: ( ',' )
            // InternalXbaseWithAnnotations.g:12709:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getCommaKeyword_3_2_0()); 
            }
            match(input,54,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getCommaKeyword_3_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_3_2__0__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_3_2__1"
    // InternalXbaseWithAnnotations.g:12718:1: rule__XConstructorCall__Group_3_2__1 : rule__XConstructorCall__Group_3_2__1__Impl ;
    public final void rule__XConstructorCall__Group_3_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12722:1: ( rule__XConstructorCall__Group_3_2__1__Impl )
            // InternalXbaseWithAnnotations.g:12723:2: rule__XConstructorCall__Group_3_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_3_2__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_3_2__1"


    // $ANTLR start "rule__XConstructorCall__Group_3_2__1__Impl"
    // InternalXbaseWithAnnotations.g:12729:1: rule__XConstructorCall__Group_3_2__1__Impl : ( ( rule__XConstructorCall__TypeArgumentsAssignment_3_2_1 ) ) ;
    public final void rule__XConstructorCall__Group_3_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12733:1: ( ( ( rule__XConstructorCall__TypeArgumentsAssignment_3_2_1 ) ) )
            // InternalXbaseWithAnnotations.g:12734:1: ( ( rule__XConstructorCall__TypeArgumentsAssignment_3_2_1 ) )
            {
            // InternalXbaseWithAnnotations.g:12734:1: ( ( rule__XConstructorCall__TypeArgumentsAssignment_3_2_1 ) )
            // InternalXbaseWithAnnotations.g:12735:2: ( rule__XConstructorCall__TypeArgumentsAssignment_3_2_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getTypeArgumentsAssignment_3_2_1()); 
            }
            // InternalXbaseWithAnnotations.g:12736:2: ( rule__XConstructorCall__TypeArgumentsAssignment_3_2_1 )
            // InternalXbaseWithAnnotations.g:12736:3: rule__XConstructorCall__TypeArgumentsAssignment_3_2_1
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__TypeArgumentsAssignment_3_2_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getTypeArgumentsAssignment_3_2_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_3_2__1__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_4__0"
    // InternalXbaseWithAnnotations.g:12745:1: rule__XConstructorCall__Group_4__0 : rule__XConstructorCall__Group_4__0__Impl rule__XConstructorCall__Group_4__1 ;
    public final void rule__XConstructorCall__Group_4__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12749:1: ( rule__XConstructorCall__Group_4__0__Impl rule__XConstructorCall__Group_4__1 )
            // InternalXbaseWithAnnotations.g:12750:2: rule__XConstructorCall__Group_4__0__Impl rule__XConstructorCall__Group_4__1
            {
            pushFollow(FOLLOW_49);
            rule__XConstructorCall__Group_4__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_4__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4__0"


    // $ANTLR start "rule__XConstructorCall__Group_4__0__Impl"
    // InternalXbaseWithAnnotations.g:12757:1: rule__XConstructorCall__Group_4__0__Impl : ( ( rule__XConstructorCall__ExplicitConstructorCallAssignment_4_0 ) ) ;
    public final void rule__XConstructorCall__Group_4__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12761:1: ( ( ( rule__XConstructorCall__ExplicitConstructorCallAssignment_4_0 ) ) )
            // InternalXbaseWithAnnotations.g:12762:1: ( ( rule__XConstructorCall__ExplicitConstructorCallAssignment_4_0 ) )
            {
            // InternalXbaseWithAnnotations.g:12762:1: ( ( rule__XConstructorCall__ExplicitConstructorCallAssignment_4_0 ) )
            // InternalXbaseWithAnnotations.g:12763:2: ( rule__XConstructorCall__ExplicitConstructorCallAssignment_4_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getExplicitConstructorCallAssignment_4_0()); 
            }
            // InternalXbaseWithAnnotations.g:12764:2: ( rule__XConstructorCall__ExplicitConstructorCallAssignment_4_0 )
            // InternalXbaseWithAnnotations.g:12764:3: rule__XConstructorCall__ExplicitConstructorCallAssignment_4_0
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__ExplicitConstructorCallAssignment_4_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getExplicitConstructorCallAssignment_4_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4__0__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_4__1"
    // InternalXbaseWithAnnotations.g:12772:1: rule__XConstructorCall__Group_4__1 : rule__XConstructorCall__Group_4__1__Impl rule__XConstructorCall__Group_4__2 ;
    public final void rule__XConstructorCall__Group_4__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12776:1: ( rule__XConstructorCall__Group_4__1__Impl rule__XConstructorCall__Group_4__2 )
            // InternalXbaseWithAnnotations.g:12777:2: rule__XConstructorCall__Group_4__1__Impl rule__XConstructorCall__Group_4__2
            {
            pushFollow(FOLLOW_49);
            rule__XConstructorCall__Group_4__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_4__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4__1"


    // $ANTLR start "rule__XConstructorCall__Group_4__1__Impl"
    // InternalXbaseWithAnnotations.g:12784:1: rule__XConstructorCall__Group_4__1__Impl : ( ( rule__XConstructorCall__Alternatives_4_1 )? ) ;
    public final void rule__XConstructorCall__Group_4__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12788:1: ( ( ( rule__XConstructorCall__Alternatives_4_1 )? ) )
            // InternalXbaseWithAnnotations.g:12789:1: ( ( rule__XConstructorCall__Alternatives_4_1 )? )
            {
            // InternalXbaseWithAnnotations.g:12789:1: ( ( rule__XConstructorCall__Alternatives_4_1 )? )
            // InternalXbaseWithAnnotations.g:12790:2: ( rule__XConstructorCall__Alternatives_4_1 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getAlternatives_4_1()); 
            }
            // InternalXbaseWithAnnotations.g:12791:2: ( rule__XConstructorCall__Alternatives_4_1 )?
            int alt108=2;
            int LA108_0 = input.LA(1);

            if ( ((LA108_0>=RULE_ID && LA108_0<=RULE_STRING)||LA108_0==27||LA108_0==31||(LA108_0>=34 && LA108_0<=35)||LA108_0==40||(LA108_0>=45 && LA108_0<=50)||LA108_0==52||(LA108_0>=56 && LA108_0<=57)||LA108_0==60||LA108_0==63||LA108_0==65||(LA108_0>=69 && LA108_0<=77)||LA108_0==79||LA108_0==85||LA108_0==87) ) {
                alt108=1;
            }
            switch (alt108) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:12791:3: rule__XConstructorCall__Alternatives_4_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XConstructorCall__Alternatives_4_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getAlternatives_4_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4__1__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_4__2"
    // InternalXbaseWithAnnotations.g:12799:1: rule__XConstructorCall__Group_4__2 : rule__XConstructorCall__Group_4__2__Impl ;
    public final void rule__XConstructorCall__Group_4__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12803:1: ( rule__XConstructorCall__Group_4__2__Impl )
            // InternalXbaseWithAnnotations.g:12804:2: rule__XConstructorCall__Group_4__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_4__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4__2"


    // $ANTLR start "rule__XConstructorCall__Group_4__2__Impl"
    // InternalXbaseWithAnnotations.g:12810:1: rule__XConstructorCall__Group_4__2__Impl : ( ')' ) ;
    public final void rule__XConstructorCall__Group_4__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12814:1: ( ( ')' ) )
            // InternalXbaseWithAnnotations.g:12815:1: ( ')' )
            {
            // InternalXbaseWithAnnotations.g:12815:1: ( ')' )
            // InternalXbaseWithAnnotations.g:12816:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getRightParenthesisKeyword_4_2()); 
            }
            match(input,53,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getRightParenthesisKeyword_4_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4__2__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_4_1_1__0"
    // InternalXbaseWithAnnotations.g:12826:1: rule__XConstructorCall__Group_4_1_1__0 : rule__XConstructorCall__Group_4_1_1__0__Impl rule__XConstructorCall__Group_4_1_1__1 ;
    public final void rule__XConstructorCall__Group_4_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12830:1: ( rule__XConstructorCall__Group_4_1_1__0__Impl rule__XConstructorCall__Group_4_1_1__1 )
            // InternalXbaseWithAnnotations.g:12831:2: rule__XConstructorCall__Group_4_1_1__0__Impl rule__XConstructorCall__Group_4_1_1__1
            {
            pushFollow(FOLLOW_8);
            rule__XConstructorCall__Group_4_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_4_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4_1_1__0"


    // $ANTLR start "rule__XConstructorCall__Group_4_1_1__0__Impl"
    // InternalXbaseWithAnnotations.g:12838:1: rule__XConstructorCall__Group_4_1_1__0__Impl : ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_1_0 ) ) ;
    public final void rule__XConstructorCall__Group_4_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12842:1: ( ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_1_0 ) ) )
            // InternalXbaseWithAnnotations.g:12843:1: ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_1_0 ) )
            {
            // InternalXbaseWithAnnotations.g:12843:1: ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_1_0 ) )
            // InternalXbaseWithAnnotations.g:12844:2: ( rule__XConstructorCall__ArgumentsAssignment_4_1_1_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getArgumentsAssignment_4_1_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:12845:2: ( rule__XConstructorCall__ArgumentsAssignment_4_1_1_0 )
            // InternalXbaseWithAnnotations.g:12845:3: rule__XConstructorCall__ArgumentsAssignment_4_1_1_0
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__ArgumentsAssignment_4_1_1_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getArgumentsAssignment_4_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4_1_1__0__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_4_1_1__1"
    // InternalXbaseWithAnnotations.g:12853:1: rule__XConstructorCall__Group_4_1_1__1 : rule__XConstructorCall__Group_4_1_1__1__Impl ;
    public final void rule__XConstructorCall__Group_4_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12857:1: ( rule__XConstructorCall__Group_4_1_1__1__Impl )
            // InternalXbaseWithAnnotations.g:12858:2: rule__XConstructorCall__Group_4_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_4_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4_1_1__1"


    // $ANTLR start "rule__XConstructorCall__Group_4_1_1__1__Impl"
    // InternalXbaseWithAnnotations.g:12864:1: rule__XConstructorCall__Group_4_1_1__1__Impl : ( ( rule__XConstructorCall__Group_4_1_1_1__0 )* ) ;
    public final void rule__XConstructorCall__Group_4_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12868:1: ( ( ( rule__XConstructorCall__Group_4_1_1_1__0 )* ) )
            // InternalXbaseWithAnnotations.g:12869:1: ( ( rule__XConstructorCall__Group_4_1_1_1__0 )* )
            {
            // InternalXbaseWithAnnotations.g:12869:1: ( ( rule__XConstructorCall__Group_4_1_1_1__0 )* )
            // InternalXbaseWithAnnotations.g:12870:2: ( rule__XConstructorCall__Group_4_1_1_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getGroup_4_1_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:12871:2: ( rule__XConstructorCall__Group_4_1_1_1__0 )*
            loop109:
            do {
                int alt109=2;
                int LA109_0 = input.LA(1);

                if ( (LA109_0==54) ) {
                    alt109=1;
                }


                switch (alt109) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:12871:3: rule__XConstructorCall__Group_4_1_1_1__0
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__XConstructorCall__Group_4_1_1_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop109;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getGroup_4_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4_1_1__1__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_4_1_1_1__0"
    // InternalXbaseWithAnnotations.g:12880:1: rule__XConstructorCall__Group_4_1_1_1__0 : rule__XConstructorCall__Group_4_1_1_1__0__Impl rule__XConstructorCall__Group_4_1_1_1__1 ;
    public final void rule__XConstructorCall__Group_4_1_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12884:1: ( rule__XConstructorCall__Group_4_1_1_1__0__Impl rule__XConstructorCall__Group_4_1_1_1__1 )
            // InternalXbaseWithAnnotations.g:12885:2: rule__XConstructorCall__Group_4_1_1_1__0__Impl rule__XConstructorCall__Group_4_1_1_1__1
            {
            pushFollow(FOLLOW_10);
            rule__XConstructorCall__Group_4_1_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_4_1_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4_1_1_1__0"


    // $ANTLR start "rule__XConstructorCall__Group_4_1_1_1__0__Impl"
    // InternalXbaseWithAnnotations.g:12892:1: rule__XConstructorCall__Group_4_1_1_1__0__Impl : ( ',' ) ;
    public final void rule__XConstructorCall__Group_4_1_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12896:1: ( ( ',' ) )
            // InternalXbaseWithAnnotations.g:12897:1: ( ',' )
            {
            // InternalXbaseWithAnnotations.g:12897:1: ( ',' )
            // InternalXbaseWithAnnotations.g:12898:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getCommaKeyword_4_1_1_1_0()); 
            }
            match(input,54,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getCommaKeyword_4_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4_1_1_1__0__Impl"


    // $ANTLR start "rule__XConstructorCall__Group_4_1_1_1__1"
    // InternalXbaseWithAnnotations.g:12907:1: rule__XConstructorCall__Group_4_1_1_1__1 : rule__XConstructorCall__Group_4_1_1_1__1__Impl ;
    public final void rule__XConstructorCall__Group_4_1_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12911:1: ( rule__XConstructorCall__Group_4_1_1_1__1__Impl )
            // InternalXbaseWithAnnotations.g:12912:2: rule__XConstructorCall__Group_4_1_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__Group_4_1_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4_1_1_1__1"


    // $ANTLR start "rule__XConstructorCall__Group_4_1_1_1__1__Impl"
    // InternalXbaseWithAnnotations.g:12918:1: rule__XConstructorCall__Group_4_1_1_1__1__Impl : ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_1_1_1 ) ) ;
    public final void rule__XConstructorCall__Group_4_1_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12922:1: ( ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_1_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:12923:1: ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_1_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:12923:1: ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_1_1_1 ) )
            // InternalXbaseWithAnnotations.g:12924:2: ( rule__XConstructorCall__ArgumentsAssignment_4_1_1_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getArgumentsAssignment_4_1_1_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:12925:2: ( rule__XConstructorCall__ArgumentsAssignment_4_1_1_1_1 )
            // InternalXbaseWithAnnotations.g:12925:3: rule__XConstructorCall__ArgumentsAssignment_4_1_1_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XConstructorCall__ArgumentsAssignment_4_1_1_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getArgumentsAssignment_4_1_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__Group_4_1_1_1__1__Impl"


    // $ANTLR start "rule__XBooleanLiteral__Group__0"
    // InternalXbaseWithAnnotations.g:12934:1: rule__XBooleanLiteral__Group__0 : rule__XBooleanLiteral__Group__0__Impl rule__XBooleanLiteral__Group__1 ;
    public final void rule__XBooleanLiteral__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12938:1: ( rule__XBooleanLiteral__Group__0__Impl rule__XBooleanLiteral__Group__1 )
            // InternalXbaseWithAnnotations.g:12939:2: rule__XBooleanLiteral__Group__0__Impl rule__XBooleanLiteral__Group__1
            {
            pushFollow(FOLLOW_76);
            rule__XBooleanLiteral__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XBooleanLiteral__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBooleanLiteral__Group__0"


    // $ANTLR start "rule__XBooleanLiteral__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:12946:1: rule__XBooleanLiteral__Group__0__Impl : ( () ) ;
    public final void rule__XBooleanLiteral__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12950:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:12951:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:12951:1: ( () )
            // InternalXbaseWithAnnotations.g:12952:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBooleanLiteralAccess().getXBooleanLiteralAction_0()); 
            }
            // InternalXbaseWithAnnotations.g:12953:2: ()
            // InternalXbaseWithAnnotations.g:12953:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBooleanLiteralAccess().getXBooleanLiteralAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBooleanLiteral__Group__0__Impl"


    // $ANTLR start "rule__XBooleanLiteral__Group__1"
    // InternalXbaseWithAnnotations.g:12961:1: rule__XBooleanLiteral__Group__1 : rule__XBooleanLiteral__Group__1__Impl ;
    public final void rule__XBooleanLiteral__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12965:1: ( rule__XBooleanLiteral__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:12966:2: rule__XBooleanLiteral__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XBooleanLiteral__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBooleanLiteral__Group__1"


    // $ANTLR start "rule__XBooleanLiteral__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:12972:1: rule__XBooleanLiteral__Group__1__Impl : ( ( rule__XBooleanLiteral__Alternatives_1 ) ) ;
    public final void rule__XBooleanLiteral__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12976:1: ( ( ( rule__XBooleanLiteral__Alternatives_1 ) ) )
            // InternalXbaseWithAnnotations.g:12977:1: ( ( rule__XBooleanLiteral__Alternatives_1 ) )
            {
            // InternalXbaseWithAnnotations.g:12977:1: ( ( rule__XBooleanLiteral__Alternatives_1 ) )
            // InternalXbaseWithAnnotations.g:12978:2: ( rule__XBooleanLiteral__Alternatives_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBooleanLiteralAccess().getAlternatives_1()); 
            }
            // InternalXbaseWithAnnotations.g:12979:2: ( rule__XBooleanLiteral__Alternatives_1 )
            // InternalXbaseWithAnnotations.g:12979:3: rule__XBooleanLiteral__Alternatives_1
            {
            pushFollow(FOLLOW_2);
            rule__XBooleanLiteral__Alternatives_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBooleanLiteralAccess().getAlternatives_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBooleanLiteral__Group__1__Impl"


    // $ANTLR start "rule__XNullLiteral__Group__0"
    // InternalXbaseWithAnnotations.g:12988:1: rule__XNullLiteral__Group__0 : rule__XNullLiteral__Group__0__Impl rule__XNullLiteral__Group__1 ;
    public final void rule__XNullLiteral__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:12992:1: ( rule__XNullLiteral__Group__0__Impl rule__XNullLiteral__Group__1 )
            // InternalXbaseWithAnnotations.g:12993:2: rule__XNullLiteral__Group__0__Impl rule__XNullLiteral__Group__1
            {
            pushFollow(FOLLOW_77);
            rule__XNullLiteral__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XNullLiteral__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XNullLiteral__Group__0"


    // $ANTLR start "rule__XNullLiteral__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:13000:1: rule__XNullLiteral__Group__0__Impl : ( () ) ;
    public final void rule__XNullLiteral__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13004:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:13005:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:13005:1: ( () )
            // InternalXbaseWithAnnotations.g:13006:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXNullLiteralAccess().getXNullLiteralAction_0()); 
            }
            // InternalXbaseWithAnnotations.g:13007:2: ()
            // InternalXbaseWithAnnotations.g:13007:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXNullLiteralAccess().getXNullLiteralAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XNullLiteral__Group__0__Impl"


    // $ANTLR start "rule__XNullLiteral__Group__1"
    // InternalXbaseWithAnnotations.g:13015:1: rule__XNullLiteral__Group__1 : rule__XNullLiteral__Group__1__Impl ;
    public final void rule__XNullLiteral__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13019:1: ( rule__XNullLiteral__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:13020:2: rule__XNullLiteral__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XNullLiteral__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XNullLiteral__Group__1"


    // $ANTLR start "rule__XNullLiteral__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:13026:1: rule__XNullLiteral__Group__1__Impl : ( 'null' ) ;
    public final void rule__XNullLiteral__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13030:1: ( ( 'null' ) )
            // InternalXbaseWithAnnotations.g:13031:1: ( 'null' )
            {
            // InternalXbaseWithAnnotations.g:13031:1: ( 'null' )
            // InternalXbaseWithAnnotations.g:13032:2: 'null'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXNullLiteralAccess().getNullKeyword_1()); 
            }
            match(input,73,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXNullLiteralAccess().getNullKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XNullLiteral__Group__1__Impl"


    // $ANTLR start "rule__XNumberLiteral__Group__0"
    // InternalXbaseWithAnnotations.g:13042:1: rule__XNumberLiteral__Group__0 : rule__XNumberLiteral__Group__0__Impl rule__XNumberLiteral__Group__1 ;
    public final void rule__XNumberLiteral__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13046:1: ( rule__XNumberLiteral__Group__0__Impl rule__XNumberLiteral__Group__1 )
            // InternalXbaseWithAnnotations.g:13047:2: rule__XNumberLiteral__Group__0__Impl rule__XNumberLiteral__Group__1
            {
            pushFollow(FOLLOW_78);
            rule__XNumberLiteral__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XNumberLiteral__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XNumberLiteral__Group__0"


    // $ANTLR start "rule__XNumberLiteral__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:13054:1: rule__XNumberLiteral__Group__0__Impl : ( () ) ;
    public final void rule__XNumberLiteral__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13058:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:13059:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:13059:1: ( () )
            // InternalXbaseWithAnnotations.g:13060:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXNumberLiteralAccess().getXNumberLiteralAction_0()); 
            }
            // InternalXbaseWithAnnotations.g:13061:2: ()
            // InternalXbaseWithAnnotations.g:13061:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXNumberLiteralAccess().getXNumberLiteralAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XNumberLiteral__Group__0__Impl"


    // $ANTLR start "rule__XNumberLiteral__Group__1"
    // InternalXbaseWithAnnotations.g:13069:1: rule__XNumberLiteral__Group__1 : rule__XNumberLiteral__Group__1__Impl ;
    public final void rule__XNumberLiteral__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13073:1: ( rule__XNumberLiteral__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:13074:2: rule__XNumberLiteral__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XNumberLiteral__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XNumberLiteral__Group__1"


    // $ANTLR start "rule__XNumberLiteral__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:13080:1: rule__XNumberLiteral__Group__1__Impl : ( ( rule__XNumberLiteral__ValueAssignment_1 ) ) ;
    public final void rule__XNumberLiteral__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13084:1: ( ( ( rule__XNumberLiteral__ValueAssignment_1 ) ) )
            // InternalXbaseWithAnnotations.g:13085:1: ( ( rule__XNumberLiteral__ValueAssignment_1 ) )
            {
            // InternalXbaseWithAnnotations.g:13085:1: ( ( rule__XNumberLiteral__ValueAssignment_1 ) )
            // InternalXbaseWithAnnotations.g:13086:2: ( rule__XNumberLiteral__ValueAssignment_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXNumberLiteralAccess().getValueAssignment_1()); 
            }
            // InternalXbaseWithAnnotations.g:13087:2: ( rule__XNumberLiteral__ValueAssignment_1 )
            // InternalXbaseWithAnnotations.g:13087:3: rule__XNumberLiteral__ValueAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__XNumberLiteral__ValueAssignment_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXNumberLiteralAccess().getValueAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XNumberLiteral__Group__1__Impl"


    // $ANTLR start "rule__XStringLiteral__Group__0"
    // InternalXbaseWithAnnotations.g:13096:1: rule__XStringLiteral__Group__0 : rule__XStringLiteral__Group__0__Impl rule__XStringLiteral__Group__1 ;
    public final void rule__XStringLiteral__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13100:1: ( rule__XStringLiteral__Group__0__Impl rule__XStringLiteral__Group__1 )
            // InternalXbaseWithAnnotations.g:13101:2: rule__XStringLiteral__Group__0__Impl rule__XStringLiteral__Group__1
            {
            pushFollow(FOLLOW_79);
            rule__XStringLiteral__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XStringLiteral__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XStringLiteral__Group__0"


    // $ANTLR start "rule__XStringLiteral__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:13108:1: rule__XStringLiteral__Group__0__Impl : ( () ) ;
    public final void rule__XStringLiteral__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13112:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:13113:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:13113:1: ( () )
            // InternalXbaseWithAnnotations.g:13114:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXStringLiteralAccess().getXStringLiteralAction_0()); 
            }
            // InternalXbaseWithAnnotations.g:13115:2: ()
            // InternalXbaseWithAnnotations.g:13115:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXStringLiteralAccess().getXStringLiteralAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XStringLiteral__Group__0__Impl"


    // $ANTLR start "rule__XStringLiteral__Group__1"
    // InternalXbaseWithAnnotations.g:13123:1: rule__XStringLiteral__Group__1 : rule__XStringLiteral__Group__1__Impl ;
    public final void rule__XStringLiteral__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13127:1: ( rule__XStringLiteral__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:13128:2: rule__XStringLiteral__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XStringLiteral__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XStringLiteral__Group__1"


    // $ANTLR start "rule__XStringLiteral__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:13134:1: rule__XStringLiteral__Group__1__Impl : ( ( rule__XStringLiteral__ValueAssignment_1 ) ) ;
    public final void rule__XStringLiteral__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13138:1: ( ( ( rule__XStringLiteral__ValueAssignment_1 ) ) )
            // InternalXbaseWithAnnotations.g:13139:1: ( ( rule__XStringLiteral__ValueAssignment_1 ) )
            {
            // InternalXbaseWithAnnotations.g:13139:1: ( ( rule__XStringLiteral__ValueAssignment_1 ) )
            // InternalXbaseWithAnnotations.g:13140:2: ( rule__XStringLiteral__ValueAssignment_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXStringLiteralAccess().getValueAssignment_1()); 
            }
            // InternalXbaseWithAnnotations.g:13141:2: ( rule__XStringLiteral__ValueAssignment_1 )
            // InternalXbaseWithAnnotations.g:13141:3: rule__XStringLiteral__ValueAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__XStringLiteral__ValueAssignment_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXStringLiteralAccess().getValueAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XStringLiteral__Group__1__Impl"


    // $ANTLR start "rule__XTypeLiteral__Group__0"
    // InternalXbaseWithAnnotations.g:13150:1: rule__XTypeLiteral__Group__0 : rule__XTypeLiteral__Group__0__Impl rule__XTypeLiteral__Group__1 ;
    public final void rule__XTypeLiteral__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13154:1: ( rule__XTypeLiteral__Group__0__Impl rule__XTypeLiteral__Group__1 )
            // InternalXbaseWithAnnotations.g:13155:2: rule__XTypeLiteral__Group__0__Impl rule__XTypeLiteral__Group__1
            {
            pushFollow(FOLLOW_80);
            rule__XTypeLiteral__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTypeLiteral__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__Group__0"


    // $ANTLR start "rule__XTypeLiteral__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:13162:1: rule__XTypeLiteral__Group__0__Impl : ( () ) ;
    public final void rule__XTypeLiteral__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13166:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:13167:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:13167:1: ( () )
            // InternalXbaseWithAnnotations.g:13168:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTypeLiteralAccess().getXTypeLiteralAction_0()); 
            }
            // InternalXbaseWithAnnotations.g:13169:2: ()
            // InternalXbaseWithAnnotations.g:13169:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTypeLiteralAccess().getXTypeLiteralAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__Group__0__Impl"


    // $ANTLR start "rule__XTypeLiteral__Group__1"
    // InternalXbaseWithAnnotations.g:13177:1: rule__XTypeLiteral__Group__1 : rule__XTypeLiteral__Group__1__Impl rule__XTypeLiteral__Group__2 ;
    public final void rule__XTypeLiteral__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13181:1: ( rule__XTypeLiteral__Group__1__Impl rule__XTypeLiteral__Group__2 )
            // InternalXbaseWithAnnotations.g:13182:2: rule__XTypeLiteral__Group__1__Impl rule__XTypeLiteral__Group__2
            {
            pushFollow(FOLLOW_6);
            rule__XTypeLiteral__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTypeLiteral__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__Group__1"


    // $ANTLR start "rule__XTypeLiteral__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:13189:1: rule__XTypeLiteral__Group__1__Impl : ( 'typeof' ) ;
    public final void rule__XTypeLiteral__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13193:1: ( ( 'typeof' ) )
            // InternalXbaseWithAnnotations.g:13194:1: ( 'typeof' )
            {
            // InternalXbaseWithAnnotations.g:13194:1: ( 'typeof' )
            // InternalXbaseWithAnnotations.g:13195:2: 'typeof'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTypeLiteralAccess().getTypeofKeyword_1()); 
            }
            match(input,74,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTypeLiteralAccess().getTypeofKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__Group__1__Impl"


    // $ANTLR start "rule__XTypeLiteral__Group__2"
    // InternalXbaseWithAnnotations.g:13204:1: rule__XTypeLiteral__Group__2 : rule__XTypeLiteral__Group__2__Impl rule__XTypeLiteral__Group__3 ;
    public final void rule__XTypeLiteral__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13208:1: ( rule__XTypeLiteral__Group__2__Impl rule__XTypeLiteral__Group__3 )
            // InternalXbaseWithAnnotations.g:13209:2: rule__XTypeLiteral__Group__2__Impl rule__XTypeLiteral__Group__3
            {
            pushFollow(FOLLOW_5);
            rule__XTypeLiteral__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTypeLiteral__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__Group__2"


    // $ANTLR start "rule__XTypeLiteral__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:13216:1: rule__XTypeLiteral__Group__2__Impl : ( '(' ) ;
    public final void rule__XTypeLiteral__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13220:1: ( ( '(' ) )
            // InternalXbaseWithAnnotations.g:13221:1: ( '(' )
            {
            // InternalXbaseWithAnnotations.g:13221:1: ( '(' )
            // InternalXbaseWithAnnotations.g:13222:2: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTypeLiteralAccess().getLeftParenthesisKeyword_2()); 
            }
            match(input,52,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTypeLiteralAccess().getLeftParenthesisKeyword_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__Group__2__Impl"


    // $ANTLR start "rule__XTypeLiteral__Group__3"
    // InternalXbaseWithAnnotations.g:13231:1: rule__XTypeLiteral__Group__3 : rule__XTypeLiteral__Group__3__Impl rule__XTypeLiteral__Group__4 ;
    public final void rule__XTypeLiteral__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13235:1: ( rule__XTypeLiteral__Group__3__Impl rule__XTypeLiteral__Group__4 )
            // InternalXbaseWithAnnotations.g:13236:2: rule__XTypeLiteral__Group__3__Impl rule__XTypeLiteral__Group__4
            {
            pushFollow(FOLLOW_81);
            rule__XTypeLiteral__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTypeLiteral__Group__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__Group__3"


    // $ANTLR start "rule__XTypeLiteral__Group__3__Impl"
    // InternalXbaseWithAnnotations.g:13243:1: rule__XTypeLiteral__Group__3__Impl : ( ( rule__XTypeLiteral__TypeAssignment_3 ) ) ;
    public final void rule__XTypeLiteral__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13247:1: ( ( ( rule__XTypeLiteral__TypeAssignment_3 ) ) )
            // InternalXbaseWithAnnotations.g:13248:1: ( ( rule__XTypeLiteral__TypeAssignment_3 ) )
            {
            // InternalXbaseWithAnnotations.g:13248:1: ( ( rule__XTypeLiteral__TypeAssignment_3 ) )
            // InternalXbaseWithAnnotations.g:13249:2: ( rule__XTypeLiteral__TypeAssignment_3 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTypeLiteralAccess().getTypeAssignment_3()); 
            }
            // InternalXbaseWithAnnotations.g:13250:2: ( rule__XTypeLiteral__TypeAssignment_3 )
            // InternalXbaseWithAnnotations.g:13250:3: rule__XTypeLiteral__TypeAssignment_3
            {
            pushFollow(FOLLOW_2);
            rule__XTypeLiteral__TypeAssignment_3();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTypeLiteralAccess().getTypeAssignment_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__Group__3__Impl"


    // $ANTLR start "rule__XTypeLiteral__Group__4"
    // InternalXbaseWithAnnotations.g:13258:1: rule__XTypeLiteral__Group__4 : rule__XTypeLiteral__Group__4__Impl rule__XTypeLiteral__Group__5 ;
    public final void rule__XTypeLiteral__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13262:1: ( rule__XTypeLiteral__Group__4__Impl rule__XTypeLiteral__Group__5 )
            // InternalXbaseWithAnnotations.g:13263:2: rule__XTypeLiteral__Group__4__Impl rule__XTypeLiteral__Group__5
            {
            pushFollow(FOLLOW_81);
            rule__XTypeLiteral__Group__4__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTypeLiteral__Group__5();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__Group__4"


    // $ANTLR start "rule__XTypeLiteral__Group__4__Impl"
    // InternalXbaseWithAnnotations.g:13270:1: rule__XTypeLiteral__Group__4__Impl : ( ( rule__XTypeLiteral__ArrayDimensionsAssignment_4 )* ) ;
    public final void rule__XTypeLiteral__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13274:1: ( ( ( rule__XTypeLiteral__ArrayDimensionsAssignment_4 )* ) )
            // InternalXbaseWithAnnotations.g:13275:1: ( ( rule__XTypeLiteral__ArrayDimensionsAssignment_4 )* )
            {
            // InternalXbaseWithAnnotations.g:13275:1: ( ( rule__XTypeLiteral__ArrayDimensionsAssignment_4 )* )
            // InternalXbaseWithAnnotations.g:13276:2: ( rule__XTypeLiteral__ArrayDimensionsAssignment_4 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTypeLiteralAccess().getArrayDimensionsAssignment_4()); 
            }
            // InternalXbaseWithAnnotations.g:13277:2: ( rule__XTypeLiteral__ArrayDimensionsAssignment_4 )*
            loop110:
            do {
                int alt110=2;
                int LA110_0 = input.LA(1);

                if ( (LA110_0==57) ) {
                    alt110=1;
                }


                switch (alt110) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:13277:3: rule__XTypeLiteral__ArrayDimensionsAssignment_4
            	    {
            	    pushFollow(FOLLOW_82);
            	    rule__XTypeLiteral__ArrayDimensionsAssignment_4();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop110;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTypeLiteralAccess().getArrayDimensionsAssignment_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__Group__4__Impl"


    // $ANTLR start "rule__XTypeLiteral__Group__5"
    // InternalXbaseWithAnnotations.g:13285:1: rule__XTypeLiteral__Group__5 : rule__XTypeLiteral__Group__5__Impl ;
    public final void rule__XTypeLiteral__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13289:1: ( rule__XTypeLiteral__Group__5__Impl )
            // InternalXbaseWithAnnotations.g:13290:2: rule__XTypeLiteral__Group__5__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XTypeLiteral__Group__5__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__Group__5"


    // $ANTLR start "rule__XTypeLiteral__Group__5__Impl"
    // InternalXbaseWithAnnotations.g:13296:1: rule__XTypeLiteral__Group__5__Impl : ( ')' ) ;
    public final void rule__XTypeLiteral__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13300:1: ( ( ')' ) )
            // InternalXbaseWithAnnotations.g:13301:1: ( ')' )
            {
            // InternalXbaseWithAnnotations.g:13301:1: ( ')' )
            // InternalXbaseWithAnnotations.g:13302:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTypeLiteralAccess().getRightParenthesisKeyword_5()); 
            }
            match(input,53,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTypeLiteralAccess().getRightParenthesisKeyword_5()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__Group__5__Impl"


    // $ANTLR start "rule__XThrowExpression__Group__0"
    // InternalXbaseWithAnnotations.g:13312:1: rule__XThrowExpression__Group__0 : rule__XThrowExpression__Group__0__Impl rule__XThrowExpression__Group__1 ;
    public final void rule__XThrowExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13316:1: ( rule__XThrowExpression__Group__0__Impl rule__XThrowExpression__Group__1 )
            // InternalXbaseWithAnnotations.g:13317:2: rule__XThrowExpression__Group__0__Impl rule__XThrowExpression__Group__1
            {
            pushFollow(FOLLOW_83);
            rule__XThrowExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XThrowExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XThrowExpression__Group__0"


    // $ANTLR start "rule__XThrowExpression__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:13324:1: rule__XThrowExpression__Group__0__Impl : ( () ) ;
    public final void rule__XThrowExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13328:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:13329:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:13329:1: ( () )
            // InternalXbaseWithAnnotations.g:13330:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXThrowExpressionAccess().getXThrowExpressionAction_0()); 
            }
            // InternalXbaseWithAnnotations.g:13331:2: ()
            // InternalXbaseWithAnnotations.g:13331:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXThrowExpressionAccess().getXThrowExpressionAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XThrowExpression__Group__0__Impl"


    // $ANTLR start "rule__XThrowExpression__Group__1"
    // InternalXbaseWithAnnotations.g:13339:1: rule__XThrowExpression__Group__1 : rule__XThrowExpression__Group__1__Impl rule__XThrowExpression__Group__2 ;
    public final void rule__XThrowExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13343:1: ( rule__XThrowExpression__Group__1__Impl rule__XThrowExpression__Group__2 )
            // InternalXbaseWithAnnotations.g:13344:2: rule__XThrowExpression__Group__1__Impl rule__XThrowExpression__Group__2
            {
            pushFollow(FOLLOW_10);
            rule__XThrowExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XThrowExpression__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XThrowExpression__Group__1"


    // $ANTLR start "rule__XThrowExpression__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:13351:1: rule__XThrowExpression__Group__1__Impl : ( 'throw' ) ;
    public final void rule__XThrowExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13355:1: ( ( 'throw' ) )
            // InternalXbaseWithAnnotations.g:13356:1: ( 'throw' )
            {
            // InternalXbaseWithAnnotations.g:13356:1: ( 'throw' )
            // InternalXbaseWithAnnotations.g:13357:2: 'throw'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXThrowExpressionAccess().getThrowKeyword_1()); 
            }
            match(input,75,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXThrowExpressionAccess().getThrowKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XThrowExpression__Group__1__Impl"


    // $ANTLR start "rule__XThrowExpression__Group__2"
    // InternalXbaseWithAnnotations.g:13366:1: rule__XThrowExpression__Group__2 : rule__XThrowExpression__Group__2__Impl ;
    public final void rule__XThrowExpression__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13370:1: ( rule__XThrowExpression__Group__2__Impl )
            // InternalXbaseWithAnnotations.g:13371:2: rule__XThrowExpression__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XThrowExpression__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XThrowExpression__Group__2"


    // $ANTLR start "rule__XThrowExpression__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:13377:1: rule__XThrowExpression__Group__2__Impl : ( ( rule__XThrowExpression__ExpressionAssignment_2 ) ) ;
    public final void rule__XThrowExpression__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13381:1: ( ( ( rule__XThrowExpression__ExpressionAssignment_2 ) ) )
            // InternalXbaseWithAnnotations.g:13382:1: ( ( rule__XThrowExpression__ExpressionAssignment_2 ) )
            {
            // InternalXbaseWithAnnotations.g:13382:1: ( ( rule__XThrowExpression__ExpressionAssignment_2 ) )
            // InternalXbaseWithAnnotations.g:13383:2: ( rule__XThrowExpression__ExpressionAssignment_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXThrowExpressionAccess().getExpressionAssignment_2()); 
            }
            // InternalXbaseWithAnnotations.g:13384:2: ( rule__XThrowExpression__ExpressionAssignment_2 )
            // InternalXbaseWithAnnotations.g:13384:3: rule__XThrowExpression__ExpressionAssignment_2
            {
            pushFollow(FOLLOW_2);
            rule__XThrowExpression__ExpressionAssignment_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXThrowExpressionAccess().getExpressionAssignment_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XThrowExpression__Group__2__Impl"


    // $ANTLR start "rule__XReturnExpression__Group__0"
    // InternalXbaseWithAnnotations.g:13393:1: rule__XReturnExpression__Group__0 : rule__XReturnExpression__Group__0__Impl rule__XReturnExpression__Group__1 ;
    public final void rule__XReturnExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13397:1: ( rule__XReturnExpression__Group__0__Impl rule__XReturnExpression__Group__1 )
            // InternalXbaseWithAnnotations.g:13398:2: rule__XReturnExpression__Group__0__Impl rule__XReturnExpression__Group__1
            {
            pushFollow(FOLLOW_84);
            rule__XReturnExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XReturnExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XReturnExpression__Group__0"


    // $ANTLR start "rule__XReturnExpression__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:13405:1: rule__XReturnExpression__Group__0__Impl : ( () ) ;
    public final void rule__XReturnExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13409:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:13410:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:13410:1: ( () )
            // InternalXbaseWithAnnotations.g:13411:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXReturnExpressionAccess().getXReturnExpressionAction_0()); 
            }
            // InternalXbaseWithAnnotations.g:13412:2: ()
            // InternalXbaseWithAnnotations.g:13412:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXReturnExpressionAccess().getXReturnExpressionAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XReturnExpression__Group__0__Impl"


    // $ANTLR start "rule__XReturnExpression__Group__1"
    // InternalXbaseWithAnnotations.g:13420:1: rule__XReturnExpression__Group__1 : rule__XReturnExpression__Group__1__Impl rule__XReturnExpression__Group__2 ;
    public final void rule__XReturnExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13424:1: ( rule__XReturnExpression__Group__1__Impl rule__XReturnExpression__Group__2 )
            // InternalXbaseWithAnnotations.g:13425:2: rule__XReturnExpression__Group__1__Impl rule__XReturnExpression__Group__2
            {
            pushFollow(FOLLOW_10);
            rule__XReturnExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XReturnExpression__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XReturnExpression__Group__1"


    // $ANTLR start "rule__XReturnExpression__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:13432:1: rule__XReturnExpression__Group__1__Impl : ( 'return' ) ;
    public final void rule__XReturnExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13436:1: ( ( 'return' ) )
            // InternalXbaseWithAnnotations.g:13437:1: ( 'return' )
            {
            // InternalXbaseWithAnnotations.g:13437:1: ( 'return' )
            // InternalXbaseWithAnnotations.g:13438:2: 'return'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXReturnExpressionAccess().getReturnKeyword_1()); 
            }
            match(input,76,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXReturnExpressionAccess().getReturnKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XReturnExpression__Group__1__Impl"


    // $ANTLR start "rule__XReturnExpression__Group__2"
    // InternalXbaseWithAnnotations.g:13447:1: rule__XReturnExpression__Group__2 : rule__XReturnExpression__Group__2__Impl ;
    public final void rule__XReturnExpression__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13451:1: ( rule__XReturnExpression__Group__2__Impl )
            // InternalXbaseWithAnnotations.g:13452:2: rule__XReturnExpression__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XReturnExpression__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XReturnExpression__Group__2"


    // $ANTLR start "rule__XReturnExpression__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:13458:1: rule__XReturnExpression__Group__2__Impl : ( ( rule__XReturnExpression__ExpressionAssignment_2 )? ) ;
    public final void rule__XReturnExpression__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13462:1: ( ( ( rule__XReturnExpression__ExpressionAssignment_2 )? ) )
            // InternalXbaseWithAnnotations.g:13463:1: ( ( rule__XReturnExpression__ExpressionAssignment_2 )? )
            {
            // InternalXbaseWithAnnotations.g:13463:1: ( ( rule__XReturnExpression__ExpressionAssignment_2 )? )
            // InternalXbaseWithAnnotations.g:13464:2: ( rule__XReturnExpression__ExpressionAssignment_2 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXReturnExpressionAccess().getExpressionAssignment_2()); 
            }
            // InternalXbaseWithAnnotations.g:13465:2: ( rule__XReturnExpression__ExpressionAssignment_2 )?
            int alt111=2;
            alt111 = dfa111.predict(input);
            switch (alt111) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:13465:3: rule__XReturnExpression__ExpressionAssignment_2
                    {
                    pushFollow(FOLLOW_2);
                    rule__XReturnExpression__ExpressionAssignment_2();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXReturnExpressionAccess().getExpressionAssignment_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XReturnExpression__Group__2__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group__0"
    // InternalXbaseWithAnnotations.g:13474:1: rule__XTryCatchFinallyExpression__Group__0 : rule__XTryCatchFinallyExpression__Group__0__Impl rule__XTryCatchFinallyExpression__Group__1 ;
    public final void rule__XTryCatchFinallyExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13478:1: ( rule__XTryCatchFinallyExpression__Group__0__Impl rule__XTryCatchFinallyExpression__Group__1 )
            // InternalXbaseWithAnnotations.g:13479:2: rule__XTryCatchFinallyExpression__Group__0__Impl rule__XTryCatchFinallyExpression__Group__1
            {
            pushFollow(FOLLOW_85);
            rule__XTryCatchFinallyExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group__0"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:13486:1: rule__XTryCatchFinallyExpression__Group__0__Impl : ( () ) ;
    public final void rule__XTryCatchFinallyExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13490:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:13491:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:13491:1: ( () )
            // InternalXbaseWithAnnotations.g:13492:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getXTryCatchFinallyExpressionAction_0()); 
            }
            // InternalXbaseWithAnnotations.g:13493:2: ()
            // InternalXbaseWithAnnotations.g:13493:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getXTryCatchFinallyExpressionAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group__0__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group__1"
    // InternalXbaseWithAnnotations.g:13501:1: rule__XTryCatchFinallyExpression__Group__1 : rule__XTryCatchFinallyExpression__Group__1__Impl rule__XTryCatchFinallyExpression__Group__2 ;
    public final void rule__XTryCatchFinallyExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13505:1: ( rule__XTryCatchFinallyExpression__Group__1__Impl rule__XTryCatchFinallyExpression__Group__2 )
            // InternalXbaseWithAnnotations.g:13506:2: rule__XTryCatchFinallyExpression__Group__1__Impl rule__XTryCatchFinallyExpression__Group__2
            {
            pushFollow(FOLLOW_10);
            rule__XTryCatchFinallyExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group__1"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:13513:1: rule__XTryCatchFinallyExpression__Group__1__Impl : ( 'try' ) ;
    public final void rule__XTryCatchFinallyExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13517:1: ( ( 'try' ) )
            // InternalXbaseWithAnnotations.g:13518:1: ( 'try' )
            {
            // InternalXbaseWithAnnotations.g:13518:1: ( 'try' )
            // InternalXbaseWithAnnotations.g:13519:2: 'try'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getTryKeyword_1()); 
            }
            match(input,77,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getTryKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group__1__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group__2"
    // InternalXbaseWithAnnotations.g:13528:1: rule__XTryCatchFinallyExpression__Group__2 : rule__XTryCatchFinallyExpression__Group__2__Impl rule__XTryCatchFinallyExpression__Group__3 ;
    public final void rule__XTryCatchFinallyExpression__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13532:1: ( rule__XTryCatchFinallyExpression__Group__2__Impl rule__XTryCatchFinallyExpression__Group__3 )
            // InternalXbaseWithAnnotations.g:13533:2: rule__XTryCatchFinallyExpression__Group__2__Impl rule__XTryCatchFinallyExpression__Group__3
            {
            pushFollow(FOLLOW_86);
            rule__XTryCatchFinallyExpression__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group__2"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:13540:1: rule__XTryCatchFinallyExpression__Group__2__Impl : ( ( rule__XTryCatchFinallyExpression__ExpressionAssignment_2 ) ) ;
    public final void rule__XTryCatchFinallyExpression__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13544:1: ( ( ( rule__XTryCatchFinallyExpression__ExpressionAssignment_2 ) ) )
            // InternalXbaseWithAnnotations.g:13545:1: ( ( rule__XTryCatchFinallyExpression__ExpressionAssignment_2 ) )
            {
            // InternalXbaseWithAnnotations.g:13545:1: ( ( rule__XTryCatchFinallyExpression__ExpressionAssignment_2 ) )
            // InternalXbaseWithAnnotations.g:13546:2: ( rule__XTryCatchFinallyExpression__ExpressionAssignment_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getExpressionAssignment_2()); 
            }
            // InternalXbaseWithAnnotations.g:13547:2: ( rule__XTryCatchFinallyExpression__ExpressionAssignment_2 )
            // InternalXbaseWithAnnotations.g:13547:3: rule__XTryCatchFinallyExpression__ExpressionAssignment_2
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__ExpressionAssignment_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getExpressionAssignment_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group__2__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group__3"
    // InternalXbaseWithAnnotations.g:13555:1: rule__XTryCatchFinallyExpression__Group__3 : rule__XTryCatchFinallyExpression__Group__3__Impl ;
    public final void rule__XTryCatchFinallyExpression__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13559:1: ( rule__XTryCatchFinallyExpression__Group__3__Impl )
            // InternalXbaseWithAnnotations.g:13560:2: rule__XTryCatchFinallyExpression__Group__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group__3"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group__3__Impl"
    // InternalXbaseWithAnnotations.g:13566:1: rule__XTryCatchFinallyExpression__Group__3__Impl : ( ( rule__XTryCatchFinallyExpression__Alternatives_3 ) ) ;
    public final void rule__XTryCatchFinallyExpression__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13570:1: ( ( ( rule__XTryCatchFinallyExpression__Alternatives_3 ) ) )
            // InternalXbaseWithAnnotations.g:13571:1: ( ( rule__XTryCatchFinallyExpression__Alternatives_3 ) )
            {
            // InternalXbaseWithAnnotations.g:13571:1: ( ( rule__XTryCatchFinallyExpression__Alternatives_3 ) )
            // InternalXbaseWithAnnotations.g:13572:2: ( rule__XTryCatchFinallyExpression__Alternatives_3 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getAlternatives_3()); 
            }
            // InternalXbaseWithAnnotations.g:13573:2: ( rule__XTryCatchFinallyExpression__Alternatives_3 )
            // InternalXbaseWithAnnotations.g:13573:3: rule__XTryCatchFinallyExpression__Alternatives_3
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Alternatives_3();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getAlternatives_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group__3__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_3_0__0"
    // InternalXbaseWithAnnotations.g:13582:1: rule__XTryCatchFinallyExpression__Group_3_0__0 : rule__XTryCatchFinallyExpression__Group_3_0__0__Impl rule__XTryCatchFinallyExpression__Group_3_0__1 ;
    public final void rule__XTryCatchFinallyExpression__Group_3_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13586:1: ( rule__XTryCatchFinallyExpression__Group_3_0__0__Impl rule__XTryCatchFinallyExpression__Group_3_0__1 )
            // InternalXbaseWithAnnotations.g:13587:2: rule__XTryCatchFinallyExpression__Group_3_0__0__Impl rule__XTryCatchFinallyExpression__Group_3_0__1
            {
            pushFollow(FOLLOW_87);
            rule__XTryCatchFinallyExpression__Group_3_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_3_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_3_0__0"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_3_0__0__Impl"
    // InternalXbaseWithAnnotations.g:13594:1: rule__XTryCatchFinallyExpression__Group_3_0__0__Impl : ( ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0 ) ) ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0 )* ) ) ;
    public final void rule__XTryCatchFinallyExpression__Group_3_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13598:1: ( ( ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0 ) ) ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0 )* ) ) )
            // InternalXbaseWithAnnotations.g:13599:1: ( ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0 ) ) ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0 )* ) )
            {
            // InternalXbaseWithAnnotations.g:13599:1: ( ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0 ) ) ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0 )* ) )
            // InternalXbaseWithAnnotations.g:13600:2: ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0 ) ) ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0 )* )
            {
            // InternalXbaseWithAnnotations.g:13600:2: ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0 ) )
            // InternalXbaseWithAnnotations.g:13601:3: ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getCatchClausesAssignment_3_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:13602:3: ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0 )
            // InternalXbaseWithAnnotations.g:13602:4: rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0
            {
            pushFollow(FOLLOW_88);
            rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getCatchClausesAssignment_3_0_0()); 
            }

            }

            // InternalXbaseWithAnnotations.g:13605:2: ( ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0 )* )
            // InternalXbaseWithAnnotations.g:13606:3: ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getCatchClausesAssignment_3_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:13607:3: ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0 )*
            loop112:
            do {
                int alt112=2;
                int LA112_0 = input.LA(1);

                if ( (LA112_0==80) ) {
                    int LA112_2 = input.LA(2);

                    if ( (synpred155_InternalXbaseWithAnnotations()) ) {
                        alt112=1;
                    }


                }


                switch (alt112) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:13607:4: rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0
            	    {
            	    pushFollow(FOLLOW_88);
            	    rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop112;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getCatchClausesAssignment_3_0_0()); 
            }

            }


            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_3_0__0__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_3_0__1"
    // InternalXbaseWithAnnotations.g:13616:1: rule__XTryCatchFinallyExpression__Group_3_0__1 : rule__XTryCatchFinallyExpression__Group_3_0__1__Impl ;
    public final void rule__XTryCatchFinallyExpression__Group_3_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13620:1: ( rule__XTryCatchFinallyExpression__Group_3_0__1__Impl )
            // InternalXbaseWithAnnotations.g:13621:2: rule__XTryCatchFinallyExpression__Group_3_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_3_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_3_0__1"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_3_0__1__Impl"
    // InternalXbaseWithAnnotations.g:13627:1: rule__XTryCatchFinallyExpression__Group_3_0__1__Impl : ( ( rule__XTryCatchFinallyExpression__Group_3_0_1__0 )? ) ;
    public final void rule__XTryCatchFinallyExpression__Group_3_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13631:1: ( ( ( rule__XTryCatchFinallyExpression__Group_3_0_1__0 )? ) )
            // InternalXbaseWithAnnotations.g:13632:1: ( ( rule__XTryCatchFinallyExpression__Group_3_0_1__0 )? )
            {
            // InternalXbaseWithAnnotations.g:13632:1: ( ( rule__XTryCatchFinallyExpression__Group_3_0_1__0 )? )
            // InternalXbaseWithAnnotations.g:13633:2: ( rule__XTryCatchFinallyExpression__Group_3_0_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_3_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:13634:2: ( rule__XTryCatchFinallyExpression__Group_3_0_1__0 )?
            int alt113=2;
            int LA113_0 = input.LA(1);

            if ( (LA113_0==78) ) {
                int LA113_1 = input.LA(2);

                if ( (synpred156_InternalXbaseWithAnnotations()) ) {
                    alt113=1;
                }
            }
            switch (alt113) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:13634:3: rule__XTryCatchFinallyExpression__Group_3_0_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XTryCatchFinallyExpression__Group_3_0_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getGroup_3_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_3_0__1__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_3_0_1__0"
    // InternalXbaseWithAnnotations.g:13643:1: rule__XTryCatchFinallyExpression__Group_3_0_1__0 : rule__XTryCatchFinallyExpression__Group_3_0_1__0__Impl rule__XTryCatchFinallyExpression__Group_3_0_1__1 ;
    public final void rule__XTryCatchFinallyExpression__Group_3_0_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13647:1: ( rule__XTryCatchFinallyExpression__Group_3_0_1__0__Impl rule__XTryCatchFinallyExpression__Group_3_0_1__1 )
            // InternalXbaseWithAnnotations.g:13648:2: rule__XTryCatchFinallyExpression__Group_3_0_1__0__Impl rule__XTryCatchFinallyExpression__Group_3_0_1__1
            {
            pushFollow(FOLLOW_10);
            rule__XTryCatchFinallyExpression__Group_3_0_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_3_0_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_3_0_1__0"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_3_0_1__0__Impl"
    // InternalXbaseWithAnnotations.g:13655:1: rule__XTryCatchFinallyExpression__Group_3_0_1__0__Impl : ( ( 'finally' ) ) ;
    public final void rule__XTryCatchFinallyExpression__Group_3_0_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13659:1: ( ( ( 'finally' ) ) )
            // InternalXbaseWithAnnotations.g:13660:1: ( ( 'finally' ) )
            {
            // InternalXbaseWithAnnotations.g:13660:1: ( ( 'finally' ) )
            // InternalXbaseWithAnnotations.g:13661:2: ( 'finally' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyKeyword_3_0_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:13662:2: ( 'finally' )
            // InternalXbaseWithAnnotations.g:13662:3: 'finally'
            {
            match(input,78,FOLLOW_2); if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyKeyword_3_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_3_0_1__0__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_3_0_1__1"
    // InternalXbaseWithAnnotations.g:13670:1: rule__XTryCatchFinallyExpression__Group_3_0_1__1 : rule__XTryCatchFinallyExpression__Group_3_0_1__1__Impl ;
    public final void rule__XTryCatchFinallyExpression__Group_3_0_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13674:1: ( rule__XTryCatchFinallyExpression__Group_3_0_1__1__Impl )
            // InternalXbaseWithAnnotations.g:13675:2: rule__XTryCatchFinallyExpression__Group_3_0_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_3_0_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_3_0_1__1"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_3_0_1__1__Impl"
    // InternalXbaseWithAnnotations.g:13681:1: rule__XTryCatchFinallyExpression__Group_3_0_1__1__Impl : ( ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_3_0_1_1 ) ) ;
    public final void rule__XTryCatchFinallyExpression__Group_3_0_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13685:1: ( ( ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_3_0_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:13686:1: ( ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_3_0_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:13686:1: ( ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_3_0_1_1 ) )
            // InternalXbaseWithAnnotations.g:13687:2: ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_3_0_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionAssignment_3_0_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:13688:2: ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_3_0_1_1 )
            // InternalXbaseWithAnnotations.g:13688:3: rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_3_0_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_3_0_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionAssignment_3_0_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_3_0_1__1__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_3_1__0"
    // InternalXbaseWithAnnotations.g:13697:1: rule__XTryCatchFinallyExpression__Group_3_1__0 : rule__XTryCatchFinallyExpression__Group_3_1__0__Impl rule__XTryCatchFinallyExpression__Group_3_1__1 ;
    public final void rule__XTryCatchFinallyExpression__Group_3_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13701:1: ( rule__XTryCatchFinallyExpression__Group_3_1__0__Impl rule__XTryCatchFinallyExpression__Group_3_1__1 )
            // InternalXbaseWithAnnotations.g:13702:2: rule__XTryCatchFinallyExpression__Group_3_1__0__Impl rule__XTryCatchFinallyExpression__Group_3_1__1
            {
            pushFollow(FOLLOW_10);
            rule__XTryCatchFinallyExpression__Group_3_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_3_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_3_1__0"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_3_1__0__Impl"
    // InternalXbaseWithAnnotations.g:13709:1: rule__XTryCatchFinallyExpression__Group_3_1__0__Impl : ( 'finally' ) ;
    public final void rule__XTryCatchFinallyExpression__Group_3_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13713:1: ( ( 'finally' ) )
            // InternalXbaseWithAnnotations.g:13714:1: ( 'finally' )
            {
            // InternalXbaseWithAnnotations.g:13714:1: ( 'finally' )
            // InternalXbaseWithAnnotations.g:13715:2: 'finally'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyKeyword_3_1_0()); 
            }
            match(input,78,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyKeyword_3_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_3_1__0__Impl"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_3_1__1"
    // InternalXbaseWithAnnotations.g:13724:1: rule__XTryCatchFinallyExpression__Group_3_1__1 : rule__XTryCatchFinallyExpression__Group_3_1__1__Impl ;
    public final void rule__XTryCatchFinallyExpression__Group_3_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13728:1: ( rule__XTryCatchFinallyExpression__Group_3_1__1__Impl )
            // InternalXbaseWithAnnotations.g:13729:2: rule__XTryCatchFinallyExpression__Group_3_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__Group_3_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_3_1__1"


    // $ANTLR start "rule__XTryCatchFinallyExpression__Group_3_1__1__Impl"
    // InternalXbaseWithAnnotations.g:13735:1: rule__XTryCatchFinallyExpression__Group_3_1__1__Impl : ( ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_3_1_1 ) ) ;
    public final void rule__XTryCatchFinallyExpression__Group_3_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13739:1: ( ( ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_3_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:13740:1: ( ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_3_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:13740:1: ( ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_3_1_1 ) )
            // InternalXbaseWithAnnotations.g:13741:2: ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_3_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionAssignment_3_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:13742:2: ( rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_3_1_1 )
            // InternalXbaseWithAnnotations.g:13742:3: rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_3_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_3_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionAssignment_3_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__Group_3_1__1__Impl"


    // $ANTLR start "rule__XSynchronizedExpression__Group__0"
    // InternalXbaseWithAnnotations.g:13751:1: rule__XSynchronizedExpression__Group__0 : rule__XSynchronizedExpression__Group__0__Impl rule__XSynchronizedExpression__Group__1 ;
    public final void rule__XSynchronizedExpression__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13755:1: ( rule__XSynchronizedExpression__Group__0__Impl rule__XSynchronizedExpression__Group__1 )
            // InternalXbaseWithAnnotations.g:13756:2: rule__XSynchronizedExpression__Group__0__Impl rule__XSynchronizedExpression__Group__1
            {
            pushFollow(FOLLOW_10);
            rule__XSynchronizedExpression__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group__0"


    // $ANTLR start "rule__XSynchronizedExpression__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:13763:1: rule__XSynchronizedExpression__Group__0__Impl : ( ( rule__XSynchronizedExpression__Group_0__0 ) ) ;
    public final void rule__XSynchronizedExpression__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13767:1: ( ( ( rule__XSynchronizedExpression__Group_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:13768:1: ( ( rule__XSynchronizedExpression__Group_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:13768:1: ( ( rule__XSynchronizedExpression__Group_0__0 ) )
            // InternalXbaseWithAnnotations.g:13769:2: ( rule__XSynchronizedExpression__Group_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSynchronizedExpressionAccess().getGroup_0()); 
            }
            // InternalXbaseWithAnnotations.g:13770:2: ( rule__XSynchronizedExpression__Group_0__0 )
            // InternalXbaseWithAnnotations.g:13770:3: rule__XSynchronizedExpression__Group_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__Group_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSynchronizedExpressionAccess().getGroup_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group__0__Impl"


    // $ANTLR start "rule__XSynchronizedExpression__Group__1"
    // InternalXbaseWithAnnotations.g:13778:1: rule__XSynchronizedExpression__Group__1 : rule__XSynchronizedExpression__Group__1__Impl rule__XSynchronizedExpression__Group__2 ;
    public final void rule__XSynchronizedExpression__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13782:1: ( rule__XSynchronizedExpression__Group__1__Impl rule__XSynchronizedExpression__Group__2 )
            // InternalXbaseWithAnnotations.g:13783:2: rule__XSynchronizedExpression__Group__1__Impl rule__XSynchronizedExpression__Group__2
            {
            pushFollow(FOLLOW_57);
            rule__XSynchronizedExpression__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group__1"


    // $ANTLR start "rule__XSynchronizedExpression__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:13790:1: rule__XSynchronizedExpression__Group__1__Impl : ( ( rule__XSynchronizedExpression__ParamAssignment_1 ) ) ;
    public final void rule__XSynchronizedExpression__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13794:1: ( ( ( rule__XSynchronizedExpression__ParamAssignment_1 ) ) )
            // InternalXbaseWithAnnotations.g:13795:1: ( ( rule__XSynchronizedExpression__ParamAssignment_1 ) )
            {
            // InternalXbaseWithAnnotations.g:13795:1: ( ( rule__XSynchronizedExpression__ParamAssignment_1 ) )
            // InternalXbaseWithAnnotations.g:13796:2: ( rule__XSynchronizedExpression__ParamAssignment_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSynchronizedExpressionAccess().getParamAssignment_1()); 
            }
            // InternalXbaseWithAnnotations.g:13797:2: ( rule__XSynchronizedExpression__ParamAssignment_1 )
            // InternalXbaseWithAnnotations.g:13797:3: rule__XSynchronizedExpression__ParamAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__ParamAssignment_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSynchronizedExpressionAccess().getParamAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group__1__Impl"


    // $ANTLR start "rule__XSynchronizedExpression__Group__2"
    // InternalXbaseWithAnnotations.g:13805:1: rule__XSynchronizedExpression__Group__2 : rule__XSynchronizedExpression__Group__2__Impl rule__XSynchronizedExpression__Group__3 ;
    public final void rule__XSynchronizedExpression__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13809:1: ( rule__XSynchronizedExpression__Group__2__Impl rule__XSynchronizedExpression__Group__3 )
            // InternalXbaseWithAnnotations.g:13810:2: rule__XSynchronizedExpression__Group__2__Impl rule__XSynchronizedExpression__Group__3
            {
            pushFollow(FOLLOW_10);
            rule__XSynchronizedExpression__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group__2"


    // $ANTLR start "rule__XSynchronizedExpression__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:13817:1: rule__XSynchronizedExpression__Group__2__Impl : ( ')' ) ;
    public final void rule__XSynchronizedExpression__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13821:1: ( ( ')' ) )
            // InternalXbaseWithAnnotations.g:13822:1: ( ')' )
            {
            // InternalXbaseWithAnnotations.g:13822:1: ( ')' )
            // InternalXbaseWithAnnotations.g:13823:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSynchronizedExpressionAccess().getRightParenthesisKeyword_2()); 
            }
            match(input,53,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSynchronizedExpressionAccess().getRightParenthesisKeyword_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group__2__Impl"


    // $ANTLR start "rule__XSynchronizedExpression__Group__3"
    // InternalXbaseWithAnnotations.g:13832:1: rule__XSynchronizedExpression__Group__3 : rule__XSynchronizedExpression__Group__3__Impl ;
    public final void rule__XSynchronizedExpression__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13836:1: ( rule__XSynchronizedExpression__Group__3__Impl )
            // InternalXbaseWithAnnotations.g:13837:2: rule__XSynchronizedExpression__Group__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group__3"


    // $ANTLR start "rule__XSynchronizedExpression__Group__3__Impl"
    // InternalXbaseWithAnnotations.g:13843:1: rule__XSynchronizedExpression__Group__3__Impl : ( ( rule__XSynchronizedExpression__ExpressionAssignment_3 ) ) ;
    public final void rule__XSynchronizedExpression__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13847:1: ( ( ( rule__XSynchronizedExpression__ExpressionAssignment_3 ) ) )
            // InternalXbaseWithAnnotations.g:13848:1: ( ( rule__XSynchronizedExpression__ExpressionAssignment_3 ) )
            {
            // InternalXbaseWithAnnotations.g:13848:1: ( ( rule__XSynchronizedExpression__ExpressionAssignment_3 ) )
            // InternalXbaseWithAnnotations.g:13849:2: ( rule__XSynchronizedExpression__ExpressionAssignment_3 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSynchronizedExpressionAccess().getExpressionAssignment_3()); 
            }
            // InternalXbaseWithAnnotations.g:13850:2: ( rule__XSynchronizedExpression__ExpressionAssignment_3 )
            // InternalXbaseWithAnnotations.g:13850:3: rule__XSynchronizedExpression__ExpressionAssignment_3
            {
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__ExpressionAssignment_3();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSynchronizedExpressionAccess().getExpressionAssignment_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group__3__Impl"


    // $ANTLR start "rule__XSynchronizedExpression__Group_0__0"
    // InternalXbaseWithAnnotations.g:13859:1: rule__XSynchronizedExpression__Group_0__0 : rule__XSynchronizedExpression__Group_0__0__Impl ;
    public final void rule__XSynchronizedExpression__Group_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13863:1: ( rule__XSynchronizedExpression__Group_0__0__Impl )
            // InternalXbaseWithAnnotations.g:13864:2: rule__XSynchronizedExpression__Group_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__Group_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group_0__0"


    // $ANTLR start "rule__XSynchronizedExpression__Group_0__0__Impl"
    // InternalXbaseWithAnnotations.g:13870:1: rule__XSynchronizedExpression__Group_0__0__Impl : ( ( rule__XSynchronizedExpression__Group_0_0__0 ) ) ;
    public final void rule__XSynchronizedExpression__Group_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13874:1: ( ( ( rule__XSynchronizedExpression__Group_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:13875:1: ( ( rule__XSynchronizedExpression__Group_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:13875:1: ( ( rule__XSynchronizedExpression__Group_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:13876:2: ( rule__XSynchronizedExpression__Group_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSynchronizedExpressionAccess().getGroup_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:13877:2: ( rule__XSynchronizedExpression__Group_0_0__0 )
            // InternalXbaseWithAnnotations.g:13877:3: rule__XSynchronizedExpression__Group_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__Group_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSynchronizedExpressionAccess().getGroup_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group_0__0__Impl"


    // $ANTLR start "rule__XSynchronizedExpression__Group_0_0__0"
    // InternalXbaseWithAnnotations.g:13886:1: rule__XSynchronizedExpression__Group_0_0__0 : rule__XSynchronizedExpression__Group_0_0__0__Impl rule__XSynchronizedExpression__Group_0_0__1 ;
    public final void rule__XSynchronizedExpression__Group_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13890:1: ( rule__XSynchronizedExpression__Group_0_0__0__Impl rule__XSynchronizedExpression__Group_0_0__1 )
            // InternalXbaseWithAnnotations.g:13891:2: rule__XSynchronizedExpression__Group_0_0__0__Impl rule__XSynchronizedExpression__Group_0_0__1
            {
            pushFollow(FOLLOW_89);
            rule__XSynchronizedExpression__Group_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__Group_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group_0_0__0"


    // $ANTLR start "rule__XSynchronizedExpression__Group_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:13898:1: rule__XSynchronizedExpression__Group_0_0__0__Impl : ( () ) ;
    public final void rule__XSynchronizedExpression__Group_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13902:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:13903:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:13903:1: ( () )
            // InternalXbaseWithAnnotations.g:13904:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSynchronizedExpressionAccess().getXSynchronizedExpressionAction_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:13905:2: ()
            // InternalXbaseWithAnnotations.g:13905:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSynchronizedExpressionAccess().getXSynchronizedExpressionAction_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group_0_0__0__Impl"


    // $ANTLR start "rule__XSynchronizedExpression__Group_0_0__1"
    // InternalXbaseWithAnnotations.g:13913:1: rule__XSynchronizedExpression__Group_0_0__1 : rule__XSynchronizedExpression__Group_0_0__1__Impl rule__XSynchronizedExpression__Group_0_0__2 ;
    public final void rule__XSynchronizedExpression__Group_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13917:1: ( rule__XSynchronizedExpression__Group_0_0__1__Impl rule__XSynchronizedExpression__Group_0_0__2 )
            // InternalXbaseWithAnnotations.g:13918:2: rule__XSynchronizedExpression__Group_0_0__1__Impl rule__XSynchronizedExpression__Group_0_0__2
            {
            pushFollow(FOLLOW_6);
            rule__XSynchronizedExpression__Group_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__Group_0_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group_0_0__1"


    // $ANTLR start "rule__XSynchronizedExpression__Group_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:13925:1: rule__XSynchronizedExpression__Group_0_0__1__Impl : ( 'synchronized' ) ;
    public final void rule__XSynchronizedExpression__Group_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13929:1: ( ( 'synchronized' ) )
            // InternalXbaseWithAnnotations.g:13930:1: ( 'synchronized' )
            {
            // InternalXbaseWithAnnotations.g:13930:1: ( 'synchronized' )
            // InternalXbaseWithAnnotations.g:13931:2: 'synchronized'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSynchronizedExpressionAccess().getSynchronizedKeyword_0_0_1()); 
            }
            match(input,79,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSynchronizedExpressionAccess().getSynchronizedKeyword_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group_0_0__1__Impl"


    // $ANTLR start "rule__XSynchronizedExpression__Group_0_0__2"
    // InternalXbaseWithAnnotations.g:13940:1: rule__XSynchronizedExpression__Group_0_0__2 : rule__XSynchronizedExpression__Group_0_0__2__Impl ;
    public final void rule__XSynchronizedExpression__Group_0_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13944:1: ( rule__XSynchronizedExpression__Group_0_0__2__Impl )
            // InternalXbaseWithAnnotations.g:13945:2: rule__XSynchronizedExpression__Group_0_0__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XSynchronizedExpression__Group_0_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group_0_0__2"


    // $ANTLR start "rule__XSynchronizedExpression__Group_0_0__2__Impl"
    // InternalXbaseWithAnnotations.g:13951:1: rule__XSynchronizedExpression__Group_0_0__2__Impl : ( '(' ) ;
    public final void rule__XSynchronizedExpression__Group_0_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13955:1: ( ( '(' ) )
            // InternalXbaseWithAnnotations.g:13956:1: ( '(' )
            {
            // InternalXbaseWithAnnotations.g:13956:1: ( '(' )
            // InternalXbaseWithAnnotations.g:13957:2: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSynchronizedExpressionAccess().getLeftParenthesisKeyword_0_0_2()); 
            }
            match(input,52,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSynchronizedExpressionAccess().getLeftParenthesisKeyword_0_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__Group_0_0__2__Impl"


    // $ANTLR start "rule__XCatchClause__Group__0"
    // InternalXbaseWithAnnotations.g:13967:1: rule__XCatchClause__Group__0 : rule__XCatchClause__Group__0__Impl rule__XCatchClause__Group__1 ;
    public final void rule__XCatchClause__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13971:1: ( rule__XCatchClause__Group__0__Impl rule__XCatchClause__Group__1 )
            // InternalXbaseWithAnnotations.g:13972:2: rule__XCatchClause__Group__0__Impl rule__XCatchClause__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__XCatchClause__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XCatchClause__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCatchClause__Group__0"


    // $ANTLR start "rule__XCatchClause__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:13979:1: rule__XCatchClause__Group__0__Impl : ( ( 'catch' ) ) ;
    public final void rule__XCatchClause__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13983:1: ( ( ( 'catch' ) ) )
            // InternalXbaseWithAnnotations.g:13984:1: ( ( 'catch' ) )
            {
            // InternalXbaseWithAnnotations.g:13984:1: ( ( 'catch' ) )
            // InternalXbaseWithAnnotations.g:13985:2: ( 'catch' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCatchClauseAccess().getCatchKeyword_0()); 
            }
            // InternalXbaseWithAnnotations.g:13986:2: ( 'catch' )
            // InternalXbaseWithAnnotations.g:13986:3: 'catch'
            {
            match(input,80,FOLLOW_2); if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCatchClauseAccess().getCatchKeyword_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCatchClause__Group__0__Impl"


    // $ANTLR start "rule__XCatchClause__Group__1"
    // InternalXbaseWithAnnotations.g:13994:1: rule__XCatchClause__Group__1 : rule__XCatchClause__Group__1__Impl rule__XCatchClause__Group__2 ;
    public final void rule__XCatchClause__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:13998:1: ( rule__XCatchClause__Group__1__Impl rule__XCatchClause__Group__2 )
            // InternalXbaseWithAnnotations.g:13999:2: rule__XCatchClause__Group__1__Impl rule__XCatchClause__Group__2
            {
            pushFollow(FOLLOW_27);
            rule__XCatchClause__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XCatchClause__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCatchClause__Group__1"


    // $ANTLR start "rule__XCatchClause__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:14006:1: rule__XCatchClause__Group__1__Impl : ( '(' ) ;
    public final void rule__XCatchClause__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14010:1: ( ( '(' ) )
            // InternalXbaseWithAnnotations.g:14011:1: ( '(' )
            {
            // InternalXbaseWithAnnotations.g:14011:1: ( '(' )
            // InternalXbaseWithAnnotations.g:14012:2: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCatchClauseAccess().getLeftParenthesisKeyword_1()); 
            }
            match(input,52,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCatchClauseAccess().getLeftParenthesisKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCatchClause__Group__1__Impl"


    // $ANTLR start "rule__XCatchClause__Group__2"
    // InternalXbaseWithAnnotations.g:14021:1: rule__XCatchClause__Group__2 : rule__XCatchClause__Group__2__Impl rule__XCatchClause__Group__3 ;
    public final void rule__XCatchClause__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14025:1: ( rule__XCatchClause__Group__2__Impl rule__XCatchClause__Group__3 )
            // InternalXbaseWithAnnotations.g:14026:2: rule__XCatchClause__Group__2__Impl rule__XCatchClause__Group__3
            {
            pushFollow(FOLLOW_57);
            rule__XCatchClause__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XCatchClause__Group__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCatchClause__Group__2"


    // $ANTLR start "rule__XCatchClause__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:14033:1: rule__XCatchClause__Group__2__Impl : ( ( rule__XCatchClause__DeclaredParamAssignment_2 ) ) ;
    public final void rule__XCatchClause__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14037:1: ( ( ( rule__XCatchClause__DeclaredParamAssignment_2 ) ) )
            // InternalXbaseWithAnnotations.g:14038:1: ( ( rule__XCatchClause__DeclaredParamAssignment_2 ) )
            {
            // InternalXbaseWithAnnotations.g:14038:1: ( ( rule__XCatchClause__DeclaredParamAssignment_2 ) )
            // InternalXbaseWithAnnotations.g:14039:2: ( rule__XCatchClause__DeclaredParamAssignment_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCatchClauseAccess().getDeclaredParamAssignment_2()); 
            }
            // InternalXbaseWithAnnotations.g:14040:2: ( rule__XCatchClause__DeclaredParamAssignment_2 )
            // InternalXbaseWithAnnotations.g:14040:3: rule__XCatchClause__DeclaredParamAssignment_2
            {
            pushFollow(FOLLOW_2);
            rule__XCatchClause__DeclaredParamAssignment_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCatchClauseAccess().getDeclaredParamAssignment_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCatchClause__Group__2__Impl"


    // $ANTLR start "rule__XCatchClause__Group__3"
    // InternalXbaseWithAnnotations.g:14048:1: rule__XCatchClause__Group__3 : rule__XCatchClause__Group__3__Impl rule__XCatchClause__Group__4 ;
    public final void rule__XCatchClause__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14052:1: ( rule__XCatchClause__Group__3__Impl rule__XCatchClause__Group__4 )
            // InternalXbaseWithAnnotations.g:14053:2: rule__XCatchClause__Group__3__Impl rule__XCatchClause__Group__4
            {
            pushFollow(FOLLOW_10);
            rule__XCatchClause__Group__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XCatchClause__Group__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCatchClause__Group__3"


    // $ANTLR start "rule__XCatchClause__Group__3__Impl"
    // InternalXbaseWithAnnotations.g:14060:1: rule__XCatchClause__Group__3__Impl : ( ')' ) ;
    public final void rule__XCatchClause__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14064:1: ( ( ')' ) )
            // InternalXbaseWithAnnotations.g:14065:1: ( ')' )
            {
            // InternalXbaseWithAnnotations.g:14065:1: ( ')' )
            // InternalXbaseWithAnnotations.g:14066:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCatchClauseAccess().getRightParenthesisKeyword_3()); 
            }
            match(input,53,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCatchClauseAccess().getRightParenthesisKeyword_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCatchClause__Group__3__Impl"


    // $ANTLR start "rule__XCatchClause__Group__4"
    // InternalXbaseWithAnnotations.g:14075:1: rule__XCatchClause__Group__4 : rule__XCatchClause__Group__4__Impl ;
    public final void rule__XCatchClause__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14079:1: ( rule__XCatchClause__Group__4__Impl )
            // InternalXbaseWithAnnotations.g:14080:2: rule__XCatchClause__Group__4__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XCatchClause__Group__4__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCatchClause__Group__4"


    // $ANTLR start "rule__XCatchClause__Group__4__Impl"
    // InternalXbaseWithAnnotations.g:14086:1: rule__XCatchClause__Group__4__Impl : ( ( rule__XCatchClause__ExpressionAssignment_4 ) ) ;
    public final void rule__XCatchClause__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14090:1: ( ( ( rule__XCatchClause__ExpressionAssignment_4 ) ) )
            // InternalXbaseWithAnnotations.g:14091:1: ( ( rule__XCatchClause__ExpressionAssignment_4 ) )
            {
            // InternalXbaseWithAnnotations.g:14091:1: ( ( rule__XCatchClause__ExpressionAssignment_4 ) )
            // InternalXbaseWithAnnotations.g:14092:2: ( rule__XCatchClause__ExpressionAssignment_4 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCatchClauseAccess().getExpressionAssignment_4()); 
            }
            // InternalXbaseWithAnnotations.g:14093:2: ( rule__XCatchClause__ExpressionAssignment_4 )
            // InternalXbaseWithAnnotations.g:14093:3: rule__XCatchClause__ExpressionAssignment_4
            {
            pushFollow(FOLLOW_2);
            rule__XCatchClause__ExpressionAssignment_4();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCatchClauseAccess().getExpressionAssignment_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCatchClause__Group__4__Impl"


    // $ANTLR start "rule__QualifiedName__Group__0"
    // InternalXbaseWithAnnotations.g:14102:1: rule__QualifiedName__Group__0 : rule__QualifiedName__Group__0__Impl rule__QualifiedName__Group__1 ;
    public final void rule__QualifiedName__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14106:1: ( rule__QualifiedName__Group__0__Impl rule__QualifiedName__Group__1 )
            // InternalXbaseWithAnnotations.g:14107:2: rule__QualifiedName__Group__0__Impl rule__QualifiedName__Group__1
            {
            pushFollow(FOLLOW_90);
            rule__QualifiedName__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group__0"


    // $ANTLR start "rule__QualifiedName__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:14114:1: rule__QualifiedName__Group__0__Impl : ( ruleValidID ) ;
    public final void rule__QualifiedName__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14118:1: ( ( ruleValidID ) )
            // InternalXbaseWithAnnotations.g:14119:1: ( ruleValidID )
            {
            // InternalXbaseWithAnnotations.g:14119:1: ( ruleValidID )
            // InternalXbaseWithAnnotations.g:14120:2: ruleValidID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameAccess().getValidIDParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleValidID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameAccess().getValidIDParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group__0__Impl"


    // $ANTLR start "rule__QualifiedName__Group__1"
    // InternalXbaseWithAnnotations.g:14129:1: rule__QualifiedName__Group__1 : rule__QualifiedName__Group__1__Impl ;
    public final void rule__QualifiedName__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14133:1: ( rule__QualifiedName__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:14134:2: rule__QualifiedName__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group__1"


    // $ANTLR start "rule__QualifiedName__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:14140:1: rule__QualifiedName__Group__1__Impl : ( ( rule__QualifiedName__Group_1__0 )* ) ;
    public final void rule__QualifiedName__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14144:1: ( ( ( rule__QualifiedName__Group_1__0 )* ) )
            // InternalXbaseWithAnnotations.g:14145:1: ( ( rule__QualifiedName__Group_1__0 )* )
            {
            // InternalXbaseWithAnnotations.g:14145:1: ( ( rule__QualifiedName__Group_1__0 )* )
            // InternalXbaseWithAnnotations.g:14146:2: ( rule__QualifiedName__Group_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameAccess().getGroup_1()); 
            }
            // InternalXbaseWithAnnotations.g:14147:2: ( rule__QualifiedName__Group_1__0 )*
            loop114:
            do {
                int alt114=2;
                int LA114_0 = input.LA(1);

                if ( (LA114_0==43) ) {
                    int LA114_2 = input.LA(2);

                    if ( (LA114_2==RULE_ID) ) {
                        int LA114_3 = input.LA(3);

                        if ( (synpred157_InternalXbaseWithAnnotations()) ) {
                            alt114=1;
                        }


                    }


                }


                switch (alt114) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:14147:3: rule__QualifiedName__Group_1__0
            	    {
            	    pushFollow(FOLLOW_91);
            	    rule__QualifiedName__Group_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop114;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group__1__Impl"


    // $ANTLR start "rule__QualifiedName__Group_1__0"
    // InternalXbaseWithAnnotations.g:14156:1: rule__QualifiedName__Group_1__0 : rule__QualifiedName__Group_1__0__Impl rule__QualifiedName__Group_1__1 ;
    public final void rule__QualifiedName__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14160:1: ( rule__QualifiedName__Group_1__0__Impl rule__QualifiedName__Group_1__1 )
            // InternalXbaseWithAnnotations.g:14161:2: rule__QualifiedName__Group_1__0__Impl rule__QualifiedName__Group_1__1
            {
            pushFollow(FOLLOW_5);
            rule__QualifiedName__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group_1__0"


    // $ANTLR start "rule__QualifiedName__Group_1__0__Impl"
    // InternalXbaseWithAnnotations.g:14168:1: rule__QualifiedName__Group_1__0__Impl : ( ( '.' ) ) ;
    public final void rule__QualifiedName__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14172:1: ( ( ( '.' ) ) )
            // InternalXbaseWithAnnotations.g:14173:1: ( ( '.' ) )
            {
            // InternalXbaseWithAnnotations.g:14173:1: ( ( '.' ) )
            // InternalXbaseWithAnnotations.g:14174:2: ( '.' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameAccess().getFullStopKeyword_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:14175:2: ( '.' )
            // InternalXbaseWithAnnotations.g:14175:3: '.'
            {
            match(input,43,FOLLOW_2); if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameAccess().getFullStopKeyword_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group_1__0__Impl"


    // $ANTLR start "rule__QualifiedName__Group_1__1"
    // InternalXbaseWithAnnotations.g:14183:1: rule__QualifiedName__Group_1__1 : rule__QualifiedName__Group_1__1__Impl ;
    public final void rule__QualifiedName__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14187:1: ( rule__QualifiedName__Group_1__1__Impl )
            // InternalXbaseWithAnnotations.g:14188:2: rule__QualifiedName__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedName__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group_1__1"


    // $ANTLR start "rule__QualifiedName__Group_1__1__Impl"
    // InternalXbaseWithAnnotations.g:14194:1: rule__QualifiedName__Group_1__1__Impl : ( ruleValidID ) ;
    public final void rule__QualifiedName__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14198:1: ( ( ruleValidID ) )
            // InternalXbaseWithAnnotations.g:14199:1: ( ruleValidID )
            {
            // InternalXbaseWithAnnotations.g:14199:1: ( ruleValidID )
            // InternalXbaseWithAnnotations.g:14200:2: ruleValidID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameAccess().getValidIDParserRuleCall_1_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleValidID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameAccess().getValidIDParserRuleCall_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedName__Group_1__1__Impl"


    // $ANTLR start "rule__Number__Group_1__0"
    // InternalXbaseWithAnnotations.g:14210:1: rule__Number__Group_1__0 : rule__Number__Group_1__0__Impl rule__Number__Group_1__1 ;
    public final void rule__Number__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14214:1: ( rule__Number__Group_1__0__Impl rule__Number__Group_1__1 )
            // InternalXbaseWithAnnotations.g:14215:2: rule__Number__Group_1__0__Impl rule__Number__Group_1__1
            {
            pushFollow(FOLLOW_90);
            rule__Number__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__Number__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Number__Group_1__0"


    // $ANTLR start "rule__Number__Group_1__0__Impl"
    // InternalXbaseWithAnnotations.g:14222:1: rule__Number__Group_1__0__Impl : ( ( rule__Number__Alternatives_1_0 ) ) ;
    public final void rule__Number__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14226:1: ( ( ( rule__Number__Alternatives_1_0 ) ) )
            // InternalXbaseWithAnnotations.g:14227:1: ( ( rule__Number__Alternatives_1_0 ) )
            {
            // InternalXbaseWithAnnotations.g:14227:1: ( ( rule__Number__Alternatives_1_0 ) )
            // InternalXbaseWithAnnotations.g:14228:2: ( rule__Number__Alternatives_1_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getNumberAccess().getAlternatives_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:14229:2: ( rule__Number__Alternatives_1_0 )
            // InternalXbaseWithAnnotations.g:14229:3: rule__Number__Alternatives_1_0
            {
            pushFollow(FOLLOW_2);
            rule__Number__Alternatives_1_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getNumberAccess().getAlternatives_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Number__Group_1__0__Impl"


    // $ANTLR start "rule__Number__Group_1__1"
    // InternalXbaseWithAnnotations.g:14237:1: rule__Number__Group_1__1 : rule__Number__Group_1__1__Impl ;
    public final void rule__Number__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14241:1: ( rule__Number__Group_1__1__Impl )
            // InternalXbaseWithAnnotations.g:14242:2: rule__Number__Group_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Number__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Number__Group_1__1"


    // $ANTLR start "rule__Number__Group_1__1__Impl"
    // InternalXbaseWithAnnotations.g:14248:1: rule__Number__Group_1__1__Impl : ( ( rule__Number__Group_1_1__0 )? ) ;
    public final void rule__Number__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14252:1: ( ( ( rule__Number__Group_1_1__0 )? ) )
            // InternalXbaseWithAnnotations.g:14253:1: ( ( rule__Number__Group_1_1__0 )? )
            {
            // InternalXbaseWithAnnotations.g:14253:1: ( ( rule__Number__Group_1_1__0 )? )
            // InternalXbaseWithAnnotations.g:14254:2: ( rule__Number__Group_1_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getNumberAccess().getGroup_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:14255:2: ( rule__Number__Group_1_1__0 )?
            int alt115=2;
            int LA115_0 = input.LA(1);

            if ( (LA115_0==43) ) {
                int LA115_1 = input.LA(2);

                if ( ((LA115_1>=RULE_INT && LA115_1<=RULE_DECIMAL)) ) {
                    alt115=1;
                }
            }
            switch (alt115) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:14255:3: rule__Number__Group_1_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Number__Group_1_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getNumberAccess().getGroup_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Number__Group_1__1__Impl"


    // $ANTLR start "rule__Number__Group_1_1__0"
    // InternalXbaseWithAnnotations.g:14264:1: rule__Number__Group_1_1__0 : rule__Number__Group_1_1__0__Impl rule__Number__Group_1_1__1 ;
    public final void rule__Number__Group_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14268:1: ( rule__Number__Group_1_1__0__Impl rule__Number__Group_1_1__1 )
            // InternalXbaseWithAnnotations.g:14269:2: rule__Number__Group_1_1__0__Impl rule__Number__Group_1_1__1
            {
            pushFollow(FOLLOW_92);
            rule__Number__Group_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__Number__Group_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Number__Group_1_1__0"


    // $ANTLR start "rule__Number__Group_1_1__0__Impl"
    // InternalXbaseWithAnnotations.g:14276:1: rule__Number__Group_1_1__0__Impl : ( '.' ) ;
    public final void rule__Number__Group_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14280:1: ( ( '.' ) )
            // InternalXbaseWithAnnotations.g:14281:1: ( '.' )
            {
            // InternalXbaseWithAnnotations.g:14281:1: ( '.' )
            // InternalXbaseWithAnnotations.g:14282:2: '.'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getNumberAccess().getFullStopKeyword_1_1_0()); 
            }
            match(input,43,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getNumberAccess().getFullStopKeyword_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Number__Group_1_1__0__Impl"


    // $ANTLR start "rule__Number__Group_1_1__1"
    // InternalXbaseWithAnnotations.g:14291:1: rule__Number__Group_1_1__1 : rule__Number__Group_1_1__1__Impl ;
    public final void rule__Number__Group_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14295:1: ( rule__Number__Group_1_1__1__Impl )
            // InternalXbaseWithAnnotations.g:14296:2: rule__Number__Group_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Number__Group_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Number__Group_1_1__1"


    // $ANTLR start "rule__Number__Group_1_1__1__Impl"
    // InternalXbaseWithAnnotations.g:14302:1: rule__Number__Group_1_1__1__Impl : ( ( rule__Number__Alternatives_1_1_1 ) ) ;
    public final void rule__Number__Group_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14306:1: ( ( ( rule__Number__Alternatives_1_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:14307:1: ( ( rule__Number__Alternatives_1_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:14307:1: ( ( rule__Number__Alternatives_1_1_1 ) )
            // InternalXbaseWithAnnotations.g:14308:2: ( rule__Number__Alternatives_1_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getNumberAccess().getAlternatives_1_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:14309:2: ( rule__Number__Alternatives_1_1_1 )
            // InternalXbaseWithAnnotations.g:14309:3: rule__Number__Alternatives_1_1_1
            {
            pushFollow(FOLLOW_2);
            rule__Number__Alternatives_1_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getNumberAccess().getAlternatives_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Number__Group_1_1__1__Impl"


    // $ANTLR start "rule__JvmTypeReference__Group_0__0"
    // InternalXbaseWithAnnotations.g:14318:1: rule__JvmTypeReference__Group_0__0 : rule__JvmTypeReference__Group_0__0__Impl rule__JvmTypeReference__Group_0__1 ;
    public final void rule__JvmTypeReference__Group_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14322:1: ( rule__JvmTypeReference__Group_0__0__Impl rule__JvmTypeReference__Group_0__1 )
            // InternalXbaseWithAnnotations.g:14323:2: rule__JvmTypeReference__Group_0__0__Impl rule__JvmTypeReference__Group_0__1
            {
            pushFollow(FOLLOW_14);
            rule__JvmTypeReference__Group_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmTypeReference__Group_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmTypeReference__Group_0__0"


    // $ANTLR start "rule__JvmTypeReference__Group_0__0__Impl"
    // InternalXbaseWithAnnotations.g:14330:1: rule__JvmTypeReference__Group_0__0__Impl : ( ruleJvmParameterizedTypeReference ) ;
    public final void rule__JvmTypeReference__Group_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14334:1: ( ( ruleJvmParameterizedTypeReference ) )
            // InternalXbaseWithAnnotations.g:14335:1: ( ruleJvmParameterizedTypeReference )
            {
            // InternalXbaseWithAnnotations.g:14335:1: ( ruleJvmParameterizedTypeReference )
            // InternalXbaseWithAnnotations.g:14336:2: ruleJvmParameterizedTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmTypeReferenceAccess().getJvmParameterizedTypeReferenceParserRuleCall_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmParameterizedTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmTypeReferenceAccess().getJvmParameterizedTypeReferenceParserRuleCall_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmTypeReference__Group_0__0__Impl"


    // $ANTLR start "rule__JvmTypeReference__Group_0__1"
    // InternalXbaseWithAnnotations.g:14345:1: rule__JvmTypeReference__Group_0__1 : rule__JvmTypeReference__Group_0__1__Impl ;
    public final void rule__JvmTypeReference__Group_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14349:1: ( rule__JvmTypeReference__Group_0__1__Impl )
            // InternalXbaseWithAnnotations.g:14350:2: rule__JvmTypeReference__Group_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmTypeReference__Group_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmTypeReference__Group_0__1"


    // $ANTLR start "rule__JvmTypeReference__Group_0__1__Impl"
    // InternalXbaseWithAnnotations.g:14356:1: rule__JvmTypeReference__Group_0__1__Impl : ( ( rule__JvmTypeReference__Group_0_1__0 )* ) ;
    public final void rule__JvmTypeReference__Group_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14360:1: ( ( ( rule__JvmTypeReference__Group_0_1__0 )* ) )
            // InternalXbaseWithAnnotations.g:14361:1: ( ( rule__JvmTypeReference__Group_0_1__0 )* )
            {
            // InternalXbaseWithAnnotations.g:14361:1: ( ( rule__JvmTypeReference__Group_0_1__0 )* )
            // InternalXbaseWithAnnotations.g:14362:2: ( rule__JvmTypeReference__Group_0_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmTypeReferenceAccess().getGroup_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:14363:2: ( rule__JvmTypeReference__Group_0_1__0 )*
            loop116:
            do {
                int alt116=2;
                int LA116_0 = input.LA(1);

                if ( (LA116_0==57) ) {
                    int LA116_2 = input.LA(2);

                    if ( (LA116_2==55) ) {
                        int LA116_3 = input.LA(3);

                        if ( (synpred159_InternalXbaseWithAnnotations()) ) {
                            alt116=1;
                        }


                    }


                }


                switch (alt116) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:14363:3: rule__JvmTypeReference__Group_0_1__0
            	    {
            	    pushFollow(FOLLOW_82);
            	    rule__JvmTypeReference__Group_0_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop116;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmTypeReferenceAccess().getGroup_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmTypeReference__Group_0__1__Impl"


    // $ANTLR start "rule__JvmTypeReference__Group_0_1__0"
    // InternalXbaseWithAnnotations.g:14372:1: rule__JvmTypeReference__Group_0_1__0 : rule__JvmTypeReference__Group_0_1__0__Impl ;
    public final void rule__JvmTypeReference__Group_0_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14376:1: ( rule__JvmTypeReference__Group_0_1__0__Impl )
            // InternalXbaseWithAnnotations.g:14377:2: rule__JvmTypeReference__Group_0_1__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmTypeReference__Group_0_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmTypeReference__Group_0_1__0"


    // $ANTLR start "rule__JvmTypeReference__Group_0_1__0__Impl"
    // InternalXbaseWithAnnotations.g:14383:1: rule__JvmTypeReference__Group_0_1__0__Impl : ( ( rule__JvmTypeReference__Group_0_1_0__0 ) ) ;
    public final void rule__JvmTypeReference__Group_0_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14387:1: ( ( ( rule__JvmTypeReference__Group_0_1_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:14388:1: ( ( rule__JvmTypeReference__Group_0_1_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:14388:1: ( ( rule__JvmTypeReference__Group_0_1_0__0 ) )
            // InternalXbaseWithAnnotations.g:14389:2: ( rule__JvmTypeReference__Group_0_1_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmTypeReferenceAccess().getGroup_0_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:14390:2: ( rule__JvmTypeReference__Group_0_1_0__0 )
            // InternalXbaseWithAnnotations.g:14390:3: rule__JvmTypeReference__Group_0_1_0__0
            {
            pushFollow(FOLLOW_2);
            rule__JvmTypeReference__Group_0_1_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmTypeReferenceAccess().getGroup_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmTypeReference__Group_0_1__0__Impl"


    // $ANTLR start "rule__JvmTypeReference__Group_0_1_0__0"
    // InternalXbaseWithAnnotations.g:14399:1: rule__JvmTypeReference__Group_0_1_0__0 : rule__JvmTypeReference__Group_0_1_0__0__Impl rule__JvmTypeReference__Group_0_1_0__1 ;
    public final void rule__JvmTypeReference__Group_0_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14403:1: ( rule__JvmTypeReference__Group_0_1_0__0__Impl rule__JvmTypeReference__Group_0_1_0__1 )
            // InternalXbaseWithAnnotations.g:14404:2: rule__JvmTypeReference__Group_0_1_0__0__Impl rule__JvmTypeReference__Group_0_1_0__1
            {
            pushFollow(FOLLOW_14);
            rule__JvmTypeReference__Group_0_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmTypeReference__Group_0_1_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmTypeReference__Group_0_1_0__0"


    // $ANTLR start "rule__JvmTypeReference__Group_0_1_0__0__Impl"
    // InternalXbaseWithAnnotations.g:14411:1: rule__JvmTypeReference__Group_0_1_0__0__Impl : ( () ) ;
    public final void rule__JvmTypeReference__Group_0_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14415:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:14416:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:14416:1: ( () )
            // InternalXbaseWithAnnotations.g:14417:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmTypeReferenceAccess().getJvmGenericArrayTypeReferenceComponentTypeAction_0_1_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:14418:2: ()
            // InternalXbaseWithAnnotations.g:14418:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmTypeReferenceAccess().getJvmGenericArrayTypeReferenceComponentTypeAction_0_1_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmTypeReference__Group_0_1_0__0__Impl"


    // $ANTLR start "rule__JvmTypeReference__Group_0_1_0__1"
    // InternalXbaseWithAnnotations.g:14426:1: rule__JvmTypeReference__Group_0_1_0__1 : rule__JvmTypeReference__Group_0_1_0__1__Impl ;
    public final void rule__JvmTypeReference__Group_0_1_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14430:1: ( rule__JvmTypeReference__Group_0_1_0__1__Impl )
            // InternalXbaseWithAnnotations.g:14431:2: rule__JvmTypeReference__Group_0_1_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmTypeReference__Group_0_1_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmTypeReference__Group_0_1_0__1"


    // $ANTLR start "rule__JvmTypeReference__Group_0_1_0__1__Impl"
    // InternalXbaseWithAnnotations.g:14437:1: rule__JvmTypeReference__Group_0_1_0__1__Impl : ( ruleArrayBrackets ) ;
    public final void rule__JvmTypeReference__Group_0_1_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14441:1: ( ( ruleArrayBrackets ) )
            // InternalXbaseWithAnnotations.g:14442:1: ( ruleArrayBrackets )
            {
            // InternalXbaseWithAnnotations.g:14442:1: ( ruleArrayBrackets )
            // InternalXbaseWithAnnotations.g:14443:2: ruleArrayBrackets
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmTypeReferenceAccess().getArrayBracketsParserRuleCall_0_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleArrayBrackets();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmTypeReferenceAccess().getArrayBracketsParserRuleCall_0_1_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmTypeReference__Group_0_1_0__1__Impl"


    // $ANTLR start "rule__ArrayBrackets__Group__0"
    // InternalXbaseWithAnnotations.g:14453:1: rule__ArrayBrackets__Group__0 : rule__ArrayBrackets__Group__0__Impl rule__ArrayBrackets__Group__1 ;
    public final void rule__ArrayBrackets__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14457:1: ( rule__ArrayBrackets__Group__0__Impl rule__ArrayBrackets__Group__1 )
            // InternalXbaseWithAnnotations.g:14458:2: rule__ArrayBrackets__Group__0__Impl rule__ArrayBrackets__Group__1
            {
            pushFollow(FOLLOW_53);
            rule__ArrayBrackets__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__ArrayBrackets__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ArrayBrackets__Group__0"


    // $ANTLR start "rule__ArrayBrackets__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:14465:1: rule__ArrayBrackets__Group__0__Impl : ( '[' ) ;
    public final void rule__ArrayBrackets__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14469:1: ( ( '[' ) )
            // InternalXbaseWithAnnotations.g:14470:1: ( '[' )
            {
            // InternalXbaseWithAnnotations.g:14470:1: ( '[' )
            // InternalXbaseWithAnnotations.g:14471:2: '['
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getArrayBracketsAccess().getLeftSquareBracketKeyword_0()); 
            }
            match(input,57,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getArrayBracketsAccess().getLeftSquareBracketKeyword_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ArrayBrackets__Group__0__Impl"


    // $ANTLR start "rule__ArrayBrackets__Group__1"
    // InternalXbaseWithAnnotations.g:14480:1: rule__ArrayBrackets__Group__1 : rule__ArrayBrackets__Group__1__Impl ;
    public final void rule__ArrayBrackets__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14484:1: ( rule__ArrayBrackets__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:14485:2: rule__ArrayBrackets__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__ArrayBrackets__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ArrayBrackets__Group__1"


    // $ANTLR start "rule__ArrayBrackets__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:14491:1: rule__ArrayBrackets__Group__1__Impl : ( ']' ) ;
    public final void rule__ArrayBrackets__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14495:1: ( ( ']' ) )
            // InternalXbaseWithAnnotations.g:14496:1: ( ']' )
            {
            // InternalXbaseWithAnnotations.g:14496:1: ( ']' )
            // InternalXbaseWithAnnotations.g:14497:2: ']'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getArrayBracketsAccess().getRightSquareBracketKeyword_1()); 
            }
            match(input,55,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getArrayBracketsAccess().getRightSquareBracketKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ArrayBrackets__Group__1__Impl"


    // $ANTLR start "rule__XFunctionTypeRef__Group__0"
    // InternalXbaseWithAnnotations.g:14507:1: rule__XFunctionTypeRef__Group__0 : rule__XFunctionTypeRef__Group__0__Impl rule__XFunctionTypeRef__Group__1 ;
    public final void rule__XFunctionTypeRef__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14511:1: ( rule__XFunctionTypeRef__Group__0__Impl rule__XFunctionTypeRef__Group__1 )
            // InternalXbaseWithAnnotations.g:14512:2: rule__XFunctionTypeRef__Group__0__Impl rule__XFunctionTypeRef__Group__1
            {
            pushFollow(FOLLOW_27);
            rule__XFunctionTypeRef__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group__0"


    // $ANTLR start "rule__XFunctionTypeRef__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:14519:1: rule__XFunctionTypeRef__Group__0__Impl : ( ( rule__XFunctionTypeRef__Group_0__0 )? ) ;
    public final void rule__XFunctionTypeRef__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14523:1: ( ( ( rule__XFunctionTypeRef__Group_0__0 )? ) )
            // InternalXbaseWithAnnotations.g:14524:1: ( ( rule__XFunctionTypeRef__Group_0__0 )? )
            {
            // InternalXbaseWithAnnotations.g:14524:1: ( ( rule__XFunctionTypeRef__Group_0__0 )? )
            // InternalXbaseWithAnnotations.g:14525:2: ( rule__XFunctionTypeRef__Group_0__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getGroup_0()); 
            }
            // InternalXbaseWithAnnotations.g:14526:2: ( rule__XFunctionTypeRef__Group_0__0 )?
            int alt117=2;
            int LA117_0 = input.LA(1);

            if ( (LA117_0==52) ) {
                alt117=1;
            }
            switch (alt117) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:14526:3: rule__XFunctionTypeRef__Group_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XFunctionTypeRef__Group_0__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getGroup_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group__0__Impl"


    // $ANTLR start "rule__XFunctionTypeRef__Group__1"
    // InternalXbaseWithAnnotations.g:14534:1: rule__XFunctionTypeRef__Group__1 : rule__XFunctionTypeRef__Group__1__Impl rule__XFunctionTypeRef__Group__2 ;
    public final void rule__XFunctionTypeRef__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14538:1: ( rule__XFunctionTypeRef__Group__1__Impl rule__XFunctionTypeRef__Group__2 )
            // InternalXbaseWithAnnotations.g:14539:2: rule__XFunctionTypeRef__Group__1__Impl rule__XFunctionTypeRef__Group__2
            {
            pushFollow(FOLLOW_27);
            rule__XFunctionTypeRef__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group__1"


    // $ANTLR start "rule__XFunctionTypeRef__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:14546:1: rule__XFunctionTypeRef__Group__1__Impl : ( '=>' ) ;
    public final void rule__XFunctionTypeRef__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14550:1: ( ( '=>' ) )
            // InternalXbaseWithAnnotations.g:14551:1: ( '=>' )
            {
            // InternalXbaseWithAnnotations.g:14551:1: ( '=>' )
            // InternalXbaseWithAnnotations.g:14552:2: '=>'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getEqualsSignGreaterThanSignKeyword_1()); 
            }
            match(input,31,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getEqualsSignGreaterThanSignKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group__1__Impl"


    // $ANTLR start "rule__XFunctionTypeRef__Group__2"
    // InternalXbaseWithAnnotations.g:14561:1: rule__XFunctionTypeRef__Group__2 : rule__XFunctionTypeRef__Group__2__Impl ;
    public final void rule__XFunctionTypeRef__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14565:1: ( rule__XFunctionTypeRef__Group__2__Impl )
            // InternalXbaseWithAnnotations.g:14566:2: rule__XFunctionTypeRef__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group__2"


    // $ANTLR start "rule__XFunctionTypeRef__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:14572:1: rule__XFunctionTypeRef__Group__2__Impl : ( ( rule__XFunctionTypeRef__ReturnTypeAssignment_2 ) ) ;
    public final void rule__XFunctionTypeRef__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14576:1: ( ( ( rule__XFunctionTypeRef__ReturnTypeAssignment_2 ) ) )
            // InternalXbaseWithAnnotations.g:14577:1: ( ( rule__XFunctionTypeRef__ReturnTypeAssignment_2 ) )
            {
            // InternalXbaseWithAnnotations.g:14577:1: ( ( rule__XFunctionTypeRef__ReturnTypeAssignment_2 ) )
            // InternalXbaseWithAnnotations.g:14578:2: ( rule__XFunctionTypeRef__ReturnTypeAssignment_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getReturnTypeAssignment_2()); 
            }
            // InternalXbaseWithAnnotations.g:14579:2: ( rule__XFunctionTypeRef__ReturnTypeAssignment_2 )
            // InternalXbaseWithAnnotations.g:14579:3: rule__XFunctionTypeRef__ReturnTypeAssignment_2
            {
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__ReturnTypeAssignment_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getReturnTypeAssignment_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group__2__Impl"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0__0"
    // InternalXbaseWithAnnotations.g:14588:1: rule__XFunctionTypeRef__Group_0__0 : rule__XFunctionTypeRef__Group_0__0__Impl rule__XFunctionTypeRef__Group_0__1 ;
    public final void rule__XFunctionTypeRef__Group_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14592:1: ( rule__XFunctionTypeRef__Group_0__0__Impl rule__XFunctionTypeRef__Group_0__1 )
            // InternalXbaseWithAnnotations.g:14593:2: rule__XFunctionTypeRef__Group_0__0__Impl rule__XFunctionTypeRef__Group_0__1
            {
            pushFollow(FOLLOW_93);
            rule__XFunctionTypeRef__Group_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__Group_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0__0"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0__0__Impl"
    // InternalXbaseWithAnnotations.g:14600:1: rule__XFunctionTypeRef__Group_0__0__Impl : ( '(' ) ;
    public final void rule__XFunctionTypeRef__Group_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14604:1: ( ( '(' ) )
            // InternalXbaseWithAnnotations.g:14605:1: ( '(' )
            {
            // InternalXbaseWithAnnotations.g:14605:1: ( '(' )
            // InternalXbaseWithAnnotations.g:14606:2: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getLeftParenthesisKeyword_0_0()); 
            }
            match(input,52,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getLeftParenthesisKeyword_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0__0__Impl"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0__1"
    // InternalXbaseWithAnnotations.g:14615:1: rule__XFunctionTypeRef__Group_0__1 : rule__XFunctionTypeRef__Group_0__1__Impl rule__XFunctionTypeRef__Group_0__2 ;
    public final void rule__XFunctionTypeRef__Group_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14619:1: ( rule__XFunctionTypeRef__Group_0__1__Impl rule__XFunctionTypeRef__Group_0__2 )
            // InternalXbaseWithAnnotations.g:14620:2: rule__XFunctionTypeRef__Group_0__1__Impl rule__XFunctionTypeRef__Group_0__2
            {
            pushFollow(FOLLOW_93);
            rule__XFunctionTypeRef__Group_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__Group_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0__1"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0__1__Impl"
    // InternalXbaseWithAnnotations.g:14627:1: rule__XFunctionTypeRef__Group_0__1__Impl : ( ( rule__XFunctionTypeRef__Group_0_1__0 )? ) ;
    public final void rule__XFunctionTypeRef__Group_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14631:1: ( ( ( rule__XFunctionTypeRef__Group_0_1__0 )? ) )
            // InternalXbaseWithAnnotations.g:14632:1: ( ( rule__XFunctionTypeRef__Group_0_1__0 )? )
            {
            // InternalXbaseWithAnnotations.g:14632:1: ( ( rule__XFunctionTypeRef__Group_0_1__0 )? )
            // InternalXbaseWithAnnotations.g:14633:2: ( rule__XFunctionTypeRef__Group_0_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getGroup_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:14634:2: ( rule__XFunctionTypeRef__Group_0_1__0 )?
            int alt118=2;
            int LA118_0 = input.LA(1);

            if ( (LA118_0==RULE_ID||LA118_0==31||LA118_0==52) ) {
                alt118=1;
            }
            switch (alt118) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:14634:3: rule__XFunctionTypeRef__Group_0_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__XFunctionTypeRef__Group_0_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getGroup_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0__1__Impl"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0__2"
    // InternalXbaseWithAnnotations.g:14642:1: rule__XFunctionTypeRef__Group_0__2 : rule__XFunctionTypeRef__Group_0__2__Impl ;
    public final void rule__XFunctionTypeRef__Group_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14646:1: ( rule__XFunctionTypeRef__Group_0__2__Impl )
            // InternalXbaseWithAnnotations.g:14647:2: rule__XFunctionTypeRef__Group_0__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__Group_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0__2"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0__2__Impl"
    // InternalXbaseWithAnnotations.g:14653:1: rule__XFunctionTypeRef__Group_0__2__Impl : ( ')' ) ;
    public final void rule__XFunctionTypeRef__Group_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14657:1: ( ( ')' ) )
            // InternalXbaseWithAnnotations.g:14658:1: ( ')' )
            {
            // InternalXbaseWithAnnotations.g:14658:1: ( ')' )
            // InternalXbaseWithAnnotations.g:14659:2: ')'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getRightParenthesisKeyword_0_2()); 
            }
            match(input,53,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getRightParenthesisKeyword_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0__2__Impl"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0_1__0"
    // InternalXbaseWithAnnotations.g:14669:1: rule__XFunctionTypeRef__Group_0_1__0 : rule__XFunctionTypeRef__Group_0_1__0__Impl rule__XFunctionTypeRef__Group_0_1__1 ;
    public final void rule__XFunctionTypeRef__Group_0_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14673:1: ( rule__XFunctionTypeRef__Group_0_1__0__Impl rule__XFunctionTypeRef__Group_0_1__1 )
            // InternalXbaseWithAnnotations.g:14674:2: rule__XFunctionTypeRef__Group_0_1__0__Impl rule__XFunctionTypeRef__Group_0_1__1
            {
            pushFollow(FOLLOW_8);
            rule__XFunctionTypeRef__Group_0_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__Group_0_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0_1__0"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0_1__0__Impl"
    // InternalXbaseWithAnnotations.g:14681:1: rule__XFunctionTypeRef__Group_0_1__0__Impl : ( ( rule__XFunctionTypeRef__ParamTypesAssignment_0_1_0 ) ) ;
    public final void rule__XFunctionTypeRef__Group_0_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14685:1: ( ( ( rule__XFunctionTypeRef__ParamTypesAssignment_0_1_0 ) ) )
            // InternalXbaseWithAnnotations.g:14686:1: ( ( rule__XFunctionTypeRef__ParamTypesAssignment_0_1_0 ) )
            {
            // InternalXbaseWithAnnotations.g:14686:1: ( ( rule__XFunctionTypeRef__ParamTypesAssignment_0_1_0 ) )
            // InternalXbaseWithAnnotations.g:14687:2: ( rule__XFunctionTypeRef__ParamTypesAssignment_0_1_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getParamTypesAssignment_0_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:14688:2: ( rule__XFunctionTypeRef__ParamTypesAssignment_0_1_0 )
            // InternalXbaseWithAnnotations.g:14688:3: rule__XFunctionTypeRef__ParamTypesAssignment_0_1_0
            {
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__ParamTypesAssignment_0_1_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getParamTypesAssignment_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0_1__0__Impl"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0_1__1"
    // InternalXbaseWithAnnotations.g:14696:1: rule__XFunctionTypeRef__Group_0_1__1 : rule__XFunctionTypeRef__Group_0_1__1__Impl ;
    public final void rule__XFunctionTypeRef__Group_0_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14700:1: ( rule__XFunctionTypeRef__Group_0_1__1__Impl )
            // InternalXbaseWithAnnotations.g:14701:2: rule__XFunctionTypeRef__Group_0_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__Group_0_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0_1__1"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0_1__1__Impl"
    // InternalXbaseWithAnnotations.g:14707:1: rule__XFunctionTypeRef__Group_0_1__1__Impl : ( ( rule__XFunctionTypeRef__Group_0_1_1__0 )* ) ;
    public final void rule__XFunctionTypeRef__Group_0_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14711:1: ( ( ( rule__XFunctionTypeRef__Group_0_1_1__0 )* ) )
            // InternalXbaseWithAnnotations.g:14712:1: ( ( rule__XFunctionTypeRef__Group_0_1_1__0 )* )
            {
            // InternalXbaseWithAnnotations.g:14712:1: ( ( rule__XFunctionTypeRef__Group_0_1_1__0 )* )
            // InternalXbaseWithAnnotations.g:14713:2: ( rule__XFunctionTypeRef__Group_0_1_1__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getGroup_0_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:14714:2: ( rule__XFunctionTypeRef__Group_0_1_1__0 )*
            loop119:
            do {
                int alt119=2;
                int LA119_0 = input.LA(1);

                if ( (LA119_0==54) ) {
                    alt119=1;
                }


                switch (alt119) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:14714:3: rule__XFunctionTypeRef__Group_0_1_1__0
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__XFunctionTypeRef__Group_0_1_1__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop119;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getGroup_0_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0_1__1__Impl"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0_1_1__0"
    // InternalXbaseWithAnnotations.g:14723:1: rule__XFunctionTypeRef__Group_0_1_1__0 : rule__XFunctionTypeRef__Group_0_1_1__0__Impl rule__XFunctionTypeRef__Group_0_1_1__1 ;
    public final void rule__XFunctionTypeRef__Group_0_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14727:1: ( rule__XFunctionTypeRef__Group_0_1_1__0__Impl rule__XFunctionTypeRef__Group_0_1_1__1 )
            // InternalXbaseWithAnnotations.g:14728:2: rule__XFunctionTypeRef__Group_0_1_1__0__Impl rule__XFunctionTypeRef__Group_0_1_1__1
            {
            pushFollow(FOLLOW_27);
            rule__XFunctionTypeRef__Group_0_1_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__Group_0_1_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0_1_1__0"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0_1_1__0__Impl"
    // InternalXbaseWithAnnotations.g:14735:1: rule__XFunctionTypeRef__Group_0_1_1__0__Impl : ( ',' ) ;
    public final void rule__XFunctionTypeRef__Group_0_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14739:1: ( ( ',' ) )
            // InternalXbaseWithAnnotations.g:14740:1: ( ',' )
            {
            // InternalXbaseWithAnnotations.g:14740:1: ( ',' )
            // InternalXbaseWithAnnotations.g:14741:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getCommaKeyword_0_1_1_0()); 
            }
            match(input,54,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getCommaKeyword_0_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0_1_1__0__Impl"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0_1_1__1"
    // InternalXbaseWithAnnotations.g:14750:1: rule__XFunctionTypeRef__Group_0_1_1__1 : rule__XFunctionTypeRef__Group_0_1_1__1__Impl ;
    public final void rule__XFunctionTypeRef__Group_0_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14754:1: ( rule__XFunctionTypeRef__Group_0_1_1__1__Impl )
            // InternalXbaseWithAnnotations.g:14755:2: rule__XFunctionTypeRef__Group_0_1_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__Group_0_1_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0_1_1__1"


    // $ANTLR start "rule__XFunctionTypeRef__Group_0_1_1__1__Impl"
    // InternalXbaseWithAnnotations.g:14761:1: rule__XFunctionTypeRef__Group_0_1_1__1__Impl : ( ( rule__XFunctionTypeRef__ParamTypesAssignment_0_1_1_1 ) ) ;
    public final void rule__XFunctionTypeRef__Group_0_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14765:1: ( ( ( rule__XFunctionTypeRef__ParamTypesAssignment_0_1_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:14766:1: ( ( rule__XFunctionTypeRef__ParamTypesAssignment_0_1_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:14766:1: ( ( rule__XFunctionTypeRef__ParamTypesAssignment_0_1_1_1 ) )
            // InternalXbaseWithAnnotations.g:14767:2: ( rule__XFunctionTypeRef__ParamTypesAssignment_0_1_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getParamTypesAssignment_0_1_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:14768:2: ( rule__XFunctionTypeRef__ParamTypesAssignment_0_1_1_1 )
            // InternalXbaseWithAnnotations.g:14768:3: rule__XFunctionTypeRef__ParamTypesAssignment_0_1_1_1
            {
            pushFollow(FOLLOW_2);
            rule__XFunctionTypeRef__ParamTypesAssignment_0_1_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getParamTypesAssignment_0_1_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__Group_0_1_1__1__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group__0"
    // InternalXbaseWithAnnotations.g:14777:1: rule__JvmParameterizedTypeReference__Group__0 : rule__JvmParameterizedTypeReference__Group__0__Impl rule__JvmParameterizedTypeReference__Group__1 ;
    public final void rule__JvmParameterizedTypeReference__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14781:1: ( rule__JvmParameterizedTypeReference__Group__0__Impl rule__JvmParameterizedTypeReference__Group__1 )
            // InternalXbaseWithAnnotations.g:14782:2: rule__JvmParameterizedTypeReference__Group__0__Impl rule__JvmParameterizedTypeReference__Group__1
            {
            pushFollow(FOLLOW_17);
            rule__JvmParameterizedTypeReference__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group__0"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:14789:1: rule__JvmParameterizedTypeReference__Group__0__Impl : ( ( rule__JvmParameterizedTypeReference__TypeAssignment_0 ) ) ;
    public final void rule__JvmParameterizedTypeReference__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14793:1: ( ( ( rule__JvmParameterizedTypeReference__TypeAssignment_0 ) ) )
            // InternalXbaseWithAnnotations.g:14794:1: ( ( rule__JvmParameterizedTypeReference__TypeAssignment_0 ) )
            {
            // InternalXbaseWithAnnotations.g:14794:1: ( ( rule__JvmParameterizedTypeReference__TypeAssignment_0 ) )
            // InternalXbaseWithAnnotations.g:14795:2: ( rule__JvmParameterizedTypeReference__TypeAssignment_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeAssignment_0()); 
            }
            // InternalXbaseWithAnnotations.g:14796:2: ( rule__JvmParameterizedTypeReference__TypeAssignment_0 )
            // InternalXbaseWithAnnotations.g:14796:3: rule__JvmParameterizedTypeReference__TypeAssignment_0
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__TypeAssignment_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeAssignment_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group__0__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group__1"
    // InternalXbaseWithAnnotations.g:14804:1: rule__JvmParameterizedTypeReference__Group__1 : rule__JvmParameterizedTypeReference__Group__1__Impl ;
    public final void rule__JvmParameterizedTypeReference__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14808:1: ( rule__JvmParameterizedTypeReference__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:14809:2: rule__JvmParameterizedTypeReference__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group__1"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:14815:1: rule__JvmParameterizedTypeReference__Group__1__Impl : ( ( rule__JvmParameterizedTypeReference__Group_1__0 )? ) ;
    public final void rule__JvmParameterizedTypeReference__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14819:1: ( ( ( rule__JvmParameterizedTypeReference__Group_1__0 )? ) )
            // InternalXbaseWithAnnotations.g:14820:1: ( ( rule__JvmParameterizedTypeReference__Group_1__0 )? )
            {
            // InternalXbaseWithAnnotations.g:14820:1: ( ( rule__JvmParameterizedTypeReference__Group_1__0 )? )
            // InternalXbaseWithAnnotations.g:14821:2: ( rule__JvmParameterizedTypeReference__Group_1__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1()); 
            }
            // InternalXbaseWithAnnotations.g:14822:2: ( rule__JvmParameterizedTypeReference__Group_1__0 )?
            int alt120=2;
            alt120 = dfa120.predict(input);
            switch (alt120) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:14822:3: rule__JvmParameterizedTypeReference__Group_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__JvmParameterizedTypeReference__Group_1__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group__1__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1__0"
    // InternalXbaseWithAnnotations.g:14831:1: rule__JvmParameterizedTypeReference__Group_1__0 : rule__JvmParameterizedTypeReference__Group_1__0__Impl rule__JvmParameterizedTypeReference__Group_1__1 ;
    public final void rule__JvmParameterizedTypeReference__Group_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14835:1: ( rule__JvmParameterizedTypeReference__Group_1__0__Impl rule__JvmParameterizedTypeReference__Group_1__1 )
            // InternalXbaseWithAnnotations.g:14836:2: rule__JvmParameterizedTypeReference__Group_1__0__Impl rule__JvmParameterizedTypeReference__Group_1__1
            {
            pushFollow(FOLLOW_47);
            rule__JvmParameterizedTypeReference__Group_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1__0"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1__0__Impl"
    // InternalXbaseWithAnnotations.g:14843:1: rule__JvmParameterizedTypeReference__Group_1__0__Impl : ( ( '<' ) ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14847:1: ( ( ( '<' ) ) )
            // InternalXbaseWithAnnotations.g:14848:1: ( ( '<' ) )
            {
            // InternalXbaseWithAnnotations.g:14848:1: ( ( '<' ) )
            // InternalXbaseWithAnnotations.g:14849:2: ( '<' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getLessThanSignKeyword_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:14850:2: ( '<' )
            // InternalXbaseWithAnnotations.g:14850:3: '<'
            {
            match(input,27,FOLLOW_2); if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getLessThanSignKeyword_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1__0__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1__1"
    // InternalXbaseWithAnnotations.g:14858:1: rule__JvmParameterizedTypeReference__Group_1__1 : rule__JvmParameterizedTypeReference__Group_1__1__Impl rule__JvmParameterizedTypeReference__Group_1__2 ;
    public final void rule__JvmParameterizedTypeReference__Group_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14862:1: ( rule__JvmParameterizedTypeReference__Group_1__1__Impl rule__JvmParameterizedTypeReference__Group_1__2 )
            // InternalXbaseWithAnnotations.g:14863:2: rule__JvmParameterizedTypeReference__Group_1__1__Impl rule__JvmParameterizedTypeReference__Group_1__2
            {
            pushFollow(FOLLOW_48);
            rule__JvmParameterizedTypeReference__Group_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1__1"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1__1__Impl"
    // InternalXbaseWithAnnotations.g:14870:1: rule__JvmParameterizedTypeReference__Group_1__1__Impl : ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_1 ) ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14874:1: ( ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_1 ) ) )
            // InternalXbaseWithAnnotations.g:14875:1: ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_1 ) )
            {
            // InternalXbaseWithAnnotations.g:14875:1: ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_1 ) )
            // InternalXbaseWithAnnotations.g:14876:2: ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsAssignment_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:14877:2: ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_1 )
            // InternalXbaseWithAnnotations.g:14877:3: rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_1
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsAssignment_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1__1__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1__2"
    // InternalXbaseWithAnnotations.g:14885:1: rule__JvmParameterizedTypeReference__Group_1__2 : rule__JvmParameterizedTypeReference__Group_1__2__Impl rule__JvmParameterizedTypeReference__Group_1__3 ;
    public final void rule__JvmParameterizedTypeReference__Group_1__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14889:1: ( rule__JvmParameterizedTypeReference__Group_1__2__Impl rule__JvmParameterizedTypeReference__Group_1__3 )
            // InternalXbaseWithAnnotations.g:14890:2: rule__JvmParameterizedTypeReference__Group_1__2__Impl rule__JvmParameterizedTypeReference__Group_1__3
            {
            pushFollow(FOLLOW_48);
            rule__JvmParameterizedTypeReference__Group_1__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1__2"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1__2__Impl"
    // InternalXbaseWithAnnotations.g:14897:1: rule__JvmParameterizedTypeReference__Group_1__2__Impl : ( ( rule__JvmParameterizedTypeReference__Group_1_2__0 )* ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14901:1: ( ( ( rule__JvmParameterizedTypeReference__Group_1_2__0 )* ) )
            // InternalXbaseWithAnnotations.g:14902:1: ( ( rule__JvmParameterizedTypeReference__Group_1_2__0 )* )
            {
            // InternalXbaseWithAnnotations.g:14902:1: ( ( rule__JvmParameterizedTypeReference__Group_1_2__0 )* )
            // InternalXbaseWithAnnotations.g:14903:2: ( rule__JvmParameterizedTypeReference__Group_1_2__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1_2()); 
            }
            // InternalXbaseWithAnnotations.g:14904:2: ( rule__JvmParameterizedTypeReference__Group_1_2__0 )*
            loop121:
            do {
                int alt121=2;
                int LA121_0 = input.LA(1);

                if ( (LA121_0==54) ) {
                    alt121=1;
                }


                switch (alt121) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:14904:3: rule__JvmParameterizedTypeReference__Group_1_2__0
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__JvmParameterizedTypeReference__Group_1_2__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop121;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1__2__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1__3"
    // InternalXbaseWithAnnotations.g:14912:1: rule__JvmParameterizedTypeReference__Group_1__3 : rule__JvmParameterizedTypeReference__Group_1__3__Impl rule__JvmParameterizedTypeReference__Group_1__4 ;
    public final void rule__JvmParameterizedTypeReference__Group_1__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14916:1: ( rule__JvmParameterizedTypeReference__Group_1__3__Impl rule__JvmParameterizedTypeReference__Group_1__4 )
            // InternalXbaseWithAnnotations.g:14917:2: rule__JvmParameterizedTypeReference__Group_1__3__Impl rule__JvmParameterizedTypeReference__Group_1__4
            {
            pushFollow(FOLLOW_90);
            rule__JvmParameterizedTypeReference__Group_1__3__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1__4();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1__3"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1__3__Impl"
    // InternalXbaseWithAnnotations.g:14924:1: rule__JvmParameterizedTypeReference__Group_1__3__Impl : ( '>' ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14928:1: ( ( '>' ) )
            // InternalXbaseWithAnnotations.g:14929:1: ( '>' )
            {
            // InternalXbaseWithAnnotations.g:14929:1: ( '>' )
            // InternalXbaseWithAnnotations.g:14930:2: '>'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGreaterThanSignKeyword_1_3()); 
            }
            match(input,26,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGreaterThanSignKeyword_1_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1__3__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1__4"
    // InternalXbaseWithAnnotations.g:14939:1: rule__JvmParameterizedTypeReference__Group_1__4 : rule__JvmParameterizedTypeReference__Group_1__4__Impl ;
    public final void rule__JvmParameterizedTypeReference__Group_1__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14943:1: ( rule__JvmParameterizedTypeReference__Group_1__4__Impl )
            // InternalXbaseWithAnnotations.g:14944:2: rule__JvmParameterizedTypeReference__Group_1__4__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1__4__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1__4"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1__4__Impl"
    // InternalXbaseWithAnnotations.g:14950:1: rule__JvmParameterizedTypeReference__Group_1__4__Impl : ( ( rule__JvmParameterizedTypeReference__Group_1_4__0 )* ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14954:1: ( ( ( rule__JvmParameterizedTypeReference__Group_1_4__0 )* ) )
            // InternalXbaseWithAnnotations.g:14955:1: ( ( rule__JvmParameterizedTypeReference__Group_1_4__0 )* )
            {
            // InternalXbaseWithAnnotations.g:14955:1: ( ( rule__JvmParameterizedTypeReference__Group_1_4__0 )* )
            // InternalXbaseWithAnnotations.g:14956:2: ( rule__JvmParameterizedTypeReference__Group_1_4__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1_4()); 
            }
            // InternalXbaseWithAnnotations.g:14957:2: ( rule__JvmParameterizedTypeReference__Group_1_4__0 )*
            loop122:
            do {
                int alt122=2;
                int LA122_0 = input.LA(1);

                if ( (LA122_0==43) ) {
                    int LA122_2 = input.LA(2);

                    if ( (LA122_2==RULE_ID) ) {
                        int LA122_3 = input.LA(3);

                        if ( (synpred165_InternalXbaseWithAnnotations()) ) {
                            alt122=1;
                        }


                    }


                }


                switch (alt122) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:14957:3: rule__JvmParameterizedTypeReference__Group_1_4__0
            	    {
            	    pushFollow(FOLLOW_91);
            	    rule__JvmParameterizedTypeReference__Group_1_4__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop122;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1_4()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1__4__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_2__0"
    // InternalXbaseWithAnnotations.g:14966:1: rule__JvmParameterizedTypeReference__Group_1_2__0 : rule__JvmParameterizedTypeReference__Group_1_2__0__Impl rule__JvmParameterizedTypeReference__Group_1_2__1 ;
    public final void rule__JvmParameterizedTypeReference__Group_1_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14970:1: ( rule__JvmParameterizedTypeReference__Group_1_2__0__Impl rule__JvmParameterizedTypeReference__Group_1_2__1 )
            // InternalXbaseWithAnnotations.g:14971:2: rule__JvmParameterizedTypeReference__Group_1_2__0__Impl rule__JvmParameterizedTypeReference__Group_1_2__1
            {
            pushFollow(FOLLOW_47);
            rule__JvmParameterizedTypeReference__Group_1_2__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_2__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_2__0"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_2__0__Impl"
    // InternalXbaseWithAnnotations.g:14978:1: rule__JvmParameterizedTypeReference__Group_1_2__0__Impl : ( ',' ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14982:1: ( ( ',' ) )
            // InternalXbaseWithAnnotations.g:14983:1: ( ',' )
            {
            // InternalXbaseWithAnnotations.g:14983:1: ( ',' )
            // InternalXbaseWithAnnotations.g:14984:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getCommaKeyword_1_2_0()); 
            }
            match(input,54,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getCommaKeyword_1_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_2__0__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_2__1"
    // InternalXbaseWithAnnotations.g:14993:1: rule__JvmParameterizedTypeReference__Group_1_2__1 : rule__JvmParameterizedTypeReference__Group_1_2__1__Impl ;
    public final void rule__JvmParameterizedTypeReference__Group_1_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:14997:1: ( rule__JvmParameterizedTypeReference__Group_1_2__1__Impl )
            // InternalXbaseWithAnnotations.g:14998:2: rule__JvmParameterizedTypeReference__Group_1_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_2__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_2__1"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_2__1__Impl"
    // InternalXbaseWithAnnotations.g:15004:1: rule__JvmParameterizedTypeReference__Group_1_2__1__Impl : ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_2_1 ) ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15008:1: ( ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_2_1 ) ) )
            // InternalXbaseWithAnnotations.g:15009:1: ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_2_1 ) )
            {
            // InternalXbaseWithAnnotations.g:15009:1: ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_2_1 ) )
            // InternalXbaseWithAnnotations.g:15010:2: ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_2_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsAssignment_1_2_1()); 
            }
            // InternalXbaseWithAnnotations.g:15011:2: ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_2_1 )
            // InternalXbaseWithAnnotations.g:15011:3: rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_2_1
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_2_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsAssignment_1_2_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_2__1__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4__0"
    // InternalXbaseWithAnnotations.g:15020:1: rule__JvmParameterizedTypeReference__Group_1_4__0 : rule__JvmParameterizedTypeReference__Group_1_4__0__Impl rule__JvmParameterizedTypeReference__Group_1_4__1 ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15024:1: ( rule__JvmParameterizedTypeReference__Group_1_4__0__Impl rule__JvmParameterizedTypeReference__Group_1_4__1 )
            // InternalXbaseWithAnnotations.g:15025:2: rule__JvmParameterizedTypeReference__Group_1_4__0__Impl rule__JvmParameterizedTypeReference__Group_1_4__1
            {
            pushFollow(FOLLOW_5);
            rule__JvmParameterizedTypeReference__Group_1_4__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4__0"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4__0__Impl"
    // InternalXbaseWithAnnotations.g:15032:1: rule__JvmParameterizedTypeReference__Group_1_4__0__Impl : ( ( rule__JvmParameterizedTypeReference__Group_1_4_0__0 ) ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15036:1: ( ( ( rule__JvmParameterizedTypeReference__Group_1_4_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:15037:1: ( ( rule__JvmParameterizedTypeReference__Group_1_4_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:15037:1: ( ( rule__JvmParameterizedTypeReference__Group_1_4_0__0 ) )
            // InternalXbaseWithAnnotations.g:15038:2: ( rule__JvmParameterizedTypeReference__Group_1_4_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1_4_0()); 
            }
            // InternalXbaseWithAnnotations.g:15039:2: ( rule__JvmParameterizedTypeReference__Group_1_4_0__0 )
            // InternalXbaseWithAnnotations.g:15039:3: rule__JvmParameterizedTypeReference__Group_1_4_0__0
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1_4_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4__0__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4__1"
    // InternalXbaseWithAnnotations.g:15047:1: rule__JvmParameterizedTypeReference__Group_1_4__1 : rule__JvmParameterizedTypeReference__Group_1_4__1__Impl rule__JvmParameterizedTypeReference__Group_1_4__2 ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15051:1: ( rule__JvmParameterizedTypeReference__Group_1_4__1__Impl rule__JvmParameterizedTypeReference__Group_1_4__2 )
            // InternalXbaseWithAnnotations.g:15052:2: rule__JvmParameterizedTypeReference__Group_1_4__1__Impl rule__JvmParameterizedTypeReference__Group_1_4__2
            {
            pushFollow(FOLLOW_17);
            rule__JvmParameterizedTypeReference__Group_1_4__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4__1"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4__1__Impl"
    // InternalXbaseWithAnnotations.g:15059:1: rule__JvmParameterizedTypeReference__Group_1_4__1__Impl : ( ( rule__JvmParameterizedTypeReference__TypeAssignment_1_4_1 ) ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15063:1: ( ( ( rule__JvmParameterizedTypeReference__TypeAssignment_1_4_1 ) ) )
            // InternalXbaseWithAnnotations.g:15064:1: ( ( rule__JvmParameterizedTypeReference__TypeAssignment_1_4_1 ) )
            {
            // InternalXbaseWithAnnotations.g:15064:1: ( ( rule__JvmParameterizedTypeReference__TypeAssignment_1_4_1 ) )
            // InternalXbaseWithAnnotations.g:15065:2: ( rule__JvmParameterizedTypeReference__TypeAssignment_1_4_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeAssignment_1_4_1()); 
            }
            // InternalXbaseWithAnnotations.g:15066:2: ( rule__JvmParameterizedTypeReference__TypeAssignment_1_4_1 )
            // InternalXbaseWithAnnotations.g:15066:3: rule__JvmParameterizedTypeReference__TypeAssignment_1_4_1
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__TypeAssignment_1_4_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeAssignment_1_4_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4__1__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4__2"
    // InternalXbaseWithAnnotations.g:15074:1: rule__JvmParameterizedTypeReference__Group_1_4__2 : rule__JvmParameterizedTypeReference__Group_1_4__2__Impl ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15078:1: ( rule__JvmParameterizedTypeReference__Group_1_4__2__Impl )
            // InternalXbaseWithAnnotations.g:15079:2: rule__JvmParameterizedTypeReference__Group_1_4__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4__2"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4__2__Impl"
    // InternalXbaseWithAnnotations.g:15085:1: rule__JvmParameterizedTypeReference__Group_1_4__2__Impl : ( ( rule__JvmParameterizedTypeReference__Group_1_4_2__0 )? ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15089:1: ( ( ( rule__JvmParameterizedTypeReference__Group_1_4_2__0 )? ) )
            // InternalXbaseWithAnnotations.g:15090:1: ( ( rule__JvmParameterizedTypeReference__Group_1_4_2__0 )? )
            {
            // InternalXbaseWithAnnotations.g:15090:1: ( ( rule__JvmParameterizedTypeReference__Group_1_4_2__0 )? )
            // InternalXbaseWithAnnotations.g:15091:2: ( rule__JvmParameterizedTypeReference__Group_1_4_2__0 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1_4_2()); 
            }
            // InternalXbaseWithAnnotations.g:15092:2: ( rule__JvmParameterizedTypeReference__Group_1_4_2__0 )?
            int alt123=2;
            alt123 = dfa123.predict(input);
            switch (alt123) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:15092:3: rule__JvmParameterizedTypeReference__Group_1_4_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__JvmParameterizedTypeReference__Group_1_4_2__0();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1_4_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4__2__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_0__0"
    // InternalXbaseWithAnnotations.g:15101:1: rule__JvmParameterizedTypeReference__Group_1_4_0__0 : rule__JvmParameterizedTypeReference__Group_1_4_0__0__Impl ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15105:1: ( rule__JvmParameterizedTypeReference__Group_1_4_0__0__Impl )
            // InternalXbaseWithAnnotations.g:15106:2: rule__JvmParameterizedTypeReference__Group_1_4_0__0__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_0__0"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_0__0__Impl"
    // InternalXbaseWithAnnotations.g:15112:1: rule__JvmParameterizedTypeReference__Group_1_4_0__0__Impl : ( ( rule__JvmParameterizedTypeReference__Group_1_4_0_0__0 ) ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15116:1: ( ( ( rule__JvmParameterizedTypeReference__Group_1_4_0_0__0 ) ) )
            // InternalXbaseWithAnnotations.g:15117:1: ( ( rule__JvmParameterizedTypeReference__Group_1_4_0_0__0 ) )
            {
            // InternalXbaseWithAnnotations.g:15117:1: ( ( rule__JvmParameterizedTypeReference__Group_1_4_0_0__0 ) )
            // InternalXbaseWithAnnotations.g:15118:2: ( rule__JvmParameterizedTypeReference__Group_1_4_0_0__0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1_4_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:15119:2: ( rule__JvmParameterizedTypeReference__Group_1_4_0_0__0 )
            // InternalXbaseWithAnnotations.g:15119:3: rule__JvmParameterizedTypeReference__Group_1_4_0_0__0
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4_0_0__0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1_4_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_0__0__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_0_0__0"
    // InternalXbaseWithAnnotations.g:15128:1: rule__JvmParameterizedTypeReference__Group_1_4_0_0__0 : rule__JvmParameterizedTypeReference__Group_1_4_0_0__0__Impl rule__JvmParameterizedTypeReference__Group_1_4_0_0__1 ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_0_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15132:1: ( rule__JvmParameterizedTypeReference__Group_1_4_0_0__0__Impl rule__JvmParameterizedTypeReference__Group_1_4_0_0__1 )
            // InternalXbaseWithAnnotations.g:15133:2: rule__JvmParameterizedTypeReference__Group_1_4_0_0__0__Impl rule__JvmParameterizedTypeReference__Group_1_4_0_0__1
            {
            pushFollow(FOLLOW_90);
            rule__JvmParameterizedTypeReference__Group_1_4_0_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4_0_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_0_0__0"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_0_0__0__Impl"
    // InternalXbaseWithAnnotations.g:15140:1: rule__JvmParameterizedTypeReference__Group_1_4_0_0__0__Impl : ( () ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_0_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15144:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:15145:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:15145:1: ( () )
            // InternalXbaseWithAnnotations.g:15146:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getJvmInnerTypeReferenceOuterAction_1_4_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:15147:2: ()
            // InternalXbaseWithAnnotations.g:15147:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getJvmInnerTypeReferenceOuterAction_1_4_0_0_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_0_0__0__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_0_0__1"
    // InternalXbaseWithAnnotations.g:15155:1: rule__JvmParameterizedTypeReference__Group_1_4_0_0__1 : rule__JvmParameterizedTypeReference__Group_1_4_0_0__1__Impl ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_0_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15159:1: ( rule__JvmParameterizedTypeReference__Group_1_4_0_0__1__Impl )
            // InternalXbaseWithAnnotations.g:15160:2: rule__JvmParameterizedTypeReference__Group_1_4_0_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4_0_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_0_0__1"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_0_0__1__Impl"
    // InternalXbaseWithAnnotations.g:15166:1: rule__JvmParameterizedTypeReference__Group_1_4_0_0__1__Impl : ( '.' ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_0_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15170:1: ( ( '.' ) )
            // InternalXbaseWithAnnotations.g:15171:1: ( '.' )
            {
            // InternalXbaseWithAnnotations.g:15171:1: ( '.' )
            // InternalXbaseWithAnnotations.g:15172:2: '.'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getFullStopKeyword_1_4_0_0_1()); 
            }
            match(input,43,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getFullStopKeyword_1_4_0_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_0_0__1__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_2__0"
    // InternalXbaseWithAnnotations.g:15182:1: rule__JvmParameterizedTypeReference__Group_1_4_2__0 : rule__JvmParameterizedTypeReference__Group_1_4_2__0__Impl rule__JvmParameterizedTypeReference__Group_1_4_2__1 ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15186:1: ( rule__JvmParameterizedTypeReference__Group_1_4_2__0__Impl rule__JvmParameterizedTypeReference__Group_1_4_2__1 )
            // InternalXbaseWithAnnotations.g:15187:2: rule__JvmParameterizedTypeReference__Group_1_4_2__0__Impl rule__JvmParameterizedTypeReference__Group_1_4_2__1
            {
            pushFollow(FOLLOW_47);
            rule__JvmParameterizedTypeReference__Group_1_4_2__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4_2__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_2__0"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_2__0__Impl"
    // InternalXbaseWithAnnotations.g:15194:1: rule__JvmParameterizedTypeReference__Group_1_4_2__0__Impl : ( ( '<' ) ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15198:1: ( ( ( '<' ) ) )
            // InternalXbaseWithAnnotations.g:15199:1: ( ( '<' ) )
            {
            // InternalXbaseWithAnnotations.g:15199:1: ( ( '<' ) )
            // InternalXbaseWithAnnotations.g:15200:2: ( '<' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getLessThanSignKeyword_1_4_2_0()); 
            }
            // InternalXbaseWithAnnotations.g:15201:2: ( '<' )
            // InternalXbaseWithAnnotations.g:15201:3: '<'
            {
            match(input,27,FOLLOW_2); if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getLessThanSignKeyword_1_4_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_2__0__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_2__1"
    // InternalXbaseWithAnnotations.g:15209:1: rule__JvmParameterizedTypeReference__Group_1_4_2__1 : rule__JvmParameterizedTypeReference__Group_1_4_2__1__Impl rule__JvmParameterizedTypeReference__Group_1_4_2__2 ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15213:1: ( rule__JvmParameterizedTypeReference__Group_1_4_2__1__Impl rule__JvmParameterizedTypeReference__Group_1_4_2__2 )
            // InternalXbaseWithAnnotations.g:15214:2: rule__JvmParameterizedTypeReference__Group_1_4_2__1__Impl rule__JvmParameterizedTypeReference__Group_1_4_2__2
            {
            pushFollow(FOLLOW_48);
            rule__JvmParameterizedTypeReference__Group_1_4_2__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4_2__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_2__1"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_2__1__Impl"
    // InternalXbaseWithAnnotations.g:15221:1: rule__JvmParameterizedTypeReference__Group_1_4_2__1__Impl : ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_1 ) ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15225:1: ( ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_1 ) ) )
            // InternalXbaseWithAnnotations.g:15226:1: ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_1 ) )
            {
            // InternalXbaseWithAnnotations.g:15226:1: ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_1 ) )
            // InternalXbaseWithAnnotations.g:15227:2: ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsAssignment_1_4_2_1()); 
            }
            // InternalXbaseWithAnnotations.g:15228:2: ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_1 )
            // InternalXbaseWithAnnotations.g:15228:3: rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_1
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsAssignment_1_4_2_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_2__1__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_2__2"
    // InternalXbaseWithAnnotations.g:15236:1: rule__JvmParameterizedTypeReference__Group_1_4_2__2 : rule__JvmParameterizedTypeReference__Group_1_4_2__2__Impl rule__JvmParameterizedTypeReference__Group_1_4_2__3 ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_2__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15240:1: ( rule__JvmParameterizedTypeReference__Group_1_4_2__2__Impl rule__JvmParameterizedTypeReference__Group_1_4_2__3 )
            // InternalXbaseWithAnnotations.g:15241:2: rule__JvmParameterizedTypeReference__Group_1_4_2__2__Impl rule__JvmParameterizedTypeReference__Group_1_4_2__3
            {
            pushFollow(FOLLOW_48);
            rule__JvmParameterizedTypeReference__Group_1_4_2__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4_2__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_2__2"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_2__2__Impl"
    // InternalXbaseWithAnnotations.g:15248:1: rule__JvmParameterizedTypeReference__Group_1_4_2__2__Impl : ( ( rule__JvmParameterizedTypeReference__Group_1_4_2_2__0 )* ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_2__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15252:1: ( ( ( rule__JvmParameterizedTypeReference__Group_1_4_2_2__0 )* ) )
            // InternalXbaseWithAnnotations.g:15253:1: ( ( rule__JvmParameterizedTypeReference__Group_1_4_2_2__0 )* )
            {
            // InternalXbaseWithAnnotations.g:15253:1: ( ( rule__JvmParameterizedTypeReference__Group_1_4_2_2__0 )* )
            // InternalXbaseWithAnnotations.g:15254:2: ( rule__JvmParameterizedTypeReference__Group_1_4_2_2__0 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1_4_2_2()); 
            }
            // InternalXbaseWithAnnotations.g:15255:2: ( rule__JvmParameterizedTypeReference__Group_1_4_2_2__0 )*
            loop124:
            do {
                int alt124=2;
                int LA124_0 = input.LA(1);

                if ( (LA124_0==54) ) {
                    alt124=1;
                }


                switch (alt124) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:15255:3: rule__JvmParameterizedTypeReference__Group_1_4_2_2__0
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__JvmParameterizedTypeReference__Group_1_4_2_2__0();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop124;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGroup_1_4_2_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_2__2__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_2__3"
    // InternalXbaseWithAnnotations.g:15263:1: rule__JvmParameterizedTypeReference__Group_1_4_2__3 : rule__JvmParameterizedTypeReference__Group_1_4_2__3__Impl ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_2__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15267:1: ( rule__JvmParameterizedTypeReference__Group_1_4_2__3__Impl )
            // InternalXbaseWithAnnotations.g:15268:2: rule__JvmParameterizedTypeReference__Group_1_4_2__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4_2__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_2__3"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_2__3__Impl"
    // InternalXbaseWithAnnotations.g:15274:1: rule__JvmParameterizedTypeReference__Group_1_4_2__3__Impl : ( '>' ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_2__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15278:1: ( ( '>' ) )
            // InternalXbaseWithAnnotations.g:15279:1: ( '>' )
            {
            // InternalXbaseWithAnnotations.g:15279:1: ( '>' )
            // InternalXbaseWithAnnotations.g:15280:2: '>'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGreaterThanSignKeyword_1_4_2_3()); 
            }
            match(input,26,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getGreaterThanSignKeyword_1_4_2_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_2__3__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_2_2__0"
    // InternalXbaseWithAnnotations.g:15290:1: rule__JvmParameterizedTypeReference__Group_1_4_2_2__0 : rule__JvmParameterizedTypeReference__Group_1_4_2_2__0__Impl rule__JvmParameterizedTypeReference__Group_1_4_2_2__1 ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_2_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15294:1: ( rule__JvmParameterizedTypeReference__Group_1_4_2_2__0__Impl rule__JvmParameterizedTypeReference__Group_1_4_2_2__1 )
            // InternalXbaseWithAnnotations.g:15295:2: rule__JvmParameterizedTypeReference__Group_1_4_2_2__0__Impl rule__JvmParameterizedTypeReference__Group_1_4_2_2__1
            {
            pushFollow(FOLLOW_47);
            rule__JvmParameterizedTypeReference__Group_1_4_2_2__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4_2_2__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_2_2__0"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_2_2__0__Impl"
    // InternalXbaseWithAnnotations.g:15302:1: rule__JvmParameterizedTypeReference__Group_1_4_2_2__0__Impl : ( ',' ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_2_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15306:1: ( ( ',' ) )
            // InternalXbaseWithAnnotations.g:15307:1: ( ',' )
            {
            // InternalXbaseWithAnnotations.g:15307:1: ( ',' )
            // InternalXbaseWithAnnotations.g:15308:2: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getCommaKeyword_1_4_2_2_0()); 
            }
            match(input,54,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getCommaKeyword_1_4_2_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_2_2__0__Impl"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_2_2__1"
    // InternalXbaseWithAnnotations.g:15317:1: rule__JvmParameterizedTypeReference__Group_1_4_2_2__1 : rule__JvmParameterizedTypeReference__Group_1_4_2_2__1__Impl ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_2_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15321:1: ( rule__JvmParameterizedTypeReference__Group_1_4_2_2__1__Impl )
            // InternalXbaseWithAnnotations.g:15322:2: rule__JvmParameterizedTypeReference__Group_1_4_2_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__Group_1_4_2_2__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_2_2__1"


    // $ANTLR start "rule__JvmParameterizedTypeReference__Group_1_4_2_2__1__Impl"
    // InternalXbaseWithAnnotations.g:15328:1: rule__JvmParameterizedTypeReference__Group_1_4_2_2__1__Impl : ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_2_1 ) ) ;
    public final void rule__JvmParameterizedTypeReference__Group_1_4_2_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15332:1: ( ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_2_1 ) ) )
            // InternalXbaseWithAnnotations.g:15333:1: ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_2_1 ) )
            {
            // InternalXbaseWithAnnotations.g:15333:1: ( ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_2_1 ) )
            // InternalXbaseWithAnnotations.g:15334:2: ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_2_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsAssignment_1_4_2_2_1()); 
            }
            // InternalXbaseWithAnnotations.g:15335:2: ( rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_2_1 )
            // InternalXbaseWithAnnotations.g:15335:3: rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_2_1
            {
            pushFollow(FOLLOW_2);
            rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_2_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsAssignment_1_4_2_2_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__Group_1_4_2_2__1__Impl"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group__0"
    // InternalXbaseWithAnnotations.g:15344:1: rule__JvmWildcardTypeReference__Group__0 : rule__JvmWildcardTypeReference__Group__0__Impl rule__JvmWildcardTypeReference__Group__1 ;
    public final void rule__JvmWildcardTypeReference__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15348:1: ( rule__JvmWildcardTypeReference__Group__0__Impl rule__JvmWildcardTypeReference__Group__1 )
            // InternalXbaseWithAnnotations.g:15349:2: rule__JvmWildcardTypeReference__Group__0__Impl rule__JvmWildcardTypeReference__Group__1
            {
            pushFollow(FOLLOW_47);
            rule__JvmWildcardTypeReference__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmWildcardTypeReference__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group__0"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:15356:1: rule__JvmWildcardTypeReference__Group__0__Impl : ( () ) ;
    public final void rule__JvmWildcardTypeReference__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15360:1: ( ( () ) )
            // InternalXbaseWithAnnotations.g:15361:1: ( () )
            {
            // InternalXbaseWithAnnotations.g:15361:1: ( () )
            // InternalXbaseWithAnnotations.g:15362:2: ()
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceAccess().getJvmWildcardTypeReferenceAction_0()); 
            }
            // InternalXbaseWithAnnotations.g:15363:2: ()
            // InternalXbaseWithAnnotations.g:15363:3: 
            {
            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceAccess().getJvmWildcardTypeReferenceAction_0()); 
            }

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group__0__Impl"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group__1"
    // InternalXbaseWithAnnotations.g:15371:1: rule__JvmWildcardTypeReference__Group__1 : rule__JvmWildcardTypeReference__Group__1__Impl rule__JvmWildcardTypeReference__Group__2 ;
    public final void rule__JvmWildcardTypeReference__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15375:1: ( rule__JvmWildcardTypeReference__Group__1__Impl rule__JvmWildcardTypeReference__Group__2 )
            // InternalXbaseWithAnnotations.g:15376:2: rule__JvmWildcardTypeReference__Group__1__Impl rule__JvmWildcardTypeReference__Group__2
            {
            pushFollow(FOLLOW_94);
            rule__JvmWildcardTypeReference__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmWildcardTypeReference__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group__1"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:15383:1: rule__JvmWildcardTypeReference__Group__1__Impl : ( '?' ) ;
    public final void rule__JvmWildcardTypeReference__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15387:1: ( ( '?' ) )
            // InternalXbaseWithAnnotations.g:15388:1: ( '?' )
            {
            // InternalXbaseWithAnnotations.g:15388:1: ( '?' )
            // InternalXbaseWithAnnotations.g:15389:2: '?'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceAccess().getQuestionMarkKeyword_1()); 
            }
            match(input,81,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceAccess().getQuestionMarkKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group__1__Impl"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group__2"
    // InternalXbaseWithAnnotations.g:15398:1: rule__JvmWildcardTypeReference__Group__2 : rule__JvmWildcardTypeReference__Group__2__Impl ;
    public final void rule__JvmWildcardTypeReference__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15402:1: ( rule__JvmWildcardTypeReference__Group__2__Impl )
            // InternalXbaseWithAnnotations.g:15403:2: rule__JvmWildcardTypeReference__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmWildcardTypeReference__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group__2"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:15409:1: rule__JvmWildcardTypeReference__Group__2__Impl : ( ( rule__JvmWildcardTypeReference__Alternatives_2 )? ) ;
    public final void rule__JvmWildcardTypeReference__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15413:1: ( ( ( rule__JvmWildcardTypeReference__Alternatives_2 )? ) )
            // InternalXbaseWithAnnotations.g:15414:1: ( ( rule__JvmWildcardTypeReference__Alternatives_2 )? )
            {
            // InternalXbaseWithAnnotations.g:15414:1: ( ( rule__JvmWildcardTypeReference__Alternatives_2 )? )
            // InternalXbaseWithAnnotations.g:15415:2: ( rule__JvmWildcardTypeReference__Alternatives_2 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceAccess().getAlternatives_2()); 
            }
            // InternalXbaseWithAnnotations.g:15416:2: ( rule__JvmWildcardTypeReference__Alternatives_2 )?
            int alt125=2;
            int LA125_0 = input.LA(1);

            if ( (LA125_0==45||LA125_0==49) ) {
                alt125=1;
            }
            switch (alt125) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:15416:3: rule__JvmWildcardTypeReference__Alternatives_2
                    {
                    pushFollow(FOLLOW_2);
                    rule__JvmWildcardTypeReference__Alternatives_2();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceAccess().getAlternatives_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group__2__Impl"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group_2_0__0"
    // InternalXbaseWithAnnotations.g:15425:1: rule__JvmWildcardTypeReference__Group_2_0__0 : rule__JvmWildcardTypeReference__Group_2_0__0__Impl rule__JvmWildcardTypeReference__Group_2_0__1 ;
    public final void rule__JvmWildcardTypeReference__Group_2_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15429:1: ( rule__JvmWildcardTypeReference__Group_2_0__0__Impl rule__JvmWildcardTypeReference__Group_2_0__1 )
            // InternalXbaseWithAnnotations.g:15430:2: rule__JvmWildcardTypeReference__Group_2_0__0__Impl rule__JvmWildcardTypeReference__Group_2_0__1
            {
            pushFollow(FOLLOW_95);
            rule__JvmWildcardTypeReference__Group_2_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmWildcardTypeReference__Group_2_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group_2_0__0"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group_2_0__0__Impl"
    // InternalXbaseWithAnnotations.g:15437:1: rule__JvmWildcardTypeReference__Group_2_0__0__Impl : ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_0 ) ) ;
    public final void rule__JvmWildcardTypeReference__Group_2_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15441:1: ( ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_0 ) ) )
            // InternalXbaseWithAnnotations.g:15442:1: ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_0 ) )
            {
            // InternalXbaseWithAnnotations.g:15442:1: ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_0 ) )
            // InternalXbaseWithAnnotations.g:15443:2: ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsAssignment_2_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:15444:2: ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_0 )
            // InternalXbaseWithAnnotations.g:15444:3: rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_0
            {
            pushFollow(FOLLOW_2);
            rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsAssignment_2_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group_2_0__0__Impl"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group_2_0__1"
    // InternalXbaseWithAnnotations.g:15452:1: rule__JvmWildcardTypeReference__Group_2_0__1 : rule__JvmWildcardTypeReference__Group_2_0__1__Impl ;
    public final void rule__JvmWildcardTypeReference__Group_2_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15456:1: ( rule__JvmWildcardTypeReference__Group_2_0__1__Impl )
            // InternalXbaseWithAnnotations.g:15457:2: rule__JvmWildcardTypeReference__Group_2_0__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmWildcardTypeReference__Group_2_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group_2_0__1"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group_2_0__1__Impl"
    // InternalXbaseWithAnnotations.g:15463:1: rule__JvmWildcardTypeReference__Group_2_0__1__Impl : ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_1 )* ) ;
    public final void rule__JvmWildcardTypeReference__Group_2_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15467:1: ( ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_1 )* ) )
            // InternalXbaseWithAnnotations.g:15468:1: ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_1 )* )
            {
            // InternalXbaseWithAnnotations.g:15468:1: ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_1 )* )
            // InternalXbaseWithAnnotations.g:15469:2: ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_1 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsAssignment_2_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:15470:2: ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_1 )*
            loop126:
            do {
                int alt126=2;
                int LA126_0 = input.LA(1);

                if ( (LA126_0==82) ) {
                    alt126=1;
                }


                switch (alt126) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:15470:3: rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_1
            	    {
            	    pushFollow(FOLLOW_96);
            	    rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_1();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop126;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsAssignment_2_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group_2_0__1__Impl"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group_2_1__0"
    // InternalXbaseWithAnnotations.g:15479:1: rule__JvmWildcardTypeReference__Group_2_1__0 : rule__JvmWildcardTypeReference__Group_2_1__0__Impl rule__JvmWildcardTypeReference__Group_2_1__1 ;
    public final void rule__JvmWildcardTypeReference__Group_2_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15483:1: ( rule__JvmWildcardTypeReference__Group_2_1__0__Impl rule__JvmWildcardTypeReference__Group_2_1__1 )
            // InternalXbaseWithAnnotations.g:15484:2: rule__JvmWildcardTypeReference__Group_2_1__0__Impl rule__JvmWildcardTypeReference__Group_2_1__1
            {
            pushFollow(FOLLOW_95);
            rule__JvmWildcardTypeReference__Group_2_1__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmWildcardTypeReference__Group_2_1__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group_2_1__0"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group_2_1__0__Impl"
    // InternalXbaseWithAnnotations.g:15491:1: rule__JvmWildcardTypeReference__Group_2_1__0__Impl : ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_0 ) ) ;
    public final void rule__JvmWildcardTypeReference__Group_2_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15495:1: ( ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_0 ) ) )
            // InternalXbaseWithAnnotations.g:15496:1: ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_0 ) )
            {
            // InternalXbaseWithAnnotations.g:15496:1: ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_0 ) )
            // InternalXbaseWithAnnotations.g:15497:2: ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsAssignment_2_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:15498:2: ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_0 )
            // InternalXbaseWithAnnotations.g:15498:3: rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_0
            {
            pushFollow(FOLLOW_2);
            rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsAssignment_2_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group_2_1__0__Impl"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group_2_1__1"
    // InternalXbaseWithAnnotations.g:15506:1: rule__JvmWildcardTypeReference__Group_2_1__1 : rule__JvmWildcardTypeReference__Group_2_1__1__Impl ;
    public final void rule__JvmWildcardTypeReference__Group_2_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15510:1: ( rule__JvmWildcardTypeReference__Group_2_1__1__Impl )
            // InternalXbaseWithAnnotations.g:15511:2: rule__JvmWildcardTypeReference__Group_2_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmWildcardTypeReference__Group_2_1__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group_2_1__1"


    // $ANTLR start "rule__JvmWildcardTypeReference__Group_2_1__1__Impl"
    // InternalXbaseWithAnnotations.g:15517:1: rule__JvmWildcardTypeReference__Group_2_1__1__Impl : ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_1 )* ) ;
    public final void rule__JvmWildcardTypeReference__Group_2_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15521:1: ( ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_1 )* ) )
            // InternalXbaseWithAnnotations.g:15522:1: ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_1 )* )
            {
            // InternalXbaseWithAnnotations.g:15522:1: ( ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_1 )* )
            // InternalXbaseWithAnnotations.g:15523:2: ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_1 )*
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsAssignment_2_1_1()); 
            }
            // InternalXbaseWithAnnotations.g:15524:2: ( rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_1 )*
            loop127:
            do {
                int alt127=2;
                int LA127_0 = input.LA(1);

                if ( (LA127_0==82) ) {
                    alt127=1;
                }


                switch (alt127) {
            	case 1 :
            	    // InternalXbaseWithAnnotations.g:15524:3: rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_1
            	    {
            	    pushFollow(FOLLOW_96);
            	    rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_1();

            	    state._fsp--;
            	    if (state.failed) return ;

            	    }
            	    break;

            	default :
            	    break loop127;
                }
            } while (true);

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsAssignment_2_1_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__Group_2_1__1__Impl"


    // $ANTLR start "rule__JvmUpperBound__Group__0"
    // InternalXbaseWithAnnotations.g:15533:1: rule__JvmUpperBound__Group__0 : rule__JvmUpperBound__Group__0__Impl rule__JvmUpperBound__Group__1 ;
    public final void rule__JvmUpperBound__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15537:1: ( rule__JvmUpperBound__Group__0__Impl rule__JvmUpperBound__Group__1 )
            // InternalXbaseWithAnnotations.g:15538:2: rule__JvmUpperBound__Group__0__Impl rule__JvmUpperBound__Group__1
            {
            pushFollow(FOLLOW_27);
            rule__JvmUpperBound__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmUpperBound__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmUpperBound__Group__0"


    // $ANTLR start "rule__JvmUpperBound__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:15545:1: rule__JvmUpperBound__Group__0__Impl : ( 'extends' ) ;
    public final void rule__JvmUpperBound__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15549:1: ( ( 'extends' ) )
            // InternalXbaseWithAnnotations.g:15550:1: ( 'extends' )
            {
            // InternalXbaseWithAnnotations.g:15550:1: ( 'extends' )
            // InternalXbaseWithAnnotations.g:15551:2: 'extends'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmUpperBoundAccess().getExtendsKeyword_0()); 
            }
            match(input,45,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmUpperBoundAccess().getExtendsKeyword_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmUpperBound__Group__0__Impl"


    // $ANTLR start "rule__JvmUpperBound__Group__1"
    // InternalXbaseWithAnnotations.g:15560:1: rule__JvmUpperBound__Group__1 : rule__JvmUpperBound__Group__1__Impl ;
    public final void rule__JvmUpperBound__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15564:1: ( rule__JvmUpperBound__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:15565:2: rule__JvmUpperBound__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmUpperBound__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmUpperBound__Group__1"


    // $ANTLR start "rule__JvmUpperBound__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:15571:1: rule__JvmUpperBound__Group__1__Impl : ( ( rule__JvmUpperBound__TypeReferenceAssignment_1 ) ) ;
    public final void rule__JvmUpperBound__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15575:1: ( ( ( rule__JvmUpperBound__TypeReferenceAssignment_1 ) ) )
            // InternalXbaseWithAnnotations.g:15576:1: ( ( rule__JvmUpperBound__TypeReferenceAssignment_1 ) )
            {
            // InternalXbaseWithAnnotations.g:15576:1: ( ( rule__JvmUpperBound__TypeReferenceAssignment_1 ) )
            // InternalXbaseWithAnnotations.g:15577:2: ( rule__JvmUpperBound__TypeReferenceAssignment_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmUpperBoundAccess().getTypeReferenceAssignment_1()); 
            }
            // InternalXbaseWithAnnotations.g:15578:2: ( rule__JvmUpperBound__TypeReferenceAssignment_1 )
            // InternalXbaseWithAnnotations.g:15578:3: rule__JvmUpperBound__TypeReferenceAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__JvmUpperBound__TypeReferenceAssignment_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmUpperBoundAccess().getTypeReferenceAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmUpperBound__Group__1__Impl"


    // $ANTLR start "rule__JvmUpperBoundAnded__Group__0"
    // InternalXbaseWithAnnotations.g:15587:1: rule__JvmUpperBoundAnded__Group__0 : rule__JvmUpperBoundAnded__Group__0__Impl rule__JvmUpperBoundAnded__Group__1 ;
    public final void rule__JvmUpperBoundAnded__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15591:1: ( rule__JvmUpperBoundAnded__Group__0__Impl rule__JvmUpperBoundAnded__Group__1 )
            // InternalXbaseWithAnnotations.g:15592:2: rule__JvmUpperBoundAnded__Group__0__Impl rule__JvmUpperBoundAnded__Group__1
            {
            pushFollow(FOLLOW_27);
            rule__JvmUpperBoundAnded__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmUpperBoundAnded__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmUpperBoundAnded__Group__0"


    // $ANTLR start "rule__JvmUpperBoundAnded__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:15599:1: rule__JvmUpperBoundAnded__Group__0__Impl : ( '&' ) ;
    public final void rule__JvmUpperBoundAnded__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15603:1: ( ( '&' ) )
            // InternalXbaseWithAnnotations.g:15604:1: ( '&' )
            {
            // InternalXbaseWithAnnotations.g:15604:1: ( '&' )
            // InternalXbaseWithAnnotations.g:15605:2: '&'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmUpperBoundAndedAccess().getAmpersandKeyword_0()); 
            }
            match(input,82,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmUpperBoundAndedAccess().getAmpersandKeyword_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmUpperBoundAnded__Group__0__Impl"


    // $ANTLR start "rule__JvmUpperBoundAnded__Group__1"
    // InternalXbaseWithAnnotations.g:15614:1: rule__JvmUpperBoundAnded__Group__1 : rule__JvmUpperBoundAnded__Group__1__Impl ;
    public final void rule__JvmUpperBoundAnded__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15618:1: ( rule__JvmUpperBoundAnded__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:15619:2: rule__JvmUpperBoundAnded__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmUpperBoundAnded__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmUpperBoundAnded__Group__1"


    // $ANTLR start "rule__JvmUpperBoundAnded__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:15625:1: rule__JvmUpperBoundAnded__Group__1__Impl : ( ( rule__JvmUpperBoundAnded__TypeReferenceAssignment_1 ) ) ;
    public final void rule__JvmUpperBoundAnded__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15629:1: ( ( ( rule__JvmUpperBoundAnded__TypeReferenceAssignment_1 ) ) )
            // InternalXbaseWithAnnotations.g:15630:1: ( ( rule__JvmUpperBoundAnded__TypeReferenceAssignment_1 ) )
            {
            // InternalXbaseWithAnnotations.g:15630:1: ( ( rule__JvmUpperBoundAnded__TypeReferenceAssignment_1 ) )
            // InternalXbaseWithAnnotations.g:15631:2: ( rule__JvmUpperBoundAnded__TypeReferenceAssignment_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmUpperBoundAndedAccess().getTypeReferenceAssignment_1()); 
            }
            // InternalXbaseWithAnnotations.g:15632:2: ( rule__JvmUpperBoundAnded__TypeReferenceAssignment_1 )
            // InternalXbaseWithAnnotations.g:15632:3: rule__JvmUpperBoundAnded__TypeReferenceAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__JvmUpperBoundAnded__TypeReferenceAssignment_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmUpperBoundAndedAccess().getTypeReferenceAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmUpperBoundAnded__Group__1__Impl"


    // $ANTLR start "rule__JvmLowerBound__Group__0"
    // InternalXbaseWithAnnotations.g:15641:1: rule__JvmLowerBound__Group__0 : rule__JvmLowerBound__Group__0__Impl rule__JvmLowerBound__Group__1 ;
    public final void rule__JvmLowerBound__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15645:1: ( rule__JvmLowerBound__Group__0__Impl rule__JvmLowerBound__Group__1 )
            // InternalXbaseWithAnnotations.g:15646:2: rule__JvmLowerBound__Group__0__Impl rule__JvmLowerBound__Group__1
            {
            pushFollow(FOLLOW_27);
            rule__JvmLowerBound__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmLowerBound__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmLowerBound__Group__0"


    // $ANTLR start "rule__JvmLowerBound__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:15653:1: rule__JvmLowerBound__Group__0__Impl : ( 'super' ) ;
    public final void rule__JvmLowerBound__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15657:1: ( ( 'super' ) )
            // InternalXbaseWithAnnotations.g:15658:1: ( 'super' )
            {
            // InternalXbaseWithAnnotations.g:15658:1: ( 'super' )
            // InternalXbaseWithAnnotations.g:15659:2: 'super'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmLowerBoundAccess().getSuperKeyword_0()); 
            }
            match(input,49,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmLowerBoundAccess().getSuperKeyword_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmLowerBound__Group__0__Impl"


    // $ANTLR start "rule__JvmLowerBound__Group__1"
    // InternalXbaseWithAnnotations.g:15668:1: rule__JvmLowerBound__Group__1 : rule__JvmLowerBound__Group__1__Impl ;
    public final void rule__JvmLowerBound__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15672:1: ( rule__JvmLowerBound__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:15673:2: rule__JvmLowerBound__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmLowerBound__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmLowerBound__Group__1"


    // $ANTLR start "rule__JvmLowerBound__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:15679:1: rule__JvmLowerBound__Group__1__Impl : ( ( rule__JvmLowerBound__TypeReferenceAssignment_1 ) ) ;
    public final void rule__JvmLowerBound__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15683:1: ( ( ( rule__JvmLowerBound__TypeReferenceAssignment_1 ) ) )
            // InternalXbaseWithAnnotations.g:15684:1: ( ( rule__JvmLowerBound__TypeReferenceAssignment_1 ) )
            {
            // InternalXbaseWithAnnotations.g:15684:1: ( ( rule__JvmLowerBound__TypeReferenceAssignment_1 ) )
            // InternalXbaseWithAnnotations.g:15685:2: ( rule__JvmLowerBound__TypeReferenceAssignment_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmLowerBoundAccess().getTypeReferenceAssignment_1()); 
            }
            // InternalXbaseWithAnnotations.g:15686:2: ( rule__JvmLowerBound__TypeReferenceAssignment_1 )
            // InternalXbaseWithAnnotations.g:15686:3: rule__JvmLowerBound__TypeReferenceAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__JvmLowerBound__TypeReferenceAssignment_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmLowerBoundAccess().getTypeReferenceAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmLowerBound__Group__1__Impl"


    // $ANTLR start "rule__JvmLowerBoundAnded__Group__0"
    // InternalXbaseWithAnnotations.g:15695:1: rule__JvmLowerBoundAnded__Group__0 : rule__JvmLowerBoundAnded__Group__0__Impl rule__JvmLowerBoundAnded__Group__1 ;
    public final void rule__JvmLowerBoundAnded__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15699:1: ( rule__JvmLowerBoundAnded__Group__0__Impl rule__JvmLowerBoundAnded__Group__1 )
            // InternalXbaseWithAnnotations.g:15700:2: rule__JvmLowerBoundAnded__Group__0__Impl rule__JvmLowerBoundAnded__Group__1
            {
            pushFollow(FOLLOW_27);
            rule__JvmLowerBoundAnded__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__JvmLowerBoundAnded__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmLowerBoundAnded__Group__0"


    // $ANTLR start "rule__JvmLowerBoundAnded__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:15707:1: rule__JvmLowerBoundAnded__Group__0__Impl : ( '&' ) ;
    public final void rule__JvmLowerBoundAnded__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15711:1: ( ( '&' ) )
            // InternalXbaseWithAnnotations.g:15712:1: ( '&' )
            {
            // InternalXbaseWithAnnotations.g:15712:1: ( '&' )
            // InternalXbaseWithAnnotations.g:15713:2: '&'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmLowerBoundAndedAccess().getAmpersandKeyword_0()); 
            }
            match(input,82,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmLowerBoundAndedAccess().getAmpersandKeyword_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmLowerBoundAnded__Group__0__Impl"


    // $ANTLR start "rule__JvmLowerBoundAnded__Group__1"
    // InternalXbaseWithAnnotations.g:15722:1: rule__JvmLowerBoundAnded__Group__1 : rule__JvmLowerBoundAnded__Group__1__Impl ;
    public final void rule__JvmLowerBoundAnded__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15726:1: ( rule__JvmLowerBoundAnded__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:15727:2: rule__JvmLowerBoundAnded__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__JvmLowerBoundAnded__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmLowerBoundAnded__Group__1"


    // $ANTLR start "rule__JvmLowerBoundAnded__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:15733:1: rule__JvmLowerBoundAnded__Group__1__Impl : ( ( rule__JvmLowerBoundAnded__TypeReferenceAssignment_1 ) ) ;
    public final void rule__JvmLowerBoundAnded__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15737:1: ( ( ( rule__JvmLowerBoundAnded__TypeReferenceAssignment_1 ) ) )
            // InternalXbaseWithAnnotations.g:15738:1: ( ( rule__JvmLowerBoundAnded__TypeReferenceAssignment_1 ) )
            {
            // InternalXbaseWithAnnotations.g:15738:1: ( ( rule__JvmLowerBoundAnded__TypeReferenceAssignment_1 ) )
            // InternalXbaseWithAnnotations.g:15739:2: ( rule__JvmLowerBoundAnded__TypeReferenceAssignment_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmLowerBoundAndedAccess().getTypeReferenceAssignment_1()); 
            }
            // InternalXbaseWithAnnotations.g:15740:2: ( rule__JvmLowerBoundAnded__TypeReferenceAssignment_1 )
            // InternalXbaseWithAnnotations.g:15740:3: rule__JvmLowerBoundAnded__TypeReferenceAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__JvmLowerBoundAnded__TypeReferenceAssignment_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmLowerBoundAndedAccess().getTypeReferenceAssignment_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmLowerBoundAnded__Group__1__Impl"


    // $ANTLR start "rule__QualifiedNameWithWildcard__Group__0"
    // InternalXbaseWithAnnotations.g:15749:1: rule__QualifiedNameWithWildcard__Group__0 : rule__QualifiedNameWithWildcard__Group__0__Impl rule__QualifiedNameWithWildcard__Group__1 ;
    public final void rule__QualifiedNameWithWildcard__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15753:1: ( rule__QualifiedNameWithWildcard__Group__0__Impl rule__QualifiedNameWithWildcard__Group__1 )
            // InternalXbaseWithAnnotations.g:15754:2: rule__QualifiedNameWithWildcard__Group__0__Impl rule__QualifiedNameWithWildcard__Group__1
            {
            pushFollow(FOLLOW_90);
            rule__QualifiedNameWithWildcard__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__QualifiedNameWithWildcard__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameWithWildcard__Group__0"


    // $ANTLR start "rule__QualifiedNameWithWildcard__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:15761:1: rule__QualifiedNameWithWildcard__Group__0__Impl : ( ruleQualifiedName ) ;
    public final void rule__QualifiedNameWithWildcard__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15765:1: ( ( ruleQualifiedName ) )
            // InternalXbaseWithAnnotations.g:15766:1: ( ruleQualifiedName )
            {
            // InternalXbaseWithAnnotations.g:15766:1: ( ruleQualifiedName )
            // InternalXbaseWithAnnotations.g:15767:2: ruleQualifiedName
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameWithWildcardAccess().getQualifiedNameParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleQualifiedName();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameWithWildcardAccess().getQualifiedNameParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameWithWildcard__Group__0__Impl"


    // $ANTLR start "rule__QualifiedNameWithWildcard__Group__1"
    // InternalXbaseWithAnnotations.g:15776:1: rule__QualifiedNameWithWildcard__Group__1 : rule__QualifiedNameWithWildcard__Group__1__Impl rule__QualifiedNameWithWildcard__Group__2 ;
    public final void rule__QualifiedNameWithWildcard__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15780:1: ( rule__QualifiedNameWithWildcard__Group__1__Impl rule__QualifiedNameWithWildcard__Group__2 )
            // InternalXbaseWithAnnotations.g:15781:2: rule__QualifiedNameWithWildcard__Group__1__Impl rule__QualifiedNameWithWildcard__Group__2
            {
            pushFollow(FOLLOW_97);
            rule__QualifiedNameWithWildcard__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__QualifiedNameWithWildcard__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameWithWildcard__Group__1"


    // $ANTLR start "rule__QualifiedNameWithWildcard__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:15788:1: rule__QualifiedNameWithWildcard__Group__1__Impl : ( '.' ) ;
    public final void rule__QualifiedNameWithWildcard__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15792:1: ( ( '.' ) )
            // InternalXbaseWithAnnotations.g:15793:1: ( '.' )
            {
            // InternalXbaseWithAnnotations.g:15793:1: ( '.' )
            // InternalXbaseWithAnnotations.g:15794:2: '.'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameWithWildcardAccess().getFullStopKeyword_1()); 
            }
            match(input,43,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameWithWildcardAccess().getFullStopKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameWithWildcard__Group__1__Impl"


    // $ANTLR start "rule__QualifiedNameWithWildcard__Group__2"
    // InternalXbaseWithAnnotations.g:15803:1: rule__QualifiedNameWithWildcard__Group__2 : rule__QualifiedNameWithWildcard__Group__2__Impl ;
    public final void rule__QualifiedNameWithWildcard__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15807:1: ( rule__QualifiedNameWithWildcard__Group__2__Impl )
            // InternalXbaseWithAnnotations.g:15808:2: rule__QualifiedNameWithWildcard__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedNameWithWildcard__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameWithWildcard__Group__2"


    // $ANTLR start "rule__QualifiedNameWithWildcard__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:15814:1: rule__QualifiedNameWithWildcard__Group__2__Impl : ( '*' ) ;
    public final void rule__QualifiedNameWithWildcard__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15818:1: ( ( '*' ) )
            // InternalXbaseWithAnnotations.g:15819:1: ( '*' )
            {
            // InternalXbaseWithAnnotations.g:15819:1: ( '*' )
            // InternalXbaseWithAnnotations.g:15820:2: '*'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameWithWildcardAccess().getAsteriskKeyword_2()); 
            }
            match(input,36,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameWithWildcardAccess().getAsteriskKeyword_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameWithWildcard__Group__2__Impl"


    // $ANTLR start "rule__XImportDeclaration__Group__0"
    // InternalXbaseWithAnnotations.g:15830:1: rule__XImportDeclaration__Group__0 : rule__XImportDeclaration__Group__0__Impl rule__XImportDeclaration__Group__1 ;
    public final void rule__XImportDeclaration__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15834:1: ( rule__XImportDeclaration__Group__0__Impl rule__XImportDeclaration__Group__1 )
            // InternalXbaseWithAnnotations.g:15835:2: rule__XImportDeclaration__Group__0__Impl rule__XImportDeclaration__Group__1
            {
            pushFollow(FOLLOW_98);
            rule__XImportDeclaration__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XImportDeclaration__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group__0"


    // $ANTLR start "rule__XImportDeclaration__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:15842:1: rule__XImportDeclaration__Group__0__Impl : ( 'import' ) ;
    public final void rule__XImportDeclaration__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15846:1: ( ( 'import' ) )
            // InternalXbaseWithAnnotations.g:15847:1: ( 'import' )
            {
            // InternalXbaseWithAnnotations.g:15847:1: ( 'import' )
            // InternalXbaseWithAnnotations.g:15848:2: 'import'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getImportKeyword_0()); 
            }
            match(input,47,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getImportKeyword_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group__0__Impl"


    // $ANTLR start "rule__XImportDeclaration__Group__1"
    // InternalXbaseWithAnnotations.g:15857:1: rule__XImportDeclaration__Group__1 : rule__XImportDeclaration__Group__1__Impl rule__XImportDeclaration__Group__2 ;
    public final void rule__XImportDeclaration__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15861:1: ( rule__XImportDeclaration__Group__1__Impl rule__XImportDeclaration__Group__2 )
            // InternalXbaseWithAnnotations.g:15862:2: rule__XImportDeclaration__Group__1__Impl rule__XImportDeclaration__Group__2
            {
            pushFollow(FOLLOW_56);
            rule__XImportDeclaration__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XImportDeclaration__Group__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group__1"


    // $ANTLR start "rule__XImportDeclaration__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:15869:1: rule__XImportDeclaration__Group__1__Impl : ( ( rule__XImportDeclaration__Alternatives_1 ) ) ;
    public final void rule__XImportDeclaration__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15873:1: ( ( ( rule__XImportDeclaration__Alternatives_1 ) ) )
            // InternalXbaseWithAnnotations.g:15874:1: ( ( rule__XImportDeclaration__Alternatives_1 ) )
            {
            // InternalXbaseWithAnnotations.g:15874:1: ( ( rule__XImportDeclaration__Alternatives_1 ) )
            // InternalXbaseWithAnnotations.g:15875:2: ( rule__XImportDeclaration__Alternatives_1 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getAlternatives_1()); 
            }
            // InternalXbaseWithAnnotations.g:15876:2: ( rule__XImportDeclaration__Alternatives_1 )
            // InternalXbaseWithAnnotations.g:15876:3: rule__XImportDeclaration__Alternatives_1
            {
            pushFollow(FOLLOW_2);
            rule__XImportDeclaration__Alternatives_1();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getAlternatives_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group__1__Impl"


    // $ANTLR start "rule__XImportDeclaration__Group__2"
    // InternalXbaseWithAnnotations.g:15884:1: rule__XImportDeclaration__Group__2 : rule__XImportDeclaration__Group__2__Impl ;
    public final void rule__XImportDeclaration__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15888:1: ( rule__XImportDeclaration__Group__2__Impl )
            // InternalXbaseWithAnnotations.g:15889:2: rule__XImportDeclaration__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XImportDeclaration__Group__2__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group__2"


    // $ANTLR start "rule__XImportDeclaration__Group__2__Impl"
    // InternalXbaseWithAnnotations.g:15895:1: rule__XImportDeclaration__Group__2__Impl : ( ( ';' )? ) ;
    public final void rule__XImportDeclaration__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15899:1: ( ( ( ';' )? ) )
            // InternalXbaseWithAnnotations.g:15900:1: ( ( ';' )? )
            {
            // InternalXbaseWithAnnotations.g:15900:1: ( ( ';' )? )
            // InternalXbaseWithAnnotations.g:15901:2: ( ';' )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getSemicolonKeyword_2()); 
            }
            // InternalXbaseWithAnnotations.g:15902:2: ( ';' )?
            int alt128=2;
            int LA128_0 = input.LA(1);

            if ( (LA128_0==62) ) {
                alt128=1;
            }
            switch (alt128) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:15902:3: ';'
                    {
                    match(input,62,FOLLOW_2); if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getSemicolonKeyword_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group__2__Impl"


    // $ANTLR start "rule__XImportDeclaration__Group_1_0__0"
    // InternalXbaseWithAnnotations.g:15911:1: rule__XImportDeclaration__Group_1_0__0 : rule__XImportDeclaration__Group_1_0__0__Impl rule__XImportDeclaration__Group_1_0__1 ;
    public final void rule__XImportDeclaration__Group_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15915:1: ( rule__XImportDeclaration__Group_1_0__0__Impl rule__XImportDeclaration__Group_1_0__1 )
            // InternalXbaseWithAnnotations.g:15916:2: rule__XImportDeclaration__Group_1_0__0__Impl rule__XImportDeclaration__Group_1_0__1
            {
            pushFollow(FOLLOW_99);
            rule__XImportDeclaration__Group_1_0__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XImportDeclaration__Group_1_0__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group_1_0__0"


    // $ANTLR start "rule__XImportDeclaration__Group_1_0__0__Impl"
    // InternalXbaseWithAnnotations.g:15923:1: rule__XImportDeclaration__Group_1_0__0__Impl : ( ( rule__XImportDeclaration__StaticAssignment_1_0_0 ) ) ;
    public final void rule__XImportDeclaration__Group_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15927:1: ( ( ( rule__XImportDeclaration__StaticAssignment_1_0_0 ) ) )
            // InternalXbaseWithAnnotations.g:15928:1: ( ( rule__XImportDeclaration__StaticAssignment_1_0_0 ) )
            {
            // InternalXbaseWithAnnotations.g:15928:1: ( ( rule__XImportDeclaration__StaticAssignment_1_0_0 ) )
            // InternalXbaseWithAnnotations.g:15929:2: ( rule__XImportDeclaration__StaticAssignment_1_0_0 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getStaticAssignment_1_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:15930:2: ( rule__XImportDeclaration__StaticAssignment_1_0_0 )
            // InternalXbaseWithAnnotations.g:15930:3: rule__XImportDeclaration__StaticAssignment_1_0_0
            {
            pushFollow(FOLLOW_2);
            rule__XImportDeclaration__StaticAssignment_1_0_0();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getStaticAssignment_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group_1_0__0__Impl"


    // $ANTLR start "rule__XImportDeclaration__Group_1_0__1"
    // InternalXbaseWithAnnotations.g:15938:1: rule__XImportDeclaration__Group_1_0__1 : rule__XImportDeclaration__Group_1_0__1__Impl rule__XImportDeclaration__Group_1_0__2 ;
    public final void rule__XImportDeclaration__Group_1_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15942:1: ( rule__XImportDeclaration__Group_1_0__1__Impl rule__XImportDeclaration__Group_1_0__2 )
            // InternalXbaseWithAnnotations.g:15943:2: rule__XImportDeclaration__Group_1_0__1__Impl rule__XImportDeclaration__Group_1_0__2
            {
            pushFollow(FOLLOW_99);
            rule__XImportDeclaration__Group_1_0__1__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XImportDeclaration__Group_1_0__2();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group_1_0__1"


    // $ANTLR start "rule__XImportDeclaration__Group_1_0__1__Impl"
    // InternalXbaseWithAnnotations.g:15950:1: rule__XImportDeclaration__Group_1_0__1__Impl : ( ( rule__XImportDeclaration__ExtensionAssignment_1_0_1 )? ) ;
    public final void rule__XImportDeclaration__Group_1_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15954:1: ( ( ( rule__XImportDeclaration__ExtensionAssignment_1_0_1 )? ) )
            // InternalXbaseWithAnnotations.g:15955:1: ( ( rule__XImportDeclaration__ExtensionAssignment_1_0_1 )? )
            {
            // InternalXbaseWithAnnotations.g:15955:1: ( ( rule__XImportDeclaration__ExtensionAssignment_1_0_1 )? )
            // InternalXbaseWithAnnotations.g:15956:2: ( rule__XImportDeclaration__ExtensionAssignment_1_0_1 )?
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getExtensionAssignment_1_0_1()); 
            }
            // InternalXbaseWithAnnotations.g:15957:2: ( rule__XImportDeclaration__ExtensionAssignment_1_0_1 )?
            int alt129=2;
            int LA129_0 = input.LA(1);

            if ( (LA129_0==48) ) {
                alt129=1;
            }
            switch (alt129) {
                case 1 :
                    // InternalXbaseWithAnnotations.g:15957:3: rule__XImportDeclaration__ExtensionAssignment_1_0_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__XImportDeclaration__ExtensionAssignment_1_0_1();

                    state._fsp--;
                    if (state.failed) return ;

                    }
                    break;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getExtensionAssignment_1_0_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group_1_0__1__Impl"


    // $ANTLR start "rule__XImportDeclaration__Group_1_0__2"
    // InternalXbaseWithAnnotations.g:15965:1: rule__XImportDeclaration__Group_1_0__2 : rule__XImportDeclaration__Group_1_0__2__Impl rule__XImportDeclaration__Group_1_0__3 ;
    public final void rule__XImportDeclaration__Group_1_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15969:1: ( rule__XImportDeclaration__Group_1_0__2__Impl rule__XImportDeclaration__Group_1_0__3 )
            // InternalXbaseWithAnnotations.g:15970:2: rule__XImportDeclaration__Group_1_0__2__Impl rule__XImportDeclaration__Group_1_0__3
            {
            pushFollow(FOLLOW_100);
            rule__XImportDeclaration__Group_1_0__2__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__XImportDeclaration__Group_1_0__3();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group_1_0__2"


    // $ANTLR start "rule__XImportDeclaration__Group_1_0__2__Impl"
    // InternalXbaseWithAnnotations.g:15977:1: rule__XImportDeclaration__Group_1_0__2__Impl : ( ( rule__XImportDeclaration__ImportedTypeAssignment_1_0_2 ) ) ;
    public final void rule__XImportDeclaration__Group_1_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15981:1: ( ( ( rule__XImportDeclaration__ImportedTypeAssignment_1_0_2 ) ) )
            // InternalXbaseWithAnnotations.g:15982:1: ( ( rule__XImportDeclaration__ImportedTypeAssignment_1_0_2 ) )
            {
            // InternalXbaseWithAnnotations.g:15982:1: ( ( rule__XImportDeclaration__ImportedTypeAssignment_1_0_2 ) )
            // InternalXbaseWithAnnotations.g:15983:2: ( rule__XImportDeclaration__ImportedTypeAssignment_1_0_2 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getImportedTypeAssignment_1_0_2()); 
            }
            // InternalXbaseWithAnnotations.g:15984:2: ( rule__XImportDeclaration__ImportedTypeAssignment_1_0_2 )
            // InternalXbaseWithAnnotations.g:15984:3: rule__XImportDeclaration__ImportedTypeAssignment_1_0_2
            {
            pushFollow(FOLLOW_2);
            rule__XImportDeclaration__ImportedTypeAssignment_1_0_2();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getImportedTypeAssignment_1_0_2()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group_1_0__2__Impl"


    // $ANTLR start "rule__XImportDeclaration__Group_1_0__3"
    // InternalXbaseWithAnnotations.g:15992:1: rule__XImportDeclaration__Group_1_0__3 : rule__XImportDeclaration__Group_1_0__3__Impl ;
    public final void rule__XImportDeclaration__Group_1_0__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:15996:1: ( rule__XImportDeclaration__Group_1_0__3__Impl )
            // InternalXbaseWithAnnotations.g:15997:2: rule__XImportDeclaration__Group_1_0__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__XImportDeclaration__Group_1_0__3__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group_1_0__3"


    // $ANTLR start "rule__XImportDeclaration__Group_1_0__3__Impl"
    // InternalXbaseWithAnnotations.g:16003:1: rule__XImportDeclaration__Group_1_0__3__Impl : ( ( rule__XImportDeclaration__Alternatives_1_0_3 ) ) ;
    public final void rule__XImportDeclaration__Group_1_0__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16007:1: ( ( ( rule__XImportDeclaration__Alternatives_1_0_3 ) ) )
            // InternalXbaseWithAnnotations.g:16008:1: ( ( rule__XImportDeclaration__Alternatives_1_0_3 ) )
            {
            // InternalXbaseWithAnnotations.g:16008:1: ( ( rule__XImportDeclaration__Alternatives_1_0_3 ) )
            // InternalXbaseWithAnnotations.g:16009:2: ( rule__XImportDeclaration__Alternatives_1_0_3 )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getAlternatives_1_0_3()); 
            }
            // InternalXbaseWithAnnotations.g:16010:2: ( rule__XImportDeclaration__Alternatives_1_0_3 )
            // InternalXbaseWithAnnotations.g:16010:3: rule__XImportDeclaration__Alternatives_1_0_3
            {
            pushFollow(FOLLOW_2);
            rule__XImportDeclaration__Alternatives_1_0_3();

            state._fsp--;
            if (state.failed) return ;

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getAlternatives_1_0_3()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__Group_1_0__3__Impl"


    // $ANTLR start "rule__QualifiedNameInStaticImport__Group__0"
    // InternalXbaseWithAnnotations.g:16019:1: rule__QualifiedNameInStaticImport__Group__0 : rule__QualifiedNameInStaticImport__Group__0__Impl rule__QualifiedNameInStaticImport__Group__1 ;
    public final void rule__QualifiedNameInStaticImport__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16023:1: ( rule__QualifiedNameInStaticImport__Group__0__Impl rule__QualifiedNameInStaticImport__Group__1 )
            // InternalXbaseWithAnnotations.g:16024:2: rule__QualifiedNameInStaticImport__Group__0__Impl rule__QualifiedNameInStaticImport__Group__1
            {
            pushFollow(FOLLOW_90);
            rule__QualifiedNameInStaticImport__Group__0__Impl();

            state._fsp--;
            if (state.failed) return ;
            pushFollow(FOLLOW_2);
            rule__QualifiedNameInStaticImport__Group__1();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameInStaticImport__Group__0"


    // $ANTLR start "rule__QualifiedNameInStaticImport__Group__0__Impl"
    // InternalXbaseWithAnnotations.g:16031:1: rule__QualifiedNameInStaticImport__Group__0__Impl : ( ruleValidID ) ;
    public final void rule__QualifiedNameInStaticImport__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16035:1: ( ( ruleValidID ) )
            // InternalXbaseWithAnnotations.g:16036:1: ( ruleValidID )
            {
            // InternalXbaseWithAnnotations.g:16036:1: ( ruleValidID )
            // InternalXbaseWithAnnotations.g:16037:2: ruleValidID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameInStaticImportAccess().getValidIDParserRuleCall_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleValidID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameInStaticImportAccess().getValidIDParserRuleCall_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameInStaticImport__Group__0__Impl"


    // $ANTLR start "rule__QualifiedNameInStaticImport__Group__1"
    // InternalXbaseWithAnnotations.g:16046:1: rule__QualifiedNameInStaticImport__Group__1 : rule__QualifiedNameInStaticImport__Group__1__Impl ;
    public final void rule__QualifiedNameInStaticImport__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16050:1: ( rule__QualifiedNameInStaticImport__Group__1__Impl )
            // InternalXbaseWithAnnotations.g:16051:2: rule__QualifiedNameInStaticImport__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__QualifiedNameInStaticImport__Group__1__Impl();

            state._fsp--;
            if (state.failed) return ;

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameInStaticImport__Group__1"


    // $ANTLR start "rule__QualifiedNameInStaticImport__Group__1__Impl"
    // InternalXbaseWithAnnotations.g:16057:1: rule__QualifiedNameInStaticImport__Group__1__Impl : ( '.' ) ;
    public final void rule__QualifiedNameInStaticImport__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16061:1: ( ( '.' ) )
            // InternalXbaseWithAnnotations.g:16062:1: ( '.' )
            {
            // InternalXbaseWithAnnotations.g:16062:1: ( '.' )
            // InternalXbaseWithAnnotations.g:16063:2: '.'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getQualifiedNameInStaticImportAccess().getFullStopKeyword_1()); 
            }
            match(input,43,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getQualifiedNameInStaticImportAccess().getFullStopKeyword_1()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__QualifiedNameInStaticImport__Group__1__Impl"


    // $ANTLR start "rule__XAnnotation__AnnotationTypeAssignment_2"
    // InternalXbaseWithAnnotations.g:16073:1: rule__XAnnotation__AnnotationTypeAssignment_2 : ( ( ruleQualifiedName ) ) ;
    public final void rule__XAnnotation__AnnotationTypeAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16077:1: ( ( ( ruleQualifiedName ) ) )
            // InternalXbaseWithAnnotations.g:16078:2: ( ( ruleQualifiedName ) )
            {
            // InternalXbaseWithAnnotations.g:16078:2: ( ( ruleQualifiedName ) )
            // InternalXbaseWithAnnotations.g:16079:3: ( ruleQualifiedName )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationAccess().getAnnotationTypeJvmAnnotationTypeCrossReference_2_0()); 
            }
            // InternalXbaseWithAnnotations.g:16080:3: ( ruleQualifiedName )
            // InternalXbaseWithAnnotations.g:16081:4: ruleQualifiedName
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationAccess().getAnnotationTypeJvmAnnotationTypeQualifiedNameParserRuleCall_2_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleQualifiedName();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationAccess().getAnnotationTypeJvmAnnotationTypeQualifiedNameParserRuleCall_2_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationAccess().getAnnotationTypeJvmAnnotationTypeCrossReference_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__AnnotationTypeAssignment_2"


    // $ANTLR start "rule__XAnnotation__ElementValuePairsAssignment_3_1_0_0"
    // InternalXbaseWithAnnotations.g:16092:1: rule__XAnnotation__ElementValuePairsAssignment_3_1_0_0 : ( ruleXAnnotationElementValuePair ) ;
    public final void rule__XAnnotation__ElementValuePairsAssignment_3_1_0_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16096:1: ( ( ruleXAnnotationElementValuePair ) )
            // InternalXbaseWithAnnotations.g:16097:2: ( ruleXAnnotationElementValuePair )
            {
            // InternalXbaseWithAnnotations.g:16097:2: ( ruleXAnnotationElementValuePair )
            // InternalXbaseWithAnnotations.g:16098:3: ruleXAnnotationElementValuePair
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationAccess().getElementValuePairsXAnnotationElementValuePairParserRuleCall_3_1_0_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAnnotationElementValuePair();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationAccess().getElementValuePairsXAnnotationElementValuePairParserRuleCall_3_1_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__ElementValuePairsAssignment_3_1_0_0"


    // $ANTLR start "rule__XAnnotation__ElementValuePairsAssignment_3_1_0_1_1"
    // InternalXbaseWithAnnotations.g:16107:1: rule__XAnnotation__ElementValuePairsAssignment_3_1_0_1_1 : ( ruleXAnnotationElementValuePair ) ;
    public final void rule__XAnnotation__ElementValuePairsAssignment_3_1_0_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16111:1: ( ( ruleXAnnotationElementValuePair ) )
            // InternalXbaseWithAnnotations.g:16112:2: ( ruleXAnnotationElementValuePair )
            {
            // InternalXbaseWithAnnotations.g:16112:2: ( ruleXAnnotationElementValuePair )
            // InternalXbaseWithAnnotations.g:16113:3: ruleXAnnotationElementValuePair
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationAccess().getElementValuePairsXAnnotationElementValuePairParserRuleCall_3_1_0_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAnnotationElementValuePair();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationAccess().getElementValuePairsXAnnotationElementValuePairParserRuleCall_3_1_0_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__ElementValuePairsAssignment_3_1_0_1_1"


    // $ANTLR start "rule__XAnnotation__ValueAssignment_3_1_1"
    // InternalXbaseWithAnnotations.g:16122:1: rule__XAnnotation__ValueAssignment_3_1_1 : ( ruleXAnnotationElementValueOrCommaList ) ;
    public final void rule__XAnnotation__ValueAssignment_3_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16126:1: ( ( ruleXAnnotationElementValueOrCommaList ) )
            // InternalXbaseWithAnnotations.g:16127:2: ( ruleXAnnotationElementValueOrCommaList )
            {
            // InternalXbaseWithAnnotations.g:16127:2: ( ruleXAnnotationElementValueOrCommaList )
            // InternalXbaseWithAnnotations.g:16128:3: ruleXAnnotationElementValueOrCommaList
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationAccess().getValueXAnnotationElementValueOrCommaListParserRuleCall_3_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAnnotationElementValueOrCommaList();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationAccess().getValueXAnnotationElementValueOrCommaListParserRuleCall_3_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotation__ValueAssignment_3_1_1"


    // $ANTLR start "rule__XAnnotationElementValuePair__ElementAssignment_0_0_0"
    // InternalXbaseWithAnnotations.g:16137:1: rule__XAnnotationElementValuePair__ElementAssignment_0_0_0 : ( ( ruleValidID ) ) ;
    public final void rule__XAnnotationElementValuePair__ElementAssignment_0_0_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16141:1: ( ( ( ruleValidID ) ) )
            // InternalXbaseWithAnnotations.g:16142:2: ( ( ruleValidID ) )
            {
            // InternalXbaseWithAnnotations.g:16142:2: ( ( ruleValidID ) )
            // InternalXbaseWithAnnotations.g:16143:3: ( ruleValidID )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValuePairAccess().getElementJvmOperationCrossReference_0_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:16144:3: ( ruleValidID )
            // InternalXbaseWithAnnotations.g:16145:4: ruleValidID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValuePairAccess().getElementJvmOperationValidIDParserRuleCall_0_0_0_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleValidID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValuePairAccess().getElementJvmOperationValidIDParserRuleCall_0_0_0_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValuePairAccess().getElementJvmOperationCrossReference_0_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValuePair__ElementAssignment_0_0_0"


    // $ANTLR start "rule__XAnnotationElementValuePair__ValueAssignment_1"
    // InternalXbaseWithAnnotations.g:16156:1: rule__XAnnotationElementValuePair__ValueAssignment_1 : ( ruleXAnnotationElementValue ) ;
    public final void rule__XAnnotationElementValuePair__ValueAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16160:1: ( ( ruleXAnnotationElementValue ) )
            // InternalXbaseWithAnnotations.g:16161:2: ( ruleXAnnotationElementValue )
            {
            // InternalXbaseWithAnnotations.g:16161:2: ( ruleXAnnotationElementValue )
            // InternalXbaseWithAnnotations.g:16162:3: ruleXAnnotationElementValue
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValuePairAccess().getValueXAnnotationElementValueParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAnnotationElementValue();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValuePairAccess().getValueXAnnotationElementValueParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValuePair__ValueAssignment_1"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__ElementsAssignment_0_1_0"
    // InternalXbaseWithAnnotations.g:16171:1: rule__XAnnotationElementValueOrCommaList__ElementsAssignment_0_1_0 : ( ruleXAnnotationOrExpression ) ;
    public final void rule__XAnnotationElementValueOrCommaList__ElementsAssignment_0_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16175:1: ( ( ruleXAnnotationOrExpression ) )
            // InternalXbaseWithAnnotations.g:16176:2: ( ruleXAnnotationOrExpression )
            {
            // InternalXbaseWithAnnotations.g:16176:2: ( ruleXAnnotationOrExpression )
            // InternalXbaseWithAnnotations.g:16177:3: ruleXAnnotationOrExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getElementsXAnnotationOrExpressionParserRuleCall_0_1_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAnnotationOrExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getElementsXAnnotationOrExpressionParserRuleCall_0_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__ElementsAssignment_0_1_0"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__ElementsAssignment_0_1_1_1"
    // InternalXbaseWithAnnotations.g:16186:1: rule__XAnnotationElementValueOrCommaList__ElementsAssignment_0_1_1_1 : ( ruleXAnnotationOrExpression ) ;
    public final void rule__XAnnotationElementValueOrCommaList__ElementsAssignment_0_1_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16190:1: ( ( ruleXAnnotationOrExpression ) )
            // InternalXbaseWithAnnotations.g:16191:2: ( ruleXAnnotationOrExpression )
            {
            // InternalXbaseWithAnnotations.g:16191:2: ( ruleXAnnotationOrExpression )
            // InternalXbaseWithAnnotations.g:16192:3: ruleXAnnotationOrExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getElementsXAnnotationOrExpressionParserRuleCall_0_1_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAnnotationOrExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getElementsXAnnotationOrExpressionParserRuleCall_0_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__ElementsAssignment_0_1_1_1"


    // $ANTLR start "rule__XAnnotationElementValueOrCommaList__ElementsAssignment_1_1_1_1"
    // InternalXbaseWithAnnotations.g:16201:1: rule__XAnnotationElementValueOrCommaList__ElementsAssignment_1_1_1_1 : ( ruleXAnnotationOrExpression ) ;
    public final void rule__XAnnotationElementValueOrCommaList__ElementsAssignment_1_1_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16205:1: ( ( ruleXAnnotationOrExpression ) )
            // InternalXbaseWithAnnotations.g:16206:2: ( ruleXAnnotationOrExpression )
            {
            // InternalXbaseWithAnnotations.g:16206:2: ( ruleXAnnotationOrExpression )
            // InternalXbaseWithAnnotations.g:16207:3: ruleXAnnotationOrExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getElementsXAnnotationOrExpressionParserRuleCall_1_1_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAnnotationOrExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getElementsXAnnotationOrExpressionParserRuleCall_1_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValueOrCommaList__ElementsAssignment_1_1_1_1"


    // $ANTLR start "rule__XAnnotationElementValue__ElementsAssignment_0_1_0"
    // InternalXbaseWithAnnotations.g:16216:1: rule__XAnnotationElementValue__ElementsAssignment_0_1_0 : ( ruleXAnnotationOrExpression ) ;
    public final void rule__XAnnotationElementValue__ElementsAssignment_0_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16220:1: ( ( ruleXAnnotationOrExpression ) )
            // InternalXbaseWithAnnotations.g:16221:2: ( ruleXAnnotationOrExpression )
            {
            // InternalXbaseWithAnnotations.g:16221:2: ( ruleXAnnotationOrExpression )
            // InternalXbaseWithAnnotations.g:16222:3: ruleXAnnotationOrExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueAccess().getElementsXAnnotationOrExpressionParserRuleCall_0_1_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAnnotationOrExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueAccess().getElementsXAnnotationOrExpressionParserRuleCall_0_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__ElementsAssignment_0_1_0"


    // $ANTLR start "rule__XAnnotationElementValue__ElementsAssignment_0_1_1_1"
    // InternalXbaseWithAnnotations.g:16231:1: rule__XAnnotationElementValue__ElementsAssignment_0_1_1_1 : ( ruleXAnnotationOrExpression ) ;
    public final void rule__XAnnotationElementValue__ElementsAssignment_0_1_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16235:1: ( ( ruleXAnnotationOrExpression ) )
            // InternalXbaseWithAnnotations.g:16236:2: ( ruleXAnnotationOrExpression )
            {
            // InternalXbaseWithAnnotations.g:16236:2: ( ruleXAnnotationOrExpression )
            // InternalXbaseWithAnnotations.g:16237:3: ruleXAnnotationOrExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAnnotationElementValueAccess().getElementsXAnnotationOrExpressionParserRuleCall_0_1_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAnnotationOrExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAnnotationElementValueAccess().getElementsXAnnotationOrExpressionParserRuleCall_0_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAnnotationElementValue__ElementsAssignment_0_1_1_1"


    // $ANTLR start "rule__XAssignment__FeatureAssignment_0_1"
    // InternalXbaseWithAnnotations.g:16246:1: rule__XAssignment__FeatureAssignment_0_1 : ( ( ruleFeatureCallID ) ) ;
    public final void rule__XAssignment__FeatureAssignment_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16250:1: ( ( ( ruleFeatureCallID ) ) )
            // InternalXbaseWithAnnotations.g:16251:2: ( ( ruleFeatureCallID ) )
            {
            // InternalXbaseWithAnnotations.g:16251:2: ( ( ruleFeatureCallID ) )
            // InternalXbaseWithAnnotations.g:16252:3: ( ruleFeatureCallID )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getFeatureJvmIdentifiableElementCrossReference_0_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:16253:3: ( ruleFeatureCallID )
            // InternalXbaseWithAnnotations.g:16254:4: ruleFeatureCallID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getFeatureJvmIdentifiableElementFeatureCallIDParserRuleCall_0_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleFeatureCallID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getFeatureJvmIdentifiableElementFeatureCallIDParserRuleCall_0_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getFeatureJvmIdentifiableElementCrossReference_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__FeatureAssignment_0_1"


    // $ANTLR start "rule__XAssignment__ValueAssignment_0_3"
    // InternalXbaseWithAnnotations.g:16265:1: rule__XAssignment__ValueAssignment_0_3 : ( ruleXAssignment ) ;
    public final void rule__XAssignment__ValueAssignment_0_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16269:1: ( ( ruleXAssignment ) )
            // InternalXbaseWithAnnotations.g:16270:2: ( ruleXAssignment )
            {
            // InternalXbaseWithAnnotations.g:16270:2: ( ruleXAssignment )
            // InternalXbaseWithAnnotations.g:16271:3: ruleXAssignment
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getValueXAssignmentParserRuleCall_0_3_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAssignment();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getValueXAssignmentParserRuleCall_0_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__ValueAssignment_0_3"


    // $ANTLR start "rule__XAssignment__FeatureAssignment_1_1_0_0_1"
    // InternalXbaseWithAnnotations.g:16280:1: rule__XAssignment__FeatureAssignment_1_1_0_0_1 : ( ( ruleOpMultiAssign ) ) ;
    public final void rule__XAssignment__FeatureAssignment_1_1_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16284:1: ( ( ( ruleOpMultiAssign ) ) )
            // InternalXbaseWithAnnotations.g:16285:2: ( ( ruleOpMultiAssign ) )
            {
            // InternalXbaseWithAnnotations.g:16285:2: ( ( ruleOpMultiAssign ) )
            // InternalXbaseWithAnnotations.g:16286:3: ( ruleOpMultiAssign )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getFeatureJvmIdentifiableElementCrossReference_1_1_0_0_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:16287:3: ( ruleOpMultiAssign )
            // InternalXbaseWithAnnotations.g:16288:4: ruleOpMultiAssign
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getFeatureJvmIdentifiableElementOpMultiAssignParserRuleCall_1_1_0_0_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleOpMultiAssign();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getFeatureJvmIdentifiableElementOpMultiAssignParserRuleCall_1_1_0_0_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getFeatureJvmIdentifiableElementCrossReference_1_1_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__FeatureAssignment_1_1_0_0_1"


    // $ANTLR start "rule__XAssignment__RightOperandAssignment_1_1_1"
    // InternalXbaseWithAnnotations.g:16299:1: rule__XAssignment__RightOperandAssignment_1_1_1 : ( ruleXAssignment ) ;
    public final void rule__XAssignment__RightOperandAssignment_1_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16303:1: ( ( ruleXAssignment ) )
            // InternalXbaseWithAnnotations.g:16304:2: ( ruleXAssignment )
            {
            // InternalXbaseWithAnnotations.g:16304:2: ( ruleXAssignment )
            // InternalXbaseWithAnnotations.g:16305:3: ruleXAssignment
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAssignmentAccess().getRightOperandXAssignmentParserRuleCall_1_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAssignment();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAssignmentAccess().getRightOperandXAssignmentParserRuleCall_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAssignment__RightOperandAssignment_1_1_1"


    // $ANTLR start "rule__XOrExpression__FeatureAssignment_1_0_0_1"
    // InternalXbaseWithAnnotations.g:16314:1: rule__XOrExpression__FeatureAssignment_1_0_0_1 : ( ( ruleOpOr ) ) ;
    public final void rule__XOrExpression__FeatureAssignment_1_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16318:1: ( ( ( ruleOpOr ) ) )
            // InternalXbaseWithAnnotations.g:16319:2: ( ( ruleOpOr ) )
            {
            // InternalXbaseWithAnnotations.g:16319:2: ( ( ruleOpOr ) )
            // InternalXbaseWithAnnotations.g:16320:3: ( ruleOpOr )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOrExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:16321:3: ( ruleOpOr )
            // InternalXbaseWithAnnotations.g:16322:4: ruleOpOr
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOrExpressionAccess().getFeatureJvmIdentifiableElementOpOrParserRuleCall_1_0_0_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleOpOr();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOrExpressionAccess().getFeatureJvmIdentifiableElementOpOrParserRuleCall_1_0_0_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOrExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__FeatureAssignment_1_0_0_1"


    // $ANTLR start "rule__XOrExpression__RightOperandAssignment_1_1"
    // InternalXbaseWithAnnotations.g:16333:1: rule__XOrExpression__RightOperandAssignment_1_1 : ( ruleXAndExpression ) ;
    public final void rule__XOrExpression__RightOperandAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16337:1: ( ( ruleXAndExpression ) )
            // InternalXbaseWithAnnotations.g:16338:2: ( ruleXAndExpression )
            {
            // InternalXbaseWithAnnotations.g:16338:2: ( ruleXAndExpression )
            // InternalXbaseWithAnnotations.g:16339:3: ruleXAndExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOrExpressionAccess().getRightOperandXAndExpressionParserRuleCall_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAndExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOrExpressionAccess().getRightOperandXAndExpressionParserRuleCall_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOrExpression__RightOperandAssignment_1_1"


    // $ANTLR start "rule__XAndExpression__FeatureAssignment_1_0_0_1"
    // InternalXbaseWithAnnotations.g:16348:1: rule__XAndExpression__FeatureAssignment_1_0_0_1 : ( ( ruleOpAnd ) ) ;
    public final void rule__XAndExpression__FeatureAssignment_1_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16352:1: ( ( ( ruleOpAnd ) ) )
            // InternalXbaseWithAnnotations.g:16353:2: ( ( ruleOpAnd ) )
            {
            // InternalXbaseWithAnnotations.g:16353:2: ( ( ruleOpAnd ) )
            // InternalXbaseWithAnnotations.g:16354:3: ( ruleOpAnd )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAndExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:16355:3: ( ruleOpAnd )
            // InternalXbaseWithAnnotations.g:16356:4: ruleOpAnd
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAndExpressionAccess().getFeatureJvmIdentifiableElementOpAndParserRuleCall_1_0_0_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleOpAnd();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAndExpressionAccess().getFeatureJvmIdentifiableElementOpAndParserRuleCall_1_0_0_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAndExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__FeatureAssignment_1_0_0_1"


    // $ANTLR start "rule__XAndExpression__RightOperandAssignment_1_1"
    // InternalXbaseWithAnnotations.g:16367:1: rule__XAndExpression__RightOperandAssignment_1_1 : ( ruleXEqualityExpression ) ;
    public final void rule__XAndExpression__RightOperandAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16371:1: ( ( ruleXEqualityExpression ) )
            // InternalXbaseWithAnnotations.g:16372:2: ( ruleXEqualityExpression )
            {
            // InternalXbaseWithAnnotations.g:16372:2: ( ruleXEqualityExpression )
            // InternalXbaseWithAnnotations.g:16373:3: ruleXEqualityExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAndExpressionAccess().getRightOperandXEqualityExpressionParserRuleCall_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXEqualityExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAndExpressionAccess().getRightOperandXEqualityExpressionParserRuleCall_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAndExpression__RightOperandAssignment_1_1"


    // $ANTLR start "rule__XEqualityExpression__FeatureAssignment_1_0_0_1"
    // InternalXbaseWithAnnotations.g:16382:1: rule__XEqualityExpression__FeatureAssignment_1_0_0_1 : ( ( ruleOpEquality ) ) ;
    public final void rule__XEqualityExpression__FeatureAssignment_1_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16386:1: ( ( ( ruleOpEquality ) ) )
            // InternalXbaseWithAnnotations.g:16387:2: ( ( ruleOpEquality ) )
            {
            // InternalXbaseWithAnnotations.g:16387:2: ( ( ruleOpEquality ) )
            // InternalXbaseWithAnnotations.g:16388:3: ( ruleOpEquality )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXEqualityExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:16389:3: ( ruleOpEquality )
            // InternalXbaseWithAnnotations.g:16390:4: ruleOpEquality
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXEqualityExpressionAccess().getFeatureJvmIdentifiableElementOpEqualityParserRuleCall_1_0_0_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleOpEquality();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXEqualityExpressionAccess().getFeatureJvmIdentifiableElementOpEqualityParserRuleCall_1_0_0_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXEqualityExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__FeatureAssignment_1_0_0_1"


    // $ANTLR start "rule__XEqualityExpression__RightOperandAssignment_1_1"
    // InternalXbaseWithAnnotations.g:16401:1: rule__XEqualityExpression__RightOperandAssignment_1_1 : ( ruleXRelationalExpression ) ;
    public final void rule__XEqualityExpression__RightOperandAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16405:1: ( ( ruleXRelationalExpression ) )
            // InternalXbaseWithAnnotations.g:16406:2: ( ruleXRelationalExpression )
            {
            // InternalXbaseWithAnnotations.g:16406:2: ( ruleXRelationalExpression )
            // InternalXbaseWithAnnotations.g:16407:3: ruleXRelationalExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXEqualityExpressionAccess().getRightOperandXRelationalExpressionParserRuleCall_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXRelationalExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXEqualityExpressionAccess().getRightOperandXRelationalExpressionParserRuleCall_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XEqualityExpression__RightOperandAssignment_1_1"


    // $ANTLR start "rule__XRelationalExpression__TypeAssignment_1_0_1"
    // InternalXbaseWithAnnotations.g:16416:1: rule__XRelationalExpression__TypeAssignment_1_0_1 : ( ruleJvmTypeReference ) ;
    public final void rule__XRelationalExpression__TypeAssignment_1_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16420:1: ( ( ruleJvmTypeReference ) )
            // InternalXbaseWithAnnotations.g:16421:2: ( ruleJvmTypeReference )
            {
            // InternalXbaseWithAnnotations.g:16421:2: ( ruleJvmTypeReference )
            // InternalXbaseWithAnnotations.g:16422:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getTypeJvmTypeReferenceParserRuleCall_1_0_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getTypeJvmTypeReferenceParserRuleCall_1_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__TypeAssignment_1_0_1"


    // $ANTLR start "rule__XRelationalExpression__FeatureAssignment_1_1_0_0_1"
    // InternalXbaseWithAnnotations.g:16431:1: rule__XRelationalExpression__FeatureAssignment_1_1_0_0_1 : ( ( ruleOpCompare ) ) ;
    public final void rule__XRelationalExpression__FeatureAssignment_1_1_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16435:1: ( ( ( ruleOpCompare ) ) )
            // InternalXbaseWithAnnotations.g:16436:2: ( ( ruleOpCompare ) )
            {
            // InternalXbaseWithAnnotations.g:16436:2: ( ( ruleOpCompare ) )
            // InternalXbaseWithAnnotations.g:16437:3: ( ruleOpCompare )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_1_0_0_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:16438:3: ( ruleOpCompare )
            // InternalXbaseWithAnnotations.g:16439:4: ruleOpCompare
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getFeatureJvmIdentifiableElementOpCompareParserRuleCall_1_1_0_0_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleOpCompare();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getFeatureJvmIdentifiableElementOpCompareParserRuleCall_1_1_0_0_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_1_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__FeatureAssignment_1_1_0_0_1"


    // $ANTLR start "rule__XRelationalExpression__RightOperandAssignment_1_1_1"
    // InternalXbaseWithAnnotations.g:16450:1: rule__XRelationalExpression__RightOperandAssignment_1_1_1 : ( ruleXOtherOperatorExpression ) ;
    public final void rule__XRelationalExpression__RightOperandAssignment_1_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16454:1: ( ( ruleXOtherOperatorExpression ) )
            // InternalXbaseWithAnnotations.g:16455:2: ( ruleXOtherOperatorExpression )
            {
            // InternalXbaseWithAnnotations.g:16455:2: ( ruleXOtherOperatorExpression )
            // InternalXbaseWithAnnotations.g:16456:3: ruleXOtherOperatorExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXRelationalExpressionAccess().getRightOperandXOtherOperatorExpressionParserRuleCall_1_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXOtherOperatorExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXRelationalExpressionAccess().getRightOperandXOtherOperatorExpressionParserRuleCall_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XRelationalExpression__RightOperandAssignment_1_1_1"


    // $ANTLR start "rule__XOtherOperatorExpression__FeatureAssignment_1_0_0_1"
    // InternalXbaseWithAnnotations.g:16465:1: rule__XOtherOperatorExpression__FeatureAssignment_1_0_0_1 : ( ( ruleOpOther ) ) ;
    public final void rule__XOtherOperatorExpression__FeatureAssignment_1_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16469:1: ( ( ( ruleOpOther ) ) )
            // InternalXbaseWithAnnotations.g:16470:2: ( ( ruleOpOther ) )
            {
            // InternalXbaseWithAnnotations.g:16470:2: ( ( ruleOpOther ) )
            // InternalXbaseWithAnnotations.g:16471:3: ( ruleOpOther )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOtherOperatorExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:16472:3: ( ruleOpOther )
            // InternalXbaseWithAnnotations.g:16473:4: ruleOpOther
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOtherOperatorExpressionAccess().getFeatureJvmIdentifiableElementOpOtherParserRuleCall_1_0_0_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleOpOther();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOtherOperatorExpressionAccess().getFeatureJvmIdentifiableElementOpOtherParserRuleCall_1_0_0_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOtherOperatorExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__FeatureAssignment_1_0_0_1"


    // $ANTLR start "rule__XOtherOperatorExpression__RightOperandAssignment_1_1"
    // InternalXbaseWithAnnotations.g:16484:1: rule__XOtherOperatorExpression__RightOperandAssignment_1_1 : ( ruleXAdditiveExpression ) ;
    public final void rule__XOtherOperatorExpression__RightOperandAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16488:1: ( ( ruleXAdditiveExpression ) )
            // InternalXbaseWithAnnotations.g:16489:2: ( ruleXAdditiveExpression )
            {
            // InternalXbaseWithAnnotations.g:16489:2: ( ruleXAdditiveExpression )
            // InternalXbaseWithAnnotations.g:16490:3: ruleXAdditiveExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXOtherOperatorExpressionAccess().getRightOperandXAdditiveExpressionParserRuleCall_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAdditiveExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXOtherOperatorExpressionAccess().getRightOperandXAdditiveExpressionParserRuleCall_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XOtherOperatorExpression__RightOperandAssignment_1_1"


    // $ANTLR start "rule__XAdditiveExpression__FeatureAssignment_1_0_0_1"
    // InternalXbaseWithAnnotations.g:16499:1: rule__XAdditiveExpression__FeatureAssignment_1_0_0_1 : ( ( ruleOpAdd ) ) ;
    public final void rule__XAdditiveExpression__FeatureAssignment_1_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16503:1: ( ( ( ruleOpAdd ) ) )
            // InternalXbaseWithAnnotations.g:16504:2: ( ( ruleOpAdd ) )
            {
            // InternalXbaseWithAnnotations.g:16504:2: ( ( ruleOpAdd ) )
            // InternalXbaseWithAnnotations.g:16505:3: ( ruleOpAdd )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAdditiveExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:16506:3: ( ruleOpAdd )
            // InternalXbaseWithAnnotations.g:16507:4: ruleOpAdd
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAdditiveExpressionAccess().getFeatureJvmIdentifiableElementOpAddParserRuleCall_1_0_0_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleOpAdd();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAdditiveExpressionAccess().getFeatureJvmIdentifiableElementOpAddParserRuleCall_1_0_0_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAdditiveExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__FeatureAssignment_1_0_0_1"


    // $ANTLR start "rule__XAdditiveExpression__RightOperandAssignment_1_1"
    // InternalXbaseWithAnnotations.g:16518:1: rule__XAdditiveExpression__RightOperandAssignment_1_1 : ( ruleXMultiplicativeExpression ) ;
    public final void rule__XAdditiveExpression__RightOperandAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16522:1: ( ( ruleXMultiplicativeExpression ) )
            // InternalXbaseWithAnnotations.g:16523:2: ( ruleXMultiplicativeExpression )
            {
            // InternalXbaseWithAnnotations.g:16523:2: ( ruleXMultiplicativeExpression )
            // InternalXbaseWithAnnotations.g:16524:3: ruleXMultiplicativeExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXAdditiveExpressionAccess().getRightOperandXMultiplicativeExpressionParserRuleCall_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXMultiplicativeExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXAdditiveExpressionAccess().getRightOperandXMultiplicativeExpressionParserRuleCall_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XAdditiveExpression__RightOperandAssignment_1_1"


    // $ANTLR start "rule__XMultiplicativeExpression__FeatureAssignment_1_0_0_1"
    // InternalXbaseWithAnnotations.g:16533:1: rule__XMultiplicativeExpression__FeatureAssignment_1_0_0_1 : ( ( ruleOpMulti ) ) ;
    public final void rule__XMultiplicativeExpression__FeatureAssignment_1_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16537:1: ( ( ( ruleOpMulti ) ) )
            // InternalXbaseWithAnnotations.g:16538:2: ( ( ruleOpMulti ) )
            {
            // InternalXbaseWithAnnotations.g:16538:2: ( ( ruleOpMulti ) )
            // InternalXbaseWithAnnotations.g:16539:3: ( ruleOpMulti )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMultiplicativeExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:16540:3: ( ruleOpMulti )
            // InternalXbaseWithAnnotations.g:16541:4: ruleOpMulti
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMultiplicativeExpressionAccess().getFeatureJvmIdentifiableElementOpMultiParserRuleCall_1_0_0_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleOpMulti();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMultiplicativeExpressionAccess().getFeatureJvmIdentifiableElementOpMultiParserRuleCall_1_0_0_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMultiplicativeExpressionAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__FeatureAssignment_1_0_0_1"


    // $ANTLR start "rule__XMultiplicativeExpression__RightOperandAssignment_1_1"
    // InternalXbaseWithAnnotations.g:16552:1: rule__XMultiplicativeExpression__RightOperandAssignment_1_1 : ( ruleXUnaryOperation ) ;
    public final void rule__XMultiplicativeExpression__RightOperandAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16556:1: ( ( ruleXUnaryOperation ) )
            // InternalXbaseWithAnnotations.g:16557:2: ( ruleXUnaryOperation )
            {
            // InternalXbaseWithAnnotations.g:16557:2: ( ruleXUnaryOperation )
            // InternalXbaseWithAnnotations.g:16558:3: ruleXUnaryOperation
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMultiplicativeExpressionAccess().getRightOperandXUnaryOperationParserRuleCall_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXUnaryOperation();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMultiplicativeExpressionAccess().getRightOperandXUnaryOperationParserRuleCall_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMultiplicativeExpression__RightOperandAssignment_1_1"


    // $ANTLR start "rule__XUnaryOperation__FeatureAssignment_0_1"
    // InternalXbaseWithAnnotations.g:16567:1: rule__XUnaryOperation__FeatureAssignment_0_1 : ( ( ruleOpUnary ) ) ;
    public final void rule__XUnaryOperation__FeatureAssignment_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16571:1: ( ( ( ruleOpUnary ) ) )
            // InternalXbaseWithAnnotations.g:16572:2: ( ( ruleOpUnary ) )
            {
            // InternalXbaseWithAnnotations.g:16572:2: ( ( ruleOpUnary ) )
            // InternalXbaseWithAnnotations.g:16573:3: ( ruleOpUnary )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXUnaryOperationAccess().getFeatureJvmIdentifiableElementCrossReference_0_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:16574:3: ( ruleOpUnary )
            // InternalXbaseWithAnnotations.g:16575:4: ruleOpUnary
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXUnaryOperationAccess().getFeatureJvmIdentifiableElementOpUnaryParserRuleCall_0_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleOpUnary();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXUnaryOperationAccess().getFeatureJvmIdentifiableElementOpUnaryParserRuleCall_0_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXUnaryOperationAccess().getFeatureJvmIdentifiableElementCrossReference_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XUnaryOperation__FeatureAssignment_0_1"


    // $ANTLR start "rule__XUnaryOperation__OperandAssignment_0_2"
    // InternalXbaseWithAnnotations.g:16586:1: rule__XUnaryOperation__OperandAssignment_0_2 : ( ruleXUnaryOperation ) ;
    public final void rule__XUnaryOperation__OperandAssignment_0_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16590:1: ( ( ruleXUnaryOperation ) )
            // InternalXbaseWithAnnotations.g:16591:2: ( ruleXUnaryOperation )
            {
            // InternalXbaseWithAnnotations.g:16591:2: ( ruleXUnaryOperation )
            // InternalXbaseWithAnnotations.g:16592:3: ruleXUnaryOperation
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXUnaryOperationAccess().getOperandXUnaryOperationParserRuleCall_0_2_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXUnaryOperation();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXUnaryOperationAccess().getOperandXUnaryOperationParserRuleCall_0_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XUnaryOperation__OperandAssignment_0_2"


    // $ANTLR start "rule__XCastedExpression__TypeAssignment_1_1"
    // InternalXbaseWithAnnotations.g:16601:1: rule__XCastedExpression__TypeAssignment_1_1 : ( ruleJvmTypeReference ) ;
    public final void rule__XCastedExpression__TypeAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16605:1: ( ( ruleJvmTypeReference ) )
            // InternalXbaseWithAnnotations.g:16606:2: ( ruleJvmTypeReference )
            {
            // InternalXbaseWithAnnotations.g:16606:2: ( ruleJvmTypeReference )
            // InternalXbaseWithAnnotations.g:16607:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCastedExpressionAccess().getTypeJvmTypeReferenceParserRuleCall_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCastedExpressionAccess().getTypeJvmTypeReferenceParserRuleCall_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCastedExpression__TypeAssignment_1_1"


    // $ANTLR start "rule__XPostfixOperation__FeatureAssignment_1_0_1"
    // InternalXbaseWithAnnotations.g:16616:1: rule__XPostfixOperation__FeatureAssignment_1_0_1 : ( ( ruleOpPostfix ) ) ;
    public final void rule__XPostfixOperation__FeatureAssignment_1_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16620:1: ( ( ( ruleOpPostfix ) ) )
            // InternalXbaseWithAnnotations.g:16621:2: ( ( ruleOpPostfix ) )
            {
            // InternalXbaseWithAnnotations.g:16621:2: ( ( ruleOpPostfix ) )
            // InternalXbaseWithAnnotations.g:16622:3: ( ruleOpPostfix )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXPostfixOperationAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:16623:3: ( ruleOpPostfix )
            // InternalXbaseWithAnnotations.g:16624:4: ruleOpPostfix
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXPostfixOperationAccess().getFeatureJvmIdentifiableElementOpPostfixParserRuleCall_1_0_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleOpPostfix();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXPostfixOperationAccess().getFeatureJvmIdentifiableElementOpPostfixParserRuleCall_1_0_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXPostfixOperationAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XPostfixOperation__FeatureAssignment_1_0_1"


    // $ANTLR start "rule__XMemberFeatureCall__ExplicitStaticAssignment_1_0_0_0_1_1"
    // InternalXbaseWithAnnotations.g:16635:1: rule__XMemberFeatureCall__ExplicitStaticAssignment_1_0_0_0_1_1 : ( ( '::' ) ) ;
    public final void rule__XMemberFeatureCall__ExplicitStaticAssignment_1_0_0_0_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16639:1: ( ( ( '::' ) ) )
            // InternalXbaseWithAnnotations.g:16640:2: ( ( '::' ) )
            {
            // InternalXbaseWithAnnotations.g:16640:2: ( ( '::' ) )
            // InternalXbaseWithAnnotations.g:16641:3: ( '::' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticColonColonKeyword_1_0_0_0_1_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:16642:3: ( '::' )
            // InternalXbaseWithAnnotations.g:16643:4: '::'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticColonColonKeyword_1_0_0_0_1_1_0()); 
            }
            match(input,83,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticColonColonKeyword_1_0_0_0_1_1_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticColonColonKeyword_1_0_0_0_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__ExplicitStaticAssignment_1_0_0_0_1_1"


    // $ANTLR start "rule__XMemberFeatureCall__FeatureAssignment_1_0_0_0_2"
    // InternalXbaseWithAnnotations.g:16654:1: rule__XMemberFeatureCall__FeatureAssignment_1_0_0_0_2 : ( ( ruleFeatureCallID ) ) ;
    public final void rule__XMemberFeatureCall__FeatureAssignment_1_0_0_0_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16658:1: ( ( ( ruleFeatureCallID ) ) )
            // InternalXbaseWithAnnotations.g:16659:2: ( ( ruleFeatureCallID ) )
            {
            // InternalXbaseWithAnnotations.g:16659:2: ( ( ruleFeatureCallID ) )
            // InternalXbaseWithAnnotations.g:16660:3: ( ruleFeatureCallID )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_0_2_0()); 
            }
            // InternalXbaseWithAnnotations.g:16661:3: ( ruleFeatureCallID )
            // InternalXbaseWithAnnotations.g:16662:4: ruleFeatureCallID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getFeatureJvmIdentifiableElementFeatureCallIDParserRuleCall_1_0_0_0_2_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleFeatureCallID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getFeatureJvmIdentifiableElementFeatureCallIDParserRuleCall_1_0_0_0_2_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getFeatureJvmIdentifiableElementCrossReference_1_0_0_0_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__FeatureAssignment_1_0_0_0_2"


    // $ANTLR start "rule__XMemberFeatureCall__ValueAssignment_1_0_1"
    // InternalXbaseWithAnnotations.g:16673:1: rule__XMemberFeatureCall__ValueAssignment_1_0_1 : ( ruleXAssignment ) ;
    public final void rule__XMemberFeatureCall__ValueAssignment_1_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16677:1: ( ( ruleXAssignment ) )
            // InternalXbaseWithAnnotations.g:16678:2: ( ruleXAssignment )
            {
            // InternalXbaseWithAnnotations.g:16678:2: ( ruleXAssignment )
            // InternalXbaseWithAnnotations.g:16679:3: ruleXAssignment
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getValueXAssignmentParserRuleCall_1_0_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXAssignment();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getValueXAssignmentParserRuleCall_1_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__ValueAssignment_1_0_1"


    // $ANTLR start "rule__XMemberFeatureCall__NullSafeAssignment_1_1_0_0_1_1"
    // InternalXbaseWithAnnotations.g:16688:1: rule__XMemberFeatureCall__NullSafeAssignment_1_1_0_0_1_1 : ( ( '?.' ) ) ;
    public final void rule__XMemberFeatureCall__NullSafeAssignment_1_1_0_0_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16692:1: ( ( ( '?.' ) ) )
            // InternalXbaseWithAnnotations.g:16693:2: ( ( '?.' ) )
            {
            // InternalXbaseWithAnnotations.g:16693:2: ( ( '?.' ) )
            // InternalXbaseWithAnnotations.g:16694:3: ( '?.' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getNullSafeQuestionMarkFullStopKeyword_1_1_0_0_1_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:16695:3: ( '?.' )
            // InternalXbaseWithAnnotations.g:16696:4: '?.'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getNullSafeQuestionMarkFullStopKeyword_1_1_0_0_1_1_0()); 
            }
            match(input,84,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getNullSafeQuestionMarkFullStopKeyword_1_1_0_0_1_1_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getNullSafeQuestionMarkFullStopKeyword_1_1_0_0_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__NullSafeAssignment_1_1_0_0_1_1"


    // $ANTLR start "rule__XMemberFeatureCall__ExplicitStaticAssignment_1_1_0_0_1_2"
    // InternalXbaseWithAnnotations.g:16707:1: rule__XMemberFeatureCall__ExplicitStaticAssignment_1_1_0_0_1_2 : ( ( '::' ) ) ;
    public final void rule__XMemberFeatureCall__ExplicitStaticAssignment_1_1_0_0_1_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16711:1: ( ( ( '::' ) ) )
            // InternalXbaseWithAnnotations.g:16712:2: ( ( '::' ) )
            {
            // InternalXbaseWithAnnotations.g:16712:2: ( ( '::' ) )
            // InternalXbaseWithAnnotations.g:16713:3: ( '::' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticColonColonKeyword_1_1_0_0_1_2_0()); 
            }
            // InternalXbaseWithAnnotations.g:16714:3: ( '::' )
            // InternalXbaseWithAnnotations.g:16715:4: '::'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticColonColonKeyword_1_1_0_0_1_2_0()); 
            }
            match(input,83,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticColonColonKeyword_1_1_0_0_1_2_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getExplicitStaticColonColonKeyword_1_1_0_0_1_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__ExplicitStaticAssignment_1_1_0_0_1_2"


    // $ANTLR start "rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_1"
    // InternalXbaseWithAnnotations.g:16726:1: rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_1 : ( ruleJvmArgumentTypeReference ) ;
    public final void rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16730:1: ( ( ruleJvmArgumentTypeReference ) )
            // InternalXbaseWithAnnotations.g:16731:2: ( ruleJvmArgumentTypeReference )
            {
            // InternalXbaseWithAnnotations.g:16731:2: ( ruleJvmArgumentTypeReference )
            // InternalXbaseWithAnnotations.g:16732:3: ruleJvmArgumentTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_1_1_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmArgumentTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_1_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_1"


    // $ANTLR start "rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_2_1"
    // InternalXbaseWithAnnotations.g:16741:1: rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_2_1 : ( ruleJvmArgumentTypeReference ) ;
    public final void rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16745:1: ( ( ruleJvmArgumentTypeReference ) )
            // InternalXbaseWithAnnotations.g:16746:2: ( ruleJvmArgumentTypeReference )
            {
            // InternalXbaseWithAnnotations.g:16746:2: ( ruleJvmArgumentTypeReference )
            // InternalXbaseWithAnnotations.g:16747:3: ruleJvmArgumentTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_1_1_1_2_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmArgumentTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_1_1_1_2_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__TypeArgumentsAssignment_1_1_1_2_1"


    // $ANTLR start "rule__XMemberFeatureCall__FeatureAssignment_1_1_2"
    // InternalXbaseWithAnnotations.g:16756:1: rule__XMemberFeatureCall__FeatureAssignment_1_1_2 : ( ( ruleIdOrSuper ) ) ;
    public final void rule__XMemberFeatureCall__FeatureAssignment_1_1_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16760:1: ( ( ( ruleIdOrSuper ) ) )
            // InternalXbaseWithAnnotations.g:16761:2: ( ( ruleIdOrSuper ) )
            {
            // InternalXbaseWithAnnotations.g:16761:2: ( ( ruleIdOrSuper ) )
            // InternalXbaseWithAnnotations.g:16762:3: ( ruleIdOrSuper )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getFeatureJvmIdentifiableElementCrossReference_1_1_2_0()); 
            }
            // InternalXbaseWithAnnotations.g:16763:3: ( ruleIdOrSuper )
            // InternalXbaseWithAnnotations.g:16764:4: ruleIdOrSuper
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getFeatureJvmIdentifiableElementIdOrSuperParserRuleCall_1_1_2_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleIdOrSuper();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getFeatureJvmIdentifiableElementIdOrSuperParserRuleCall_1_1_2_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getFeatureJvmIdentifiableElementCrossReference_1_1_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__FeatureAssignment_1_1_2"


    // $ANTLR start "rule__XMemberFeatureCall__ExplicitOperationCallAssignment_1_1_3_0"
    // InternalXbaseWithAnnotations.g:16775:1: rule__XMemberFeatureCall__ExplicitOperationCallAssignment_1_1_3_0 : ( ( '(' ) ) ;
    public final void rule__XMemberFeatureCall__ExplicitOperationCallAssignment_1_1_3_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16779:1: ( ( ( '(' ) ) )
            // InternalXbaseWithAnnotations.g:16780:2: ( ( '(' ) )
            {
            // InternalXbaseWithAnnotations.g:16780:2: ( ( '(' ) )
            // InternalXbaseWithAnnotations.g:16781:3: ( '(' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getExplicitOperationCallLeftParenthesisKeyword_1_1_3_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:16782:3: ( '(' )
            // InternalXbaseWithAnnotations.g:16783:4: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getExplicitOperationCallLeftParenthesisKeyword_1_1_3_0_0()); 
            }
            match(input,52,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getExplicitOperationCallLeftParenthesisKeyword_1_1_3_0_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getExplicitOperationCallLeftParenthesisKeyword_1_1_3_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__ExplicitOperationCallAssignment_1_1_3_0"


    // $ANTLR start "rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0"
    // InternalXbaseWithAnnotations.g:16794:1: rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 : ( ruleXShortClosure ) ;
    public final void rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16798:1: ( ( ruleXShortClosure ) )
            // InternalXbaseWithAnnotations.g:16799:2: ( ruleXShortClosure )
            {
            // InternalXbaseWithAnnotations.g:16799:2: ( ruleXShortClosure )
            // InternalXbaseWithAnnotations.g:16800:3: ruleXShortClosure
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsXShortClosureParserRuleCall_1_1_3_1_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXShortClosure();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsXShortClosureParserRuleCall_1_1_3_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0"


    // $ANTLR start "rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_0"
    // InternalXbaseWithAnnotations.g:16809:1: rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_0 : ( ruleXExpression ) ;
    public final void rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16813:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:16814:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:16814:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:16815:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsXExpressionParserRuleCall_1_1_3_1_1_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsXExpressionParserRuleCall_1_1_3_1_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_0"


    // $ANTLR start "rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_1_1"
    // InternalXbaseWithAnnotations.g:16824:1: rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_1_1 : ( ruleXExpression ) ;
    public final void rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16828:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:16829:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:16829:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:16830:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsXExpressionParserRuleCall_1_1_3_1_1_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsXExpressionParserRuleCall_1_1_3_1_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_1_1_1"


    // $ANTLR start "rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4"
    // InternalXbaseWithAnnotations.g:16839:1: rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4 : ( ruleXClosure ) ;
    public final void rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16843:1: ( ( ruleXClosure ) )
            // InternalXbaseWithAnnotations.g:16844:2: ( ruleXClosure )
            {
            // InternalXbaseWithAnnotations.g:16844:2: ( ruleXClosure )
            // InternalXbaseWithAnnotations.g:16845:3: ruleXClosure
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsXClosureParserRuleCall_1_1_4_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXClosure();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsXClosureParserRuleCall_1_1_4_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4"


    // $ANTLR start "rule__XSetLiteral__ElementsAssignment_3_0"
    // InternalXbaseWithAnnotations.g:16854:1: rule__XSetLiteral__ElementsAssignment_3_0 : ( ruleXExpression ) ;
    public final void rule__XSetLiteral__ElementsAssignment_3_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16858:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:16859:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:16859:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:16860:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralAccess().getElementsXExpressionParserRuleCall_3_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralAccess().getElementsXExpressionParserRuleCall_3_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__ElementsAssignment_3_0"


    // $ANTLR start "rule__XSetLiteral__ElementsAssignment_3_1_1"
    // InternalXbaseWithAnnotations.g:16869:1: rule__XSetLiteral__ElementsAssignment_3_1_1 : ( ruleXExpression ) ;
    public final void rule__XSetLiteral__ElementsAssignment_3_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16873:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:16874:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:16874:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:16875:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSetLiteralAccess().getElementsXExpressionParserRuleCall_3_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSetLiteralAccess().getElementsXExpressionParserRuleCall_3_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSetLiteral__ElementsAssignment_3_1_1"


    // $ANTLR start "rule__XListLiteral__ElementsAssignment_3_0"
    // InternalXbaseWithAnnotations.g:16884:1: rule__XListLiteral__ElementsAssignment_3_0 : ( ruleXExpression ) ;
    public final void rule__XListLiteral__ElementsAssignment_3_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16888:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:16889:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:16889:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:16890:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralAccess().getElementsXExpressionParserRuleCall_3_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralAccess().getElementsXExpressionParserRuleCall_3_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__ElementsAssignment_3_0"


    // $ANTLR start "rule__XListLiteral__ElementsAssignment_3_1_1"
    // InternalXbaseWithAnnotations.g:16899:1: rule__XListLiteral__ElementsAssignment_3_1_1 : ( ruleXExpression ) ;
    public final void rule__XListLiteral__ElementsAssignment_3_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16903:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:16904:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:16904:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:16905:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXListLiteralAccess().getElementsXExpressionParserRuleCall_3_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXListLiteralAccess().getElementsXExpressionParserRuleCall_3_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XListLiteral__ElementsAssignment_3_1_1"


    // $ANTLR start "rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_0"
    // InternalXbaseWithAnnotations.g:16914:1: rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_0 : ( ruleJvmFormalParameter ) ;
    public final void rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16918:1: ( ( ruleJvmFormalParameter ) )
            // InternalXbaseWithAnnotations.g:16919:2: ( ruleJvmFormalParameter )
            {
            // InternalXbaseWithAnnotations.g:16919:2: ( ruleJvmFormalParameter )
            // InternalXbaseWithAnnotations.g:16920:3: ruleJvmFormalParameter
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getDeclaredFormalParametersJvmFormalParameterParserRuleCall_1_0_0_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmFormalParameter();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getDeclaredFormalParametersJvmFormalParameterParserRuleCall_1_0_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_0"


    // $ANTLR start "rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_1_1"
    // InternalXbaseWithAnnotations.g:16929:1: rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_1_1 : ( ruleJvmFormalParameter ) ;
    public final void rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16933:1: ( ( ruleJvmFormalParameter ) )
            // InternalXbaseWithAnnotations.g:16934:2: ( ruleJvmFormalParameter )
            {
            // InternalXbaseWithAnnotations.g:16934:2: ( ruleJvmFormalParameter )
            // InternalXbaseWithAnnotations.g:16935:3: ruleJvmFormalParameter
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getDeclaredFormalParametersJvmFormalParameterParserRuleCall_1_0_0_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmFormalParameter();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getDeclaredFormalParametersJvmFormalParameterParserRuleCall_1_0_0_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__DeclaredFormalParametersAssignment_1_0_0_1_1"


    // $ANTLR start "rule__XClosure__ExplicitSyntaxAssignment_1_0_1"
    // InternalXbaseWithAnnotations.g:16944:1: rule__XClosure__ExplicitSyntaxAssignment_1_0_1 : ( ( '|' ) ) ;
    public final void rule__XClosure__ExplicitSyntaxAssignment_1_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16948:1: ( ( ( '|' ) ) )
            // InternalXbaseWithAnnotations.g:16949:2: ( ( '|' ) )
            {
            // InternalXbaseWithAnnotations.g:16949:2: ( ( '|' ) )
            // InternalXbaseWithAnnotations.g:16950:3: ( '|' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getExplicitSyntaxVerticalLineKeyword_1_0_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:16951:3: ( '|' )
            // InternalXbaseWithAnnotations.g:16952:4: '|'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getExplicitSyntaxVerticalLineKeyword_1_0_1_0()); 
            }
            match(input,85,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getExplicitSyntaxVerticalLineKeyword_1_0_1_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getExplicitSyntaxVerticalLineKeyword_1_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__ExplicitSyntaxAssignment_1_0_1"


    // $ANTLR start "rule__XClosure__ExpressionAssignment_2"
    // InternalXbaseWithAnnotations.g:16963:1: rule__XClosure__ExpressionAssignment_2 : ( ruleXExpressionInClosure ) ;
    public final void rule__XClosure__ExpressionAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16967:1: ( ( ruleXExpressionInClosure ) )
            // InternalXbaseWithAnnotations.g:16968:2: ( ruleXExpressionInClosure )
            {
            // InternalXbaseWithAnnotations.g:16968:2: ( ruleXExpressionInClosure )
            // InternalXbaseWithAnnotations.g:16969:3: ruleXExpressionInClosure
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXClosureAccess().getExpressionXExpressionInClosureParserRuleCall_2_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpressionInClosure();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXClosureAccess().getExpressionXExpressionInClosureParserRuleCall_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XClosure__ExpressionAssignment_2"


    // $ANTLR start "rule__XExpressionInClosure__ExpressionsAssignment_1_0"
    // InternalXbaseWithAnnotations.g:16978:1: rule__XExpressionInClosure__ExpressionsAssignment_1_0 : ( ruleXExpressionOrVarDeclaration ) ;
    public final void rule__XExpressionInClosure__ExpressionsAssignment_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16982:1: ( ( ruleXExpressionOrVarDeclaration ) )
            // InternalXbaseWithAnnotations.g:16983:2: ( ruleXExpressionOrVarDeclaration )
            {
            // InternalXbaseWithAnnotations.g:16983:2: ( ruleXExpressionOrVarDeclaration )
            // InternalXbaseWithAnnotations.g:16984:3: ruleXExpressionOrVarDeclaration
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXExpressionInClosureAccess().getExpressionsXExpressionOrVarDeclarationParserRuleCall_1_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpressionOrVarDeclaration();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXExpressionInClosureAccess().getExpressionsXExpressionOrVarDeclarationParserRuleCall_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XExpressionInClosure__ExpressionsAssignment_1_0"


    // $ANTLR start "rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_0"
    // InternalXbaseWithAnnotations.g:16993:1: rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_0 : ( ruleJvmFormalParameter ) ;
    public final void rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:16997:1: ( ( ruleJvmFormalParameter ) )
            // InternalXbaseWithAnnotations.g:16998:2: ( ruleJvmFormalParameter )
            {
            // InternalXbaseWithAnnotations.g:16998:2: ( ruleJvmFormalParameter )
            // InternalXbaseWithAnnotations.g:16999:3: ruleJvmFormalParameter
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getDeclaredFormalParametersJvmFormalParameterParserRuleCall_0_0_1_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmFormalParameter();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getDeclaredFormalParametersJvmFormalParameterParserRuleCall_0_0_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_0"


    // $ANTLR start "rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_1_1"
    // InternalXbaseWithAnnotations.g:17008:1: rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_1_1 : ( ruleJvmFormalParameter ) ;
    public final void rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17012:1: ( ( ruleJvmFormalParameter ) )
            // InternalXbaseWithAnnotations.g:17013:2: ( ruleJvmFormalParameter )
            {
            // InternalXbaseWithAnnotations.g:17013:2: ( ruleJvmFormalParameter )
            // InternalXbaseWithAnnotations.g:17014:3: ruleJvmFormalParameter
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getDeclaredFormalParametersJvmFormalParameterParserRuleCall_0_0_1_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmFormalParameter();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getDeclaredFormalParametersJvmFormalParameterParserRuleCall_0_0_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__DeclaredFormalParametersAssignment_0_0_1_1_1"


    // $ANTLR start "rule__XShortClosure__ExplicitSyntaxAssignment_0_0_2"
    // InternalXbaseWithAnnotations.g:17023:1: rule__XShortClosure__ExplicitSyntaxAssignment_0_0_2 : ( ( '|' ) ) ;
    public final void rule__XShortClosure__ExplicitSyntaxAssignment_0_0_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17027:1: ( ( ( '|' ) ) )
            // InternalXbaseWithAnnotations.g:17028:2: ( ( '|' ) )
            {
            // InternalXbaseWithAnnotations.g:17028:2: ( ( '|' ) )
            // InternalXbaseWithAnnotations.g:17029:3: ( '|' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getExplicitSyntaxVerticalLineKeyword_0_0_2_0()); 
            }
            // InternalXbaseWithAnnotations.g:17030:3: ( '|' )
            // InternalXbaseWithAnnotations.g:17031:4: '|'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getExplicitSyntaxVerticalLineKeyword_0_0_2_0()); 
            }
            match(input,85,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getExplicitSyntaxVerticalLineKeyword_0_0_2_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getExplicitSyntaxVerticalLineKeyword_0_0_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__ExplicitSyntaxAssignment_0_0_2"


    // $ANTLR start "rule__XShortClosure__ExpressionAssignment_1"
    // InternalXbaseWithAnnotations.g:17042:1: rule__XShortClosure__ExpressionAssignment_1 : ( ruleXExpression ) ;
    public final void rule__XShortClosure__ExpressionAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17046:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17047:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17047:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17048:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXShortClosureAccess().getExpressionXExpressionParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXShortClosureAccess().getExpressionXExpressionParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XShortClosure__ExpressionAssignment_1"


    // $ANTLR start "rule__XIfExpression__IfAssignment_3"
    // InternalXbaseWithAnnotations.g:17057:1: rule__XIfExpression__IfAssignment_3 : ( ruleXExpression ) ;
    public final void rule__XIfExpression__IfAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17061:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17062:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17062:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17063:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getIfXExpressionParserRuleCall_3_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getIfXExpressionParserRuleCall_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__IfAssignment_3"


    // $ANTLR start "rule__XIfExpression__ThenAssignment_5"
    // InternalXbaseWithAnnotations.g:17072:1: rule__XIfExpression__ThenAssignment_5 : ( ruleXExpression ) ;
    public final void rule__XIfExpression__ThenAssignment_5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17076:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17077:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17077:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17078:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getThenXExpressionParserRuleCall_5_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getThenXExpressionParserRuleCall_5_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__ThenAssignment_5"


    // $ANTLR start "rule__XIfExpression__ElseAssignment_6_1"
    // InternalXbaseWithAnnotations.g:17087:1: rule__XIfExpression__ElseAssignment_6_1 : ( ruleXExpression ) ;
    public final void rule__XIfExpression__ElseAssignment_6_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17091:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17092:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17092:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17093:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXIfExpressionAccess().getElseXExpressionParserRuleCall_6_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXIfExpressionAccess().getElseXExpressionParserRuleCall_6_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XIfExpression__ElseAssignment_6_1"


    // $ANTLR start "rule__XSwitchExpression__DeclaredParamAssignment_2_0_0_0_1"
    // InternalXbaseWithAnnotations.g:17102:1: rule__XSwitchExpression__DeclaredParamAssignment_2_0_0_0_1 : ( ruleJvmFormalParameter ) ;
    public final void rule__XSwitchExpression__DeclaredParamAssignment_2_0_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17106:1: ( ( ruleJvmFormalParameter ) )
            // InternalXbaseWithAnnotations.g:17107:2: ( ruleJvmFormalParameter )
            {
            // InternalXbaseWithAnnotations.g:17107:2: ( ruleJvmFormalParameter )
            // InternalXbaseWithAnnotations.g:17108:3: ruleJvmFormalParameter
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getDeclaredParamJvmFormalParameterParserRuleCall_2_0_0_0_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmFormalParameter();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getDeclaredParamJvmFormalParameterParserRuleCall_2_0_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__DeclaredParamAssignment_2_0_0_0_1"


    // $ANTLR start "rule__XSwitchExpression__SwitchAssignment_2_0_1"
    // InternalXbaseWithAnnotations.g:17117:1: rule__XSwitchExpression__SwitchAssignment_2_0_1 : ( ruleXExpression ) ;
    public final void rule__XSwitchExpression__SwitchAssignment_2_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17121:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17122:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17122:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17123:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getSwitchXExpressionParserRuleCall_2_0_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getSwitchXExpressionParserRuleCall_2_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__SwitchAssignment_2_0_1"


    // $ANTLR start "rule__XSwitchExpression__DeclaredParamAssignment_2_1_0_0_0"
    // InternalXbaseWithAnnotations.g:17132:1: rule__XSwitchExpression__DeclaredParamAssignment_2_1_0_0_0 : ( ruleJvmFormalParameter ) ;
    public final void rule__XSwitchExpression__DeclaredParamAssignment_2_1_0_0_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17136:1: ( ( ruleJvmFormalParameter ) )
            // InternalXbaseWithAnnotations.g:17137:2: ( ruleJvmFormalParameter )
            {
            // InternalXbaseWithAnnotations.g:17137:2: ( ruleJvmFormalParameter )
            // InternalXbaseWithAnnotations.g:17138:3: ruleJvmFormalParameter
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getDeclaredParamJvmFormalParameterParserRuleCall_2_1_0_0_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmFormalParameter();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getDeclaredParamJvmFormalParameterParserRuleCall_2_1_0_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__DeclaredParamAssignment_2_1_0_0_0"


    // $ANTLR start "rule__XSwitchExpression__SwitchAssignment_2_1_1"
    // InternalXbaseWithAnnotations.g:17147:1: rule__XSwitchExpression__SwitchAssignment_2_1_1 : ( ruleXExpression ) ;
    public final void rule__XSwitchExpression__SwitchAssignment_2_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17151:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17152:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17152:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17153:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getSwitchXExpressionParserRuleCall_2_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getSwitchXExpressionParserRuleCall_2_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__SwitchAssignment_2_1_1"


    // $ANTLR start "rule__XSwitchExpression__CasesAssignment_4"
    // InternalXbaseWithAnnotations.g:17162:1: rule__XSwitchExpression__CasesAssignment_4 : ( ruleXCasePart ) ;
    public final void rule__XSwitchExpression__CasesAssignment_4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17166:1: ( ( ruleXCasePart ) )
            // InternalXbaseWithAnnotations.g:17167:2: ( ruleXCasePart )
            {
            // InternalXbaseWithAnnotations.g:17167:2: ( ruleXCasePart )
            // InternalXbaseWithAnnotations.g:17168:3: ruleXCasePart
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getCasesXCasePartParserRuleCall_4_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXCasePart();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getCasesXCasePartParserRuleCall_4_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__CasesAssignment_4"


    // $ANTLR start "rule__XSwitchExpression__DefaultAssignment_5_2"
    // InternalXbaseWithAnnotations.g:17177:1: rule__XSwitchExpression__DefaultAssignment_5_2 : ( ruleXExpression ) ;
    public final void rule__XSwitchExpression__DefaultAssignment_5_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17181:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17182:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17182:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17183:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSwitchExpressionAccess().getDefaultXExpressionParserRuleCall_5_2_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSwitchExpressionAccess().getDefaultXExpressionParserRuleCall_5_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSwitchExpression__DefaultAssignment_5_2"


    // $ANTLR start "rule__XCasePart__TypeGuardAssignment_1"
    // InternalXbaseWithAnnotations.g:17192:1: rule__XCasePart__TypeGuardAssignment_1 : ( ruleJvmTypeReference ) ;
    public final void rule__XCasePart__TypeGuardAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17196:1: ( ( ruleJvmTypeReference ) )
            // InternalXbaseWithAnnotations.g:17197:2: ( ruleJvmTypeReference )
            {
            // InternalXbaseWithAnnotations.g:17197:2: ( ruleJvmTypeReference )
            // InternalXbaseWithAnnotations.g:17198:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getTypeGuardJvmTypeReferenceParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getTypeGuardJvmTypeReferenceParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__TypeGuardAssignment_1"


    // $ANTLR start "rule__XCasePart__CaseAssignment_2_1"
    // InternalXbaseWithAnnotations.g:17207:1: rule__XCasePart__CaseAssignment_2_1 : ( ruleXExpression ) ;
    public final void rule__XCasePart__CaseAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17211:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17212:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17212:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17213:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getCaseXExpressionParserRuleCall_2_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getCaseXExpressionParserRuleCall_2_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__CaseAssignment_2_1"


    // $ANTLR start "rule__XCasePart__ThenAssignment_3_0_1"
    // InternalXbaseWithAnnotations.g:17222:1: rule__XCasePart__ThenAssignment_3_0_1 : ( ruleXExpression ) ;
    public final void rule__XCasePart__ThenAssignment_3_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17226:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17227:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17227:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17228:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getThenXExpressionParserRuleCall_3_0_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getThenXExpressionParserRuleCall_3_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__ThenAssignment_3_0_1"


    // $ANTLR start "rule__XCasePart__FallThroughAssignment_3_1"
    // InternalXbaseWithAnnotations.g:17237:1: rule__XCasePart__FallThroughAssignment_3_1 : ( ( ',' ) ) ;
    public final void rule__XCasePart__FallThroughAssignment_3_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17241:1: ( ( ( ',' ) ) )
            // InternalXbaseWithAnnotations.g:17242:2: ( ( ',' ) )
            {
            // InternalXbaseWithAnnotations.g:17242:2: ( ( ',' ) )
            // InternalXbaseWithAnnotations.g:17243:3: ( ',' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getFallThroughCommaKeyword_3_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:17244:3: ( ',' )
            // InternalXbaseWithAnnotations.g:17245:4: ','
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCasePartAccess().getFallThroughCommaKeyword_3_1_0()); 
            }
            match(input,54,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getFallThroughCommaKeyword_3_1_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCasePartAccess().getFallThroughCommaKeyword_3_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCasePart__FallThroughAssignment_3_1"


    // $ANTLR start "rule__XForLoopExpression__DeclaredParamAssignment_0_0_3"
    // InternalXbaseWithAnnotations.g:17256:1: rule__XForLoopExpression__DeclaredParamAssignment_0_0_3 : ( ruleJvmFormalParameter ) ;
    public final void rule__XForLoopExpression__DeclaredParamAssignment_0_0_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17260:1: ( ( ruleJvmFormalParameter ) )
            // InternalXbaseWithAnnotations.g:17261:2: ( ruleJvmFormalParameter )
            {
            // InternalXbaseWithAnnotations.g:17261:2: ( ruleJvmFormalParameter )
            // InternalXbaseWithAnnotations.g:17262:3: ruleJvmFormalParameter
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getDeclaredParamJvmFormalParameterParserRuleCall_0_0_3_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmFormalParameter();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getDeclaredParamJvmFormalParameterParserRuleCall_0_0_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__DeclaredParamAssignment_0_0_3"


    // $ANTLR start "rule__XForLoopExpression__ForExpressionAssignment_1"
    // InternalXbaseWithAnnotations.g:17271:1: rule__XForLoopExpression__ForExpressionAssignment_1 : ( ruleXExpression ) ;
    public final void rule__XForLoopExpression__ForExpressionAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17275:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17276:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17276:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17277:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getForExpressionXExpressionParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getForExpressionXExpressionParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__ForExpressionAssignment_1"


    // $ANTLR start "rule__XForLoopExpression__EachExpressionAssignment_3"
    // InternalXbaseWithAnnotations.g:17286:1: rule__XForLoopExpression__EachExpressionAssignment_3 : ( ruleXExpression ) ;
    public final void rule__XForLoopExpression__EachExpressionAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17290:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17291:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17291:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17292:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXForLoopExpressionAccess().getEachExpressionXExpressionParserRuleCall_3_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXForLoopExpressionAccess().getEachExpressionXExpressionParserRuleCall_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XForLoopExpression__EachExpressionAssignment_3"


    // $ANTLR start "rule__XBasicForLoopExpression__InitExpressionsAssignment_3_0"
    // InternalXbaseWithAnnotations.g:17301:1: rule__XBasicForLoopExpression__InitExpressionsAssignment_3_0 : ( ruleXExpressionOrVarDeclaration ) ;
    public final void rule__XBasicForLoopExpression__InitExpressionsAssignment_3_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17305:1: ( ( ruleXExpressionOrVarDeclaration ) )
            // InternalXbaseWithAnnotations.g:17306:2: ( ruleXExpressionOrVarDeclaration )
            {
            // InternalXbaseWithAnnotations.g:17306:2: ( ruleXExpressionOrVarDeclaration )
            // InternalXbaseWithAnnotations.g:17307:3: ruleXExpressionOrVarDeclaration
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getInitExpressionsXExpressionOrVarDeclarationParserRuleCall_3_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpressionOrVarDeclaration();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getInitExpressionsXExpressionOrVarDeclarationParserRuleCall_3_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__InitExpressionsAssignment_3_0"


    // $ANTLR start "rule__XBasicForLoopExpression__InitExpressionsAssignment_3_1_1"
    // InternalXbaseWithAnnotations.g:17316:1: rule__XBasicForLoopExpression__InitExpressionsAssignment_3_1_1 : ( ruleXExpressionOrVarDeclaration ) ;
    public final void rule__XBasicForLoopExpression__InitExpressionsAssignment_3_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17320:1: ( ( ruleXExpressionOrVarDeclaration ) )
            // InternalXbaseWithAnnotations.g:17321:2: ( ruleXExpressionOrVarDeclaration )
            {
            // InternalXbaseWithAnnotations.g:17321:2: ( ruleXExpressionOrVarDeclaration )
            // InternalXbaseWithAnnotations.g:17322:3: ruleXExpressionOrVarDeclaration
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getInitExpressionsXExpressionOrVarDeclarationParserRuleCall_3_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpressionOrVarDeclaration();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getInitExpressionsXExpressionOrVarDeclarationParserRuleCall_3_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__InitExpressionsAssignment_3_1_1"


    // $ANTLR start "rule__XBasicForLoopExpression__ExpressionAssignment_5"
    // InternalXbaseWithAnnotations.g:17331:1: rule__XBasicForLoopExpression__ExpressionAssignment_5 : ( ruleXExpression ) ;
    public final void rule__XBasicForLoopExpression__ExpressionAssignment_5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17335:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17336:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17336:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17337:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getExpressionXExpressionParserRuleCall_5_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getExpressionXExpressionParserRuleCall_5_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__ExpressionAssignment_5"


    // $ANTLR start "rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_0"
    // InternalXbaseWithAnnotations.g:17346:1: rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_0 : ( ruleXExpression ) ;
    public final void rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17350:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17351:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17351:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17352:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getUpdateExpressionsXExpressionParserRuleCall_7_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getUpdateExpressionsXExpressionParserRuleCall_7_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_0"


    // $ANTLR start "rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_1_1"
    // InternalXbaseWithAnnotations.g:17361:1: rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_1_1 : ( ruleXExpression ) ;
    public final void rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17365:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17366:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17366:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17367:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getUpdateExpressionsXExpressionParserRuleCall_7_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getUpdateExpressionsXExpressionParserRuleCall_7_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__UpdateExpressionsAssignment_7_1_1"


    // $ANTLR start "rule__XBasicForLoopExpression__EachExpressionAssignment_9"
    // InternalXbaseWithAnnotations.g:17376:1: rule__XBasicForLoopExpression__EachExpressionAssignment_9 : ( ruleXExpression ) ;
    public final void rule__XBasicForLoopExpression__EachExpressionAssignment_9() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17380:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17381:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17381:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17382:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBasicForLoopExpressionAccess().getEachExpressionXExpressionParserRuleCall_9_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBasicForLoopExpressionAccess().getEachExpressionXExpressionParserRuleCall_9_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBasicForLoopExpression__EachExpressionAssignment_9"


    // $ANTLR start "rule__XWhileExpression__PredicateAssignment_3"
    // InternalXbaseWithAnnotations.g:17391:1: rule__XWhileExpression__PredicateAssignment_3 : ( ruleXExpression ) ;
    public final void rule__XWhileExpression__PredicateAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17395:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17396:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17396:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17397:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXWhileExpressionAccess().getPredicateXExpressionParserRuleCall_3_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXWhileExpressionAccess().getPredicateXExpressionParserRuleCall_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__PredicateAssignment_3"


    // $ANTLR start "rule__XWhileExpression__BodyAssignment_5"
    // InternalXbaseWithAnnotations.g:17406:1: rule__XWhileExpression__BodyAssignment_5 : ( ruleXExpression ) ;
    public final void rule__XWhileExpression__BodyAssignment_5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17410:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17411:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17411:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17412:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXWhileExpressionAccess().getBodyXExpressionParserRuleCall_5_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXWhileExpressionAccess().getBodyXExpressionParserRuleCall_5_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XWhileExpression__BodyAssignment_5"


    // $ANTLR start "rule__XDoWhileExpression__BodyAssignment_2"
    // InternalXbaseWithAnnotations.g:17421:1: rule__XDoWhileExpression__BodyAssignment_2 : ( ruleXExpression ) ;
    public final void rule__XDoWhileExpression__BodyAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17425:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17426:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17426:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17427:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXDoWhileExpressionAccess().getBodyXExpressionParserRuleCall_2_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXDoWhileExpressionAccess().getBodyXExpressionParserRuleCall_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__BodyAssignment_2"


    // $ANTLR start "rule__XDoWhileExpression__PredicateAssignment_5"
    // InternalXbaseWithAnnotations.g:17436:1: rule__XDoWhileExpression__PredicateAssignment_5 : ( ruleXExpression ) ;
    public final void rule__XDoWhileExpression__PredicateAssignment_5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17440:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17441:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17441:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17442:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXDoWhileExpressionAccess().getPredicateXExpressionParserRuleCall_5_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXDoWhileExpressionAccess().getPredicateXExpressionParserRuleCall_5_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XDoWhileExpression__PredicateAssignment_5"


    // $ANTLR start "rule__XBlockExpression__ExpressionsAssignment_2_0"
    // InternalXbaseWithAnnotations.g:17451:1: rule__XBlockExpression__ExpressionsAssignment_2_0 : ( ruleXExpressionOrVarDeclaration ) ;
    public final void rule__XBlockExpression__ExpressionsAssignment_2_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17455:1: ( ( ruleXExpressionOrVarDeclaration ) )
            // InternalXbaseWithAnnotations.g:17456:2: ( ruleXExpressionOrVarDeclaration )
            {
            // InternalXbaseWithAnnotations.g:17456:2: ( ruleXExpressionOrVarDeclaration )
            // InternalXbaseWithAnnotations.g:17457:3: ruleXExpressionOrVarDeclaration
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBlockExpressionAccess().getExpressionsXExpressionOrVarDeclarationParserRuleCall_2_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpressionOrVarDeclaration();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBlockExpressionAccess().getExpressionsXExpressionOrVarDeclarationParserRuleCall_2_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBlockExpression__ExpressionsAssignment_2_0"


    // $ANTLR start "rule__XVariableDeclaration__WriteableAssignment_1_0"
    // InternalXbaseWithAnnotations.g:17466:1: rule__XVariableDeclaration__WriteableAssignment_1_0 : ( ( 'var' ) ) ;
    public final void rule__XVariableDeclaration__WriteableAssignment_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17470:1: ( ( ( 'var' ) ) )
            // InternalXbaseWithAnnotations.g:17471:2: ( ( 'var' ) )
            {
            // InternalXbaseWithAnnotations.g:17471:2: ( ( 'var' ) )
            // InternalXbaseWithAnnotations.g:17472:3: ( 'var' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getWriteableVarKeyword_1_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:17473:3: ( 'var' )
            // InternalXbaseWithAnnotations.g:17474:4: 'var'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getWriteableVarKeyword_1_0_0()); 
            }
            match(input,86,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getWriteableVarKeyword_1_0_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getWriteableVarKeyword_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__WriteableAssignment_1_0"


    // $ANTLR start "rule__XVariableDeclaration__TypeAssignment_2_0_0_0"
    // InternalXbaseWithAnnotations.g:17485:1: rule__XVariableDeclaration__TypeAssignment_2_0_0_0 : ( ruleJvmTypeReference ) ;
    public final void rule__XVariableDeclaration__TypeAssignment_2_0_0_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17489:1: ( ( ruleJvmTypeReference ) )
            // InternalXbaseWithAnnotations.g:17490:2: ( ruleJvmTypeReference )
            {
            // InternalXbaseWithAnnotations.g:17490:2: ( ruleJvmTypeReference )
            // InternalXbaseWithAnnotations.g:17491:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getTypeJvmTypeReferenceParserRuleCall_2_0_0_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getTypeJvmTypeReferenceParserRuleCall_2_0_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__TypeAssignment_2_0_0_0"


    // $ANTLR start "rule__XVariableDeclaration__NameAssignment_2_0_0_1"
    // InternalXbaseWithAnnotations.g:17500:1: rule__XVariableDeclaration__NameAssignment_2_0_0_1 : ( ruleValidID ) ;
    public final void rule__XVariableDeclaration__NameAssignment_2_0_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17504:1: ( ( ruleValidID ) )
            // InternalXbaseWithAnnotations.g:17505:2: ( ruleValidID )
            {
            // InternalXbaseWithAnnotations.g:17505:2: ( ruleValidID )
            // InternalXbaseWithAnnotations.g:17506:3: ruleValidID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getNameValidIDParserRuleCall_2_0_0_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleValidID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getNameValidIDParserRuleCall_2_0_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__NameAssignment_2_0_0_1"


    // $ANTLR start "rule__XVariableDeclaration__NameAssignment_2_1"
    // InternalXbaseWithAnnotations.g:17515:1: rule__XVariableDeclaration__NameAssignment_2_1 : ( ruleValidID ) ;
    public final void rule__XVariableDeclaration__NameAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17519:1: ( ( ruleValidID ) )
            // InternalXbaseWithAnnotations.g:17520:2: ( ruleValidID )
            {
            // InternalXbaseWithAnnotations.g:17520:2: ( ruleValidID )
            // InternalXbaseWithAnnotations.g:17521:3: ruleValidID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getNameValidIDParserRuleCall_2_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleValidID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getNameValidIDParserRuleCall_2_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__NameAssignment_2_1"


    // $ANTLR start "rule__XVariableDeclaration__RightAssignment_3_1"
    // InternalXbaseWithAnnotations.g:17530:1: rule__XVariableDeclaration__RightAssignment_3_1 : ( ruleXExpression ) ;
    public final void rule__XVariableDeclaration__RightAssignment_3_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17534:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17535:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17535:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17536:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXVariableDeclarationAccess().getRightXExpressionParserRuleCall_3_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXVariableDeclarationAccess().getRightXExpressionParserRuleCall_3_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XVariableDeclaration__RightAssignment_3_1"


    // $ANTLR start "rule__JvmFormalParameter__ParameterTypeAssignment_0"
    // InternalXbaseWithAnnotations.g:17545:1: rule__JvmFormalParameter__ParameterTypeAssignment_0 : ( ruleJvmTypeReference ) ;
    public final void rule__JvmFormalParameter__ParameterTypeAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17549:1: ( ( ruleJvmTypeReference ) )
            // InternalXbaseWithAnnotations.g:17550:2: ( ruleJvmTypeReference )
            {
            // InternalXbaseWithAnnotations.g:17550:2: ( ruleJvmTypeReference )
            // InternalXbaseWithAnnotations.g:17551:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmFormalParameterAccess().getParameterTypeJvmTypeReferenceParserRuleCall_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmFormalParameterAccess().getParameterTypeJvmTypeReferenceParserRuleCall_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmFormalParameter__ParameterTypeAssignment_0"


    // $ANTLR start "rule__JvmFormalParameter__NameAssignment_1"
    // InternalXbaseWithAnnotations.g:17560:1: rule__JvmFormalParameter__NameAssignment_1 : ( ruleValidID ) ;
    public final void rule__JvmFormalParameter__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17564:1: ( ( ruleValidID ) )
            // InternalXbaseWithAnnotations.g:17565:2: ( ruleValidID )
            {
            // InternalXbaseWithAnnotations.g:17565:2: ( ruleValidID )
            // InternalXbaseWithAnnotations.g:17566:3: ruleValidID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmFormalParameterAccess().getNameValidIDParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleValidID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmFormalParameterAccess().getNameValidIDParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmFormalParameter__NameAssignment_1"


    // $ANTLR start "rule__FullJvmFormalParameter__ParameterTypeAssignment_0"
    // InternalXbaseWithAnnotations.g:17575:1: rule__FullJvmFormalParameter__ParameterTypeAssignment_0 : ( ruleJvmTypeReference ) ;
    public final void rule__FullJvmFormalParameter__ParameterTypeAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17579:1: ( ( ruleJvmTypeReference ) )
            // InternalXbaseWithAnnotations.g:17580:2: ( ruleJvmTypeReference )
            {
            // InternalXbaseWithAnnotations.g:17580:2: ( ruleJvmTypeReference )
            // InternalXbaseWithAnnotations.g:17581:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getFullJvmFormalParameterAccess().getParameterTypeJvmTypeReferenceParserRuleCall_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getFullJvmFormalParameterAccess().getParameterTypeJvmTypeReferenceParserRuleCall_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullJvmFormalParameter__ParameterTypeAssignment_0"


    // $ANTLR start "rule__FullJvmFormalParameter__NameAssignment_1"
    // InternalXbaseWithAnnotations.g:17590:1: rule__FullJvmFormalParameter__NameAssignment_1 : ( ruleValidID ) ;
    public final void rule__FullJvmFormalParameter__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17594:1: ( ( ruleValidID ) )
            // InternalXbaseWithAnnotations.g:17595:2: ( ruleValidID )
            {
            // InternalXbaseWithAnnotations.g:17595:2: ( ruleValidID )
            // InternalXbaseWithAnnotations.g:17596:3: ruleValidID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getFullJvmFormalParameterAccess().getNameValidIDParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleValidID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getFullJvmFormalParameterAccess().getNameValidIDParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullJvmFormalParameter__NameAssignment_1"


    // $ANTLR start "rule__XFeatureCall__TypeArgumentsAssignment_1_1"
    // InternalXbaseWithAnnotations.g:17605:1: rule__XFeatureCall__TypeArgumentsAssignment_1_1 : ( ruleJvmArgumentTypeReference ) ;
    public final void rule__XFeatureCall__TypeArgumentsAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17609:1: ( ( ruleJvmArgumentTypeReference ) )
            // InternalXbaseWithAnnotations.g:17610:2: ( ruleJvmArgumentTypeReference )
            {
            // InternalXbaseWithAnnotations.g:17610:2: ( ruleJvmArgumentTypeReference )
            // InternalXbaseWithAnnotations.g:17611:3: ruleJvmArgumentTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmArgumentTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__TypeArgumentsAssignment_1_1"


    // $ANTLR start "rule__XFeatureCall__TypeArgumentsAssignment_1_2_1"
    // InternalXbaseWithAnnotations.g:17620:1: rule__XFeatureCall__TypeArgumentsAssignment_1_2_1 : ( ruleJvmArgumentTypeReference ) ;
    public final void rule__XFeatureCall__TypeArgumentsAssignment_1_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17624:1: ( ( ruleJvmArgumentTypeReference ) )
            // InternalXbaseWithAnnotations.g:17625:2: ( ruleJvmArgumentTypeReference )
            {
            // InternalXbaseWithAnnotations.g:17625:2: ( ruleJvmArgumentTypeReference )
            // InternalXbaseWithAnnotations.g:17626:3: ruleJvmArgumentTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_1_2_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmArgumentTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_1_2_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__TypeArgumentsAssignment_1_2_1"


    // $ANTLR start "rule__XFeatureCall__FeatureAssignment_2"
    // InternalXbaseWithAnnotations.g:17635:1: rule__XFeatureCall__FeatureAssignment_2 : ( ( ruleIdOrSuper ) ) ;
    public final void rule__XFeatureCall__FeatureAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17639:1: ( ( ( ruleIdOrSuper ) ) )
            // InternalXbaseWithAnnotations.g:17640:2: ( ( ruleIdOrSuper ) )
            {
            // InternalXbaseWithAnnotations.g:17640:2: ( ( ruleIdOrSuper ) )
            // InternalXbaseWithAnnotations.g:17641:3: ( ruleIdOrSuper )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getFeatureJvmIdentifiableElementCrossReference_2_0()); 
            }
            // InternalXbaseWithAnnotations.g:17642:3: ( ruleIdOrSuper )
            // InternalXbaseWithAnnotations.g:17643:4: ruleIdOrSuper
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getFeatureJvmIdentifiableElementIdOrSuperParserRuleCall_2_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleIdOrSuper();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getFeatureJvmIdentifiableElementIdOrSuperParserRuleCall_2_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getFeatureJvmIdentifiableElementCrossReference_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__FeatureAssignment_2"


    // $ANTLR start "rule__XFeatureCall__ExplicitOperationCallAssignment_3_0"
    // InternalXbaseWithAnnotations.g:17654:1: rule__XFeatureCall__ExplicitOperationCallAssignment_3_0 : ( ( '(' ) ) ;
    public final void rule__XFeatureCall__ExplicitOperationCallAssignment_3_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17658:1: ( ( ( '(' ) ) )
            // InternalXbaseWithAnnotations.g:17659:2: ( ( '(' ) )
            {
            // InternalXbaseWithAnnotations.g:17659:2: ( ( '(' ) )
            // InternalXbaseWithAnnotations.g:17660:3: ( '(' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getExplicitOperationCallLeftParenthesisKeyword_3_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:17661:3: ( '(' )
            // InternalXbaseWithAnnotations.g:17662:4: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getExplicitOperationCallLeftParenthesisKeyword_3_0_0()); 
            }
            match(input,52,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getExplicitOperationCallLeftParenthesisKeyword_3_0_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getExplicitOperationCallLeftParenthesisKeyword_3_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__ExplicitOperationCallAssignment_3_0"


    // $ANTLR start "rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0"
    // InternalXbaseWithAnnotations.g:17673:1: rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 : ( ruleXShortClosure ) ;
    public final void rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17677:1: ( ( ruleXShortClosure ) )
            // InternalXbaseWithAnnotations.g:17678:2: ( ruleXShortClosure )
            {
            // InternalXbaseWithAnnotations.g:17678:2: ( ruleXShortClosure )
            // InternalXbaseWithAnnotations.g:17679:3: ruleXShortClosure
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsXShortClosureParserRuleCall_3_1_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXShortClosure();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsXShortClosureParserRuleCall_3_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0"


    // $ANTLR start "rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_0"
    // InternalXbaseWithAnnotations.g:17688:1: rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_0 : ( ruleXExpression ) ;
    public final void rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17692:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17693:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17693:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17694:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsXExpressionParserRuleCall_3_1_1_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsXExpressionParserRuleCall_3_1_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_0"


    // $ANTLR start "rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_1_1"
    // InternalXbaseWithAnnotations.g:17703:1: rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_1_1 : ( ruleXExpression ) ;
    public final void rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17707:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17708:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17708:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17709:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsXExpressionParserRuleCall_3_1_1_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsXExpressionParserRuleCall_3_1_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_1_1_1"


    // $ANTLR start "rule__XFeatureCall__FeatureCallArgumentsAssignment_4"
    // InternalXbaseWithAnnotations.g:17718:1: rule__XFeatureCall__FeatureCallArgumentsAssignment_4 : ( ruleXClosure ) ;
    public final void rule__XFeatureCall__FeatureCallArgumentsAssignment_4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17722:1: ( ( ruleXClosure ) )
            // InternalXbaseWithAnnotations.g:17723:2: ( ruleXClosure )
            {
            // InternalXbaseWithAnnotations.g:17723:2: ( ruleXClosure )
            // InternalXbaseWithAnnotations.g:17724:3: ruleXClosure
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsXClosureParserRuleCall_4_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXClosure();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsXClosureParserRuleCall_4_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFeatureCall__FeatureCallArgumentsAssignment_4"


    // $ANTLR start "rule__XConstructorCall__ConstructorAssignment_2"
    // InternalXbaseWithAnnotations.g:17733:1: rule__XConstructorCall__ConstructorAssignment_2 : ( ( ruleQualifiedName ) ) ;
    public final void rule__XConstructorCall__ConstructorAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17737:1: ( ( ( ruleQualifiedName ) ) )
            // InternalXbaseWithAnnotations.g:17738:2: ( ( ruleQualifiedName ) )
            {
            // InternalXbaseWithAnnotations.g:17738:2: ( ( ruleQualifiedName ) )
            // InternalXbaseWithAnnotations.g:17739:3: ( ruleQualifiedName )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getConstructorJvmConstructorCrossReference_2_0()); 
            }
            // InternalXbaseWithAnnotations.g:17740:3: ( ruleQualifiedName )
            // InternalXbaseWithAnnotations.g:17741:4: ruleQualifiedName
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getConstructorJvmConstructorQualifiedNameParserRuleCall_2_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleQualifiedName();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getConstructorJvmConstructorQualifiedNameParserRuleCall_2_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getConstructorJvmConstructorCrossReference_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__ConstructorAssignment_2"


    // $ANTLR start "rule__XConstructorCall__TypeArgumentsAssignment_3_1"
    // InternalXbaseWithAnnotations.g:17752:1: rule__XConstructorCall__TypeArgumentsAssignment_3_1 : ( ruleJvmArgumentTypeReference ) ;
    public final void rule__XConstructorCall__TypeArgumentsAssignment_3_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17756:1: ( ( ruleJvmArgumentTypeReference ) )
            // InternalXbaseWithAnnotations.g:17757:2: ( ruleJvmArgumentTypeReference )
            {
            // InternalXbaseWithAnnotations.g:17757:2: ( ruleJvmArgumentTypeReference )
            // InternalXbaseWithAnnotations.g:17758:3: ruleJvmArgumentTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_3_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmArgumentTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_3_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__TypeArgumentsAssignment_3_1"


    // $ANTLR start "rule__XConstructorCall__TypeArgumentsAssignment_3_2_1"
    // InternalXbaseWithAnnotations.g:17767:1: rule__XConstructorCall__TypeArgumentsAssignment_3_2_1 : ( ruleJvmArgumentTypeReference ) ;
    public final void rule__XConstructorCall__TypeArgumentsAssignment_3_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17771:1: ( ( ruleJvmArgumentTypeReference ) )
            // InternalXbaseWithAnnotations.g:17772:2: ( ruleJvmArgumentTypeReference )
            {
            // InternalXbaseWithAnnotations.g:17772:2: ( ruleJvmArgumentTypeReference )
            // InternalXbaseWithAnnotations.g:17773:3: ruleJvmArgumentTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_3_2_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmArgumentTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getTypeArgumentsJvmArgumentTypeReferenceParserRuleCall_3_2_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__TypeArgumentsAssignment_3_2_1"


    // $ANTLR start "rule__XConstructorCall__ExplicitConstructorCallAssignment_4_0"
    // InternalXbaseWithAnnotations.g:17782:1: rule__XConstructorCall__ExplicitConstructorCallAssignment_4_0 : ( ( '(' ) ) ;
    public final void rule__XConstructorCall__ExplicitConstructorCallAssignment_4_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17786:1: ( ( ( '(' ) ) )
            // InternalXbaseWithAnnotations.g:17787:2: ( ( '(' ) )
            {
            // InternalXbaseWithAnnotations.g:17787:2: ( ( '(' ) )
            // InternalXbaseWithAnnotations.g:17788:3: ( '(' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getExplicitConstructorCallLeftParenthesisKeyword_4_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:17789:3: ( '(' )
            // InternalXbaseWithAnnotations.g:17790:4: '('
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getExplicitConstructorCallLeftParenthesisKeyword_4_0_0()); 
            }
            match(input,52,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getExplicitConstructorCallLeftParenthesisKeyword_4_0_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getExplicitConstructorCallLeftParenthesisKeyword_4_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__ExplicitConstructorCallAssignment_4_0"


    // $ANTLR start "rule__XConstructorCall__ArgumentsAssignment_4_1_0"
    // InternalXbaseWithAnnotations.g:17801:1: rule__XConstructorCall__ArgumentsAssignment_4_1_0 : ( ruleXShortClosure ) ;
    public final void rule__XConstructorCall__ArgumentsAssignment_4_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17805:1: ( ( ruleXShortClosure ) )
            // InternalXbaseWithAnnotations.g:17806:2: ( ruleXShortClosure )
            {
            // InternalXbaseWithAnnotations.g:17806:2: ( ruleXShortClosure )
            // InternalXbaseWithAnnotations.g:17807:3: ruleXShortClosure
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getArgumentsXShortClosureParserRuleCall_4_1_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXShortClosure();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getArgumentsXShortClosureParserRuleCall_4_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__ArgumentsAssignment_4_1_0"


    // $ANTLR start "rule__XConstructorCall__ArgumentsAssignment_4_1_1_0"
    // InternalXbaseWithAnnotations.g:17816:1: rule__XConstructorCall__ArgumentsAssignment_4_1_1_0 : ( ruleXExpression ) ;
    public final void rule__XConstructorCall__ArgumentsAssignment_4_1_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17820:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17821:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17821:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17822:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getArgumentsXExpressionParserRuleCall_4_1_1_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getArgumentsXExpressionParserRuleCall_4_1_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__ArgumentsAssignment_4_1_1_0"


    // $ANTLR start "rule__XConstructorCall__ArgumentsAssignment_4_1_1_1_1"
    // InternalXbaseWithAnnotations.g:17831:1: rule__XConstructorCall__ArgumentsAssignment_4_1_1_1_1 : ( ruleXExpression ) ;
    public final void rule__XConstructorCall__ArgumentsAssignment_4_1_1_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17835:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17836:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17836:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17837:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getArgumentsXExpressionParserRuleCall_4_1_1_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getArgumentsXExpressionParserRuleCall_4_1_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__ArgumentsAssignment_4_1_1_1_1"


    // $ANTLR start "rule__XConstructorCall__ArgumentsAssignment_5"
    // InternalXbaseWithAnnotations.g:17846:1: rule__XConstructorCall__ArgumentsAssignment_5 : ( ruleXClosure ) ;
    public final void rule__XConstructorCall__ArgumentsAssignment_5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17850:1: ( ( ruleXClosure ) )
            // InternalXbaseWithAnnotations.g:17851:2: ( ruleXClosure )
            {
            // InternalXbaseWithAnnotations.g:17851:2: ( ruleXClosure )
            // InternalXbaseWithAnnotations.g:17852:3: ruleXClosure
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXConstructorCallAccess().getArgumentsXClosureParserRuleCall_5_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXClosure();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXConstructorCallAccess().getArgumentsXClosureParserRuleCall_5_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XConstructorCall__ArgumentsAssignment_5"


    // $ANTLR start "rule__XBooleanLiteral__IsTrueAssignment_1_1"
    // InternalXbaseWithAnnotations.g:17861:1: rule__XBooleanLiteral__IsTrueAssignment_1_1 : ( ( 'true' ) ) ;
    public final void rule__XBooleanLiteral__IsTrueAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17865:1: ( ( ( 'true' ) ) )
            // InternalXbaseWithAnnotations.g:17866:2: ( ( 'true' ) )
            {
            // InternalXbaseWithAnnotations.g:17866:2: ( ( 'true' ) )
            // InternalXbaseWithAnnotations.g:17867:3: ( 'true' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBooleanLiteralAccess().getIsTrueTrueKeyword_1_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:17868:3: ( 'true' )
            // InternalXbaseWithAnnotations.g:17869:4: 'true'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXBooleanLiteralAccess().getIsTrueTrueKeyword_1_1_0()); 
            }
            match(input,87,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBooleanLiteralAccess().getIsTrueTrueKeyword_1_1_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXBooleanLiteralAccess().getIsTrueTrueKeyword_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XBooleanLiteral__IsTrueAssignment_1_1"


    // $ANTLR start "rule__XNumberLiteral__ValueAssignment_1"
    // InternalXbaseWithAnnotations.g:17880:1: rule__XNumberLiteral__ValueAssignment_1 : ( ruleNumber ) ;
    public final void rule__XNumberLiteral__ValueAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17884:1: ( ( ruleNumber ) )
            // InternalXbaseWithAnnotations.g:17885:2: ( ruleNumber )
            {
            // InternalXbaseWithAnnotations.g:17885:2: ( ruleNumber )
            // InternalXbaseWithAnnotations.g:17886:3: ruleNumber
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXNumberLiteralAccess().getValueNumberParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleNumber();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXNumberLiteralAccess().getValueNumberParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XNumberLiteral__ValueAssignment_1"


    // $ANTLR start "rule__XStringLiteral__ValueAssignment_1"
    // InternalXbaseWithAnnotations.g:17895:1: rule__XStringLiteral__ValueAssignment_1 : ( RULE_STRING ) ;
    public final void rule__XStringLiteral__ValueAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17899:1: ( ( RULE_STRING ) )
            // InternalXbaseWithAnnotations.g:17900:2: ( RULE_STRING )
            {
            // InternalXbaseWithAnnotations.g:17900:2: ( RULE_STRING )
            // InternalXbaseWithAnnotations.g:17901:3: RULE_STRING
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXStringLiteralAccess().getValueSTRINGTerminalRuleCall_1_0()); 
            }
            match(input,RULE_STRING,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXStringLiteralAccess().getValueSTRINGTerminalRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XStringLiteral__ValueAssignment_1"


    // $ANTLR start "rule__XTypeLiteral__TypeAssignment_3"
    // InternalXbaseWithAnnotations.g:17910:1: rule__XTypeLiteral__TypeAssignment_3 : ( ( ruleQualifiedName ) ) ;
    public final void rule__XTypeLiteral__TypeAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17914:1: ( ( ( ruleQualifiedName ) ) )
            // InternalXbaseWithAnnotations.g:17915:2: ( ( ruleQualifiedName ) )
            {
            // InternalXbaseWithAnnotations.g:17915:2: ( ( ruleQualifiedName ) )
            // InternalXbaseWithAnnotations.g:17916:3: ( ruleQualifiedName )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTypeLiteralAccess().getTypeJvmTypeCrossReference_3_0()); 
            }
            // InternalXbaseWithAnnotations.g:17917:3: ( ruleQualifiedName )
            // InternalXbaseWithAnnotations.g:17918:4: ruleQualifiedName
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTypeLiteralAccess().getTypeJvmTypeQualifiedNameParserRuleCall_3_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleQualifiedName();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTypeLiteralAccess().getTypeJvmTypeQualifiedNameParserRuleCall_3_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTypeLiteralAccess().getTypeJvmTypeCrossReference_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__TypeAssignment_3"


    // $ANTLR start "rule__XTypeLiteral__ArrayDimensionsAssignment_4"
    // InternalXbaseWithAnnotations.g:17929:1: rule__XTypeLiteral__ArrayDimensionsAssignment_4 : ( ruleArrayBrackets ) ;
    public final void rule__XTypeLiteral__ArrayDimensionsAssignment_4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17933:1: ( ( ruleArrayBrackets ) )
            // InternalXbaseWithAnnotations.g:17934:2: ( ruleArrayBrackets )
            {
            // InternalXbaseWithAnnotations.g:17934:2: ( ruleArrayBrackets )
            // InternalXbaseWithAnnotations.g:17935:3: ruleArrayBrackets
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTypeLiteralAccess().getArrayDimensionsArrayBracketsParserRuleCall_4_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleArrayBrackets();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTypeLiteralAccess().getArrayDimensionsArrayBracketsParserRuleCall_4_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTypeLiteral__ArrayDimensionsAssignment_4"


    // $ANTLR start "rule__XThrowExpression__ExpressionAssignment_2"
    // InternalXbaseWithAnnotations.g:17944:1: rule__XThrowExpression__ExpressionAssignment_2 : ( ruleXExpression ) ;
    public final void rule__XThrowExpression__ExpressionAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17948:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17949:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17949:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17950:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXThrowExpressionAccess().getExpressionXExpressionParserRuleCall_2_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXThrowExpressionAccess().getExpressionXExpressionParserRuleCall_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XThrowExpression__ExpressionAssignment_2"


    // $ANTLR start "rule__XReturnExpression__ExpressionAssignment_2"
    // InternalXbaseWithAnnotations.g:17959:1: rule__XReturnExpression__ExpressionAssignment_2 : ( ruleXExpression ) ;
    public final void rule__XReturnExpression__ExpressionAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17963:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17964:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17964:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17965:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXReturnExpressionAccess().getExpressionXExpressionParserRuleCall_2_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXReturnExpressionAccess().getExpressionXExpressionParserRuleCall_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XReturnExpression__ExpressionAssignment_2"


    // $ANTLR start "rule__XTryCatchFinallyExpression__ExpressionAssignment_2"
    // InternalXbaseWithAnnotations.g:17974:1: rule__XTryCatchFinallyExpression__ExpressionAssignment_2 : ( ruleXExpression ) ;
    public final void rule__XTryCatchFinallyExpression__ExpressionAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17978:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:17979:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:17979:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:17980:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getExpressionXExpressionParserRuleCall_2_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getExpressionXExpressionParserRuleCall_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__ExpressionAssignment_2"


    // $ANTLR start "rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0"
    // InternalXbaseWithAnnotations.g:17989:1: rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0 : ( ruleXCatchClause ) ;
    public final void rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:17993:1: ( ( ruleXCatchClause ) )
            // InternalXbaseWithAnnotations.g:17994:2: ( ruleXCatchClause )
            {
            // InternalXbaseWithAnnotations.g:17994:2: ( ruleXCatchClause )
            // InternalXbaseWithAnnotations.g:17995:3: ruleXCatchClause
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getCatchClausesXCatchClauseParserRuleCall_3_0_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXCatchClause();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getCatchClausesXCatchClauseParserRuleCall_3_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0"


    // $ANTLR start "rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_3_0_1_1"
    // InternalXbaseWithAnnotations.g:18004:1: rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_3_0_1_1 : ( ruleXExpression ) ;
    public final void rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_3_0_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18008:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:18009:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:18009:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:18010:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionXExpressionParserRuleCall_3_0_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionXExpressionParserRuleCall_3_0_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_3_0_1_1"


    // $ANTLR start "rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_3_1_1"
    // InternalXbaseWithAnnotations.g:18019:1: rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_3_1_1 : ( ruleXExpression ) ;
    public final void rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_3_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18023:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:18024:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:18024:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:18025:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionXExpressionParserRuleCall_3_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXTryCatchFinallyExpressionAccess().getFinallyExpressionXExpressionParserRuleCall_3_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XTryCatchFinallyExpression__FinallyExpressionAssignment_3_1_1"


    // $ANTLR start "rule__XSynchronizedExpression__ParamAssignment_1"
    // InternalXbaseWithAnnotations.g:18034:1: rule__XSynchronizedExpression__ParamAssignment_1 : ( ruleXExpression ) ;
    public final void rule__XSynchronizedExpression__ParamAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18038:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:18039:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:18039:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:18040:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSynchronizedExpressionAccess().getParamXExpressionParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSynchronizedExpressionAccess().getParamXExpressionParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__ParamAssignment_1"


    // $ANTLR start "rule__XSynchronizedExpression__ExpressionAssignment_3"
    // InternalXbaseWithAnnotations.g:18049:1: rule__XSynchronizedExpression__ExpressionAssignment_3 : ( ruleXExpression ) ;
    public final void rule__XSynchronizedExpression__ExpressionAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18053:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:18054:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:18054:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:18055:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXSynchronizedExpressionAccess().getExpressionXExpressionParserRuleCall_3_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXSynchronizedExpressionAccess().getExpressionXExpressionParserRuleCall_3_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XSynchronizedExpression__ExpressionAssignment_3"


    // $ANTLR start "rule__XCatchClause__DeclaredParamAssignment_2"
    // InternalXbaseWithAnnotations.g:18064:1: rule__XCatchClause__DeclaredParamAssignment_2 : ( ruleFullJvmFormalParameter ) ;
    public final void rule__XCatchClause__DeclaredParamAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18068:1: ( ( ruleFullJvmFormalParameter ) )
            // InternalXbaseWithAnnotations.g:18069:2: ( ruleFullJvmFormalParameter )
            {
            // InternalXbaseWithAnnotations.g:18069:2: ( ruleFullJvmFormalParameter )
            // InternalXbaseWithAnnotations.g:18070:3: ruleFullJvmFormalParameter
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCatchClauseAccess().getDeclaredParamFullJvmFormalParameterParserRuleCall_2_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleFullJvmFormalParameter();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCatchClauseAccess().getDeclaredParamFullJvmFormalParameterParserRuleCall_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCatchClause__DeclaredParamAssignment_2"


    // $ANTLR start "rule__XCatchClause__ExpressionAssignment_4"
    // InternalXbaseWithAnnotations.g:18079:1: rule__XCatchClause__ExpressionAssignment_4 : ( ruleXExpression ) ;
    public final void rule__XCatchClause__ExpressionAssignment_4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18083:1: ( ( ruleXExpression ) )
            // InternalXbaseWithAnnotations.g:18084:2: ( ruleXExpression )
            {
            // InternalXbaseWithAnnotations.g:18084:2: ( ruleXExpression )
            // InternalXbaseWithAnnotations.g:18085:3: ruleXExpression
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXCatchClauseAccess().getExpressionXExpressionParserRuleCall_4_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleXExpression();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXCatchClauseAccess().getExpressionXExpressionParserRuleCall_4_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XCatchClause__ExpressionAssignment_4"


    // $ANTLR start "rule__XFunctionTypeRef__ParamTypesAssignment_0_1_0"
    // InternalXbaseWithAnnotations.g:18094:1: rule__XFunctionTypeRef__ParamTypesAssignment_0_1_0 : ( ruleJvmTypeReference ) ;
    public final void rule__XFunctionTypeRef__ParamTypesAssignment_0_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18098:1: ( ( ruleJvmTypeReference ) )
            // InternalXbaseWithAnnotations.g:18099:2: ( ruleJvmTypeReference )
            {
            // InternalXbaseWithAnnotations.g:18099:2: ( ruleJvmTypeReference )
            // InternalXbaseWithAnnotations.g:18100:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getParamTypesJvmTypeReferenceParserRuleCall_0_1_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getParamTypesJvmTypeReferenceParserRuleCall_0_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__ParamTypesAssignment_0_1_0"


    // $ANTLR start "rule__XFunctionTypeRef__ParamTypesAssignment_0_1_1_1"
    // InternalXbaseWithAnnotations.g:18109:1: rule__XFunctionTypeRef__ParamTypesAssignment_0_1_1_1 : ( ruleJvmTypeReference ) ;
    public final void rule__XFunctionTypeRef__ParamTypesAssignment_0_1_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18113:1: ( ( ruleJvmTypeReference ) )
            // InternalXbaseWithAnnotations.g:18114:2: ( ruleJvmTypeReference )
            {
            // InternalXbaseWithAnnotations.g:18114:2: ( ruleJvmTypeReference )
            // InternalXbaseWithAnnotations.g:18115:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getParamTypesJvmTypeReferenceParserRuleCall_0_1_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getParamTypesJvmTypeReferenceParserRuleCall_0_1_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__ParamTypesAssignment_0_1_1_1"


    // $ANTLR start "rule__XFunctionTypeRef__ReturnTypeAssignment_2"
    // InternalXbaseWithAnnotations.g:18124:1: rule__XFunctionTypeRef__ReturnTypeAssignment_2 : ( ruleJvmTypeReference ) ;
    public final void rule__XFunctionTypeRef__ReturnTypeAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18128:1: ( ( ruleJvmTypeReference ) )
            // InternalXbaseWithAnnotations.g:18129:2: ( ruleJvmTypeReference )
            {
            // InternalXbaseWithAnnotations.g:18129:2: ( ruleJvmTypeReference )
            // InternalXbaseWithAnnotations.g:18130:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXFunctionTypeRefAccess().getReturnTypeJvmTypeReferenceParserRuleCall_2_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXFunctionTypeRefAccess().getReturnTypeJvmTypeReferenceParserRuleCall_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XFunctionTypeRef__ReturnTypeAssignment_2"


    // $ANTLR start "rule__JvmParameterizedTypeReference__TypeAssignment_0"
    // InternalXbaseWithAnnotations.g:18139:1: rule__JvmParameterizedTypeReference__TypeAssignment_0 : ( ( ruleQualifiedName ) ) ;
    public final void rule__JvmParameterizedTypeReference__TypeAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18143:1: ( ( ( ruleQualifiedName ) ) )
            // InternalXbaseWithAnnotations.g:18144:2: ( ( ruleQualifiedName ) )
            {
            // InternalXbaseWithAnnotations.g:18144:2: ( ( ruleQualifiedName ) )
            // InternalXbaseWithAnnotations.g:18145:3: ( ruleQualifiedName )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeJvmTypeCrossReference_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:18146:3: ( ruleQualifiedName )
            // InternalXbaseWithAnnotations.g:18147:4: ruleQualifiedName
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeJvmTypeQualifiedNameParserRuleCall_0_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleQualifiedName();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeJvmTypeQualifiedNameParserRuleCall_0_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeJvmTypeCrossReference_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__TypeAssignment_0"


    // $ANTLR start "rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_1"
    // InternalXbaseWithAnnotations.g:18158:1: rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_1 : ( ruleJvmArgumentTypeReference ) ;
    public final void rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18162:1: ( ( ruleJvmArgumentTypeReference ) )
            // InternalXbaseWithAnnotations.g:18163:2: ( ruleJvmArgumentTypeReference )
            {
            // InternalXbaseWithAnnotations.g:18163:2: ( ruleJvmArgumentTypeReference )
            // InternalXbaseWithAnnotations.g:18164:3: ruleJvmArgumentTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsJvmArgumentTypeReferenceParserRuleCall_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmArgumentTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsJvmArgumentTypeReferenceParserRuleCall_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_1"


    // $ANTLR start "rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_2_1"
    // InternalXbaseWithAnnotations.g:18173:1: rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_2_1 : ( ruleJvmArgumentTypeReference ) ;
    public final void rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18177:1: ( ( ruleJvmArgumentTypeReference ) )
            // InternalXbaseWithAnnotations.g:18178:2: ( ruleJvmArgumentTypeReference )
            {
            // InternalXbaseWithAnnotations.g:18178:2: ( ruleJvmArgumentTypeReference )
            // InternalXbaseWithAnnotations.g:18179:3: ruleJvmArgumentTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsJvmArgumentTypeReferenceParserRuleCall_1_2_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmArgumentTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsJvmArgumentTypeReferenceParserRuleCall_1_2_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_2_1"


    // $ANTLR start "rule__JvmParameterizedTypeReference__TypeAssignment_1_4_1"
    // InternalXbaseWithAnnotations.g:18188:1: rule__JvmParameterizedTypeReference__TypeAssignment_1_4_1 : ( ( ruleValidID ) ) ;
    public final void rule__JvmParameterizedTypeReference__TypeAssignment_1_4_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18192:1: ( ( ( ruleValidID ) ) )
            // InternalXbaseWithAnnotations.g:18193:2: ( ( ruleValidID ) )
            {
            // InternalXbaseWithAnnotations.g:18193:2: ( ( ruleValidID ) )
            // InternalXbaseWithAnnotations.g:18194:3: ( ruleValidID )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeJvmTypeCrossReference_1_4_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:18195:3: ( ruleValidID )
            // InternalXbaseWithAnnotations.g:18196:4: ruleValidID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeJvmTypeValidIDParserRuleCall_1_4_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleValidID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeJvmTypeValidIDParserRuleCall_1_4_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getTypeJvmTypeCrossReference_1_4_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__TypeAssignment_1_4_1"


    // $ANTLR start "rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_1"
    // InternalXbaseWithAnnotations.g:18207:1: rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_1 : ( ruleJvmArgumentTypeReference ) ;
    public final void rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18211:1: ( ( ruleJvmArgumentTypeReference ) )
            // InternalXbaseWithAnnotations.g:18212:2: ( ruleJvmArgumentTypeReference )
            {
            // InternalXbaseWithAnnotations.g:18212:2: ( ruleJvmArgumentTypeReference )
            // InternalXbaseWithAnnotations.g:18213:3: ruleJvmArgumentTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsJvmArgumentTypeReferenceParserRuleCall_1_4_2_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmArgumentTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsJvmArgumentTypeReferenceParserRuleCall_1_4_2_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_1"


    // $ANTLR start "rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_2_1"
    // InternalXbaseWithAnnotations.g:18222:1: rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_2_1 : ( ruleJvmArgumentTypeReference ) ;
    public final void rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18226:1: ( ( ruleJvmArgumentTypeReference ) )
            // InternalXbaseWithAnnotations.g:18227:2: ( ruleJvmArgumentTypeReference )
            {
            // InternalXbaseWithAnnotations.g:18227:2: ( ruleJvmArgumentTypeReference )
            // InternalXbaseWithAnnotations.g:18228:3: ruleJvmArgumentTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsJvmArgumentTypeReferenceParserRuleCall_1_4_2_2_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmArgumentTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmParameterizedTypeReferenceAccess().getArgumentsJvmArgumentTypeReferenceParserRuleCall_1_4_2_2_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmParameterizedTypeReference__ArgumentsAssignment_1_4_2_2_1"


    // $ANTLR start "rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_0"
    // InternalXbaseWithAnnotations.g:18237:1: rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_0 : ( ruleJvmUpperBound ) ;
    public final void rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18241:1: ( ( ruleJvmUpperBound ) )
            // InternalXbaseWithAnnotations.g:18242:2: ( ruleJvmUpperBound )
            {
            // InternalXbaseWithAnnotations.g:18242:2: ( ruleJvmUpperBound )
            // InternalXbaseWithAnnotations.g:18243:3: ruleJvmUpperBound
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsJvmUpperBoundParserRuleCall_2_0_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmUpperBound();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsJvmUpperBoundParserRuleCall_2_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_0"


    // $ANTLR start "rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_1"
    // InternalXbaseWithAnnotations.g:18252:1: rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_1 : ( ruleJvmUpperBoundAnded ) ;
    public final void rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18256:1: ( ( ruleJvmUpperBoundAnded ) )
            // InternalXbaseWithAnnotations.g:18257:2: ( ruleJvmUpperBoundAnded )
            {
            // InternalXbaseWithAnnotations.g:18257:2: ( ruleJvmUpperBoundAnded )
            // InternalXbaseWithAnnotations.g:18258:3: ruleJvmUpperBoundAnded
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsJvmUpperBoundAndedParserRuleCall_2_0_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmUpperBoundAnded();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsJvmUpperBoundAndedParserRuleCall_2_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__ConstraintsAssignment_2_0_1"


    // $ANTLR start "rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_0"
    // InternalXbaseWithAnnotations.g:18267:1: rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_0 : ( ruleJvmLowerBound ) ;
    public final void rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18271:1: ( ( ruleJvmLowerBound ) )
            // InternalXbaseWithAnnotations.g:18272:2: ( ruleJvmLowerBound )
            {
            // InternalXbaseWithAnnotations.g:18272:2: ( ruleJvmLowerBound )
            // InternalXbaseWithAnnotations.g:18273:3: ruleJvmLowerBound
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsJvmLowerBoundParserRuleCall_2_1_0_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmLowerBound();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsJvmLowerBoundParserRuleCall_2_1_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_0"


    // $ANTLR start "rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_1"
    // InternalXbaseWithAnnotations.g:18282:1: rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_1 : ( ruleJvmLowerBoundAnded ) ;
    public final void rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18286:1: ( ( ruleJvmLowerBoundAnded ) )
            // InternalXbaseWithAnnotations.g:18287:2: ( ruleJvmLowerBoundAnded )
            {
            // InternalXbaseWithAnnotations.g:18287:2: ( ruleJvmLowerBoundAnded )
            // InternalXbaseWithAnnotations.g:18288:3: ruleJvmLowerBoundAnded
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsJvmLowerBoundAndedParserRuleCall_2_1_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmLowerBoundAnded();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmWildcardTypeReferenceAccess().getConstraintsJvmLowerBoundAndedParserRuleCall_2_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmWildcardTypeReference__ConstraintsAssignment_2_1_1"


    // $ANTLR start "rule__JvmUpperBound__TypeReferenceAssignment_1"
    // InternalXbaseWithAnnotations.g:18297:1: rule__JvmUpperBound__TypeReferenceAssignment_1 : ( ruleJvmTypeReference ) ;
    public final void rule__JvmUpperBound__TypeReferenceAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18301:1: ( ( ruleJvmTypeReference ) )
            // InternalXbaseWithAnnotations.g:18302:2: ( ruleJvmTypeReference )
            {
            // InternalXbaseWithAnnotations.g:18302:2: ( ruleJvmTypeReference )
            // InternalXbaseWithAnnotations.g:18303:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmUpperBoundAccess().getTypeReferenceJvmTypeReferenceParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmUpperBoundAccess().getTypeReferenceJvmTypeReferenceParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmUpperBound__TypeReferenceAssignment_1"


    // $ANTLR start "rule__JvmUpperBoundAnded__TypeReferenceAssignment_1"
    // InternalXbaseWithAnnotations.g:18312:1: rule__JvmUpperBoundAnded__TypeReferenceAssignment_1 : ( ruleJvmTypeReference ) ;
    public final void rule__JvmUpperBoundAnded__TypeReferenceAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18316:1: ( ( ruleJvmTypeReference ) )
            // InternalXbaseWithAnnotations.g:18317:2: ( ruleJvmTypeReference )
            {
            // InternalXbaseWithAnnotations.g:18317:2: ( ruleJvmTypeReference )
            // InternalXbaseWithAnnotations.g:18318:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmUpperBoundAndedAccess().getTypeReferenceJvmTypeReferenceParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmUpperBoundAndedAccess().getTypeReferenceJvmTypeReferenceParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmUpperBoundAnded__TypeReferenceAssignment_1"


    // $ANTLR start "rule__JvmLowerBound__TypeReferenceAssignment_1"
    // InternalXbaseWithAnnotations.g:18327:1: rule__JvmLowerBound__TypeReferenceAssignment_1 : ( ruleJvmTypeReference ) ;
    public final void rule__JvmLowerBound__TypeReferenceAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18331:1: ( ( ruleJvmTypeReference ) )
            // InternalXbaseWithAnnotations.g:18332:2: ( ruleJvmTypeReference )
            {
            // InternalXbaseWithAnnotations.g:18332:2: ( ruleJvmTypeReference )
            // InternalXbaseWithAnnotations.g:18333:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmLowerBoundAccess().getTypeReferenceJvmTypeReferenceParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmLowerBoundAccess().getTypeReferenceJvmTypeReferenceParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmLowerBound__TypeReferenceAssignment_1"


    // $ANTLR start "rule__JvmLowerBoundAnded__TypeReferenceAssignment_1"
    // InternalXbaseWithAnnotations.g:18342:1: rule__JvmLowerBoundAnded__TypeReferenceAssignment_1 : ( ruleJvmTypeReference ) ;
    public final void rule__JvmLowerBoundAnded__TypeReferenceAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18346:1: ( ( ruleJvmTypeReference ) )
            // InternalXbaseWithAnnotations.g:18347:2: ( ruleJvmTypeReference )
            {
            // InternalXbaseWithAnnotations.g:18347:2: ( ruleJvmTypeReference )
            // InternalXbaseWithAnnotations.g:18348:3: ruleJvmTypeReference
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getJvmLowerBoundAndedAccess().getTypeReferenceJvmTypeReferenceParserRuleCall_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleJvmTypeReference();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getJvmLowerBoundAndedAccess().getTypeReferenceJvmTypeReferenceParserRuleCall_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__JvmLowerBoundAnded__TypeReferenceAssignment_1"


    // $ANTLR start "rule__XImportDeclaration__StaticAssignment_1_0_0"
    // InternalXbaseWithAnnotations.g:18357:1: rule__XImportDeclaration__StaticAssignment_1_0_0 : ( ( 'static' ) ) ;
    public final void rule__XImportDeclaration__StaticAssignment_1_0_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18361:1: ( ( ( 'static' ) ) )
            // InternalXbaseWithAnnotations.g:18362:2: ( ( 'static' ) )
            {
            // InternalXbaseWithAnnotations.g:18362:2: ( ( 'static' ) )
            // InternalXbaseWithAnnotations.g:18363:3: ( 'static' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getStaticStaticKeyword_1_0_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:18364:3: ( 'static' )
            // InternalXbaseWithAnnotations.g:18365:4: 'static'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getStaticStaticKeyword_1_0_0_0()); 
            }
            match(input,46,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getStaticStaticKeyword_1_0_0_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getStaticStaticKeyword_1_0_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__StaticAssignment_1_0_0"


    // $ANTLR start "rule__XImportDeclaration__ExtensionAssignment_1_0_1"
    // InternalXbaseWithAnnotations.g:18376:1: rule__XImportDeclaration__ExtensionAssignment_1_0_1 : ( ( 'extension' ) ) ;
    public final void rule__XImportDeclaration__ExtensionAssignment_1_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18380:1: ( ( ( 'extension' ) ) )
            // InternalXbaseWithAnnotations.g:18381:2: ( ( 'extension' ) )
            {
            // InternalXbaseWithAnnotations.g:18381:2: ( ( 'extension' ) )
            // InternalXbaseWithAnnotations.g:18382:3: ( 'extension' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getExtensionExtensionKeyword_1_0_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:18383:3: ( 'extension' )
            // InternalXbaseWithAnnotations.g:18384:4: 'extension'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getExtensionExtensionKeyword_1_0_1_0()); 
            }
            match(input,48,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getExtensionExtensionKeyword_1_0_1_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getExtensionExtensionKeyword_1_0_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__ExtensionAssignment_1_0_1"


    // $ANTLR start "rule__XImportDeclaration__ImportedTypeAssignment_1_0_2"
    // InternalXbaseWithAnnotations.g:18395:1: rule__XImportDeclaration__ImportedTypeAssignment_1_0_2 : ( ( ruleQualifiedNameInStaticImport ) ) ;
    public final void rule__XImportDeclaration__ImportedTypeAssignment_1_0_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18399:1: ( ( ( ruleQualifiedNameInStaticImport ) ) )
            // InternalXbaseWithAnnotations.g:18400:2: ( ( ruleQualifiedNameInStaticImport ) )
            {
            // InternalXbaseWithAnnotations.g:18400:2: ( ( ruleQualifiedNameInStaticImport ) )
            // InternalXbaseWithAnnotations.g:18401:3: ( ruleQualifiedNameInStaticImport )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getImportedTypeJvmDeclaredTypeCrossReference_1_0_2_0()); 
            }
            // InternalXbaseWithAnnotations.g:18402:3: ( ruleQualifiedNameInStaticImport )
            // InternalXbaseWithAnnotations.g:18403:4: ruleQualifiedNameInStaticImport
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getImportedTypeJvmDeclaredTypeQualifiedNameInStaticImportParserRuleCall_1_0_2_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleQualifiedNameInStaticImport();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getImportedTypeJvmDeclaredTypeQualifiedNameInStaticImportParserRuleCall_1_0_2_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getImportedTypeJvmDeclaredTypeCrossReference_1_0_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__ImportedTypeAssignment_1_0_2"


    // $ANTLR start "rule__XImportDeclaration__WildcardAssignment_1_0_3_0"
    // InternalXbaseWithAnnotations.g:18414:1: rule__XImportDeclaration__WildcardAssignment_1_0_3_0 : ( ( '*' ) ) ;
    public final void rule__XImportDeclaration__WildcardAssignment_1_0_3_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18418:1: ( ( ( '*' ) ) )
            // InternalXbaseWithAnnotations.g:18419:2: ( ( '*' ) )
            {
            // InternalXbaseWithAnnotations.g:18419:2: ( ( '*' ) )
            // InternalXbaseWithAnnotations.g:18420:3: ( '*' )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getWildcardAsteriskKeyword_1_0_3_0_0()); 
            }
            // InternalXbaseWithAnnotations.g:18421:3: ( '*' )
            // InternalXbaseWithAnnotations.g:18422:4: '*'
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getWildcardAsteriskKeyword_1_0_3_0_0()); 
            }
            match(input,36,FOLLOW_2); if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getWildcardAsteriskKeyword_1_0_3_0_0()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getWildcardAsteriskKeyword_1_0_3_0_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__WildcardAssignment_1_0_3_0"


    // $ANTLR start "rule__XImportDeclaration__MemberNameAssignment_1_0_3_1"
    // InternalXbaseWithAnnotations.g:18433:1: rule__XImportDeclaration__MemberNameAssignment_1_0_3_1 : ( ruleValidID ) ;
    public final void rule__XImportDeclaration__MemberNameAssignment_1_0_3_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18437:1: ( ( ruleValidID ) )
            // InternalXbaseWithAnnotations.g:18438:2: ( ruleValidID )
            {
            // InternalXbaseWithAnnotations.g:18438:2: ( ruleValidID )
            // InternalXbaseWithAnnotations.g:18439:3: ruleValidID
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getMemberNameValidIDParserRuleCall_1_0_3_1_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleValidID();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getMemberNameValidIDParserRuleCall_1_0_3_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__MemberNameAssignment_1_0_3_1"


    // $ANTLR start "rule__XImportDeclaration__ImportedTypeAssignment_1_1"
    // InternalXbaseWithAnnotations.g:18448:1: rule__XImportDeclaration__ImportedTypeAssignment_1_1 : ( ( ruleQualifiedName ) ) ;
    public final void rule__XImportDeclaration__ImportedTypeAssignment_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18452:1: ( ( ( ruleQualifiedName ) ) )
            // InternalXbaseWithAnnotations.g:18453:2: ( ( ruleQualifiedName ) )
            {
            // InternalXbaseWithAnnotations.g:18453:2: ( ( ruleQualifiedName ) )
            // InternalXbaseWithAnnotations.g:18454:3: ( ruleQualifiedName )
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getImportedTypeJvmDeclaredTypeCrossReference_1_1_0()); 
            }
            // InternalXbaseWithAnnotations.g:18455:3: ( ruleQualifiedName )
            // InternalXbaseWithAnnotations.g:18456:4: ruleQualifiedName
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getImportedTypeJvmDeclaredTypeQualifiedNameParserRuleCall_1_1_0_1()); 
            }
            pushFollow(FOLLOW_2);
            ruleQualifiedName();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getImportedTypeJvmDeclaredTypeQualifiedNameParserRuleCall_1_1_0_1()); 
            }

            }

            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getImportedTypeJvmDeclaredTypeCrossReference_1_1_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__ImportedTypeAssignment_1_1"


    // $ANTLR start "rule__XImportDeclaration__ImportedNamespaceAssignment_1_2"
    // InternalXbaseWithAnnotations.g:18467:1: rule__XImportDeclaration__ImportedNamespaceAssignment_1_2 : ( ruleQualifiedNameWithWildcard ) ;
    public final void rule__XImportDeclaration__ImportedNamespaceAssignment_1_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalXbaseWithAnnotations.g:18471:1: ( ( ruleQualifiedNameWithWildcard ) )
            // InternalXbaseWithAnnotations.g:18472:2: ( ruleQualifiedNameWithWildcard )
            {
            // InternalXbaseWithAnnotations.g:18472:2: ( ruleQualifiedNameWithWildcard )
            // InternalXbaseWithAnnotations.g:18473:3: ruleQualifiedNameWithWildcard
            {
            if ( state.backtracking==0 ) {
               before(grammarAccess.getXImportDeclarationAccess().getImportedNamespaceQualifiedNameWithWildcardParserRuleCall_1_2_0()); 
            }
            pushFollow(FOLLOW_2);
            ruleQualifiedNameWithWildcard();

            state._fsp--;
            if (state.failed) return ;
            if ( state.backtracking==0 ) {
               after(grammarAccess.getXImportDeclarationAccess().getImportedNamespaceQualifiedNameWithWildcardParserRuleCall_1_2_0()); 
            }

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__XImportDeclaration__ImportedNamespaceAssignment_1_2"

    // $ANTLR start synpred2_InternalXbaseWithAnnotations
    public final void synpred2_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:2078:2: ( ( ( rule__XAnnotation__Group_3_1_0__0 ) ) )
        // InternalXbaseWithAnnotations.g:2078:2: ( ( rule__XAnnotation__Group_3_1_0__0 ) )
        {
        // InternalXbaseWithAnnotations.g:2078:2: ( ( rule__XAnnotation__Group_3_1_0__0 ) )
        // InternalXbaseWithAnnotations.g:2079:3: ( rule__XAnnotation__Group_3_1_0__0 )
        {
        if ( state.backtracking==0 ) {
           before(grammarAccess.getXAnnotationAccess().getGroup_3_1_0()); 
        }
        // InternalXbaseWithAnnotations.g:2080:3: ( rule__XAnnotation__Group_3_1_0__0 )
        // InternalXbaseWithAnnotations.g:2080:4: rule__XAnnotation__Group_3_1_0__0
        {
        pushFollow(FOLLOW_2);
        rule__XAnnotation__Group_3_1_0__0();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }
    }
    // $ANTLR end synpred2_InternalXbaseWithAnnotations

    // $ANTLR start synpred3_InternalXbaseWithAnnotations
    public final void synpred3_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:2099:2: ( ( ( rule__XAnnotationElementValueOrCommaList__Group_0__0 ) ) )
        // InternalXbaseWithAnnotations.g:2099:2: ( ( rule__XAnnotationElementValueOrCommaList__Group_0__0 ) )
        {
        // InternalXbaseWithAnnotations.g:2099:2: ( ( rule__XAnnotationElementValueOrCommaList__Group_0__0 ) )
        // InternalXbaseWithAnnotations.g:2100:3: ( rule__XAnnotationElementValueOrCommaList__Group_0__0 )
        {
        if ( state.backtracking==0 ) {
           before(grammarAccess.getXAnnotationElementValueOrCommaListAccess().getGroup_0()); 
        }
        // InternalXbaseWithAnnotations.g:2101:3: ( rule__XAnnotationElementValueOrCommaList__Group_0__0 )
        // InternalXbaseWithAnnotations.g:2101:4: rule__XAnnotationElementValueOrCommaList__Group_0__0
        {
        pushFollow(FOLLOW_2);
        rule__XAnnotationElementValueOrCommaList__Group_0__0();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }
    }
    // $ANTLR end synpred3_InternalXbaseWithAnnotations

    // $ANTLR start synpred4_InternalXbaseWithAnnotations
    public final void synpred4_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:2120:2: ( ( ( rule__XAnnotationElementValue__Group_0__0 ) ) )
        // InternalXbaseWithAnnotations.g:2120:2: ( ( rule__XAnnotationElementValue__Group_0__0 ) )
        {
        // InternalXbaseWithAnnotations.g:2120:2: ( ( rule__XAnnotationElementValue__Group_0__0 ) )
        // InternalXbaseWithAnnotations.g:2121:3: ( rule__XAnnotationElementValue__Group_0__0 )
        {
        if ( state.backtracking==0 ) {
           before(grammarAccess.getXAnnotationElementValueAccess().getGroup_0()); 
        }
        // InternalXbaseWithAnnotations.g:2122:3: ( rule__XAnnotationElementValue__Group_0__0 )
        // InternalXbaseWithAnnotations.g:2122:4: rule__XAnnotationElementValue__Group_0__0
        {
        pushFollow(FOLLOW_2);
        rule__XAnnotationElementValue__Group_0__0();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }
    }
    // $ANTLR end synpred4_InternalXbaseWithAnnotations

    // $ANTLR start synpred29_InternalXbaseWithAnnotations
    public final void synpred29_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:2405:2: ( ( ( rule__OpOther__Group_6_1_0__0 ) ) )
        // InternalXbaseWithAnnotations.g:2405:2: ( ( rule__OpOther__Group_6_1_0__0 ) )
        {
        // InternalXbaseWithAnnotations.g:2405:2: ( ( rule__OpOther__Group_6_1_0__0 ) )
        // InternalXbaseWithAnnotations.g:2406:3: ( rule__OpOther__Group_6_1_0__0 )
        {
        if ( state.backtracking==0 ) {
           before(grammarAccess.getOpOtherAccess().getGroup_6_1_0()); 
        }
        // InternalXbaseWithAnnotations.g:2407:3: ( rule__OpOther__Group_6_1_0__0 )
        // InternalXbaseWithAnnotations.g:2407:4: rule__OpOther__Group_6_1_0__0
        {
        pushFollow(FOLLOW_2);
        rule__OpOther__Group_6_1_0__0();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }
    }
    // $ANTLR end synpred29_InternalXbaseWithAnnotations

    // $ANTLR start synpred30_InternalXbaseWithAnnotations
    public final void synpred30_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:2411:2: ( ( '<' ) )
        // InternalXbaseWithAnnotations.g:2411:2: ( '<' )
        {
        // InternalXbaseWithAnnotations.g:2411:2: ( '<' )
        // InternalXbaseWithAnnotations.g:2412:3: '<'
        {
        if ( state.backtracking==0 ) {
           before(grammarAccess.getOpOtherAccess().getLessThanSignKeyword_6_1_1()); 
        }
        match(input,27,FOLLOW_2); if (state.failed) return ;

        }


        }
    }
    // $ANTLR end synpred30_InternalXbaseWithAnnotations

    // $ANTLR start synpred43_InternalXbaseWithAnnotations
    public final void synpred43_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:2624:2: ( ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 ) ) )
        // InternalXbaseWithAnnotations.g:2624:2: ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 ) )
        {
        // InternalXbaseWithAnnotations.g:2624:2: ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 ) )
        // InternalXbaseWithAnnotations.g:2625:3: ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 )
        {
        if ( state.backtracking==0 ) {
           before(grammarAccess.getXMemberFeatureCallAccess().getMemberCallArgumentsAssignment_1_1_3_1_0()); 
        }
        // InternalXbaseWithAnnotations.g:2626:3: ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 )
        // InternalXbaseWithAnnotations.g:2626:4: rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0
        {
        pushFollow(FOLLOW_2);
        rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }
    }
    // $ANTLR end synpred43_InternalXbaseWithAnnotations

    // $ANTLR start synpred51_InternalXbaseWithAnnotations
    public final void synpred51_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:2687:2: ( ( ( ruleXForLoopExpression ) ) )
        // InternalXbaseWithAnnotations.g:2687:2: ( ( ruleXForLoopExpression ) )
        {
        // InternalXbaseWithAnnotations.g:2687:2: ( ( ruleXForLoopExpression ) )
        // InternalXbaseWithAnnotations.g:2688:3: ( ruleXForLoopExpression )
        {
        if ( state.backtracking==0 ) {
           before(grammarAccess.getXPrimaryExpressionAccess().getXForLoopExpressionParserRuleCall_7()); 
        }
        // InternalXbaseWithAnnotations.g:2689:3: ( ruleXForLoopExpression )
        // InternalXbaseWithAnnotations.g:2689:4: ruleXForLoopExpression
        {
        pushFollow(FOLLOW_2);
        ruleXForLoopExpression();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }
    }
    // $ANTLR end synpred51_InternalXbaseWithAnnotations

    // $ANTLR start synpred52_InternalXbaseWithAnnotations
    public final void synpred52_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:2693:2: ( ( ruleXBasicForLoopExpression ) )
        // InternalXbaseWithAnnotations.g:2693:2: ( ruleXBasicForLoopExpression )
        {
        // InternalXbaseWithAnnotations.g:2693:2: ( ruleXBasicForLoopExpression )
        // InternalXbaseWithAnnotations.g:2694:3: ruleXBasicForLoopExpression
        {
        if ( state.backtracking==0 ) {
           before(grammarAccess.getXPrimaryExpressionAccess().getXBasicForLoopExpressionParserRuleCall_8()); 
        }
        pushFollow(FOLLOW_2);
        ruleXBasicForLoopExpression();

        state._fsp--;
        if (state.failed) return ;

        }


        }
    }
    // $ANTLR end synpred52_InternalXbaseWithAnnotations

    // $ANTLR start synpred65_InternalXbaseWithAnnotations
    public final void synpred65_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:2816:2: ( ( ( rule__XSwitchExpression__Group_2_0__0 ) ) )
        // InternalXbaseWithAnnotations.g:2816:2: ( ( rule__XSwitchExpression__Group_2_0__0 ) )
        {
        // InternalXbaseWithAnnotations.g:2816:2: ( ( rule__XSwitchExpression__Group_2_0__0 ) )
        // InternalXbaseWithAnnotations.g:2817:3: ( rule__XSwitchExpression__Group_2_0__0 )
        {
        if ( state.backtracking==0 ) {
           before(grammarAccess.getXSwitchExpressionAccess().getGroup_2_0()); 
        }
        // InternalXbaseWithAnnotations.g:2818:3: ( rule__XSwitchExpression__Group_2_0__0 )
        // InternalXbaseWithAnnotations.g:2818:4: rule__XSwitchExpression__Group_2_0__0
        {
        pushFollow(FOLLOW_2);
        rule__XSwitchExpression__Group_2_0__0();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }
    }
    // $ANTLR end synpred65_InternalXbaseWithAnnotations

    // $ANTLR start synpred69_InternalXbaseWithAnnotations
    public final void synpred69_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:2900:2: ( ( ( rule__XVariableDeclaration__Group_2_0__0 ) ) )
        // InternalXbaseWithAnnotations.g:2900:2: ( ( rule__XVariableDeclaration__Group_2_0__0 ) )
        {
        // InternalXbaseWithAnnotations.g:2900:2: ( ( rule__XVariableDeclaration__Group_2_0__0 ) )
        // InternalXbaseWithAnnotations.g:2901:3: ( rule__XVariableDeclaration__Group_2_0__0 )
        {
        if ( state.backtracking==0 ) {
           before(grammarAccess.getXVariableDeclarationAccess().getGroup_2_0()); 
        }
        // InternalXbaseWithAnnotations.g:2902:3: ( rule__XVariableDeclaration__Group_2_0__0 )
        // InternalXbaseWithAnnotations.g:2902:4: rule__XVariableDeclaration__Group_2_0__0
        {
        pushFollow(FOLLOW_2);
        rule__XVariableDeclaration__Group_2_0__0();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }
    }
    // $ANTLR end synpred69_InternalXbaseWithAnnotations

    // $ANTLR start synpred70_InternalXbaseWithAnnotations
    public final void synpred70_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:2921:2: ( ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 ) ) )
        // InternalXbaseWithAnnotations.g:2921:2: ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 ) )
        {
        // InternalXbaseWithAnnotations.g:2921:2: ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 ) )
        // InternalXbaseWithAnnotations.g:2922:3: ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 )
        {
        if ( state.backtracking==0 ) {
           before(grammarAccess.getXFeatureCallAccess().getFeatureCallArgumentsAssignment_3_1_0()); 
        }
        // InternalXbaseWithAnnotations.g:2923:3: ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 )
        // InternalXbaseWithAnnotations.g:2923:4: rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0
        {
        pushFollow(FOLLOW_2);
        rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }
    }
    // $ANTLR end synpred70_InternalXbaseWithAnnotations

    // $ANTLR start synpred76_InternalXbaseWithAnnotations
    public final void synpred76_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:3002:2: ( ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_0 ) ) )
        // InternalXbaseWithAnnotations.g:3002:2: ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_0 ) )
        {
        // InternalXbaseWithAnnotations.g:3002:2: ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_0 ) )
        // InternalXbaseWithAnnotations.g:3003:3: ( rule__XConstructorCall__ArgumentsAssignment_4_1_0 )
        {
        if ( state.backtracking==0 ) {
           before(grammarAccess.getXConstructorCallAccess().getArgumentsAssignment_4_1_0()); 
        }
        // InternalXbaseWithAnnotations.g:3004:3: ( rule__XConstructorCall__ArgumentsAssignment_4_1_0 )
        // InternalXbaseWithAnnotations.g:3004:4: rule__XConstructorCall__ArgumentsAssignment_4_1_0
        {
        pushFollow(FOLLOW_2);
        rule__XConstructorCall__ArgumentsAssignment_4_1_0();

        state._fsp--;
        if (state.failed) return ;

        }


        }


        }
    }
    // $ANTLR end synpred76_InternalXbaseWithAnnotations

    // $ANTLR start synpred97_InternalXbaseWithAnnotations
    public final void synpred97_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:4582:3: ( rule__XAssignment__Group_1_1__0 )
        // InternalXbaseWithAnnotations.g:4582:3: rule__XAssignment__Group_1_1__0
        {
        pushFollow(FOLLOW_2);
        rule__XAssignment__Group_1_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred97_InternalXbaseWithAnnotations

    // $ANTLR start synpred99_InternalXbaseWithAnnotations
    public final void synpred99_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:4933:3: ( rule__XOrExpression__Group_1__0 )
        // InternalXbaseWithAnnotations.g:4933:3: rule__XOrExpression__Group_1__0
        {
        pushFollow(FOLLOW_2);
        rule__XOrExpression__Group_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred99_InternalXbaseWithAnnotations

    // $ANTLR start synpred100_InternalXbaseWithAnnotations
    public final void synpred100_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:5122:3: ( rule__XAndExpression__Group_1__0 )
        // InternalXbaseWithAnnotations.g:5122:3: rule__XAndExpression__Group_1__0
        {
        pushFollow(FOLLOW_2);
        rule__XAndExpression__Group_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred100_InternalXbaseWithAnnotations

    // $ANTLR start synpred101_InternalXbaseWithAnnotations
    public final void synpred101_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:5311:3: ( rule__XEqualityExpression__Group_1__0 )
        // InternalXbaseWithAnnotations.g:5311:3: rule__XEqualityExpression__Group_1__0
        {
        pushFollow(FOLLOW_2);
        rule__XEqualityExpression__Group_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred101_InternalXbaseWithAnnotations

    // $ANTLR start synpred102_InternalXbaseWithAnnotations
    public final void synpred102_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:5500:3: ( rule__XRelationalExpression__Alternatives_1 )
        // InternalXbaseWithAnnotations.g:5500:3: rule__XRelationalExpression__Alternatives_1
        {
        pushFollow(FOLLOW_2);
        rule__XRelationalExpression__Alternatives_1();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred102_InternalXbaseWithAnnotations

    // $ANTLR start synpred103_InternalXbaseWithAnnotations
    public final void synpred103_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:5878:3: ( rule__XOtherOperatorExpression__Group_1__0 )
        // InternalXbaseWithAnnotations.g:5878:3: rule__XOtherOperatorExpression__Group_1__0
        {
        pushFollow(FOLLOW_2);
        rule__XOtherOperatorExpression__Group_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred103_InternalXbaseWithAnnotations

    // $ANTLR start synpred104_InternalXbaseWithAnnotations
    public final void synpred104_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:6391:3: ( rule__XAdditiveExpression__Group_1__0 )
        // InternalXbaseWithAnnotations.g:6391:3: rule__XAdditiveExpression__Group_1__0
        {
        pushFollow(FOLLOW_2);
        rule__XAdditiveExpression__Group_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred104_InternalXbaseWithAnnotations

    // $ANTLR start synpred105_InternalXbaseWithAnnotations
    public final void synpred105_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:6580:3: ( rule__XMultiplicativeExpression__Group_1__0 )
        // InternalXbaseWithAnnotations.g:6580:3: rule__XMultiplicativeExpression__Group_1__0
        {
        pushFollow(FOLLOW_2);
        rule__XMultiplicativeExpression__Group_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred105_InternalXbaseWithAnnotations

    // $ANTLR start synpred106_InternalXbaseWithAnnotations
    public final void synpred106_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:6850:3: ( rule__XCastedExpression__Group_1__0 )
        // InternalXbaseWithAnnotations.g:6850:3: rule__XCastedExpression__Group_1__0
        {
        pushFollow(FOLLOW_2);
        rule__XCastedExpression__Group_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred106_InternalXbaseWithAnnotations

    // $ANTLR start synpred107_InternalXbaseWithAnnotations
    public final void synpred107_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:7039:3: ( rule__XPostfixOperation__Group_1__0 )
        // InternalXbaseWithAnnotations.g:7039:3: rule__XPostfixOperation__Group_1__0
        {
        pushFollow(FOLLOW_2);
        rule__XPostfixOperation__Group_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred107_InternalXbaseWithAnnotations

    // $ANTLR start synpred108_InternalXbaseWithAnnotations
    public final void synpred108_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:7174:3: ( rule__XMemberFeatureCall__Alternatives_1 )
        // InternalXbaseWithAnnotations.g:7174:3: rule__XMemberFeatureCall__Alternatives_1
        {
        pushFollow(FOLLOW_2);
        rule__XMemberFeatureCall__Alternatives_1();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred108_InternalXbaseWithAnnotations

    // $ANTLR start synpred110_InternalXbaseWithAnnotations
    public final void synpred110_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:7472:3: ( rule__XMemberFeatureCall__Group_1_1_3__0 )
        // InternalXbaseWithAnnotations.g:7472:3: rule__XMemberFeatureCall__Group_1_1_3__0
        {
        pushFollow(FOLLOW_2);
        rule__XMemberFeatureCall__Group_1_1_3__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred110_InternalXbaseWithAnnotations

    // $ANTLR start synpred111_InternalXbaseWithAnnotations
    public final void synpred111_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:7498:3: ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4 )
        // InternalXbaseWithAnnotations.g:7498:3: rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4
        {
        pushFollow(FOLLOW_2);
        rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred111_InternalXbaseWithAnnotations

    // $ANTLR start synpred119_InternalXbaseWithAnnotations
    public final void synpred119_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:8471:3: ( rule__XClosure__Group_1__0 )
        // InternalXbaseWithAnnotations.g:8471:3: rule__XClosure__Group_1__0
        {
        pushFollow(FOLLOW_2);
        rule__XClosure__Group_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred119_InternalXbaseWithAnnotations

    // $ANTLR start synpred126_InternalXbaseWithAnnotations
    public final void synpred126_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:9442:3: ( rule__XIfExpression__Group_6__0 )
        // InternalXbaseWithAnnotations.g:9442:3: rule__XIfExpression__Group_6__0
        {
        pushFollow(FOLLOW_2);
        rule__XIfExpression__Group_6__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred126_InternalXbaseWithAnnotations

    // $ANTLR start synpred129_InternalXbaseWithAnnotations
    public final void synpred129_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:9902:3: ( rule__XSwitchExpression__Group_2_1_0__0 )
        // InternalXbaseWithAnnotations.g:9902:3: rule__XSwitchExpression__Group_2_1_0__0
        {
        pushFollow(FOLLOW_2);
        rule__XSwitchExpression__Group_2_1_0__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred129_InternalXbaseWithAnnotations

    // $ANTLR start synpred142_InternalXbaseWithAnnotations
    public final void synpred142_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:12035:3: ( rule__XFeatureCall__Group_3__0 )
        // InternalXbaseWithAnnotations.g:12035:3: rule__XFeatureCall__Group_3__0
        {
        pushFollow(FOLLOW_2);
        rule__XFeatureCall__Group_3__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred142_InternalXbaseWithAnnotations

    // $ANTLR start synpred143_InternalXbaseWithAnnotations
    public final void synpred143_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:12061:3: ( rule__XFeatureCall__FeatureCallArgumentsAssignment_4 )
        // InternalXbaseWithAnnotations.g:12061:3: rule__XFeatureCall__FeatureCallArgumentsAssignment_4
        {
        pushFollow(FOLLOW_2);
        rule__XFeatureCall__FeatureCallArgumentsAssignment_4();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred143_InternalXbaseWithAnnotations

    // $ANTLR start synpred147_InternalXbaseWithAnnotations
    public final void synpred147_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:12521:3: ( rule__XConstructorCall__Group_3__0 )
        // InternalXbaseWithAnnotations.g:12521:3: rule__XConstructorCall__Group_3__0
        {
        pushFollow(FOLLOW_2);
        rule__XConstructorCall__Group_3__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred147_InternalXbaseWithAnnotations

    // $ANTLR start synpred148_InternalXbaseWithAnnotations
    public final void synpred148_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:12548:3: ( rule__XConstructorCall__Group_4__0 )
        // InternalXbaseWithAnnotations.g:12548:3: rule__XConstructorCall__Group_4__0
        {
        pushFollow(FOLLOW_2);
        rule__XConstructorCall__Group_4__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred148_InternalXbaseWithAnnotations

    // $ANTLR start synpred149_InternalXbaseWithAnnotations
    public final void synpred149_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:12574:3: ( rule__XConstructorCall__ArgumentsAssignment_5 )
        // InternalXbaseWithAnnotations.g:12574:3: rule__XConstructorCall__ArgumentsAssignment_5
        {
        pushFollow(FOLLOW_2);
        rule__XConstructorCall__ArgumentsAssignment_5();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred149_InternalXbaseWithAnnotations

    // $ANTLR start synpred154_InternalXbaseWithAnnotations
    public final void synpred154_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:13465:3: ( rule__XReturnExpression__ExpressionAssignment_2 )
        // InternalXbaseWithAnnotations.g:13465:3: rule__XReturnExpression__ExpressionAssignment_2
        {
        pushFollow(FOLLOW_2);
        rule__XReturnExpression__ExpressionAssignment_2();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred154_InternalXbaseWithAnnotations

    // $ANTLR start synpred155_InternalXbaseWithAnnotations
    public final void synpred155_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:13607:4: ( rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0 )
        // InternalXbaseWithAnnotations.g:13607:4: rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0
        {
        pushFollow(FOLLOW_2);
        rule__XTryCatchFinallyExpression__CatchClausesAssignment_3_0_0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred155_InternalXbaseWithAnnotations

    // $ANTLR start synpred156_InternalXbaseWithAnnotations
    public final void synpred156_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:13634:3: ( rule__XTryCatchFinallyExpression__Group_3_0_1__0 )
        // InternalXbaseWithAnnotations.g:13634:3: rule__XTryCatchFinallyExpression__Group_3_0_1__0
        {
        pushFollow(FOLLOW_2);
        rule__XTryCatchFinallyExpression__Group_3_0_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred156_InternalXbaseWithAnnotations

    // $ANTLR start synpred157_InternalXbaseWithAnnotations
    public final void synpred157_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:14147:3: ( rule__QualifiedName__Group_1__0 )
        // InternalXbaseWithAnnotations.g:14147:3: rule__QualifiedName__Group_1__0
        {
        pushFollow(FOLLOW_2);
        rule__QualifiedName__Group_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred157_InternalXbaseWithAnnotations

    // $ANTLR start synpred159_InternalXbaseWithAnnotations
    public final void synpred159_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:14363:3: ( rule__JvmTypeReference__Group_0_1__0 )
        // InternalXbaseWithAnnotations.g:14363:3: rule__JvmTypeReference__Group_0_1__0
        {
        pushFollow(FOLLOW_2);
        rule__JvmTypeReference__Group_0_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred159_InternalXbaseWithAnnotations

    // $ANTLR start synpred163_InternalXbaseWithAnnotations
    public final void synpred163_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:14822:3: ( rule__JvmParameterizedTypeReference__Group_1__0 )
        // InternalXbaseWithAnnotations.g:14822:3: rule__JvmParameterizedTypeReference__Group_1__0
        {
        pushFollow(FOLLOW_2);
        rule__JvmParameterizedTypeReference__Group_1__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred163_InternalXbaseWithAnnotations

    // $ANTLR start synpred165_InternalXbaseWithAnnotations
    public final void synpred165_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:14957:3: ( rule__JvmParameterizedTypeReference__Group_1_4__0 )
        // InternalXbaseWithAnnotations.g:14957:3: rule__JvmParameterizedTypeReference__Group_1_4__0
        {
        pushFollow(FOLLOW_2);
        rule__JvmParameterizedTypeReference__Group_1_4__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred165_InternalXbaseWithAnnotations

    // $ANTLR start synpred166_InternalXbaseWithAnnotations
    public final void synpred166_InternalXbaseWithAnnotations_fragment() throws RecognitionException {   
        // InternalXbaseWithAnnotations.g:15092:3: ( rule__JvmParameterizedTypeReference__Group_1_4_2__0 )
        // InternalXbaseWithAnnotations.g:15092:3: rule__JvmParameterizedTypeReference__Group_1_4_2__0
        {
        pushFollow(FOLLOW_2);
        rule__JvmParameterizedTypeReference__Group_1_4_2__0();

        state._fsp--;
        if (state.failed) return ;

        }
    }
    // $ANTLR end synpred166_InternalXbaseWithAnnotations

    // Delegated rules

    public final boolean synpred149_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred149_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred2_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred2_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred163_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred163_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred126_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred126_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred30_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred30_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred107_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred107_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred119_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred119_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred29_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred29_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred102_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred102_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred156_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred156_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred3_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred3_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred110_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred110_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred103_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred103_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred157_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred157_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred108_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred108_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred43_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred43_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred97_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred97_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred99_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred99_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred154_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred154_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred4_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred4_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred52_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred52_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred100_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred100_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred104_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred104_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred142_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred142_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred159_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred159_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred70_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred70_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred165_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred165_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred69_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred69_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred105_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred105_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred111_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred111_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred51_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred51_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred147_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred147_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred129_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred129_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred143_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred143_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred155_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred155_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred101_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred101_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred65_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred65_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred106_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred106_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred166_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred166_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred76_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred76_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }
    public final boolean synpred148_InternalXbaseWithAnnotations() {
        state.backtracking++;
        int start = input.mark();
        try {
            synpred148_InternalXbaseWithAnnotations_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !state.failed;
        input.rewind(start);
        state.backtracking--;
        state.failed=false;
        return success;
    }


    protected DFA2 dfa2 = new DFA2(this);
    protected DFA3 dfa3 = new DFA3(this);
    protected DFA4 dfa4 = new DFA4(this);
    protected DFA11 dfa11 = new DFA11(this);
    protected DFA19 dfa19 = new DFA19(this);
    protected DFA22 dfa22 = new DFA22(this);
    protected DFA23 dfa23 = new DFA23(this);
    protected DFA26 dfa26 = new DFA26(this);
    protected DFA31 dfa31 = new DFA31(this);
    protected DFA34 dfa34 = new DFA34(this);
    protected DFA43 dfa43 = new DFA43(this);
    protected DFA54 dfa54 = new DFA54(this);
    protected DFA60 dfa60 = new DFA60(this);
    protected DFA67 dfa67 = new DFA67(this);
    protected DFA68 dfa68 = new DFA68(this);
    protected DFA76 dfa76 = new DFA76(this);
    protected DFA86 dfa86 = new DFA86(this);
    protected DFA99 dfa99 = new DFA99(this);
    protected DFA100 dfa100 = new DFA100(this);
    protected DFA104 dfa104 = new DFA104(this);
    protected DFA105 dfa105 = new DFA105(this);
    protected DFA106 dfa106 = new DFA106(this);
    protected DFA111 dfa111 = new DFA111(this);
    protected DFA120 dfa120 = new DFA120(this);
    protected DFA123 dfa123 = new DFA123(this);
    static final String dfa_1s = "\43\uffff";
    static final String dfa_2s = "\1\4\1\0\41\uffff";
    static final String dfa_3s = "\1\127\1\0\41\uffff";
    static final String dfa_4s = "\2\uffff\1\2\37\uffff\1\1";
    static final String dfa_5s = "\1\uffff\1\0\41\uffff}>";
    static final String[] dfa_6s = {
            "\1\1\4\2\22\uffff\1\2\6\uffff\2\2\4\uffff\1\2\4\uffff\10\2\3\uffff\2\2\2\uffff\1\2\2\uffff\1\2\1\uffff\1\2\3\uffff\11\2\1\uffff\1\2\7\uffff\1\2",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_1 = DFA.unpackEncodedString(dfa_1s);
    static final char[] dfa_2 = DFA.unpackEncodedStringToUnsignedChars(dfa_2s);
    static final char[] dfa_3 = DFA.unpackEncodedStringToUnsignedChars(dfa_3s);
    static final short[] dfa_4 = DFA.unpackEncodedString(dfa_4s);
    static final short[] dfa_5 = DFA.unpackEncodedString(dfa_5s);
    static final short[][] dfa_6 = unpackEncodedStringArray(dfa_6s);

    class DFA2 extends DFA {

        public DFA2(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 2;
            this.eot = dfa_1;
            this.eof = dfa_1;
            this.min = dfa_2;
            this.max = dfa_3;
            this.accept = dfa_4;
            this.special = dfa_5;
            this.transition = dfa_6;
        }
        public String getDescription() {
            return "2073:1: rule__XAnnotation__Alternatives_3_1 : ( ( ( rule__XAnnotation__Group_3_1_0__0 ) ) | ( ( rule__XAnnotation__ValueAssignment_3_1_1 ) ) );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA2_1 = input.LA(1);

                         
                        int index2_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred2_InternalXbaseWithAnnotations()) ) {s = 34;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index2_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 2, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String[] dfa_7s = {
            "\5\2\22\uffff\1\2\6\uffff\2\2\4\uffff\1\2\4\uffff\10\2\3\uffff\1\1\1\2\2\uffff\1\2\2\uffff\1\2\1\uffff\1\2\3\uffff\11\2\1\uffff\1\2\7\uffff\1\2",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };
    static final short[][] dfa_7 = unpackEncodedStringArray(dfa_7s);

    class DFA3 extends DFA {

        public DFA3(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 3;
            this.eot = dfa_1;
            this.eof = dfa_1;
            this.min = dfa_2;
            this.max = dfa_3;
            this.accept = dfa_4;
            this.special = dfa_5;
            this.transition = dfa_7;
        }
        public String getDescription() {
            return "2094:1: rule__XAnnotationElementValueOrCommaList__Alternatives : ( ( ( rule__XAnnotationElementValueOrCommaList__Group_0__0 ) ) | ( ( rule__XAnnotationElementValueOrCommaList__Group_1__0 ) ) );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA3_1 = input.LA(1);

                         
                        int index3_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred3_InternalXbaseWithAnnotations()) ) {s = 34;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index3_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 3, _s, input);
            error(nvae);
            throw nvae;
        }
    }

    class DFA4 extends DFA {

        public DFA4(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 4;
            this.eot = dfa_1;
            this.eof = dfa_1;
            this.min = dfa_2;
            this.max = dfa_3;
            this.accept = dfa_4;
            this.special = dfa_5;
            this.transition = dfa_7;
        }
        public String getDescription() {
            return "2115:1: rule__XAnnotationElementValue__Alternatives : ( ( ( rule__XAnnotationElementValue__Group_0__0 ) ) | ( ruleXAnnotationOrExpression ) );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA4_1 = input.LA(1);

                         
                        int index4_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred4_InternalXbaseWithAnnotations()) ) {s = 34;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index4_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 4, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_8s = "\13\uffff";
    static final String dfa_9s = "\1\32\2\uffff\1\32\7\uffff";
    static final String dfa_10s = "\1\41\2\uffff\1\36\7\uffff";
    static final String dfa_11s = "\1\uffff\1\1\1\2\1\uffff\1\4\1\5\1\7\1\10\1\11\1\6\1\3";
    static final String dfa_12s = "\13\uffff}>";
    static final String[] dfa_13s = {
            "\1\3\1\6\1\1\1\2\1\4\1\5\1\7\1\10",
            "",
            "",
            "\1\11\3\uffff\1\12",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_8 = DFA.unpackEncodedString(dfa_8s);
    static final char[] dfa_9 = DFA.unpackEncodedStringToUnsignedChars(dfa_9s);
    static final char[] dfa_10 = DFA.unpackEncodedStringToUnsignedChars(dfa_10s);
    static final short[] dfa_11 = DFA.unpackEncodedString(dfa_11s);
    static final short[] dfa_12 = DFA.unpackEncodedString(dfa_12s);
    static final short[][] dfa_13 = unpackEncodedStringArray(dfa_13s);

    class DFA11 extends DFA {

        public DFA11(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 11;
            this.eot = dfa_8;
            this.eof = dfa_8;
            this.min = dfa_9;
            this.max = dfa_10;
            this.accept = dfa_11;
            this.special = dfa_12;
            this.transition = dfa_13;
        }
        public String getDescription() {
            return "2316:1: rule__OpOther__Alternatives : ( ( '->' ) | ( '..<' ) | ( ( rule__OpOther__Group_2__0 ) ) | ( '..' ) | ( '=>' ) | ( ( rule__OpOther__Group_5__0 ) ) | ( ( rule__OpOther__Group_6__0 ) ) | ( '<>' ) | ( '?:' ) );";
        }
    }
    static final String dfa_14s = "\12\uffff";
    static final String dfa_15s = "\4\uffff\5\3\1\uffff";
    static final String dfa_16s = "\1\53\2\4\1\uffff\5\4\1\uffff";
    static final String dfa_17s = "\1\124\2\61\1\uffff\5\127\1\uffff";
    static final String dfa_18s = "\3\uffff\1\2\5\uffff\1\1";
    static final String dfa_19s = "\12\uffff}>";
    static final String[] dfa_20s = {
            "\1\1\47\uffff\1\2\1\3",
            "\1\4\26\uffff\1\3\21\uffff\1\5\1\6\1\7\1\10\1\3",
            "\1\4\26\uffff\1\3\21\uffff\1\5\1\6\1\7\1\10\1\3",
            "",
            "\5\3\4\uffff\1\11\45\3\1\uffff\35\3\2\uffff\2\3\1\uffff\2\3",
            "\5\3\4\uffff\1\11\45\3\1\uffff\35\3\2\uffff\2\3\1\uffff\2\3",
            "\5\3\4\uffff\1\11\45\3\1\uffff\35\3\2\uffff\2\3\1\uffff\2\3",
            "\5\3\4\uffff\1\11\45\3\1\uffff\35\3\2\uffff\2\3\1\uffff\2\3",
            "\5\3\4\uffff\1\11\45\3\1\uffff\35\3\2\uffff\2\3\1\uffff\2\3",
            ""
    };

    static final short[] dfa_14 = DFA.unpackEncodedString(dfa_14s);
    static final short[] dfa_15 = DFA.unpackEncodedString(dfa_15s);
    static final char[] dfa_16 = DFA.unpackEncodedStringToUnsignedChars(dfa_16s);
    static final char[] dfa_17 = DFA.unpackEncodedStringToUnsignedChars(dfa_17s);
    static final short[] dfa_18 = DFA.unpackEncodedString(dfa_18s);
    static final short[] dfa_19 = DFA.unpackEncodedString(dfa_19s);
    static final short[][] dfa_20 = unpackEncodedStringArray(dfa_20s);

    class DFA19 extends DFA {

        public DFA19(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 19;
            this.eot = dfa_14;
            this.eof = dfa_15;
            this.min = dfa_16;
            this.max = dfa_17;
            this.accept = dfa_18;
            this.special = dfa_19;
            this.transition = dfa_20;
        }
        public String getDescription() {
            return "2550:1: rule__XMemberFeatureCall__Alternatives_1 : ( ( ( rule__XMemberFeatureCall__Group_1_0__0 ) ) | ( ( rule__XMemberFeatureCall__Group_1_1__0 ) ) );";
        }
    }
    static final String dfa_21s = "\1\4\2\0\40\uffff";
    static final String dfa_22s = "\1\127\2\0\40\uffff";
    static final String dfa_23s = "\3\uffff\1\1\1\uffff\1\2\35\uffff";
    static final String dfa_24s = "\1\uffff\1\0\1\1\40\uffff}>";
    static final String[] dfa_25s = {
            "\1\1\4\5\22\uffff\1\5\3\uffff\1\3\2\uffff\2\5\4\uffff\1\5\4\uffff\6\5\1\uffff\1\2\3\uffff\2\5\2\uffff\1\5\2\uffff\1\5\1\uffff\1\5\3\uffff\11\5\1\uffff\1\5\5\uffff\1\3\1\uffff\1\5",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };
    static final char[] dfa_21 = DFA.unpackEncodedStringToUnsignedChars(dfa_21s);
    static final char[] dfa_22 = DFA.unpackEncodedStringToUnsignedChars(dfa_22s);
    static final short[] dfa_23 = DFA.unpackEncodedString(dfa_23s);
    static final short[] dfa_24 = DFA.unpackEncodedString(dfa_24s);
    static final short[][] dfa_25 = unpackEncodedStringArray(dfa_25s);

    class DFA22 extends DFA {

        public DFA22(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 22;
            this.eot = dfa_1;
            this.eof = dfa_1;
            this.min = dfa_21;
            this.max = dfa_22;
            this.accept = dfa_23;
            this.special = dfa_24;
            this.transition = dfa_25;
        }
        public String getDescription() {
            return "2619:1: rule__XMemberFeatureCall__Alternatives_1_1_3_1 : ( ( ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_3_1_0 ) ) | ( ( rule__XMemberFeatureCall__Group_1_1_3_1_1__0 ) ) );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA22_1 = input.LA(1);

                         
                        int index22_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred43_InternalXbaseWithAnnotations()) ) {s = 3;}

                        else if ( (true) ) {s = 5;}

                         
                        input.seek(index22_1);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA22_2 = input.LA(1);

                         
                        int index22_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred43_InternalXbaseWithAnnotations()) ) {s = 3;}

                        else if ( (true) ) {s = 5;}

                         
                        input.seek(index22_2);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 22, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_26s = "\40\uffff";
    static final String dfa_27s = "\1\4\26\uffff\1\0\10\uffff";
    static final String dfa_28s = "\1\127\26\uffff\1\0\10\uffff";
    static final String dfa_29s = "\1\uffff\1\1\1\2\1\3\1\4\1\5\6\uffff\1\6\11\uffff\1\7\1\uffff\1\12\1\13\1\14\1\15\1\16\1\17\1\10\1\11";
    static final String dfa_30s = "\27\uffff\1\0\10\uffff}>";
    static final String[] dfa_31s = {
            "\1\5\4\14\22\uffff\1\5\21\uffff\5\5\1\14\1\uffff\1\35\3\uffff\2\14\2\uffff\1\2\2\uffff\1\26\1\uffff\1\3\3\uffff\1\27\1\30\1\31\1\1\2\14\1\32\1\33\1\34\1\uffff\1\4\7\uffff\1\14",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_26 = DFA.unpackEncodedString(dfa_26s);
    static final char[] dfa_27 = DFA.unpackEncodedStringToUnsignedChars(dfa_27s);
    static final char[] dfa_28 = DFA.unpackEncodedStringToUnsignedChars(dfa_28s);
    static final short[] dfa_29 = DFA.unpackEncodedString(dfa_29s);
    static final short[] dfa_30 = DFA.unpackEncodedString(dfa_30s);
    static final short[][] dfa_31 = unpackEncodedStringArray(dfa_31s);

    class DFA23 extends DFA {

        public DFA23(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 23;
            this.eot = dfa_26;
            this.eof = dfa_26;
            this.min = dfa_27;
            this.max = dfa_28;
            this.accept = dfa_29;
            this.special = dfa_30;
            this.transition = dfa_31;
        }
        public String getDescription() {
            return "2640:1: rule__XPrimaryExpression__Alternatives : ( ( ruleXConstructorCall ) | ( ruleXBlockExpression ) | ( ruleXSwitchExpression ) | ( ( ruleXSynchronizedExpression ) ) | ( ruleXFeatureCall ) | ( ruleXLiteral ) | ( ruleXIfExpression ) | ( ( ruleXForLoopExpression ) ) | ( ruleXBasicForLoopExpression ) | ( ruleXWhileExpression ) | ( ruleXDoWhileExpression ) | ( ruleXThrowExpression ) | ( ruleXReturnExpression ) | ( ruleXTryCatchFinallyExpression ) | ( ruleXParenthesizedExpression ) );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA23_23 = input.LA(1);

                         
                        int index23_23 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred51_InternalXbaseWithAnnotations()) ) {s = 30;}

                        else if ( (synpred52_InternalXbaseWithAnnotations()) ) {s = 31;}

                         
                        input.seek(index23_23);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 23, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String[] dfa_32s = {
            "\5\2\22\uffff\1\2\3\uffff\1\2\2\uffff\2\2\4\uffff\1\2\4\uffff\6\2\1\uffff\1\1\3\uffff\2\2\2\uffff\1\2\2\uffff\1\2\1\uffff\1\2\3\uffff\11\2\1\uffff\1\2\7\uffff\1\2",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };
    static final short[][] dfa_32 = unpackEncodedStringArray(dfa_32s);

    class DFA26 extends DFA {

        public DFA26(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 26;
            this.eot = dfa_1;
            this.eof = dfa_1;
            this.min = dfa_2;
            this.max = dfa_3;
            this.accept = dfa_4;
            this.special = dfa_5;
            this.transition = dfa_32;
        }
        public String getDescription() {
            return "2811:1: rule__XSwitchExpression__Alternatives_2 : ( ( ( rule__XSwitchExpression__Group_2_0__0 ) ) | ( ( rule__XSwitchExpression__Group_2_1__0 ) ) );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA26_1 = input.LA(1);

                         
                        int index26_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred65_InternalXbaseWithAnnotations()) ) {s = 34;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index26_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 26, _s, input);
            error(nvae);
            throw nvae;
        }
    }

    class DFA31 extends DFA {

        public DFA31(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 31;
            this.eot = dfa_1;
            this.eof = dfa_1;
            this.min = dfa_21;
            this.max = dfa_22;
            this.accept = dfa_23;
            this.special = dfa_24;
            this.transition = dfa_25;
        }
        public String getDescription() {
            return "2916:1: rule__XFeatureCall__Alternatives_3_1 : ( ( ( rule__XFeatureCall__FeatureCallArgumentsAssignment_3_1_0 ) ) | ( ( rule__XFeatureCall__Group_3_1_1__0 ) ) );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA31_1 = input.LA(1);

                         
                        int index31_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred70_InternalXbaseWithAnnotations()) ) {s = 3;}

                        else if ( (true) ) {s = 5;}

                         
                        input.seek(index31_1);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA31_2 = input.LA(1);

                         
                        int index31_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred70_InternalXbaseWithAnnotations()) ) {s = 3;}

                        else if ( (true) ) {s = 5;}

                         
                        input.seek(index31_2);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 31, _s, input);
            error(nvae);
            throw nvae;
        }
    }

    class DFA34 extends DFA {

        public DFA34(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 34;
            this.eot = dfa_1;
            this.eof = dfa_1;
            this.min = dfa_21;
            this.max = dfa_22;
            this.accept = dfa_23;
            this.special = dfa_24;
            this.transition = dfa_25;
        }
        public String getDescription() {
            return "2997:1: rule__XConstructorCall__Alternatives_4_1 : ( ( ( rule__XConstructorCall__ArgumentsAssignment_4_1_0 ) ) | ( ( rule__XConstructorCall__Group_4_1_1__0 ) ) );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA34_1 = input.LA(1);

                         
                        int index34_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred76_InternalXbaseWithAnnotations()) ) {s = 3;}

                        else if ( (true) ) {s = 5;}

                         
                        input.seek(index34_1);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA34_2 = input.LA(1);

                         
                        int index34_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred76_InternalXbaseWithAnnotations()) ) {s = 3;}

                        else if ( (true) ) {s = 5;}

                         
                        input.seek(index34_2);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 34, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_33s = "\7\uffff";
    static final String dfa_34s = "\2\uffff\1\4\2\uffff\1\4\1\uffff";
    static final String dfa_35s = "\1\4\1\uffff\1\53\1\4\1\uffff\1\53\1\uffff";
    static final String dfa_36s = "\1\56\1\uffff\1\76\1\44\1\uffff\1\76\1\uffff";
    static final String dfa_37s = "\1\uffff\1\1\2\uffff\1\2\1\uffff\1\3";
    static final String dfa_38s = "\7\uffff}>";
    static final String[] dfa_39s = {
            "\1\2\51\uffff\1\1",
            "",
            "\1\3\22\uffff\1\4",
            "\1\5\37\uffff\1\6",
            "",
            "\1\3\22\uffff\1\4",
            ""
    };

    static final short[] dfa_33 = DFA.unpackEncodedString(dfa_33s);
    static final short[] dfa_34 = DFA.unpackEncodedString(dfa_34s);
    static final char[] dfa_35 = DFA.unpackEncodedStringToUnsignedChars(dfa_35s);
    static final char[] dfa_36 = DFA.unpackEncodedStringToUnsignedChars(dfa_36s);
    static final short[] dfa_37 = DFA.unpackEncodedString(dfa_37s);
    static final short[] dfa_38 = DFA.unpackEncodedString(dfa_38s);
    static final short[][] dfa_39 = unpackEncodedStringArray(dfa_39s);

    class DFA43 extends DFA {

        public DFA43(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 43;
            this.eot = dfa_33;
            this.eof = dfa_34;
            this.min = dfa_35;
            this.max = dfa_36;
            this.accept = dfa_37;
            this.special = dfa_38;
            this.transition = dfa_39;
        }
        public String getDescription() {
            return "3186:1: rule__XImportDeclaration__Alternatives_1 : ( ( ( rule__XImportDeclaration__Group_1_0__0 ) ) | ( ( rule__XImportDeclaration__ImportedTypeAssignment_1_1 ) ) | ( ( rule__XImportDeclaration__ImportedNamespaceAssignment_1_2 ) ) );";
        }
    }
    static final String dfa_40s = "\1\10\11\uffff";
    static final String dfa_41s = "\1\4\7\0\2\uffff";
    static final String dfa_42s = "\1\127\7\0\2\uffff";
    static final String dfa_43s = "\10\uffff\1\2\1\1";
    static final String dfa_44s = "\1\uffff\1\0\1\5\1\4\1\3\1\1\1\6\1\2\2\uffff}>";
    static final String[] dfa_45s = {
            "\5\10\5\uffff\2\10\1\1\1\2\1\3\1\4\1\5\5\10\1\7\1\6\27\10\1\uffff\35\10\2\uffff\2\10\1\uffff\2\10",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            ""
    };
    static final short[] dfa_40 = DFA.unpackEncodedString(dfa_40s);
    static final char[] dfa_41 = DFA.unpackEncodedStringToUnsignedChars(dfa_41s);
    static final char[] dfa_42 = DFA.unpackEncodedStringToUnsignedChars(dfa_42s);
    static final short[] dfa_43 = DFA.unpackEncodedString(dfa_43s);
    static final short[] dfa_44 = DFA.unpackEncodedString(dfa_44s);
    static final short[][] dfa_45 = unpackEncodedStringArray(dfa_45s);

    class DFA54 extends DFA {

        public DFA54(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 54;
            this.eot = dfa_14;
            this.eof = dfa_40;
            this.min = dfa_41;
            this.max = dfa_42;
            this.accept = dfa_43;
            this.special = dfa_44;
            this.transition = dfa_45;
        }
        public String getDescription() {
            return "4582:2: ( rule__XAssignment__Group_1_1__0 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA54_1 = input.LA(1);

                         
                        int index54_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred97_InternalXbaseWithAnnotations()) ) {s = 9;}

                        else if ( (true) ) {s = 8;}

                         
                        input.seek(index54_1);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA54_5 = input.LA(1);

                         
                        int index54_5 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred97_InternalXbaseWithAnnotations()) ) {s = 9;}

                        else if ( (true) ) {s = 8;}

                         
                        input.seek(index54_5);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA54_7 = input.LA(1);

                         
                        int index54_7 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred97_InternalXbaseWithAnnotations()) ) {s = 9;}

                        else if ( (true) ) {s = 8;}

                         
                        input.seek(index54_7);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA54_4 = input.LA(1);

                         
                        int index54_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred97_InternalXbaseWithAnnotations()) ) {s = 9;}

                        else if ( (true) ) {s = 8;}

                         
                        input.seek(index54_4);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA54_3 = input.LA(1);

                         
                        int index54_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred97_InternalXbaseWithAnnotations()) ) {s = 9;}

                        else if ( (true) ) {s = 8;}

                         
                        input.seek(index54_3);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA54_2 = input.LA(1);

                         
                        int index54_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred97_InternalXbaseWithAnnotations()) ) {s = 9;}

                        else if ( (true) ) {s = 8;}

                         
                        input.seek(index54_2);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA54_6 = input.LA(1);

                         
                        int index54_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred97_InternalXbaseWithAnnotations()) ) {s = 9;}

                        else if ( (true) ) {s = 8;}

                         
                        input.seek(index54_6);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 54, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_46s = "\1\1\12\uffff";
    static final String dfa_47s = "\1\4\1\uffff\10\0\1\uffff";
    static final String dfa_48s = "\1\127\1\uffff\10\0\1\uffff";
    static final String dfa_49s = "\1\uffff\1\2\10\uffff\1\1";
    static final String dfa_50s = "\2\uffff\1\1\1\5\1\7\1\2\1\0\1\3\1\6\1\4\1\uffff}>";
    static final String[] dfa_51s = {
            "\5\1\5\uffff\14\1\1\3\1\2\1\4\1\5\1\6\1\7\1\10\1\11\21\1\1\uffff\35\1\2\uffff\2\1\1\uffff\2\1",
            "",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            ""
    };
    static final short[] dfa_46 = DFA.unpackEncodedString(dfa_46s);
    static final char[] dfa_47 = DFA.unpackEncodedStringToUnsignedChars(dfa_47s);
    static final char[] dfa_48 = DFA.unpackEncodedStringToUnsignedChars(dfa_48s);
    static final short[] dfa_49 = DFA.unpackEncodedString(dfa_49s);
    static final short[] dfa_50 = DFA.unpackEncodedString(dfa_50s);
    static final short[][] dfa_51 = unpackEncodedStringArray(dfa_51s);

    class DFA60 extends DFA {

        public DFA60(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 60;
            this.eot = dfa_8;
            this.eof = dfa_46;
            this.min = dfa_47;
            this.max = dfa_48;
            this.accept = dfa_49;
            this.special = dfa_50;
            this.transition = dfa_51;
        }
        public String getDescription() {
            return "()* loopback of 5878:2: ( rule__XOtherOperatorExpression__Group_1__0 )*";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA60_6 = input.LA(1);

                         
                        int index60_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred103_InternalXbaseWithAnnotations()) ) {s = 10;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index60_6);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA60_2 = input.LA(1);

                         
                        int index60_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred103_InternalXbaseWithAnnotations()) ) {s = 10;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index60_2);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA60_5 = input.LA(1);

                         
                        int index60_5 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred103_InternalXbaseWithAnnotations()) ) {s = 10;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index60_5);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA60_7 = input.LA(1);

                         
                        int index60_7 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred103_InternalXbaseWithAnnotations()) ) {s = 10;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index60_7);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA60_9 = input.LA(1);

                         
                        int index60_9 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred103_InternalXbaseWithAnnotations()) ) {s = 10;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index60_9);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA60_3 = input.LA(1);

                         
                        int index60_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred103_InternalXbaseWithAnnotations()) ) {s = 10;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index60_3);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA60_8 = input.LA(1);

                         
                        int index60_8 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred103_InternalXbaseWithAnnotations()) ) {s = 10;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index60_8);
                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA60_4 = input.LA(1);

                         
                        int index60_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred103_InternalXbaseWithAnnotations()) ) {s = 10;}

                        else if ( (true) ) {s = 1;}

                         
                        input.seek(index60_4);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 60, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_52s = "\116\uffff";
    static final String dfa_53s = "\1\2\115\uffff";
    static final String dfa_54s = "\1\4\1\0\114\uffff";
    static final String dfa_55s = "\1\127\1\0\114\uffff";
    static final String dfa_56s = "\2\uffff\1\2\112\uffff\1\1";
    static final String dfa_57s = "\1\uffff\1\0\114\uffff}>";
    static final String[] dfa_58s = {
            "\5\2\5\uffff\45\2\1\uffff\1\1\34\2\2\uffff\2\2\1\uffff\2\2",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_52 = DFA.unpackEncodedString(dfa_52s);
    static final short[] dfa_53 = DFA.unpackEncodedString(dfa_53s);
    static final char[] dfa_54 = DFA.unpackEncodedStringToUnsignedChars(dfa_54s);
    static final char[] dfa_55 = DFA.unpackEncodedStringToUnsignedChars(dfa_55s);
    static final short[] dfa_56 = DFA.unpackEncodedString(dfa_56s);
    static final short[] dfa_57 = DFA.unpackEncodedString(dfa_57s);
    static final short[][] dfa_58 = unpackEncodedStringArray(dfa_58s);

    class DFA67 extends DFA {

        public DFA67(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 67;
            this.eot = dfa_52;
            this.eof = dfa_53;
            this.min = dfa_54;
            this.max = dfa_55;
            this.accept = dfa_56;
            this.special = dfa_57;
            this.transition = dfa_58;
        }
        public String getDescription() {
            return "7472:2: ( rule__XMemberFeatureCall__Group_1_1_3__0 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA67_1 = input.LA(1);

                         
                        int index67_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred110_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index67_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 67, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String[] dfa_59s = {
            "\5\2\5\uffff\45\2\1\uffff\5\2\1\1\27\2\2\uffff\2\2\1\uffff\2\2",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };
    static final short[][] dfa_59 = unpackEncodedStringArray(dfa_59s);

    class DFA68 extends DFA {

        public DFA68(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 68;
            this.eot = dfa_52;
            this.eof = dfa_53;
            this.min = dfa_54;
            this.max = dfa_55;
            this.accept = dfa_56;
            this.special = dfa_57;
            this.transition = dfa_59;
        }
        public String getDescription() {
            return "7498:2: ( rule__XMemberFeatureCall__MemberCallArgumentsAssignment_1_1_4 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA68_1 = input.LA(1);

                         
                        int index68_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred111_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index68_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 68, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_60s = "\46\uffff";
    static final String dfa_61s = "\1\4\2\0\43\uffff";
    static final String dfa_62s = "\1\127\2\0\43\uffff";
    static final String dfa_63s = "\3\uffff\1\1\1\uffff\1\2\40\uffff";
    static final String dfa_64s = "\1\uffff\1\0\1\1\43\uffff}>";
    static final String[] dfa_65s = {
            "\1\1\4\5\22\uffff\1\5\3\uffff\1\3\2\uffff\2\5\4\uffff\1\5\3\uffff\7\5\1\uffff\1\2\2\uffff\3\5\2\uffff\1\5\2\uffff\1\5\1\uffff\1\5\3\uffff\11\5\1\uffff\1\5\5\uffff\1\3\2\5",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_60 = DFA.unpackEncodedString(dfa_60s);
    static final char[] dfa_61 = DFA.unpackEncodedStringToUnsignedChars(dfa_61s);
    static final char[] dfa_62 = DFA.unpackEncodedStringToUnsignedChars(dfa_62s);
    static final short[] dfa_63 = DFA.unpackEncodedString(dfa_63s);
    static final short[] dfa_64 = DFA.unpackEncodedString(dfa_64s);
    static final short[][] dfa_65 = unpackEncodedStringArray(dfa_65s);

    class DFA76 extends DFA {

        public DFA76(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 76;
            this.eot = dfa_60;
            this.eof = dfa_60;
            this.min = dfa_61;
            this.max = dfa_62;
            this.accept = dfa_63;
            this.special = dfa_64;
            this.transition = dfa_65;
        }
        public String getDescription() {
            return "8471:2: ( rule__XClosure__Group_1__0 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA76_1 = input.LA(1);

                         
                        int index76_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred119_InternalXbaseWithAnnotations()) ) {s = 3;}

                        else if ( (true) ) {s = 5;}

                         
                        input.seek(index76_1);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA76_2 = input.LA(1);

                         
                        int index76_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred119_InternalXbaseWithAnnotations()) ) {s = 3;}

                        else if ( (true) ) {s = 5;}

                         
                        input.seek(index76_2);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 76, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_66s = "\42\uffff";
    static final String dfa_67s = "\1\4\2\0\37\uffff";
    static final String dfa_68s = "\1\127\2\0\37\uffff";
    static final String dfa_69s = "\3\uffff\1\1\1\2\35\uffff";
    static final String dfa_70s = "\1\uffff\1\0\1\1\37\uffff}>";
    static final String[] dfa_71s = {
            "\1\1\4\4\22\uffff\1\4\3\uffff\1\3\2\uffff\2\4\4\uffff\1\4\4\uffff\6\4\1\uffff\1\2\3\uffff\2\4\2\uffff\1\4\2\uffff\1\4\1\uffff\1\4\3\uffff\11\4\1\uffff\1\4\7\uffff\1\4",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_66 = DFA.unpackEncodedString(dfa_66s);
    static final char[] dfa_67 = DFA.unpackEncodedStringToUnsignedChars(dfa_67s);
    static final char[] dfa_68 = DFA.unpackEncodedStringToUnsignedChars(dfa_68s);
    static final short[] dfa_69 = DFA.unpackEncodedString(dfa_69s);
    static final short[] dfa_70 = DFA.unpackEncodedString(dfa_70s);
    static final short[][] dfa_71 = unpackEncodedStringArray(dfa_71s);

    class DFA86 extends DFA {

        public DFA86(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 86;
            this.eot = dfa_66;
            this.eof = dfa_66;
            this.min = dfa_67;
            this.max = dfa_68;
            this.accept = dfa_69;
            this.special = dfa_70;
            this.transition = dfa_71;
        }
        public String getDescription() {
            return "9902:2: ( rule__XSwitchExpression__Group_2_1_0__0 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA86_1 = input.LA(1);

                         
                        int index86_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred129_InternalXbaseWithAnnotations()) ) {s = 3;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index86_1);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA86_2 = input.LA(1);

                         
                        int index86_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred129_InternalXbaseWithAnnotations()) ) {s = 3;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index86_2);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 86, _s, input);
            error(nvae);
            throw nvae;
        }
    }

    class DFA99 extends DFA {

        public DFA99(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 99;
            this.eot = dfa_52;
            this.eof = dfa_53;
            this.min = dfa_54;
            this.max = dfa_55;
            this.accept = dfa_56;
            this.special = dfa_57;
            this.transition = dfa_58;
        }
        public String getDescription() {
            return "12035:2: ( rule__XFeatureCall__Group_3__0 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA99_1 = input.LA(1);

                         
                        int index99_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred142_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index99_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 99, _s, input);
            error(nvae);
            throw nvae;
        }
    }

    class DFA100 extends DFA {

        public DFA100(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 100;
            this.eot = dfa_52;
            this.eof = dfa_53;
            this.min = dfa_54;
            this.max = dfa_55;
            this.accept = dfa_56;
            this.special = dfa_57;
            this.transition = dfa_59;
        }
        public String getDescription() {
            return "12061:2: ( rule__XFeatureCall__FeatureCallArgumentsAssignment_4 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA100_1 = input.LA(1);

                         
                        int index100_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred143_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index100_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 100, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String[] dfa_72s = {
            "\5\2\5\uffff\15\2\1\1\27\2\1\uffff\35\2\2\uffff\2\2\1\uffff\2\2",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };
    static final short[][] dfa_72 = unpackEncodedStringArray(dfa_72s);

    class DFA104 extends DFA {

        public DFA104(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 104;
            this.eot = dfa_52;
            this.eof = dfa_53;
            this.min = dfa_54;
            this.max = dfa_55;
            this.accept = dfa_56;
            this.special = dfa_57;
            this.transition = dfa_72;
        }
        public String getDescription() {
            return "12521:2: ( rule__XConstructorCall__Group_3__0 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA104_1 = input.LA(1);

                         
                        int index104_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred147_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index104_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 104, _s, input);
            error(nvae);
            throw nvae;
        }
    }

    class DFA105 extends DFA {

        public DFA105(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 105;
            this.eot = dfa_52;
            this.eof = dfa_53;
            this.min = dfa_54;
            this.max = dfa_55;
            this.accept = dfa_56;
            this.special = dfa_57;
            this.transition = dfa_58;
        }
        public String getDescription() {
            return "12548:2: ( rule__XConstructorCall__Group_4__0 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA105_1 = input.LA(1);

                         
                        int index105_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred148_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index105_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 105, _s, input);
            error(nvae);
            throw nvae;
        }
    }

    class DFA106 extends DFA {

        public DFA106(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 106;
            this.eot = dfa_52;
            this.eof = dfa_53;
            this.min = dfa_54;
            this.max = dfa_55;
            this.accept = dfa_56;
            this.special = dfa_57;
            this.transition = dfa_59;
        }
        public String getDescription() {
            return "12574:2: ( rule__XConstructorCall__ArgumentsAssignment_5 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA106_1 = input.LA(1);

                         
                        int index106_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred149_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index106_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 106, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_73s = "\1\41\115\uffff";
    static final String dfa_74s = "\1\4\40\0\55\uffff";
    static final String dfa_75s = "\1\127\40\0\55\uffff";
    static final String dfa_76s = "\41\uffff\1\2\53\uffff\1\1";
    static final String dfa_77s = "\1\uffff\1\0\1\1\1\2\1\3\1\4\1\5\1\6\1\7\1\10\1\11\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21\1\22\1\23\1\24\1\25\1\26\1\27\1\30\1\31\1\32\1\33\1\34\1\35\1\36\1\37\55\uffff}>";
    static final String[] dfa_78s = {
            "\1\1\1\23\1\24\1\25\1\27\5\uffff\15\41\1\15\6\41\1\10\1\7\4\41\1\6\4\41\1\2\1\3\1\4\1\5\1\16\1\21\1\uffff\1\40\3\41\1\17\1\20\2\41\1\12\2\41\1\31\1\41\1\13\3\41\1\32\1\33\1\34\1\11\1\26\1\30\1\35\1\36\1\37\1\41\1\14\1\41\2\uffff\2\41\1\uffff\1\41\1\22",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };
    static final short[] dfa_73 = DFA.unpackEncodedString(dfa_73s);
    static final char[] dfa_74 = DFA.unpackEncodedStringToUnsignedChars(dfa_74s);
    static final char[] dfa_75 = DFA.unpackEncodedStringToUnsignedChars(dfa_75s);
    static final short[] dfa_76 = DFA.unpackEncodedString(dfa_76s);
    static final short[] dfa_77 = DFA.unpackEncodedString(dfa_77s);
    static final short[][] dfa_78 = unpackEncodedStringArray(dfa_78s);

    class DFA111 extends DFA {

        public DFA111(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 111;
            this.eot = dfa_52;
            this.eof = dfa_73;
            this.min = dfa_74;
            this.max = dfa_75;
            this.accept = dfa_76;
            this.special = dfa_77;
            this.transition = dfa_78;
        }
        public String getDescription() {
            return "13465:2: ( rule__XReturnExpression__ExpressionAssignment_2 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA111_1 = input.LA(1);

                         
                        int index111_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_1);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA111_2 = input.LA(1);

                         
                        int index111_2 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_2);
                        if ( s>=0 ) return s;
                        break;
                    case 2 : 
                        int LA111_3 = input.LA(1);

                         
                        int index111_3 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_3);
                        if ( s>=0 ) return s;
                        break;
                    case 3 : 
                        int LA111_4 = input.LA(1);

                         
                        int index111_4 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_4);
                        if ( s>=0 ) return s;
                        break;
                    case 4 : 
                        int LA111_5 = input.LA(1);

                         
                        int index111_5 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_5);
                        if ( s>=0 ) return s;
                        break;
                    case 5 : 
                        int LA111_6 = input.LA(1);

                         
                        int index111_6 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_6);
                        if ( s>=0 ) return s;
                        break;
                    case 6 : 
                        int LA111_7 = input.LA(1);

                         
                        int index111_7 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_7);
                        if ( s>=0 ) return s;
                        break;
                    case 7 : 
                        int LA111_8 = input.LA(1);

                         
                        int index111_8 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_8);
                        if ( s>=0 ) return s;
                        break;
                    case 8 : 
                        int LA111_9 = input.LA(1);

                         
                        int index111_9 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_9);
                        if ( s>=0 ) return s;
                        break;
                    case 9 : 
                        int LA111_10 = input.LA(1);

                         
                        int index111_10 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_10);
                        if ( s>=0 ) return s;
                        break;
                    case 10 : 
                        int LA111_11 = input.LA(1);

                         
                        int index111_11 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_11);
                        if ( s>=0 ) return s;
                        break;
                    case 11 : 
                        int LA111_12 = input.LA(1);

                         
                        int index111_12 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_12);
                        if ( s>=0 ) return s;
                        break;
                    case 12 : 
                        int LA111_13 = input.LA(1);

                         
                        int index111_13 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_13);
                        if ( s>=0 ) return s;
                        break;
                    case 13 : 
                        int LA111_14 = input.LA(1);

                         
                        int index111_14 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_14);
                        if ( s>=0 ) return s;
                        break;
                    case 14 : 
                        int LA111_15 = input.LA(1);

                         
                        int index111_15 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_15);
                        if ( s>=0 ) return s;
                        break;
                    case 15 : 
                        int LA111_16 = input.LA(1);

                         
                        int index111_16 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_16);
                        if ( s>=0 ) return s;
                        break;
                    case 16 : 
                        int LA111_17 = input.LA(1);

                         
                        int index111_17 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_17);
                        if ( s>=0 ) return s;
                        break;
                    case 17 : 
                        int LA111_18 = input.LA(1);

                         
                        int index111_18 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_18);
                        if ( s>=0 ) return s;
                        break;
                    case 18 : 
                        int LA111_19 = input.LA(1);

                         
                        int index111_19 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_19);
                        if ( s>=0 ) return s;
                        break;
                    case 19 : 
                        int LA111_20 = input.LA(1);

                         
                        int index111_20 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_20);
                        if ( s>=0 ) return s;
                        break;
                    case 20 : 
                        int LA111_21 = input.LA(1);

                         
                        int index111_21 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_21);
                        if ( s>=0 ) return s;
                        break;
                    case 21 : 
                        int LA111_22 = input.LA(1);

                         
                        int index111_22 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_22);
                        if ( s>=0 ) return s;
                        break;
                    case 22 : 
                        int LA111_23 = input.LA(1);

                         
                        int index111_23 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_23);
                        if ( s>=0 ) return s;
                        break;
                    case 23 : 
                        int LA111_24 = input.LA(1);

                         
                        int index111_24 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_24);
                        if ( s>=0 ) return s;
                        break;
                    case 24 : 
                        int LA111_25 = input.LA(1);

                         
                        int index111_25 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_25);
                        if ( s>=0 ) return s;
                        break;
                    case 25 : 
                        int LA111_26 = input.LA(1);

                         
                        int index111_26 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_26);
                        if ( s>=0 ) return s;
                        break;
                    case 26 : 
                        int LA111_27 = input.LA(1);

                         
                        int index111_27 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_27);
                        if ( s>=0 ) return s;
                        break;
                    case 27 : 
                        int LA111_28 = input.LA(1);

                         
                        int index111_28 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_28);
                        if ( s>=0 ) return s;
                        break;
                    case 28 : 
                        int LA111_29 = input.LA(1);

                         
                        int index111_29 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_29);
                        if ( s>=0 ) return s;
                        break;
                    case 29 : 
                        int LA111_30 = input.LA(1);

                         
                        int index111_30 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_30);
                        if ( s>=0 ) return s;
                        break;
                    case 30 : 
                        int LA111_31 = input.LA(1);

                         
                        int index111_31 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_31);
                        if ( s>=0 ) return s;
                        break;
                    case 31 : 
                        int LA111_32 = input.LA(1);

                         
                        int index111_32 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred154_InternalXbaseWithAnnotations()) ) {s = 77;}

                        else if ( (true) ) {s = 33;}

                         
                        input.seek(index111_32);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 111, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String dfa_79s = "\117\uffff";
    static final String dfa_80s = "\1\2\116\uffff";
    static final String dfa_81s = "\1\4\1\0\115\uffff";
    static final String dfa_82s = "\1\127\1\0\115\uffff";
    static final String dfa_83s = "\2\uffff\1\2\113\uffff\1\1";
    static final String dfa_84s = "\1\uffff\1\0\115\uffff}>";
    static final String[] dfa_85s = {
            "\5\2\5\uffff\15\2\1\1\27\2\1\uffff\35\2\1\uffff\3\2\1\uffff\2\2",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] dfa_79 = DFA.unpackEncodedString(dfa_79s);
    static final short[] dfa_80 = DFA.unpackEncodedString(dfa_80s);
    static final char[] dfa_81 = DFA.unpackEncodedStringToUnsignedChars(dfa_81s);
    static final char[] dfa_82 = DFA.unpackEncodedStringToUnsignedChars(dfa_82s);
    static final short[] dfa_83 = DFA.unpackEncodedString(dfa_83s);
    static final short[] dfa_84 = DFA.unpackEncodedString(dfa_84s);
    static final short[][] dfa_85 = unpackEncodedStringArray(dfa_85s);

    class DFA120 extends DFA {

        public DFA120(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 120;
            this.eot = dfa_79;
            this.eof = dfa_80;
            this.min = dfa_81;
            this.max = dfa_82;
            this.accept = dfa_83;
            this.special = dfa_84;
            this.transition = dfa_85;
        }
        public String getDescription() {
            return "14822:2: ( rule__JvmParameterizedTypeReference__Group_1__0 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA120_1 = input.LA(1);

                         
                        int index120_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred163_InternalXbaseWithAnnotations()) ) {s = 78;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index120_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 120, _s, input);
            error(nvae);
            throw nvae;
        }
    }

    class DFA123 extends DFA {

        public DFA123(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 123;
            this.eot = dfa_79;
            this.eof = dfa_80;
            this.min = dfa_81;
            this.max = dfa_82;
            this.accept = dfa_83;
            this.special = dfa_84;
            this.transition = dfa_85;
        }
        public String getDescription() {
            return "15092:2: ( rule__JvmParameterizedTypeReference__Group_1_4_2__0 )?";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA123_1 = input.LA(1);

                         
                        int index123_1 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (synpred166_InternalXbaseWithAnnotations()) ) {s = 78;}

                        else if ( (true) ) {s = 2;}

                         
                        input.seek(index123_1);
                        if ( s>=0 ) return s;
                        break;
            }
            if (state.backtracking>0) {state.failed=true; return -1;}
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 123, _s, input);
            error(nvae);
            throw nvae;
        }
    }
 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000000012L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0008000000000000L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0010000000000000L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x933FE10C080001F0L,0x000000000080BFE2L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0040000000000000L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0040000000000002L});
    public static final BitSet FOLLOW_10 = new BitSet(new long[]{0x931FE10C080001F0L,0x000000000080BFE2L});
    public static final BitSet FOLLOW_11 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_12 = new BitSet(new long[]{0x939FE10C080001F0L,0x000000000080BFE2L});
    public static final BitSet FOLLOW_13 = new BitSet(new long[]{0x0100000000000000L});
    public static final BitSet FOLLOW_14 = new BitSet(new long[]{0x0200000000000000L});
    public static final BitSet FOLLOW_15 = new BitSet(new long[]{0x0001E00000000010L});
    public static final BitSet FOLLOW_16 = new BitSet(new long[]{0x000000000C1F0000L});
    public static final BitSet FOLLOW_17 = new BitSet(new long[]{0x0000000008000000L});
    public static final BitSet FOLLOW_18 = new BitSet(new long[]{0x0000000006000000L});
    public static final BitSet FOLLOW_19 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_20 = new BitSet(new long[]{0x0000000000004002L});
    public static final BitSet FOLLOW_21 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_22 = new BitSet(new long[]{0x0000000000008002L});
    public static final BitSet FOLLOW_23 = new BitSet(new long[]{0x0000000001E00000L});
    public static final BitSet FOLLOW_24 = new BitSet(new long[]{0x0000000001E00002L});
    public static final BitSet FOLLOW_25 = new BitSet(new long[]{0x040000000E000000L});
    public static final BitSet FOLLOW_26 = new BitSet(new long[]{0x040000000E000002L});
    public static final BitSet FOLLOW_27 = new BitSet(new long[]{0x0010000080000010L});
    public static final BitSet FOLLOW_28 = new BitSet(new long[]{0x0400000000000000L});
    public static final BitSet FOLLOW_29 = new BitSet(new long[]{0x00000003FC000000L});
    public static final BitSet FOLLOW_30 = new BitSet(new long[]{0x00000003FC000002L});
    public static final BitSet FOLLOW_31 = new BitSet(new long[]{0x0000000040000000L});
    public static final BitSet FOLLOW_32 = new BitSet(new long[]{0x0000000004000000L});
    public static final BitSet FOLLOW_33 = new BitSet(new long[]{0x0000000088000000L});
    public static final BitSet FOLLOW_34 = new BitSet(new long[]{0x0000000C00000000L});
    public static final BitSet FOLLOW_35 = new BitSet(new long[]{0x0000000C00000002L});
    public static final BitSet FOLLOW_36 = new BitSet(new long[]{0x000000F000000000L});
    public static final BitSet FOLLOW_37 = new BitSet(new long[]{0x000000F000000002L});
    public static final BitSet FOLLOW_38 = new BitSet(new long[]{0x0000010C00000000L});
    public static final BitSet FOLLOW_39 = new BitSet(new long[]{0x0800000000000000L});
    public static final BitSet FOLLOW_40 = new BitSet(new long[]{0x0800000000000002L});
    public static final BitSet FOLLOW_41 = new BitSet(new long[]{0x0000060000000000L});
    public static final BitSet FOLLOW_42 = new BitSet(new long[]{0x0000080000000000L,0x0000000000180000L});
    public static final BitSet FOLLOW_43 = new BitSet(new long[]{0x0000080000000002L,0x0000000000180000L});
    public static final BitSet FOLLOW_44 = new BitSet(new long[]{0x0000080000000000L,0x0000000000080000L});
    public static final BitSet FOLLOW_45 = new BitSet(new long[]{0x0003E00008000010L});
    public static final BitSet FOLLOW_46 = new BitSet(new long[]{0x0210000000000000L});
    public static final BitSet FOLLOW_47 = new BitSet(new long[]{0x0010000080000010L,0x0000000000020000L});
    public static final BitSet FOLLOW_48 = new BitSet(new long[]{0x0040000004000000L});
    public static final BitSet FOLLOW_49 = new BitSet(new long[]{0x933FE10C880001F0L,0x0000000000A0BFE2L});
    public static final BitSet FOLLOW_50 = new BitSet(new long[]{0x1000000000000000L});
    public static final BitSet FOLLOW_51 = new BitSet(new long[]{0xB31FE10C080001F0L,0x000000000080BFE2L});
    public static final BitSet FOLLOW_52 = new BitSet(new long[]{0x931FF10C880001F0L,0x0000000000E0BFE2L});
    public static final BitSet FOLLOW_53 = new BitSet(new long[]{0x0080000000000000L});
    public static final BitSet FOLLOW_54 = new BitSet(new long[]{0x0010000080000010L,0x0000000000200000L});
    public static final BitSet FOLLOW_55 = new BitSet(new long[]{0x931FF10C080001F2L,0x0000000000C0BFE2L});
    public static final BitSet FOLLOW_56 = new BitSet(new long[]{0x4000000000000000L});
    public static final BitSet FOLLOW_57 = new BitSet(new long[]{0x0020000000000000L});
    public static final BitSet FOLLOW_58 = new BitSet(new long[]{0x8000000000000000L});
    public static final BitSet FOLLOW_59 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_60 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000002L});
    public static final BitSet FOLLOW_61 = new BitSet(new long[]{0x931FE10C880001F0L,0x000000000080BFE2L});
    public static final BitSet FOLLOW_62 = new BitSet(new long[]{0x2050000080000010L,0x000000000000001CL});
    public static final BitSet FOLLOW_63 = new BitSet(new long[]{0x0050000080000012L,0x0000000000000014L});
    public static final BitSet FOLLOW_64 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000004L});
    public static final BitSet FOLLOW_65 = new BitSet(new long[]{0x0050000080000010L,0x0000000000000014L});
    public static final BitSet FOLLOW_66 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000020L});
    public static final BitSet FOLLOW_67 = new BitSet(new long[]{0xD31FF10C080001F0L,0x0000000000C0BFE2L});
    public static final BitSet FOLLOW_68 = new BitSet(new long[]{0xD31FE10C080001F0L,0x000000000080BFE2L});
    public static final BitSet FOLLOW_69 = new BitSet(new long[]{0x931FF10C080001F0L,0x0000000000C0BFE2L});
    public static final BitSet FOLLOW_70 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000040L});
    public static final BitSet FOLLOW_71 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000080L});
    public static final BitSet FOLLOW_72 = new BitSet(new long[]{0xB31FF10C080001F0L,0x0000000000C0BFE2L});
    public static final BitSet FOLLOW_73 = new BitSet(new long[]{0x0000100000000000L,0x0000000000400000L});
    public static final BitSet FOLLOW_74 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000100L});
    public static final BitSet FOLLOW_75 = new BitSet(new long[]{0x0210000008000000L});
    public static final BitSet FOLLOW_76 = new BitSet(new long[]{0x0004000000000000L,0x0000000000800000L});
    public static final BitSet FOLLOW_77 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000200L});
    public static final BitSet FOLLOW_78 = new BitSet(new long[]{0x00000000000000E0L});
    public static final BitSet FOLLOW_79 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_80 = new BitSet(new long[]{0x03040000000001E0L,0x0000000000800600L});
    public static final BitSet FOLLOW_81 = new BitSet(new long[]{0x0220000000000000L});
    public static final BitSet FOLLOW_82 = new BitSet(new long[]{0x0200000000000002L});
    public static final BitSet FOLLOW_83 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000800L});
    public static final BitSet FOLLOW_84 = new BitSet(new long[]{0x0000000000000000L,0x0000000000001000L});
    public static final BitSet FOLLOW_85 = new BitSet(new long[]{0x0000000000000000L,0x0000000000002000L});
    public static final BitSet FOLLOW_86 = new BitSet(new long[]{0x0000000000000000L,0x0000000000014000L});
    public static final BitSet FOLLOW_87 = new BitSet(new long[]{0x0000000000000000L,0x0000000000004000L});
    public static final BitSet FOLLOW_88 = new BitSet(new long[]{0x0000000000000002L,0x0000000000010000L});
    public static final BitSet FOLLOW_89 = new BitSet(new long[]{0x0000000000000000L,0x0000000000008000L});
    public static final BitSet FOLLOW_90 = new BitSet(new long[]{0x0000080000000000L});
    public static final BitSet FOLLOW_91 = new BitSet(new long[]{0x0000080000000002L});
    public static final BitSet FOLLOW_92 = new BitSet(new long[]{0x00000000000000C0L});
    public static final BitSet FOLLOW_93 = new BitSet(new long[]{0x0030000080000010L});
    public static final BitSet FOLLOW_94 = new BitSet(new long[]{0x0002200000000000L});
    public static final BitSet FOLLOW_95 = new BitSet(new long[]{0x0000000000000000L,0x0000000000040000L});
    public static final BitSet FOLLOW_96 = new BitSet(new long[]{0x0000000000000002L,0x0000000000040000L});
    public static final BitSet FOLLOW_97 = new BitSet(new long[]{0x0000001000000000L});
    public static final BitSet FOLLOW_98 = new BitSet(new long[]{0x0000400000000010L});
    public static final BitSet FOLLOW_99 = new BitSet(new long[]{0x0001000000000010L});
    public static final BitSet FOLLOW_100 = new BitSet(new long[]{0x0000001000000010L});

}